/*
PostgreSQL Backup
Database: Test/public
Backup Time: 2024-04-18 09:22:45
*/

DROP TABLE IF EXISTS "public"."AbpAuditLogActions";
DROP TABLE IF EXISTS "public"."AbpAuditLogs";
DROP TABLE IF EXISTS "public"."AbpBackgroundJobs";
DROP TABLE IF EXISTS "public"."AbpClaimTypes";
DROP TABLE IF EXISTS "public"."AbpEntityChanges";
DROP TABLE IF EXISTS "public"."AbpEntityPropertyChanges";
DROP TABLE IF EXISTS "public"."AbpFeatureGroups";
DROP TABLE IF EXISTS "public"."AbpFeatureValues";
DROP TABLE IF EXISTS "public"."AbpFeatures";
DROP TABLE IF EXISTS "public"."AbpLinkUsers";
DROP TABLE IF EXISTS "public"."AbpOrganizationUnitRoles";
DROP TABLE IF EXISTS "public"."AbpOrganizationUnits";
DROP TABLE IF EXISTS "public"."AbpPermissionGrants";
DROP TABLE IF EXISTS "public"."AbpPermissionGroups";
DROP TABLE IF EXISTS "public"."AbpPermissions";
DROP TABLE IF EXISTS "public"."AbpRoleClaims";
DROP TABLE IF EXISTS "public"."AbpRoles";
DROP TABLE IF EXISTS "public"."AbpSecurityLogs";
DROP TABLE IF EXISTS "public"."AbpSettingDefinitions";
DROP TABLE IF EXISTS "public"."AbpSettings";
DROP TABLE IF EXISTS "public"."AbpTenantConnectionStrings";
DROP TABLE IF EXISTS "public"."AbpTenants";
DROP TABLE IF EXISTS "public"."AbpUserClaims";
DROP TABLE IF EXISTS "public"."AbpUserDelegations";
DROP TABLE IF EXISTS "public"."AbpUserLogins";
DROP TABLE IF EXISTS "public"."AbpUserOrganizationUnits";
DROP TABLE IF EXISTS "public"."AbpUserRoles";
DROP TABLE IF EXISTS "public"."AbpUserTokens";
DROP TABLE IF EXISTS "public"."AbpUsers";
DROP TABLE IF EXISTS "public"."OpenIddictApplications";
DROP TABLE IF EXISTS "public"."OpenIddictAuthorizations";
DROP TABLE IF EXISTS "public"."OpenIddictScopes";
DROP TABLE IF EXISTS "public"."OpenIddictTokens";
DROP TABLE IF EXISTS "public"."__EFMigrationsHistory";
DROP TABLE IF EXISTS "public"."wp_product_gender";
DROP TABLE IF EXISTS "public"."wp_product_type";
DROP TABLE IF EXISTS "public"."wp_size_chart";
CREATE TABLE "AbpAuditLogActions" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "AuditLogId" uuid NOT NULL,
  "ServiceName" varchar(256) COLLATE "pg_catalog"."default",
  "MethodName" varchar(128) COLLATE "pg_catalog"."default",
  "Parameters" varchar(2000) COLLATE "pg_catalog"."default",
  "ExecutionTime" timestamp(6) NOT NULL,
  "ExecutionDuration" int4 NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpAuditLogActions" OWNER TO "postgres";
CREATE TABLE "AbpAuditLogs" (
  "Id" uuid NOT NULL,
  "ApplicationName" varchar(96) COLLATE "pg_catalog"."default",
  "UserId" uuid,
  "UserName" varchar(256) COLLATE "pg_catalog"."default",
  "TenantId" uuid,
  "TenantName" varchar(64) COLLATE "pg_catalog"."default",
  "ImpersonatorUserId" uuid,
  "ImpersonatorUserName" varchar(256) COLLATE "pg_catalog"."default",
  "ImpersonatorTenantId" uuid,
  "ImpersonatorTenantName" varchar(64) COLLATE "pg_catalog"."default",
  "ExecutionTime" timestamp(6) NOT NULL,
  "ExecutionDuration" int4 NOT NULL,
  "ClientIpAddress" varchar(64) COLLATE "pg_catalog"."default",
  "ClientName" varchar(128) COLLATE "pg_catalog"."default",
  "ClientId" varchar(64) COLLATE "pg_catalog"."default",
  "CorrelationId" varchar(64) COLLATE "pg_catalog"."default",
  "BrowserInfo" varchar(512) COLLATE "pg_catalog"."default",
  "HttpMethod" varchar(16) COLLATE "pg_catalog"."default",
  "Url" varchar(256) COLLATE "pg_catalog"."default",
  "Exceptions" text COLLATE "pg_catalog"."default",
  "Comments" varchar(256) COLLATE "pg_catalog"."default",
  "HttpStatusCode" int4,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpAuditLogs" OWNER TO "postgres";
CREATE TABLE "AbpBackgroundJobs" (
  "Id" uuid NOT NULL,
  "JobName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "JobArgs" varchar(1048576) COLLATE "pg_catalog"."default" NOT NULL,
  "TryCount" int2 NOT NULL DEFAULT 0,
  "CreationTime" timestamp(6) NOT NULL,
  "NextTryTime" timestamp(6) NOT NULL,
  "LastTryTime" timestamp(6),
  "IsAbandoned" bool NOT NULL DEFAULT false,
  "Priority" int2 NOT NULL DEFAULT 15,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpBackgroundJobs" OWNER TO "postgres";
CREATE TABLE "AbpClaimTypes" (
  "Id" uuid NOT NULL,
  "Name" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "Required" bool NOT NULL,
  "IsStatic" bool NOT NULL,
  "Regex" varchar(512) COLLATE "pg_catalog"."default",
  "RegexDescription" varchar(128) COLLATE "pg_catalog"."default",
  "Description" varchar(256) COLLATE "pg_catalog"."default",
  "ValueType" int4 NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpClaimTypes" OWNER TO "postgres";
CREATE TABLE "AbpEntityChanges" (
  "Id" uuid NOT NULL,
  "AuditLogId" uuid NOT NULL,
  "TenantId" uuid,
  "ChangeTime" timestamp(6) NOT NULL,
  "ChangeType" int2 NOT NULL,
  "EntityTenantId" uuid,
  "EntityId" varchar(128) COLLATE "pg_catalog"."default",
  "EntityTypeFullName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpEntityChanges" OWNER TO "postgres";
CREATE TABLE "AbpEntityPropertyChanges" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "EntityChangeId" uuid NOT NULL,
  "NewValue" varchar(512) COLLATE "pg_catalog"."default",
  "OriginalValue" varchar(512) COLLATE "pg_catalog"."default",
  "PropertyName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "PropertyTypeFullName" varchar(64) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpEntityPropertyChanges" OWNER TO "postgres";
CREATE TABLE "AbpFeatureGroups" (
  "Id" uuid NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "DisplayName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpFeatureGroups" OWNER TO "postgres";
CREATE TABLE "AbpFeatureValues" (
  "Id" uuid NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "Value" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "ProviderName" varchar(64) COLLATE "pg_catalog"."default",
  "ProviderKey" varchar(64) COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpFeatureValues" OWNER TO "postgres";
CREATE TABLE "AbpFeatures" (
  "Id" uuid NOT NULL,
  "GroupName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "ParentName" varchar(128) COLLATE "pg_catalog"."default",
  "DisplayName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "Description" varchar(256) COLLATE "pg_catalog"."default",
  "DefaultValue" varchar(256) COLLATE "pg_catalog"."default",
  "IsVisibleToClients" bool NOT NULL,
  "IsAvailableToHost" bool NOT NULL,
  "AllowedProviders" varchar(256) COLLATE "pg_catalog"."default",
  "ValueType" varchar(2048) COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpFeatures" OWNER TO "postgres";
CREATE TABLE "AbpLinkUsers" (
  "Id" uuid NOT NULL,
  "SourceUserId" uuid NOT NULL,
  "SourceTenantId" uuid,
  "TargetUserId" uuid NOT NULL,
  "TargetTenantId" uuid
)
;
ALTER TABLE "AbpLinkUsers" OWNER TO "postgres";
CREATE TABLE "AbpOrganizationUnitRoles" (
  "RoleId" uuid NOT NULL,
  "OrganizationUnitId" uuid NOT NULL,
  "TenantId" uuid,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid
)
;
ALTER TABLE "AbpOrganizationUnitRoles" OWNER TO "postgres";
CREATE TABLE "AbpOrganizationUnits" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "ParentId" uuid,
  "Code" varchar(95) COLLATE "pg_catalog"."default" NOT NULL,
  "DisplayName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "EntityVersion" int4 NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "AbpOrganizationUnits" OWNER TO "postgres";
CREATE TABLE "AbpPermissionGrants" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "ProviderName" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "ProviderKey" varchar(64) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpPermissionGrants" OWNER TO "postgres";
CREATE TABLE "AbpPermissionGroups" (
  "Id" uuid NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "DisplayName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpPermissionGroups" OWNER TO "postgres";
CREATE TABLE "AbpPermissions" (
  "Id" uuid NOT NULL,
  "GroupName" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "ParentName" varchar(128) COLLATE "pg_catalog"."default",
  "DisplayName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "IsEnabled" bool NOT NULL,
  "MultiTenancySide" int2 NOT NULL,
  "Providers" varchar(128) COLLATE "pg_catalog"."default",
  "StateCheckers" varchar(256) COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpPermissions" OWNER TO "postgres";
CREATE TABLE "AbpRoleClaims" (
  "Id" uuid NOT NULL,
  "RoleId" uuid NOT NULL,
  "TenantId" uuid,
  "ClaimType" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "ClaimValue" varchar(1024) COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpRoleClaims" OWNER TO "postgres";
CREATE TABLE "AbpRoles" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "Name" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "NormalizedName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "IsDefault" bool NOT NULL,
  "IsStatic" bool NOT NULL,
  "IsPublic" bool NOT NULL,
  "EntityVersion" int4 NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpRoles" OWNER TO "postgres";
CREATE TABLE "AbpSecurityLogs" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "ApplicationName" varchar(96) COLLATE "pg_catalog"."default",
  "Identity" varchar(96) COLLATE "pg_catalog"."default",
  "Action" varchar(96) COLLATE "pg_catalog"."default",
  "UserId" uuid,
  "UserName" varchar(256) COLLATE "pg_catalog"."default",
  "TenantName" varchar(64) COLLATE "pg_catalog"."default",
  "ClientId" varchar(64) COLLATE "pg_catalog"."default",
  "CorrelationId" varchar(64) COLLATE "pg_catalog"."default",
  "ClientIpAddress" varchar(64) COLLATE "pg_catalog"."default",
  "BrowserInfo" varchar(512) COLLATE "pg_catalog"."default",
  "CreationTime" timestamp(6) NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpSecurityLogs" OWNER TO "postgres";
CREATE TABLE "AbpSettingDefinitions" (
  "Id" uuid NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "DisplayName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "Description" varchar(512) COLLATE "pg_catalog"."default",
  "DefaultValue" varchar(2048) COLLATE "pg_catalog"."default",
  "IsVisibleToClients" bool NOT NULL,
  "Providers" varchar(1024) COLLATE "pg_catalog"."default",
  "IsInherited" bool NOT NULL,
  "IsEncrypted" bool NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpSettingDefinitions" OWNER TO "postgres";
CREATE TABLE "AbpSettings" (
  "Id" uuid NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "Value" varchar(2048) COLLATE "pg_catalog"."default" NOT NULL,
  "ProviderName" varchar(64) COLLATE "pg_catalog"."default",
  "ProviderKey" varchar(64) COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpSettings" OWNER TO "postgres";
CREATE TABLE "AbpTenantConnectionStrings" (
  "TenantId" uuid NOT NULL,
  "Name" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "Value" varchar(1024) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "AbpTenantConnectionStrings" OWNER TO "postgres";
CREATE TABLE "AbpTenants" (
  "Id" uuid NOT NULL,
  "Name" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "NormalizedName" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "EntityVersion" int4 NOT NULL,
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "AbpTenants" OWNER TO "postgres";
CREATE TABLE "AbpUserClaims" (
  "Id" uuid NOT NULL,
  "UserId" uuid NOT NULL,
  "TenantId" uuid,
  "ClaimType" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "ClaimValue" varchar(1024) COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpUserClaims" OWNER TO "postgres";
CREATE TABLE "AbpUserDelegations" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "SourceUserId" uuid NOT NULL,
  "TargetUserId" uuid NOT NULL,
  "StartTime" timestamp(6) NOT NULL,
  "EndTime" timestamp(6) NOT NULL
)
;
ALTER TABLE "AbpUserDelegations" OWNER TO "postgres";
CREATE TABLE "AbpUserLogins" (
  "UserId" uuid NOT NULL,
  "LoginProvider" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "TenantId" uuid,
  "ProviderKey" varchar(196) COLLATE "pg_catalog"."default" NOT NULL,
  "ProviderDisplayName" varchar(128) COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpUserLogins" OWNER TO "postgres";
CREATE TABLE "AbpUserOrganizationUnits" (
  "UserId" uuid NOT NULL,
  "OrganizationUnitId" uuid NOT NULL,
  "TenantId" uuid,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid
)
;
ALTER TABLE "AbpUserOrganizationUnits" OWNER TO "postgres";
CREATE TABLE "AbpUserRoles" (
  "UserId" uuid NOT NULL,
  "RoleId" uuid NOT NULL,
  "TenantId" uuid
)
;
ALTER TABLE "AbpUserRoles" OWNER TO "postgres";
CREATE TABLE "AbpUserTokens" (
  "UserId" uuid NOT NULL,
  "LoginProvider" varchar(64) COLLATE "pg_catalog"."default" NOT NULL,
  "Name" varchar(128) COLLATE "pg_catalog"."default" NOT NULL,
  "TenantId" uuid,
  "Value" text COLLATE "pg_catalog"."default"
)
;
ALTER TABLE "AbpUserTokens" OWNER TO "postgres";
CREATE TABLE "AbpUsers" (
  "Id" uuid NOT NULL,
  "TenantId" uuid,
  "UserName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "NormalizedUserName" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "Name" varchar(64) COLLATE "pg_catalog"."default",
  "Surname" varchar(64) COLLATE "pg_catalog"."default",
  "Email" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "NormalizedEmail" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "EmailConfirmed" bool NOT NULL DEFAULT false,
  "PasswordHash" varchar(256) COLLATE "pg_catalog"."default",
  "SecurityStamp" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "IsExternal" bool NOT NULL DEFAULT false,
  "PhoneNumber" varchar(16) COLLATE "pg_catalog"."default",
  "PhoneNumberConfirmed" bool NOT NULL DEFAULT false,
  "IsActive" bool NOT NULL,
  "TwoFactorEnabled" bool NOT NULL DEFAULT false,
  "LockoutEnd" timestamptz(6),
  "LockoutEnabled" bool NOT NULL DEFAULT false,
  "AccessFailedCount" int4 NOT NULL DEFAULT 0,
  "ShouldChangePasswordOnNextLogin" bool NOT NULL,
  "EntityVersion" int4 NOT NULL,
  "LastPasswordChangeTime" timestamptz(6),
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "AbpUsers" OWNER TO "postgres";
CREATE TABLE "OpenIddictApplications" (
  "Id" uuid NOT NULL,
  "ApplicationType" varchar(50) COLLATE "pg_catalog"."default",
  "ClientId" varchar(100) COLLATE "pg_catalog"."default",
  "ClientSecret" text COLLATE "pg_catalog"."default",
  "ClientType" varchar(50) COLLATE "pg_catalog"."default",
  "ConsentType" varchar(50) COLLATE "pg_catalog"."default",
  "DisplayName" text COLLATE "pg_catalog"."default",
  "DisplayNames" text COLLATE "pg_catalog"."default",
  "JsonWebKeySet" text COLLATE "pg_catalog"."default",
  "Permissions" text COLLATE "pg_catalog"."default",
  "PostLogoutRedirectUris" text COLLATE "pg_catalog"."default",
  "Properties" text COLLATE "pg_catalog"."default",
  "RedirectUris" text COLLATE "pg_catalog"."default",
  "Requirements" text COLLATE "pg_catalog"."default",
  "Settings" text COLLATE "pg_catalog"."default",
  "ClientUri" text COLLATE "pg_catalog"."default",
  "LogoUri" text COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "OpenIddictApplications" OWNER TO "postgres";
CREATE TABLE "OpenIddictAuthorizations" (
  "Id" uuid NOT NULL,
  "ApplicationId" uuid,
  "CreationDate" timestamp(6),
  "Properties" text COLLATE "pg_catalog"."default",
  "Scopes" text COLLATE "pg_catalog"."default",
  "Status" varchar(50) COLLATE "pg_catalog"."default",
  "Subject" varchar(400) COLLATE "pg_catalog"."default",
  "Type" varchar(50) COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "OpenIddictAuthorizations" OWNER TO "postgres";
CREATE TABLE "OpenIddictScopes" (
  "Id" uuid NOT NULL,
  "Description" text COLLATE "pg_catalog"."default",
  "Descriptions" text COLLATE "pg_catalog"."default",
  "DisplayName" text COLLATE "pg_catalog"."default",
  "DisplayNames" text COLLATE "pg_catalog"."default",
  "Name" varchar(200) COLLATE "pg_catalog"."default",
  "Properties" text COLLATE "pg_catalog"."default",
  "Resources" text COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "OpenIddictScopes" OWNER TO "postgres";
CREATE TABLE "OpenIddictTokens" (
  "Id" uuid NOT NULL,
  "ApplicationId" uuid,
  "AuthorizationId" uuid,
  "CreationDate" timestamp(6),
  "ExpirationDate" timestamp(6),
  "Payload" text COLLATE "pg_catalog"."default",
  "Properties" text COLLATE "pg_catalog"."default",
  "RedemptionDate" timestamp(6),
  "ReferenceId" varchar(100) COLLATE "pg_catalog"."default",
  "Status" varchar(50) COLLATE "pg_catalog"."default",
  "Subject" varchar(400) COLLATE "pg_catalog"."default",
  "Type" varchar(50) COLLATE "pg_catalog"."default",
  "ExtraProperties" text COLLATE "pg_catalog"."default" NOT NULL,
  "ConcurrencyStamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL,
  "CreationTime" timestamp(6) NOT NULL,
  "CreatorId" uuid,
  "LastModificationTime" timestamp(6),
  "LastModifierId" uuid,
  "IsDeleted" bool NOT NULL DEFAULT false,
  "DeleterId" uuid,
  "DeletionTime" timestamp(6)
)
;
ALTER TABLE "OpenIddictTokens" OWNER TO "postgres";
CREATE TABLE "__EFMigrationsHistory" (
  "MigrationId" varchar(150) COLLATE "pg_catalog"."default" NOT NULL,
  "ProductVersion" varchar(32) COLLATE "pg_catalog"."default" NOT NULL
)
;
ALTER TABLE "__EFMigrationsHistory" OWNER TO "postgres";
CREATE TABLE "wp_product_gender" (
  "id" uuid NOT NULL,
  "name" varchar(256) COLLATE "pg_catalog"."default" NOT NULL,
  "extra_properties" text COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::text,
  "concurrency_stamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "creation_time" timestamp(6) NOT NULL DEFAULT now(),
  "creator_id" uuid,
  "last_modification_time" timestamp(6),
  "last_modifier_id" uuid,
  "is_deleted" bool NOT NULL DEFAULT false,
  "deleter_id" uuid,
  "deletion_time" timestamp(6)
)
;
ALTER TABLE "wp_product_gender" OWNER TO "postgres";
CREATE TABLE "wp_product_type" (
  "id" uuid NOT NULL,
  "name" varchar(256) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "extra_properties" text COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::text,
  "concurrency_stamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "creation_time" timestamp(6) NOT NULL DEFAULT now(),
  "creator_id" uuid,
  "last_modification_time" timestamp(6),
  "last_modifier_id" uuid,
  "is_deleted" bool NOT NULL DEFAULT false,
  "deleter_id" uuid,
  "deletion_time" timestamp(6)
)
;
ALTER TABLE "wp_product_type" OWNER TO "postgres";
CREATE TABLE "wp_size_chart" (
  "id" uuid NOT NULL,
  "product_gender_id" uuid,
  "product_type_id" uuid,
  "brand_type" varchar(32) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "original_size" varchar(512) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "us_size" varchar(512) COLLATE "pg_catalog"."default",
  "canada_size" varchar(512) COLLATE "pg_catalog"."default",
  "sp_size" varchar(512) COLLATE "pg_catalog"."default",
  "china_size" varchar(512) COLLATE "pg_catalog"."default",
  "ru_size" varchar(512) COLLATE "pg_catalog"."default",
  "uk_size" varchar(512) COLLATE "pg_catalog"."default",
  "eu_size" varchar(512) COLLATE "pg_catalog"."default",
  "jp_size" varchar(512) COLLATE "pg_catalog"."default",
  "it_size" varchar(512) COLLATE "pg_catalog"."default",
  "fr_size" varchar(512) COLLATE "pg_catalog"."default",
  "cn_size" text COLLATE "pg_catalog"."default",
  "mxsp_size" text COLLATE "pg_catalog"."default",
  "uy_size" text COLLATE "pg_catalog"."default",
  "id_size" text COLLATE "pg_catalog"."default",
  "kr_size" text COLLATE "pg_catalog"."default",
  "online" text COLLATE "pg_catalog"."default",
  "s1us_size" varchar(512) COLLATE "pg_catalog"."default",
  "s2can_size" varchar(512) COLLATE "pg_catalog"."default",
  "s3uk_size" varchar(512) COLLATE "pg_catalog"."default",
  "s4eu_size" varchar(512) COLLATE "pg_catalog"."default",
  "s5jp_size" varchar(512) COLLATE "pg_catalog"."default",
  "s6" varchar(512) COLLATE "pg_catalog"."default",
  "s7us_size" varchar(512) COLLATE "pg_catalog"."default",
  "s8can_size" varchar(512) COLLATE "pg_catalog"."default",
  "s9uk_size" varchar(512) COLLATE "pg_catalog"."default",
  "s10eu_size" varchar(512) COLLATE "pg_catalog"."default",
  "s11jp_size" varchar(512) COLLATE "pg_catalog"."default",
  "s12it_size" varchar(512) COLLATE "pg_catalog"."default",
  "s13fr_size" varchar(512) COLLATE "pg_catalog"."default",
  "s14it_size" varchar(512) COLLATE "pg_catalog"."default",
  "s15fr_size" varchar(512) COLLATE "pg_catalog"."default",
  "extra_properties" text COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::text,
  "concurrency_stamp" varchar(40) COLLATE "pg_catalog"."default" NOT NULL DEFAULT ''::character varying,
  "creation_time" timestamp(6) NOT NULL DEFAULT now(),
  "creator_id" uuid,
  "last_modification_time" timestamp(6),
  "last_modifier_id" uuid,
  "is_deleted" bool NOT NULL DEFAULT false,
  "deleter_id" uuid,
  "deletion_time" timestamp(6)
)
;
ALTER TABLE "wp_size_chart" OWNER TO "postgres";
BEGIN;
LOCK TABLE "public"."AbpAuditLogActions" IN SHARE MODE;
DELETE FROM "public"."AbpAuditLogActions";
INSERT INTO "public"."AbpAuditLogActions" ("Id","TenantId","AuditLogId","ServiceName","MethodName","Parameters","ExecutionTime","ExecutionDuration","ExtraProperties") VALUES ('3a11f757-1f69-9c02-c8b7-3486a9eb9d9f', NULL, '3a11f757-1f68-1561-f657-0aa424ed0db1', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 12:28:46.537973', 10463, '{}'),('3a11f769-280e-e7b5-5882-c62a583f0108', NULL, '3a11f769-280e-b3ed-e9bd-4e44280655ec', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 12:48:37.541287', 1344, '{}'),('3a11f769-f5b4-65c6-e0c8-0bb5cce9bc31', NULL, '3a11f769-f5b3-67f9-7f16-3f101cd558bb', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 12:49:22.55146', 8955, '{}'),('3a11f76b-db72-2530-7bb4-a424b0f20690', NULL, '3a11f76b-db71-c17d-3b18-dd3f8da9348a', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 12:51:11.499278', 24364, '{}'),('3a11f780-9223-73cf-6deb-20f00e858bd4', NULL, '3a11f780-9222-6b84-32eb-98fc494a4e89', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 13:14:12.001331', 1223, '{}'),('3a11f781-ac7a-6635-6aa7-5b8545506404', NULL, '3a11f781-ac7a-4540-cb6b-f4044f8f2317', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 13:15:23.9459', 1693, '{}'),('3a11f79d-8afc-e073-99a9-24a9245e359a', NULL, '3a11f79d-8afc-6a70-bf1a-90789d796b4f', 'Acme.BookStore.V6.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 13:45:21.733406', 30328, '{}'),('3a11f7b7-634d-d0f2-de45-f01e48d6b7ed', NULL, '3a11f7b7-634c-7ded-8f85-fc69e6ce28d9', 'Acme.BookStore.Web.Pages.IndexModel', 'OnGetAsync', '{}', '2024-04-16 14:14:03.735152', 2082, '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpAuditLogs" IN SHARE MODE;
DELETE FROM "public"."AbpAuditLogs";
INSERT INTO "public"."AbpAuditLogs" ("Id","ApplicationName","UserId","UserName","TenantId","TenantName","ImpersonatorUserId","ImpersonatorUserName","ImpersonatorTenantId","ImpersonatorTenantName","ExecutionTime","ExecutionDuration","ClientIpAddress","ClientName","ClientId","CorrelationId","BrowserInfo","HttpMethod","Url","Exceptions","Comments","HttpStatusCode","ExtraProperties","ConcurrencyStamp") VALUES ('3a11f757-1f68-1561-f657-0aa424ed0db1', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 12:28:46.326565', 10725, '::1', NULL, NULL, 'c034292fa4c8473593d0b398c132ae29', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {},
    "validationErrors": null
  }
]', '', 500, '{}', '8c85ead22e0a45ddb72a12890dd960b2'),('3a11f769-280e-b3ed-e9bd-4e44280655ec', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 12:48:37.342147', 1570, '::1', NULL, NULL, '6bfba6cb98bc4b27bd16eb3fa76d289f', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {},
    "validationErrors": null
  }
]', '', 500, '{}', 'b4384c1c646c4ef783cc29873e05e9da'),('3a11f769-f5b3-67f9-7f16-3f101cd558bb', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 12:49:22.289213', 9267, '::1', NULL, NULL, 'd5b59ee39d4242768c5cb351a16b1316', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {},
    "validationErrors": null
  }
]', '', 500, '{}', 'b0d43d2a416348d8add32fb2bdbc1f72'),('3a11f76b-db71-c17d-3b18-dd3f8da9348a', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 12:51:11.305026', 24597, '::1', NULL, NULL, '8614851f92b746b79bef1176f8adeda9', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {},
    "validationErrors": null
  }
]', '', 500, '{}', '4337d81c1ff9407db9beff2971699a88'),('3a11f780-9222-6b84-32eb-98fc494a4e89', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 13:14:11.773268', 1599, '::1', NULL, NULL, '601ee07514b640b9a781085116fc2be8', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {
      "Severity": "ERROR",
      "InvariantSeverity": "ERROR",
      "SqlState": "42P01",
      "MessageText": "relation \"SizeChart\" does not exist",
      "Position": 1064,
      "File": "parse_relation.c",
      "Line": "1186",
      "Routine": "parserOpenTable"
    },
    "validationErrors": null
  }
]', '', 500, '{}', '32d64793df84492c9538753b6bd54bb2'),('3a11f781-ac7a-4540-cb6b-f4044f8f2317', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 13:15:23.703735', 1971, '::1', NULL, NULL, 'f16a1f39029d4a2f90e30039783e4158', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {
      "Severity": "ERROR",
      "InvariantSeverity": "ERROR",
      "SqlState": "42883",
      "MessageText": "operator does not exist: character varying = integer",
      "Hint": "No operator matches the given name and argument type(s). You might need to add explicit type casts.",
      "Position": 1708,
      "File": "parse_oper.c",
      "Line": "728",
      "Routine": "op_error"
    },
    "validationErrors": null
  }
]', '', 500, '{}', 'b9609dd0f7ca4bef9bde47fa1122d249'),('3a11f79d-8afc-6a70-bf1a-90789d796b4f', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 13:45:21.516899', 30576, '::1', NULL, NULL, '4941f04a5d7040c08a6b9440dad34224', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "An internal error occurred during your request!",
    "details": null,
    "data": {
      "Severity": "ERROR",
      "InvariantSeverity": "ERROR",
      "SqlState": "42P01",
      "MessageText": "relation \"Appsize_chart\" does not exist",
      "Position": 998,
      "File": "parse_relation.c",
      "Line": "1186",
      "Routine": "parserOpenTable"
    },
    "validationErrors": null
  }
]', '', 500, '{}', '9f739d902279412aae68c7a145d56b70'),('3a11f7b7-634c-7ded-8f85-fc69e6ce28d9', 'Acme.BookStore.Web', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-04-16 14:14:03.371809', 2509, '::1', NULL, NULL, 'fcf9c3f071b14692b1efd80f05d9b48a', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0', 'GET', '/', '[
  {
    "code": null,
    "message": "对不起，在处理您的请求期间产生了一个服务器内部错误！！",
    "details": null,
    "data": {
      "Severity": "ERROR",
      "InvariantSeverity": "ERROR",
      "SqlState": "42703",
      "MessageText": "column w0.Id does not exist",
      "Hint": "Perhaps you meant to reference the column \"w0.id\".",
      "Position": 1108,
      "File": "parse_relation.c",
      "Line": "3288",
      "Routine": "errorMissingColumn"
    },
    "validationErrors": null
  }
]', '', 500, '{}', 'ed7acb8173ec4f17afc915a927403a71')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpBackgroundJobs" IN SHARE MODE;
DELETE FROM "public"."AbpBackgroundJobs";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpClaimTypes" IN SHARE MODE;
DELETE FROM "public"."AbpClaimTypes";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpEntityChanges" IN SHARE MODE;
DELETE FROM "public"."AbpEntityChanges";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpEntityPropertyChanges" IN SHARE MODE;
DELETE FROM "public"."AbpEntityPropertyChanges";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpFeatureGroups" IN SHARE MODE;
DELETE FROM "public"."AbpFeatureGroups";
INSERT INTO "public"."AbpFeatureGroups" ("Id","Name","DisplayName","ExtraProperties") VALUES ('3a11f756-e400-6db9-8113-3e77a70a3b78', 'SettingManagement', 'L:AbpSettingManagement,Feature:SettingManagementGroup', '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpFeatureValues" IN SHARE MODE;
DELETE FROM "public"."AbpFeatureValues";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpFeatures" IN SHARE MODE;
DELETE FROM "public"."AbpFeatures";
INSERT INTO "public"."AbpFeatures" ("Id","GroupName","Name","ParentName","DisplayName","Description","DefaultValue","IsVisibleToClients","IsAvailableToHost","AllowedProviders","ValueType","ExtraProperties") VALUES ('3a11f756-e403-4677-efc6-47f1ab6e21a4', 'SettingManagement', 'SettingManagement.Enable', NULL, 'L:AbpSettingManagement,Feature:SettingManagementEnable', 'L:AbpSettingManagement,Feature:SettingManagementEnableDescription', 'true', 't', 'f', NULL, '{"name":"ToggleStringValueType","properties":{},"validator":{"name":"BOOLEAN","properties":{}}}', '{}'),('3a11f756-e40c-68d8-f517-1d634ce94620', 'SettingManagement', 'SettingManagement.AllowChangingEmailSettings', 'SettingManagement.Enable', 'L:AbpSettingManagement,Feature:AllowChangingEmailSettings', NULL, 'false', 't', 'f', NULL, '{"name":"ToggleStringValueType","properties":{},"validator":{"name":"BOOLEAN","properties":{}}}', '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpLinkUsers" IN SHARE MODE;
DELETE FROM "public"."AbpLinkUsers";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpOrganizationUnitRoles" IN SHARE MODE;
DELETE FROM "public"."AbpOrganizationUnitRoles";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpOrganizationUnits" IN SHARE MODE;
DELETE FROM "public"."AbpOrganizationUnits";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpPermissionGrants" IN SHARE MODE;
DELETE FROM "public"."AbpPermissionGrants";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpPermissionGroups" IN SHARE MODE;
DELETE FROM "public"."AbpPermissionGroups";
INSERT INTO "public"."AbpPermissionGroups" ("Id","Name","DisplayName","ExtraProperties") VALUES ('3a11f756-e27a-f56a-6c3f-77912e2fed89', 'AbpIdentity', 'L:AbpIdentity,Permission:IdentityManagement', '{}'),('3a11f756-e28d-dc6f-62d5-1361e2a07517', 'SettingManagement', 'L:AbpSettingManagement,Permission:SettingManagement', '{}'),('3a11f756-e28d-eb97-795b-3625a1e77dda', 'FeatureManagement', 'L:AbpFeatureManagement,Permission:FeatureManagement', '{}'),('3a11f756-e294-83de-5620-abc3eaf8e0ab', 'AbpTenantManagement', 'L:AbpTenantManagement,Permission:TenantManagement', '{}'),('3a11f756-e294-c9e0-5065-53b62f1b9460', 'BookStore', 'F:BookStore', '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpPermissions" IN SHARE MODE;
DELETE FROM "public"."AbpPermissions";
INSERT INTO "public"."AbpPermissions" ("Id","GroupName","Name","ParentName","DisplayName","IsEnabled","MultiTenancySide","Providers","StateCheckers","ExtraProperties") VALUES ('3a11f756-e285-458c-04c9-bca6ad13528f', 'AbpIdentity', 'AbpIdentity.Roles', NULL, 'L:AbpIdentity,Permission:RoleManagement', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-124c-8387-5f3ea2738339', 'AbpIdentity', 'AbpIdentity.Users', NULL, 'L:AbpIdentity,Permission:UserManagement', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-2503-460c-208c1bc9fbee', 'AbpIdentity', 'AbpIdentity.Users.Create', 'AbpIdentity.Users', 'L:AbpIdentity,Permission:Create', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-3285-d359-f3978f2f7ac8', 'AbpIdentity', 'AbpIdentity.Users.Update', 'AbpIdentity.Users', 'L:AbpIdentity,Permission:Edit', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-36a9-6b12-3c240c293763', 'AbpIdentity', 'AbpIdentity.Roles.Delete', 'AbpIdentity.Roles', 'L:AbpIdentity,Permission:Delete', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-5a0c-f5ec-ff3a1be94cb6', 'AbpIdentity', 'AbpIdentity.Roles.Create', 'AbpIdentity.Roles', 'L:AbpIdentity,Permission:Create', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-82cc-3047-9e7d8da422f6', 'AbpIdentity', 'AbpIdentity.Roles.ManagePermissions', 'AbpIdentity.Roles', 'L:AbpIdentity,Permission:ChangePermissions', 't', 3, NULL, NULL, '{}'),('3a11f756-e28c-d3ae-25aa-2186a3f09ba9', 'AbpIdentity', 'AbpIdentity.Roles.Update', 'AbpIdentity.Roles', 'L:AbpIdentity,Permission:Edit', 't', 3, NULL, NULL, '{}'),('3a11f756-e28d-3aad-dafa-f2bd13e05fad', 'AbpIdentity', 'AbpIdentity.UserLookup', NULL, 'L:AbpIdentity,Permission:UserLookup', 't', 3, 'C', NULL, '{}'),('3a11f756-e28d-843a-5e20-5feb8cc20e5f', 'FeatureManagement', 'FeatureManagement.ManageHostFeatures', NULL, 'L:AbpFeatureManagement,Permission:FeatureManagement.ManageHostFeatures', 't', 2, NULL, NULL, '{}'),('3a11f756-e28d-9a5b-2773-600ef0d81f1f', 'AbpIdentity', 'AbpIdentity.Users.Update.ManageRoles', 'AbpIdentity.Users', 'L:AbpIdentity,Permission:ManageRoles', 't', 3, NULL, NULL, '{}'),('3a11f756-e28d-9b01-d67f-2fec29f3cc32', 'AbpIdentity', 'AbpIdentity.Users.Delete', 'AbpIdentity.Users', 'L:AbpIdentity,Permission:Delete', 't', 3, NULL, NULL, '{}'),('3a11f756-e28d-adae-5f01-88b15b748d4e', 'AbpIdentity', 'AbpIdentity.Users.ManagePermissions', 'AbpIdentity.Users', 'L:AbpIdentity,Permission:ChangePermissions', 't', 3, NULL, NULL, '{}'),('3a11f756-e28d-c2ad-bb5d-e389cb4bfc94', 'SettingManagement', 'SettingManagement.Emailing', NULL, 'L:AbpSettingManagement,Permission:Emailing', 't', 3, NULL, NULL, '{}'),('3a11f756-e294-12b2-d2c3-d81de50bdeff', 'AbpTenantManagement', 'AbpTenantManagement.Tenants.Create', 'AbpTenantManagement.Tenants', 'L:AbpTenantManagement,Permission:Create', 't', 2, NULL, NULL, '{}'),('3a11f756-e294-2a63-6955-ae2d0cd8e3e4', 'AbpTenantManagement', 'AbpTenantManagement.Tenants.Update', 'AbpTenantManagement.Tenants', 'L:AbpTenantManagement,Permission:Edit', 't', 2, NULL, NULL, '{}'),('3a11f756-e294-5aa9-d228-54e7896440a3', 'AbpTenantManagement', 'AbpTenantManagement.Tenants', NULL, 'L:AbpTenantManagement,Permission:TenantManagement', 't', 2, NULL, NULL, '{}'),('3a11f756-e294-6242-af8d-61ceeef975c4', 'SettingManagement', 'SettingManagement.Emailing.Test', 'SettingManagement.Emailing', 'L:AbpSettingManagement,Permission:EmailingTest', 't', 3, NULL, NULL, '{}'),('3a11f756-e294-6792-f8d2-3164026ee3dd', 'AbpTenantManagement', 'AbpTenantManagement.Tenants.ManageConnectionStrings', 'AbpTenantManagement.Tenants', 'L:AbpTenantManagement,Permission:ManageConnectionStrings', 't', 2, NULL, NULL, '{}'),('3a11f756-e294-a839-0711-f0f3b675a316', 'SettingManagement', 'SettingManagement.TimeZone', NULL, 'L:AbpSettingManagement,Permission:TimeZone', 't', 3, NULL, NULL, '{}'),('3a11f756-e294-cea9-8336-0743a7a289ca', 'AbpTenantManagement', 'AbpTenantManagement.Tenants.Delete', 'AbpTenantManagement.Tenants', 'L:AbpTenantManagement,Permission:Delete', 't', 2, NULL, NULL, '{}'),('3a11f756-e294-fd17-5ede-57e43194f3bd', 'AbpTenantManagement', 'AbpTenantManagement.Tenants.ManageFeatures', 'AbpTenantManagement.Tenants', 'L:AbpTenantManagement,Permission:ManageFeatures', 't', 2, NULL, NULL, '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpRoleClaims" IN SHARE MODE;
DELETE FROM "public"."AbpRoleClaims";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpRoles" IN SHARE MODE;
DELETE FROM "public"."AbpRoles";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpSecurityLogs" IN SHARE MODE;
DELETE FROM "public"."AbpSecurityLogs";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpSettingDefinitions" IN SHARE MODE;
DELETE FROM "public"."AbpSettingDefinitions";
INSERT INTO "public"."AbpSettingDefinitions" ("Id","Name","DisplayName","Description","DefaultValue","IsVisibleToClients","Providers","IsInherited","IsEncrypted","ExtraProperties") VALUES ('3a11f756-e402-f344-d98c-3e56d2c87a5b', 'Abp.Localization.DefaultLanguage', 'L:AbpLocalization,DisplayName:Abp.Localization.DefaultLanguage', 'L:AbpLocalization,Description:Abp.Localization.DefaultLanguage', 'en', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-004e-85d2-59754b8d44be', 'Abp.Identity.Password.RequireLowercase', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequireLowercase', 'L:AbpIdentity,Description:Abp.Identity.Password.RequireLowercase', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-1cc9-10c1-214bb7091d78', 'Abp.Identity.SignIn.RequireConfirmedPhoneNumber', 'L:AbpIdentity,DisplayName:Abp.Identity.SignIn.RequireConfirmedPhoneNumber', 'L:AbpIdentity,Description:Abp.Identity.SignIn.RequireConfirmedPhoneNumber', 'False', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-20bc-3501-1f291f79ad8b', 'Abp.Mailing.Smtp.Port', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.Port', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.Port', '25', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-24d0-2fc1-038b8e1789a8', 'Abp.Identity.Lockout.MaxFailedAccessAttempts', 'L:AbpIdentity,DisplayName:Abp.Identity.Lockout.MaxFailedAccessAttempts', 'L:AbpIdentity,Description:Abp.Identity.Lockout.MaxFailedAccessAttempts', '5', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-364f-c454-3b5db191c27c', 'Abp.Mailing.Smtp.UseDefaultCredentials', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.UseDefaultCredentials', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.UseDefaultCredentials', 'true', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-4015-9a99-b5f3d57b61dc', 'Abp.Identity.Password.RequiredUniqueChars', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequiredUniqueChars', 'L:AbpIdentity,Description:Abp.Identity.Password.RequiredUniqueChars', '1', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-4fd4-bff0-8ff15da7e51c', 'Abp.Identity.Password.RequiredLength', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequiredLength', 'L:AbpIdentity,Description:Abp.Identity.Password.RequiredLength', '6', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-5a05-4a0c-21d1840a9349', 'Abp.Identity.Lockout.AllowedForNewUsers', 'L:AbpIdentity,DisplayName:Abp.Identity.Lockout.AllowedForNewUsers', 'L:AbpIdentity,Description:Abp.Identity.Lockout.AllowedForNewUsers', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-79fe-f8c4-e33acf24f937', 'Abp.Identity.Password.PasswordChangePeriodDays', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.PasswordChangePeriodDays', 'L:AbpIdentity,Description:Abp.Identity.Password.PasswordChangePeriodDays', '0', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-8226-c1bc-9117d305652c', 'Abp.Identity.Password.RequireDigit', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequireDigit', 'L:AbpIdentity,Description:Abp.Identity.Password.RequireDigit', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-8386-f1ce-55c0866c5032', 'Abp.Identity.Password.RequireUppercase', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequireUppercase', 'L:AbpIdentity,Description:Abp.Identity.Password.RequireUppercase', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-85b9-8372-0f52d199cd6d', 'Abp.Identity.SignIn.EnablePhoneNumberConfirmation', 'L:AbpIdentity,DisplayName:Abp.Identity.SignIn.EnablePhoneNumberConfirmation', 'L:AbpIdentity,Description:Abp.Identity.SignIn.EnablePhoneNumberConfirmation', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-87d2-915e-09e8ca54d3ca', 'Abp.Account.IsSelfRegistrationEnabled', 'L:AbpAccount,DisplayName:Abp.Account.IsSelfRegistrationEnabled', 'L:AbpAccount,Description:Abp.Account.IsSelfRegistrationEnabled', 'true', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-8833-7d35-32ea99716812', 'Abp.Mailing.Smtp.EnableSsl', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.EnableSsl', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.EnableSsl', 'false', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-8fb2-69d6-6a9cca39ae7b', 'Abp.Identity.Password.ForceUsersToPeriodicallyChangePassword', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.ForceUsersToPeriodicallyChangePassword', 'L:AbpIdentity,Description:Abp.Identity.Password.ForceUsersToPeriodicallyChangePassword', 'False', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-94fe-f92a-497b28e1dfc0', 'Abp.Mailing.DefaultFromDisplayName', 'L:AbpEmailing,DisplayName:Abp.Mailing.DefaultFromDisplayName', 'L:AbpEmailing,Description:Abp.Mailing.DefaultFromDisplayName', 'ABP application', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-9d07-2fcc-00b205f07684', 'Abp.Mailing.Smtp.Domain', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.Domain', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.Domain', NULL, 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-9eb8-57f1-b5a37896cd65', 'Abp.Identity.User.IsEmailUpdateEnabled', 'L:AbpIdentity,DisplayName:Abp.Identity.User.IsEmailUpdateEnabled', 'L:AbpIdentity,Description:Abp.Identity.User.IsEmailUpdateEnabled', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-abde-19b7-07cdbd2b39b2', 'Abp.Identity.Password.RequireNonAlphanumeric', 'L:AbpIdentity,DisplayName:Abp.Identity.Password.RequireNonAlphanumeric', 'L:AbpIdentity,Description:Abp.Identity.Password.RequireNonAlphanumeric', 'True', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-ac36-72d1-49f6d6014556', 'Abp.Identity.Lockout.LockoutDuration', 'L:AbpIdentity,DisplayName:Abp.Identity.Lockout.LockoutDuration', 'L:AbpIdentity,Description:Abp.Identity.Lockout.LockoutDuration', '300', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-b3f5-2aa1-97e4767ca378', 'Abp.Account.EnableLocalLogin', 'L:AbpAccount,DisplayName:Abp.Account.EnableLocalLogin', 'L:AbpAccount,Description:Abp.Account.EnableLocalLogin', 'true', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-b942-4e37-b98f16a16ed9', 'Abp.Identity.OrganizationUnit.MaxUserMembershipCount', 'L:AbpIdentity,Identity.OrganizationUnit.MaxUserMembershipCount', 'L:AbpIdentity,Identity.OrganizationUnit.MaxUserMembershipCount', '2147483647', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-c134-e96b-64243bc6897d', 'Abp.Timing.TimeZone', 'L:AbpTiming,DisplayName:Abp.Timing.Timezone', 'L:AbpTiming,Description:Abp.Timing.Timezone', 'UTC', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-d0a8-f98f-5cfaa997b43a', 'Abp.Mailing.Smtp.UserName', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.UserName', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.UserName', NULL, 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-d650-68a6-770549db62a8', 'Abp.Identity.SignIn.RequireConfirmedEmail', 'L:AbpIdentity,DisplayName:Abp.Identity.SignIn.RequireConfirmedEmail', 'L:AbpIdentity,Description:Abp.Identity.SignIn.RequireConfirmedEmail', 'False', 't', NULL, 't', 'f', '{}'),('3a11f756-e404-e3f4-f0de-c0f9ef49dee2', 'Abp.Mailing.Smtp.Host', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.Host', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.Host', '127.0.0.1', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-edb9-8c5c-661dd7cc4186', 'Abp.Mailing.Smtp.Password', 'L:AbpEmailing,DisplayName:Abp.Mailing.Smtp.Password', 'L:AbpEmailing,Description:Abp.Mailing.Smtp.Password', NULL, 'f', NULL, 't', 't', '{}'),('3a11f756-e404-fa89-0663-8f90fc55be4f', 'Abp.Mailing.DefaultFromAddress', 'L:AbpEmailing,DisplayName:Abp.Mailing.DefaultFromAddress', 'L:AbpEmailing,Description:Abp.Mailing.DefaultFromAddress', 'noreply@abp.io', 'f', NULL, 't', 'f', '{}'),('3a11f756-e404-faea-7deb-2ad49ed0586d', 'Abp.Identity.User.IsUserNameUpdateEnabled', 'L:AbpIdentity,DisplayName:Abp.Identity.User.IsUserNameUpdateEnabled', 'L:AbpIdentity,Description:Abp.Identity.User.IsUserNameUpdateEnabled', 'True', 't', NULL, 't', 'f', '{}')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpSettings" IN SHARE MODE;
DELETE FROM "public"."AbpSettings";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpTenantConnectionStrings" IN SHARE MODE;
DELETE FROM "public"."AbpTenantConnectionStrings";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpTenants" IN SHARE MODE;
DELETE FROM "public"."AbpTenants";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserClaims" IN SHARE MODE;
DELETE FROM "public"."AbpUserClaims";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserDelegations" IN SHARE MODE;
DELETE FROM "public"."AbpUserDelegations";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserLogins" IN SHARE MODE;
DELETE FROM "public"."AbpUserLogins";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserOrganizationUnits" IN SHARE MODE;
DELETE FROM "public"."AbpUserOrganizationUnits";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserRoles" IN SHARE MODE;
DELETE FROM "public"."AbpUserRoles";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUserTokens" IN SHARE MODE;
DELETE FROM "public"."AbpUserTokens";
COMMIT;
BEGIN;
LOCK TABLE "public"."AbpUsers" IN SHARE MODE;
DELETE FROM "public"."AbpUsers";
COMMIT;
BEGIN;
LOCK TABLE "public"."OpenIddictApplications" IN SHARE MODE;
DELETE FROM "public"."OpenIddictApplications";
COMMIT;
BEGIN;
LOCK TABLE "public"."OpenIddictAuthorizations" IN SHARE MODE;
DELETE FROM "public"."OpenIddictAuthorizations";
COMMIT;
BEGIN;
LOCK TABLE "public"."OpenIddictScopes" IN SHARE MODE;
DELETE FROM "public"."OpenIddictScopes";
COMMIT;
BEGIN;
LOCK TABLE "public"."OpenIddictTokens" IN SHARE MODE;
DELETE FROM "public"."OpenIddictTokens";
COMMIT;
BEGIN;
LOCK TABLE "public"."__EFMigrationsHistory" IN SHARE MODE;
DELETE FROM "public"."__EFMigrationsHistory";
INSERT INTO "public"."__EFMigrationsHistory" ("MigrationId","ProductVersion") VALUES ('20240416035359_Init', '8.0.2')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."wp_product_gender" IN SHARE MODE;
DELETE FROM "public"."wp_product_gender";
INSERT INTO "public"."wp_product_gender" ("id","name","extra_properties","concurrency_stamp","creation_time","creator_id","last_modification_time","last_modifier_id","is_deleted","deleter_id","deletion_time") VALUES ('3a0c74c8-3055-2d7c-e355-ed873d5ced2d', 'BR Toddler', '{}', '4965074805ba473dabd073b3abb12734', '2023-07-17 14:48:15.342814', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-373e-14b2-d2a1eea21a91', 'BR Baby', '{}', '8d8e014c113d419da9a182afecfe73ea', '2023-07-17 14:48:15.342774', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-475b-4b2d-61966f05c000', 'BR Women', '{}', '91ccc2565c654dde869db287a2688056', '2023-07-17 14:48:15.323637', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-8590-30a2-d59a6faa10a7', 'BR Home', '{}', '5fc21434904a4cb48ba2e6924e55796e', '2023-07-17 14:48:15.342731', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-ad0c-c2f9-32634e7d880e', 'BR Pets', '{}', 'd8b092a6600f41d2a9d9641c3a3e613a', '2023-07-17 14:48:15.342688', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-d9e1-c906-afbfe9051db5', 'BR Footwear', '{}', 'b33911d7c8674efaa5dcba1800ad1798', '2023-07-17 14:48:15.342621', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3055-fc79-e74c-203533439c04', 'BR Men', '{}', '80ec407ad39447bd8b8ba6046355ae2d', '2023-07-17 14:48:15.339534', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa0f-67e0-6f2b-1dd310b05df3', 'Toddler', '{}', '951bd3fa37c748c09c5e59b65b957e0f', '2024-01-30 09:52:59.450464', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa0f-f689-1ea9-73f47ce24812', 'Toddlers', '{}', '338ef5a1af8c44e6942dcb0df7bbcb6e', '2024-01-30 09:52:59.452622', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b37f-1c3c-154a-5fc05ea8e835', 'BRFS Tall', '{}', '87a4a7a59fb84e478f17265fc90f25e2', '2024-02-02 10:28:59.399084', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b37f-4dd0-e786-fc769333b513', 'BRFS Baby', '{}', '5ef27982b01f4cb4b75f7aa47d51b052', '2024-02-02 10:28:59.39673', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b37f-9c68-4af9-a7e043d79d92', 'BRFS Women', '{}', 'd77b64676c19404ca134753ae1447b67', '2024-02-02 10:28:59.394789', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-220f-d013-1006-25030e1c4971', 'Mens', '{}', '3ff28c37da6e47c8b6c77035f454d0d0', '2023-05-26 14:01:58.630973', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-0592-3b1e-c422f9013905', 'Girls', '{}', 'e7c9da88fb86428690f7d7ace2f00cfa', '2023-05-26 14:01:58.661969', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-1980-c64e-bd99eecc1c92', 'Teen Girls', '{}', '7eb1206d1daf4b69b20b0439cbd8d4e6', '2023-05-26 14:01:58.664474', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-7698-3c3f-c90317f131c1', 'Baby_Infant_Newborn_Toddler', '{}', 'c3bb3d423c4545d087bda43343dee284', '2023-05-26 14:01:58.664376', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-7d16-13f5-a57d6adc7199', 'Teen Boys', '{}', '3dde092ccef245b680c5b2d9e2990366', '2023-05-26 14:01:58.664428', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-b852-827d-34a4e881d20a', 'Others', '{}', '26038b68826d4d45ab7c3a95fd9ccebf', '2023-05-26 14:01:58.664519', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-c0ef-7380-365754ac9ff9', 'Boys', '{}', '33f219db73da4de0adea733baafe489d', '2023-05-26 14:01:58.664331', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-e0b7-747f-899c0a793431', 'Womens_Maternity', '{}', '5c13d517b08044c2bcc2b3d35d79b287', '2023-05-26 14:01:58.664267', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', 'OTHERS', '{}', '3ad21980322c4400b51d61e81abf099e', '2023-05-26 14:01:58.664564', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-07ab-f486-f54a2dd49b82', 'UNIVERSAL', '{}', 'ccee4ad46a824068a9278b03cafa99c4', '2023-05-26 15:32:31.684435', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-2168-ea21-a05b6666288a', 'WOMEN', '{}', '410eb23e2a9a489a84c6789b77bec840', '2023-05-26 15:32:31.684352', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-2173-ff5b-217480fd2a7b', 'BOYS', '{}', '1214e505f5f64cd9962c2a983b4ff49a', '2023-05-26 15:32:31.684212', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-33de-544d-9a8f959de695', 'FOOTWEAR', '{}', 'ebbf90c3e30843c798989d13a7ac8f01', '2023-05-26 15:32:31.684478', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-487c-b42c-3e08fe71ba71', 'Universal', '{}', '85db4b899b6440d0bbbca39943181b8f', '2023-05-26 15:32:31.684268', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-5220-6222-f5457a734acc', 'BABY', '{}', '07a8193c00d041dcaa6a506378a87d7d', '2023-05-26 15:32:31.684393', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-5912-13e9-a145cae7c89f', 'MEN', '{}', '575610fed53742509cd90da4bfefd18b', '2023-05-26 15:32:31.668583', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-7da1-34e1-cd0d98d494e0', 'MATERNITY', '{}', '87b529efcc4240cebe44de6bc6f6513a', '2023-05-26 15:32:31.68431', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', 'DOG', '{}', '02c8109b58d54164bd07198940a1094d', '2023-05-26 15:32:31.68452', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', 'GIRLS', '{}', '2a4e4f1406184a45b78dbb6c1998f988', '2023-05-26 15:32:31.682057', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-9f55-d7ee-d479-006ea423fa34', 'BR WOMEN (MISSY)', '{}', 'e6a006764a984b2a8fc319aa701601e2', '2023-05-26 16:07:01.983346', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-9f55-e760-de7e-3e7d79cc52fa', 'BR MEN', '{}', 'd21e29d3000f490f8fbf3ef2c1b13855', '2023-05-26 16:07:01.96975', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-44ec-ceaf-bbc9-9f5dfd749109', 'BRFS WOMEN (MISSY)', '{}', '16f9449e55254b228138465d2e935f86', '2023-05-26 16:15:22.98144', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-44ed-f91f-3cb0-f893cf06b723', 'BRFS MEN', '{}', '281aa166bc7f4b7886dd64c1db0aa951', '2023-05-26 16:15:22.995147', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c0821-0d69-04ae-a309-96f2dae01921', 'Test1', '{}', 'd12bdcad07ce4bc58f188a21fcae62e0', '2023-06-26 12:26:42.41109', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:01:06.713558', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:01:06.712726'),('3a0c08e5-7194-057c-bbb9-eedfa8e32a8b', 'Test1', '{}', 'd8546775edaf469884d515db225c2a59', '2023-06-26 16:01:13.109989', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:01:32.825003', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:01:32.824421'),('3a0c08e5-f7ae-3aca-ce05-380867a314c5', 'Test', '{}', '62848cb91a7244f78fd81dc76383980b', '2023-06-26 16:01:47.438698', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:20.663196', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:20.659823'),('3a0c0821-53e2-3279-8b46-d1c593a4380b', 'Test1', '{}', 'bcea957c34d342efb707e58f224caf90', '2023-06-26 12:27:00.450647', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:22.886472', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:22.885913'),('3a0c0911-035a-3402-0ecf-2d7019f5dcba', 'Test2', '{}', '0cde7ac3b44341d9b21f64a7b0203fd6', '2023-06-26 16:48:48.475882', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:25.308544', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 16:49:25.30805')
;
COMMIT;
BEGIN;
LOCK TABLE "public"."wp_product_type" IN SHARE MODE;
DELETE FROM "public"."wp_product_type";
INSERT INTO "public"."wp_product_type" ("id","name","extra_properties","concurrency_stamp","creation_time","creator_id","last_modification_time","last_modifier_id","is_deleted","deleter_id","deletion_time") VALUES ('3a0b6926-0ca4-06a5-d198-61e3090c7618', 'Hats', '{}', '1d336329347b4016aa6dbe8f2af09df7', '2023-05-26 15:32:32.549637', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-0700-897d-c39ccfb96386', 'Kids', '{}', '62e0013774044e4ea3cc16a4b2486377', '2023-05-26 15:32:32.551279', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-0c34-91ed-b52ed97b4187', 'Hair Ties, Headbands & Hair Accessories', '{}', '39eb447a2de444b1b7a8171463b66731', '2023-05-26 15:32:32.55037', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'Tops & Dresses', '{}', '059235cf5b81413cbe4ac5e480b78bf9', '2023-05-26 15:32:32.550998', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'UnderGarment Tops', '{}', '6f47150051fa4affb655df1ce78a30d7', '2023-05-26 15:32:32.549347', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-19d9-e9ad-b1b188dae848', 'Bags', '{}', '39e437892d7f4032b3db6556ab266a0d', '2023-05-26 15:32:32.550572', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-2282-7614-ed7706e671c5', 'Umbrellas', '{}', 'a8b61533ec6a43b9a112b3388681896a', '2023-05-26 15:32:32.55032', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-2389-760a-ec7dab04c63c', 'Tights', '{}', 'ea14a4700aea48af892f843adcd34c1b', '2023-05-26 15:32:32.551512', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-2430-da0d-e8ef7a29d82e', 'Beach Towels', '{}', 'df217238aeaf4bf789dae1d17b9aac70', '2023-05-26 15:32:32.55047', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-2be0-758a-06e232d7f0f6', 'Knit Hats', '{}', '74fa4d85b8d14ac7b47e42f6650b6fb6', '2023-05-26 15:32:32.550222', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'Top - Sleep Snug', '{}', 'eb06f0a8dc7e4387ba69449626feb78d', '2023-05-26 15:32:32.551571', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-34c3-4e5c-11e6de75cf25', 'Belts', '{}', '139e07e68ee24635912731a5d0bfd064', '2023-05-26 15:32:32.549009', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-3852-ad92-431df5ec2280', 'Knits Hats and Caps', '{}', '1f0bbbf726b14f7ca1be86e1a9a8bdad', '2023-05-26 15:32:32.54949', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-4060-8a08-87ee9b4b71dc', 'UnderGarments', '{}', 'fc6702244a8c402ab857f008f4c8f3e8', '2023-05-26 15:32:32.551053', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-4898-5c90-cde054079121', 'Jewelry', '{}', '72394abf39714f98a97d8a6086a50d99', '2023-05-26 15:32:32.549305', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'Toddler', '{}', '988cc00de74a42f3a38175849f092f96', '2023-05-26 15:32:32.551165', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-5632-0013-9c5a4acd2162', 'Knit Hats and Caps', '{}', '4035c36f234248aeb574a2e3219f52fa', '2023-05-26 15:32:32.551453', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-59c4-1a32-c170aca4803c', 'Collar', '{}', 'c59ab20e9ebc41298a7e821d7d0bae22', '2023-05-26 15:32:32.550624', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-5b57-5ec5-5f579cc9e38d', 'Leash', '{}', '2ea2fc8d52db4b0b8687c27a78f18770', '2023-05-26 15:32:32.550676', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'UnderGarments Tops', '{}', '0af3d93462ef4e1fb507233156838f62', '2023-05-26 15:32:32.549725', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'Garment', '{}', 'b7571aa546804f539185d056cd710208', '2023-05-26 15:32:32.550833', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-66ad-28c5-a2370330a232', 'Tops', '{}', '054a3d003e7c40528d0d376999d649e0', '2023-05-26 15:32:32.549782', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'Top & Dresses EXCEPT Sleep Snug', '{}', '2a9b9bbc28084110854b99cbddf16846', '2023-05-26 15:32:32.550079', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'Bottoms', '{}', 'f47b1cb59df042f2ae66b5f12a9b0134', '2023-05-26 15:32:32.549388', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'Mens', '{}', 'e0aceca9c2d44fb4a520987b6c6ade92', '2023-05-26 15:32:32.550033', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-7c36-acad-12ebafd8c716', 'Scarf & Blanket', '{}', 'a23277e95c2e4afeaf7de6df664e9808', '2023-05-26 15:32:32.55042', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-8395-e0d6-ee0f99391d21', 'NewBorn or Toddler', '{}', '6be1b7608cd7403e97082353f4bc5874', '2023-05-26 15:32:32.549895', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-85de-782e-4460e0b7a850', 'Top & Dresses Sleep Snug', '{}', '5d11d6b285ce4365996b1afef838d613', '2023-05-26 15:32:32.549829', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'Mens - Forever Collective', '{}', '5bdba51a3a424488b675586224b5cd79', '2023-05-26 15:32:32.551337', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-96dd-63bd-c7b166ddf2eb', 'Earmuffs', '{}', 'd554c23581954179b4035e73c89c797d', '2023-05-26 15:32:32.550175', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-989f-2777-b6e102a93443', 'Baby Bibs', '{}', '1a17c4c36c2d467880750a8eec030b59', '2023-05-26 15:32:32.550127', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-9c9e-8cb3-8a8541a66beb', 'Toy', '{}', 'f3690418a95f4eb899ac918b524bde77', '2023-05-26 15:32:32.550729', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-9e82-04bf-8d1094bc6403', 'Adjustable Hats and Caps', '{}', '3cd5140c20df423db2fd7afb001a9c3a', '2023-05-26 15:32:32.549532', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-a48d-93be-70b1603b5160', 'UnderGarment Bottoms - Belly Band', '{}', '8655298f044242e5ae6f2e6f9040b952', '2023-05-26 15:32:32.550889', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'UnderGarments Bottoms', '{}', 'ad7640adee7a4fc48977c1bff33a2f5e', '2023-05-26 15:32:32.549681', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-acab-cf36-334ffe531b27', 'UnderGarment Bottoms & Swim', '{}', 'def0cb99f30c42adb5ad25b4faa83809', '2023-05-26 15:32:32.550943', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'Bottoms - Sleep Snug', '{}', '6d6d049e7fb1416596c59baef9c3bccd', '2023-05-26 15:32:32.549181', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Women''s / Maternity Tops, Dresses & Outerwear - Dual Alpha Sizing', '{}', '501c0ece1d65441d91e4a0ac1dd5c699', '2023-05-26 14:01:58.946506', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Men''s Shorts - Alpha Sizing', '{}', 'b1a1ce04d2354f0aae9a97b89a6d6b5c', '2023-05-26 14:01:58.946041', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Infant Tights - Numeric Sizing', '{}', '866afb7c1f564c88999d7ce227261695', '2023-05-26 14:01:58.938585', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0745-618e-918791902aed', 'Women''s Footwear', '{}', 'd6d19fbdd4904e7ab1629c8e07ef10cf', '2023-05-26 14:01:58.943887', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0856-7830-3e34768ec693', 'Newborn Woven Gloves/Mittens - Numeric Sizing', '{}', '2c8d938281f944528e9d3948e9fdaa28', '2023-05-26 14:01:58.938354', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Toddler Boy & Girl Bottoms - Denim, Woven, Knit, (Outlet - Sleep Bottoms) - Numeric Sizing', '{}', 'a8b3617224644bc0bc253a5686bd0c4c', '2023-05-26 14:01:58.937567', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'INFANT - TODDLER HEADBANDS -Numeric Sizing', '{}', '972a03f6e869439fa2a57aae4861b9b7', '2023-05-26 14:01:58.94825', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-0e9d-e7cb-83bcdbfa9dfd', 'Girl''s Scarves', '{}', '3bdd717f06874b7bbf7b715d6eb5d514', '2023-05-26 14:01:58.939175', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-1016-d539-c4328a2f8e84', 'Women''s Scarves', '{}', '4ad7f611cffa43f782cd51bddd7ee43c', '2023-05-26 14:01:58.941817', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-107d-666a-56ad73c13d60', 'BOY''S UNDERWEAR - ALPHA NUMERIC SIZING', '{}', '0d70df5ece424f58ac45d26b87ac3732', '2023-05-26 14:01:58.948763', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-1229-2ce7-628852840be6', 'INFANT TIGHTS - NUMERIC SIZING', '{}', 'fdfcbee7643f443d99a3aff25326b3f0', '2023-05-26 14:01:58.942606', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-b4af-8018-c4a2505a756f', 'Water Bottles & Sippy Cups', '{}', '4889f7a3885a48f3a3e7c28f621bfe2c', '2023-05-26 15:32:32.550271', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-b9da-3de8-d9fab52ceda5', 'Socks', '{}', '8d7e93a866be4fc58e381c9aea3b6307', '2023-05-26 15:32:32.549575', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-cc77-5b00-71f0d63b8294', 'Hats and Caps', '{}', 'e4e03d6f2ec140258e18ce93de765f39', '2023-05-26 15:32:32.551394', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-e721-597f-54fdd4c0bc82', 'Gloves', '{}', 'e266a778fdf44c9fa170586cb27cd5e9', '2023-05-26 15:32:32.549428', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'Newborn', '{}', '3ac6676b366d4491b4830d3c91d8034e', '2023-05-26 15:32:32.551108', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'Bottoms - EXCEPT Sleep Snug', '{}', '0fb39250ebae4aee99a8e9ee10419fab', '2023-05-26 15:32:32.549262', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-f595-0bad-a02861647b77', 'Kids - Forever Collective', '{}', '8c3c0e571b824a42b73e175e3dea625e', '2023-05-26 15:32:32.551222', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Women''s / Maternity Tops, Dresses & Outerwear - Alpha Sizing', '{}', 'c3df19d3ab1c439bab2b53db8cf898e8', '2023-05-26 14:01:58.936868', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Women''s / Maternity Bottoms, Denim, Lounge & Active - Alpha Sizing', '{}', 'd6247c28101c45c79380369ad30e7cf6', '2023-05-26 14:01:58.937347', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-14fc-dba8-880741636a4d', 'Dog Sweaters', '{}', 'b8d5e1a0c914474699901546b4456456', '2023-05-26 14:01:58.943526', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-1e7b-dc82-553848260965', 'Girl''s Socks - With Spandex', '{}', 'e86c0f8ff9074b158be700059a02b1dd', '2023-05-26 14:01:58.938757', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-2772-0f83-1ae9ec1022cd', 'Girl''s Headbands', '{}', 'facffa9a8171435d8ca2612e5458fb66', '2023-05-26 14:01:58.938935', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-28d9-e5da-9797f8fc4682', 'Women''s Socks - One Size (W/O Spandex)', '{}', '0f0037b17e494d50b5f3b2565351c42a', '2023-05-26 14:01:58.94069', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Boy''s Tops, Swim Tops & Outerwear - Alpha Sizing', '{}', 'febd7b617f914802ba40c2f7f30f30d9', '2023-05-26 14:01:58.937016', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3040-560f-b95803c0b112', 'Girl''s Bottoms Regular Alpha - Numeric Sizing', '{}', 'c2ae4e7d9b204dca83018ea375ad80f5', '2023-05-26 14:01:58.947355', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Men''s Tops & Outerwear (Wovens & Knits) - Numeric Sizing', '{}', '1dac95d96f7241b68a7b46843be5555a', '2023-05-26 14:01:58.94595', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3708-1eca-242b4d964916', 'Infant - Toddler Woven Hats - Numeric Sizing', '{}', '3545df38fa40469ea84fc2dba686abb6', '2023-05-26 14:01:58.938038', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Toddler Boy & Girl Underwear - Dual Numeric Sizing', '{}', '21b01361bd894e40931088abfd89218b', '2023-05-26 14:01:58.937882', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Men''s Shorts - Numeric Sizing', '{}', '2678a913f27445cba1f2c870b21b7e14', '2023-05-26 14:01:58.946132', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3b60-b833-94cf629eb613', 'Newborn/Infant Bottoms - Denim, Woven, Knit - Numeric Sizing', '{}', '7d769f5999414766a454d37a037110a0', '2023-05-26 14:01:58.937615', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Newborn/Infant Woven Hats - Numeric Sizing', '{}', 'b11ed09a5fac418b8f2ce9441bf6405d', '2023-05-26 14:01:58.938248', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3dbd-7cf0-fc3d70abc36c', 'Women''s Headbands', '{}', '230d569758ba4f7aa93f75e68f0f962a', '2023-05-26 14:01:58.941392', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3ef6-84d6-7cfea460ba11', 'Boy''s Belts - Dual Alpha Sizing', '{}', '24169a04957244bd84803d0b3ade4842', '2023-05-26 14:01:58.946973', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Toddler Boy & Girls Socks - Without Spandex', '{}', 'b0de25b2e7c3413a865430b75c7d89a1', '2023-05-26 14:01:58.937933', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3f51-fb5c-714f94367e54', 'Toddler Boy & Girl Tops - Dual Alpha Sizing', '{}', '1af414b942e54a6485296800adc68296', '2023-05-26 14:01:58.945191', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Toddler Boy & Girls Socks - With Spandex', '{}', 'e99cd6faac35465faaa3a76635ab5e07', '2023-05-26 14:01:58.937818', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-43ba-4d32-d4765755b21f', 'Girl''s Woven Hats - Dual Alpha Sizing', '{}', 'c836230eb7a948569e702790f41aa025', '2023-05-26 14:01:58.947653', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-4407-8b9e-a6afa1319c44', 'Toddler Boy & Girl Woven Hats - Dual Alpha Sizing', '{}', 'e96c6f0ee7004d838d02ad4d52288596', '2023-05-26 14:01:58.944265', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Boy''s Woven Bottoms, Knit Bottoms & Denim - Numeric Sizing', '{}', 'c037ca3a65ab4036919f1d9c65cdcdc4', '2023-05-26 14:01:58.937166', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-45c1-f2af-4cad493341e4', 'Girl''s Belts - Alpha Sizing', '{}', '8cafe59e588c41168a6ad0d61711ea77', '2023-05-26 14:01:58.947751', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-4811-7a0d-f7453d8c0729', 'Girl''s Leg Warmers', '{}', '0577c710bc6445e89c1765dc42a653f7', '2023-05-26 14:01:58.939114', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-49c2-60e8-0bb146df8a52', 'Women''s / Maternity Jackets & Bathrobes - Dual Alpha Sizing', '{}', 'eacdb50906b04da1bf97623318a3828a', '2023-05-26 14:01:58.946406', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Men''s Woven & Denim Bottoms', '{}', '38c8d708750a4cdf8c825f240b0a3224', '2023-05-26 14:01:58.936468', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-4e16-36d5-892d7cb07f93', 'Newborn/Infant Handbags, Totes, Backpacks, Wallets, Luggage', '{}', 'd90a8aea741e4c48a18d1c89576871e5', '2023-05-26 14:01:58.942452', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-4e71-f43c-5fa7e185650d', 'Toddler Boy & Girl Scarves', '{}', '01f899d5029f4b53925e2cbfde6eaa26', '2023-05-26 14:01:58.941915', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Toddler Boy & Girl Tops, One Piece & Sleepwear - Numeric Sizing', '{}', '9716d20b6b0f425e8572e0dcc364cef7', '2023-05-26 14:01:58.937518', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'KIDS SHOES AND FLIP FLOPS (D) REG WIDTH', '{}', '66a1ad6141424ac28f85a8927388f2c5', '2023-05-26 14:01:58.948661', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-57c5-dd8d-3f495b0c94bf', 'Baby Leg Warmers', '{}', '0999ccaba4ce44899e5b6908f80e19f1', '2023-05-26 14:01:58.941168', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-5981-531c-629f152fffa4', 'NEWBORN - Numeric Sizing', '{}', '19aa7b4eacda48379de811edcac8c4d6', '2023-05-26 14:01:58.94835', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-5b49-14b8-c57b35a022e2', 'Boy''s Hats - Woven - One Size', '{}', 'a81111d1d0d545459c22b304096139e9', '2023-05-26 14:01:58.940529', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-5e98-8d89-1c1c318078cd', 'Women''s Sleepwear', '{}', 'f9d10de6c81547d28ffbf5574018df72', '2023-05-26 14:01:58.9421', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Men''s Briefs, Knit Boxers & Knit Bottoms - Alpha Sizing', '{}', '4fee12be70c849a998a29b275cc49593', '2023-05-26 14:01:58.945769', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6331-d8ba-438a49af2b55', 'Girl''s Handbag', '{}', '533c85d93edf4747a906ecb596bcd17b', '2023-05-26 14:01:58.938875', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Toddler Woven Hats - Numeric Sizing', '{}', 'a6a4ce1aa0f94d7693809b144da1f5b9', '2023-05-26 14:01:58.937985', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-65c2-1cb4-e8b699a38e29', 'Women''s BELTS - ALPHA SIZING', '{}', 'fda3516afe524fe6a992512fc91f8a47', '2023-05-26 14:01:58.942696', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Newborn/Infant Socks - Without Spandex', '{}', 'ba7adc7126fd43a190c6c0001b152595', '2023-05-26 14:01:58.938471', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6829-6223-f9d5706de912', 'Newborn Knit Hats - Numeric Sizing', '{}', '6b3d0429ebcf4efc978ef4fc8de1b401', '2023-05-26 14:01:58.938408', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Women''s Panty, Swim Bottom, Tights, Panthose, Leggings - Alpha & Dual Alpha Sizing', '{}', 'fb96d87ba4b843429e82b8c7838e71dc', '2023-05-26 14:01:58.946314', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Men''s Shoes - Alpha Sizing', '{}', '511c24fb34194125901fd92003bf2448', '2023-05-26 14:01:58.944521', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6a89-2501-9d7ae73292fb', 'Boy''s Belts - Alpha Sizing', '{}', '35b5a40ffc1a4b7dbe7a540a66dbc468', '2023-05-26 14:01:58.947068', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Newborn/Infant Tops, One Piece & Sleepwear - Numeric Sizing', '{}', 'daf21f8ebc1a4ac3a97ec89a29244724', '2023-05-26 14:01:58.937664', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6c2b-8bdf-fed3dc8214fb', 'Girl''s Gloves & Mittens - Alpha Sizing', '{}', '6bc4175da56d413e9022529f3ba74775', '2023-05-26 14:01:58.947456', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Women''s / Maternity Tops, Dresses & Outerwear - Numeric Sizing', '{}', 'ee13e8518d034c40857efaef4579dea5', '2023-05-26 14:01:58.937412', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'TODDLER SHOES (SLIPPERS) - ALPHA SIZING', '{}', 'cb53be7add4e4d66b07a080163f5094d', '2023-05-26 14:01:58.943102', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-74ce-1093-a7088791c880', 'Men''s Briefs, Knit / Woven Boxers & Knit Bottoms - Alpha Numeric Sizing', '{}', '835d230b626142bb8ac10364f152ce6c', '2023-05-26 14:01:58.945678', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7628-c0e7-2953753a67e1', 'Men''s Socks - Alpha Sizing', '{}', '189477d6cb634f50b83119621ea81334', '2023-05-26 14:01:58.940758', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7744-6623-09d5f49320cd', 'Boy''s Handbags, Totes, Backpacks, Wallets, Luggage', '{}', '10bded1028394b0f81917f65f9a63069', '2023-05-26 14:01:58.940405', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Men''s Collar Shirts With Neck Sizing', '{}', 'b8cbbb385e9544f4b0e3143d5bfa6c1f', '2023-05-26 14:01:58.945389', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Boy''s Sleep Bottoms, Swim Bottoms & Underwear - Numeric Sizing', '{}', 'd58ab41b7f1546a1a2a42f74401c2a48', '2023-05-26 14:01:58.93706', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Men''s Belts - Numeric Sizing', '{}', '2fc910be63554959a58425f2d7f6a16b', '2023-05-26 14:01:58.944994', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Women''s Woven Hats', '{}', '3b15591bdb7a407986cf8cdc41f55c9b', '2023-05-26 14:01:58.940996', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7d68-c07a-b92a3815bbb5', 'Boy''s Scarves', '{}', '885c3135f7bb49b5b1fa2782f04baeb2', '2023-05-26 14:01:58.939361', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7dcb-0ca5-19fb6787a519', 'Girl''s Earmuffs', '{}', '04f7fc102839458786ddcfcda8fd4570', '2023-05-26 14:01:58.938993', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Girl''s Bottoms Slim Alpha - Numeric Sizing', '{}', '435331ca9a73471eae920ded3dfcc933', '2023-05-26 14:01:58.947259', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Boy''s Tops, Sleep Tops & Undershirts - Numeric Sizing', '{}', '2c4af01bd31e45dbad6d75c69f37614e', '2023-05-26 14:01:58.942843', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-80c6-83bd-2a580112b620', 'Handbags, Totes, Backpacks, Wallets, Luggage', '{}', 'c0ff78e6906e4f31b4079d05494b1dc4', '2023-05-26 14:01:58.94226', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-8117-8b6f-f6106a33ac4c', 'Women''s SHOES (B) REG WIDTH', '{}', '5b7bd90a32994601889c9b6d26ca1ec7', '2023-05-26 14:01:58.943021', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Toddler Boy & Girl Knit Hats', '{}', '1f3a5b460d3d42f3b4a27104325ea2fb', '2023-05-26 14:01:58.941467', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Infant - Toddler Knit Hats - Numeric Sizing', '{}', 'bc1fdcdd244e4ffc9b590cbaf32d3f1f', '2023-05-26 14:01:58.93809', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Women''s Shoes (B) Reg Width', '{}', 'e5b3cf201549409f9f555a5f032d2e67', '2023-05-26 14:01:58.943267', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Newborn Shoes (D) Reg Width', '{}', '91c23c4af1ff43ad8322d454c76da484', '2023-05-26 14:01:58.944018', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Girl''s Woven Bottoms, Knit Bottoms & Denim - Numeric Sizing', '{}', '3f20b0ae603448e7aec14bd12e51eeac', '2023-05-26 14:01:58.937104', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Infant Hat/Mitten Set - Numeric Sizing', '{}', '3881d7bc93f4484999e178b71c7b8203', '2023-05-26 14:01:58.938527', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Women''s and Maternity Denim - Numeric Sizing', '{}', '5c5091ea54fe4aa4bf58b481566b5bdb', '2023-05-26 14:01:58.936825', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Boy''s Woven Bottoms, Knit Bottoms & Denim - Alpha Sizing', '{}', '6138cc2ad8894d0d8d2d6f2d2472ad6d', '2023-05-26 14:01:58.936953', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-95bc-3dfc-0a1b593accae', 'Men''s Woven Hats - Dual Sizing', '{}', '1516bf5fdd044d78bcbcd6e10af5ceaa', '2023-05-26 14:01:58.944758', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9607-1abf-44de15979e47', 'Girls''s Hats - Woven - One Size', '{}', '0e90c6f99e304d80975beb8b489b1793', '2023-05-26 14:01:58.939299', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-97df-de7b-257cf76a473b', 'Men''s Gloves', '{}', '8548d9057eec4055811536de6eea4827', '2023-05-26 14:01:58.94132', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Kids Shoes (D) Reg Width', '{}', '356637b22b0b4a978436cd2febd5a1af', '2023-05-26 14:01:58.946599', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9eaf-f686-592904d735f2', 'Women''s SLIPPERS', '{}', '2f8f7dcf2328414f90be5d68048cc71f', '2023-05-26 14:01:58.943183', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Men''s Under Shirts - Alpha Sizing', '{}', '104d31a4f370440cab63628ce499f754', '2023-05-26 14:01:58.94586', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Khaki Style For Men''s And Women''s Denim Only', '{}', '70f0679feb7247e4ad7e76c64dd2cf58', '2023-05-26 14:01:58.94341', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-a5bd-9668-0296bc777474', 'Men''s Woven Pj Bottoms - Alpha Sizing', '{}', 'e143fafd049a4b1c8839a4faa4975032', '2023-05-26 14:01:58.945581', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-a5d1-8b1a-6681f41aed59', 'Men''s Knit Hats', '{}', '79b41be92d664c928678c62a85e40cea', '2023-05-26 14:01:58.941238', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Girl''s Tops & Sleepwear - Numeric Sizing', '{}', '1d1b2f8efa7b495abe2f6f2b63643ef8', '2023-05-26 14:01:58.942939', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-abc6-5927-9b41f70fc3ad', 'Women''s SOCKS - ONE SIZE (WITH SPANDEX)', '{}', 'c69d2ed3d6724db0981a12427f83cd78', '2023-05-26 14:01:58.942369', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Women''s Gloves', '{}', '6aa24a21e6fd44689c84d7b9b7d89c8d', '2023-05-26 14:01:58.940918', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Girl''s Tops, Swim Tops & Outerwear - Alpha Sizing', '{}', 'f866071d4a9b4c0188d17cde1b0f10e4', '2023-05-26 14:01:58.937301', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-ae4a-b884-905829162a3c', 'Men''s Shoes - Dual Numeric Sizing', '{}', '50fee556abcf41a0ac2b3372cfc56a1c', '2023-05-26 14:01:58.943775', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Women''s Belts - Alpha Sizing', '{}', 'dfa1c1158f4a47f69b618614eaba47d1', '2023-05-26 14:01:58.946223', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-b554-462b-291d8f62b33e', 'Boy''s Socks - With Spandex', '{}', 'e3044cd05e2942889ef85faf18a61f37', '2023-05-26 14:01:58.939237', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Girl''s Underwear - Alpha Sizing', '{}', 'c53b4f2e5f6d468fa9c8d38f0854c836', '2023-05-26 14:01:58.936675', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Girl''s KNIT HATS', '{}', '4ca316731073407e8f905f89d9fe65f7', '2023-05-26 14:01:58.938816', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Newborn Knit Gloves/Mittens - Numeric Sizing', '{}', 'be9547072fc94fb0973c9ed07026f22e', '2023-05-26 14:01:58.938301', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Toddler Shoes (D) Reg Width', '{}', '83e2d8ded20440d7886bf0e0ed8752fb', '2023-05-26 14:01:58.944131', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-bec5-de88-f6ec558ddb30', 'Toddler Boy & Girls Socks - Dual Alpha Sizing - Without Spandex', '{}', '2aa527a84b594d3a8053e86b3c3ab312', '2023-05-26 14:01:58.943676', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-beef-4b96-697ae26c1476', 'Girl''s Knit Hats', '{}', 'd0137c2e54a4449daf930746b642bc3c', '2023-05-26 14:01:58.947555', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-bfa1-05a3-b0d0a7835e54', 'Toddler Boy & Girl Gloves & Mittens - Dual Alpha Sizing', '{}', '965c6157d7314eed9a4ece9dd7424767', '2023-05-26 14:01:58.944377', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c181-a8bd-98f9701619cf', 'Girl''s Tights - Dual Alpha Sizing', '{}', '2fc6e794e73b4762a696d21d1fad2151', '2023-05-26 14:01:58.94785', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c1d4-cbc5-e3c060b978e1', 'Women''s Knit Hats', '{}', 'f1d8b79e1b404aefbceedf17e224b0c0', '2023-05-26 14:01:58.941095', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c459-a695-1b0f4c446eb7', 'Boy''s Woven Hats - Dual Alpha Sizing', '{}', '9576df17ab4c437dba39f33f2384c5ce', '2023-05-26 14:01:58.946785', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Boy''s KNIT HATS', '{}', '6d8161db814e4b958cd7e4624e8f4159', '2023-05-26 14:01:58.940058', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Boy''s Socks - Without Spandex (Outlet Size Chart)', '{}', '6f9ae7ef40f849fcb5b3de4b44191e1c', '2023-05-26 14:01:58.940617', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-c84f-6058-c43ce11f704f', 'Men''s Belts - Alpha Sizing', '{}', '9bc5a59d373d46799c2191a17576c9df', '2023-05-26 14:01:58.944897', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-d145-94a8-c29267eb9430', 'Boy''s Ties', '{}', '942279f883574c358e87f95087995348', '2023-05-26 14:01:58.939423', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Girl''s Socks - Without Spandex', '{}', 'dba38625a8d44cdca481fc85e401db1f', '2023-05-26 14:01:58.939053', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Girl''s Underwear - Alpha Numeric Sizing', '{}', 'cc7a325fad964a959320eadc52cbed43', '2023-05-26 14:01:58.947949', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Newborn/Infant Socks - With Spandex', '{}', 'd9be7b9832b148c5b46172a9cbb2629e', '2023-05-26 14:01:58.938195', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-db72-ed40-794fde312607', 'Infant Knit Hats - Numeric Sizing', '{}', '7786b088e99b4b8c9d65b26c93d9da05', '2023-05-26 14:01:58.938642', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Girl''s Sleep Bottoms & Underwear - Numeric Sizing', '{}', '00701e3210f64ea5a726abadb56fc725', '2023-05-26 14:01:58.948049', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e069-cc20-180a73889e60', 'Infant Gloves & Mittens - Numeric Sizing', '{}', 'b969b62735ee4480a11e5ffda9391310', '2023-05-26 14:01:58.938142', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Women''s Bra, Camisole, Swim Top, & 1-Piece Swim', '{}', '1349cac947a24d608c49e057a9224710', '2023-05-26 14:01:58.937469', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Infant Outerwear & Swimwear Knits & Woven', '{}', 'aa1bcb178f2f40488c8107de04c54743', '2023-05-26 14:01:58.938699', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Boy''s Sleep Bottoms & Swim Bottoms - Alpha Sizing', '{}', 'ff0ee4b2fa9d4b43a3fb3577c08f708e', '2023-05-26 14:01:58.937256', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Men''s Tops & Outerwear (Woven & Knits) - Alpha Sizing', '{}', '67e75d5deb5b4bbf981996f146b3936a', '2023-05-26 14:01:58.94253', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e7be-1769-35299b754315', 'Toddler Girl Tights - Numeric Sizing', '{}', 'b35d88e862aa45ffabe6051eb61e11fb', '2023-05-26 14:01:58.937767', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-e943-0e10-fa44023e6216', 'Boy''s Knit Hats', '{}', '46f9263db4df41ba8283b95c78cbc8fc', '2023-05-26 14:01:58.946879', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'KHADI STYLE FOR MEN''S AND WOMEN''S DENIM ONLY', '{}', 'fa3170a5844c46f0ad1d34f11529f3aa', '2023-05-26 14:01:58.94815', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Infant Headbands', '{}', '7d0098e3e6234ff2b5c66bc042a790f4', '2023-05-26 14:01:58.937717', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f564-4619-85abdcf21226', 'Women''s and Maternity Woven Bottoms - Numeric Sizing', '{}', 'a7ffee1bbe0649edb0c3a0ddfa5d7228', '2023-05-26 14:01:58.93691', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f595-5385-5d8564a0738d', 'Women''s And Maternity Denim - Numeric Sizing', '{}', '7a40716e26aa49cab869e657dd755c42', '2023-05-26 14:01:58.936776', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f66b-0046-267e93b606fd', 'Boy''s Underwear - Alpha Sizing', '{}', '2729d5bf77d44dec82bef5e4e934ca4b', '2023-05-26 14:01:58.947163', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Men''s Shoes (D) Reg Width', '{}', '72b0fcadc89a46b288adca50a7c4a797', '2023-05-26 14:01:58.944664', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-f96b-e1e7-9a5d3b960c0f', 'Men''s Ties', '{}', '4bc8b241c57d42a8a8ba8eec53022a36', '2023-05-26 14:01:58.941539', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-fa07-f4fd-146a1fb15d21', 'Men''s SCARVES', '{}', '16877612c9e846c7ac8f50ffbbe9be15', '2023-05-26 14:01:58.941996', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-fbb7-e51c-c71e8847e2c7', 'WOMEN''S FOOTWEAR ALPHA NUMERIC SIZING', '{}', 'cb2ce27c97a1454aa1f0fcffc3c23292', '2023-05-26 14:01:58.948558', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-fc2a-f50a-b69401759c32', 'Baby Blankets', '{}', '9dffd55b6d834f6ea91349082111f1b4', '2023-05-26 14:01:58.94161', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-fd07-5fc3-8d6e440f42f0', 'NEWBORN/INFANT KNIT HATS', '{}', '32ae159a13ff4eefb87740c7e8df02b8', '2023-05-26 14:01:58.941682', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-fe72-7341-9187777fa457', 'Girl''s Woven Bottoms, Knit Bottoms, Denim, Swim Bottoms & Swim One Piece - Alpha Sizing', '{}', 'bb6e8768d1f04ec7b5b514f279a6536e', '2023-05-26 14:01:58.937212', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b68d3-2385-ff5b-9d4e-c827ac82c155', 'Boy''s Gloves & Mittens - Alpha Sizing', '{}', 'c32debfad9ff4c0aa4abdeee22036fd0', '2023-05-26 14:01:58.946692', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'Top - EXCEPT Sleep Snug', '{}', '515707e364cc43f6a620ec256f74e1b7', '2023-05-26 15:32:32.54994', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6926-0ca4-fb14-766d-bfe8b62a60ba', 'Ties', '{}', '738c7021c3e74a36b9c33aedaf3838d0', '2023-05-26 15:32:32.550521', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-01eb-0deb-895b0f1ac44d', 'BR - MISSY / PETITE / TALL Tights', '{}', 'dc3ee15f5faf4aefabc4d3553515e870', '2023-05-26 16:07:02.300349', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-0e54-2504-ad449f4f3f11', 'BR - Men''s Vests', '{}', 'd8a07f3ff7254ad0b2d04bf2e4200fa3', '2023-05-26 16:07:02.300022', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-11b0-c3e8-3c93a4b76384', 'BR - Men''s Woven Boxers', '{}', 'aadc3b8438d3495db937b8c2e396e2bd', '2023-05-26 16:07:02.299813', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-147c-9ebf-e12a7be4a277', 'BR - Men''s Woven Hats', '{}', '40c5bc59a8d34ff79c09d29cf9d1a083', '2023-05-26 16:07:02.299342', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-1507-8cb6-19e99b643c3c', 'BR - Missy Denim Waist Size', '{}', '459327c81af3480d96a10e46040b4e03', '2023-05-26 16:07:02.30046', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-193e-6ac1-6d89ca832824', 'BR - Men''s Knit Underwear', '{}', '5b3a007b13b047aa9abd3fca3ea265aa', '2023-05-26 16:07:02.299865', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-1b4d-8e44-87fdaa3ef371', 'BR - Men''s Pants Alpha Sizing', '{}', '32fca4ec8f5a4eeda09567c1f6099c1a', '2023-05-26 16:07:02.299969', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-1f05-6e1a-6ef126bc11ef', 'BR - Men''s Neck & Sleeve Woven Shirts', '{}', '36c3f1af0a314102800c2c3bf6f7e829', '2023-05-26 16:07:02.299155', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-2c9c-9477-25e744ba0add', 'BR - Intimates / Accessories (single sizing)', '{}', '4cba6748939f4536b775f88e59bf62f0', '2023-05-26 16:07:02.298862', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-2ff1-216f-b0725cfa76a9', 'BR - Missy On-line Denim Waist Size (Regular)', '{}', '4bd28f96a441482cb92678b19d36f424', '2023-05-26 16:07:02.299003', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-338c-bf8c-7bc669aeda12', 'BR - Men''s Habedashery Shirts', '{}', 'cfcec0da13a94fc0847bc08ece1edecb', '2023-05-26 16:07:02.300076', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-3f57-4aaf-878b7757289c', 'BR - Missy On-line Bottoms / Pants (Short)', '{}', '69dce49765a84466b9ef3c1d7960be59', '2023-05-26 16:07:02.300697', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-46db-3bf2-ba70d7cb3504', 'BR - Intimates / Accessories (dual sizing)', '{}', '5155acbbb529453fae0a350702aabb22', '2023-05-26 16:07:02.300404', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-498b-b540-4cf0c5645621', 'BR - Missy Dresses / Skirts / Tops / Sweaters Numeric Sizing', '{}', '325e318e8fd7410cb3e86336e3c65aa7', '2023-05-26 16:07:02.300876', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-4dc9-67a5-d26d091434a7', 'BR - Missy Woven On-line Bottoms (Long)', '{}', 'e0875a227ec24ec8a2bc0992be964e10', '2023-05-26 16:07:02.300639', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-536b-5c9a-05543313dcd5', 'BR - Men''s Everyday Pants / Suiting Pants (WxL)', '{}', 'b53afa094c0b450090fbac506aa83e37', '2023-05-26 16:07:02.298662', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-5a5b-3130-2a50435f2f9b', 'BR - Missy Belts (Alpha)', '{}', '2b816d22239c45ab819257456f7cb7b7', '2023-05-26 16:07:02.300293', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-5de1-23ea-2703706e8b87', 'BR - WOMEN''S SHOES', '{}', '356129e317b74eb6b3de3074e03d3a2e', '2023-05-26 16:07:02.300183', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-6216-16f2-8cc66401fe5c', 'BR - Men''s Belts (Alpha)', '{}', 'c44d33361b4d416b92bc1cb2c340ef71', '2023-05-26 16:07:02.299709', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-827b-b8d9-8d2cdd074278', 'BR - Missy Blazers & Outerwear Numeric Sizing', '{}', '9a7164c039f548d2bba1ae572b4ab472', '2023-05-26 16:07:02.300757', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-85c5-827a-72199b760ac3', 'BR - Men''s Blazers / Suting Jackets', '{}', 'c3a70e250c7149b79b071b7c61021260', '2023-05-26 16:07:02.299514', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-8881-e6f3-4aa15c54886d', 'BR - Missy Blazers & Outerwear Alpha Sizing', '{}', '662327136e064be891f45545271fe1e9', '2023-05-26 16:07:02.299244', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-8950-6343-ab79e014d476', 'BR - Missy Numeric Bottoms / Pants', '{}', 'bf291724afcc45c39ea9416f87b65579', '2023-05-26 16:07:02.300939', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-9530-e50e-789be12c105e', 'BR - Missy Dresses / Skirts / Tops / Sweaters Alpha Sizing', '{}', 'ef1114eb331f450396ecf4483a3a8d51', '2023-05-26 16:07:02.300817', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-97c2-34bc-2db53d9aa2b9', 'BR - Men''s Habedashery Shirts - Online only', '{}', 'b7b09fc4e5eb4889b16a06a1c30f7039', '2023-05-26 16:07:02.300129', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-9a57-4571-973353a7361e', 'BR - Men''s Tops / Knits / Sweaters - Alpha Sizing', '{}', 'e146cd1f41814355a626e6c854361e6f', '2023-05-26 16:07:02.299918', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-9db6-8331-bd9c518a130a', 'BR - M''s Swim Trunks', '{}', '477b4bf8e8af4f64ba1f5b8d2ae84ff3', '2023-05-26 16:07:02.299637', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-a8bf-0ad9-e8a516d1313b', 'BR - Missy On-line Denim Waist Size (Long)', '{}', '97c8a45894e74513a351157566c9782c', '2023-05-26 16:07:02.299049', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-b232-ae71-560409bb0007', 'BR - Petite Bottoms / Pants / Tops / Sweaters / Blazers / Outewear / Dresses / Skirts Numeric Sizing', '{}', '77a293d30f4f4e5faaa6ca862c566505', '2023-05-26 16:07:02.300517', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-b835-e2ca-66431d986e5a', 'BR - Petite Denim Waist Size', '{}', 'a3a782d884f34bd98391a87232f07a8c', '2023-05-26 16:07:02.298953', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-b886-dcf6-3ae3501d411f', 'BR - Men''s Outerwear', '{}', 'eedec38bd8314acfa5ad820d64d8e600', '2023-05-26 16:07:02.299586', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-cccc-9a18-a042b5e48791', 'BR - Missy On-line Denim Waist Size (Short)', '{}', '5591b4e6afe043228be98c270db123cd', '2023-05-26 16:07:02.299095', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-d24f-979e-579ab9807569', 'BR - Petite Bottoms / Pants / Tops / Sweaters / Blazers / Outewear / Dresses / Skirts (Alpha Sizing-- no "P")', '{}', 'b8728a5c74a04c808bce324ae1b57eba', '2023-05-26 16:07:02.300581', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-d41c-ec22-3d90362e3d54', 'BR - Men''s Shoes', '{}', '8c5582340a204967a3a2924109c72e14', '2023-05-26 16:07:02.299292', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'Men''s Belts (Numeric)', '{}', '95b133c34d644592899e7df4917eab8a', '2023-05-26 16:07:02.299761', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-dbb9-2634-752c44d49ff5', 'BR - Men''s Accessories (For, But Not Limited To, Wallet, Gloves only)', '{}', '79192394c7fb4582a47b7631e7e70a58', '2023-05-26 16:07:02.299416', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-e065-e455-0504070c93b4', 'BR - Men''s Shorts & Board Shorts (Waist)', '{}', '68144823bc2f41028a6fbad2a973dcc3', '2023-05-26 16:07:02.299465', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b6945-a19a-f2ee-d216-9db93eab6e95', 'BR - Missy Intimates / Accessories (Handbag, Wallet only)', '{}', '1d79c378ec1a437aadbf266a8c3b5c89', '2023-05-26 16:07:02.300238', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-03b4-279a-a1e2ada2bcb1', 'BRFS - Missy Accessories (single sizing)', '{}', '4976535fb41b424aa6adac81ecd02663', '2023-05-26 16:15:23.21039', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-05d0-d54a-7db7fc5e6845', 'BRFS - Men''s Belts (Numeric)', '{}', 'e72584195a44433584d853791c809db9', '2023-05-26 16:15:23.211038', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-1061-18a9-9453ea99977c', 'BRFS - Men''s Habedashery Shirts', '{}', 'a517de664fc8463a9e5b1c62fe95b61f', '2023-05-26 16:15:23.210937', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-16fd-fbb4-06d8dbffb232', 'BRFS - Men''s Belts (Alpha)', '{}', 'b116068d04b84e8d891959753eb54a85', '2023-05-26 16:15:23.21109', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-200b-e8ee-33e658ec52c8', 'BRFS - Missy Dresses / Skirts / Tops / Sweaters Alpha Sizing', '{}', '780b175d2b544664876bbc25f57a58b2', '2023-05-26 16:15:23.209611', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-25c6-210b-191bf4142084', 'BRFS - Women''s Numeric Tops & Bottoms (Ankle)', '{}', 'ced34486d4b44de49b0c8be87c0014b9', '2023-05-26 16:15:23.210599', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-263d-5062-3efd70507bee', 'BRFS - Women''s Numeric Dual Size Denim (Long)', '{}', 'df7e865ce7f24183afdfcc337678466c', '2023-05-26 16:15:23.210838', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-31f9-d6dd-581e65d4a2a4', 'BRFS - Women''s Numeric Tops & Bottoms (Petite)', '{}', '98c1bad217864450ad166e6dafe9c75e', '2023-05-26 16:15:23.210015', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'Men''s Habedashery Shirts - TALL (Online Only)', '{}', 'de4613da8e8c4712bbc74dfd47598f27', '2023-05-26 16:15:23.209972', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-3f22-109f-5127025b58be', 'Men''s / Alpha Sizing: Top* & Bottoms', '{}', 'cb3c3d7c5d1142caabe0f55c38ae18a7', '2023-05-26 16:15:23.209889', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-4ad5-4c23-3ddfadcdf585', 'BRFS - Women''s Numeric Dual Size Denim (Petite)', '{}', '44afae54d6214b36903fc5835e33f02e', '2023-05-26 16:15:23.210694', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-4b2a-60e1-285cf2fde5e3', 'BRFS - Women''s Numeric Tops & Bottoms (Long)', '{}', 'bb6503a46a2f4538ac2dbf3f2700c658', '2023-05-26 16:15:23.210551', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-510c-dc8d-2d986115b823', 'BRFS - Women''s Hats', '{}', 'd0c8bde7bc56439d8c021eae940c1643', '2023-05-26 16:15:23.210283', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-5578-f3e4-ba89b58a543d', 'BRFS - Missy Blazers & Outerwear Alpha Sizing', '{}', '85d985fc5ac1483886babdf92987bb58', '2023-05-26 16:15:23.211362', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-5a68-ecf3-5a631d52a511', 'BRFS - Women''s Gloves', '{}', '6fb18977bf2e4ca49c154844c44da9b3', '2023-05-26 16:15:23.210341', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-6ad3-2267-cb7fb1e966ec', 'BRFS - Women''s Numeric Dual Size Denim', '{}', '19f2596dda214d7a9aecaf46285ad883', '2023-05-26 16:15:23.210789', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-6c77-6643-1b3b4f3eb145', 'BRFS - Women''s Numeric Tops & Bottoms (Short)', '{}', '2389cfaa758340ac959b3c2fccca40c4', '2023-05-26 16:15:23.210436', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-7e52-8f72-8eef31f8bcff', 'BRFS - Men''s Alpha Sizing: Tops & Bottoms', '{}', 'f605b56d68e64cceb67bf52a2f2c1ff2', '2023-05-26 16:15:23.211142', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-8308-83ba-e1a10abc997b', 'BRFS - Women''s Numeric Tops & Bottoms', '{}', '2444b4f113034724bc40a95643fdb238', '2023-05-26 16:15:23.210646', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-860b-30fb-c718078ae45e', 'BRFS - Women''s Numeric Tops & Bottoms (Regular)', '{}', '6aea010bfbca4cd39ddf992a60ca97d2', '2023-05-26 16:15:23.210504', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-98f4-de2a-f0ef84398c58', 'BRFS - Men''s Numeric Sizing: Suit, Blazer & Shorts', '{}', 'eadcc399b47047b5863a83e051fad6c4', '2023-05-26 16:15:23.210887', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-9e3d-b58e-ae9a42277679', 'BRFS - Missy Belts (Dual Alpha)', '{}', 'a9e56e94422d4c0a93916caa818ff0be', '2023-05-26 16:15:23.211247', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'Men''s SHOES', '{}', '81280eef7ef44103a60d01551d3647a7', '2023-05-26 16:15:23.209766', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-a314-0cc5-39a26350bd22', 'BRFS - Missy Belts (Alpha)', '{}', '48a5c34026b644f890d56c73441688c8', '2023-05-26 16:15:23.211194', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-a382-d703-fae3ac174bee', 'BRFS - Men''s Blazer Suting Jackets', '{}', 'ad314578953146a191b516a25f7adffb', '2023-05-26 16:15:23.210987', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-a6fe-fcc2-b1b671ce72b0', 'BRFS - Missy Dresses / Skirts / Tops / Sweaters Numeric Sizing', '{}', 'ae2dd46661a045d3b8cfede816a9e170', '2023-05-26 16:15:23.211471', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-b3da-f1b4-b2da353704a4', 'BRFS - Men''s Gloves', '{}', '888580e78eee4757ba1de27e3b533737', '2023-05-26 16:15:23.209845', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-ca0f-6f01-042ef4b35fa5', 'BRFS - Men''s Accessories (Neckties, Scarves)', '{}', 'a9352efe5bb54228a31c8a1ad926440f', '2023-05-26 16:15:23.210122', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'Men''s Habedashery Shirts - Online only (Alpha sizing)', '{}', 'bccf08a8ccb741f0b1367d43a5d93abb', '2023-05-26 16:15:23.209931', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-d6d1-a187-da1614d64921', 'BRFS - Women''s Numeric Dual Size Denim (Regular)', '{}', '0a04fb293a894c37bbd2b2860d4eee78', '2023-05-26 16:15:23.210741', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-dd2b-c040-848239c94854', 'BRFS - Missy Blazers & Outerwear Numeric Sizing', '{}', '9cf40b182c0f45c7ba124511fd2ddfeb', '2023-05-26 16:15:23.211416', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-ea16-2ed7-f2275ee777e9', 'BRFS - Women''s Alpha Sizing: Tops & Bottoms', '{}', 'd1b16e5192b74938abeebc3218830585', '2023-05-26 16:15:23.2113', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-ee6b-75d8-001747155ee4', 'BRFS - Women''s Petite Alpha Sizing: Tops & Bottoms', '{}', 'becd54cdbb3c478eaf2088dd0aee37d4', '2023-05-26 16:15:23.21008', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-f3d1-9083-ce13f141eda1', 'BRFS - Men''s Everyday Pant Suiting / Pant Denim (WxL)', '{}', 'd397e51de6d04e8f89a12a91ba87135b', '2023-05-26 16:15:23.210239', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0b694d-4649-fb37-1609-13323fc9ce91', 'BRFS - Men''s Hats', '{}', 'f56c99be77bd419583ef9a5eee609a3f', '2023-05-26 16:15:23.210171', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c0815-6e66-b6c8-3e48-5a194b50c7cd', 'Test1', '{}', '6710f4a773e344a78ffc74c6ce136ca9', '2023-06-26 12:14:00.8099', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:14:40.528367', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:14:40.523559'),('3a0c0825-ea9b-1bc2-fa46-5f5b4c0e01e3', 'Test', '{}', '2a55d8ade8984f7b8a7e22ff178e1dcb', '2023-06-26 12:32:01.179475', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:32:30.055892', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:32:30.055256'),('3a0c0826-8e1b-f736-9781-ffa33b7da7b3', 'Test', '{}', '5c1e6a5d171f4ec9baaa7619d0579eff', '2023-06-26 12:32:43.035478', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:33:05.780206', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 12:33:05.779673'),('3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'Womens', '{}', '1389a6ee49714d39b58bec5d2b3ef295', '2023-05-26 14:01:58.948456', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', '2023-06-26 15:22:54.257952', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', 'f', NULL, NULL),('3a0c0827-45db-9ac9-27d7-96d6922fc7b8', 'Test', '{}', '2b6cf39676794a6b989cc14b45147e97', '2023-06-26 12:33:30.075711', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:42.136887', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:42.131381'),('3a0c08da-c6eb-95c0-e7ce-f8e45bb61e13', 'Test', '{}', 'aafa0d21f6574583840051ef1ba962e9', '2023-06-26 15:49:34.063073', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:54.601628', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:54.600884'),('3a0c0826-01c3-bae5-37c3-0f8882dd9d57', 'Test', '{}', '1cae4164d845428fb6f92eec07e8afce', '2023-06-26 12:32:07.107406', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:56.90178', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', 't', '3a0bc62c-a428-de09-fe55-1a4bfe5fe7a8', '2023-06-26 15:49:56.901235'),('3a0b6926-0ca4-78b8-5c26-de9e6dee1d7f', 'Womens 1', '{}', '47d69ce1b473431ba22694388f81acd7', '2023-05-26 15:32:32.549987', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', '2023-06-30 14:58:47.73891', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', 'f', NULL, NULL),('3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'TODDLER BOY & GIRL GLOVES & MITTENS - DUAL ALPHA SIZING', '{}', '374990828f6f469f92511b8a5f738fe7', '2023-07-17 14:48:15.659042', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-0a85-a337-a156f5d60f44', 'Missy Woven On-line Bottoms (Long)', '{}', '090c68cca56c4a679a5702929b72778d', '2023-07-17 14:48:15.655612', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'Pillows & Throws', '{}', 'ef38141e21da49e2afc5d920459cf4ee', '2023-07-17 14:48:15.657364', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-0df0-ca33-6fa4848dbade', 'TODDLER BOY & GIRLS SOCKS - DUAL ALPHA SIZING - WITHOUT SPANDEX', '{}', '43eeaead641a4670a84e0a84c0bcffeb', '2023-07-17 14:48:15.658897', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-1058-f861-61c1307ef900', 'Men''s Tops / Knits / Sweaters ~ Alpha Sizing', '{}', '076963ad1f25437d9849199487695364', '2023-07-17 14:48:15.656574', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-11c9-c08f-c3edc02cde24', 'Missy  On-line Denim Waist Size (Long)', '{}', 'ebcc77d468f04a4cae67ff0abfb6a39d', '2023-07-17 14:48:15.65595', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'Missy Blazers & Outerwear Numeric Sizing', '{}', '5bbed5d3e9ce45d89f95d67a8bd37053', '2023-07-17 14:48:15.65545', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-294e-b136-9c9270278a10', 'Men''s Neck & Sleeve Woven Shirts', '{}', '009679faad9a40778d20af5fe9205782', '2023-07-17 14:48:15.656319', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-2d58-420d-35c2b7f44188', 'Men''s Everyday Pants / Suiting Pants (Waist and Alpha Length Sizing)', '{}', 'c85c2e64e7a846f0ac946241df6367ed', '2023-07-17 14:48:15.65647', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-3126-d192-f842917e1e27', 'Petite Denim Waist Size', '{}', '2b2ee60651f049bcbd607651d7915920', '2023-07-17 14:48:15.655814', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-3896-7659-36de4c2659a7', 'TODDLER BOY & GIRL TOPS, ONE PIECE & SLEEPWEAR - NUMERIC SIZING', '{}', '83114b260767440d94b3ddd2c8ffa1d7', '2023-07-17 14:48:15.658521', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-38e9-c516-81a50eb39d13', 'M''s Swim Trunks', '{}', '1ef88cfc5a0c4d1f8801d8ed9bff5d37', '2023-07-17 14:48:15.656833', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'Men''s Shorts,  Board shorts & Pants with single size (waist)', '{}', 'aef939bd6c744eb398df7419d39357bc', '2023-07-17 14:48:15.657006', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-4534-7e51-de95ab641dc6', 'WOVEN HATS', '{}', '9de729fea23b424fb4cca624263bb28d', '2023-07-17 14:48:15.658185', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-5119-2c68-4a208711d430', 'Men''s Woven Boxers', '{}', 'ac9431bec28b4791be83e64c1cd37048', '2023-07-17 14:48:15.656679', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'TODDLER SHOES AND FLIP FLOPS (D) REG WIDTH', '{}', '156b413278cd4a8d8def8242ba8fe647', '2023-07-17 14:48:15.659413', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'Men''s Outerwear', '{}', '43c72b0dc05c4ff39fc1732d793c30cd', '2023-07-17 14:48:15.656892', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'INFANT GLOVES & MITTENS - NUMERIC SIZING', '{}', '4d7d92db923f46e1949a0b34fff856ea', '2023-07-17 14:48:15.657792', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-6209-fa67-ce299a8617ba', 'Missy Dresses / Skirts / Tops / Sweaters Alpha Sizing', '{}', '4d97cf1fafbb4d0ba4bce3f0239c9097', '2023-07-17 14:48:15.655403', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'Missy Intimates / Accessories', '{}', '33245afb6d3344d9ac6c183af2ff22fc', '2023-07-17 14:48:15.656171', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-6620-9086-22c0270c80bc', 'TODDLER BOY & GIRL SCARVES', '{}', '38227c6c4210448aa6a3a62dab1ce7b1', '2023-07-17 14:48:15.65934', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-6683-f003-ec05899cd254', 'Missy On-line Denim Waist Size (Short)', '{}', 'ee6cf3a3c5614041a312002612dbe03a', '2023-07-17 14:48:15.655859', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'Missy On-line Bottoms / Pants (Short)', '{}', '8c135df82da44b7a8d66afe579f933c5', '2023-07-17 14:48:15.655542', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'Men''s Knit Underwear', '{}', 'ca3af89cf37048df8d5311fe3aa0d5c9', '2023-07-17 14:48:15.656625', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-72ad-5483-0d7d357dff38', 'BABY LEG WARMERS', '{}', 'ce00dc4c328545a6adf9b27d5cadfc23', '2023-07-17 14:48:15.658112', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-7321-1a24-0670356a45c5', 'Men''s Accessories', '{}', 'e0734fc4f75042e5adde97d18df7c173', '2023-07-17 14:48:15.657063', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-78e0-56d4-fb41656408d0', 'NEWBORN - INFANT - TODDLER WOVEN HATS - NUMERIC SIZING', '{}', '58be911d5a5c4a43a0883d8d1d413c8f', '2023-07-17 14:48:15.657919', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-7e09-0459-326b6b1dd706', 'Petite Bottoms / Pants / Tops / Sweaters / Blazers / Outewear / Dresses / Skirts Numeric Sizing', '{}', 'a254643b81a141b2b4872914aee60e00', '2023-07-17 14:48:15.655701', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-812c-790f-7d8eb578f719', 'Men''s Pants Alpha Sizing', '{}', '57947ee2ac2240eba2b1d6d7cf85773b', '2023-07-17 14:48:15.656521', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-8260-30c7-bcd31c94e7f1', 'BABY TOWELL & TOWELL MITTS', '{}', 'a36f76bf2b894bb398b93ecb48767ca2', '2023-07-17 14:48:15.658318', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-83c3-21c0-8fa3d54622e3', 'NEWBORN/INFANT SOCKS - WITHOUT SPANDEX', '{}', '8169c1a891b04fc68880ff44961fc548', '2023-07-17 14:48:15.657669', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-8406-e648-f4efcd581d1f', 'TODDLER BOY & GIRL UNDERWEAR - DUAL NUMERIC SIZING', '{}', '4a56d183b614416e9efd90a01c49e0ab', '2023-07-17 14:48:15.658658', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'NEWBORN/INFANT SOCKS - WITH SPANDEX', '{}', 'bb4bc190d7454a77991fb50397c8d1d8', '2023-07-17 14:48:15.657607', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'Missy On-line Denim Waist Size (Regular)', '{}', '60e825001ea94c4e85b2c636af4ca47d', '2023-07-17 14:48:15.655904', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-8bac-8990-02a7108a446f', 'TODDLER WOVEN HATS - NUMERIC SIZING', '{}', 'ba9666ded3e84946afeb16eb2dc2b967', '2023-07-17 14:48:15.659267', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-9187-3993-eec83afd5079', 'Missy Numeric Bottoms / Pants', '{}', 'bdc2a3f712084a01b15aaa3236c95b9f', '2023-07-17 14:48:15.655067', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'INFANT - TODDLER KNIT HATS - Numeric Sizing', '{}', 'cb0d351408f84aa4a09e085c4dffdebf', '2023-07-17 14:48:15.658385', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'Men''s Woven Hats', '{}', 'fd3e41721c214bae9ec0f7dae692ec5f', '2023-07-17 14:48:15.657119', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-9623-3863-60e0355d6341', 'Missy Blazers & Outerwear Alpha Sizing', '{}', '2e32f4d85501405c9237faea1e81d299', '2023-07-17 14:48:15.655498', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-96e6-3365-d2d141f2cc36', 'NEWBORN SHOES (D) REG WIDTH', '{}', 'acfc04ccf83249e197bd81fee1230b17', '2023-07-17 14:48:15.658252', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'TODDLER GIRL TIGHTS - NUMERIC SIZING', '{}', '396b22fc9d58483e89e3b366e2210782', '2023-07-17 14:48:15.658727', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-a470-563a-6e1450651ed3', 'INFANT HAT/MITTEN SET - NUMERIC SIZING', '{}', '24b4337f1b194fd7851a3ea3ee5d2eb9', '2023-07-17 14:48:15.658047', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-a857-7dde-6c178b17ea37', 'Missy Belts (Alpha)', '{}', '54fd3d39af584b3085fec6416c544b74', '2023-07-17 14:48:15.656117', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-aa48-fbc4-1ea0f3f8443e', 'TALL SIZES', '{}', 'a249dad004974679a0cf6975a0bd29e9', '2023-07-17 14:48:15.655268', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'NEWBORN WOVEN GLOVES/MITTENS - NUMERIC SIZING', '{}', '3e51180bad7b4605b9a6d8e0a6eda396', '2023-07-17 14:48:15.65773', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'WOMEN''S SHOES', '{}', '6ea3877945794150b41f019c8433c7ba', '2023-07-17 14:48:15.657184', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-b099-d4c3-c664a4da2766', 'NEWBORN KNIT GLOVES/MITTENS - NUMERIC SIZING', '{}', '8efd393341244474adbc18317d783677', '2023-07-17 14:48:15.657856', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'Missy Denim Waist Size', '{}', '53646cab6cf84d2faed4063746d260c9', '2023-07-17 14:48:15.655768', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-ba8b-511a-d553a9608347', 'BABY BLANKETS', '{}', 'b104b206e5be4ebbae77a25085fcbc46', '2023-07-17 14:48:15.657983', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-ba93-17e3-00f06407e583', 'TODDLER BOY & GIRLS SOCKS - WITHOUT SPANDEX', '{}', '013e5d0e2ae04c5f90a1b7a5888a0530', '2023-07-17 14:48:15.658969', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'NEWBORN/INFANT BOTTOMS - DENIM, WOVEN, KNIT - NUMERIC SIZING', '{}', '2fbf7e291c3a44cca81ac2db93aa99b5', '2023-07-17 14:48:15.657426', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-be46-c9cb-405f42fc6977', 'TODDLER BOY & GIRL KNIT HATS AND HEADBANDS', '{}', 'd6e010b95a4f4c8c89e6ad65a1621583', '2023-07-17 14:48:15.659194', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-bf97-a6bc-52d444c90887', 'INFANT OUTERWEAR & SWIMWEAR KNITS & WOVEN', '{}', '2f15ecc702c64a4683838863aa9d4848', '2023-07-17 14:48:15.657545', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-c096-c719-d4a93239e342', 'Missy Dresses / Skirts / Tops / Sweaters Numeric Sizing', '{}', 'fa563995215b497ab86499b6bbdf0f86', '2023-07-17 14:48:15.655358', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'TODDLER BOY & GIRL TOPS - DUAL ALPHA SIZING', '{}', '48b4d66f79f54140a68a4d2e42696202', '2023-07-17 14:48:15.65859', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-cf24-8093-38ecac76f375', 'TODDLER BOY & GIRL BOTTOMS - DENIM, WOVEN, KNIT, SLEEP BOTTOMS - NUMERIC SIZING', '{}', '7ec901294377444a9557922ea67d44a5', '2023-07-17 14:48:15.658453', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'Men''s Vests', '{}', '6ce9bc0e24994fb18c4dc00775a11d17', '2023-07-17 14:48:15.656368', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-d68b-3231-c25588a50a7c', 'NEWBORN/INFANT TOPS, ONE PIECE & SLEEPWEAR - NUMERIC SIZING', '{}', 'ad9d08b8fa014ff4a340f08e3a09ed4f', '2023-07-17 14:48:15.657485', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'Men''s Blazers / Suting Jackets', '{}', '0a896db01e504eb8a3ffe3ba70793780', '2023-07-17 14:48:15.656949', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'Men''s Belts (Alpha Numeric)', '{}', '4f97d312a8aa4f14a03fc4dc59035db7', '2023-07-17 14:48:15.656733', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-dd11-88f6-7d8ab84d3811', 'Dog Accessories  - collars and tops', '{}', 'b4a2cc312b6b4f128dcd01f08c9d7274', '2023-07-17 14:48:15.657304', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-de5a-9612-43ec872471ad', 'TODDLER BOY & GIRLS SOCKS - WITH SPANDEX', '{}', '5a00cd5e92724980a5ec2c24ebb6cd48', '2023-07-17 14:48:15.658796', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'MEN''S SHOES', '{}', 'e627fabe02e84083a97775e3bfe02bcf', '2023-07-17 14:48:15.657245', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'TODDLER BOY & GIRL WOVEN HATS - DUAL ALPHA SIZING', '{}', '1696ec8e43e4432897617ccc3b209f18', '2023-07-17 14:48:15.659114', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'Petite Bottoms / Pants / Tops / Sweaters / Blazers / Outewear / Dresses / Skirts (Alpha Sizing-- no "P")', '{}', '057fca7862a549828343a87b0ede9073', '2023-07-17 14:48:15.655656', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-f6e4-a677-be3223b85d18', 'Intimates / Accessories', '{}', '9ed4ea3e9f2e406ebc8cb736727f3a53', '2023-07-17 14:48:15.65602', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-fa5d-49e8-70aab4d0a6d0', 'Men''s Habedashery Shirts - Online only', '{}', '37c518e7c6f94635a8e5ade3894d29e7', '2023-07-17 14:48:15.656221', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-fcdb-35df-c4e65e2362a3', 'MISSY / PETITE / TALL Tights', '{}', 'e44b833c7a664daa992b15e692a67729', '2023-07-17 14:48:15.656068', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'Men''s Habedashery Shirts', '{}', 'eae86c171a5c4a929649b26fac5edf05', '2023-07-17 14:48:15.65627', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'Men''s Everyday Pants / Suiting Pants (WxL)', '{}', 'a8b3addd0bf341c29f04cd946bd07285', '2023-07-17 14:48:15.65642', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-120e-f174-83eed1baee83', 'Unisex - Accessories: hats/outerwear (0-6 months to 6-12 months)', '{}', '065c0ec3e2ac432b85b18173798f9642', '2024-01-11 10:31:42.491019', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-29c6-ce4e-984a2cb974fa', 'Men''s Tops / Knits / Sweaters - Alpha Sizing', '{}', '905d0113bc7d4ea3be79f08c27916326', '2024-01-11 10:31:42.491244', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-65ec-cfe3-3a0689e94ccc', 'Unisex -knits - ONLINE ONLY (zip playsuits) (Up to 7 lbs to 9 months)', '{}', 'a5a51df19a644ffa9e48ded69ace2967', '2024-01-11 10:31:42.491106', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'Unisex - wovens/sweaters/knits (bodysuits/pants) shoes (sandals) (0 months to 24 months)', '{}', '7961920e9a2d4b91a1b0353583366a04', '2024-01-11 10:31:42.470728', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-6d00-e662-f9075c9c03fa', 'Petite Bottoms / Pants / Tops / Sweaters / Blazers / Outewear / Dresses / Skirts (Alpha Sizing-- No "P")', '{}', '48992c562a184c0e8f72376c26a9757c', '2024-01-11 10:31:42.491375', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-9f75-e96c-9e5ce76c95ce', 'Missy On-line Denim Waist Size (Long)', '{}', 'c62fe96599e94dab8342549abaa4da3a', '2024-01-11 10:31:42.491331', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-a657-ef1b-7244c71678eb', 'Unisex - Accessories:  playmat/blankets/gift boxes', '{}', '305e4ead1fad454bbed75e5bfa158d98', '2024-01-11 10:31:42.491201', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-bf2d-8d60-97bbac1690ea', 'Unisex - Accessories: booties/footwear (0 months to 12 months)', '{}', '7267bc6b160f4815979c7f90ea9544d8', '2024-01-11 10:31:42.488239', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-d450-f5c4-b21605a5f7ab', 'Unisex - Accessories: beanie/zip playsuits (0 months to 9 months)', '{}', '7d4568f72f2444a994708564ff8d963d', '2024-01-11 10:31:42.491063', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-e11c-301d-4e7abc8cbfea', 'Unisex - Accessories: hats/outerwear (0-12 months to 12-24 months)', '{}', '09a3148b5be74d22994f584aa3c9c988', '2024-01-11 10:31:42.490942', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-faed-5a98-49473fd9de44', 'Unisex -knits - ONLINE ONLY (bodysuits/pants) (Up to 7 lbs to 24 months)', '{}', '81c30a7faea142f3b41020ccffde42a3', '2024-01-11 10:31:42.491148', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a100889-485f-fc29-7006-25cb2a5966f6', 'Dog Accessories - collars and tops', '{}', 'e5f69c15fdd7428abe487141582b83ca', '2024-01-11 10:31:42.491288', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-1592-bbdc-475d7e7d56a9', 'Toddler > Robes > Alpha Size', '{}', '98876dfa4bb1484f8ddac916c63780a9', '2024-01-30 09:52:59.492276', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-457d-6d07-4b1a19f3d72b', 'ACCESSORIES- Duster/ Sarong > Dual Alpha Size', '{}', 'c8eee1c46033469cbcbe3886a98dceea', '2024-01-30 09:52:59.492488', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-4e87-4d59-f5cb64a7ca0b', 'ACCESSORIES-Leather & Fake Leather Gloves > One Size', '{}', '33212d96dde742b49332ecc21c4ed903', '2024-01-30 09:52:59.491965', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-54d8-959b-7a0395f0cb84', 'ACCESSORIES- Non-Leather Gloves > One Size', '{}', 'ea7bf098719f416ca931dd7153413c31', '2024-01-30 09:52:59.492748', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-5b44-e938-a3c489e62f62', 'ACCESSORIES- Hats (except knit + adjustable caps)', '{}', 'fbb4be2cbb91489e9012bd95b9cc28f0', '2024-01-30 09:52:59.491728', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-5cef-6463-8b67386d0802', 'ACCESSORIES- Active Socks > Dual Alpha Size', '{}', '6f5f38d6d7f64706bb986c99d05fe6e8', '2024-01-30 09:52:59.492341', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-5e96-a141-900f95a616df', 'ACCESSORIES- NewBorn', '{}', '3a3a0fe62af1400d97ba446babce8ef6', '2024-01-30 09:52:59.490746', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-6a19-38f8-1a37cf0c40ff', 'ACCESSORIES-Non-Leather Gloves > One Size', '{}', '94736e35473646fbbe785ec99f4ea480', '2024-01-30 09:52:59.492024', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'ACCESSORIES- Belts', '{}', '4398278c45f849838280c510b0bbf8f6', '2024-01-30 09:52:59.491144', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'NewBorn', '{}', '5b68b258cc5d4e7397c45f985eb4dbcf', '2024-01-30 09:52:59.491034', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-8cd6-cd0c-a8d7866c28bf', 'ACCESSORIES- Active Socks > Dual Numeric Size', '{}', 'd1202fdf32074227ac2507f40e24f5c9', '2024-01-30 09:52:59.492404', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-9394-6e1e-c67cd721e736', 'ACCESSORIES- Socks', '{}', 'fd3fbd49876240279e56293bb7005a28', '2024-01-30 09:52:59.491347', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-9743-d440-2b15e78e046b', 'ACCESSORIES- Tights', '{}', '00f9c1ea16a64a7eb048c189d47e857a', '2024-01-30 09:52:59.491397', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-a57d-b650-4f26ecffc811', 'ACCESSORIES-Gloves & Mittens > Alpha Size', '{}', '983a06924cd949d68651c2446822522b', '2024-01-30 09:52:59.491447', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-a9e0-c5bf-9be9c8037172', 'ACCESSORIES- Leather & Fake Leather Gloves > Dual Alpha Size', '{}', 'ab964de8fe3243cb975f82c48dfc6a4a', '2024-01-30 09:52:59.491847', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-b2ad-212c-21d3979d940b', 'ACCESSORIES-Gloves & Mittens > Dual Alpha Size', '{}', 'cecedaeed29f4ca4a6fb2cf2a8c99ae6', '2024-01-30 09:52:59.491506', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-b404-5ce0-c85cc3b25989', 'ACCESSORIES- Adjustable Hats and Caps', '{}', '17df29d9ac814e1fafb816a4c703a95d', '2024-01-30 09:52:59.491093', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'ACCESSORIES- Gloves & Mittens', '{}', '6882f0de9af3441abcc3fa9b87382d5c', '2024-01-30 09:52:59.491191', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-c903-74cb-ec08fed5be7c', 'ACCESSORIES- Hats and Caps', '{}', '6ffe4af91c4149d3b82c2e9dc4386feb', '2024-01-30 09:52:59.491243', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-ccce-3509-cda52df613f7', 'ACCESSORIES- Leather & Fake Leather Gloves > One Size', '{}', '4ef3b9f879df4a2ca09056e61e4392b5', '2024-01-30 09:52:59.492681', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-d73a-003a-ed15d2119ffd', 'Toddler > Leg Warmer', '{}', '68e3ed429c2b427eb6f1e42f840614a5', '2024-01-30 09:52:59.49217', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'ACCESSORIES- Toddler', '{}', 'b21501c74795454d93a32dee03350f23', '2024-01-30 09:52:59.49094', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-e115-fdbd-d29a32c010a6', 'ACCESSORIES- Non-Leather Gloves > Dual Alpha Size', '{}', '40a9b1580a3441658b8e866ea56d86b7', '2024-01-30 09:52:59.491905', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-e3fd-54b5-12977ee75b89', 'ACCESSORIES-Gloves & Mittens > One Size', '{}', '4025fec6dd404a2198485ee08b0cf004', '2024-01-30 09:52:59.491561', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-e413-e823-ad5042a060ad', 'ACCESSORIES- Knit Hats and Caps', '{}', '23afb1c5321a486d94e7c4731e1cfa29', '2024-01-30 09:52:59.491296', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-eee2-86bd-56a01f5666ee', 'ACCESSORIES- Knits Hats and Caps', '{}', '8c756b9046f74fe3b72dc028fab0da3b', '2024-01-30 09:52:59.49179', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-f114-8571-ec68ec3bdf3c', 'ACCESSORIES- Hats', '{}', 'ce4409d8a6be4ce4b245f119aadcde69', '2024-01-30 09:52:59.492605', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-f429-f86f-6638328ea66d', 'Adjusta Hats and Caps', '{}', '75def6c9fbfc40ee844afc29e3c66fed', '2024-01-30 09:52:59.49208', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a106a3e-aa62-f5e6-b8df-22b25d9170e2', 'ACCESSORIES- Adjustable Hats & Caps (except knit hats & caps)', '{}', 'c773f48a46b7423d993c9343cd6a7179', '2024-01-30 09:52:59.491638', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-073c-15cf-a05caab09529', 'Women''s Petite Numeric Sizing: Tops / Bottoms / Sweaters /Blazers / Outerwear / Skirts / Dresses - Tall Call-out', '{}', 'b4683e9f9a9f4b48b1c4e011498e772f', '2024-02-02 10:28:59.43187', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'Men''s Habedashery Shirts - TALL (Online Only) (Alpha sizing)', '{}', 'e738677d52784184bc4b7a393bc3e1da', '2024-02-02 10:28:59.431802', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'Men''s Belts (Alpha)', '{}', '02d8f8baad8c4a5fb280557a51d013f7', '2024-02-02 10:28:59.430652', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'Men''s Numeric Sizing: Suit, Blazer & Shorts', '{}', 'a90e66f1ee1745529118dbde96274f6f', '2024-02-02 10:28:59.431022', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'Women''s Numeric Dual Size Denim(Petite)', '{}', 'c3deb8b2bd88424bb5f105c5fe924e7c', '2024-02-02 10:28:59.431081', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'Men''s / Alpha Sizing: Top* & Bottoms - TALL SIZES', '{}', '9ff3a0d0877b4aa4a88ef9884e1f7992', '2024-02-02 10:28:59.429725', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-2486-bbb5-f548b6741855', 'Men''s Alpha Sizing: Tops & Bottoms - TALL', '{}', 'acd83e9f41374152b2feecaef987479a', '2024-02-02 10:28:59.431603', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'Women''s Numeric Dual Size Denim (Petite)', '{}', '64542c5dbe3e43f683fe032dee26d1e5', '2024-02-02 10:28:59.430391', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'Women''s Petite Alpha Sizing: Tops & Bottoms', '{}', '2b45df28886d4028900643cf0740920e', '2024-02-02 10:28:59.430069', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'Women''s Numeric Tops & Bottoms (Long)', '{}', '9220d342b2004f41b933cc48ce14f574', '2024-02-02 10:28:59.43029', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-34bb-7876-d77e298f6e65', 'Women''s Hats', '{}', '7ea16644e067417aa02f0de3aaa0cd34', '2024-02-02 10:28:59.430888', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-435a-c901-c591d57a234f', 'Women''s Numeric Tops & Bottoms (Ankle)', '{}', 'fcbfe171d5c24d58bf426c28789b1e31', '2024-02-02 10:28:59.430023', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'Women''s Numeric Tops & Bottoms (Regular)', '{}', 'c23328b6697e4f9a8ee7ec0a5d20cfd0', '2024-02-02 10:28:59.430341', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-525d-2588-e7f15d7093a2', 'Missy Belts (Dual Alpha)', '{}', '7598d1d3b1db4ec0884245473501a177', '2024-02-02 10:28:59.430544', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-5ecd-3898-133431d438d6', 'Missy Dresses / Skirts / Tops / Sweaters Alpha Sizing - TALL SIZES', '{}', '582537f49e3f4390842d9f2dad505704', '2024-02-02 10:28:59.43141', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'Men''s / Alpha Sizing: Vest', '{}', '4b08195c1f7a41c29479a90e7748d333', '2024-02-02 10:28:59.430961', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'Women''s Numeric Dual Size Denim/Women''s Numeric Dual Size Denim (Petite)/TALL SIZES', '{}', '75d3a2e659c44736b156fb4d507bf334', '2024-02-02 10:28:59.430228', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'Women''s Petite Alpha Sizing: Tops / Bottoms / Sweaters /Blazers / Outerwear / Skirts / Dresses - Petite Call-out', '{}', 'fce863e1681d4beaa5feb31b55edb3e0', '2024-02-02 10:28:59.429799', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'Women''s Numeric Dual Size Denim - TALL SIZES', '{}', '4ab815aa89b4496197ce87be4da74691', '2024-02-02 10:28:59.43076', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'Women''s Numeric Dual Size Denim (Regular)', '{}', '502ea1c4cfdc44158e7023f21c45cc81', '2024-02-02 10:28:59.430492', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'Women''s Numeric Tops & Bottoms (Petite)', '{}', '5855e2acf2944199b983d888ab87c705', '2024-02-02 10:28:59.429847', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-87ee-0020-f6ad0d4b02e0', 'Men''s Accessories (Neckties, Scarves)', '{}', 'c1e27b5906f84b84ab6ccacc6dfc4de9', '2024-02-02 10:28:59.431734', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'Missy Blazers & Outerwear Numeric Sizing - TALL SIZES', '{}', 'be0a1523c8dd4d2184f675c6ddae3dab', '2024-02-02 10:28:59.431473', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'Women''s Numeric Dual Size Denim (Long)', '{}', '5717dd5a9b6842ecb269140c92478617', '2024-02-02 10:28:59.430441', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'Men''s Hats', '{}', 'f906d653c08e4c1dbd019c76214cd440', '2024-02-02 10:28:59.431669', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-a512-98bc-8070412bba03', 'Women''s Numeric Dual Size Denim', '{}', 'e50c0e654852443fb7d9dc37f5e627ed', '2024-02-02 10:28:59.429598', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-c337-6592-3b68eb86d962', 'Women''s Numeric Tops & Bottoms (Short)', '{}', 'aac2c3d866fb4d3c88dadef4d0cf636c', '2024-02-02 10:28:59.430116', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-c616-3965-4eefa8115c62', 'Women''s Numeric Dual Size Denim - Tall SIZES', '{}', '3870bc4cf7f6431b8bc0ff5eebcad5e0', '2024-02-02 10:28:59.431346', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-d02c-b2b6-d2120b13de33', 'Missy Accessories (single sizing)', '{}', 'cf206e9cc7ce44ba8ce41a7d5ea3a52e', '2024-02-02 10:28:59.430817', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'Women''s Alpha Sizing: Tops & Bottoms', '{}', '2dfacba37ed7412ab69abb8f181f1ae8', '2024-02-02 10:28:59.42989', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'Men''s Everyday Pant Suiting / Pant Denim (WxL)', '{}', '4d3398ec1a2b423eb9b112f170e74b6d', '2024-02-02 10:28:59.429979', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'Men''s Blazer Suting Jackets', '{}', 'c1e65e0a151743edbf8f8f298885f836', '2024-02-02 10:28:59.430706', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'Women''s Numeric Tops & Bottoms', '{}', '9a41706a007c4322a45ce9fb946a4732', '2024-02-02 10:28:59.429934', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'Missy Dresses / Skirts / Tops / Sweaters Numeric Sizing - TALL SIZES', '{}', '20e2671e085d4e10a1e414f870091d97', '2024-02-02 10:28:59.431141', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'Men''s Alpha Sizing: Tops & Bottoms', '{}', '3486ab78d7ef43cea99b2730df750275', '2024-02-02 10:28:59.4306', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'Missy Dresses / Skirts /Bottoms/Tops / Sweaters Alpha Sizing', '{}', '0b1eda3888434538ad6407052ead09f7', '2024-02-02 10:28:59.431277', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL),('3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'Missy Blazers & Outerwear Alpha Sizing - TALL SIZES', '{}', '3a4e509e501045839d9188764f6711e7', '2024-02-02 10:28:59.431538', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', NULL, NULL, 'f', NULL, NULL)
;
COMMIT;
BEGIN;
LOCK TABLE "public"."wp_size_chart" IN SHARE MODE;
DELETE FROM "public"."wp_size_chart";
INSERT INTO "public"."wp_size_chart" ("id","product_gender_id","product_type_id","brand_type","original_size","us_size","canada_size","sp_size","china_size","ru_size","uk_size","eu_size","jp_size","it_size","fr_size","cn_size","mxsp_size","uy_size","id_size","kr_size","online","s1us_size","s2can_size","s3uk_size","s4eu_size","s5jp_size","s6","s7us_size","s8can_size","s9uk_size","s10eu_size","s11jp_size","s12it_size","s13fr_size","s14it_size","s15fr_size","extra_properties","concurrency_stamp","creation_time","creator_id","last_modification_time","last_modifier_id","is_deleted","deleter_id","deletion_time") VALUES ('0006495d-4f38-467a-9375-55cdb02f1370', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36DD', NULL, NULL, NULL, 'E80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0006f039-0ab2-4a53-a4c3-cfd7519f4b70', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '34/18 Regular', NULL, '34/18 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0008cb2e-0884-44d8-b7c1-a825c0661175', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('000b3238-c7ef-4e8f-b4e2-fd3dcbc1a628', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 / 34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00111d7b-cc97-4429-b369-0d11aedf6d80', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12 HSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0011cbdd-6517-41e2-9037-7e1076c6743a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 /30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0034bd1f-a3e5-46b0-b34d-f34801ea6e3f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'MP', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00355321-58b3-4cfa-abaf-ecf7a603e103', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0041e02f-e0a5-4a50-b984-feadd19f6082', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '11 ', NULL, '11 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('004a6d77-e809-4e87-bf69-3981e4d8e4f4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('004a8d30-95f5-4588-80fb-b28564ad18fe', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'M', NULL, NULL, NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('005d3a34-2b33-4979-a529-6705e9f8cf36', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0067067a-b19e-4407-b3f6-7c9b4763da31', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '9.5', NULL, '9.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('006e07ab-7749-42a4-89a9-b899efce4aee', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00733653-0712-4e24-86f7-224fcf871aa1', '3a0c74c8-3055-ad0c-c2f9-32634e7d880e', '3a100889-485f-fc29-7006-25cb2a5966f6', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0078eb37-2c57-4f49-b2a1-3149e84ee74c', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '12-18M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('00835e32-dd13-493b-b06d-8f773356f33d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-54d8-959b-7a0395f0cb84', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '205/230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('008603b5-3e24-4b60-8ccc-cf8fda01f4e8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33/16 Regular', NULL, '33/16 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0088b038-2fc5-4ede-8433-135bd7452fe5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublicFactoryStore', '3-6 months', NULL, '3-6 months/mois  23-27 in.  58-69 cm  12-17 lbs.  5-7 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('009b9524-210a-4a59-85f1-b14855b1fe07', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('009be678-b766-4419-8cab-309ef1523cc9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00a84daa-47d8-4866-a087-1403dc3b7c19', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '18-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('00b528f5-ff14-4fbc-aac9-ca27dc51e307', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '26 PETITE', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('00b5d65a-adcf-417f-ac12-70ac102b8253', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'M T', NULL, 'M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00b8ee62-9eb3-47cd-8627-8414dd650e59', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00cf0498-0b40-4020-af38-c16d3f769e9d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '32 LONG', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('00d3d335-7928-442d-a8ca-fe5c6434f69b', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '9.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('00d81d7f-6187-4028-b770-c45ea9eda34e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24MON', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00ec3858-30f7-45e0-8d44-f90d02949c5f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-c84f-6058-c43ce11f704f', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('00f151d6-dfe9-4f99-a78d-28df30344197', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0P', NULL, '0/25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01179497-35c4-4931-8e60-89e2b361d046', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M PETITE', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('011fdf1e-6ca2-4eca-aa93-22b0c0c8742f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01333c75-0d8c-44dd-89b8-9259e9bb8296', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('01489c43-7c93-47d2-ad0e-9b343e4de4ca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/ 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de8a431f-2f25-4ceb-89c0-cb4911f33d71', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2XSHORT', NULL, NULL, '2 CHICA', '155/80A', NULL, NULL, NULL, NULL, NULL, '2', NULL, NULL, 'PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817+08', NULL, 'OldNavy', NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('01521889-23d4-417a-b05f-0724914062d4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0164b112-fe42-4fe6-b15e-3372a2276dcd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18 M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0164f85f-a9a9-460a-86a1-8959cfc6f72e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9607-1abf-44de15979e47', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01682e81-e6a5-46dd-a43a-7dc85e3d03c8', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '42 X 34', NULL, '42 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('017742a4-83ef-41f1-bff5-df6f01aec5b8', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('017f2639-ba17-45aa-a1d0-07d006c65c5e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18+ REG', NULL, '18 TAILLE FORTE', NULL, '160/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0193142a-8f83-4d78-aa0a-cd21f9a565eb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XLR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01b6834a-97af-4a3a-bef9-747ddd034968', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29TALL', NULL, '8/29 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01b68b6a-cf74-4429-ba59-80b228bcb2e6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6 MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01c424f7-b038-4a68-8a85-c9585bf900e2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-3ef6-84d6-7cfea460ba11', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01ca07b5-1842-4090-b324-a006206fbc64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 TALL', NULL, '00/24 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01d3ebff-f3f9-4b62-8f47-ec2255c843e6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X 28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01d836bd-c189-4b71-b86d-dacfca6a30d8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-f114-8571-ec68ec3bdf3c', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('01db32be-7aaf-4fa8-b821-3c2149d4d3c5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '30/10 Petite', NULL, '30/10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('01dc1390-1b14-451e-bf7d-d8eb8b1b97ec', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('01e3893a-78e2-4234-8a90-ed5f26d0323c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8 HUSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('01fd08f9-1bf2-4aea-a60d-716129927001', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '27S TALL', NULL, '27S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('01fefcd0-bb98-4640-958b-7f1cbfd692ed', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('02047153-010a-437b-9ddd-61849d9b5d5f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '38 X 36', NULL, '38 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0212e7d3-36fc-40fc-9727-6b5912c566ae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '10.5', NULL, '10.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('021d7311-30bc-4c8d-b18b-fb5ef80084f8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/ 32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0230879f-1cb4-45b3-866a-77e12eeace76', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'S', NULL, 'P', NULL, '170/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0238e46d-4fe4-4210-827e-5e38cab8d7f6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25 TALL', NULL, '0/25 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('023b2e93-9d47-4598-8a69-ba050b0ba487', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('026841e2-29f9-418e-8041-716b8ae62dd8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02772fb8-a75b-4dbb-a61a-a18c7b250a46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02780f1c-088c-4175-82af-64423c5c5cfa', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('028e1ab8-9fbf-4461-bfc4-c163a9f778cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/ 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('029ee248-8d6c-4f03-bd60-9336c9579cc2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('02a62f3c-485c-4f4b-9940-39ed5d7d4a78', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12HSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02a7bdd5-d0aa-4503-87a5-26037b55f05f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X 30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02aa66e7-951f-4f9a-8ef3-acca98ed68a7', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XSPLUS', NULL, 'TP (5) TAILLE FORTE', NULL, '110/64 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('02b7618f-6cea-4670-b7d5-f58e42ce90ec', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18X 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02c01b25-fbb8-4458-ae69-7ef7228d13d8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('02cb3123-fbfc-42be-bcf4-c51b52f5e231', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 LONG', NULL, '2/26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02d98322-ccbc-4be9-a537-a03b4353b51f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'L SLIM TALL', NULL, 'G ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('02e85da5-cbd6-4bae-ac77-393e83c5ae0d', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '6 TALL', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('02ebf2de-e4e2-43dd-821e-a8343b928685', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '6-9M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0307b3f0-0fd4-4837-b80f-1a59d532dd57', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40 DD', NULL, '40DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('030c1f43-f631-4bbe-9bbc-f356d5a391fb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '25L', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('030d7804-6673-4359-89cb-9c60feec5132', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('030f4ecd-1260-434f-b824-f86812daf2e2', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('03121d95-6dd9-4207-acbc-ed657934ea44', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38S TALL', NULL, '38C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('031ae266-0cd7-45d4-988c-5c0d80a66590', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46DDDD/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('031ce2e8-3bb9-4770-9e42-fe7e942f46d8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0320a79c-3186-4d51-969a-7937cdac9974', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c459-a695-1b0f4c446eb7', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03238949-23ca-404d-983b-6818e90b18f7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0326ee07-2735-4bbf-99e9-58c852b83029', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L T', NULL, 'G GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('032932a5-8589-40c3-a38d-03278f55306a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38DD', NULL, '38DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03322f40-23c9-482c-892c-6e22df48d07a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03365365-536d-4e92-9068-8cbb3dfaa78a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L +', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0338a2a8-5ca1-494f-a3a2-b4034b83483f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '2', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('03473028-0860-4aa8-94d5-e3ed0a1bc0a5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 /34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03507c62-5771-453a-8f9b-432eb2f4ac55', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 REG', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('035d6466-f8f8-4b9c-a2c7-7a0eb4480a50', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '185/132A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('035ee7d5-890e-40cb-984e-750966a2a848', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('035fffcb-61b7-4517-b219-4b1d95e422af', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03745dd1-7a26-4150-8f52-8ab82807fc86', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12', NULL, '12', NULL, '145/66 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('038fff51-ac1f-437d-973a-2c1e4bcf1ca5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXL T', NULL, 'TTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0391072a-ec22-41bc-9a6f-c0f16efa4902', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18PLUS', NULL, '18 TAILLE FORTE', NULL, '165/81 - 14 岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('039ca399-d81b-401f-9fa1-ce833835173a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03a38579-67f2-43cd-9be0-e07c10bf5f7b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('03acaea8-0598-453a-98c1-ffbb115de85a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03b08209-b163-4dfd-aa08-51809b3b1d8f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-57c5-dd8d-3f495b0c94bf', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03c2a43d-142d-468c-87c1-b2bf29bed90b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25SHORT', NULL, '0/25 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03c803d2-475e-4272-849a-be963006467b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23SHORT', NULL, '000/23 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03cd81b1-043e-4abf-9cf4-eba6d68a9094', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 PETITE', NULL, '00/24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03d56601-0c9a-4673-92d4-103593d65620', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '18 TALL', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('03d6f895-0252-47c5-9467-b5c1712b0e10', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03dca51c-dc0b-412a-97ec-ad003a5f754a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '20P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('03dfbc23-5548-467f-bca2-4c3f0acff3bf', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', 'UPTO7LB', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('03e2f35e-f3e3-454f-ab19-4bbc421334c0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 LONG', NULL, '12/31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03e81bff-5a9c-486e-80be-de01df1e1756', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03e9c946-ea70-44fd-bdde-d87e31dd513c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '180/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('03f0fe74-f4aa-4c59-a842-0d7a55776dc4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03f14522-e0d6-454a-8880-d539ec8f2234', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03f28db1-a604-48d9-9387-8acc6a83cb7d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('03fa5914-0adc-4868-b8bf-ea0e7b44dc9a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '34 TALL', NULL, '34 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('03fb06d5-60ad-41ac-a232-e2a99f3a179f', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '9.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('0427ed1e-6640-4833-b3b0-9059d3b330fa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('042bc019-15af-4105-a586-b945502d2c54', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35J', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('042d00a0-b6f7-4b5c-b538-6a30248db005', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 TALL', NULL, '6/28 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04376c9a-643b-4826-a39c-bd537683013b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0438af53-e6b4-4fd4-a61e-0aa68aaadbfa', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XLREG', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04415eb6-0d67-44f9-81d6-53bd61d88c7c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20R', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04516bc1-a746-46e2-af45-4e6f79161dfe', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '36 X 32', NULL, '36 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('045743cf-1d16-4934-b4a5-74e56a2c0c3d', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', 'Up to 7lb', NULL, 'baby/nouveau-né  0-17 in  0-43 cm  0-7 lbs. 0-3 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0480fb21-a292-4e2d-b3eb-b76ac034f4c4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '175/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04855a8c-ce4e-4c74-9858-bf23b6da9112', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '170/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0486952f-fbdc-4316-be6a-1f7e1cb10eb4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04885124-6343-468d-a367-465750fda9a3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '40', NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('048e55c5-dcba-4ec8-b40b-46e0bfe1142c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('049471df-0347-45b1-904e-846dd85d55e4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, '160/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04991537-1718-4eb8-87a1-4a04e97ed79f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('049a8649-82cc-4c3f-bbf1-103b6da7df56', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04a4932a-5eac-4f35-b7ef-7f3f78c9123f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('04a6f014-d2aa-4a5c-88d1-c0f6af4f5c85', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04aa6c5b-b142-4ad3-b4ee-1766aec30927', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', 'NEWBORN UP TO 7 LBS-Notuse', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04b5708e-993d-46f3-a33f-7cd5cd2415d2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('04be05f7-2c77-4919-80ba-b2dcb932d7f8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'LPLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04cee1c5-863a-49bc-a8ba-247297228615', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('04db668e-9761-48de-a84a-2738c1c82f88', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL/XXL', NULL, 'TG-TTG', NULL, '170/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04dd29e6-39e0-4f67-84cd-f47945ea18fa', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S PETITE', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('04e0b067-a61c-4e1b-a93b-b6b1736a8920', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25/0 Petite', NULL, '25/0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('04f0143f-c3b4-4498-b311-77ade6ee65a5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14XLONG', NULL, '14 GRAND', NULL, '170/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04f61232-1326-4b94-b679-f85e3bff6dfa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12XLONG', NULL, '12 GRAND', NULL, '170/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('04ff2d17-f2d7-4229-a697-54d4910432e3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'SSLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('050ded81-5283-40a6-b3a2-28ff260a582c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0513a41e-1ec6-4275-b14e-6c10db33de12', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/ 36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('051fd398-bff2-40d9-a856-dcefc02d9525', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48R TALL', NULL, '48S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('051fdb30-5c9a-4762-96a3-ef9e90e5da1b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8S', NULL, '8/29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('052192b1-1e90-4abc-b259-53875d83071b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26/2 Petite', NULL, '26/2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('052f1e25-6b04-4b7f-93ae-0f0534a9c4df', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '23/000 Petite', NULL, '23/000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('05393157-155b-47f6-9664-5a367adc769d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('053e3d90-38d6-48b7-a5ba-c774897553b1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05480d1c-9f69-4b1e-98a7-e3c9813ba5e7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('054bf8bb-a2b3-428f-a2bf-a73ef2c8919c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0565f912-a489-49cf-b6dc-93881cfb0360', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5 REGULAR', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0568a7ac-83c0-4ce0-bd8b-5baaf48838e5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'LPLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0581c61b-71cb-420a-9c9d-c40ba3471b71', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('05853078-4499-40a4-b3f8-137c06d7ac05', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('058851f0-d117-44f0-9f36-8ad70c67a3a0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05ad5451-5f88-428b-b28f-ee1c6b34fda4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05ae8aec-6d32-4bf8-9868-6f796af186c4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05ae968c-1646-4e3f-a884-e59b65d78236', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05b1da6f-1ee2-43f1-9005-60e340947773', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '16+', NULL, '16 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('05bd3a43-cc0b-4017-8626-7a9c81dc1422', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24 T', NULL, '00/24 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05c9d8d5-60a7-43ce-97e2-6cb27faad1ca', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X 32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05d0b19f-9acc-4d97-abf4-35cb9aa255ea', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18 HSKY', NULL, '18 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05d394a9-00ec-4d32-9653-377998d914b1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10HSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05d5f386-e141-4b4f-8aa8-3cbe926def9f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16 HSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05d64298-08c3-4900-98e5-f2a472bd66da', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('05d68381-2520-4db0-b95c-1086bbda1dca', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X 34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05d74674-ffd7-4cd5-a294-f7432e41fbf9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05ea69bd-fd3c-4ce4-b87f-07a63b92559f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('05f04daa-e1b0-4147-b821-b73114674034', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27REG', NULL, '4/27 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05f57524-1bb1-4516-9c3c-bf8a3e40cf01', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('05f5d1c3-aecd-48f9-8335-7f0ac0589304', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/ 28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('05fb84e1-5fe0-4eca-9ee4-2701a9d214b7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 A', NULL, '6 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06037a0d-24e3-4018-8c43-ea1b3dd0c47d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0604f3a0-a2cf-48c7-97b3-47ba59fbe44a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '32/14 Regular', NULL, '32/14 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('061630dc-14f5-475f-af4b-56e8f55b887a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '34 TALL', NULL, '34 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('06173961-d145-41e2-9be5-a99cc703fbb7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('061cb1c0-a0ae-4797-b760-21d4cc736843', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '14 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0628cf7e-b6b3-4b9d-ac9e-198bff977ecf', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('06362c18-9ef5-46ed-b31d-2296d4b68f1d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XL/T', NULL, 'TG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('06399dc1-7e3a-4777-abcd-660a8d0d3104', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('063c29bf-9e9f-489c-997b-fa3b299b4741', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('064063b1-2629-4474-b460-4c8f61ca8b16', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 / 30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06461159-c8a4-4ed0-bd9f-cfc6d2e85b53', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18XSHRT', NULL, NULL, NULL, '165/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('06469a6a-986f-416e-8d4c-544e1814a2be', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06521c34-9d0f-4ccb-b86c-fae54ae44b26', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X 28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06564408-5b31-48b5-9130-a1967c9e36dd', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXLPLUS', NULL, 'TTG (18) TAILLE FORTE', NULL, '165/81 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('06564c62-c230-47e8-a693-9438eda036d2', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('065eed14-bc78-4178-aadf-21391079112f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('066e437d-e357-4c70-85dd-079fe092b932', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '8 TALL', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('06706e52-4f0e-453c-a442-48c00d7baab5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0670be5d-74e9-4eea-a0e0-8ef4f0ea5114', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL-XXL PETITE', NULL, 'TG-TTG PETITE', NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0673a198-6df5-4573-829a-5eda8bbc5954', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6c2b-8bdf-fed3dc8214fb', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0681b23b-01bb-4c60-8c5f-7441af6ff6d5', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-4534-7e51-de95ab641dc6', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('068db8c5-7b08-4a4d-b147-783dc7599ac0', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'S TALL', NULL, 'S TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('06918dba-df2e-41d3-ad1b-76066a9db7de', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36 LONG', NULL, '36 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('069adf95-8a13-480e-8ff0-4d3c08eced27', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '26L', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('06a15b45-047f-4a07-a2d6-90f63a0484bd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('06a7704f-890a-4323-81d8-4ef754e5775b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('06adb040-2523-4ade-bfea-9ce31c083e1d', '3a0c74c8-3055-ad0c-c2f9-32634e7d880e', '3a100889-485f-fc29-7006-25cb2a5966f6', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('06d7e750-dc85-456e-8fea-6bd601d1a1bd', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '180/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('06da5204-d19a-4c00-b587-94b48d7702b7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X34', NULL, '34X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06dbf6e9-495a-43ec-af82-b365927cf8bc', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '26 LONG', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('06ea3b4c-0b77-4f88-8391-c7d57a7d7c5a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 REG', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06eabe00-b144-4d1e-a891-ba72b72764b1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'L', NULL, 'G', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('06ec70bd-40d3-4529-bb4b-cb07ec6b9733', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/ 34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('06f81f25-e1f0-435a-aafd-e9f3f4e35e5b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X 32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('07050e03-c434-4eda-832d-66a7bc38348c', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4', NULL, '4', NULL, '160/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('070e3a76-1500-4ccd-8b18-98c5ea028353', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'S14-14 1/2', NULL, 'P 14-14 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0713409e-1a5e-45f9-80f8-7ebfd26ba01b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'L/T', NULL, 'G/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('07293d97-8a64-46d0-be21-71c0aa64fe95', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('072a1595-ecbe-4ee2-b409-2cd708516be2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4P', NULL, NULL, NULL, '155/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('072c7c98-c363-4d3e-bc6f-017a83cd25c9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('073ea8ac-afe2-4995-9117-8ff43e526c5b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '16', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0749c0ef-6e1c-4d35-a4e9-57f9fd7bf153', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0753f650-00cc-459d-bf31-679b5436aae5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('075978bc-0bc5-40b9-b5f9-3b559e20ef9f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'LREGULAR', NULL, 'G Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0771b8b9-38dd-495c-adb4-8049cf817004', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL SLIM', NULL, 'TTG (18) ÉTROIT', NULL, '165/66 -14 岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0774a465-1461-40cb-9a55-377d9d16d3a6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S HSKY', NULL, 'P COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('077ff8cd-9e15-445d-bade-f07d6db5d4f5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('078fd75f-d90a-4eb6-81b1-d823c5a73ca4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XS HUSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('079406d9-b55a-4fea-bc8d-5149af6e3081', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2P', NULL, '2 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('079e9fd4-caf7-42e8-b5e8-717ef932ae30', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '12 Long', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('07aeb4b5-d3bf-4521-9731-576c9449fee3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33REGULAR', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('07af0160-6dd9-46d1-8254-0233a79d4c0e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 /24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('07bbaaa1-01f6-4772-9b48-a02897a324a0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('07c4285c-2450-4ce0-b90b-3d6a50a3b0fe', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10SHORT', NULL, '10 COURT', NULL, '160/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('07cb8ef4-7543-478d-90c1-ded489a761d2', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '7.5', NULL, '7.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('07cd0130-4779-465f-833e-0afbd447d6f1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XXL', NULL, 'TTG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('07e5cd73-e1d7-4c17-9dd2-36d21ab7d4a8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '33 LONG', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('07e5da72-0643-407c-a454-96d90b2e245c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20 TALL', NULL, '20 GRAND', NULL, '175/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('07e9296b-4fcc-406b-8a32-0a7422a4ff09', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18+', NULL, '18 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('07ff6659-8f1a-48c1-be62-39606c7ffe2b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '9/10', NULL, '9/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('08012828-3581-4f62-99e9-53ae9c23538c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'M/L TALL', NULL, 'M/L TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0815d2f4-0dae-4240-a5e3-73203b5ec957', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '34 LONG', NULL, '34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('08193d7c-d379-4c62-a420-16039ed4adec', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('08208131-80fc-48c5-bd6a-e49f75e35f4c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('082785a3-48e7-427c-ad57-286a76be3be4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000P', NULL, '0000 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('082887ab-93c4-462d-998c-fc4660dc4fb0', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-e11c-301d-4e7abc8cbfea', 'BananaRepublicFactoryStore', '0-12 months', NULL, '0-12 months/mois  0-29 in 0-74 cm  0-22lbs 0-10 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('084de034-8cc5-4203-8fce-0cb550de719e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14 PLUS', NULL, '14 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0853f8d6-0cc1-4b3d-8fe9-2a7ca092ab8e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '6 Petite', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0854870a-0b16-4873-bc7f-108d45a426d6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '170/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('08589306-b04c-42cc-b46f-077958f04374', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16', NULL, '16', NULL, '160/67 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('085d0224-f177-4aff-89d0-b26869391bef', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M+', NULL, 'M (8) TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('086476ab-0c24-4f4a-8225-59cf26ebcde8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL REG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('08671144-39af-4d7c-901f-05a2d486fae4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0867f502-b248-458a-8e96-b4376e5f696f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('086e7c0d-6536-412d-b4fe-f0cc9ecfe431', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', '3-6 months', NULL, '3-6 months/mois  23-27 in.  58-69 cm  12-17 lbs.  5-7 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('086eaf58-7753-4588-93fb-c3770df4fa0e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '3X', NULL, '3X TAILLE FORTE', NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('087d95a1-9480-4839-8958-2b162296cf03', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXSXLNG', NULL, 'TTP GRAND', NULL, '160/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0881fcce-11a3-4223-96f8-1d7f32c27138', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35T', NULL, '20/35 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('088306f5-feaa-4fe1-95d3-47dcd6cd977b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48S TALL', NULL, '48C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('088b5bc9-a526-40ed-a0a4-a1dd2d374287', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('088d4c95-c872-4ea4-87e3-456d7b936c38', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44/ 32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('089905bb-9893-482f-ae59-dfee1912416d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '8', NULL, NULL, NULL, '165/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('089cfe57-386c-4158-9c06-f03222865a27', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('08aa8004-3645-4451-bbb4-d9daddecf749', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28X28', NULL, NULL, NULL, '165/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('08ac1c45-ee15-45a1-a0c4-40d47f37a5c0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '8 TALL', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('08d82606-5440-4134-854b-319b2410f2a8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-34bb-7876-d77e298f6e65', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('08dc6a65-b42d-46ab-bc79-5d36946dfd5a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('08e22056-7458-4dd7-a061-c581e3896309', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('08f81421-4148-4110-ac5c-80c4622a8daa', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M HUSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0903e210-f720-4d55-97fe-bff7b1bea34a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00 X 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0906aea9-71ed-4363-bd88-1878e8ce15ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('090beadd-bb7e-40b6-a3af-f8b7ea655c1c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('090c7ffa-8fa8-4d9c-92a2-c07cdf7e2697', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-7628-c0e7-2953753a67e1', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('090dd2cb-5a3e-45ba-9cfa-caabf0ecc278', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44/ 30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('090e1db8-5a40-42d4-bb28-e9f23190702e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09170e6a-b853-4dad-9678-7c6ccb37b67c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('091ca16b-60ed-4fc7-8381-7ea2fabd2adc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0929aeae-7468-4502-b673-37d588f77ff3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38 DD', NULL, '38DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0932e6fd-7024-40e3-b271-9e592439bc8f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0933e345-27f3-405d-8e3f-7d1b94571ad4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16P', NULL, NULL, NULL, '165/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0934ce80-9bb6-4714-80c5-fd4ce1521c4c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0937ea59-3155-45f7-bb3b-056489d71f4b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '8', NULL, NULL, NULL, '260/94', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('094a011d-438a-4557-8c1e-fbda8b147d04', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16S', NULL, '16/33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0952b12b-1047-4c9a-bbd6-23dd0d2a0222', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12 TALL', NULL, '12 GRAND', NULL, '170/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('09532b01-3c62-4e02-b065-a6ff04657967', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '32 X 36 ', NULL, '32 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0956249a-bd5f-4be3-9d01-bb5a5b19d6fe', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('09576f2d-5f83-43cd-a5b3-ca6ed0b5694c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/ 28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09701f9c-8e82-485b-91b3-5bd76a144cf2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09748b07-19a7-4024-b454-85842936a347', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 A', NULL, '2 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0990fc8d-d158-4d21-8574-08040898af90', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '175/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('09951dd9-1cba-44b4-a263-13f5af14d30e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL+', NULL, 'TTTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09a41b67-e9f6-4872-b668-143508a9c90a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00 REG', NULL, '0', NULL, '155/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('09af3550-7ce4-4f1e-ba5b-48bf09d1675f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09bd6259-7198-4f8a-a54a-5abfdb068b13', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09c4d24f-b113-4b4e-8cc3-63976a752c9e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18S', NULL, '18/34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09dec572-e3b7-45d4-a48f-93948a9314ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28L', NULL, '6/28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09e3f7e9-22aa-476e-b0a9-857b1177976b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('09ee9e72-1a4e-4993-9249-5aba77a24f0a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09f19be2-7f6c-42e7-ab09-c191ba3b5646', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09f9a262-50bc-409a-8fb8-ff48c60ffb9a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000X22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09fb5702-7fbf-4e3d-b7ea-b1040004ec50', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('09fb777b-e9b7-48a2-8638-73f9e2196bae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20P', NULL, '20/35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09fe989d-b39e-485b-929e-cb4f7931fc4e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 SHORT', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('09ff31b8-30d3-46bb-9a70-1be6bb9a93c7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '14 TALL', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0a01a7bf-9ca7-4889-97be-b4ea20ea0d67', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/ 28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a094f3d-62b9-4307-9ca5-5efdfe49421e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '28 TALL', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0a10ff8f-fdfc-48f1-b7a7-700712dec98c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10 HSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a1cc57a-bbe3-4d35-b272-8655a7a6ce6c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 / 32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a1ddc02-48d5-4bcd-bb4c-ae96a903dfd4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36C', NULL, NULL, NULL, 'C80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0a20f7c5-aa13-454b-a630-16de580a8dee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 / 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a223546-8eb8-4022-bffe-ff659b984f75', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 REGULAR', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a38d644-6d81-4ece-9421-cbd5818d5aa4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14 / 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a4b360c-64c5-419d-8f08-6eb3af68d99f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a4e77e4-7fd1-4e86-af2a-90bfc9b43511', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8R', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a6ab3cd-a535-45cc-92fb-ef99f2a7ccf2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4T', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a6dce7a-8145-408e-9de8-d6eb5831bb26', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a6fc57f-ae2d-4b67-bcf1-fe275138f383', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXXL/T', NULL, 'TTTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0a870873-f768-41c7-9ab0-80d951a3e7c5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20 /35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0a8a6ebf-3f8e-4f87-a085-dfd8c3217149', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0a90a9df-d69c-443d-9cca-5a58c97b7079', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XL PETITE', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0a96ad5a-6d68-4809-9ced-5b169c8714b6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38 SHORT', NULL, '38 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0ab07875-bdbd-4dc5-9e16-a00450c3fce0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ab6dda2-bd12-484e-921f-0f2e43a79401', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '22-27 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ab7d510-1a00-4285-b5a5-e2e4c485a4bf', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0abd8f78-7a89-4a5f-89dc-47c371e00a4f', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0ac31d86-0ef3-4bae-9662-ab977c1bd49b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '32 TALL', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0acb6583-94b2-4c98-98ef-ea64ee02a227', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7744-6623-09d5f49320cd', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ad93845-0541-4610-96f9-5485af57056b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', 'PREEMIE – UP TO 5 LB', NULL, '  prématuré JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0ae25a4e-8465-4902-8120-945c5c941222', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'M/L', NULL, 'M-G', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ae55fa3-6266-4a12-95d9-680680c4b94f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0aea80ab-f97f-41f4-8b77-cfed13828145', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0aebcd20-396a-4484-ab36-22c362504b29', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '6-12M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0af583b7-4e6a-46be-97ca-3eae94d3787c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24+SHRT', NULL, '24 TAILLE FORTE COURT', NULL, '160/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0afcfb12-8f7a-444b-aed5-6093a9c470d6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '42 X 32', NULL, '42 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0b01a3bb-716e-447a-a4cc-8950d2bb9a75', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0b0a0344-7c5e-4195-b1d0-1898c21fc84f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '32 S', NULL, '32 S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0b3f84c7-21f3-4207-be72-7e69147b2e3d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18 REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0b440adf-80d8-4b49-83ab-0017c80d7055', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', 'XS TALL', NULL, '13-13.5 x 32 = TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0b4d7166-7a6c-4800-86a0-ed1cbea81754', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 / 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0b580116-7962-4ec7-9449-a653c97ea52c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0b5e86a4-bc24-4ea7-adf9-072d43e8c091', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2PETIT', NULL, NULL, NULL, '155/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0b76a07c-bb6c-4664-86df-f62ad2118114', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22 R', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0b93b33a-5801-477d-8235-1a3e6c854c20', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 D', NULL, '36D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0bafa7ae-b189-4b97-9edf-bb7ff12a50ae', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL REGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0bbbb52a-fec0-471d-8678-4fba7bc72438', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16+', NULL, '16 TAILLE FORTE', NULL, '160/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0bd47b8d-8649-40af-98fa-ac41c15a1635', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10P', NULL, NULL, NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0bda29e0-dd89-4283-a1e1-b65c398913ab', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 REG', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0bdca58d-fbad-40c6-820e-68a843089af4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X 32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0be31e35-a485-4925-aef5-2e144570ae7f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL SLIM', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0be4386e-1987-4958-a5c0-b82eb4d67a2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 LONG', NULL, '8/29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0be712c9-be77-4bbe-a013-e68a37c49913', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '23 PETITE', NULL, '23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0bedbe18-d0ad-4ace-ac82-005dfab20e23', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0c032fce-404b-45e6-a04f-9c89dffa1977', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c045b41-a2ad-41a5-aea5-20c30c9f9223', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M SLIM', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c060260-99f9-4916-95a7-46c9ac98bb9c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0SHORT', NULL, '0 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c06eaf7-2168-4a11-bc52-717d23f054ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29REGULAR', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c080f37-878f-43a4-8d5a-23e7e423c1ad', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'MXSHORT', NULL, NULL, NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0c227aeb-770a-4718-bf6c-0836e61d7ad9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20', NULL, '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c2b6c78-ca9b-4db9-9013-46aca83c557c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16T', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c32f561-9476-4b3f-97dc-7a6aa77c52c1', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '17 x 34/35 = XL', NULL, '17 x 34/35 = TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0c3cd46e-a99a-4303-be9a-1816abb47995', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '28 P', NULL, '28 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0c3e58b8-f3b4-469e-be96-c5b15ffc4f86', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '20', NULL, '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0c43596d-c591-4e1c-9179-45e9931243b3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0c4399a5-a62d-4713-a94a-280e6307638a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36S TALL', NULL, '36C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0c4444dc-6e2a-4878-8626-3d95f84f68ce', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/34', NULL, '32/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c50129c-d7e1-4fe6-b969-f49600b628ca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6X28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c50d57e-7218-40b6-863f-90b842bdb915', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL HSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c64d4b0-0307-4b0a-95fa-0071e2774556', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X 30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c71babf-4cb3-4e58-bfb4-d13dad7cf46b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25/0', NULL, '25/0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0c78170a-d19a-437d-83c2-b4bd28154510', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 LONG', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c8085c5-c57b-4ee4-9f2a-c0cc52cd829a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c87726d-cce6-4fde-b38d-30e95f60e08b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'LREGULAR', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c88566c-911a-4ed3-8795-e39b2f04bc2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34SHORT', NULL, '18/34 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0c925125-c1fd-411b-940a-06b1f41ef7bf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'M', NULL, NULL, NULL, '165/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0c955025-8cbc-4b36-9823-eadc401970ef', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'XXL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0c9af856-0050-4a8a-83e5-bd51ead575c3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'S HUSKY', NULL, 'P (6) TAILLE FORTE', NULL, '120/68 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0c9c14fc-b991-4190-9a00-c5da3132c301', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S SLIM', NULL, 'P (6-7) ÉTROIT', NULL, '120/53 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0cad4f72-4bfd-44a8-919e-9efcd69450a9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20-22', NULL, '20-22 TAILLE FORTE', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0cb05c1e-5810-49ac-a3e1-742478ebae7d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S PLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0cba58aa-97bb-4a9f-8e51-4a662381737a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0cbbd205-23da-4b05-9069-af4f8f3f630c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '20', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0cbc0dff-8df9-4efd-aec4-479ae70be1fc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0cbc8184-d435-40b1-885d-36da7f98938e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '52X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0cbe16fb-594d-4fc1-9a42-66f1d9d9a9eb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0cc278a7-3b43-4b76-92bd-a82e47d7cd43', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22L', NULL, '0000/22 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0cc3ccd9-bab6-47c5-9e25-9e7f7171c213', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10 SLIM', NULL, '10 ÉTROIT', NULL, '140/60 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0cddabb2-1cc7-4a23-bb0e-7a89e86e63cf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0ce611d4-8b3c-41dc-a280-9317ab44e72d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '13', NULL, NULL, NULL, '305/104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ceefc78-bdec-49fb-8791-5a0ed9eeef67', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32A', NULL, '32A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0cf96c46-a319-4e60-9dff-ee148b8f8c64', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0cfbdd1f-02b2-4403-bdaa-e0324eda21e4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XXLHSKY', NULL, 'TTG (14) TAILLE FORTE', NULL, '155/80 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0d001f3d-fcdb-463b-8ba0-334359379bd7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0d1f90b9-ca0b-4484-8c48-4cb813f6d719', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 REG', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d24096b-d7dd-412e-822b-6ad2d661a2d6', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2', NULL, '2', NULL, '160/90C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0d27cb76-b831-4d06-85e1-489ad71838fe', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d2a77c2-7909-445e-842a-5f390d049c0d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '46 Regular', NULL, '46 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0d309c86-b604-4bfc-b2dd-8fe1e0f7ebb4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d4623dd-b81c-4490-9d6c-901b865b48e5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '18S', NULL, '18 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0d61025c-edd7-4d7c-a5cd-42a0a79a9575', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X 34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d613703-dd85-4637-9e4a-74b856de2763', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0d62043e-d3de-4a89-af43-3417149c2d29', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d628d3e-e58f-42a6-91ff-d2c2a6eb9ce5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0d69131a-40aa-4973-9b1c-b7be01660edb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d7a843f-187d-45b6-a6ab-ee58b49c1ea1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d7d37fb-591c-44d7-907b-4d2c083ef0fb', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0d92e12a-27d0-4002-8142-08db6d6253d6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '6 Long', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0d98ed6b-1fae-4b80-8b3f-1bc873872db5', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '40 Short', NULL, '40 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0d997b5b-078a-4592-a0ea-7ab9f54ffca5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0d9c95dd-46b5-4d78-9b6e-c10a2452da0f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0da41719-97b8-40ac-95cf-7d79c3d055fe', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '32 TALL', NULL, '32 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0db302da-3cca-4d03-ad78-9f8188c4343d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-d145-94a8-c29267eb9430', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0dbfa395-793d-492a-bea1-c6a7a94054d4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 L', NULL, '4 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0dcc35b6-8a9d-4b71-8382-13c338400f7e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL R', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0dcd343b-4d99-4b4b-8fb1-688b22c5a8c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X 30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0dd121ba-eda2-45c3-b899-8d1ad6647322', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X 36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0dd2d288-4400-48e6-81cc-3115098265d2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '16P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0de066c3-b566-4a98-bed4-43cc0e9920e3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0de0eaee-c65a-4876-b92a-32606a0f13fa', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'XL/XXL', NULL, 'TG-TTG', NULL, '170/120C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0de1e74c-787c-4a9e-a34f-8110ad67a080', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0de862c0-8a8a-4c2d-9bad-947bcd92ee31', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0deec853-7449-4864-b2ee-c9670dab88c9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e0181e2-3042-49ae-b7fe-b368d63058bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3YEARS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e09c4b3-4e7c-4da3-84dc-473e6f4811e2', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '180/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0e125f25-96e5-469c-808f-19eaabaf3819', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e19a721-c1e2-42e2-be82-4e773324ee98', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0e204ebb-eaf2-4719-8676-dc18433d61d6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e24cb10-c870-4a1a-b9ed-9a97741252d5', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'S PLUS', NULL, 'P (6-7) TAILLE FORTE', NULL, '120/68 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0e2ae465-3c97-4a75-9ac1-07688e355d5a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e3aff3c-08e9-4140-9fd9-bb2181685338', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '9', NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e3c20de-8fd4-445d-a393-618a789029df', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e4445ca-2e34-494a-9aad-0beae8be190a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e47b1cb-fbe7-4202-aa73-f380b4a9fe75', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '46X30', NULL, NULL, NULL, '170/116A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0e566323-70a7-4d9c-a84b-149168fd8ab0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 /26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e667bd1-db58-43fb-9f67-cddea168ad92', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '35/20', NULL, '35/20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0e70b842-8800-4ce5-afbf-fc8a213d14f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14T', NULL, '14/32 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e76dfe1-7d73-40a3-b61a-c701fb1fe90f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 TALL', NULL, '0000/22 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e7a6844-d681-45fb-ba86-78e425d0086a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26X32', NULL, '26X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e87db8a-7eb9-4f6f-aa3c-f4a302f237c8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0e894d82-d437-43dd-8fd8-967c79bc8074', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2 X 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e9767f6-1cf3-45ab-8e5c-694d3276f6e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0e9e983b-313c-4306-a4c5-ebf1976574db', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38D', NULL, NULL, NULL, 'E85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ea036ff-4b8b-424e-8671-98519ff02b46', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0eca8fc0-8484-4f75-9b29-3a05476c2752', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34X38', NULL, NULL, NULL, '190/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ecbb35c-e792-4762-85bd-837e52d6e5f0', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS', NULL, 'TP', NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ed59f0b-bcdb-4ca2-81e0-e69fc4cd10a6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23J REG', NULL, '000/23 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ee1fe37-f58c-4cfc-9581-b88677ee7799', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0ef5c30c-bc75-42a5-a064-1a798eb7c083', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00 TALL', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ef9a135-3a16-4e94-a4be-cac78aba299a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0f06a28e-99e9-4d1e-b9a1-6ec396620e9c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6 T', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f0936ec-cf87-45de-a433-8e7d31b13d3b', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-989f-2777-b6e102a93443', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, 'l', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0f0c8c55-37e9-4094-b1ad-0845afa6127f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32 T', NULL, '14/32 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f128fc1-8a6f-4ee9-9dc9-f0228fc5f498', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 TALL', NULL, '18/34 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f2b5729-cbfa-4477-a333-e10be99ae77e', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'M', NULL, NULL, NULL, '165/105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0f40a323-f4cf-473a-be1e-828fed649747', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16+', NULL, '16 TAILLE FORTE', NULL, '160/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0f45409a-6607-4884-b3c6-f9bd54c09109', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XXXL', NULL, 'TTTG(46-48)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f53f024-85b6-4074-b0d7-b5c70cdb8859', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '31 P', NULL, '31 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0f5dd9dd-1a5b-4acd-8afd-e88dd70d0d15', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '10 TALL', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0f5ffe2c-57a8-490f-beec-174bfc30b74d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0f6286f6-4fa0-4d52-9d80-c77049287a1f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL+', NULL, '2X', NULL, '165/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0f6d0631-4617-49cc-ad4b-c422c0ccee94', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f75143a-7fe3-4d21-8e8f-60ccc9519802', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4SLIM', NULL, '4 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f753283-78c5-492c-80f6-6c54b3134e4f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0f822a5c-3268-4e87-9a75-c6162213866a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '12S', NULL, '12 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0f8f84e0-b4e8-4e98-a2b8-295f0676e623', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XSP', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fa41e35-e054-4e29-b68d-83d89297e99f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fb5a45d-830f-47a7-8731-65d311e4e096', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('0fb9a131-e593-42bb-a0f3-ce6c4c44e15a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fbca1a9-8bfc-4a78-9aa3-347c2d72ca7d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'L', NULL, 'G', NULL, '140/61 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0fbfb51a-9dd2-467a-a94e-b68ff5e63988', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 / 28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fc020fc-e92c-46f4-a155-d5c38bb5ec93', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 / 32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fca761f-f017-4aaa-82f4-b8e15ee4254e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20L', NULL, '20/35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fd0333b-81ee-43d7-8529-1c1114fcefc0', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '185/104A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0fdad4cb-f2ef-4bca-8196-9664de48ffe6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31 T', NULL, '12/31 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fde544c-9559-4fdf-874a-a79075a9cb92', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fe8ac16-ef78-4e80-bcad-fbb712b4cd51', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32X36', NULL, NULL, NULL, '185/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('0fec95bc-0c65-413b-b02a-277a811787e9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23 S', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0fee8c77-5ea9-4619-b986-30aec81b5d18', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12 X31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ff477b7-99c0-4654-af28-6b6364a795fe', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('0ff81e16-1a42-4106-865b-2ac1060cab93', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'M (8)', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ffb1297-028c-4ce8-af98-ce40e53473f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ffbc88e-66f6-41db-aa1a-5e2157192cf6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18HUSKY', NULL, '18 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('0ffc7313-9257-480f-885f-62bf74da5c6b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1002f608-a59e-4040-aea9-d64851cfe267', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '16 Petite', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('100d0619-bbde-42a6-9b01-12ae07aa243a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32LONG', NULL, '14/32 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('100f3f9f-aed7-4983-bbdd-c23f56eb11fd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fc2a-f50a-b69401759c32', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10159ac0-8071-4ad0-9dc3-d90e217d46ec', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '4T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1029dc1d-2dcd-44e1-b67c-8302e5784ed5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('102bc95d-8680-4d99-9b94-618cb5293e86', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '29 TALL', NULL, '29 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('10307aef-5097-4425-b872-358352292c5b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('103fc4e0-9be4-4dce-86da-90c1383e0d43', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10427fcc-7e6c-4ea2-949e-492bf1e2510e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '180/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1042e43e-91b7-46ac-a12a-f6662730c173', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8 X29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1058edde-ff01-4194-83c0-a1b79b4a9c92', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6HUSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10626eab-3a09-4660-b95f-e7b791e045ce', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '00 LONG', NULL, '00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('106c1b31-d5f2-471a-ac54-56f1c3580053', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'L', NULL, 'G', NULL, '22-24 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1076249d-c9a8-4a47-a52b-0cf59a31f7f6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1077a0b2-5fb8-4ff0-bb93-28efe8f5dd6a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8 TALL', NULL, '8 GRAND', NULL, '170/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1082b855-08d5-401b-ad6c-795bcd429a98', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1083252b-b35a-46b5-b685-4355b76143c0', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1086ae6b-9578-4245-ac1c-bfa8925c9af8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'XXS 14 1/4" 33 7/8" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('109444b7-da73-4308-a947-14d1ebc154a1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33-TALL', NULL, '33 GRAND', NULL, '180/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('109489e7-7a36-4299-934b-e047440e03d1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26J', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10ad8813-43c8-42de-901b-52d7efb63c48', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10b45e9f-ef36-4abd-ba5a-2c42c6678f5f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18 SLIM', NULL, '18 ÉTROIT', NULL, '165/69 - 14 岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('10b7f080-fead-4638-8950-d28a2f301905', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 REG', NULL, '8', NULL, '165/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('10c348ef-8fd7-4e12-9118-82f3b42d9ebe', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '2S TALL', NULL, '2C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('10c891cf-4114-4360-9e43-e525ce71798e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '30 SHORT', NULL, '30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('10e734fc-a5e6-49b3-9f4e-51395732c066', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S T', NULL, 'P GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('10e764af-6c6b-43bb-80d1-89d2e2e4b3be', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('10f98137-7179-4f6c-ad05-ececed90d506', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL PLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('110d1624-55cf-44d5-930d-1f80e2858af5', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('110d4150-bb32-4930-82bb-ef3a382f3611', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '4X', NULL, '4X TAILLE FORTE', NULL, '170/155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('11203096-9ecc-4f52-b5a5-02d12bcd5639', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('11237533-c553-4c5c-8538-bdf351639147', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1124ae6d-185f-4860-af6d-bce8ca89af1c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31/12 Regular', NULL, '31/12 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('11283f7f-08af-4983-939f-dc2040b47e9f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'BananaRepublicFactoryStore', 'S/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('113417b7-c139-4162-be40-b7f20848a812', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('11455612-196b-4c5b-a63c-9b56adafefc2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-fa07-f4fd-146a1fb15d21', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('114f014a-188b-406b-b295-44ba10161345', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11612888-ea69-4eb8-956a-ca8fac6cc385', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1162a950-d3ce-48ee-87cd-73ebe9186ae7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('119f3b4e-8a2c-4f6a-93e1-2e16362f3282', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11a59dd5-0725-4c33-85ec-a70381701d17', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'MREG', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11a80b38-d67b-4525-af14-611f881cc2f7', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'S', NULL, 'P', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('11b03638-e794-42f0-99db-15138b9aa4d3', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('11c14457-2dcb-41f9-b3b4-e57f4154880b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '39', NULL, '39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11c1f135-3860-4e0b-8352-aeb4f67b773b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('11c62068-21b9-4142-b6cb-79ea383410b5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18PLUS', NULL, '18 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11cd78d4-5fb1-49d2-8c2f-56d7ca46f346', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'M15-15 1/2', NULL, 'M 15-15 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11d1ac70-4ace-40d5-a1d4-c7249cea0615', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'XL', NULL, 'XL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11d4df81-8186-4502-9881-a1dcfca5b306', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11e018eb-a741-465b-b8d8-25268c3bf6c3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11e41021-6c05-4b77-adf5-e910750dac83', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'M PLUS', NULL, 'M (8) TAILLE FORTE', NULL, '130/72 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('11f4e3a1-c1e6-432f-9f14-5599bcc84aa9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6TALL', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('11fac8b6-3fc1-4f54-8999-99caddd191a8', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L+', NULL, 'G (10) TAILLE FORTE', NULL, '140/70 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('120980c7-293a-428e-90dc-ed031d8484f1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16+', NULL, '16 TAILLE FORTE', NULL, '160/114C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('120a7ed7-7698-41c0-b3a4-14f88459fd4a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '1', NULL, '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1215c3a4-99ce-4409-97ff-c35705943fea', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6 REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('121acccc-d503-4af0-a9a8-c1d3cb7d5b67', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', 'XL', NULL, 'TG (12-13)', NULL, '305/104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1229b456-59a7-413e-b927-b8e6b9732e50', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', '3-6 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1229bf0d-2642-4a9e-94d8-7008708f5408', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5d1-8b1a-6681f41aed59', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('122b0ab5-fba4-4f7f-84de-1df2bba9833a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('122d9924-bfcd-4a4b-a03d-3105184a2d2f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1235a628-e3eb-4c09-bbff-4b5b1d1ade20', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('124195b0-871d-4203-a3b7-29ca6bac088b', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('124e3eaa-6192-4115-ae94-cc1b78e4b3e6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1264ddd8-3e70-4ccd-b39e-b7c2da0e8660', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X 28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1267cd14-6cf3-43fa-8d60-4e8a7867b67e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXLREG', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('126dc299-66ae-414c-b0e8-8200a8bc48a9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25S', NULL, '0/25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('128d6319-c40c-4669-95d1-d9b99e022bd9', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M', NULL, 'M  (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1291693c-af6c-4ee6-8ee6-c584c0ffdeaa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XL/XXL TALL', NULL, 'TG/TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('129879d8-28ae-4c71-b20c-f6778d193042', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '6-12M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('129d7b5c-01e9-410c-a372-2ab8464aa147', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10L', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('129e9b33-ad60-475e-8845-e8ad2d1f672c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12aae07b-c0dd-486f-92f5-a138dbb9c546', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXS REGULAR', NULL, 'TTP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12c54352-9d1b-406a-9f1e-40abd6427bd0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '3X', NULL, '3X TAILLE FORTE', NULL, '165/145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('12cc41bd-4c7e-4bd5-9f63-d8899c6e987c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35REG', NULL, '20/35 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12ce2794-a076-46d3-8fd6-bcd780556d93', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '35/20 Regular', NULL, '35/20 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('12ce2ebc-b36a-4d95-a629-97ae872030ec', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '27 P', NULL, '27 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('12d0c3f1-2a87-440b-be19-18eacf81e25a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '35 LONG', NULL, '35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('12d248ca-4683-407d-afcf-cc345bbc0e6e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 /34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12d46309-1316-41fb-97cd-133a3b1dbdea', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '11', NULL, NULL, NULL, '290/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('12dd755a-abf5-4566-a401-331a3ab5d406', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('12eced8c-b3c1-4da2-a96d-b994c5496aea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXLP', NULL, 'TTTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12eeb52c-11ad-4cfb-9704-d43bf0cab9bb', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('12f9613a-a06c-4584-8472-1160393acda7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2X26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('12ff4578-becb-498c-a50f-0738cda72a65', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 L', NULL, '6 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1308fd8c-2e80-4ac1-8ce1-916ee2da1bf9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '18P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('131355f8-524f-4506-b7bd-733e0aa32236', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9607-1abf-44de15979e47', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('131a4462-d786-4133-8fd9-cafc0c1d30ad', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '28 LONG', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1322222a-4248-42fc-9c66-34d74d8db44c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '29/8', NULL, '29/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('13222e78-8db2-481c-8bc7-f3f029369baa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1323939e-a69e-4bfd-978d-ccafa86918af', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '31S TALL', NULL, '31S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1323c5ec-df2b-48c7-80aa-8665a4b7c000', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bec5-de88-f6ec558ddb30', 'Gap', 'X/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('133d53a1-0bec-493e-99b7-4cf1e7a2ee61', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '33/16 Petite', NULL, '33/16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('133e55f7-05cd-4657-a4e9-1784425c3800', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '23 LONG', NULL, '23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('134aa61e-edf6-4d13-948a-77346c758fc8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/ 32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('13583915-c125-42e4-a4cf-681a84532c24', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '31P', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('136009b6-df8e-4d4b-83f3-38b47e2c90a4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('13768031-6ab3-44f1-83bd-b2f40443e813', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 /32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('137df768-65fa-4d17-92e1-9b43c80153e5', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'M', NULL, NULL, NULL, '19-22 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('137f45d1-2b80-45a6-a415-c06506389214', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '34/18', NULL, '34/18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('138c5dba-9e19-40f1-8543-b50ba12e12f2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '14 PETITE', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('139249b5-2763-473e-8c2c-1ade79ea07ea', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-eee2-86bd-56a01f5666ee', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '****', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('139c4fd4-75a5-4770-86c0-79594149a449', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 XLONG', NULL, '8 GRAND', NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('13ac6007-b436-4158-b301-2c1cde7f5992', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('13b6cac8-df3d-450b-8f68-c2b649eb8906', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('13baa420-c492-40ba-9f21-3ea46aeab501', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('13c30e7f-0f0a-4652-9cf0-7c0f8ee18dce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('13c81089-c968-441c-ab43-b85181dcb1e5', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33X36', NULL, NULL, NULL, '185/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('13cf7fa3-f993-4f62-88c3-7b6ac3c929ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0 X 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('13d6e17b-b03a-4540-9719-2da9813f4fd0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0T', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1404a1e1-ecdd-4580-88aa-52cf107b9beb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('140d6235-a383-4d12-919a-aaf28a5f9ae4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1417af05-e2f6-4072-a93b-a529868f0fde', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('14192780-649c-4ddf-8f51-24b6d5487044', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3 YEARS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14297d72-6142-40c5-89c7-ba898821af1c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('142a1903-fb98-4f73-8347-f51e3d013e50', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '33P', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1430c827-989b-4e56-9ad5-50c4453cc98c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'L/T', NULL, 'G/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('143175c2-2568-4fff-9e2b-9742b0b62273', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 REG', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14559f2c-0921-482e-aaa3-8ff3c9e6ca3f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1459613d-8a4b-45d7-85ca-3d1ba73c9678', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10 P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1460479f-3737-48a6-9845-ba05da182d61', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1467b53f-424a-45d0-af08-1c354ac335cf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10 REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('146c6f18-aaa3-4b94-ac2f-7f4794442e67', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M HSKY', NULL, 'M COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1470f938-8c0f-450b-9300-0d1875b17187', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29LONG', NULL, '8/29 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1477b428-9a01-478a-a17e-6be5ab2c7756', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9 MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1477f75d-3a40-4617-b563-6b0f69e4dfca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S/P', NULL, 'P PETITE', NULL, '155/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('14a28137-7eed-47cc-8fd8-b60e165569ca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0/25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14a990e9-bb82-4430-ab71-ce298152774e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14ba060a-cf9e-4bcb-83bf-866654031743', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14bf0419-c921-4c25-89f4-65d0592cf1b4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXLREG', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14c3d0d7-1f7b-4cc4-b7eb-7817a604520c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '34 TALL', NULL, '34 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('14ccb71b-554f-4d34-a77f-b17f627a04ba', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '42 X 32', NULL, '42 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('14d23206-c8b3-4803-bcbe-c70040385377', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14d508e7-c51f-4f74-a9ac-b51bd5babc49', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32X32', NULL, NULL, NULL, '175/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('14e55238-d71b-4273-88e1-3732e3aa3fd3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '29P', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('14e7189f-5c18-4b7f-a01e-01101f7de127', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14e75e74-6fa6-4074-bc21-d11d4a97bd54', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'L16-16 1/2', NULL, 'G 16-16 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('14fd4553-0d90-4a53-b2c6-bcd7e5ea86a1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12L', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1500a75f-8e3f-409d-8309-7297cf538b9c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXSSLIM', NULL, 'TTTP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15026167-f805-4585-8fb9-fb2ef9db3fe6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('150554d6-693c-432a-b226-d3931267b692', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-34c3-4e5c-11e6de75cf25', 'OldNavy', '3X', NULL, '3X TAILLE FORTE', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1509f241-26d4-458a-bf3a-c868fe65ff46', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('151280e7-b1d8-4fe1-96cf-923cb4d1306b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8TALL', NULL, '8 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1514d023-5a2a-4891-8523-d5374ea23d65', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('151d0e9e-8094-4e8a-bdef-aa214e185dde', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'MP', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1520d6bf-558e-40f6-b5b7-09ff84a47b30', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 / 34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('152f685d-b477-402a-985a-87aa27ac6843', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5 SLIM', NULL, '5 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1534b961-2028-46bd-9264-0b22686bc5b4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'L SLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15396977-9052-4e66-900f-ec74e10b559c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('153c6eaf-c4a8-456b-a8ef-cb6d41ad48b9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X 30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15537ecf-eb3f-4737-a56f-05ba7c9dd04f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1556a44b-edfa-46b2-b76d-ac07977bc55e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1565c926-54bb-4027-85f7-fc8c194f2556', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35/20 Petite', NULL, '35/20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('15702ba2-ce21-42ac-a0cc-e029bdfb929b', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '3-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('157d3d03-c1be-4c50-a779-4af51796fd0a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X 36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1580b4bb-eb9b-4588-914f-c6fa8c01c828', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15829b9a-2409-4402-9ba2-f7eacc8e8338', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '14 TALL', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('158d5bda-b6cd-4026-88e5-14178dea8558', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-f595-0bad-a02861647b77', 'OldNavy', 'M', NULL, NULL, NULL, '195/74', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15994c35-5067-434b-8231-d0cbb70d0cc2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('159d9896-9182-4fc8-b23d-f89552707bde', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '32 TALL', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('15a27b2e-0ccd-47f3-a27a-ce061a963856', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42X36', NULL, NULL, NULL, '185/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15af72fb-217f-4512-94d6-c2e5c020ff46', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '31 X 36', NULL, '31 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('15b3760d-9772-42e8-94f3-db28eebc80fe', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '20 TALL', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('15b3845e-0951-4138-b752-eceeaa6868ec', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('15ba1cb1-bb2b-44cb-b674-3aa7755e4e14', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'SREG', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15c88ccb-12dd-44b4-9931-379bf0bec2b6', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '29X34', NULL, NULL, NULL, '180/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15cdca75-1756-4f9c-862a-4eacca2b1660', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 LONG', NULL, '00/24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15e90dde-5918-42d3-89f9-213c6a626180', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S', NULL, 'P', NULL, '170/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15ee3e56-70e2-40f9-944b-ec2240a4aa8a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16 REG', NULL, '16', NULL, '170/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('15fc56e9-35ae-4485-a394-0e382e933b0f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 TALL', NULL, '14/32 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('15fcbb36-3e61-4319-becc-1974998e2baa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16097270-888f-4fb0-975b-80186400c395', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('160d36af-0c0e-4336-94ec-b578958635fc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('160f9523-e6de-4a5d-8ecc-06ebd76b7895', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0TALL', NULL, '0 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16151c79-08cf-46d1-ab1f-abb480509cea', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '29 X 30', NULL, '29 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('161762c7-08b0-4aa3-9557-5966b8f8c5c5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('161b6a20-ad5a-4ab0-92cb-1f12217a1d8b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4 REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('161e6311-20ec-429b-9b60-3fe1917bc3d0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('162965ae-2338-484a-8f21-2c2d755055c2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16338569-8739-4307-8fdc-efba02c2a410', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X32', NULL, '32X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16342e5e-9e29-42e5-8f05-092c7e126d36', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XXS TALL', NULL, 'XXS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1637aa97-c360-4890-b294-639c5c745097', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'L', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('163ebce1-0800-4980-953b-0917f40034da', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-a48d-93be-70b1603b5160', 'OldNavy', 'XL/XXL', NULL, 'TG-TTG', NULL, '116 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1648eade-f9da-4086-8ce7-5fcb1d7577fc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '30 Short', NULL, '30 Short', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('16527e09-5f6f-4f98-a086-f237bf5a32ba', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16542875-93c5-4d64-a31f-ef37bf78ef7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '4', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1666694d-5ada-4453-8a02-1f6955881ebd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL REG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('167dfbac-42d8-4767-9efc-d438e7882e14', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1689ad87-8b2a-452a-97bd-a49368453adb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('16966b18-b53f-452f-8437-05029bbad361', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16ab743c-9bf4-4b8f-acbd-de826d8ecdd8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16b31b86-155d-46b4-acd4-86d2bd593e7c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('16b98c7e-a1c8-45b9-8ff8-09bad7a31c1b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('16ba32cd-c024-4f01-9a8a-e61648eb48eb', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '165/115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('16c98251-d7b2-40b3-958e-4487d042849d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', 'L', NULL, 'G (10-11)', NULL, '290/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('16d28646-a065-4649-bfda-048fc763eb8b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-f595-0bad-a02861647b77', 'OldNavy', 'S', NULL, 'P (11-12)', NULL, '180/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('16d2f4ba-da61-4817-a4e7-517d04eb0a8e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'SHUSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16dafeb3-3f17-447e-9be1-e91bf147ff57', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27REGULAR', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16e27bb5-f7e3-463d-9fa4-b916966dce63', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('16f95e45-9c80-4077-8a69-639364c67a4d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X36', NULL, '32X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('170c01e3-b6d6-4f5a-b613-817742ef17f1', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S', NULL, 'P (6-7)', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1713dab3-d37f-4e49-99e7-c9408e78fd39', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1717dd71-976c-4a6f-bfeb-9cad5ec59ccc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1723a124-1d39-42cc-a152-944616fcb8f1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXXL', NULL, 'TTTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1728f6f5-6337-4796-878b-b33c2b2a01d6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1734889a-910e-4f56-8799-b0ffef3f9972', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/120C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1739fbd6-d377-4e21-b4f8-9235740860fb', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1747df79-c78c-4980-84f7-20dbb0e98a49', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X30', NULL, '35X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1756950e-73c1-4da1-8792-172d925bffdb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'XXL 18-18 1/2 36"', NULL, 'XXL/TTG 18-18 1/2 36"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('176e9ad9-0dab-436f-b9f6-946778deebb1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40C', NULL, NULL, NULL, 'C95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('177697ee-3532-4aad-a7e4-308dec3f1d09', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '37', NULL, '37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('177933df-7b0d-4584-bc5c-0f223109b9e4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '34 TALL', NULL, '34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('177a97ed-e63a-4aa1-a405-27f7659ca8d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000T', NULL, '000/23 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('177c0863-e456-4380-937f-3446e701ad78', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'SREGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('177d5505-bc97-4484-b859-2563ad761d04', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS/T', NULL, 'TP  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('17874836-e536-463a-b50c-eab9726b9cc6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '16 x 34/35 = L', NULL, '16 x 34/35 = G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1791c930-da2d-4c8c-87ae-0e782ca56f9c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, '130/53 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('179693f0-507a-490a-8b9b-bb3a7e0d0c46', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('179f7d3d-24dd-4588-9c44-96f0b15dcb07', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '36 TALL', NULL, '36 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('17a133cc-40af-4c7b-bfa5-4794742ddb01', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('17bdb617-7433-4576-9abf-85e40d86437f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32J REG', NULL, '14/32 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('17bebf29-2899-4831-a04b-4f98c778375a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XLXSHRT', NULL, 'TG PETITE', NULL, '165/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('17c6af84-a3a9-49b4-a4a1-214c33034f15', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4 HSKY', NULL, '4 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('17cf42da-c080-4c9a-a2a8-1957cb2f91f2', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('17f7dfe7-be58-4abc-b3ce-5662524df311', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6c2b-8bdf-fed3dc8214fb', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('17fc1312-3b2e-46d7-8bda-d94ef3cc4c34', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('180012d0-7fbe-4c64-9dc8-ccf1e7e7f0f3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00SHORT', NULL, '00 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1803543b-137b-4734-8530-e02d5d7ad266', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1805637b-9ae1-41eb-9c97-c4c19b287b88', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '26 PETITE', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('181fd06e-2e77-430d-927e-f2963ed8cf72', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18206b03-bd94-45f3-b2d5-22666beccdc4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1827e343-801a-41aa-960f-bc976b36de15', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14P', NULL, NULL, NULL, '160/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1832a73f-c3c1-4045-ab31-4cc32fbf0689', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 /28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('183541ec-5da9-40a0-b614-47f10f8eafe3', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '5YRS', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1839e271-cb88-461a-bc75-53fccff36f47', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '33L', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('183bf886-b732-421f-9ef4-2fd77ab93364', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '25 P', NULL, '25 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('183d51c4-c7ed-4379-a933-4f14da7479cc', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-f5e6-b8df-22b25d9170e2', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '54-58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('184aad8e-70e4-4c12-80fd-49c7c42c5916', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18520800-584f-4e33-9140-aaba4cb4e290', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS HUSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18606e88-433d-4c05-b654-6a3a34ade103', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18614c19-2f5a-450a-bebd-1d91991e9c32', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12SHORT', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('186532b4-e2f2-44af-a76c-20af079a913a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('18661bd1-99a2-4b99-8089-c9fdd4b508c8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '7 ', NULL, '7 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('187d3463-5b0e-4842-a90d-1fc5cbe051fe', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-a57d-b650-4f26ecffc811', 'OldNavy', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('187dfc92-c69e-4980-9df9-fe62f7f92c77', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20 / 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18818345-1913-422a-b7c8-a171cdb0c58f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '31 X 28', NULL, '31 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1888472f-b24a-456b-8046-05ae1b0e4149', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '23/000', NULL, '23/000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('18ae2f09-7ba4-4f84-9535-f1d9548be9a1', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'L REG', NULL, 'G (10-12)', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('18b9c7f6-f4b4-4a22-8c74-75912d25c212', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16 SLIM', NULL, '16 ÉTROIT', NULL, '160/66 - 14岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('18bb1119-472f-41e0-8a3f-74b76a4da2af', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'L TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('18c2dbe1-6389-4eec-b183-30a6f1fbed2b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18d60efc-29de-4d41-98bc-46197f583bc8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('18d9bdf3-8c72-4206-9f0d-0c8ee09e89ad', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/ 28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1904fb71-500f-4dc2-8e63-c45414f5f5d6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '32 PETITE', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('190904e3-ae94-47ce-af15-15551d3f79b8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 / 30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('193aa905-6222-446b-a72e-c1f0ab2cb976', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-2772-0f83-1ae9ec1022cd', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('193d56ca-39b7-4644-8504-2b3d0b7db549', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19448588-ef6a-4f46-aa3c-7285fb128144', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1949666f-6958-4b16-abbf-588b937a940e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1954aebe-8573-4dfd-8381-daf8040b4432', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '6YRS', NULL, '6 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1956bc95-f9d4-4de7-b424-649315b839cf', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '14 TALL', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1969ad2c-cbe9-42c7-95a1-9d66ff0ec6e8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '8', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('196be72d-d7c2-4bf9-b3d5-0e65e11d0573', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40 SHORT', NULL, '40 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1982f289-aef9-4364-a3f3-3ae3a0fd8462', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-f429-f86f-6638328ea66d', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '54-58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1986d5b6-3678-4959-9722-670c33ee39f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 REG', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1995a4f6-5dd4-48f4-9f0d-49212b45a823', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('19a1482f-60b1-47d4-819f-449752dec9f6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16+SHRT', NULL, '16 TAILLE FORTE COURT', NULL, '155/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('19a204f0-786d-4f82-95a3-5e2a63d39a8e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('19b445d3-e94f-486f-82a7-ff65d287a062', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '30 X 30', NULL, '30 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('19bc45f6-21e7-4ee7-9f5d-a423f4b53453', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '10', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('19c10ab5-2d11-4665-9771-c398c8dc0a45', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 SHORT', NULL, '16/33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19c28484-d21d-4453-a686-c92d16571f6e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16HUSKY', NULL, '16 TAILLE FORTE', NULL, '165/78 - 14 岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('19c80bd7-58e1-4870-9f0e-e276329d4359', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M HUSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19ca4aa8-5b98-4132-b06e-51e36262ec05', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 SHORT', NULL, '6 COURT', NULL, '155/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('19cfb866-7177-478e-b5ab-a3dd55280a39', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19d06c8a-ed36-4933-bf77-a8c4866adabd', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5+', NULL, '5 TAILLE FORTE', NULL, '110/65 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('19dafe8b-f151-4e9a-9693-ca57e796235b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35LONG', NULL, '20/35 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19e2c27f-59d1-475b-af66-503d848dc206', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S SLIM', NULL, 'P (6) ÉTROIT', NULL, '120/50 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('19e328b5-351f-4772-bad3-5f3e4df531fb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '30 X 32', NULL, '30 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('19e4b10c-3bc6-4813-9c91-301a6c5fd871', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '35/20', NULL, '35/20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('19e72031-fbc4-45fc-a7ec-78a2450f19f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS P', NULL, 'TTTP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19f53fbd-ded7-4e40-bf0e-98ba1b72225c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7 SLIM', NULL, '7 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('19f59edd-973c-4795-bcc4-8b9ba6add62e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1a164648-3d62-4104-b69f-0c26bf62cc12', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL HUSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1a1f8650-9074-4d94-bfe8-ac24a8cabcd0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1a2f08b5-676e-4e14-8505-1a3127557380', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '31X30', NULL, NULL, NULL, '170/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1a402b8e-ae1b-4a11-958d-6a9692d8330e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1a43ee1c-1c70-4080-b141-f57dd0924c72', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1a59ef21-a455-4090-8467-1f57782cda8a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1a5af049-8887-4844-86d5-e17808383bb5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '36 TALL', NULL, '36 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1a5f4861-8076-4811-ac3b-3907dde9b67c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1a65a58b-679d-493f-94cc-4da803b5324e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 /30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1a7336b8-2808-4b3e-a6ac-1a3dda9b9976', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXSP', NULL, 'TTTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1a739b15-8683-4de7-8471-966bdb69b92c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L/T', NULL, 'G/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1a7ce0f9-2cc1-4c51-b65a-3439530b113e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'L', NULL, 'G', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1a9affac-206b-4214-a5d3-7f939dc0f682', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('1aa8138f-4a5f-4b0f-b8a5-0e649c722225', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '8 PETITE', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1aab6c94-9bbe-4608-9c0f-4c6947dd00ac', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ab2f61b-656d-425f-82ab-4f584b173d25', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L', NULL, 'G', NULL, '175/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1ac10171-c6dc-4514-9863-7d1902c1f848', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20 TALL', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1acaf6fc-03ec-4f55-a840-baa288906e79', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'L HUSKY', NULL, 'G (10-12) TAILLE FORTE', NULL, '140/76 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1ad517e0-1620-444e-97ab-42ef5d9d3fb0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '12', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1ad6802d-702b-4bed-9bf1-b30815fb38dd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1aea24cd-412f-494b-a9c3-356aa5e31f28', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1af70a4a-9d0a-4db2-a494-14792fbc7a08', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32', NULL, NULL, NULL, '175/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1b1d4144-6584-426c-9d13-893268e3f6b7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34/18', NULL, '34/18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1b237fc5-ac53-4572-8ed7-be01976ac198', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1b329e51-0ccf-4ae8-94d6-fe3059a70074', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000TALL', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1b52dc54-100f-4aa9-973a-b7580dbc5f64', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34S TALL', NULL, '34C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1b55c1e9-9727-4389-b844-75b95dc52b86', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Gap', '40', NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1b64df88-ed84-4d53-b325-0f9ca00a4471', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000X23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1b6927d0-cbd3-466b-b72e-03979ed632e7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '12 PETITE', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1b7555e7-0bd2-4e1b-8a66-d4a5b773fcde', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 /35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1b85430f-de7a-4d28-8b78-e2e41a4f1956', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1bb4e7c8-6c42-44d2-81d6-22dff605fa36', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S/T', NULL, 'P GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1bbd6428-f8c2-48dd-9543-7b256ef3a5aa', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 SHORT', NULL, '8 COURT', NULL, '160/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1bbea76c-a7ae-4631-babe-b3d8ee921437', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8PETIT', NULL, NULL, NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1bc97c6c-6dcb-47fb-9962-39baf85c9a65', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'LREGULAR', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1bd0c5b1-09df-4b51-8bb4-b6fb5f7f7723', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1bdd7145-eeee-4ef8-8776-e2965ba4b5e8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20', NULL, '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1be0739f-b3a8-41e7-88d1-7faf2a751d5f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '29P', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1be50ea9-8796-4551-addf-c8f3d9d82783', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1beff955-c1d1-4ce8-8b12-573b5a4fec7c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L REGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1bf0208b-ee30-415f-9996-1597400bd63b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e943-0e10-fa44023e6216', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1bfd0dca-7b52-41d4-b4ae-5af4ef567743', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '29 PETITE', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1c04af94-507e-46b1-a83e-52aaedb9b80c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXXL', NULL, 'TTTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c09320d-4550-4d62-b35d-3659cbe96c07', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20+LONG', NULL, '20 TAILLE FORTE LONG', NULL, '170/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c0bb900-4731-456b-ac47-e70bc6f66d87', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS/T', NULL, 'TP GRAND', NULL, '165/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c0e6901-9e54-46d9-8a5b-5458c720f7d5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 SHORT', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c1ad4b7-69fd-464b-afba-52eb4137637e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bfa1-05a3-b0d0a7835e54', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c206450-ef0e-4136-ab0b-ea5041777654', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 /28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c21efb6-0d83-4eca-8270-294f54c31e41', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S', NULL, 'P', NULL, '160/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c321362-3c1a-4aa0-8dae-ee40850e2e24', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00TALL', NULL, '00 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c33ed25-c136-481c-be3c-eee8d6a72349', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L/P', NULL, 'G PETITE', NULL, '160/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c3947ae-701d-4ced-98b6-68b35d6103c7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '31 P', NULL, '31 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1c49a064-7b82-40eb-aedc-0206969b5335', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4', NULL, NULL, NULL, '160/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c5a8559-34f7-45bb-8c93-9046a0cc1390', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 TALL', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c5bfab6-235e-47fe-8c80-8f3b4fd9ec59', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6 /28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c7073ed-e4f7-43cd-89d8-40c9a9d5abc2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 LONG', NULL, '20/35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c714f9c-5427-441b-a987-40f23067352b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c72fc82-a8a3-4961-9f50-18f66258e5bd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32DD', NULL, '32DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c7788c2-01bd-4801-adfa-a810b8f87c66', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X 32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1c88a829-6c4b-4de3-9fe6-f64e6d95eedf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '3X', NULL, '3X TAILLE FORTE', NULL, '165/150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1c9f49ce-3dd3-4c73-bb76-d39adccaf098', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1ca8b77d-c2c3-4a3a-a85c-61755ea6a222', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12', NULL, '12', NULL, '145/64 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1cac0a4a-f8d4-4248-a57e-a700b6559009', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M P', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1cb12622-2129-43b5-9d93-519dc446efd7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8 +', NULL, '8 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1cb5b8c7-a665-48f2-b5af-0f8ad515c471', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XSHUSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1cbbba9e-06b9-4de0-8927-d939f6a17808', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1ccd9d4d-8735-4044-8ebb-72977f4c072c', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1cd1d961-b53d-45c7-a86f-e33acdbb05a1', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M+', NULL, 'M (8) TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1cd1dd91-da8d-4d1a-8cea-a3cef8bc8ee0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S P', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1cdc9431-e1e4-4752-9e83-b474f3e2f93f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1ceab85e-672c-4b5b-b13b-bc768e3d597d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XSHUSKY', NULL, 'TP (5) TAILLE FORTE', NULL, '110/64 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1d20369d-c987-4b32-a5cb-37abba662b03', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'L/T', NULL, 'G/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1d23f720-058c-49d2-b650-f695b304d291', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/ 30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1d29b9e5-45a1-4dfd-874f-ba42912b5853', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1d2ae7ac-907b-4f68-8a55-7517c3f1031a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '28P', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1d3a5661-b400-44ce-926f-1949d3cd6f71', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8 REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1d3df48f-f86a-48f2-8cd2-53c65c9a06ed', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1d5898f2-bab1-4f32-9c46-6029340c109c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28 X 36', NULL, '28 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1d5ef015-af87-47fb-9101-2c4c7b95b8ee', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'ONE SIZE ', NULL, 'TAILLE UNIQUE ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1d743f6a-189d-4efb-b427-bb855d0337ca', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1d76823b-cfe7-4237-b966-a23373a45d0e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '22+', NULL, '22 TAILLE FORTE', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1d86eecf-f6ea-43ad-aaa7-4b5230c80785', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS T', NULL, 'TP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1d87d621-8619-497f-917a-84803da00165', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '26 P', NULL, '26 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1da1c8a1-12e5-4463-a998-6701fb2061a1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10', NULL, NULL, NULL, '165/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1db23bee-8fc9-4f66-ae73-02f90e3f06d3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1dc7c30f-e0ec-4d79-8fb3-59499a10185b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-0e9d-e7cb-83bcdbfa9dfd', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ddf7a43-db99-45c6-a3c7-c8beb337d828', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XLREGULAR', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1de0b21f-8b3c-4f4c-8d49-371007df7bc7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L REG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1de72545-82fb-4465-b470-19a9f565ddaa', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', 'UP TO 7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1df8a25e-b7fb-4920-a45b-f8739730d6ef', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '29/8 Petite', NULL, '29/8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1df8dfd1-09f8-4ecf-9993-da8c006ef5f3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e033508-feca-42ca-877f-9d86f15dcbca', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '26S', NULL, '26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1e0f4583-f883-491b-9eaf-fca159815836', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e17e90c-364d-4dea-b5a2-6be8b9820dd6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31 S', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e1c028b-4476-4077-bcb2-84bce60c9ab9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16 T', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e206195-e4be-449c-8910-136c6cae9f14', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1e248222-dc0f-41d1-836d-10f2a32a67ab', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL', NULL, 'TG', NULL, '180/104A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1e2a9582-dea6-42e3-bb81-6f83e15e4fea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14 T', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e2cecb8-447d-4ebd-b9ca-9390fd6f7b64', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'S P', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1e3b69bb-12b6-4219-84af-993ae5982133', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e455b1a-dd1e-44eb-9a14-8ea698968c05', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12X 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e501710-a635-48ad-8b43-f175655dcafb', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', 'M', NULL, NULL, NULL, '250/81', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1e7003bb-3b0c-472a-809d-e5e315218a27', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1e70c1a3-8e63-42dc-bc5b-c9204ed0e760', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1X', NULL, '1X TAILLE FORTE', NULL, '160/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1e71c071-92e7-418c-bef4-a57b4dc8eead', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '2T-3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1e82e1b0-bc2c-4199-be37-29254f559426', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '12', NULL, NULL, NULL, '165/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1e834209-a538-4541-beac-2d7f409e25b9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8L', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1e849c6c-8db2-4a25-9795-06d25742bfd6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('1ea4e235-46a7-464b-9003-cc005485845b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X 30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ea4e31e-1a1d-4917-a0e5-50ff190d2a7f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '42 TALL', NULL, '42 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1ea4eb42-7a11-4603-9a6e-7b756ce2743d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1ead501b-6e0e-4fb3-9106-cb5daf510510', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X 32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ec34fad-5d4f-4e7a-9d02-7a9bd66234c0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ec6a58d-b5f5-4de5-8eea-4568b5a1413e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ed09d36-582b-4290-a969-c4c5decafa39', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/ 32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1eedb34c-8fca-4c17-8981-b86d597d2dfb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-fbb7-e51c-c71e8847e2c7', 'Gap', 'L', NULL, 'G (10-11)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1eefaffd-f032-45f4-9a23-d984ec683d72', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1ef3058a-be74-4c76-aabb-01742e7d43f0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '165/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1ef4c426-3923-48d7-aac8-f6e0260e5007', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XL+', NULL, 'TG (12) TAILLE FORTE', NULL, '145/80 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1efd25af-6d8b-4fe8-b7d4-3ebfac250bd2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'M REG', NULL, 'M Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f00f5af-40db-47a5-bcab-5de91c4b9d27', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('1f01beab-75ac-4f8b-a4e5-56f31106e790', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S REG', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f056607-459f-45d0-b5dc-919f0a944ec8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1f08ffe8-7f84-4b71-a29f-83473afa8b8a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS PLUS', NULL, 'TTTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f0d0e56-7b42-4676-9286-972f3aa03368', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'L', NULL, 'G', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f1d5291-c2f9-4682-ad55-f070ea119cd9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '28 PETITE', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1f2b9ba2-9d43-4005-b550-47eb91346a5f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '23 SHORT', NULL, '23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1f2bbb7d-2d90-417e-9aa8-462c8de98071', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f3ac1ba-0670-4def-ad3a-04125ba787bd', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16 LONG', NULL, NULL, NULL, '175/112C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f3b0114-f3c9-429c-8f1d-d19583ab3329', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1f3c2b6c-db98-4ce1-8d65-c3dc43d2a07e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'MPLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f3dc3a7-a374-4fa3-a960-910e8be44016', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S Reg', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f3fdb35-af7f-4f6b-bcca-f698e8c5b7f9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f453615-ac04-4318-8cbf-98faabf74e21', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1f4bb6df-af5b-45cc-b518-2c390884a1e9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXSREG', NULL, 'TTP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f582b3d-3c9f-4103-8140-1d1780930bff', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '33 PETITE', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1f79ebd7-8004-45ce-b0e4-fb1f16ac207b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1f7b949c-3efa-4c97-8a57-6c9edeac84ea', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1f7ccb9d-9062-4229-87ae-734eb2e9ca9a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0P', NULL, NULL, NULL, '150/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f7d7e50-cc8f-4daf-b6b9-f7b2535d8501', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '3-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f7e3f36-a893-4603-af27-af52ab125427', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26LONG', NULL, '2/26 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1f8cf8ce-5f10-4a8c-9f79-850f76e58c6e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '16 x 32/33', NULL, '16 x 32/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1f95462d-2a00-476e-9ff3-cd3a6adf61ef', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL-XXL TALL', NULL, 'TG-TTG GRAND', NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f9b0392-e459-4f85-83e6-6d6f35315aac', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-fb14-766d-bfe8b62a60ba', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '***', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1f9f777b-d005-4b78-9bc0-4b17df4e4c2c', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12', NULL, '12', NULL, '165/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1fa987e8-35ba-45d0-9ef7-7820b68256e8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1fc09f9c-9a46-4825-95d6-942349f20d5a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12/31', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fc0de4a-cd8e-4a33-9e40-0e03da29616f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '33 TALL', NULL, '33 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('1fc9f52f-c6bd-40f8-8354-453d339df8bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fcbd3ee-e2b1-4de9-876b-92ce74930cb5', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S', NULL, 'P (6-7)', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1fcc1cd1-b607-48de-b317-fa9bc8ae50b9', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '4', NULL, NULL, NULL, '160/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1fd03556-99b7-4afe-ac55-f12275de23dd', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '33 P', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1fd04b41-3ce9-466e-98a5-82208aa089b6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL/P', NULL, 'TTTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fd0f828-0d16-4c0a-b768-3dde95a358ea', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fd1114e-a5a1-4e28-9326-3ca267a84e92', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '42 X 36', NULL, '42 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('1fd1660a-8b9e-4ce8-9300-ba5034b3e2ea', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6 REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fd6b022-dc7f-4447-9c79-6e0b94845e37', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0PETIT', NULL, NULL, NULL, '155/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1fe14f8b-fc9a-4f06-845c-c99d8cc1ab69', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fe37f2b-23cf-412d-ab7e-480be1051f09', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7', NULL, '7', NULL, '130/62 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('1fe5a76d-3b41-4f6d-b0a3-60c1b281f241', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00P', NULL, '00/24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1ffa541f-ec73-4baf-a8ba-9fda68caf7f8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL REGULAR', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('1fffb92c-b1bd-46bd-94a1-c154d3e6e774', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-43ba-4d32-d4765755b21f', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('200f5df2-6cdf-4614-9476-de5b1eb9eb60', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 SHORT', NULL, '18/34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20115789-8e2e-4db5-aaf8-799b78fde154', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14', NULL, '14', NULL, '150/67 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2011cf55-5574-40e3-99f6-30ca7ccb404a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8 SLIM', NULL, '8 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('201bfcc8-e139-488a-a205-148dc3afcc96', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '28/6 Long', NULL, '28/6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('202d632c-3b02-448c-8900-880696dc677f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('20645c58-cca6-4dd6-b60e-e1feb89babb0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30 P', NULL, '30 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2065a797-6bac-4cd8-ac9e-ee15c436c4a8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2070ebf5-83cf-49bb-a541-6c1ba19a5e5c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8 T', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20809369-e745-4392-9264-3d7fc8c3c890', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18', NULL, NULL, NULL, '170/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('208c8559-360c-4091-b0a2-0af0056b287c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '27L', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2097de2e-9e1f-4011-9100-4628e64447f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('209f3d7e-7046-4813-931c-3af554c09d09', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('209f91ac-1759-4b13-a148-9a0c496940d2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XS Reg', NULL, 'TP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20b079bf-6025-4cf5-88e8-cdc99ec299a1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20baf2ad-cd80-4daa-a080-67d0046e70aa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Gap', '36', NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20c018ac-5244-48a2-94c2-0849acb26130', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23P', NULL, '000/23 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20c7f272-493d-4223-9e23-c9355e62723b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X34', NULL, '32X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20d15162-7b0b-4514-a6ed-9f4d37e3bd43', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('20d6f3ba-a28a-446c-bc34-b728b976a167', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('20ec8cbd-f726-4914-8177-086f155ec56c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('20ee862a-eb20-4d5c-b6fb-536e75bee6c8', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('211fa00e-a16b-4ea4-8759-9ee6a7c0b1ee', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('21201ec6-4aab-44a1-b0ca-55d45d0fcc89', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'M-L (13-15)', NULL, 'M-G (13-15)', NULL, '19-24 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2122cd46-817d-4869-bb4a-6627c6bf4b60', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L HUSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21246d21-9b4c-40b2-8022-d5fdd474ea26', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '29 Short', NULL, '29 Short', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('212c10a7-ae68-4625-a1e3-c113d0b2f905', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('213aff43-47a7-452e-82ca-26622400acf8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/M R', NULL, 'P/M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('213dc00d-6c71-42aa-b27f-e8b273345b6c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('213f4b0c-52e3-400b-8243-f16e027361d9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '25 P', NULL, '25 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2143381c-d7b7-471c-a46d-2425958ed311', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16SHORT', NULL, '16 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21434233-d65c-4f5a-9e07-94d39f85cb19', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '9', NULL, NULL, NULL, '260/83', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2148c37e-99ef-45c6-bd1a-11ad77554167', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18 LONG', NULL, NULL, NULL, '175/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2149cb9d-0ce9-4e4d-84cc-cc7d4a3e60c1', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', 'UPTO7LB', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2150bafa-99aa-4449-9052-88cff985b93a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L/XL P', NULL, 'G/TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2153d326-9cd2-4085-8968-5e7c4c74b62c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2170afcd-95d9-4ab6-b0d7-fb6c87d997ca', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS SLIM', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('217a93c4-2a49-44df-968d-29d898e0c124', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XXS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '1f3f0c2e6b564100a0adb173a7a47d9f', '2024-02-02 10:28:59.577923', NULL, '2024-02-07 10:17:09.781129', '3a0b1093-5411-9e90-9f2e-3c3703ba4870', 'f', NULL, NULL),('217ab64c-3696-4bf5-b068-feb17f03d32c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XXL SLIM', NULL, 'TTG (18) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('217fd23d-a9bb-4ea6-9fea-d677605484c0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16 REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21888b87-273b-4628-aeac-ab7144e2dc44', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('218891b5-952c-48b0-aaef-2ee26a67b7f7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20REG', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('218ff831-36a1-4db3-8f14-5e2d4b671538', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('219709f1-2675-4213-b357-aea368edd3c4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35TALL', NULL, '20/35 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('219af2df-b278-4cdf-a421-5f6c236abda5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '30P', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('21bbad3c-719a-4f4d-9313-a1767619bfc5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22P', NULL, '0000/22 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21c3418e-a2bb-469d-b274-ad9a6df0d9c7', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14', NULL, '14', NULL, '150/69 -14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('21c4ac62-3337-48e8-b595-69b3725e9e39', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21c691d3-91e9-405b-8171-f8b59e029483', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('21c902be-4f1c-4f2f-a436-560dda17a490', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'S/T', NULL, 'P/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('21dd2168-9093-48d3-b940-765117ff1147', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '18 Ankle', NULL, '18 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('21f5ff86-a158-42e5-8fb3-ea110347ea72', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXL', NULL, 'TTTG', NULL, '185/140A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('21fe4b02-fd4d-49ff-83f7-e561480e862c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '6 PETITE', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('22063808-0245-479d-8fab-08a9578b09bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2208832a-1f6a-4c4e-aa95-26043e7cde4a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M PLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22118039-f59e-4e6f-96db-4beea9979025', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('221652ab-7e8d-475a-a180-fee2c62247cd', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('222c7f74-7ec5-47e6-a6b1-38f3a3c88e45', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('222e71ca-88e3-4b2c-90ed-a769d85a50df', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2246424b-9558-49da-b0ad-7b273ba2c7fe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('224c85b4-8f16-4232-8cb9-d90db18483f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22526364-a1af-49f2-a3f0-19767fc8a764', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '26 TALL', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2252b587-3f04-4621-a2a3-aa9ea015d1a6', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-a9e0-c5bf-9be9c8037172', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2256d1d7-957e-43d8-b18c-417bda492edd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'LP', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('226b3c0f-5f36-46dd-9ad5-89da80ad72ba', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'MSLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2272223d-ad2a-421a-84ec-2cefe47301af', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2/ 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22785da1-a958-4812-a749-32d21979b06b', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '0', NULL, NULL, NULL, '160/80C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('228e94f9-cbaf-4017-b69d-8cc5f21de7cf', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('22927a6e-4063-4efd-a8af-a32375b966f6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30 REG', NULL, '30', NULL, '170/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2298b68f-fca7-4d86-818b-e5e8e0b09f87', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '4YRS', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('229c6f97-d20b-4c23-aea2-6c69aab05331', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20 T', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22a6fb24-b86b-4cea-952c-85bf0b7829f6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('22acdd2a-0c37-4322-8ce9-242489cc5060', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 LONG', NULL, NULL, NULL, '165/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('22af486f-09b9-4e57-92f1-21254eb450c9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'LP', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22b9eed9-8626-4d89-9a85-7c1981735b41', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0df0-ca33-6fa4848dbade', 'BananaRepublicFactoryStore', 'X/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('22bd4a01-dfa2-4d4c-89f2-e8243e4128b2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6X28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22bea294-534f-4f84-843f-3cc996a111e3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25 SHORT', NULL, '0/25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22c6bf63-c8c1-42f4-a4c1-71bae2c70077', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X 36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22c833d7-8b37-4290-9c5e-fd803c9156f1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '38', NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22c9ff9a-db2d-4b83-a1e1-f78946054e94', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8 PLUS', NULL, '8 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22cd7c16-1cf9-4ca1-a2c4-bfc52053877c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 DD', NULL, '36DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22d7c806-ac36-4193-a99f-5dd4a81355f8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '24 TALL', NULL, '24 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('22e5ff88-1c7e-4c79-a7b6-c87b9146c76e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X 28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('22ecbf6d-3b2c-4554-af4c-ba26c68b19ea', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28/6', NULL, '28/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('22ef21c5-ab68-4b8f-8e4d-a42c7278d6e7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L REGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2305300d-aee7-4e31-bfe5-723bc87cd929', '3a106a3e-aa0f-67e0-6f2b-1dd310b05df3', '3a106a3e-aa62-d73a-003a-ed15d2119ffd', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '80 - 110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('23056d3b-bf8d-4ceb-a051-fb1f100c6a34', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-5b44-e938-a3c489e62f62', 'OldNavy', 'S/M', NULL, 'P-M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2307120e-9444-4c77-a7c2-9ff97fd45709', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2307686f-ad58-4917-acfc-f8086a1286ea', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('233cf558-dbb0-4a4c-8a72-d1b0f7b2412a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12 SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2342b8d7-deb2-4c88-a62d-66db7ed69370', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '36 Short', NULL, '36 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2343d8a9-01ea-4a9f-9d7b-7bfd31cb8000', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '12-24M-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('23540de5-c4c1-41ba-86d3-d750c055d9f2', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16 SLIM', NULL, '16 ÉTROIT', NULL, '160/61 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('23655a82-df85-4316-8eaf-95a394ec3837', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XSXSHRT', NULL, 'TP PETITE', NULL, '155/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2370ad72-92eb-497a-8ece-6363082e3102', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('237961dc-ca33-493b-b5b5-ea6921627cfe', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8', NULL, '8', NULL, '130/59 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('237b82f9-66ed-4d31-b7dc-4b3c248d74f4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12 MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23995a2f-d0cf-4b27-8616-a151954c15bf', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '28 Regular', NULL, '28 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('239b1c19-7ffd-4bd8-81fa-e9fd7afef68a', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('239da1d9-0c58-4e53-a1db-745278e17d3d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23a188ec-453e-4b30-ae4d-0cdde0ea06bc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 P', NULL, '14/32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23b0ca14-4669-46e9-b91f-c2e1cdf29432', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 A', NULL, '32A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23b8d40e-7c8d-4824-bfd5-d5b4487f20a5', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('23c6e4f1-11a0-4c7f-965b-67a586670207', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('23e74910-d8db-40d8-b266-4b4afbd268c5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublicFactoryStore', 'NOT IN RANGE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('23f1a451-faf7-40bd-831d-8650d13a3e06', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 TALL', NULL, '000/23 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23f29784-ef5d-4f9a-8677-f25d6b00b61b', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublic', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('23f7a0c0-13c5-4faf-bdc6-66385fa1c8d7', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '8', NULL, NULL, NULL, '150/65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('23f80b83-6217-443e-8d96-03145fbbe8df', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X 29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('23fb6b54-0420-4ce7-85e7-34f510e3e786', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2405440d-ebb4-4b0c-93e0-3a0aa579f654', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '38 X 36', NULL, '38 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2406307b-88cb-4acb-9e0d-8a84fc7405cc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('241549b5-9f0b-4953-b60d-324cb33a80b8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('241771c5-4a98-4537-b5e9-c23d69cc2dd9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('241cca06-7dfc-46bd-8a20-771f4795fde4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26T', NULL, '2/26 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24255fbe-f5a4-4ce0-9086-965f070cd19f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23T', NULL, '000/23 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2429d768-e167-4728-912c-4286d562bd75', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4 LONG', NULL, '4/27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('242d3f72-e6c7-4f04-a9f0-e068f6a92b3b', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24365f8a-3036-4034-ad34-4ec421254a15', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '26P', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2439ca20-7ceb-49c7-a4af-ec735d73a163', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'S HSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24496f1a-d5bd-4c4b-93ae-e4728ed66e31', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('2465ebf1-7f1d-4521-a2b1-7e47c08b42cb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('247064fb-aafd-4b5a-bc4a-f039892bd5ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 S', NULL, '10 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24719793-dfc5-4fb5-9f98-a57ed5777b13', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30/10 Regular', NULL, '30/10 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('247869e8-2f9c-4cf6-b801-2588966ef03a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X32', NULL, '40X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('247dc08b-c069-4356-abc4-1adaa8733ef8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'M REGULAR', NULL, 'M Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24b246da-b75c-4c02-946d-017e4ab98235', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '10 SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('24b50858-7083-4b09-8c14-9e6d9f8bb826', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000L', NULL, '0000/22 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24bd7930-f0c4-42d8-ab38-7f4e3a35879e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'XXL (14-16)', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24bef179-f80b-4b20-b2af-87129f92137c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S +', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24d0ecd9-f364-4c8a-9cd1-d4b56c3b8d19', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27 T', NULL, '4/27 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24db834f-056f-4630-bd89-6f57d32ebb47', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('24e88065-f598-43c9-a19d-162de5ba716c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 L', NULL, '10 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24ea9276-1882-46e0-a652-4fd2c50c29e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20X 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('24fdaba3-2e74-43d9-a526-1b3e309a6cf7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '31 SHORT', NULL, '31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('250251b2-0933-4e4e-af33-96efc5b62003', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('250eecd8-cf8d-4a68-b4b1-a92eb5dc3964', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('251773c3-0dff-44f3-9dd0-20aa4ad8995a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XL T', NULL, 'TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('251bc680-932f-4d92-b04d-82e2a558ee3f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Gap', '5 (18-24M)', NULL, '5 (18-24M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('251f9b68-1ef7-4cd3-8ef2-2b0e422f9bcd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25224940-a701-41f1-92bf-66512da85b61', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '31S', NULL, '31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2530839c-e0ec-47d0-bc32-41de8cd4f969', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('253a16a6-1a84-445a-ac3e-940ba6ffe5d8', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44X30', NULL, NULL, NULL, '170/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('253b0c8e-eed9-48b7-b43f-14c9f8ff772a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '6S TALL', NULL, '6C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('25417e26-d400-4655-b2f0-bedd1317e37e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 TALL', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2541e4bc-eae4-4256-b27a-608e104ccb6c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-a657-ef1b-7244c71678eb', 'BananaRepublicFactoryStore', 'One Size', NULL, 'Taille Unique  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2543df19-f115-4db7-8aa3-eb675939aa80', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000 / 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2550c98f-51dc-412c-8c22-b7641d98f915', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '23/000 TALL', NULL, '23/000 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('25575806-aeac-4558-80cc-133ab183be14', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('255a0b8c-d829-481a-9579-786c48a6d0c3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('255b3326-6dba-41a1-ba20-03141b0e31f6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XSHSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('255d889e-578b-48b1-9b71-fc61a7856724', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('25636e30-ea48-4c35-8cc3-c5b436a61da3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-5cef-6463-8b67386d0802', 'OldNavy', 'S/M', NULL, 'P-M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2564c08a-fef6-4012-a39f-7e0b2b900f0e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2579d42a-9c76-4c24-9c17-7e34aca410f7', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '5.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('257b80da-9108-493a-b848-073b6503d0f0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('258d79aa-cdf0-49ab-bdf6-b408c41695f2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-e413-e823-ad5042a060ad', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('259f1950-8194-4a6d-bf7a-cafadb83b32d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XL', NULL, 'TG(38-40)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25a70f5c-6082-4a23-9185-794b9528f586', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10T', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25b0c38a-8ba4-43fc-9bc9-5ee99c89bb61', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '44 LONG', NULL, '44 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('25b11891-af4a-47a2-956f-839019fc45fd', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-a9e0-c5bf-9be9c8037172', 'OldNavy', 'S/M', NULL, 'P-M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('25b6557b-5e5d-49bd-8a58-96cf4522eb45', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25b8ae99-f999-4c3c-92e7-13f1ca26c330', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7REGULAR', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25bb410d-8c4b-4918-b43b-49c2e137dabb', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('25c0b557-b170-4f37-abc5-cc7cf8a9ef9f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XLREG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25e05f0d-5909-4fd0-a5c1-ff921761b602', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S', NULL, 'P', NULL, '170/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('25e082ac-3621-497d-8cd1-52507c451c62', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('25e2b94c-4297-493c-82ec-50e9b5410f35', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25e7294b-57a8-4adf-898b-8fd054aade69', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'MREG', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('25f5de98-9407-458a-bf85-91ac4e690b64', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'TALL', NULL, 'TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('25fe6d38-062a-4f0c-b6f6-07b74d4d0ca2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2602fd7b-91d7-483f-980e-87855299abe2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2608e75f-e040-4125-a0d1-000181589099', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2611c58a-9521-4adf-a7b7-de0b83a41319', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0X25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2618cc71-cac8-4e00-b745-9d54439c213a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 SHORT', NULL, '16 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26202373-1379-4b9f-a027-45c7d51bd96b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '33 PETITE', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('26240160-631a-4141-a627-0cf6b03992e9', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '180/132A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2629e6d0-b04e-4b83-bcbf-958eb6dd387d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29P', NULL, '8/29 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('262e516c-c062-405e-ae29-bd64156892f2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12 HUSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('263b580c-2e3e-45cc-90bd-6a5ab75d214a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '32 X 30', NULL, '32 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('263ba4b8-8914-4c41-9df7-6f842fe5523d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('263f662f-bcd0-4ac9-b8a1-25106378b5b5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2644688b-2825-447b-bf8e-f9f6ea6101c2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S/T', NULL, 'P/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('264f1ea9-8699-4b82-8731-535d32f244a2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 / 34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2657fad5-8fbf-406d-a9eb-81ff7c91569a', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2658f811-4866-4b84-b57e-eb26a746a06a', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2659409c-a1c3-435f-9b49-46641d0f8657', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18T', NULL, '18/34 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26595d98-3248-4f48-8725-bed7a3c4e00f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8XSHORT', NULL, NULL, NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('265bc74b-0b17-43d9-b9ae-4ac86e41d2dc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26J REG', NULL, '2/26 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('265bf1bb-7f7d-4cd5-888c-9d5ceea3a450', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('265fee33-01ab-4cbc-8dee-86cf52867612', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '34 X 34', NULL, '34 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('26697c61-822e-4509-b480-030c62bf6da5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4SHORT', NULL, '4 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('266f05ec-0982-4f08-974f-043aa3883b15', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33J', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2676751a-e616-41a8-926f-c37f6fa1a036', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('267a63e0-a4e4-44c1-9202-9afa2e6b5010', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26846d92-8670-4339-9330-5bf90be3a1da', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18SHORT', NULL, '18 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26906cc7-f58b-41e9-8180-d45c96adf0a0', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2695f0bb-82f7-426b-b173-7ba25a0b74a9', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XXXL', NULL, 'TTTG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('26a42d49-5cda-4a12-9de3-6bcb230c8f62', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '4 TALL', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('26b2a36c-382d-464c-a425-c789db27df99', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'L/XL P', NULL, 'G/TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('26b315ac-8ef6-4796-9f68-15c06d7555b6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28 T', NULL, '6/28 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26be93c0-90a4-4dcb-af18-48494fe2bf09', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL REG', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26e12d27-2ee6-4ee5-a00f-a0f81381d22a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('26e7478f-b40e-4fee-be7b-f2be4a8ca054', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '23 P', NULL, '23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('270e4692-1cde-4935-a808-755e9b68071c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/62 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2715d4d1-5def-461b-96ae-6546e4f9bda7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXSXSRT', NULL, 'TTP PETITE', NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('27229a4c-4192-4393-9fc8-cffc89a73935', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33R', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('272df617-d8dd-43dc-b73c-f594f89482c9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '30 LONG', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2730f301-69be-4a36-a30b-2928d5d41848', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14TALL', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2732fe39-48a5-4c33-8cad-253917ad5cd9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'MREGULAR', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('273922e9-4427-4505-a3cb-d0dfa4507e39', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-c1d4-cbc5-e3c060b978e1', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2742849b-9ace-460b-abd8-03cd6440391f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '18 TALL', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('274629f4-6b64-4cfa-9c70-f4daaacf1953', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27489db9-9f74-48d2-af2b-640c9a91c9da', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-e413-e823-ad5042a060ad', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2753f65d-4415-4a8f-9c2e-e1f9c5db1d8c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27577720-12f0-4885-967f-8228f4dc384a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'M', NULL, 'M fits-shoe-sizes-13-2_M-convient-aux-pointures-13-2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('277dcea8-4cf4-4572-b3af-0b2718807f95', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27844d4e-cc05-4486-b566-450f2fed67a5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10L', NULL, '10/30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('278cfaa5-39c5-4a31-b25b-7fce9b8bad6f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27957101-162b-44ea-8f8e-2e27976cef71', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0/ 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('279a2bdc-38d9-44b5-b895-addfd76e3767', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '12-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('27a1c980-3bf2-4fce-bd66-5a158d3541e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27aca297-debe-4bbf-a948-0611067eb736', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27b0581a-0d3a-45de-bcd1-37ab10258a07', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27b30f47-f2e7-4b3f-b646-ffffba02b7bd', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('27b78e00-1b78-4340-a03f-740c0cbc3758', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27cd775c-76d6-41dc-9d8a-7c359d9fa4ee', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '30 X 32', NULL, '30 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('27de8f4a-7d75-4a13-8240-fdea5e0118eb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '26/2 Long', NULL, '26/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('27ec3380-f7df-46b3-815e-6661370f7811', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12MON', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('27f327d3-f0e5-424a-b1f8-06e24e50d172', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '35 TALL', NULL, '35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('27fe96ae-6a45-448f-a6a8-3da093e7630b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 P', NULL, '4/27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('281f4500-65ac-4388-98e7-8316fa56bec7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('281fd889-dbc3-42ab-ba4f-e8c59849afd0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S T', NULL, 'P  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28236810-bb15-4938-ba81-67b8621da48b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14X 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('286f5529-c14f-4ff7-ac0d-598625dacf68', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28720793-22a9-4360-9316-d25d5fec6769', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('287ff43a-9898-4661-82cc-c7cf273dfb59', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X 34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('288750a8-0bcc-46c5-9407-72f530c10691', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33P', NULL, '16/33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28887fda-93d4-4d39-9800-37f3ef1ac753', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('288c35e0-6e91-4220-b90c-04b6c7eda34d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'XS 15" 34 3/4" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('289bc8ad-3518-43db-b63b-512df0cb7e78', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28a73962-28a7-49b0-a276-6e151dc86014', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('28aee6a5-ded7-4220-8d6a-dc5efd44b003', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S/M P', NULL, 'P/M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('28af6962-2d13-460b-bd33-4254be448447', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0L', NULL, '0/25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28b03025-dc98-463d-b0ec-2c4533332cb0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('28b2d6e4-03c3-4809-8dfa-055665014369', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28cbd62a-e671-4782-b0cb-45a737bd2fa8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 TALL', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28d1cb9f-2f8b-43d6-a74e-f6acb9841bae', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28db6789-d9fd-49cb-930d-e419d9895eaf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X 36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28e88627-f706-4108-a8a8-8d1abb133991', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28ebb913-3d3f-4baa-bd17-7f150976a9c3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28f2e38a-9778-47c8-acbd-a41949243ed9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'S/P', NULL, 'P PETITE', NULL, '155/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('28f364d3-b015-449f-8bd2-0f8538608639', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'LSLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28f3d015-7b5e-4924-96b4-291f7abded5d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6 HSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('28fb3c6a-afec-4b15-a659-74ae89713377', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('290888a2-e079-4332-96f7-d1c8f46af47b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '23L', NULL, '23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('29156fe1-d0bf-4207-afd1-f4db643a3989', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14PETIT', NULL, NULL, NULL, '160/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2915e834-d252-44fb-ab8f-c77f796bd061', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6 HUSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29274576-8bf4-45c5-9943-639198065675', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24+LONG', NULL, '24 TAILLE FORTE LONG', NULL, '170/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('292c1305-d7dd-423c-a2b0-a24c7538999c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29453b47-d4f5-4392-99c6-f0e65245780d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32-TALL', NULL, '32 GRAND', NULL, '180/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2945581e-3d81-4f76-a536-9ff4be9a7936', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6 TALL', NULL, '6 GRAND', NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('295d3e76-de17-4cb9-b7e3-22d0a6e19fc5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46 SHORT', NULL, '46 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('295ded79-0d63-49b6-b0a3-029a322030df', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29627b14-fd8b-433c-8a15-7294efe2fcc3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12 REG', NULL, '12', NULL, '165/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('296d6b2c-633b-4624-a07e-2d76391188f0', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublicFactoryStore', '6-9 months', NULL, '6-9 months/mois  27-29 in.  69-74 cm  17-20lbs.  7-9 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2976606f-a5a1-4042-9b63-70421f38d383', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33T', NULL, '16/33 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29855702-1c3d-4cbc-8e86-d66f522eb4a0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '00 Regular', NULL, '00 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('298c4cfb-02d3-4bb0-ad95-2af36f89096e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14S', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2990a407-ce80-4f02-9cde-b8fe0f9956ec', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('29b1407c-f700-4012-ac14-99678a2b5a29', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16TALL', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29bbf6bb-a20c-4d1d-a6c0-67703906cf14', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 A', NULL, '12 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29c4ab90-7394-44b8-930b-e8caf41b5b26', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S SLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29cd239a-1433-4437-9d9c-0ad80fd54249', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '00PETIT', NULL, NULL, NULL, '150/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('29cf61ee-abad-40d9-8019-2d8bab6fb946', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XS/S ', NULL, 'TP/P ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('29d6dfa9-1dd0-4735-ae01-8e8719309abc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29e944d2-925b-43b0-82c6-43b4ed031e17', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXXL+', NULL, '4X', NULL, '170/134C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('29ecc605-8262-4a49-a1d4-638c79162813', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('29ecd030-23f4-4d73-b868-cbb0b17ac8a3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '32 TALL', NULL, '32 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2a04130e-ad33-4bc0-99cb-17a7977f745a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '7 SLIM', NULL, '7 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2a185ff0-f83b-4398-ba0b-eae949561dcc', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', 'L TALL', NULL, '17.5 x 36/37 = TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2a1da321-2c8d-44d6-80a6-7479ade84188', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5 +', NULL, '5 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a3455a4-ddc6-4c55-a926-b0c094239800', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a3579ac-baa9-41d2-bb7b-4398e7a5e255', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXSP', NULL, 'TTTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a3c30b4-2131-459c-83a3-f287c6af4719', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '35 X 34', NULL, '35 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2a3ed827-12af-4b0f-a27e-0e5ae71f1f1f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0', NULL, NULL, NULL, '155/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2a629899-6a6f-480a-aa34-aef356dfd0c5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'L', NULL, 'G(35-36)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a6d3174-4efb-42e4-b7f8-d20c46ddf9d6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a72bbbe-f1df-443b-a294-2e2255dd8d64', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a74bc74-1b17-44f6-8e4c-cd155165bc76', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25 S', NULL, '0/25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a8255e0-b1bb-44b7-8279-8e930b4b7335', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2a89a2c7-d749-4f40-ab89-510ebcfd9430', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '32 X 32', NULL, '32 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2ab1639c-d10c-4b6a-9004-7bc9a914e8a2', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL', NULL, 'TTG  (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2abc2ead-1244-4299-acba-2ea79b1d7659', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '27P', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2abcf8af-3638-4893-bfa7-271fd8448232', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ac09a89-ba6d-4047-9811-866ea0d9cdca', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ac4c484-0b2d-46fa-b496-4d11d3b99940', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '14 Petite', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2acda8f6-5322-453e-8985-4dc58d8140df', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '24/00 TALL', NULL, '24/00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2ad02615-9f9f-48f8-b069-074fd6beab4b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '40 TALL', NULL, '40 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2ad7761d-4b9b-41ac-90fc-cbd1fb5c6025', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23 R', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2adc40f3-26b1-4440-971c-f2f8b03f6865', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25REG', NULL, '0/25 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ae0ed2c-d62f-4a13-b345-971a6efa7809', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42 REGULAR', NULL, '42 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2aec6882-d621-475c-978e-0deeace96a44', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bfa1-05a3-b0d0a7835e54', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2af88510-8d63-40bc-9d94-5d3e6963d3c8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'BananaRepublicFactoryStore', 'XL', NULL, 'XL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2b0026bb-e588-4017-b4ed-6097dd732223', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XSREGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b00cf35-d73a-4e11-9223-c04a1836267a', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/88C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2b0a02aa-c282-4eed-a7b6-ea3dfd7532a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 TALL', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b1f67ab-a277-4ced-bac0-b0b9496ed6ae', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b229e1e-9e2a-4b75-acfc-03c9ae6665b3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48L TALL', NULL, '48L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2b377edc-bff4-4bf2-a86f-4149d32ad458', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2 /26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b3eaefc-0c8f-45d2-a0c7-863cc2d486af', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26 S', NULL, '2/26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b4bdffd-8dae-4da6-95cf-45b3a1f60fe1', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/60 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2b52f04d-8db6-4ed6-97a2-39774cffc85f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b535410-e351-4e5f-bf1c-0fbeded38dfa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X 30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b55cea5-933a-4b1f-bc3e-23342b4b9b2e', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2b63d322-edc8-4961-b98a-ef984ea83c28', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b695f58-77fc-4874-92a1-de267735d0c8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b765f28-2ca8-4158-8bf4-4575186a1497', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28', NULL, NULL, NULL, '170/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2b7de217-b020-4bcb-a778-93ebe980bd06', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2b8f5fbd-4a8a-428f-93ee-951b92d4ace4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'M REG', NULL, 'M (8)', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2b989529-0703-43ff-9f0d-403edcfc9f70', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '165/200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2ba15898-695c-45a4-ab80-e7dfe14f5540', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '00', NULL, '00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2bc84139-ceaf-4926-964a-1baa1fdbddc6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '20 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2be13402-1308-427b-b3d4-437eb4576184', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8 SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2be313fc-5b93-423c-b8ef-ffd94ed53007', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X30', NULL, '33X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2be4b41a-6ed6-444f-b7d9-db69bbc48970', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42', NULL, NULL, NULL, '180/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2bec3b38-0053-4657-ac65-bd9a652decfc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6PETIT', NULL, NULL, NULL, '155/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2bfe25d2-286f-47b6-831b-c049fac7ca62', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '23 PETITE', NULL, '23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2c02de15-9662-47fb-91e3-767bc5783ac3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL HUSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c05b667-b85a-401f-94af-1c435e1eeab2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c1cc35c-4144-436d-8f5e-879d10a97022', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12 / 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c337838-9337-4427-986e-e3aae722dd1a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '00S', NULL, '00 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2c439410-8ba0-4570-a8e1-18d387ed020a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000 /23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c492eea-1ca8-4b97-9527-e68793539b5d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 / 34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c62b5b5-85d0-49b0-afb1-183dbeaee2aa', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'LSLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2c64bdf8-eff0-42b2-960f-4e5c7eeff0ba', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '6 Petite', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2c71d147-cd9b-49bd-9bf8-35cec58c4559', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M HUSKY', NULL, 'M (8) TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2c8fb4e7-edb5-434e-a123-85360803774a', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXL/T', NULL, 'TTTG GRAND', NULL, '190/140A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2caae04e-c79f-4551-bdc1-2aa0afeffea2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18SLIM', NULL, '18 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2cc037c4-be5d-4e89-abf1-ccd62cc497cb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18 TALL', NULL, '18 GRAND', NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2cf06522-3e83-4407-bef9-7fc377cfe89f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2cf0c2e0-0e5e-4110-880d-e4623cf48786', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12 +', NULL, '12 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2cf75de6-f9d5-4096-ae56-612a7787e2cf', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '29', NULL, NULL, NULL, '170/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2d0da4f8-7194-49b0-80bc-7b31e61877bb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 SHORT', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d1bc9ab-4dd1-4f41-bbc4-8b0af607cb61', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2d1cac41-7543-44e6-9df3-21c6cb652d74', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5 REG', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d1d3ff0-5faa-4dd8-b4d8-aadb0e84d55a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '29 TALL', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2d25bb1e-acaa-4bf4-8d74-25b6192030fc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d2ea7ff-6a7d-4802-85ac-5d8c42522e04', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '27 PETITE', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2d394cb8-3f5b-4086-b505-feb26faf28e4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '35P', NULL, '35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2d5082f5-b8b7-4efb-b051-c1a29c244861', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M', NULL, NULL, NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2d53a9e5-091e-4ea6-b65b-46565291d3d3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d5f12b4-9571-410b-93a0-ca5de0bb7638', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XXL PETITE', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2d6a4dc2-6374-4be7-952b-c252a5a58738', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32 P', NULL, '14/32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d72ddad-a0c9-4cc4-8b30-e7d6319e2d20', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 S', NULL, '000 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2d74a05b-1e93-4690-a4a0-685d3a2e3350', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2d9c1e09-f8e8-498c-afdb-2c3b1e58a8a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34 R', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2da7d142-5538-4f30-a979-38ec0bd2c5f0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2db23db0-135a-40a1-9d30-9a5296fc57af', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '0-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2db6b6fc-252e-4163-923f-0afc15fd09c8', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-72ad-5483-0d7d357dff38', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2dc62d67-fe3a-4dc6-9a7f-362b2263baec', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2dc71b40-0f08-4954-9ca8-7b3c71545950', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2dd0dc5a-dd7d-4dad-861f-8fbb62ca0d37', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2de257d3-44d4-4cc5-8357-e4f922925da0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18MON', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e022094-d51d-45ac-95f3-49ed2fa6d912', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34/18 Long', NULL, '34/18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2e02f98b-b84c-42f9-8e84-e8042763d907', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'S SLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e141d40-587f-438b-a994-77e733bc6ff2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-3dbd-7cf0-fc3d70abc36c', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e1bfc9e-9b1b-40b9-b48d-cf4ef08a438a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '28P', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2e1de8dc-66c0-468b-ad17-01bf5514a3c8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e245c10-9300-4593-93aa-399ea6acdafd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e2611c5-0ac0-4395-b53c-f5c7d5ef6953', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 P', NULL, '10/30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e2a874b-b308-49ac-b2c8-83da8bd56e70', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10.5', NULL, '10 TAILLE FORTE', NULL, '140/70 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2e352680-1ffb-4160-8325-4e336a15eb32', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XL/XXL TALL', NULL, 'XL/XXL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2e3c2b75-adb6-4b9c-81a8-272502c4354f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2e41ea84-2651-4d13-9755-8957aeb7d049', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '33 R', NULL, '33 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2e5c4e7b-4757-4788-84b5-ac905541fff3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/ 30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e6315f5-b14e-4171-9110-1f70ad1075a1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2e72e755-8620-436c-87b1-5bec813b99d5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'L/T', NULL, 'G G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e7dd6d5-0749-4ce0-9e59-efc2d59f130a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '32P', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2e823feb-0086-451b-afe6-c4f7abc2c582', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5d1-8b1a-6681f41aed59', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2e984123-d3d8-46ec-889c-073af8a1bfe1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublic', '0-3 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2ea86b2e-4319-4c60-9981-07b49aeb588c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L HSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2eadb09f-f833-4d0b-8e0f-acb2eb04598b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20PETIT', NULL, NULL, NULL, '165/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2eb4c6e3-c16f-4bc8-a866-4ef3bd0d201e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2eb5597d-2c53-47af-9f10-0d318dac198d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10REGULAR', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ebc32c8-3eaf-455c-8c76-54414ea6765e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32L TALL', NULL, '32L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2ebf14da-112b-466f-ab84-f2bf2ab6ea4e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('2ec62b49-df8d-4195-9834-cdc9135aacb3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X 28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ed02663-c201-424b-9c05-3f3a3655bb75', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-34bb-7876-d77e298f6e65', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2ee8184c-a797-497a-bf03-c3f12a173045', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40-TALL', NULL, '40 GRAND', NULL, '185/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2ef0d586-1a66-4784-9128-b402a3bc6351', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '46', NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ef791df-c610-4dbe-a534-1b75af7efa29', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '180/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2efa0959-8b01-42c9-ab3b-92805cd4e675', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4 P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f00d927-ad74-4db8-aff1-0a32d70565c9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2f03615d-461b-4550-a600-01aad5ccc978', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2f1fdd40-db97-4262-b622-bbcd79d1f520', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 XLONG', NULL, '0 GRAND', NULL, '165/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2f3babd1-d440-44de-ba02-604c08223ab4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f3f93b3-0fcf-4644-a6a0-fcaa225bafea', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XS/S TALL', NULL, 'TP/P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('2f438252-af3e-4baa-a126-0005f1ed469d', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '6-12M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2f501858-c01c-4c66-b6d0-d75d87ba1fd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f592759-1e56-4fdc-aeb0-06f1b4a88135', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L', NULL, 'G', NULL, '165/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2f5931ba-f000-4a67-8670-290a5be28603', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2f61e025-d49f-49fb-a3d9-4ddb19c98f2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 LONG', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f636cc0-34ec-4b32-a85a-da093cc4d4c9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f69aecd-c20d-4d51-9bda-52c31905f402', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL', NULL, 'TG  (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f6e258d-d0dd-463f-badf-c3f4f2db9282', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXXL+', NULL, '4X', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2f6f0613-136f-437b-923c-2320235e14fb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f70db34-95eb-48ac-8370-258ba65d8440', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18A', NULL, '18 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2f75d94e-0acf-44e2-a746-daf9d6f1eab3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fa5d29b-b69d-4e4c-a77c-eac7c7b32221', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fa7d268-f608-42c5-876c-6ddf899798fa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'LREG', NULL, 'G Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fb73b64-515a-46d7-b22e-465e91815d39', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14 SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fbb987e-759a-4d2a-baf7-641d95ea1027', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f51-fb5c-714f94367e54', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fbbd426-b3f1-408c-9048-f525e068b982', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fc186f3-b693-45b2-b63b-d661f162f8b2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2fd0692d-d30e-4e6a-9534-7d3489cf0c3c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXLREG', NULL, 'TTG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2fd2b406-f5d9-4173-9749-6b64819c3187', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '165/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2fd447bf-2d74-43c4-98c6-1650f406f02e', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'OldNavy', '0-3M', NULL, NULL, NULL, '90/54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('2ffb2518-bcf3-4f02-bb42-ed584cd0273b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 L', NULL, '000 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ffc93c2-c594-48c4-8f11-253e1ed8b394', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS T', NULL, 'TP  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('2ffdc432-5a26-43a7-a678-6fa27a392473', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'L 17 1/4" 37 3/8" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('2ffeda4f-306c-4d89-bc19-422758debe79', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('30000d19-8d88-4b7e-bed0-b749fd04623b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12', NULL, NULL, NULL, '165/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3001fd14-ff08-489f-a568-9b0c13efc671', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3004d7bc-3450-4a9b-a48d-48bb88f8efd8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/ 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3008c43b-42c6-4d9a-ba29-47e22a4b6245', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '48X32', NULL, NULL, NULL, '175/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3009061c-1669-48a8-8f76-becbcc1efd5f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3009cc1a-ffd8-4cec-a362-9c6808b1fa67', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('301ad956-7a12-42cf-82d3-17a7f331933c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '13-13.5 x 32 = XS', NULL, '13-13.5 x 32 = TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('301f6887-c022-494d-b18f-d90aabf2bcab', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('302f4a48-0454-4794-ae52-e98667d1f870', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL REGULAR', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('303a13de-6269-41a5-ab69-31ac8ec0efa4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000R', NULL, '000 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('303fa885-1f61-49c4-88e9-8838400afcbd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '12 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3041a59d-6160-4e68-91fe-ea8e72983432', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3042dc6c-cbc8-4e09-bb31-168acb34544b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '27/4', NULL, '27/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('304c49ff-35f9-4bf5-8947-8cbe139528b5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31/12 Petite', NULL, '31/12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('304d896e-5e9d-410c-8641-789d65e70ca9', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('305385a7-d436-4202-b875-9c640a29f119', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28X32', NULL, NULL, NULL, '175/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('305509d3-4499-42f4-8337-6656216e7430', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32 SHORT', NULL, '32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('30679aa4-1420-4a3f-8c23-99c6c03bc45a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 PETITE', NULL, '14/32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3071f83d-9a14-4e04-848d-0e7cb4b6c16d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '26 TALL', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3092031a-0ebb-4d77-ba5d-b2de1089f0ae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 LONG', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3092328e-7cb3-4d54-a575-06f39e579197', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('3096fe47-9a03-4377-a771-c026cdfb4706', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS/P', NULL, 'TTTP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30a5c31a-4b12-488d-b8cf-ce2f04b38c40', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16LONG', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30ab0d9c-b502-4150-999b-8b3c49480a50', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '180/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('30b3508d-03be-4905-b331-45f97c83917b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 REG', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30b4c4ad-dbfa-464b-b4f4-1ab6dbfec6be', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-2430-da0d-e8ef7a29d82e', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('30b9b340-fc3f-4c7a-8df6-9bc4a1be96a2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('30c15d8b-6cff-4501-8970-a03c07f9dc7f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30c34112-41ef-4c18-a658-d23990e4358d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4S', NULL, '4 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30cdab92-f702-4894-8234-e74a88e564f9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '20S TALL', NULL, '20C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('30efef50-484a-49ef-bb3c-1a2117167562', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30f2e819-2a3e-49b1-a32c-bfac287a0d7e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '38 TALL', NULL, '38 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('30f525cc-c5d1-4667-beea-ad4a18163411', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000X 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('30ffb14c-d540-4f78-af83-8014a69c83aa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L/P', NULL, 'G PETITE', NULL, '160/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('31097bb8-ba12-4378-b44e-e7032c28b712', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('31165444-c66d-450a-b7b1-4750e457cd45', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('311b016f-7448-4b19-a828-e5b5680ab5e0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXLSLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('31236efe-b3f3-419f-a7db-18ffdc4a9ad1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXS Reg', NULL, 'TTP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('312449ab-27b7-40c8-848c-4f2c1f53022a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-4811-7a0d-f7453d8c0729', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3134e9e9-ff8e-4ee2-b7e3-125344538587', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8P', NULL, NULL, NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('313e3769-e756-42cd-a6d7-79d255d44c15', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('31516f70-8321-4b50-ab0f-4d9b7a1ae63e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS/R', NULL, 'TTTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3153b03d-4d39-4650-baab-5a244a465b07', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14X32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('315e934b-f1b9-452f-98c1-a81d80909bcc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 / 36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('315fc17a-de89-4bcd-8c35-9ea1ff5e8c01', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('319c70ce-fbe6-4147-a532-174d943a2bc0', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('31a0e636-61b8-4a5d-a155-818fb7f6ed22', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('31c49a0b-7137-49d2-9daf-7e88d0b63bf6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12 MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('31d4ce78-26d5-4ba7-8ae3-57e68836db08', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('31de3c1c-9e75-4203-a286-e72c8df4dab2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16HUSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('31ef1285-d855-45cf-81ba-a3b80bf70c82', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 A', NULL, '00 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('31fb8587-faa0-47d3-bf61-1becb32e9753', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 REG', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32047be9-f943-4e65-ab1e-51e8620dfdd5', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('320a6744-de34-4145-b09a-586fafaf24b7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('322190e1-da25-451a-9959-ccf026e70b4a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('322f2f30-4ba9-467c-a2f9-aa71e9cb0f9c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6X 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3234a874-a65f-4105-9b0b-7feffbb1991e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28 TALL', NULL, '28 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('323ee69a-5d1b-4c8f-9e7b-d152779a69d8', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('32425f23-0160-4344-8f54-c8cfe220bbd9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32570fa5-b2bd-4200-a265-d81c8185ef16', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '25', NULL, '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('325dfa39-551b-4940-a57f-e68f53d16e2b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6 M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32613825-f4d0-4bab-881a-4931f8a86d72', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32661b1a-5dbf-46e5-b24d-dd80cd0c5ebf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/ 28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('327d3c30-bfb2-4e29-8c3d-06b06e7db75d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32801011-8689-4254-9203-0acad86d72b0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2REG', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('328db158-fdd7-4204-8f7e-0e09a9a98f34', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('329bd5b7-d8ac-4c8a-87ed-a895972fc929', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublic', 'Up to 7lb', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('329f444f-d075-417a-9e6e-e58936108454', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32b7160d-b0b7-4478-83b5-620fa48d8ff2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32dbd3e3-9cc8-49ca-9e3c-c39d13bccaae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000X 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('32dd58f9-bf1a-4b3d-ac5b-2e7e5f12f5cc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '16 Regular', NULL, '16 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('32f18a38-60bb-4579-a31e-879502158d1c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29/8 Petite', NULL, '29/8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('32f2fc16-f016-4504-9e9f-6c74b02e8d86', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('32f9c238-745b-425f-803e-14d80c7483ed', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3303c8ce-a48f-45cb-8466-230e3a4c27cd', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7744-6623-09d5f49320cd', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3303d8d6-b4e5-4bc3-84d1-0181599fdc2d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '29 SHORT', NULL, '29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('33063d26-ed94-4816-8f28-7077f9c0f6a3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3309fb3b-3309-4035-9f14-2620872cf5fa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('330ba0ed-d03c-40f6-b2ce-3bc0dc29f0d5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('330bc2b0-a334-4409-83f5-7d73effe7be5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'S', NULL, 'P', NULL, '160/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('33153d80-e5aa-4267-bd10-218065a6ae59', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('331c9637-d6e9-48a9-8b53-298dbe5aaebd', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('333952ce-6cca-450b-8ce6-d9d5104f2110', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('333fe972-437c-4a48-ad18-3e9674faa716', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5 SLIM', NULL, '5 ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('33421bb0-e5a4-4a7d-a552-ef1e80e9df39', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '17.5 x 34/35', NULL, '17.5 x 34/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('334a0c9e-ed65-497f-99b9-7a82f093a24c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3353f583-bbf2-4bf4-b37d-545fb04855e6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '1', NULL, '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33561d97-f71c-4ec2-ba00-661ead5cf89e', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '18-24M', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3374794d-fe79-4f04-93ff-8df5e66d4714', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('338533de-3762-46dd-83af-d38f81932de5', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33', NULL, NULL, NULL, '175/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('338d22e1-4d3b-45b2-870c-aca740a943e1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33916d9a-9035-478c-acf0-f5890318e2b2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20 TALL', NULL, '20 GRAND', NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('33951c8c-fd3a-4c70-8f33-6dad5d87ebdf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 TALL', NULL, '4/27 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33ab29ea-066f-4ee0-9f4c-52288a9c82df', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33b0fc44-c584-4843-97c6-eadb8e73555e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 PETITE', NULL, '18/34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33b80ed4-56a6-45d4-a16d-1310e6a18e26', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20P', NULL, '20 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('33c4eca1-4905-486d-b8b6-b6a9bb203de1', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '4T-5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('33cdaf70-02a4-49ce-a992-3427d7a68a35', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('33ef6310-3631-4fc4-ab07-2ea993227d5e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '4 TALL', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('340c3736-694b-46d9-915e-ff72b8438c10', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 A', NULL, '000 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34266d0f-5abe-46f2-b23e-c2971f5d4e5a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37d9f1d7-bf3b-493c-9956-71ce2ef45c97', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X 34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34321763-72f9-40f6-94b4-aae1c651df18', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '16.5 x 32/33', NULL, '16.5 x 32/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('343ac373-09a9-48ed-a0b3-2c4fad828458', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 LONG', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3457f48d-1227-46d1-8799-d808f131ee57', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '28P', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('345c24ba-5697-43a1-8f63-ef3d6be30956', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Gap', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3460a7c9-5a98-4927-bede-7402673a5852', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('34645aca-1cd4-4559-bd56-c08e876b6894', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 C', NULL, '36C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('346c3b36-b1d7-4256-9571-918dfba44831', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('34721a52-6685-4daf-a7ba-26acc277a3e9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00S', NULL, '00 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34721a8f-de26-4cfb-b807-1d1cca74a47b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'TALL', NULL, 'TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('347422ef-e8c6-4ddc-89bf-8f5d5bfffb97', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '33S', NULL, '33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3482a996-61af-4739-9954-e0e76c13d6f1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32S', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34856e9b-c0f3-45b4-87c1-a1654a264191', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12XSHRT', NULL, NULL, NULL, '160/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('34859b28-08a6-4d5c-82c4-5ba68d340e33', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '16 TALL', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('348c170d-a9f2-4cb8-9ac5-d63df45fd416', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10XLONG', NULL, '10 GRAND', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3490cde9-ebad-4dde-bb81-4c136dffbdb9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X 34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34937542-7f1b-446c-929b-a779d1febf2e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XLR', NULL, 'G/TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('349af20c-6e94-4e1d-9027-b7119d229be7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34a5b71b-951a-4050-abcf-ab263807959f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '32 X 36', NULL, '32 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('34a926da-79cb-41eb-a49b-23823772316f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XXL SLIM', NULL, 'TTG (14) ÉTROIT', NULL, '150/68 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('34b661c4-fea2-4f33-ac7c-ab676b87d232', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34c31fa2-9552-4560-99b0-5b9a42fc47df', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '6', NULL, NULL, NULL, '135/61', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('34c8ef38-b723-4070-a43f-0fec601117ee', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('34d8c38b-32f5-46c3-8510-ca6ffbc90f25', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '15.5 x 32/33', NULL, '15.5 x 32/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('34da441a-1520-495a-b4d4-d89c951e84e0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12 MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('34da46d3-9d8c-4b39-949b-6f562f4fe579', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('34def565-e996-45b3-a6bc-970ee8b1025e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'S ', NULL, 'P ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('34e68363-1613-4ea0-8fa2-e5e4b3694e3b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M', NULL, NULL, NULL, '165/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('34f1b83a-bc24-4e20-acac-d2bf55ee8601', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '28 TALL', NULL, '28 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('350ced18-c9b6-47ee-9b38-93ffe09ab981', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL/P', NULL, 'TTG PETITE', NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('350f38ba-71c6-4f19-be5b-7c7f6a51b8f1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38 B', NULL, '38B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35118474-8825-4799-ad35-e15594210db8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000S', NULL, '0000 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('351ae176-6ba6-456c-83ff-9faa3dfcd254', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-49c2-60e8-0bb146df8a52', 'Gap', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35242963-9a26-4c24-9564-d781de3b6c9f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '36 X 34', NULL, '36 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('352bc4fd-5d7e-454e-8f40-61f88757ba53', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('353eceec-f79c-4ad0-9170-34b805970ff3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32REG', NULL, '14/32 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('354b5572-c238-461f-8c97-6f7ab812ecb4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XLHUSKY', NULL, 'TG (14-16) TAILLE FORTE', NULL, '155/80 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('35534971-c114-4fbc-a70f-d574aeac99fa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3571acb2-b6ea-4d2a-954e-01aaffab90b5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('35806075-ae98-43c8-a4ff-6f940a2b50bd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7 REGULAR', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3597d145-fbbd-4b98-9c55-bd70f7c371e4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12 MONTHS', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35b6fc93-c27e-4696-a226-c86b5ba46498', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('35d5bed5-e7bd-445a-a4fd-cc410e81de06', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36 SHORT', NULL, '36 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('35d712c4-b07b-4572-8424-6f982956082c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-45c1-f2af-4cad493341e4', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35e156a2-e22e-4819-b9d8-01627321ed64', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('35e30c7e-f4e5-4a4c-bd07-9c87114c1bfe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2R', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35ea3972-3fd2-4896-a309-0c644cdfc02d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16 TALL', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('35f51f9a-7c4d-4386-b7b4-1409e84edcd3', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '12-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('360f47e9-b34f-42c4-8608-12b3ddc1f4f3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '00XSHRT', NULL, NULL, NULL, '150/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('362309c4-3c68-4c10-bff4-cc573684eee5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 R', NULL, '0000 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('362b07a6-09f0-4773-ba36-3ab318b201a7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36DD', NULL, '36DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36343e46-9a6b-4dbb-ad3f-7c5722ac1ee0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('364436eb-88e7-430b-bcc1-8a8169c53706', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3647a389-fab5-45fd-8060-0cba4579d511', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXLHUSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3658df49-747b-460e-a3a6-837788ad70c2', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '4T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('36635c32-12a0-473d-8774-d34ab206ad98', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '11.5', NULL, NULL, NULL, '295/101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('36680cf0-baa5-460d-92e2-1c5f9cd5c936', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL', NULL, 'TG', NULL, '180/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('366886d4-1287-45f0-b905-1afe09fc7094', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34J', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('366a289c-c313-4c84-ab98-dfb74755ca4a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30 A', NULL, '30A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('366d8c4d-c23e-45ae-b0ee-e4bdb899e720', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-ba8b-511a-d553a9608347', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('367b4ff9-e8c3-46dd-8e02-08064fe64bbf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('367e3495-ab3d-4d91-894a-02227c6202d1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('368333eb-0c50-4f73-9f82-14849afa3a2e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3686e34f-46e9-44f8-adf5-af23a16c36a6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36893035-c771-476c-9c10-b80cc4525975', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '28/6', NULL, '28/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3695aa15-b571-4ab4-808b-cda57b3a5acc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X36', NULL, '34X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36a95660-be59-4978-af9b-25d517fbbc30', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36aac349-15d2-4e79-abb3-c1fcb003180b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36abd538-06f7-456b-abee-ce878df3dbba', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('36ba7eaa-c16c-4c5c-aa6e-9b3685b58ce6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2X/3X', NULL, '2X-3X', NULL, '160/125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('36c36f93-485f-41aa-b0d6-3e32fffa7d8d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36d454cc-d7b7-4591-9047-de7275194cfb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('36d6205b-e83c-4de0-a36b-047e849fe190', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36d98e89-8283-4b02-a22b-d8b035659c58', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0A', NULL, '0 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36e6b73f-d87f-43de-8794-c90720058db4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '30 S', NULL, '30 S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('36e9cd21-060e-4b35-a494-18c63163a834', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35 L', NULL, '20/35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('36f23f29-9d2c-4638-b7a8-4db3014a1243', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '4 LONG', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('36ffaad7-c969-4677-a40d-07ee0f5a9d71', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS/P', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('370aacbc-a816-4700-9622-bce2bf88d498', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('370d7bc0-2d5d-4d4f-9daa-17cb4e06397d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4L', NULL, '4/27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37168d70-270c-4ef5-959f-19f70dd486c7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33SHORT', NULL, '16/33 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37195bbc-2314-4d90-8c52-aef74bf713f3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3721ced0-0eeb-49db-a2ba-bb992b290ec1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32 TALL', NULL, '32 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('37225208-6095-44c7-89f4-82c72df45922', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'BananaRepublicFactoryStore', 'L', NULL, 'L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('37342489-ed43-4d8a-9d5b-a9a1a633b25f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('374f0407-0741-474c-9234-de96ad45d7c3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3752ddd5-50ca-49eb-ab60-2522685669c3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31SHORT', NULL, '12/31 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37626944-7d9a-41b9-bfd1-8862f3f26124', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6331-d8ba-438a49af2b55', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3767b5dd-f1df-4640-8135-fe3d09e8c5f9', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('377f60ac-ef27-44ae-8493-7a39122cf5c3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XLHUSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('379ec302-f896-41b1-9020-59113c47efa6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 R', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37a768c9-4211-483b-9219-415bdba5e056', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22 L', NULL, '0000/22 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37ac0f9d-3233-4c70-af0f-b46d819638c8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37adbdd7-5127-4daa-8ca4-26a876810149', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37b59a15-363a-4e30-8ea6-2cc175662190', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '31X34', NULL, NULL, NULL, '180/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('37be7c00-9af5-45ba-89a2-9aa1b5cfa634', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL SLIM', NULL, 'TG (12) ÉTROIT', NULL, '145/60 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('37c6617a-aeb5-4a9c-81ba-8c9c2a351fee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37c91d17-2342-4c1b-b2a6-e4c4799c5f7b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XL/XXL', NULL, 'TG-TTG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('37e145b7-c11a-444b-9f55-ef17c5c25357', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 REG', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('37e6be81-8e9f-4139-b355-a4b4084a212b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '6 Ankle', NULL, '6 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('37ff7d58-53bd-4fcd-a057-6e34d7d24adf', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('38009f29-4e8d-4d0a-b367-768821a602a0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('380495db-8b50-425a-980a-79377ebdc3d4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '36', NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3807c28b-4a29-4090-8d92-f31bba437a8d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL/R', NULL, 'TTTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('380f345d-45ea-4a8a-99b0-de43a01354aa', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXLHSKY', NULL, 'TTG (18) TAILLE FORTE', NULL, '165/81 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('380f4a7b-13cf-4417-bc0c-d1b1662199c2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '2S', NULL, '2 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3820d3cd-b67f-48c1-a433-21bff75a42d8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '7.5', NULL, '7.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('38281655-84d2-46c6-ad69-f2e1b5b42e67', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('382e789a-54c1-4f27-b169-ed66b0426339', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('38327c81-8ba6-4703-859b-3ab6ba3412c9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 P', NULL, '6/28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('383b734e-acad-48f6-ad6d-618a3a0815f0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('384353f2-1a84-4be9-aba4-73447feb351a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12R', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('384429e7-3504-4436-9d7b-0521b0e7aa2b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 /32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38456868-af0a-4820-bded-529a3fb50d67', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23LONG', NULL, '000/23 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38456d82-879a-4682-b440-d40343cdbce0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f96b-e1e7-9a5d3b960c0f', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38516e66-c7e0-4925-8278-308fb17e55b1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30 L', NULL, '10/30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38551a32-cd55-42fc-9404-4bbbced8f331', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL', NULL, 'TTG  (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('386a0a28-cee0-4110-aad7-bb2ddd295d12', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('387bcb5a-294e-4a88-be60-e34cf5188445', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('387e97aa-0c10-47b0-b039-ae045ba9cbe2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38835890-4719-4303-b5c9-4da6e0760a44', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('388970c3-d5c8-4065-ba84-04e7bb3e9ed5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2 TALL', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('389a7fcd-7912-4b05-aeba-93fa45b54c43', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '35 X 30', NULL, '35 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('389b0e85-4bca-4f34-938a-751a3586b84e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('38a4c0d3-c415-43b2-9ead-1d0541e85ead', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38aea3f8-16c6-4d2d-a501-95a869b082ce', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38b5b06d-f780-48d3-8dbd-ae1e8a029d5a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6 M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38b8bd8c-288c-4db5-99df-edd3bfc4d2dd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2L', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38c6a199-111e-4c02-a25c-9fc189c0ec1c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, '130/60 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('38cfd026-671a-495b-b19a-81a5f5948d80', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2S', NULL, '2 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38cff70f-37ff-4f25-9618-5e4ac1ea218a', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'BananaRepublicFactoryStore', '6-12 months', NULL, '6-12 months/mois  27-29 in.  69-74 cm  17-22 lbs.  7-10 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('38d67aa4-184e-40c0-a25d-3ad7d5438a95', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38ef9a1a-d795-47b5-a5e9-57f736642ae0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('38eff571-5a67-473f-ba02-cf7e0ef28dc5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8/29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3907231e-ef6b-4de3-a762-60da6e1d13d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18 X 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3909c57d-ff49-4e17-bd2e-3fe26475b70c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('390b11e2-cb46-4c8d-9e4e-5361f7e436fc', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '33/16', NULL, '33/16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('390c269c-10db-4a2a-9513-a834c01c1d0d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'LREGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3910baac-2ddd-42ef-8d79-a7e486766084', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3915bb80-b185-4a44-b1d2-903d158a6590', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3916ad32-8dc7-457c-b192-8f596b69e6e6', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('39172e1e-2632-410d-8a2e-ea9a1cf0fc51', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 DDD', NULL, '32DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('392b2847-cd2b-4152-8c60-d9e21d9fdb0a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20 P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('392d98e8-e763-4a04-809a-947e11e2cff3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L PLUS', NULL, 'G (10-12) TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('392fa190-26a8-49a4-8970-6a97754c473d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 / 36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3932bd59-0171-4141-b649-f825b167b700', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 / 30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39479b14-5341-4540-b4a5-ca952ca279cd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL/R', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3951e393-57c9-427c-aeee-c826ce4b10b6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXS/T', NULL, 'TTP GRAND', NULL, '160/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3959132d-f001-4033-a00f-5d94e4c6c910', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('395ed189-f16b-4cde-8d8f-bf3f675e262a', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('396009dc-8471-4f47-9a2e-4dd05b375769', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3968e263-b12e-4df1-958d-af4c8981e057', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M REG', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('396e149f-38a6-42f2-af0c-86166a05829d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '16 LONG', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3972cf06-474c-4ab2-9607-2cc310a7b7d1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/P', NULL, 'G P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39754858-2d4a-4d22-b189-948cfb64b227', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('398da528-ee45-4deb-97fe-e347798efc8f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S XLONG', NULL, 'P GRAND', NULL, '165/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('398f785e-d7cb-4227-b5ce-78f657247509', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '12 Petite', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('399b913e-061f-4c81-b28a-ea01a952bbae', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '40 X 34', NULL, '40 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('39a49fd3-cfe1-470d-b2ee-63747f5e1848', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 S', NULL, '18 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39b628be-24ab-4c79-b017-f1893bf3914c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 LONG', NULL, '000/23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39b7f7a6-a38d-4dd1-804b-4ff24c9e051b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XL REGULAR', NULL, 'TG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39bd747a-ce24-4baa-aa48-829dfa3fbb10', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('39c1848c-da73-4db1-82fd-cedb5d966fd2', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('39cb2f3f-e607-4b15-8b87-e46ba564f10b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39cf91f7-09ef-4c5b-8c04-799a65a034be', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S (6-7)', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39dc566c-4102-4662-9e96-57cad0c78534', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('39dd8224-3356-451e-8b92-6def657700dc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XL/XXL P', NULL, 'TG/TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('39ebe7f1-4cca-4358-8ed3-51fbadc360c4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '4YEARS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('39ed605b-34fd-40c5-9965-5f875bcd83a4', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'OldNavy', 'S', NULL, 'P (5-6)', NULL, '240/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3a0af7ec-68f2-4a4f-b744-ab589df12260', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '29 Regular', NULL, '29 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3a128195-b252-46ec-b139-48b4a76d81d1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'XS 13 - 13 1/2 31-32"', NULL, 'XS/TP 13 - 13 1/2 31-32"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3a2414a1-9b02-44c6-9cda-936a9d949f52', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('3a2480f2-299f-4e88-bfcb-6a7ff3c5965e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '29 P', NULL, '29 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3a262491-6028-4feb-ac7a-9affb6695b8b', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a263d06-b976-4b27-b619-9a26d35c0923', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16X 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a3ae4b3-d6ac-4ab6-a570-599f0b09fd8a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'M', NULL, NULL, NULL, '19-22 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3a3fabe2-6cc5-40c8-a82d-73e81ed1259e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a474706-8dee-4497-8ed7-dbdb97ba35c5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'SREG', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a5cb789-18bc-4672-9bed-cc2efc4e4129', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18T', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a6b45dc-40b8-4fdd-af29-cbcb477b3b3f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3a7caa4b-7eb1-4901-9bd0-5b66b0c42afc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3a7cea0f-ccbc-44ea-9c03-8aedaafe0aa5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26 P', NULL, '26 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3aa8ed60-e30c-4149-a6c1-848ea184bfc0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ab52193-2999-455f-bf3a-4cd6c20d14b6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3abae588-5f79-4eb0-b1c6-060efb08edf8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3abb4a8a-f3fe-47bf-a932-3e8354202f3d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 TALL', NULL, '10/30 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ac1493c-84d2-4a7d-b267-63e9b6dc6825', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '32 Regular', NULL, '32 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3ad47336-0c44-42af-9ae2-8f7a9ba8f9bd', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12 REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3aff79b9-97a2-4c60-aba6-0c1e12ab2cd9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34 T', NULL, '18/34 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b0588b0-5727-422a-92c7-0e2df231dc16', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '20S', NULL, '20 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3b07cf4b-ad78-41ab-8533-b959fb1298b6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XXS P', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3b09efac-c187-4bbf-95de-8eabf2988bab', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b155033-167b-4dca-a525-cd5bd833e6cc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/30', NULL, '35/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b171bac-5883-4c86-8f45-dbe6f345acf6', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b2cdce8-3feb-490c-808e-c0c40281c118', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '185/195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3b3caf0c-4fde-4506-ac5c-8de5820153dd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 LONG', NULL, '6/28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b4209b0-e1cf-4eda-9006-128eb96b0397', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b431595-93f9-457b-82fd-a5f68918a910', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33X30', NULL, NULL, NULL, '170/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3b5ab125-2a88-4b66-b0ec-6a0f6e834450', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b720428-3cce-40da-9b3c-585bfe3fd4c9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0P', NULL, '0 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b7a4fbe-cdb1-4cc8-ab19-20383ac49079', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8S', NULL, '8 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b7af78b-4566-4cef-9a1b-e4495168ab04', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3b7c0cb6-1dd8-4487-978b-1a8acb586c21', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'LXSHORT', NULL, 'G PETITE', NULL, '160/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3b7cf1fe-c999-48a7-95ec-fd60097ca02e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '33 X 36', NULL, '33 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3b88d24a-4ed0-4cf8-98f6-0704ce2e8f1a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3b8e62d8-9c9a-4a80-bb16-3f87a7ccb066', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M', NULL, NULL, NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3b976d48-ea85-4e78-9fcd-157008ece783', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3b9ab3e4-c428-4cca-8ffc-91ee62f2d490', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '24P', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3b9e25e0-22d3-4990-8108-72dacf1b3b50', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26 TALL', NULL, '26 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3ba0ef20-c8f5-4086-b712-07aaa9628be7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3bae5486-1aa0-4cc0-8a7f-9ab69e0995bd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 DDD', NULL, '36DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3bc4458b-5e03-4028-be04-d26afd37a3be', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26/32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3bc57b1e-8b20-4872-a1c4-07151fd0b49e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-eee2-86bd-56a01f5666ee', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '****', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3bd39b50-64f4-4ab4-ba98-6da6eb7dd6b2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XLSLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3be1d594-fdb4-4d27-a013-eac1a9f6acae', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XLSLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3be2de93-8c47-454b-a70a-744a6495ba76', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L', NULL, 'G (10)', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3be9ccaa-fa48-4e76-bddf-7b756b478e81', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3bec79d7-96dc-4ac7-b417-4fd1c9379054', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL REG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3bf2168d-4594-4f1d-a56b-0bb9c045aa28', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3bf3d773-a565-40a3-9572-1da27b06963d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '27 P', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3c1c6bbb-03a3-405c-b6dd-a8d364c80170', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26X32', NULL, NULL, NULL, '175/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3c1eae9b-7892-493f-8412-33156d698007', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c21f4b8-240e-4bf0-96d8-8963ad163317', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12T', NULL, '12/31 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c243e60-9633-477b-9186-8955554ca396', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 /33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c2c3fe3-d635-4ab4-8893-371cde56e55d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXLREG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c2ee9c4-bba8-4469-9a05-4c52d949f32e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XXL ', NULL, 'TTG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c3413d5-7db6-474f-8077-0b7b7cc1b827', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27', NULL, '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c3b81ee-7ff9-436b-a70f-458700d6e5e9', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XS TALL', NULL, 'XS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c3f4ea2-5575-4f2e-b420-8454f762ec97', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '10', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c4111c0-0860-4802-813f-504406f29d6f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XXS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c484e1b-7cf3-4eee-9c21-66224434c6a8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24 MON', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c4a538b-3262-440d-8494-bbd12f594982', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8', NULL, NULL, NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3c4e8a33-0495-4e88-9deb-93914e172625', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12+', NULL, '12 TAILLE FORTE', NULL, '145/73 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3c585470-9196-4ade-8b74-818a75df3b6d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c652c0a-0544-4540-a126-867f8cbced93', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c667f1a-d02b-42f4-b514-069134f7e84f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XL SLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c6ba9af-3eca-4af3-964b-f9a22160e17c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '185/114A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3c81811d-44b7-4962-aa9d-0847c8e8291e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '6 TALL', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3c876664-1512-4e1c-9735-5d761f6ecef3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3c8ba14b-8ae5-4f90-a3c0-bb2435752e14', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '000P(On-line Only)', NULL, '000P(On-line Only)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3c94cf44-4f11-45dd-97a9-e023aebeeae5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50R TALL', NULL, '50S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3c96adc6-800d-413f-83ba-f52587305535', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3c99f674-4490-48c0-bbe9-4a3e2b177af9', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3ca3158f-0098-497f-a0cc-b21f7ebc231c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8X29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3cac725a-95f5-4096-9d7c-be5bac594027', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3caeda85-1f32-4663-832a-f0744d1de275', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XLREGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3caf61bb-63bb-439b-8e96-8d007acb9fa4', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 REG', NULL, '1', NULL, '160/86C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3cc37e30-132b-4977-beef-d25aefb1772d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10 LONG', NULL, NULL, NULL, '170/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3cd9f150-d578-46dd-8ee5-49bc5fd9f66f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28+LONG', NULL, '28 TAILLE FORTE LONG', NULL, '175/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3d023d6a-e1ea-41d6-8d23-d4994637d321', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d0a4515-86a5-4549-a682-892d2fc91720', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 REG', NULL, '4', NULL, '160/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3d1ef405-3f90-4d69-ba41-37fe16f464bb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d1f324a-110e-4c20-a36f-fcc6b092ce84', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '30 X 36', NULL, '30 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d2968e8-2c0b-4565-8acf-ab05669c40a1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18 REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3d4a3954-f1a2-4b9c-aa25-260a2f0c38a4', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d4bdfd1-1c6c-4f69-9bc0-11f17ff53194', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3d4e9db0-d3b1-4170-be99-4df60df6a79a', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3d5d37a7-06d8-406b-87a8-0b51a35fc193', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3d5f3c28-2f59-4c5c-96cc-65dda7d1a199', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'M', NULL, NULL, NULL, '130/59 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3d6b5987-2130-469c-9e2b-bf7009317534', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d75ce61-917e-4680-9c55-781a44675a17', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '32P', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3d8059fe-08d8-4418-b3f1-19cd3a9da86d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X28', NULL, '31X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3d842265-6029-4bc0-8d25-7707de562f5a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fd07-5fc3-8d6e440f42f0', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3d85a271-d197-4b75-a97c-64310556eb86', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3d8d35b1-40d7-479e-94f3-d34a56e39992', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 X 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3d9f9c46-41e4-482a-8959-f663c4a4be8c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3da0149b-c3ba-401b-b19d-97eeffb4ebb6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33 P', NULL, '16/33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3da03863-2861-445c-88ff-a76b22bb07b7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-abc6-5927-9b41f70fc3ad', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3da24892-33ec-42d6-92de-0d14e85bbbcf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M REGULAR', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3daaca5a-f1e5-45a9-ae08-33ba8e940dab', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14+', NULL, '14 TAILLE FORTE', NULL, '150/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3db5a0ce-4f1f-4d38-92a6-39ae6aabef37', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8PLUS', NULL, '8 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3dc1279f-2e80-42c8-b0e0-fb9f99dc5df9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'SHSKY', NULL, 'P COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3dc6c25b-d61e-4c79-b73c-a95c80eb6fc3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3dc849ee-abd7-48c6-b33b-9885ee9b92c1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL P', NULL, 'TG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3dca7af7-20b5-401e-b260-3a0411a5599d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27R', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ddecf0b-8f1b-4bc9-9770-3e09ab38daf0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24 MON', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3df1600e-f055-4f0f-8862-87a82dfcd904', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44', NULL, NULL, NULL, '180/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3df1df17-c77f-46f4-9439-2da879d320f3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'M TALL', NULL, 'M 15-15 1/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3df69b5a-c106-48de-840c-60ec32e172c2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL SLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '14-16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3e14390f-39a3-4f3c-9283-d7da8b3635e0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL+', NULL, 'TG (12) TAILLE FORTE', NULL, '145/73 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3e331ed4-ade8-49d7-978d-faf8498aebff', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3e3eb588-c242-4498-b8e4-37ebb1d2d83b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29T', NULL, '8/29 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3e50dca2-ace8-4dfe-a6fd-89997dfc71ee', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50 SHORT', NULL, '50 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3e51e3c7-90e1-4d6b-b32d-2c4e84cad7a5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'S SLIM TALL', NULL, 'P ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3e607aa7-083e-4f92-ba28-03c653650524', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3e67093b-738b-441c-b803-bcc9de943f86', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40 C', NULL, '40C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3e77ee32-f5c7-4436-a627-1e6a54ca2d2a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3e7952a6-969e-4291-95a3-d41470bc2f37', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28/6 Petite', NULL, '28/6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3e7a15e5-0886-46fc-9a33-384f1d3e3401', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3e8588ce-ac06-4602-80cf-ca0907eae0e0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10 TALL', NULL, '10 GRAND', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3e8ea243-c6ac-4c3a-b47b-59dcd2cd1b4b', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '24-29 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3ea271fe-5471-42c2-b124-0091660ddf8a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 LONG', NULL, '18/34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ebf440a-48cf-4b04-8d85-c3d22c648875', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '54X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3ecddd58-3f91-4601-a244-fda82673fd97', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ed1237e-34c2-4d80-a3d1-d8ef282a3d11', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'MREGULAR', NULL, 'M Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ed4983f-afbc-4575-9a0f-69504692f0f8', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '9.5', NULL, NULL, NULL, '275/97', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3ede11ac-5ae0-4b6b-9626-f33f0dfb193e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3ee2325e-2c54-4691-b42c-839fb07ca9a4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12 MONTHS', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3efc8202-5dc6-45ad-ad27-1372244a7acf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f01c2e4-a808-49af-b081-9076852a7485', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 R', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f12c1e7-127c-4556-8d3c-0c508a6ee359', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '20 Regular', NULL, '20 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f13b1fe-350c-4606-8e23-95ec74cbec90', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '25 PETITE', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('3f16c52c-73f6-4a90-8d0e-3d63a1d44923', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f31cd8e-c06e-4902-afe1-90aab1fc851d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f3e3bac-e893-4a99-8718-a511590ad53f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-0e9d-e7cb-83bcdbfa9dfd', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f434338-c133-4e26-a0e1-3ba6449fe099', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f706327-b27b-482b-8b51-03fd7152a3f9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00T', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f70be35-5cdf-4cf6-9e9b-1c8a74d8f3b4', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f8844fd-96a5-4a09-a774-1713c9cd1f21', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '18 Short', NULL, '18 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3f903ecf-edae-482f-9882-9b678165f804', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '12/13', NULL, '12/13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f91e9bf-21c3-4048-b578-2e1a46ea3713', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16 REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f9446e7-2014-4fd5-882f-2a1909849f56', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M HSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3f9bf5a8-f585-4156-8659-73ef5be53b14', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('3fa3adbb-ed52-426a-9885-53b6822a5903', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '26+', NULL, '26 TAILLE FORTE', NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3fadbedc-569e-4b0a-899c-1f21e34720d7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3fcf7d2c-cc53-4f95-9c4b-3898d05cb38b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '30.5', NULL, '30 TAILLE FORTE', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('3fd1d9d6-e232-4a2d-afdc-d41ca6de153a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3fd58500-e606-4f6d-8f9a-4a53a3d7c258', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '18P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('3fe46675-b986-495d-81c9-331a82e92db5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S HUSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3fe72d6a-7acc-46e5-adbb-95959f7a8c3c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3 YEARS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3fe99815-2a2c-4939-8349-884c5ce87711', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ffb529b-cb5b-4c45-950e-2d876c3ab171', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('3ffbe920-35b0-4e59-b8e7-8da3f86aec88', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000', NULL, '000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('400219da-ff2c-40f4-891a-c81943faa05c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('400d5c60-1786-43c2-bba6-57315bd88ada', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS +', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('401cae08-fccf-472b-b7aa-67e45e696184', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('403eca25-7090-44a2-a639-4c226460f1e5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25TALL', NULL, '0/25 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40671287-ce1b-470d-9a15-d7629dd78499', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22 LONG', NULL, NULL, NULL, '170/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('40674213-3b80-4b93-89ad-7b50f4fe9a0e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '14 Short', NULL, '14 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('406a7a25-153a-4054-a67f-9f7d19be977f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30+', NULL, '30 TAILLE FORTE', NULL, '170/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('406edc49-096d-48dc-9121-fb8ced2f7438', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12 M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('406f546d-36d0-48bd-99c5-ab35ea4ad726', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24P', NULL, '00/24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40736b52-d79c-4b07-948a-5ed7826a92ae', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('407cc975-ccc9-44d0-9979-6145146d39c8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '8 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('408164ba-9ca3-4623-92d9-c6a7c315b5dd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14 REG', NULL, '14', NULL, '165/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('408d429e-861e-490d-86fa-37f9cc520bb1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('408eed48-e6aa-40d1-8983-c3a5522094ed', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('40924b13-799c-4c94-af51-47131157008b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('40aa392a-5208-4292-9fe8-c2687e2d5f47', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fc2a-f50a-b69401759c32', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40abe282-bcfa-4b79-88a7-61fa463d8e7e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18P', NULL, '18 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40b9b8c4-7f1b-4866-a20b-fcc089683b2a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 /34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40bb078e-0ce0-4bf3-81c1-f332e54a1b6a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '5 YEARS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40c1524d-b225-4fb5-8469-b1c9cb409f42', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 X34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40ccc36c-50c6-4719-84b1-35a5199f3fe5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 REG', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40ce06f7-ab17-4537-b1f8-ce63f6ae050f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'SREGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40d356b3-4e1f-4d67-b129-cd05d96b3741', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35L', NULL, '20/35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40db463c-0c72-4d61-9cb3-797096beb9ab', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40e538a7-6794-42b8-90e4-743d5ab594a3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e16-36d5-892d7cb07f93', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40e7a0f1-d0fe-4ede-bb1d-290f17ee8299', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XSSLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40e90596-db8b-4050-add9-fea2516fee52', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('40ee5b48-2af6-4dfe-b789-1eb460914cd7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40f00fbc-4cc5-4e00-beb1-a3c1db2bdfbc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXLREGULAR', NULL, 'TTG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40f4cb59-c7b7-4754-a27a-25dc58bf7069', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X32', NULL, '29X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('40f7a771-102b-45a2-acf8-8430c5107b98', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4103fe67-f88f-4353-8f66-220f59aefc9f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('410ae804-cce1-4bc4-8ed3-d8385ea47907', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4117414e-db0d-4284-856a-c88608d22940', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('41187361-1ba9-461a-a0c8-23aa0b59c963', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7 REG', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('411b3c4d-53b3-4a00-bad8-d665f9505e11', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34/18 Petite', NULL, '34/18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4120c636-1655-46bc-894b-e0fdf3ed1209', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('412269bd-f31c-4f7c-b9b8-6f86c1069e33', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '36R', NULL, '36 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('412603a7-e388-4bcc-a39a-820a10bf13d1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublicFactoryStore', '3-6 months', NULL, '3-6 months/mois  23-27 in.  58-69 cm  12-17 lbs.  5-7 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('41394423-5d10-42a1-b9b9-a1f8061b360a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('413bc379-9530-4a8a-97d7-1d5089e282d1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '12 TALL', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('413be79c-15f4-4de5-bce3-f44fe5cf24ed', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '27 TALL', NULL, '27 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('41409efa-352d-4b04-a687-c656257566bd', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '10', NULL, NULL, NULL, '270/87', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('41436bdc-28ae-4a03-be64-9dddad328881', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 / 32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4145d745-523f-4276-9364-8b5519b84d30', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41535cde-a60d-489a-9e2c-63a3790598f7', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'S SLIM', NULL, 'P (6-7) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4155235b-2866-406e-b807-56f9c98ae78c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '18 PETITE', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4166394a-9c3f-4d89-9e7c-5ee54a54c5f4', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '18+', NULL, '18 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4166f6ef-fd42-4c07-86d4-3bea5a9f2cd8', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-a48d-93be-70b1603b5160', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '98-106 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('416ed6b1-d369-4315-b316-da97ecd7a0e2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '175/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('417ce656-0d3e-4000-9670-5be8673d71e4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 TALL', NULL, '00/24 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41872bdf-9ce8-40e2-a406-7dbf12ef0ad8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('418e604e-a372-428e-ba35-013b70877702', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/ 30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4195b72c-7b9f-4841-abb3-d986fe06c6cb', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('419884f9-edf1-49b8-b9b6-245d24d4f6f9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6P', NULL, '6/28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('419a02b0-dcd9-4687-9589-63ea810bd366', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8 X 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('419a24a3-f99d-4a38-b381-46b3ac0611dc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10 REGULAR', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41a33688-f613-475b-b2d7-87104addf020', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27S', NULL, '4/27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41a8751e-0979-43bf-914f-4881c9b0bcda', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '27', NULL, '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('41c195d7-5f2b-4a29-8e1a-c047487faf4b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7HSKY', NULL, '7 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41cd6db0-42de-4ce0-bb13-e86708687f57', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '00 PETITE', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('41cde354-c83b-4213-8f5b-fde3019659a9', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41d25202-195c-4d96-89ad-bee37e392bd6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'SPLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41d74ff4-b283-4fb0-a35a-0382fb2289c1', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '16.5', NULL, '16 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('41e3f3e2-0558-4cf4-b502-bc3272aa1def', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10 PETITE ', NULL, '10/30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('41e80a85-fdbb-4b5e-85a8-b7d14427c536', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'S', NULL, 'P', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('420dea71-7540-4814-ab29-0479fe63e8bc', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4229b715-0adc-474f-a298-ead967ed1c10', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXLPLUS', NULL, 'TTG (14) TAILLE FORTE', NULL, '155/75 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('422bef47-4379-431b-bdd3-562d332fba2e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X30', NULL, '34X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('42308df0-97b9-4e56-a2ec-bceed55616ca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '3X-4X PLUS', NULL, '3X-4X TAILLE FORTE', NULL, '165/150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4234cd47-0f7c-4134-b7e0-57f4dfc638d1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4242e72f-7ced-4d3d-8032-426d8d3f225f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('42469696-fc7e-48c3-b56f-7b0b32878288', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 TALL', NULL, '20/35 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('42518af7-b933-4294-810c-c459961e0519', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29 L', NULL, '8/29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4252c93a-0558-4d89-907f-9b05fe75ef15', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32B', NULL, '32B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('425efd59-071e-44e9-9b16-8360ccbd25f0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL+', NULL, '2X', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('42668b41-c164-4eb3-b76c-da2ea98090d5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-120e-f174-83eed1baee83', 'BananaRepublicFactoryStore', '0-6 months', NULL, '0-6 months/mois  0-27 in. 0-69 cm   0--17 lbs 3-8 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4290ff62-7b11-4bb8-956f-b056d1910d55', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28P', NULL, '6/28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('42aded7d-c077-4a7b-b233-da8d1c43db9c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/ 32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('42b0627d-2733-459e-8aee-8c3a9dbe7929', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('42d1c41d-deea-485b-9db6-beb362279f9a', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '7.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('42e84e7c-0a74-44c7-bef4-f53798014ff6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34/18 Regular', NULL, '34/18 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('430a7505-42c7-4f2e-bf61-da186fec39ae', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('43130f1d-e42e-4f96-b22a-766433bd9fe1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4316706b-fe86-488e-891d-6391f958e3cf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22LONG', NULL, '0000/22 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('431875bc-fe00-4e3b-9520-3bea5d2ac21a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S', NULL, 'P', NULL, '160/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4336d9eb-cde6-4f78-a175-770c63f59560', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30TALL', NULL, '10/30 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('43414a5e-a975-4989-a7e2-99d79c4509e6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XS PETITE', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('43426a49-0bb8-4354-94ad-e26842d3fdda', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XS', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('434fe506-1b56-4418-8a63-f6da15b1be7c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXS/T', NULL, 'TTP GRAND', NULL, '160/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4356841d-a9ad-4758-81b3-6a201b147f31', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 / 28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('435e8c82-b05f-4f45-a3e7-336f033a51ac', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '24+', NULL, '24 TAILLE FORTE', NULL, '165/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('436651d9-af22-4cbf-9844-5b6bfc6cea13', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('436a0dcb-c425-4b61-9f40-b78a2ab26bc7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('43704ca4-4e7a-4358-82c4-ab33b9be48a3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4378a47d-5646-41e1-b465-1dcea3c7f53c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26+ REG', NULL, '26 TAILLE FORTE', NULL, '165/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('437d6e12-e5cb-41c1-bd60-d4b94cfbe351', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4384a749-6c5d-4d52-92ef-546ca82261f8', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36X36', NULL, NULL, NULL, '185/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4386d9d7-84bd-4396-a855-5da9fb5315cf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 SHORT', NULL, '1 COURT', NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('438b9721-a55f-47cb-aef4-c27c7a849faf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14P', NULL, NULL, NULL, '160/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43a13983-ccc2-4075-8460-a40811fde15a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5 SLIM', NULL, '5 ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43a26b52-7bc5-417f-94dc-bec18fdf7ad4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8 PLUS', NULL, '8 TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43ac353d-d48a-44e1-b98a-7fd6ce2259d8', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '31/12 TALL', NULL, '31/12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('43b3f7e6-d1fe-4ff1-ae6b-f1d293dd12ee', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XL SLIM', NULL, 'TG (12) ÉTROIT', NULL, '145/64 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43b4962b-6886-4d5d-8001-218214e61186', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS REGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('43c55488-417e-434d-80d4-daf59d472048', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('43c69109-b80c-4aad-b937-b718d72da90c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8+', NULL, '8 TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43c9e6cb-4d93-46ba-8d48-17d1d23f57ab', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXXXL', NULL, 'TTTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('43d464e7-f1ad-4d9a-9688-d502ba719074', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-87ee-0020-f6ad0d4b02e0', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('43de4238-83c5-4f9a-8756-325b3c4dc78d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('43eb4e71-fee3-4017-867d-d43ca5bc1400', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('43efe4a7-253c-44b4-9183-57d1a75240e6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 REG', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('43f40148-0f31-4978-92ce-f02be88e7513', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30', NULL, NULL, NULL, '170/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4403ad09-a515-4cd8-a877-abb4ea8cb9ee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4404572b-5fa9-40d4-b3f4-50b16ac0bd88', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-65c2-1cb4-e8b699a38e29', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('442374d3-0709-4f3c-b7e1-2bcadd56b6ef', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X 28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4427c18c-06dd-4958-a00a-0377930f5140', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27LONG', NULL, '4/27 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('442903f9-0be7-4b89-aa86-e94b5bcd0556', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '12P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('442e9b0a-1476-40b0-ae57-a1dab25a67ca', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('442eb99c-b9ae-4505-adb8-b4325b93c34e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40L TALL', NULL, '40L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4439c4c4-809e-4f33-bd94-a64f96428db5', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-b2ad-212c-21d3979d940b', 'OldNavy', 'S/M', NULL, 'P-M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('44443913-e168-4751-b54f-2b6dfdf79a4b', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6 HUSKY', NULL, '6 TAILLE FORTE', NULL, '120/62 - 6 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4449331c-864e-4503-878e-a18ed97a0014', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('44525340-d286-43a6-b9b0-e64ed8b70af3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4463e31a-128c-4d16-b97d-b9e4e89c03ad', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '12 Regular', NULL, '12 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('44647342-bec7-4a8a-b79a-c03dffb6dd86', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42DDD', NULL, NULL, NULL, 'F100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4466c2b1-380e-42ca-b8b3-857f1621ee6b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '34 X 32', NULL, '34 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('447018a1-d6c4-4af6-a102-c3040264bcea', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X30', NULL, '31X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44765f30-768b-4659-b285-a60d25482505', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X 30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44778027-202c-4fbc-92da-a327a240aeda', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L HUSKY', NULL, 'G (10) TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('448138cc-7154-480b-b828-84a2fe20b2d3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('448677cf-a567-4b7e-9fad-22bf722e0320', '3a106a3e-aa0f-f689-1ea9-73f47ce24812', '3a106a3e-aa62-1592-bbdc-475d7e7d56a9', 'OldNavy', 'S', NULL, 'P (12-24 M)', NULL, '80/47 - 90/47', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4486c895-7f15-439d-b761-f4f1687830e8', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16SHORT', NULL, '16 COURT', NULL, '165/112C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('448fd09b-736d-4026-9742-cc820b63c8ec', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27J', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4492f816-5e65-4d59-9fac-97e255b747d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('449530ab-3637-444e-b5be-a6734a650dc3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30/10', NULL, '30/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('449fad97-a6e9-4d3d-9a72-4f995d929c78', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30J REG', NULL, '10/30 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44a6d504-984d-4dba-a8e2-61a768c597b3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'XXS', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('44addc47-e6f0-4b6f-9d6e-64eff94af1dd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22 T', NULL, '0000/22 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44aec5a5-2ec4-4693-97e9-08709d681bd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 R', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44b3d757-a476-4f71-a61f-f0a2c45e4fad', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30P', NULL, '10/30 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44b47cfd-ca97-40aa-9c53-62d96ccbc97e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14 SLIM', NULL, '14 ÉTROIT', NULL, '150/63 -14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('44c1da2d-452c-4900-8361-993af53467cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9eaf-f686-592904d735f2', 'Gap', 'M', NULL, 'M (7/8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44cb79a3-f203-457d-9431-7b5d5667eedf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '0', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('44d3ae1a-8f8f-4445-bad4-c34da9f0aba1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44d6b653-d31d-4f7a-9f22-d953698f148c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000/ 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44dda46a-863e-4bc4-967e-ccabec053e4c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '28 TALL', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('44dff540-0ae7-4589-810f-f8388b239010', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00 / 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44e2f916-bc45-43f6-9d5d-ea6d88fed602', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 X 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44e6e1f6-6d04-404e-8d04-7aebd7413db1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS+', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44e95fc1-7723-45af-ba5a-4d09fb9a675d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('44f228b4-3c83-4909-9074-d3411e09dcc5', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '20', NULL, NULL, NULL, '170/120C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('44f7322d-0fd4-49ab-bcb2-bbce3bd5bdae', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('44ffcb83-7c57-4d7a-91b9-8fcb8f34eb17', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('450798e8-0300-409d-8c7f-237dd4e6c344', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('450d794d-050f-47c5-80a0-54b9768fce97', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('450db12b-7352-4f22-8440-c170d7fe3860', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL SLIM', NULL, 'TG (14) ÉTROIT', NULL, '150/58 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('45116efd-c7a8-43df-aae4-7fd5e4fd1ad6', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '2', NULL, NULL, NULL, '160/88C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4511909e-6e5e-428d-9cce-2607ba3ca54c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 L', NULL, '18 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4519a3d8-638d-4e46-99d1-3e559168adc2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45264ad1-576d-4c9e-ac40-790ecc8f59ec', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', 'PREEMIE – UP TO 5 LB', NULL, ' JUSQU''À 2,3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4536e6a1-b3b6-46ce-8cec-1fca659b35b3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '2 TALL', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4539d5ff-6f94-4bd3-921b-f21495ae9fba', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '32P', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4555f57b-294b-4ae3-840e-e80c5e710be0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45760134-35ee-4bc4-84fc-7c5dba0ff56f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45869497-75ce-43f2-954d-ae70818a30be', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'LREG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('458968e5-0aa0-4a05-8b5e-eba30086bb85', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '14S', NULL, '14 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('45964d3c-260b-4063-aee3-f570fdd20da5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('459f08dd-95f1-46f2-be89-0631e0d34a6f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '31 TALL', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('45a7fa25-ec29-4746-8238-6438e02ea4a2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '6S', NULL, '6 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('45c82fe4-2924-4e29-8b3e-600b14d3ed70', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45ca4b97-ce4d-4720-a48a-6c2a4e3bb9ad', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '38 Short', NULL, '38 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('45d81131-88d5-4af5-9169-e70f5193db02', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('45d9ca13-12fb-4067-9273-f5855b940c17', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 XLONG', NULL, '2 GRAND', NULL, '165/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('45d9fe4a-1c17-4123-a25b-f72065d373b2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45e0d1e3-2026-4818-9611-ffec4d5ab09f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-5cef-6463-8b67386d0802', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('45e3cfcb-4bec-4f39-a9d9-e8c65f2daa70', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('45f3d209-8a13-4c4d-be56-03363667a387', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'M (8)', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4607029a-72b8-47a9-a47c-d9483060d907', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X 30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('460879dd-7b7d-4792-a7b5-0d153f11e1a5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14 TALL', NULL, '14 GRAND', NULL, '170/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('460a7018-af5a-4054-879d-9f95972800c7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4614f790-8bd1-472f-b306-537dd348af4a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XLHSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46194f01-c0b3-4f52-a68c-dd332f404a5c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '8 Short', NULL, '8 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('461e4dd4-02da-4317-bcff-5268d4526315', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4621ff06-c9d3-4827-9117-abc4dc4489cd', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '165/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('463bf723-a86b-41e4-8d38-2f6b40b34f32', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('463f2eaa-dcb7-446f-8e28-0cb0cedda761', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00SHORT', NULL, '00 COURT', NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('46440e26-1b4f-4db9-80a2-4a556d0099bb', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('46513bbd-ae51-4c16-b1da-456934611922', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('465349d0-44f2-46a9-8a16-a0ce2e56d035', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25 P', NULL, '0/25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46606bc4-5d68-44f3-b950-7febfe690562', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('466af2d6-810f-458e-91e0-f4e3a6e37bfc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '24/00 Regular', NULL, '24/00 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('466cde93-3db9-4f8e-9af6-e2a6818f7938', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('466d19ce-9628-4b76-95f0-0afe2946cbdf', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '7', NULL, NULL, NULL, '140/63', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('466ee68b-551e-44c0-b260-52d4e6507a83', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '2 TALL', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('467118fa-37f5-49a4-b1f2-1a32a9eec994', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5', NULL, '5', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4673aa9b-166f-4a17-b66c-0c2c59aecff2', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4674e8df-a173-4372-8f89-709fd3f366a9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 REGULAR', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('468f46dd-6364-4cb1-8c1d-2cc258e4e50d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 / 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46952d35-ad56-45b7-96f5-1bedbd69af77', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L PETITE', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('469735e4-f68e-4794-a7dd-bac891ccc778', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXLR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4698f9f6-0a1e-4f91-8167-c4b2391cd19f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 X 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('469a25f9-c210-4686-8751-3fde2d712bd7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '4 YEARS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('469ad9ad-a757-4761-bf49-2d7528dba867', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X 36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('469fbdfd-5951-4937-90f7-21cc2ab77990', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46a4de26-1ede-4f35-8841-a91f31e95cb6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '10 PETITE', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('46ab0625-4e1c-438f-a5b4-ec7981e484db', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XL SLIM', NULL, 'TG (14) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('46aee21e-0891-4bce-9d8d-3454fae8fd88', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 SHORT', NULL, '16/33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46aff928-dd76-43a2-88ca-72ec0145e1fd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40 D', NULL, '40D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46b598b4-43c9-4b89-93cf-80641b446262', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '30 TALL', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('46c12deb-56fb-47aa-8b2f-c4ff7089df58', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 TALL', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46da8e97-a082-47e9-a8e7-ca24636ac713', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46dc4c19-c791-44f1-b8c8-2a611c5849bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X 30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('46f52e82-d133-49ff-82fe-6655261d83d0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('46fc3951-1497-4f2a-8cc7-3d4b05651c22', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('46fd6897-cddd-46ba-a3b0-42a3adeac422', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XSHSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47072fe2-b775-486b-8891-bb5a0cb9f934', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2R', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('470742d7-e9a1-4e13-a462-a4768261bad7', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('470a5d5a-4ea9-4873-ab49-5b40b8ea85b5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 /36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4713beba-e1e8-4248-8e9b-cee17b669488', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('47166e2e-9158-49b9-a4d6-a7b4cb187c6e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34D', NULL, '34D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('472106f4-9de8-45cd-bec4-c6eb5da21eca', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'M+', NULL, 'M (8) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('47218195-11ac-46bc-b78f-c41c773f6938', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('472b024d-b5cc-4dd6-b1c6-8fb5605b1226', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('472e6f17-6831-4411-bb05-ced82db0dd42', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M REG', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4733f243-7d50-4385-b9f1-3dc3d5d09241', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '31P', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('47447d96-d922-4c8f-8345-75bca7027fbc', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '32S', NULL, '32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4745d7fe-2f59-43b9-ba3a-7cab70773e9b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00 X24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('475fe2ed-4095-48c1-ba3b-b0818c07ed6e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'S/M  TALL', NULL, 'S/M  TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('47606664-ce44-4647-8590-ebcf53728884', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47669266-7a1d-4aac-a5aa-c7a11ef43c47', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XSREGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('476e0670-a720-4818-bdd7-8656f34b63d8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14 LONG', NULL, NULL, NULL, '170/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('47767096-ce21-4319-b607-8629c243aece', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL+', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47815939-cbae-4da2-8a07-dcdc4549a687', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4784aad9-2a60-4bf4-afdf-610a2d7b3e7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12T', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47914488-45ef-4665-b5e4-a45ebda0a086', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16T', NULL, '16/33 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('479f079c-3a04-4921-833f-8bd96e0c6ae3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '8 Petite', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('47b1790b-d40c-4fc2-bfbe-0acdd20abc34', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/ 30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47bb2e16-6643-4361-9b71-a43ff58b6d00', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47c15204-44fb-46e5-93d9-69d1e948affc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47c5c712-4b4b-42dd-82c8-ca4c396f8897', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '3', NULL, NULL, NULL, '110/56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('47ce7b62-f041-46f9-9f17-6faa3c460e04', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'L 16-16 1/2', NULL, 'G 16-16 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('47d57b5b-4577-4af5-b50d-8b078ce108e2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47e96a95-540c-42e0-b2c1-01067a987c2c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL', NULL, 'TG (14-16)', NULL, '155/69 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('47f7bfba-a353-422b-affa-3819843a8a5e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 P', NULL, '8/29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('47fa5e32-7a7a-47f8-a353-0f774458e3c7', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('48004eca-7141-463f-9cf0-da3aa79a3479', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 SHORT', NULL, '2 COURT', NULL, '155/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('480aca6b-60c9-42cb-8222-75e014e4cbf7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '10 TALL', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('48161a9f-6b54-4566-a157-8d70f2305ed8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('481b766b-771c-4b85-9136-58df5d946feb', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '6-9M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4831affe-80af-49e4-ab41-c94cfbf9cef4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('483de12a-e135-4910-8ce5-096b0c45dcfe', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32/14 Regular', NULL, '32/14 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('483fac33-d725-4802-a97d-960521df37ff', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 P', NULL, '2/26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('484dd9fa-0fa0-4c39-aacb-707acc585865', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('48533b92-d83e-4c1c-8e8f-c7c79df6955f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('485a4e61-557f-41f1-8ad8-3debbe100f3a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32 P', NULL, '32 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('48623572-d9ff-4fec-98a7-ccc6dce8507f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '32 LONG', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('486ea4ea-bfb0-429a-804f-bc4c7e673ff1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S REGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('486fa3f2-3d7a-43f4-9ac3-211554cd8405', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XS T', NULL, 'TP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4880a966-1c1b-4093-ac51-762cfa64a488', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4888ec22-73e3-479f-b138-475ec554a0f1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '16 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('48891422-a601-47d1-8ddf-6ae45d748b85', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6XSHORT', NULL, NULL, NULL, '155/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('488fa464-6bd1-44fd-a1df-40027fb4a731', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 X29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4891d046-3c46-4038-a519-8585feaa26c4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '31 LONG', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4892034d-c30c-42e4-824a-5e563bf49477', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '32 X 34', NULL, '32 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('48958cfa-ab96-4b7c-80bb-67348a2b01f6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('489b7d67-0fd2-4a2d-8efa-dca0782eec5f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('48be374d-6b71-4788-944f-dbbe22ea20be', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('48c194c2-ed07-45c6-80f9-2bebf52c4e4d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 T', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('48d487dd-fea5-4a1e-ad20-c73a053eed25', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38 REGULAR', NULL, '38 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('48de21b5-e4c2-4561-9b66-71ff3e0fe675', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublicFactoryStore', '0-3 months', NULL, '0-3 months/mois  0-23 in. 0-58 cm  0--12 lbs. 3-5 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('48e0c065-6e8a-41cf-9a00-7cb9b77e5f2f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('48e6694a-295d-45c3-bfb7-fe101e07bc33', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '50X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('48fedcbb-c9e9-4b5c-8059-96c5e0fe5abd', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '12 TALL', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('490bc820-4ab7-444f-a917-1555428e476e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '5 YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('491137b6-5b43-4003-ac16-c5e43cca4ef1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4913b290-4c68-48e7-a648-c53117e7e1cd', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M25/W0', NULL, 'H25/F0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4914e65e-0c60-4550-8057-99decb0deb86', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S', NULL, 'P', NULL, '160/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('49221a4e-d5b8-4227-8d3c-cfa77c7a5920', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL T', NULL, 'TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('49359777-122f-48e7-a556-f1ed287734b9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40S TALL', NULL, '40C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('494352d6-0aec-4160-8ee1-efc060410d54', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12X31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('494398ac-d99e-4102-bc73-f5d653676669', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4951bfb8-666a-4175-8f6d-f8b619a99054', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '3T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('495c69b5-9f8f-4b5b-b67b-e7692f66ac92', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '26 TALL', NULL, '26 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('497090a1-cf87-4071-a397-54cd2d824346', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28X34', NULL, NULL, NULL, '180/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4970e668-126c-4774-8785-daaa6550d7cc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '18 Regular', NULL, '18 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('497e26f5-4e44-470d-9e27-695862854c55', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7d68-c07a-b92a3815bbb5', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4980cfe3-ada1-4f33-a891-978662cd46ce', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('499269c3-b2e3-415c-882b-299f1b86b861', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M', NULL, NULL, NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('49949caf-cc1f-4d6c-8c83-6e560cca6181', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4999bd0d-3596-4faf-b618-08d65795a169', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XXS', NULL, 'TTP(26-27)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('499b74e1-1e0c-4b62-a0fd-588cb8882999', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XLREGULAR', NULL, 'TG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('499e1296-3423-4ad0-b470-061ef03378d1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'L REG', NULL, 'G Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('49ac70bf-f8ea-4eda-9db5-8158c43c55c6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31TALL', NULL, '12/31 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('49ba62f5-f119-4c9c-98c8-65ecf88ddcc8', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46L TALL', NULL, '46L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('49bb27f1-3dcd-44c6-b1ee-33e8ebdfb956', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20PETIT', NULL, NULL, NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('49bcb270-0680-4f0b-ba59-8926ec1bb594', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('49c4d02d-e628-469d-ba72-48248f20d45a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 / 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('49d9306f-2f84-4982-a9e3-c46e466058f3', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublicFactoryStore', 'Up to 7lb', NULL, 'baby/nouveau-né  0-17 in  0-43 cm  0-7 lbs. 0-3 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('49ea3c17-3cb0-4626-b04d-1e053b166cdd', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XL+', NULL, 'TG (14-16) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('49eada32-1111-4d47-a5a9-c0169068b748', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'S/M ', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('49f46897-88e6-4aac-bdef-a62bcb116c4b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44X 32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a01f624-20e8-4498-82e1-f3d762038843', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26 LONG', NULL, NULL, NULL, '170/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a1459cb-31a2-4fe3-baf4-53b89be19b69', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a148a1e-512d-4321-968d-b4974ed32f46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 S', NULL, '8 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a17cffa-028f-4d4f-9d7d-816f7508f59e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XS REGULAR', NULL, 'TP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a1c3458-2ab9-4afb-8c0d-122f44acbda6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 /32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a1e5e83-5d2f-40d6-8424-4bc3e0348db3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '32 P', NULL, '32 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4a1f487f-80be-4902-bf9d-a1b5a32c6b37', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XSREG', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a2ab7a4-72db-43f5-8638-dc84e37e0921', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, '130/56 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a36e1ef-983d-4860-9473-2c699b92c25c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '41', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4a37d3e7-7d7c-42b2-8093-f19a662081ca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS-S TALL', NULL, 'TP-P GRAND', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a419800-147a-48c0-ae02-2f333ad57606', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XSREG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a45b862-dd6e-4739-b0b9-97026375d213', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28X30', NULL, NULL, NULL, '170/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a51adb6-3513-4ba3-a747-bc6c84d6f85e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4a54e01b-c82d-4856-8e70-54bfb55c718a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1', NULL, NULL, NULL, '160/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a6fe8ac-5ab2-4b86-965b-eb96d87a5959', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a725c85-3c58-4f2b-87f2-ea160601a98c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4a76cfdd-544e-400d-92d9-70b7ba55d34a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S/T', NULL, 'P GRAND', NULL, '165/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a7bcb2f-ce0f-47c3-a4a6-469ccb5ebf63', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20XSHRT', NULL, NULL, NULL, '165/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4a7c3c37-2c7f-4a00-a3ed-d35a5fce409c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28/6 Regular', NULL, '28/6 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4a7e9e7f-f449-4a10-9570-25009285a75e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '34/18', NULL, '34/18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4a82d4f3-8d9e-4b8d-869f-c4359e6767bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a8e3536-fa86-4f2d-9d64-a997884ae331', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X 30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a919db1-c8a3-4f90-bdc8-c95847b74104', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4a92149c-08fa-41ba-ab34-ff5a39b3dae0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X 34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a93d7c6-04cf-4139-a74e-753002cef508', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'S T', NULL, 'P GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4a9603ee-8dac-4cea-bbb8-06eef74e9933', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXLXSRT', NULL, 'TTG PETITE', NULL, '165/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4aa57777-7174-4854-b96d-74bc82d7ec60', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4aab3682-2906-422f-87c6-844e00bad886', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 P', NULL, '000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4aceea71-8f3c-498b-bd2f-6051ec98f214', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '20', NULL, '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4ad34bf4-21b3-4ffb-9383-f704c5dc039f', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '13.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4ad616ff-81c5-49b5-8fd8-7dd80cec736b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '42 Regular', NULL, '42 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4af2d66c-8008-40e5-b14d-20b64187d536', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XXL', NULL, 'TTG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b03ac74-0f3e-4053-8910-d7c7a6876d7b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b03cd66-b3a6-42b9-8440-4be06f920bfa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '16 TALL', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4b0783f7-e302-42fa-924c-79179bedf2b7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '28/6', NULL, '28/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4b174862-93ef-44a0-ba78-ca0a5cb7d440', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'XXL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4b1767df-12aa-44a1-910d-a0f375eb008a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12 MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b20ffa5-f861-450d-84f4-6076f627eb18', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S SLIM', NULL, 'P (6) ÉTROIT', NULL, '120/53 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b2a5122-ae53-42a4-96f7-aac7781543e0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-ae4a-b884-905829162a3c', 'Gap', '7/8', NULL, '7/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b33e837-634e-41e6-ac02-7b16520e6c11', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 X28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b345675-5bbd-47a7-bc38-6e4eff7485e2', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '18.5', NULL, '18 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b37e00c-ed4f-4131-b02d-a8699c2112e3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b4252d4-f92d-4b2b-8a73-5f3ce77c1a79', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXLREG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b48dcca-aa7b-44e4-89e2-932e28bfdb6d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'L SLIM', NULL, 'G (10) ÉTROIT', NULL, '140/64 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b4a1457-8042-464f-bbf1-4de0a7039ccd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 S', NULL, '6 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b4f54b8-a699-4866-9442-a516a1241f8c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4b6f581d-fd4e-4feb-9323-acc42b0e20ee', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b74b4c9-cb35-43f6-aad7-fc0701ea003b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '8', NULL, NULL, NULL, '250/81', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b8d8a3b-42a7-4b7f-a688-c367060a10e7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'LREG', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4b92b57b-35fe-4c98-8e0d-f4886bc267f9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6', NULL, NULL, NULL, '160/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4b97df7f-e579-4e12-8989-124fcc6e1203', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4b9d83d2-4b9c-432b-aa6e-ba6742bb2014', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8T', NULL, '8/29 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ba93fdc-8d0e-482f-91e8-6ab865c05bae', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bae2376-1b81-48b4-aaba-c21dd69e2e16', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 / 34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bb430b9-1e6e-495c-b793-76d2d7d53ab0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bb7c6da-17c7-4a15-80c2-5688d193aefc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0 TALL', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bb7de24-1a84-4ffa-8ad9-9fb3d0be7c64', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4bc471b2-d3cc-49a3-ac75-b15a064e732a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '8', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4bdfcb92-c845-4e65-97d4-550917391f9a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'SR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4be0ee5e-f47b-431e-88cb-886792c2d9c8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24J', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4beacd6c-c5c9-40eb-9680-ee409341b785', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XS/P', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4bf173ce-b547-40ca-a775-6163b8c6f36c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 LONG', NULL, '16/33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bf96087-2b8e-4b92-9702-9926b4b29f87', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 LONG', NULL, '00/24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4bfb15e3-1a13-4106-9d36-c7fe7b0956bb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4 HUSKY', NULL, '4 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4c0f22ec-3014-462d-97ea-3948cb9c0544', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '12 TALL', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4c1730b2-1853-4f44-aae7-51ebb1e80b9e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '25 TALL', NULL, '25 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4c1ea4f4-7a72-40fe-b42c-45452ad664bb', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '6.5', NULL, '6 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4c2ffabb-4d27-42c6-8729-582a33ec82e1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4c37856b-91d6-43c8-973f-bc6634e5ff66', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4c491e68-f092-4021-9038-408bd797f008', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '8.5 ', NULL, '8.5 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4c50279e-ad5e-4d3f-8e5c-c4fe368dc19e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6331-d8ba-438a49af2b55', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4c64954c-5bd9-4cb7-89de-17306c9827ed', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M/P', NULL, NULL, NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4c6ace16-2058-49c3-bf7f-419ae24d4ebc', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'M/T', NULL, 'M/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4c6d7a41-fafc-40f5-b599-b8e2e483152a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4c8f2e59-1334-410f-aa3d-b128be0e07f9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '12 Petite', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4ca84a2f-c053-4bd7-8542-c1b502df321e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4cb33c67-4683-41e1-a37b-e228b0797eda', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4cbba599-b900-4582-b08f-03130ef64386', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '00 Petite', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4cbf9a4e-0e4f-498e-b858-6c7d2ef4234e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '27 x 28', NULL, '27 x 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4cce702a-99ae-49e4-a674-d9629a6ac456', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4cd2ab6b-c213-4c30-97b0-ab81f947c579', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 /34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4cda99a5-33d0-4b92-877c-6ded0ad183a4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ce55ba7-41ef-47e3-98cb-bf86a0a2e4c8', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36X34', NULL, NULL, NULL, '180/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4ced597d-7d37-4c8c-8494-66b94627335c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4cfa8458-5b2d-47bb-ab41-22f58091b1e8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 REGULAR', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4cfc2b5c-5e2f-415a-b34b-512ee38007d5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '170/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4d02a656-2d10-4eda-aaed-54ae377606df', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 X33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4d12732a-6724-461c-a4eb-e343c61f2193', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6HSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4d1b46b8-04ce-43f9-a371-e2dec32c596e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4d25fb38-2c62-4e1d-ac59-a4aad290b8ae', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-5b44-e938-a3c489e62f62', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '56 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4d2da908-b870-4d2b-b0bc-0f607554f8b2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'BananaRepublicFactoryStore', 'S', NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4d47de24-e650-44c9-bbaa-b5b7970d96b6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4d615f65-2742-4ad5-ad54-9f2cc2e003b3', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'XL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4d697df2-7ff1-4e7b-91c9-447c38b919c5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50 LONG', NULL, '50 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4d74a76a-b8af-46e0-8a93-66595d95ccc3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16X33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4d7d191a-9f56-4574-b916-42fe55316924', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '35 TALL', NULL, '35 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4d8e16db-da25-4676-81b0-a2cee3b9127d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4d941975-174a-4084-b9e0-ce16ca798746', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-c84f-6058-c43ce11f704f', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4d9c53ef-cdee-494e-805a-34d40ad46577', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4da402fd-652e-4a3a-ac35-985ade60c114', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 /34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4db3bbcd-3762-4a33-9ed1-e269230267f6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/ 34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4db61b76-61e9-434e-b1b2-4f3730d79600', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '4 Long', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4db6d786-9f5f-4a6c-8207-780f65d5263d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16PLUS', NULL, '16 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4dbd0698-0a48-4482-a385-4efe51c9c2de', '3a0c74c8-3055-8590-30a2-d59a6faa10a7', '3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'BananaRepublic', '20" x 20"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4dcb1bf6-6dc3-4709-b598-44a7e1c4a662', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28 P', NULL, '28 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4ded7247-7f50-49d5-aae5-a0a7e81e69b1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4deedb97-bd78-4ccf-88c4-436c7169c69d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL P', NULL, 'TTTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4dfe474e-3897-4328-9f95-df4b0c3cd41e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 /32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4dfe7184-2216-4948-8c56-3ac5e880aedf', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL+', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e034f8f-757f-45fd-9ed7-745e71aec43c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4e0589e5-356f-43df-8fa3-de8ff35e3059', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X 32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e2b08a6-542f-4661-ab29-4d4ccf154207', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S/P', NULL, 'P/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4e2bdbc4-8897-424e-9fb5-e73e6dde62ca', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e2beed2-4a11-4491-bf42-8e352cfba902', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e31ccb7-ed3b-44f7-b553-d669b16eaf71', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4e31d84a-2441-4ed1-95d9-f7d59b6bd031', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XLSLIM', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e331105-e803-47c0-872d-880d549fb7e3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14T', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e3bc965-6b06-40d5-8f14-20e3f189e733', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e4261ed-d9ec-49f3-b540-5b80ab51b798', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e4715cb-74af-49f7-8200-84a03792b507', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('4e47ac2b-d7a6-47f9-913d-e9dcc439faa3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4e4b30e3-66d6-4dce-b5cd-b090e213ee89', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '2/1/2024 12:00:00 AM', NULL, NULL, NULL, '210/76', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4e4cba15-5136-4ccf-b5c9-7948e5ebd71b', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'S/P', NULL, 'P/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4e4f1120-6ff3-4e0a-a316-e3773f2db2e4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'M T', NULL, 'M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e50b597-daca-4e47-975c-e5bc76aafef5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e56fc4d-94e4-4cca-a57a-0c6edfc37a22', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10 REG', NULL, '10', NULL, '165/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4e6001c0-556f-4bac-b617-5fbef89d5d99', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS', NULL, 'TP', NULL, '110/60 - 4-5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4e8e411a-d147-4003-8120-72c88acfbf09', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27P', NULL, '4/27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e92e83e-99b2-4ef7-b99c-09b9c922eae6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e9a4f1a-f047-4e34-8904-a27df8a247ac', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4e9e8882-8223-451d-98c6-34376c06be5c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24R', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ea8c5b6-b2e5-4709-8974-02f5724aeb1d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'XL', NULL, 'XL fits-shoe-sizes-5-6_TG-convient-aux-pointures-5-6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4eab2c67-fb9b-4944-8813-db13dfe9d953', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6L', NULL, '6/28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4eab83c7-8a1c-441e-b63e-d9953e3a889d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ebda18e-26b3-4df1-a6db-63b95739e84c', '3a106a3e-aa0f-f689-1ea9-73f47ce24812', '3a106a3e-aa62-1592-bbdc-475d7e7d56a9', 'OldNavy', 'M', NULL, 'M (2A-3A)', NULL, '90/50 - 100/50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4ed2792f-59b6-4a27-afd5-c4e63e29b251', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ee77598-c8ed-4dd7-9410-429a1c233c7b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3 YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ef6aec4-8588-466f-b2e9-1335ff19d3bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 /28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4ef80dde-dfcb-4d8b-8104-dfebc584b43c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL REG', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f035baf-ca4e-4030-88a3-b7fff1009500', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12PLUS', NULL, '12 TAILLE FORTE', NULL, '145/75 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4f0bfe49-8bbe-4d5c-af98-104510cadf9b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31J REG', NULL, '12/31 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f12a1d6-7b49-4d11-a209-b506bb973f38', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L HSKY', NULL, 'G COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f1e23b2-9570-4f7f-b4ce-4c59cc3fbfcf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18PETIT', NULL, NULL, NULL, '165/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4f2e2f35-df15-4a06-ba6f-8347f8926832', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 / 36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f43b012-ee66-4732-8bc8-4d1be2e497c2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS P', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f46ae36-8371-4880-8031-be079de23282', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XL/XXL TALL', NULL, 'XL/XXL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4f48be17-a710-4e48-af2e-8fbb68c54c05', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 / 32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f4bf14b-d0db-48ea-bbd7-89a2c070e47d', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '16 TALL', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4f5b32ac-0be9-4c2a-a2a2-72b57b424449', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f5d1025-cd7a-41e2-a9b5-95feeb6ec871', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f6bb7b4-6810-4675-8d9f-3fda13a7af92', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('4f78da10-3a40-4404-8eeb-190a97ee739a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f90a185-f746-4b54-82e5-40784c925fb2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4f98d14d-2615-4609-aeb9-12581714ac4d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4fa68975-b4a2-4478-856d-8ccb152c5d1f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XS/S TALL', NULL, 'XS/S TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4fa6cd37-de0d-4123-80bc-d3c8f893bc19', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4fb16b02-54cc-4e86-940a-facae8b34491', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4fb788ac-024c-4950-ab16-9d0049541f07', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('4fd34fe1-eb43-4870-b3df-cdc6cfe769c7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M SLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4fd6149f-e90e-4644-b135-d554b9a5c34c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'L', NULL, 'G (10-12)', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4fdc9b20-ba6f-46ac-bcf1-046b19b75a71', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'SREGULAR', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('4fe34320-6193-428d-b9c0-515090cd870a', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10SHORT', NULL, '10 COURT', NULL, '160/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('4fedbcc5-25bf-4b8e-b886-d96915c8e5a1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5003ea90-e045-46cf-822d-c24244c93d8e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30J', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5005e14c-9214-4a9d-bf17-5550987a7b91', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-e11c-301d-4e7abc8cbfea', 'BananaRepublicFactoryStore', '12-24 months', NULL, '12-24 months/mois  29-33 in 74-84 cm  22-30 lbs 10-14 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('500b5cf8-2edc-4286-bf8e-01e02e61b4ce', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4 REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5012d6ee-a559-475d-b365-8aed08494ded', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 /32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50143eec-e1df-4c65-86de-f0e0ca6081a5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50184c47-7f44-413a-a4ef-40f5245336dd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31 TALL', NULL, '31 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5024a06d-dd1b-463a-af58-b78be4f4cd03', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000T', NULL, '0000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5027d73c-0ba8-4f24-9ec9-5ac7ab56ca04', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '31 PETITE', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5028be0f-53b4-4f2a-b4f9-1714f759375c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('504d377f-5e0a-4b3c-908c-ce2d58b18e6b', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33X34', NULL, NULL, NULL, '180/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('505ece8a-56c2-4eac-8e3d-d983529ded90', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXS T', NULL, 'TTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('508acaff-34fb-464a-9929-58999091d06f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18L', NULL, '18/34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('508fcf0e-e64d-4315-ab86-981d41abc5c9', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5099123a-612f-4dd1-9991-d56473c09d60', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16 HUSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50bdb9f0-d2cd-4f52-977f-2e7ad7c3b1a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '30', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50c21078-a960-4158-abff-2d6e09914696', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50c8d4f0-f08d-497d-a1b2-f7583a88971b', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('50d15f43-3678-4f0c-a9d1-f51a36fd9f34', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '33P', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('50d44f79-439f-4b7e-830b-e8300881b421', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50d61ef2-8537-4676-9d4c-9db6acac1b82', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0 X25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50e18ec1-5fa3-40ed-b568-8aa05d8a48ed', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 /36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('50e9443b-5a6e-4ed2-b587-3921120d5160', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('50eff543-0480-482f-92da-c684b737e046', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XL/XXL ', NULL, 'TG/TTG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('50f4f017-69f3-472f-a342-26963ede4a1b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('50faea5e-f25c-46b7-bc01-d657897362e0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14 REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('510021b0-57c5-47e5-85b0-81d09d8408cd', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('510fc2c2-4517-4ad7-ba99-5f6404c6e23b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/ 36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('513493f2-c117-4748-b8ec-d480c41b9036', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-e115-fdbd-d29a32c010a6', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '175/185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('514a00f2-46bf-4742-a88a-4bcf59cb84e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '36 R', NULL, '36 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('514cb094-c112-4d60-a10d-b09283954f65', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('515149b9-3181-4dbb-8819-d8b6e18a130d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L HSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51590720-0a47-4665-8ad3-ad69c6b8cc91', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M-L TALL', NULL, 'M-G GRAND', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('51599d3f-1cda-4fd2-b2a4-219019079aa7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51601d25-4162-4c70-a391-da30b146b6e2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5164aba0-5764-45ca-aac8-b35cc2febcc0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('51710793-f289-4cde-bd7d-45f3842f3761', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('517687ba-cfd8-404e-a5b0-c46e27b75b9d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42X34', NULL, NULL, NULL, '180/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('517ef5c4-4a44-4f77-8b24-a40b758be46b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '38 X 32', NULL, '38 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('51a637fb-d549-4930-98d2-f89956866879', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('51ab401c-3b1a-48b0-83b8-d00c14def7ab', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXLSLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51d741c8-0061-48f5-b771-b93ada6a2316', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'L', NULL, 'L fits-shoe-sizes-3-4_G-convient-aux-pointures-3-4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51e56053-f1dc-4992-bf1c-1108760ab6a8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18+', NULL, '18 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51e7e2f1-30aa-4500-b533-6c2cde280295', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('51e9b33c-7b21-4c10-947f-6ee7f887bc98', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10 REG', NULL, '10', NULL, '165/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('51ed3951-c9b1-440b-9598-2d71f0ae23b7', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '54X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('51f65db3-5282-4091-9458-0121911bc08d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', 'PREEMIE – UP TO 5 LB', NULL, ' JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5201d89e-b6d3-48d9-b106-509cc0359e7c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/ 34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52025aea-4a3f-472f-bd0f-f8810ec78e77', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-d145-94a8-c29267eb9430', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('520b0b4e-b06b-458d-92eb-5b0116d4dc34', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26/2 Long', NULL, '26/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('521080df-ef8b-4594-abf3-93d2c1539839', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('52186ffc-6e1c-4ea0-a112-df8348dab3a5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7 HUSKY', NULL, '7 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5222e97f-2054-453f-b846-fc44ad2eb53e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000 X22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('522dc981-b589-4eef-a193-e31d84c7cdd3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('523f904a-bb9c-4418-9e9a-f52294be276d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6 +', NULL, '6 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('524b9bb6-3ff9-4cbf-8ffc-398d11496018', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18SHORT', NULL, '18 COURT', NULL, '165/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5251410c-ec10-4c49-b6c5-12dd689d4b81', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '24 LONG', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('52529003-e8d8-4e5c-bec5-51c54e8b7048', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X28', NULL, '28X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('526dc18b-7b67-4937-b2de-2c342cd23033', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 L', NULL, '12 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('526f9dad-ee63-463a-842f-c2249a059a04', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29 T', NULL, '8/29 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('528117e4-df10-49b6-89a5-8ad4adbcf438', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('528ad6c7-6324-4ec8-93db-84541bb84803', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XLHSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('528b8936-3372-4c73-a694-7282fb28640d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '3X-4X PLUS', NULL, '3X-4X TAILLE FORTE', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('528bcc05-6ff2-4f7c-880c-01dd41acd2b1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6c2b-8bdf-fed3dc8214fb', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('528cb79a-b4f3-46c6-ae32-2d85c16d44cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38 C', NULL, '38C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52921362-47f3-4464-82c8-6ca22f749375', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'S REG', NULL, 'P (6-7)', NULL, '120/64 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('52969b97-20a3-440d-a2e3-ef198c6d038f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('52b142c8-5c73-4814-bb94-6466cd1c3ce5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL +', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52bae486-f324-4910-89f9-3d279dea9118', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16 X 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52c04a79-fccf-4a13-8eed-f7d8970afabd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52c08503-f1ea-4cec-a51c-1b9d35392f82', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30/10 Petite', NULL, '30/10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('52c1ea73-fb9f-48d0-8cd6-ecca493b0cd6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9 M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52c241bc-16af-4477-b363-fe6443fe4a28', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f96b-e1e7-9a5d3b960c0f', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52c8d03f-2992-48dd-8e8e-e02f27f18982', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL PLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52d20383-965a-437c-89ff-0a7fb9423d2e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '2 Petite', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('52dab7c3-e4c9-4a7e-8258-a24f45355701', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S HUSKY', NULL, 'P COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('52dca459-9011-4aec-82be-1c84e2f07254', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '5T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('52f2dff4-b762-4667-9230-b1d63494ae75', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'S   ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('52f91a91-f88f-4ebc-869c-62b423b7c75f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31/12 Long', NULL, '31/12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('530c807a-fddc-4b1f-aa98-c7fbf0ef2858', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('530f862b-2a8e-4a39-8703-a64898d16862', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 TALL', NULL, '2 GRAND', NULL, '165/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5312482b-42ad-4cf9-b52a-be178d8c5c4e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILONGLONGE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('531c20ed-486e-460a-82cd-cd18757cb462', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L/P', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('531caca3-c92d-4a2d-90da-51be1caec660', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-49c2-60e8-0bb146df8a52', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('531eef44-e0e9-4976-a435-9cad5e7d5e00', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 REGULAR', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5323c9ef-bd0e-4b4a-9190-91c314610369', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34R TALL', NULL, '34S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5324c12b-6460-4cb1-b948-cfce22794fca', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5328db41-9f84-4afa-a0e5-f3d9c43ac097', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53363e64-4142-499b-b107-6914cddacfba', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL SLIM', NULL, 'TG (12) ÉTROIT', NULL, '145/58 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5337da52-c176-4dd9-a6f8-443922b34382', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-8cd6-cd0c-a8d7866c28bf', 'OldNavy', 'S/M', NULL, '8/5/2024 12:00:00 AM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5342fdef-9f4f-41a2-b422-27981d2ac61e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('534f6cda-9bcf-431c-b9e1-b76b3a859048', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '1X-2X PLUS', NULL, '1X-2X TAILLE FORTE', NULL, '160/125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('53556e9b-b997-490f-9b82-7f99aa2fd4cf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24/00 Petite', NULL, '24/00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('536656f7-3e13-4313-8fed-a594fcb599ce', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7 +', NULL, '7 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('537a3da0-a80e-4d42-8f3d-f399552839b3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22SHORT', NULL, '22 COURT', NULL, '160/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('537c559a-eb2f-4344-815c-7ab1ca582b74', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 /30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('537dd211-e613-4cff-bb3b-22c959f6aa37', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XLREGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53845d62-947c-44f2-bbfc-a17f7ab329df', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53987c7b-d75d-4ad8-9020-58f1bdb20fd6', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('539e0573-a8b0-4550-ba8d-88892e7fc7a7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '25 P', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('53a0905d-83fd-413a-917d-b55bf09e2037', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 L', NULL, '14 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53b1a5fc-e609-452c-8b23-79da6c304f71', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-45c1-f2af-4cad493341e4', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53b76ffa-bcc6-4c54-8551-2df3f0bd7057', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', '6-12 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('53bb1805-4f73-4a41-aabb-6de1cfcf53d4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL', NULL, 'TTG (18)', NULL, '165/72 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('53cc31d0-d277-4187-840d-dbabe69c382d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53da3783-c303-409d-a2e8-a4ab0d1e842e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/ 28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('53f7acd2-bad1-49da-8ded-5c6a002e89bf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22J REG', NULL, '0000/22 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5400840b-6cfd-4735-8de7-d4e6f576cfc5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20+', NULL, '20 TAILLE FORTE', NULL, '165/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('54098158-7a52-4e39-b6c7-51b34555cb72', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', '18-24 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('540e5bcf-3da2-46bd-be9f-7276d991523f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('541521d1-8423-461b-875a-be1de6f5d7a6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '30 X 30', NULL, '30 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('542a2aa8-ec35-4b95-bbe7-21b16e1e9382', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '4 TALL', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('543dfed1-58da-482a-8b28-c85f9f957240', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 / 34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('543e991d-e772-49dc-ba1e-c1550516ea59', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M32/W12', NULL, 'M32/W12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5441e0f2-572c-479d-962e-8d9370892b5f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54433ad5-0865-4323-b2a3-c82cf4a170d2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54674b29-26d7-4851-b582-ab84d5c5c0f1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '25 PETITE', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5468dbd8-fad9-48f5-96ea-1106fd64d9e9', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '10', NULL, NULL, NULL, '165/68', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('548d80ca-2301-4a0c-860e-0b5a0791c04c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('549ebd63-6b05-41e2-9556-9a8498340075', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5119-2c68-4a208711d430', 'BananaRepublic', 'Medium 32-34', NULL, 'Moyen 32-34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('54a45148-f79b-4cbe-b728-a1407fd346ad', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6 M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54c802e9-5cd6-4bfb-a43d-26d549aafa3e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL +', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54cc6baa-881c-4f79-8d16-3f5c3e50cada', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54cd0598-5832-480b-aa12-40882a44a761', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26SHORT', NULL, '2/26 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('54d258f3-e1ba-4d84-8685-c91c67b0dd0d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30+SHRT', NULL, '30 TAILLE FORTE COURT', NULL, '165/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('54e71537-883e-4755-a392-33731bad732b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42L TALL', NULL, '42L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('54eb7360-edaa-49cb-95ff-fdbc6d964761', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('55006d0a-7f10-4336-bad8-ee1386d4c49d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS/R', NULL, 'TTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('55137707-672c-422e-b49a-4967e375419f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5523ef22-c2ef-4f2e-945a-298cc177487a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40DDD', NULL, NULL, NULL, 'F95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5524d443-c238-4bc5-85ca-4ab5ceb90a10', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '7/6/2024 12:00:00 AM', NULL, '7/6/2024 12:00:00 AM', NULL, '240/79', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('552c7a8b-4d15-432e-a4f4-60dec249861a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'L/XL ', NULL, 'G/TG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('55400f1e-06cd-41c6-a3be-2d3c0dfacff0', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('554e43f4-0d18-4d7d-8784-145fe61f7bea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 REG', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('554ebec1-2b74-4e5b-8921-841a6add0782', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8P', NULL, '8 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('554efae6-31cd-4b0f-b259-67dc4e75eeac', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27L', NULL, '4/27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('555c6c69-9e34-4118-b68b-4cf26cbc4579', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('556e2ad5-7203-464e-bf03-328e5333c296', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '32 P', NULL, '32 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('557b6501-351d-488c-83b7-4f0de2175b5c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXS T', NULL, 'TTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('559bfcab-91af-4236-8f66-c61c305d32f1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c459-a695-1b0f4c446eb7', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('559e2540-528d-45bc-bcc4-0b6ea1536a85', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '18 Petite', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('55b1f02e-d340-4e40-962a-9877649e4170', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', 'NEWBORN UP TO 7 LBS', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55b36dc8-dcfb-4db5-bfa6-03c69f48a6aa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('55ba994a-72bb-48fa-9482-e0480135d120', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S XLONG', NULL, 'P GRAND', NULL, '165/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55bf6ddc-a46f-4f41-9d15-170ab1d626cd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44DDDD/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55c11dfd-0df7-4532-af4b-c9d54637e26b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('55c2399f-3fcb-48a1-a1cb-0738ecded170', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-a9e0-c5bf-9be9c8037172', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '175/185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55da686d-c8e8-4aa7-947b-9538f666f03c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-6d00-e662-f9075c9c03fa', 'BananaRepublic', 'XXS/XS', NULL, 'TTP/TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('55dd859b-5758-48d8-ade9-168327bfad54', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'OldNavy', 'L', NULL, 'G', NULL, '背长 x 胸围 56 x 89 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55e1cafc-51ec-4e0f-8bc2-e9314184006e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18HUSKY', NULL, '18 TAILLE FORTE', NULL, '165/81 - 14 岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('55fc764e-a56c-4ccb-a228-d4c0d95a31b7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '44L TALL', NULL, '44L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('55fd1af6-8779-4a05-9556-c71e534ac72e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 REG', NULL, '1', NULL, '160/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('560de885-2b51-4155-bd0d-bf907ca2bc02', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('560e9b01-d10f-4dc0-88d1-259a42d96e0f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32T', NULL, '14/32 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('562f6679-aca7-4d12-b996-7f7294400d31', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5631b944-6944-4fd1-9fa0-f5bf9488a6b3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 R', NULL, '0 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5635d20d-48a0-40af-a6af-46b9992e7d00', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12S', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('564e336f-5d74-424f-abdf-0aca41b32d50', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '33 X 30', NULL, '33 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('565f661c-6b20-4d63-91da-c88c285442f0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16XSHRT', NULL, NULL, NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5666e01b-2895-4d0f-acd2-af1faa439919', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL REG', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('566f7ba6-c5f4-4f06-b092-9e49384fba44', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5674dfdb-b758-48c7-ba41-2ea72e1e5d92', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('567c25b3-91fd-46d3-ba41-d035e3bd4ab8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L HUSKY', NULL, 'G COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('567d8601-458f-4035-afa2-261e2609556c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40DD', NULL, '40DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5681735f-7e5e-43a2-aa31-fba0256bacc9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 / 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5689e19b-0157-4ebf-8269-7b89526968a1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'SXSHORT', NULL, 'P PETITE', NULL, '155/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('56990a61-8ddf-4df6-b889-15a2484459fd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('56b70165-9ce8-4c6a-ab57-fdaa53fe652d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('56c0f8f8-c321-4f14-8989-ba2307c722e8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('56c55283-d962-4ef0-b326-0befe64597aa', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'S', NULL, 'P (10-11)', NULL, '175/69', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('56da25b7-f1cf-46aa-8b06-69ab32deb45f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '33 TALL', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('56dd4fd6-beaa-4f1f-aa2c-2ffc92a51d85', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '29/8 Long', NULL, '29/8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('56e928c5-2758-4b68-997d-b6bf1d883ea7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('56f41f28-5883-43cf-90bb-a27eeb37caff', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4 SLIM', NULL, '4 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5705883c-0947-42f2-afd8-bdf71f25c846', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34DDD', NULL, '34DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57076d53-0aa9-4b56-94f8-f5075b510e18', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('57207a62-cee6-406c-9505-9a7151ffad2d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 SHORT', NULL, '6/28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5726239b-f1f1-4b1f-b0f3-27beadfd748e', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('572823e2-4769-4bb8-a7f4-2e09c103d26c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57352dd1-1cd5-4d8a-a0fa-157c74214a61', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34REG', NULL, '18/34 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('573d874c-b654-4152-a1a1-04f742d85de7', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '20HUSKY', NULL, '20 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5740916e-f341-4168-bd26-5a1fadbbb065', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('574601c7-6514-4e0c-a1df-07adb4f0ac89', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5752d7a4-52c5-4e7f-aca8-eb6e0de1bc24', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X32', NULL, '35X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57558a4c-4e13-4723-9397-f8f4fd884639', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5766f072-a7d8-44d4-ae49-47e1ecae182c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XXS ', NULL, 'TTP ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5769caab-1e8d-40a6-82bb-83ad450210e4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12HUSKY', NULL, '12 TAILLE FORTE', NULL, '145/75 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('576ff2f9-59c7-47c0-93e4-90053a41137c', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '0-3M-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5771fb66-ea58-482a-a449-6aeb38a7fd58', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S R', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57789342-6025-458a-96c4-bd610ff2f50e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XS SLIM TALL', NULL, 'TP ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('577a0742-1ecd-4397-bcb5-d63d7004c14b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('578c057a-b14c-4340-bd34-40fb9f60064c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26X28', NULL, NULL, NULL, '165/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5796f639-f5ed-4831-858b-4acb01ed9cb3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9 MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57987938-1bab-4d49-a936-9485b7fd37c5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '14 TALL', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('57988038-0294-4803-938e-427b3496da58', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL/P', NULL, 'TG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('579c5be1-23e1-47c2-8519-320373f26c5b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXLXSRT', NULL, 'TTG PETITE', NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('57b1daa0-a391-48c9-85eb-b081fe015c92', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36R TALL', NULL, '36S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('57b43a65-fd86-4007-abce-376862671486', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublicFactoryStore', '6-12 months', NULL, '3 (6-12M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('57b69af3-fb36-4dec-a4f9-27c76022ad26', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6 TALL', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57bd94e0-e8ca-4b2b-be0b-e127964d6e2c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57c421ac-d0c4-4c12-88fe-29f2cd44376b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'M SLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57c5c9fa-81dd-462a-aa42-16b06b656f39', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 X23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57dacf6b-bb77-45d5-a533-0f4b392ddd13', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57e65210-49c6-4e75-a4d9-abd6202bfa7b', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M30/W10', NULL, 'M30/W10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57e6e116-e87e-4c0b-a979-37da70a6a3f2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57e7451b-af9d-4a51-bf47-54fd81b25712', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6/ 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57e7adb7-f69c-45e3-8b9b-d21f92577a48', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25J REG', NULL, '0/25 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57ee056d-c6f7-49da-991e-6ddac0e01a58', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('57f5d333-2672-420f-8acc-1b67067c5fb1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 /34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('580c835a-9c4d-4f31-8182-7b858b21ea96', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '9 ', NULL, '9 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('581407e3-875e-4f7d-b7a7-6a4845ab44b4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '24S TALL', NULL, '24S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('58157718-6994-446a-bd4e-a3a66dbebae4', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'S', NULL, 'P (6)', NULL, '120/64 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('581d74c4-dd39-46d8-948f-c5aa68abb85b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('58202d1d-04a6-4540-841c-2338c2db44be', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXLPLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5822a5d6-1763-43c1-9aee-d86940751b52', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X30', NULL, '36X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('582d0609-4033-423d-af96-fda3d1a39d71', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32TALL', NULL, '14/32 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('582f782f-a1c5-46bd-b3e7-cf6f4f55dc7a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12A', NULL, '12 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('585aed11-d5be-48b7-bf5a-1ed74d884c97', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '36 X 30', NULL, '36 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5865febb-f058-4010-ba08-deba6b844714', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '42 X 30', NULL, '42 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('586b4acc-1b3a-4cfd-9a8a-1a409d1f540e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'L T', NULL, 'G GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5879b82d-fe49-42b4-9259-198e7b807577', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29/8 Regular', NULL, '29/8 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('587cfe09-9fd4-426e-9b3f-240f4edc8cdd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0S', NULL, '0 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('587e7dde-df13-4e11-9973-c53e24121cef', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5884fe72-0610-4c8a-b8bb-21fd31900584', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('58850f50-090b-46ee-8c69-303d925e0299', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('589a08a2-4462-48b7-a93a-36be729c9c28', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50 REGULAR', NULL, '50 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('58b17a54-ec3b-4775-97c6-e14c717dd73e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '9', NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('58ba8d22-85c3-4d25-90a7-a8db54571fb1', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XXL/T', NULL, 'TTG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('58c72749-f027-4559-a8c5-5b744744a95d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL PLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('58cc5580-672a-4412-a6a0-2f35e70e639e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24J REG', NULL, '00/24 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('58cf17ab-2172-4a73-818a-666708f4ba71', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('58d2b0fe-d1fc-4bbd-b32a-b9a8ee99685a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/MP', NULL, 'P/M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('58d9c3d9-d141-46c1-929d-5c3b30d162de', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('58daf2fc-83e6-45f2-9b9d-f18d5f225488', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2', NULL, NULL, NULL, '160/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('58f9bbaf-70e3-4e21-b5ff-34d96d755b93', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('58fe0507-2259-42d7-a446-e137091971d8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS HUSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59156c3f-f7de-400f-a506-43252339fc21', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS R', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5915e6c8-c1be-4613-9bf4-67cf5b650e88', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('59230f67-ae62-4b73-a24f-45ac8c49d838', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL PLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('592b8f33-ff32-473c-b185-03e73124770a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5933cfb8-d3f3-457b-adcc-99bdc815eaa8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('59462f62-2676-42a9-a61a-afbb1609eade', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S REG', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59519227-ca2f-4179-b2d0-5d65d6e15721', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XSR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59616428-e9bf-4cd1-8d69-827fd5182196', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59757109-3c15-4004-b067-60e044dfa0d7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('597ec4e9-28f2-409f-b239-d8abb081f0fa', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('598ddf26-0c27-43e2-855a-504ad23336c3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X30', NULL, '42X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59996fc9-acf6-4a81-97d8-15bb40b5e502', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('59af04f8-89c5-4178-a2b2-cf72b7ac242d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7 REGULAR', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59b37416-e86c-4cec-92b0-d9b673623ccf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('59b834f8-e4c5-43ac-a541-f5bd86b2f0db', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6SHORT', NULL, '6 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59bae977-8121-433f-aaca-161fb2734092', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'MR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59c84faa-4700-4fad-ac6b-e9212e4713bb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '26 P', NULL, '26 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('59d4ac55-0bd6-4ade-8694-823260c35281', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL/R', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59d5e560-5c05-4baa-8435-5df08375b697', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '12-24M', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('59e923f1-6243-41c2-94a1-a07475f93cca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22S', NULL, '0000/22 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('59f576eb-b3b1-4418-a0ec-44430f6bedb6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('59f8e7db-0220-4e87-9fc9-4eb0111a98cb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14 REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a0ab0ec-f95f-46c1-b6ca-dfb56c939f6f', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L', NULL, 'G', NULL, '175/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5a10ce1f-3ec2-4cbf-a5c1-fc72aa765727', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5a181714-e6cd-473c-ad3c-76f432c497cf', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a2a1909-4fe4-49ce-8e45-030d3def4572', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '33 X 32', NULL, '33 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5a2a5e25-9ff8-4307-9546-dfc60e01a147', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL/P', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a33ab93-fbbe-44f6-a63f-d4de160e72aa', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a340688-09c0-4fe9-9cc5-93cc1f2883f7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4LONG', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a3c9e4d-0203-4a60-bd72-45c75c054f1d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29SHORT', NULL, '8/29 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL);
INSERT INTO "public"."wp_size_chart" ("id","product_gender_id","product_type_id","brand_type","original_size","us_size","canada_size","sp_size","china_size","ru_size","uk_size","eu_size","jp_size","it_size","fr_size","cn_size","mxsp_size","uy_size","id_size","kr_size","online","s1us_size","s2can_size","s3uk_size","s4eu_size","s5jp_size","s6","s7us_size","s8can_size","s9uk_size","s10eu_size","s11jp_size","s12it_size","s13fr_size","s14it_size","s15fr_size","extra_properties","concurrency_stamp","creation_time","creator_id","last_modification_time","last_modifier_id","is_deleted","deleter_id","deletion_time") VALUES ('5a411765-4ba8-4193-b287-783440de8f5b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-8117-8b6f-f6106a33ac4c', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a45c909-5061-4e19-b635-5c598d667937', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4SLIM', NULL, '4 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a49dfa4-d519-4879-becc-1db144ea8f6a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 /32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a4ac030-ad35-4265-8436-6882af5f2eb6', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5a606bb5-324c-454a-8628-38984ab9e35a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '00 TALL', NULL, '00 GRAND', NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5a641af0-bd69-4d05-92ca-af7833605eb8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26 /32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a652849-1245-448b-bc61-aab4b04d77ef', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a6e0c3f-f92d-40f4-9c37-145ab8391d09', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a71d5c4-4b48-4744-9451-5eac86ae2611', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34T', NULL, '18/34 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a76b16f-1144-4330-87b8-64267b7d42a0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5a864d6e-1d36-431d-8550-d5d456021ca7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5a8f5933-6812-4e07-8c62-e1bf525cb736', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'OldNavy', 'S', NULL, 'P', NULL, '背长 x 胸围 41 x 58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5a9934cb-a783-4ed2-9c37-773288bc0132', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-34c3-4e5c-11e6de75cf25', 'OldNavy', '1X', NULL, '1X TAILLE FORTE', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5aaf108f-933d-4791-9a78-43a969549505', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27T', NULL, '4/27 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ad27b26-7b2d-413d-9192-38e74bebdda3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5ad3daf7-f362-45f8-bb4c-2dc771162a56', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30 R', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5adf7887-d9c6-4270-94b9-9dc74b8c2710', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '10/11', NULL, '10/11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c89b173-0e81-4d84-a7a8-dcf2073441ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8 /29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5afc3b91-ca50-4d66-954b-af3f3b315c27', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', '18-24 months', NULL, '18-24 months/mois  31-33 in.  79-84 cm  27-30 lbs.  12-14 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5afd0984-a54f-4b23-82ac-5ca707cd4e19', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXXL/T', NULL, 'TTTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5b0196ec-930f-4328-9e86-5ebfea1efe97', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12 M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b0199d3-3560-4237-b094-3ef385ecfdc3', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5b08a149-6abd-4d3f-89f2-b251274302ca', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24 M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b10a70d-483e-42a7-8871-810a6fe1cbcd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14', NULL, NULL, NULL, '165/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5b133fe6-e666-45a2-b953-04b08bee3502', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL T', NULL, 'TTG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b164ccc-c524-4806-988a-76a5e42ee8ac', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'MHSKY', NULL, 'M COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b2004ef-1164-4084-9f6f-08a3ae2150d6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 REG', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b23fa43-7080-42ef-82ef-c52078476ff6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10HUSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b245afd-002a-41e0-9ecb-386d234cdf55', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b2fff38-1314-4c0d-8512-a2a4b1fe1a93', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5b3a3240-9018-478d-9647-b95b359edaa0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6P', NULL, '6 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b40e1aa-d3a4-4f2a-9e8f-7c21a94e3b65', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b4208c0-f070-4a13-8af6-7319fa1090c9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5b470c7d-b9bc-45ca-a2b5-47d4c6004df0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 SHORT', NULL, '6 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b49b5c6-fc50-4455-b50b-afe356ba051e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5b4c047b-c547-4e35-872b-ecea50ece7b4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 L', NULL, '0 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b5c473a-990d-4e80-98fa-add26438dd5a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b63b97a-151f-46fd-b552-0d40a26dd439', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'LSLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b794578-b2aa-42d1-8b6a-05c5b6d163a4', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', 'S', NULL, 'P (5-6)', NULL, '230/77', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5b7a9835-65f9-4a5c-895e-1dd065b0ee04', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '33P', NULL, '33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5b86cea2-137b-4b75-ae42-d93c848f9f92', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28REGULAR', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b9db139-d7f7-4dca-ba2c-daf43649334e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '29 LONG', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5b9dd509-3217-44bf-8a94-f5b1f3f48cf7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52 LONG', NULL, '52 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5b9e82a0-8856-4218-af2c-4e1a9f8070e6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9 MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5b9f3660-027a-4faf-a927-967c3af25336', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'M', NULL, NULL, NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5ba72af6-8af5-4ceb-bbb1-889e33c8c8cc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5SLIM', NULL, '5 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5bc845f0-12d9-46e0-8d15-b9df18a6b08b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X 36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5bc86d9a-64d5-4f8b-930a-28ef1d7b4fc9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4 SLIM', NULL, '4 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5bd80e65-865a-48f7-912c-2eb6dcaf0aea', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '23/000', NULL, '23/000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5be460b0-1f63-401e-a656-5a889afe9fd1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5becc881-eed4-4e8d-ae63-95e0cf1ada79', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '11/10/2024 12:00:00 AM', NULL, '11/10/2024 12:00:00 AM', NULL, '280/89', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5befb10e-53f1-476b-8336-9b617daf4e0a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c12bbee-a8bd-4339-90c9-86c2447c55f3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 / 30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c1a296f-ac66-4238-8564-7deb36bbc664', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c1da5b3-63b7-436d-ba7b-69a9494763a6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 SHORT', NULL, '20/35 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c29680c-d8e6-4a9b-b8e9-50be0a922de7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 SHORT', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c3417e6-eb6d-420b-9476-624c9d804b27', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X32', NULL, '31X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c35d3f0-6a8a-42e8-93e2-934409b1d76c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 TALL', NULL, '20/35 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c433834-3e77-4856-9bfa-c3bcee052c13', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X 28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c493942-6fba-47fd-821e-5236030779ee', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'L (10)', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c4dcc97-4be0-4692-ae42-9bbd06a1882a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33TALL', NULL, '16/33 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c61c99f-bc66-4301-a354-35c3454295fb', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5c623f87-990c-4d0b-8360-e05c693afa63', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXXL TALL', NULL, 'TTTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5c6420c2-f27e-4361-a101-0ec5d1314b87', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c643199-ca56-45be-b294-7efea147ea3b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X 28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c7144db-b089-47c2-9fd5-c53e5ba052b8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 REG', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5c78be22-c276-4eae-a4c3-2134f132c048', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '6YRS', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5c886e00-1b87-45ce-9d53-c13235241fc1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16', NULL, NULL, NULL, '170/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5c9247cc-3992-40ef-acac-612d1f865836', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2PETIT', NULL, NULL, NULL, '155/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5c92c29a-0f18-4b09-90c7-94dec406fbb4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28 X 28', NULL, '28 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5ca2cf9e-8481-46df-9bf2-c2927c777240', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5+', NULL, '5 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ca905d5-ae63-4ab4-8760-3da8f523c8ef', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10', NULL, '10', NULL, '140/61 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5cb3549b-c1d4-415d-a5e0-a8db550ad3c1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5cb63e01-46f7-4c94-9977-bd319a2ac525', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL REGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5cb8d7db-c52e-4b5b-90c6-476a17f7c78f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5cc64468-735a-444a-bba1-b34733352bf6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', 'M TALL', NULL, '15.5 x 34/35.5 = M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5ce0057c-56c1-4b17-b8c3-8489d0269959', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5ceb88d2-ca0d-4f74-a64a-1a394d05a7cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d1bec7d-c5db-4610-8579-d7d995d65685', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10 TALL', NULL, '10 GRAND', NULL, '170/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5d2f28e5-2702-4c62-a851-395d6c960171', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d47d3c3-c39c-4330-978d-0865b91e14f2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '6.5', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d4f6a82-ee8e-4854-b367-4baea78dc832', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5d50e890-bb66-452b-a6a2-439676cf8cb9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d5ac260-300a-488b-8f86-baa4ec01212f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXSR', NULL, 'TTTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d627c97-a701-49dd-af2e-34064e44771d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5d7d57a1-1d1b-4754-9101-2f741a5a13d7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5d7daaa5-d23a-40f7-b86d-f8631d3df899', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28 REGULAR', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5d99c70b-b5ad-4757-85a8-ecc05034fc6c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5da7a9d3-f3ec-494a-9a5f-4d9d039f95e0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000 TALL', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5dac54ee-846f-47ee-936c-bdd250d30528', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5db751f1-d957-4979-9cc9-78f83e1e84ac', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5dbea84d-1e48-42b0-8539-bfbdebd82d05', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/P', NULL, 'P P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5dc3c66d-15db-43a4-a77e-6ab063f06bd8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 LONG', NULL, '0000/22 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5dcabbd0-0458-4f56-8830-6b9dcb745a25', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0X 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5dd52897-03a3-474b-b6da-597198193880', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5ddef854-6aa3-4ffe-94b5-b99102a32bef', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL', NULL, 'TG (12)', NULL, '145/64 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5df1bf79-c3af-4093-8cc5-aa4051663f2a', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '28-30 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5e025653-1461-4bfd-a1b9-a2c517a66579', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e067a6a-b7f7-4ce5-85c4-ab29809040ab', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e0c9351-374c-4834-9cfd-b86770ab23b3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5e13ce4f-9ab3-4030-b7c1-fc86c4f3938c', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e150b24-f88c-4b1e-af62-ca0b6cabe2a5', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '7/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5e195ec5-ff96-4949-8d05-e80bfecb3423', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'UPTO7LB-Notuse', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5e3f8962-67ee-40a5-9076-48d15968b0f4', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '16 SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5e436713-be87-4387-b2eb-afb1c73df818', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5e4ac8fd-c857-4aab-b804-013a2f0f42fa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e62594d-0677-4c3a-8999-70d32d5d6a54', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5e6bb85e-1d92-43aa-86bb-15a68267811e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '175/185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5e730061-f179-4c3d-8392-c89869957d37', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5e74875c-31a4-459c-ba39-f79c4b621c64', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5e760784-a7d4-44c7-9b4d-c2c388849e4e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '20 Short', NULL, '20 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5e781a81-ccff-4398-ac56-cf08adce7772', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8 REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e841d4d-8bb6-4b79-8d99-46b6d2148a91', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '155/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5e9b753f-55b5-49c2-9387-5eaa213b1bff', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e9cd2fc-ad3a-4110-8af7-6acba9a25a88', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS/T', NULL, 'TTP  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5e9f1e7f-6838-4a1a-9767-c0e421b7441a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14/ 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ea37ede-f569-4305-870e-c2a9a1bc51e4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ea65174-840a-438c-8dd9-731eebf3511e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-c181-a8bd-98f9701619cf', 'Gap', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ea9e993-fb4d-4d22-abe0-316dd05cbe6b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'M/P', NULL, 'M/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5eb24896-e22b-47a7-a899-afeccb3f8d4e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5eb48d7b-e854-4d77-8c01-e472df1ac7e3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16X 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ec88add-d325-4e6c-b348-fe270423320c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e943-0e10-fa44023e6216', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ed4c58c-6511-4d12-ae57-efc9d8fa87f6', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38-TALL', NULL, '38 GRAND', NULL, '180/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5edde360-681d-484f-b7c2-b0d558d6930e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '40', NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ee0c0af-032e-4a86-8a00-e362d8b88084', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 LONG', NULL, NULL, NULL, '165/90C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5ee6ea15-9129-418d-b4cf-af203ce3ab51', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000', NULL, '000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ee84f85-25f4-442f-b823-cce703b63255', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5ef556fc-ac5e-413f-9c7c-8a778953a52b', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44X32', NULL, NULL, NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5effa40e-c1f5-45f7-9508-27956d78f60f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12 SLIM', NULL, '12 ÉTROIT', NULL, '145/60 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5f1f5447-a8f9-4f99-a6c1-9d0319c3ff2d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '44 REGULAR', NULL, '44 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5f2a6799-ab16-4bc3-9ab2-acbdf3e03352', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14', NULL, NULL, NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5f3f22a0-e56c-4f95-a338-e5fa7f71c107', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', 'UP TO 7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5f4fe864-a891-4c02-84d3-7b2de51e0dca', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5f5041e8-c6d9-4a96-a03f-5e681b6f9492', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5f5636e4-4e30-4309-81da-9118dbb13733', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5f5f9025-6f6b-4cab-99b0-70084a7d7251', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'M P', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5f615e0d-bfb1-437a-bacb-ff21ebd28b8b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X 34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5f694885-b304-4419-9381-8a9ef231a3c3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L SLIM', NULL, 'G (10-12) ÉTROIT', NULL, '140/60 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5f79a25a-6922-4d17-bedb-4718219d84f7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/ 30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5f8171e7-bfcc-4b8b-8ced-aaad6faa3ea3', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40X36', NULL, NULL, NULL, '185/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5f8b5a94-ee13-49a4-92e5-c2ecf8e155bb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5f98b5c3-253c-47f3-905b-d0b366407d5c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5fa25300-52c4-4ee8-acde-d74f9bd1e54d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS/S P', NULL, 'TP/P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('5fa590cb-231c-46cf-925f-cfcfe7929f64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL +', NULL, 'TTTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fa5e0d1-277c-4988-a3b1-47c844eda1e3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '20 LONG', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5fa60e95-306f-40aa-b7d8-1027466fe700', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '160/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5fb226b7-6621-491e-83ac-036127f2c906', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fbaa109-ace7-460f-b424-e5ad4c2bc65f', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14SHORT', NULL, '14 COURT', NULL, '160/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5fbae255-0361-4344-8f1c-4ebba1dbc53e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4HUSKY', NULL, '4 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fbd2222-b750-46c0-a7e7-47fe45bd4522', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-95bc-3dfc-0a1b593accae', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fc16590-b751-4710-a250-3602c7028e7f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14P', NULL, '14/32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fc7da6e-d731-4a45-ba9a-7768bea712cf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00/ 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fcddff4-e8b5-49e5-8d12-1a3942ddcde9', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16.5', NULL, '16 TAILLE FORTE', NULL, '160/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5fd53b99-4452-48ad-9e52-239c140f2d2e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '0 LONG', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5fd7cdb2-cd1c-428b-8435-94d0bd78cedb', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12SHORT', NULL, '12 COURT', NULL, '160/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5fd7df38-b887-432d-b720-4303c82983b2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 XLONG', NULL, '6 GRAND', NULL, '165/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('5fe077d4-ca93-4c5d-af85-804dd03f844b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S HSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fe3c471-48b9-4cb8-ae7a-38876156c0e2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 / 28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('5fe4e144-24f0-4dc9-bfbb-5d6482b59379', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'BananaRepublic', 'S 28/30', NULL, 'P 28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('5fe626c0-f601-486d-bed8-6716c184fe88', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('5feaad28-64f0-4b3b-81ac-d23e04899f56', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4XSHORT', NULL, NULL, NULL, '155/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('60006f54-cfa1-4848-aa98-97bdef0b7e86', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('600b693c-01f1-4cea-b937-dc9fff48e025', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '27 P', NULL, '27 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6010b5f9-7ec1-4c95-bf23-4c504507fef1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6031da42-c2c3-4fa8-a25e-3393bc6b01e7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6031f95d-40af-40ec-9904-fc08da06a78f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XL T', NULL, 'G/TG G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6035031e-1c35-4779-b141-84aeb247224f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7dcb-0ca5-19fb6787a519', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60424752-f79b-4a15-8ab9-816e36b9ab57', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60430682-4c93-409a-a06f-4521637b1bd0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '16 PETITE', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('604b1dde-9238-445b-a77c-b1ef2675b5e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10 SHORT', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6053cc1d-40df-4c8c-8c79-3c97b7b5878a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5b49-14b8-c57b35a022e2', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('605725b0-45f7-4c3e-b3b0-0f70c5c230cf', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('606a0bee-5196-446d-946c-22d91a7c684f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6073a7f1-06c2-4906-b669-db73193656a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22J', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('608228bc-0d56-4790-a275-f10604843274', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2 TALL', NULL, '2 GRAND', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('609d682c-603b-46c0-8184-72fb4b4b8285', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('609ecc46-90d7-4c5c-b843-e0e412ec005e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '27 SHORT', NULL, '27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('60a75074-cedb-4907-9adc-e6796a77d809', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4P', NULL, '4 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60a785d0-0c7d-42af-aa55-f2c1290a2a30', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60d479cc-02f9-4daa-9d92-b443c015a39b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M HSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60d6d53a-4127-41bc-8bde-e13f4f785261', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60deb967-435e-4464-abe1-7c492f7f0ab2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34 L', NULL, '18/34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('60e5357f-30d7-4e40-ad23-72ec3d3d06ed', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '24 P', NULL, '24 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('60fbcd0e-7caf-44c7-ad29-0008b9f587ea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/MT', NULL, 'P/M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61036c90-0f48-4a55-af27-4645ff25758f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6105b750-0b19-4937-90fc-f839d7548f7b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'MREGULAR', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('610bcf02-0357-45c5-bc0d-1446066f6095', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '0S', NULL, '0 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6116d218-31a8-4bc0-9aab-ee9792adfa78', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6121deeb-ab9e-42d2-b615-ce781ed08aea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35P', NULL, '20/35 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61265586-afc5-4e9c-8bcf-d82f9a43bb60', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL HUSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('612c57f2-a487-4985-ab0a-e6b2f95e07fc', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5b49-14b8-c57b35a022e2', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('612c5e66-904d-489d-8116-376714f2950e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('613db3d8-a18a-4cc9-b0c3-f68f40855454', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '22.5', NULL, '22 TAILLE FORTE', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('614241bc-b705-4802-930c-ab0a92663b4a', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'L', NULL, 'G (11)', NULL, '190/72', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('61466f7d-5ee4-4f41-86d7-6dd2731f617a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 REG', NULL, '2', NULL, '160/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6160307b-da78-4f83-a00c-4b11ecdf7b1f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18P', NULL, NULL, NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6179aa3a-762c-4605-bf49-54283568a1cb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXLHSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61a7c112-3732-478a-85c3-9d0c348fe583', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14 X32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61adad31-10c6-4981-bca1-6ff5e0c8aabb', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7 SLIM', NULL, '7 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61afcb90-cc95-48cb-bf5b-b7ed34b5cd15', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 / 30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61b60dad-b399-45df-b396-126233307795', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/36', NULL, '40/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61c85dff-26d5-4b92-957d-ef77ed9341c1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('61c8f4de-c3b6-4e22-a3e4-fb32b0dbf18f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '160/67 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('61c8f82c-67ff-41c4-a79d-70ad0ab00ee2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('61d219be-903c-4704-83ee-82febc70d42f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000S', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61df03aa-2f54-46f5-bbca-9f25b8d80799', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, '160/96C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('61e31698-f5d9-4ff8-87aa-bdfcd3a03163', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61e7ff0b-1e2b-4fe0-a250-7fdb43a319a5', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XS+', NULL, 'TP (5) TAILLE FORTE', NULL, '110/68 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('61ec9128-140f-4b78-913c-06bf3a08fdb6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '8.5', NULL, '8.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('61f3573b-0d36-401b-92ce-b65d207b3c97', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L HUSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62282953-6175-4b11-ad2a-03e4ca0b6666', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL+', NULL, 'TG (18) TAILLE FORTE', NULL, '160/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('62350f0c-68cb-43bc-9c39-cc21135a6e25', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X 32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('623f18a5-a529-4261-8abc-0e9711f4c960', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6241ec3b-e20d-47ea-a4e7-2c6ec96c05c3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XXL', NULL, 'TTG (18)', NULL, '165/80 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6241f43d-44bf-440c-b72b-8c12386e3bce', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'S TALL', NULL, 'S TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('626afe88-06c4-414f-af38-61550d3502cb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('6286ea00-461e-49c2-a54e-1037ce44ae56', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10 REGULAR', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('629a9ee5-641d-4e0b-b6ac-2957e2a75cb1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30A', NULL, '30A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('629e9fd7-bb8e-418c-806c-c89960055eb7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 REG', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62a5f3bc-cd8d-4fde-9a3f-4ff8732a0181', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62a6a5f3-caa5-43d8-a0de-954a961f1f3a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 L', NULL, '16 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62a9e28f-2535-432e-bfe0-922b863b2353', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 PETITE', NULL, '20/35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62b63d4d-cf8c-458b-b81e-b60589bf90b6', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', 'PREEMIE – UP TO 5 LB', NULL, '  prématuré JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('62b82175-3d66-4559-8687-0e1a52528b18', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23 L', NULL, '000/23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62c6afcf-d952-40f5-9c44-5b110ab69a70', '3a0c74c8-3055-8590-30a2-d59a6faa10a7', '3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'BananaRepublic', '24" x 24"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('62d524ce-b65d-48cc-a295-bac049e8d0d6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 /28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62d70695-2173-43d4-af7a-4c0acd02da6e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62decdf4-a0ee-4db7-b583-1f34b5dc8c67', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62e08482-a025-460f-a531-d6edbeb599a7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18 PLUS', NULL, '18 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62e9013d-0754-4191-aa62-dde3ed3eb870', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62ea214d-b59b-4371-96a6-ee30339fbad5', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36', NULL, NULL, NULL, '175/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('62efee3b-3ecc-4372-89a7-e31e924de6a1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '38 Regular', NULL, '38 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('62f14aa8-9214-410b-9fc1-5691706300da', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-19d9-e9ad-b1b188dae848', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '**', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('62f21d00-aa0c-44d2-a552-016e49b2d486', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12P', NULL, '12 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('62f78ad0-c9be-4bb1-823f-3d24deba2973', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63003d1a-23ed-4bcc-9328-ef2cf2eb553e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X 32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63088eec-457d-4cde-a7da-00fd6d658301', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '3/4', NULL, '3/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('630af18d-842c-43c8-bcd4-56534232899e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20 X35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63116d8d-1120-4a2f-983a-34fbb814383f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36D', NULL, '36D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6311bf3f-986e-4f65-85bd-a294a6877cf4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63149dea-6090-4751-a314-d39ed2e65231', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'L', NULL, 'L fits-shoe-sizes-3-4_G-convient-aux-pointures-3-4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6324950a-e6e9-4012-85c6-aa8c2cddae1d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5119-2c68-4a208711d430', 'BananaRepublic', 'Large 36-38', NULL, 'Grand 36-38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6331abfa-a60c-4d95-8011-20486ba10418', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26', NULL, '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('63327be5-5eea-4f84-989f-df99a5c55a01', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL SLIM', NULL, 'TTG (16) ÉTROIT', NULL, '160/61 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('634e1ad1-0614-43f5-86d5-ac0974ac1c45', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6S', NULL, '6 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('635914cd-76b5-468d-9543-3f8bab5ae4e2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'M/L ', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6369062a-4d0f-4a7b-bc26-fa378218ef38', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 TALL', NULL, '8/29 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('637fb2eb-78cd-4859-9c13-7a1c5c54eeac', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', 'UP TO 7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6385a9fc-31e0-4ba7-ae03-79f962dd5f34', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34-TALL', NULL, '34 GRAND', NULL, '180/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('638e4742-15c0-4118-8df9-cfbae32e90a5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-65c2-1cb4-e8b699a38e29', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('639862af-1464-4a12-8959-3a257b26bfb6', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 SHORT', NULL, '1 COURT', NULL, '155/86C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('63ad2672-bc8d-4f0e-b8d7-b9d113df5d89', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('63ae208e-041c-4e9b-b474-3bf8ce1af713', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1', NULL, NULL, NULL, '160/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('63b0f1e4-7ee0-40b4-be81-8d6a984c42af', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63b38d74-86f6-4f3d-9f38-3aea3773d0e1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63b57d9d-3ae7-4dc9-92b1-b50aa5d3eb67', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL/T', NULL, 'TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63c579ae-420a-441d-b2d3-778d5879b43d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XL', NULL, 'TG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('63c69383-5729-4382-bfa3-29efe539ec93', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'S 14-14 1/2 32-33"', NULL, 'S/P 14-14 1/2 32-33"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('63cc449c-0702-4be4-a4d8-b9460f923364', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '32 X 32', NULL, '32 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('63cfa8e3-47fa-4911-aac9-4b00d1579217', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL+', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63e044bb-23b6-43ec-be13-3d4693d26e03', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10 REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('63fff224-ea3f-4fdf-b86b-17937baabd5e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0df0-ca33-6fa4848dbade', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6404191e-9758-4f88-ad75-f6bbbb2dec9c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '33/16', NULL, '33/16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('640ef792-8c0d-4d33-841b-9fa4f74ce901', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL PETITE', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6418b07e-bb4b-4add-b756-83d99a62a981', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6432b43f-19dd-4db7-8b23-ac64562361af', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('644f70f1-f4be-48f7-a175-266728e54201', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('645545a9-1aa6-4c45-a9dd-17a8f9a9a415', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36-TALL', NULL, '36 GRAND', NULL, '180/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6457be62-b603-4ea3-b621-39a00512dcb2', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '6.5', NULL, NULL, NULL, '235/78', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('645c0100-850a-4002-ae90-ba888eb9721b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000SRT', NULL, '0000 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('646c7d17-99c8-448c-996b-0df41e46cf4c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '36 X 36', NULL, '36 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('646e1e56-3cdc-4874-8634-dac0a9006277', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '0 Long', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6476759f-974f-40a9-b81c-fa8120472469', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-d145-94a8-c29267eb9430', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64783ba9-b2f2-46eb-a353-6112c6630245', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '28 X 28', NULL, '28 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('647edc7d-b4b7-4999-95d9-52d699ae9fc7', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '11', NULL, NULL, NULL, '175/69', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('64862517-4f92-4ab8-bf3d-ac3625adee24', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 SHORT', NULL, '4 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('648b245b-7518-4b5b-9876-1e8563471629', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X36', NULL, '38X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('649c066a-3314-46f6-aa7c-eb45d58a534e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16 X33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('649c1d72-762b-4b7f-b3d0-09bbb621eee1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64a0baf8-115b-42ba-ad65-c7b3f6dd394e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('64af5909-a024-4785-8b56-fce49b6a4bca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL+', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64b22943-e679-4284-9eb6-6514a9471b37', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6 MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64b34a1e-3fc9-4bf2-a49e-a84262707f47', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL P', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64b84ce1-37af-472d-aeca-480fee9346b0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31J', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64b88bc8-2a7a-4ccc-b4e9-a249c8239fbc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '30 Regular', NULL, '30 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('64cea001-871d-4c88-bd5c-b66457d222fe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS T', NULL, 'TTP  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64d41ce4-71e6-44c7-8085-25c89650c761', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL', NULL, 'TG', NULL, '150/76 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('64d42ac9-5d18-4a9b-83b8-9656288e3f9b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '33/16 TALL', NULL, '33/16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('64dca282-5794-489f-8662-39360ade6b36', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XLP', NULL, 'G/TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64e99f77-d7e9-4bac-a6bb-3d32073a0d59', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '4 YEARS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64ecec5b-46c8-4579-ac93-d7ed6e78e080', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18LONG', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64f8bda0-103a-453f-8579-f902b7b586f8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXLREG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('64f9e4f0-3859-4d9b-852d-5e1f9ae39455', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL REG', NULL, 'TTG (14)', NULL, '155/69 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('64fab20c-7b1e-4ec1-b3d7-a03dfb56d47b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '40 X 34', NULL, '40 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('64fd1ee6-6ea2-4060-8ee0-59da68bd7031', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6505ee55-75b1-4db8-b95e-aabe59f29a11', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65169d6c-2645-41d0-a9bd-83fb0298f3b4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6522a6e3-3f70-404c-b6d4-c644764f3d70', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('653615d0-8ee5-489f-a39c-c7117d322417', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-b2ad-212c-21d3979d940b', 'OldNavy', 'M/L', NULL, 'M-G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65539c7b-01e5-48f1-b50a-9c172eb15b77', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '6T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65566695-de04-498f-a976-a29adbec4369', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16TALL', NULL, '16 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('655f01d7-2e48-4736-b880-d4e35dd40d05', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65643cc5-da3f-4882-8868-7f22daab2fcb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS SLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6564b9df-060a-4b3b-b6db-6afd3e829668', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL HSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6566c8ed-246e-43f8-a857-ee60534791a4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6586c27b-6fd7-45f5-a194-6da2d55389d4', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6594db80-eaad-4e86-8140-017a6949fc47', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 / 30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('659b37f7-b225-48d9-96e1-2bef9c65bd58', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34S', NULL, '18/34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65a48a07-74f8-4da2-8d49-2c0b8bcebafe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33 R', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65a70288-9017-4cc2-a4f1-9d4984e2251e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65b032bf-ddbb-4345-a3fa-d9f47700adef', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'S', NULL, 'P', NULL, '170/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65b2afaf-5050-423b-a76a-bb3e8bbaf20d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXXXL+', NULL, '4X', NULL, '170/160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65bcc2d1-92f0-45c1-90fd-44c6c39c17a0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/ 34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65c19880-a3f1-43c4-8863-3208c7529595', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL/P', NULL, 'TTG PETITE', NULL, '165/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65d42c5c-e871-4ac4-85a7-94730013fe3f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65d5e4ae-f536-4483-aae0-bc37f62ab39b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25R', NULL, '0/25 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65da9ee9-acc4-4fe2-9d59-53abc6be0a43', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '29 X 32', NULL, '29 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('65dc1f38-2d71-485d-8a76-eff02bff87f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 X22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65e29044-8d9c-47a6-b321-d4aee556060c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6.5', NULL, '6 TAILLE FORTE', NULL, '120/65 - 6岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65e2dcbb-1105-4afa-b837-5aa0bae90ab0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28SHORT', NULL, '28 COURT', NULL, '165/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('65e5a692-7428-4d4f-aaf9-b4aa23a6eb6a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXLREGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('65f6c8fa-3fcc-45ba-8a92-8565a6dc7ed8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '25', NULL, '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('65f92bb9-e66f-48c1-ab77-2ad762377a14', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'XL (12)', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66044f88-86d4-4ca4-a0cb-38f9fc0a70b4', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66090222-8159-4873-b0dd-7ffb50b835c0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('660abf60-fee3-453f-835d-45848bd7acae', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6616f517-f6b8-46d9-b921-579dda00bae0', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '10.5', NULL, NULL, NULL, '285/99', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('661c12b5-1500-4d4a-9e50-6f77409a97c9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'S', NULL, 'P', NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6624344b-cd4c-47bd-802c-cfed317d835d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18 LONG', NULL, NULL, NULL, '175/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6626aa35-0ba4-4bfe-9bf9-6bf46db4a34a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14X32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('662c847a-0b6a-44b7-9df5-7d71bbe4f537', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X 28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('662eefc9-50c3-43bf-b8d4-05695bdbfe6e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25', NULL, '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('66315096-1cc5-4d39-9bc5-632fe1e18f61', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6634c5b9-824a-4c29-bac6-cafb3b41bb54', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M26/W4', NULL, 'H26/F4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6634fef5-2bda-49a3-8fb5-cb875578d9b2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23L', NULL, '000/23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('663622f8-75aa-4b6d-94f7-975e0453fa6d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66363bd4-8c10-41df-8c2b-1400feb9a830', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '29 PETITE', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('663df0f9-e554-4d0a-ba2d-55d187a59bd0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14R', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6643b6e4-5326-483a-bf7d-1c5087c75ee4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, '160/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66495aca-c0a4-4a23-825c-3dd629035e0b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('666111be-0732-4efb-8b0f-a4d16becf7e5', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6667d5ae-35aa-4c79-84b3-ed719ad5628e', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M25/W0', NULL, 'H25/F0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66710591-79a1-4244-b1e2-a431e74a475b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '24/00', NULL, '24/00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6674bbb7-d6a6-42a2-a0d0-bfdd649b915d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 LONG', NULL, '2/26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('667f9845-bd59-4795-8786-b78ce4db5a53', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 /30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66803100-1000-4dab-9536-8ff10386506f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M (8)', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6682c8ae-b568-46d2-93ce-80b8f60d8400', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6699824f-ca25-4f3b-ba80-ce3fe21ba961', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12PLUS', NULL, '12 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('669bf197-7d51-41f9-9c74-bf1d3f789fe7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16 TALL', NULL, '16 GRAND', NULL, '175/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66a84142-2690-416c-98cc-d76014a520da', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('66b56a58-ea8c-4135-a61e-03375dae6d92', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00 TALL', NULL, '00 GRAND', NULL, '160/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66bb06e3-9b6f-4f30-ba0b-bf81958167ac', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', 'S', NULL, 'P (6-7)', NULL, '250/92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66cb2952-3ed5-4c53-a1d5-ca47cc8fa210', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5.5', NULL, '5 TAILLE FORTE', NULL, '110/65 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66e6bf3b-8aed-4bd6-9611-998dfa11b0c6', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', 'NEWBORN UP TO 7 LBS', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('66ec3346-d1cb-422c-b7a0-bae8f6fd6a2c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'S PETITE', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('66f0154b-8521-4e8b-ba25-4efe0e0adb74', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6708fb71-5e22-40fc-ad34-85d52b87b0c8', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'S/M  TALL', NULL, 'S/M  TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6712a10b-f78d-42ae-96a8-1c26a16ec94b', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XXL', NULL, 'TTG (14)', NULL, '155/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('671e5f44-aedc-447e-83e7-58a9fcb5c893', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S+', NULL, 'P (6-7) TAILLE FORTE', NULL, '120/68 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('67202712-acfc-464e-b565-ebfe7efc2c85', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('67284f1e-25c2-4156-bb32-c7ea5f1bf800', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XLREG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6741a853-5b08-46f1-816c-66d887fb872f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4P', NULL, '4/27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6745b40e-ac42-49bf-b2f4-d71903de6de8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38D', NULL, '38D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6746661f-b5c2-4abd-bd0f-0786928b08e3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6749c936-3e5a-4ef3-a37a-635a8c5d5758', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 R', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('674fd5d4-ba85-4ca8-b6e2-691f0b5ca176', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23P', NULL, '000/23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6778540d-37c3-422f-9ed1-2f30ff1ec43b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '33 X 30', NULL, '33 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('677dada5-7a07-46c7-b465-db8c156fb10d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7+', NULL, '7 TAILLE FORTE', NULL, '130/65 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('678548f4-d8c2-44d2-981b-65d0744899bd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '34/18 Petite', NULL, '34/18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6790ff5e-f409-4f8f-b7c6-296d495d7cab', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '44 Long', NULL, '44 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('67975d3f-4f33-4ef0-8559-5745a5e574ad', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('67980878-1d6a-4f1d-b685-d78c718b19ff', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('679f05a4-86e6-480a-a7d6-3867e5dfedc9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('67a89a0f-f409-4e9c-bfa0-6d65ef1a8053', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '5YEARS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('67ad5090-9fa7-4055-8478-163a074381fe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('67b92b63-ae3e-49f9-a580-671b8cd6e4bd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 TALL', NULL, '2/26 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('67cddfec-19de-4dd4-b9aa-f9cb59da7280', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('67d9b2e5-7b8e-4fb9-861f-ee72d173be42', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '15 x 32/33', NULL, '15 x 32/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('67f4b59e-94ca-42ce-85f3-72a616cd694e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '31/12', NULL, '31/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('68161a46-bffa-494d-850b-a57e53059b5f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6816dde2-91e9-4a24-95c2-1598760dba71', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('681b13e1-eda8-453b-a322-91d7d57b23b4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('681d195a-eb56-4693-b36f-7c7baf39a051', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6848b1bc-6c11-4056-882a-822925feb256', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23S', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('685c85c3-e657-476b-bbf9-c95c5128adaf', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6862b53b-32ba-4696-a7b5-45959a4e3a5d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18 REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6869ea1a-e127-4cad-b582-2ad677fe74f4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00R', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68757b1e-88ab-4cde-af61-caee3ce233a0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6875f50c-54f7-4d75-97f6-8008c4e67baa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/ 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('687b3370-0f7b-4001-bd3b-bedb64d6bf2c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '28.5', NULL, '28 TAILLE FORTE', NULL, '170/148C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('687c6f26-7dea-4a9e-b839-6976233c678d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, '17.5-19 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6881ed64-7f34-442c-9744-04790347e3cf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X 30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6887d0cb-c5b3-406a-8c28-74051d861815', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XL HSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('688fc5b5-68ab-431f-b350-41acb7944bd3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'S', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('688fe7d1-afdc-4aa1-a444-8581f2eb6a79', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X 30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6891311e-ebdb-406a-8ec8-2bd60261f051', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68973d56-44c2-42ad-9a3e-e6e535570a75', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36X30', NULL, NULL, NULL, '170/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('68ac398c-f9ca-47fd-b3f9-d8509cb93ac6', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '35 X 36', NULL, '35 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('68b4ba95-4f06-4622-b42e-e19ec9b8ba4d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28TALL', NULL, '6/28 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68b4d154-d471-4460-a148-c30508a75a95', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68c74c2f-c7f1-4a91-af19-6af50caab557', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68c922cf-1d9d-4c71-9a30-ed63e9a06e90', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68d7ef04-d2b0-4d31-b8ac-6d98cadb46f6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 TALL', NULL, '1 GRAND', NULL, '165/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('68e7fae3-9613-438b-aa9f-c966cd22312b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('68fa538a-e7b2-47ba-a682-09023c7452c1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6905baa6-45ad-4b4c-909d-81cfd09e22e3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '38 X 28', NULL, '38 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('691842df-7d51-4d05-8e73-7df13494d2ae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 A', NULL, '36A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6925c7bc-59dd-4e41-b762-806a9ad9098a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('692851bc-5c46-48a3-a22b-665b86f802a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8X 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('693a210f-c6c2-4e3d-9063-921f34a58107', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('693c6b25-89b7-4feb-80fd-a744fb7c1f73', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000T', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('693e2311-3d50-4fe0-80bc-91a0b878a5c1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6942acc2-a985-43b0-a9a3-39931c75b91c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('694ff1a2-323a-4bc8-9ab2-7b0d544f3c25', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000X 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69593ebf-1138-4051-add4-8fbc635f9d6a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS REG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('695b973b-c896-4f85-b1a1-a9a05bb962f4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18P', NULL, NULL, NULL, '165/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('696337be-4b5e-4fa9-a8b9-b32df200555f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X 36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6981c1dd-cde0-4524-8892-e046e7cb59c0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('698aeeb6-7215-49d4-ade2-55b1b967d0bd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '4 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('698de47d-9355-4e71-8583-8808da9fd4ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000TAL', NULL, '0000 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('698e760a-68f1-4654-9263-d82d03055ac5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6991d32a-6718-49c6-9fdb-1524d13e7f64', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69942af1-063a-435e-9b0f-0ffe2142afda', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('699d81fc-1a18-4862-8535-1ea8afd3ccc9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('69a3abb6-7ae6-4027-b052-eae80b100859', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26X30', NULL, NULL, NULL, '170/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('69a4bd0c-9222-40d9-a4b8-57319425d992', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000L', NULL, '0000 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69aabc0a-b660-47aa-accd-2ec4a6e027c1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 X 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69b9dedc-336e-47b2-aec4-d5c825d0bcc3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44/30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69cabb8b-68f9-4329-922d-aed01dde2fbf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('69cda9ab-acfa-49a7-b361-9d6512fe8329', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 REGULAR', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69d23ea5-0098-4b6e-bc5e-afe0dd9f9f79', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '10 Petite', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('69e163b3-551a-4a4c-8fd1-3912a334fedd', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', 'UP TO 7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('69f07fd9-92a0-44ed-9e6b-6add79c38935', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28J REG', NULL, '6/28 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69f1c26c-3d00-441d-ba06-74b666809f90', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'MREGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('69fcaf53-fc9a-4ab3-b01b-27bdaf73a9ac', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6a04ccda-c16a-4917-84b9-159b482b9852', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6a11e836-8f33-4ab1-b7fe-098b94c54e40', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'BananaRepublicFactoryStore', '18-24 months', NULL, '18-24 months/mois  31-33 in.  79-84 cm  27-30 lbs.  12-14 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6a180a41-9223-499c-9e5c-45432078ba84', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S SLIM', NULL, 'P (6-7) ÉTROIT', NULL, '120/53 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6a40c97d-b532-482c-95a3-cbe09c8abf31', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'M 16 1/2" 36 1/2" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6a48a4dc-3b23-4ef9-b6b0-f69e355c1b75', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6a500774-746b-405a-ac4b-3fff66d7862b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '24P', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6a74f7cc-4b65-4019-97ae-25a138b3ad66', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '27 LONG', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6a7e9931-631f-4ad5-a30f-ba007643c194', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'XL', NULL, 'XL fits-shoe-sizes-5-6_TG-convient-aux-pointures-5-6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6a7ed07c-f1d3-46e2-8efa-7bb5e4df004e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '25 TALL', NULL, '25 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6a92014d-5d9a-4861-a04d-6a1daff54c4c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6aa5b4ed-1ee6-4e40-a6af-be90527fe100', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14HUSKY', NULL, '14 TAILLE FORTE', NULL, '155/75 -14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6aa89b9b-89f7-4db1-8ede-573fb2db7b4b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6aa8e891-40e0-4c76-91a0-7835d595bffa', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('6aab50b3-9fed-4a51-b41c-84e6ed57d315', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '25/0 Petite', NULL, '25/0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6ab1165e-b88c-47ed-8df4-98c85eea4cf0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00P', NULL, NULL, NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6ab515a8-e2fb-4717-a4c5-bc80ec0b9f26', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '4 Petite', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6ac37866-2dc3-487e-9a8c-e5a1d3dd544b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6accdd26-95e5-4026-a484-139aa25390ee', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6acd5e70-0caa-4d5c-9d51-272e77d66394', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L+', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6acf6196-4c7f-4a64-b8bf-d56cdc4ad93c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L', NULL, 'G (10-12)', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6ae06182-b44b-4ffe-bd8d-bea1ab4a6d5b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6ae592d3-7338-4e51-ba87-e0bb78265ad3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-4811-7a0d-f7453d8c0729', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6af81e05-9ea7-4ef5-9a7a-f47eddaa05f3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'SHSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6af99239-fd94-4e83-a09e-e698b529acbd', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b187d80-1def-4993-ac21-f41cd164ee0c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b215177-cf0e-407c-b738-25955dc77f17', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18+', NULL, '18 TAILLE FORTE', NULL, '160/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6b2d3aa5-0a30-476d-a52a-ba4bc9763e7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31P', NULL, '12/31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b2d9d1e-0599-43cb-8841-cbedc94c656c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 PETITE  ', NULL, '0/25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b2f936c-3e2a-4e4d-b8e8-27b70d875961', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-e115-fdbd-d29a32c010a6', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6b3ac822-5a14-4fbc-88fe-898262234e80', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6b3ddebb-8241-46a5-95dc-90ac7bd4d71c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-0e9d-e7cb-83bcdbfa9dfd', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b4172a6-5198-4487-a8b6-294f90671eaa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6b445d46-a9cc-4ab9-b339-d8eb20ee2d45', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-ae4a-b884-905829162a3c', 'Gap', '11/12', NULL, '11/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b4b023b-adfd-45c3-97e6-67f959bcc1ad', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '12.5', NULL, '12 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6b59babb-b62e-4667-b5a9-1a846928f958', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14R', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6b5d1a41-f143-4634-bed3-7fbabe08840c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '30 P', NULL, '30 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6b6cadc1-62cb-4c62-a4f7-2e0406270654', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '34 X 28', NULL, '34 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6b6dee50-5430-4d01-99fb-3a4ec72030e4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '20 Petite', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6b81b35f-d1c0-4608-bae0-2a95d4913fcb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '24S', NULL, '24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6b8ddc06-3880-4ee8-b701-4532725a28bb', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8', NULL, '8', NULL, '165/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6b92a7fb-f44d-480e-9ae9-d0b2da015607', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6be74de2-f2a4-4505-9950-cb23ded00e23', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20 LONG', NULL, NULL, NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6be968db-7874-43b5-9047-9fdd0cb76ff1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24 P', NULL, '00/24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6bf0c07a-32ca-4b30-8545-57274b4855e7', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8406-e648-f4efcd581d1f', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6bf678e0-7a75-497c-8b85-285e32063032', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18X 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6bfe5591-fa90-4ace-a70e-d0424f6db08d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22P', NULL, '0000/22 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c0241c0-2e6e-4cb2-a1fc-6492833279dd', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X 36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c0545dc-0798-41dd-a375-15caf965bfcc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c05909b-7fca-404f-a91a-e51e6d4bc116', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6c0a2398-4b0d-4d8f-969d-fde56ba8c1bd', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 LONG', NULL, NULL, NULL, '165/86C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6c2dad20-2dee-4841-8a0e-46c66340a35d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS PETITE', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6c37b6e5-ee9f-4061-aae4-ec5198f10e47', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'M', NULL, NULL, NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6c37e010-e815-4ef0-8b71-83cef1627b48', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c470f6d-459c-464a-8a0e-7d5ed759e8f8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c49aca6-f31c-42a4-a9ac-a662f3c99d8e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'M', NULL, NULL, NULL, '175/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6c4a2803-5457-4f4b-998a-918acc9ceb2a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9 M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c4d3553-ae22-404b-ad03-ad3905350b6e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6c618f79-1216-4c58-80bf-31226fb013c6', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'XS-S (10-13)', NULL, 'TP-P (10-13)', NULL, '16-19 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6c647f38-31d6-4649-921f-ee71a8c22e43', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29P', NULL, '8/29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c72436f-34ba-4eb0-845f-0e69688582f2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL/XXL P', NULL, 'TG/TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6c7f025b-1a70-48ce-9427-98dc1a8c4978', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24/00 Regular', NULL, '24/00 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6c81aeac-0de2-4cbd-bdf9-114c989d65e9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 LONG', NULL, '0/25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6c828b04-38f3-4621-90b6-375281501c0f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '29 X 32', NULL, '29 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6c849d1f-3831-4170-a5dd-ad01bcd6b027', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10 SLIM', NULL, '10 ÉTROIT', NULL, '140/55 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6cac1891-c8e1-471e-b1bc-3b840a69a66c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6cc43792-4d50-4de8-b5aa-0bc59b74cc72', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S T', NULL, 'P GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6cce8299-c2e8-4538-9e83-9352a2e687ad', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26/2', NULL, '26/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6cd06167-0e95-4963-9bf4-1fd92345f58a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6cd460f0-c4e0-488b-b444-5db256cfe882', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ce2fb78-69eb-4502-b634-dd524a787664', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8LONG', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ced7a35-9a1c-4e58-ab61-cfd506832421', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6cfb92d4-2f8c-4245-854d-b177b4fd5c5a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 R', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d03009d-4f5a-4994-a2b8-2463b1ff759d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '34/18 Long', NULL, '34/18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d0ad68d-ddbc-458c-a4a5-46e43ff11e0f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XSREG', NULL, 'TP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d1104b2-bd7e-437a-8d58-c875f3f13a16', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4', NULL, NULL, NULL, '160/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6d251bef-6f8f-4122-89c2-085797d04e2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d27e51d-d1e6-4afa-89d3-88db16771d15', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '31 TALL', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6d2ace46-4e35-4b3d-bbb5-1f4035a6ff13', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d307300-6aa2-4db0-af12-8aef0622fb08', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d3b79d5-4065-495b-a041-0719bb0cd9b1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d3cfd98-a641-49ee-85f3-77a79ebb9f24', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '28/6 Long', NULL, '28/6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d3d2873-7e8f-420d-ba01-73e0412e4b42', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'M', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d40fd94-0e74-433f-8f9a-b497b5053837', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30 B', NULL, '30B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d45bb4e-1832-4cff-afae-a36f39363c71', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '32L', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6d550838-a982-4cbd-8d8b-e7ac6d24b408', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6d63e880-41ed-431d-b216-a823883b4f79', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d68f092-042e-4322-9020-933f96edaf23', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 DDD', NULL, '34DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d6f2434-8e57-4748-867d-f10154e9d10d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L REG', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6d88bad7-b7f7-41a9-b980-a5273adace91', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25/0 Long', NULL, '25/0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d93f66b-e90e-4ea3-94e7-ee96f8ed7f1a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L/XL PETITE', NULL, 'G/TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6d94500f-9a7e-4406-ac5f-d2251790c409', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32R TALL', NULL, '32S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6da06198-69de-48ee-9e5f-e5f026386e65', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X32', NULL, '38X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6da2c61a-b8b6-4fb4-b02c-6d78008a207c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '25/0 Long', NULL, '25/0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6da75f8d-345f-49aa-b5c3-8c7665dfb535', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6dbccf02-d583-4ca5-8ba1-8d5b9f9b641d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '3X/4X', NULL, '3X-4X', NULL, '165/150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6dbddd7c-3b05-451b-9b57-a80c519eb859', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12 T', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6dc6ae85-f439-4abb-858d-ebffa16da5f4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25J', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6dc7c49d-e8fe-4313-a746-31bbf047b0e6', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6ddb55f5-2250-47d4-82b3-0097b814c6d8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35SHORT', NULL, '20/35 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ddc188c-dfe0-4f96-8ecb-85c4cb1790c6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ddc8ad0-be78-439c-8ef0-c33c829c318a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10HUSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ddec243-a323-4673-b6dd-5964b2bb3137', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6HUSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6de03814-0168-4257-a962-8777d45e9f07', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6de131e2-e439-497e-af91-dc4c53988d99', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6de99cc5-374b-45a4-83cf-649568e80357', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-5e98-8d89-1c1c318078cd', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6de9f1c2-3241-43d4-b907-47702d056c6f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X34', NULL, '35X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6dee8dde-71fc-454b-906a-ffc2aa74a1c0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', '3X/4X', NULL, '3X-4X', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6df64a73-6bdb-412a-b39d-4da50f8b0087', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXSPLUS', NULL, 'TTTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6dfa0159-6d07-4ae6-8313-4a95dd483c69', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23REGULAR', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e010677-0c57-4971-bbc9-a547b755b3cb', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'L (10)', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e033823-7c87-421a-8a10-9ca83dae74d8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e057368-cf8d-40d4-b57b-9f260f5c6fe1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '29 LONG', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6e075f58-bd45-4cb8-b5ea-7585dca8f308', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35 S', NULL, '20/35 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e099050-0b25-4fac-b6d3-8fbb63daf1f3', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e1835ae-f621-452a-b636-9c492ec14828', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '42 X 34', NULL, '42 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e1b4e29-d16f-4a57-9e06-2c39ea469708', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '7+', NULL, '7 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6e1e909d-7bd0-4b05-a030-758a525d09ec', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '22-25 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6e291323-b3d8-4cf7-9f49-ae176f1f64bd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e2ce0b5-6345-4108-8140-bdd107819a5f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e3fe9fb-a7e8-4685-9d10-3eb3179ec7cd', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 /32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e483304-5e34-47e4-8b5c-1284f30a25ed', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', '12-18 months', NULL, '12-18 months/mois  29-31 in.  74-79 cm  22-27 lbs.  10-12 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e4a705b-fdb4-41d6-a320-b752f5e4d135', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24', NULL, '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e688550-d766-426c-a1d8-bfcd49dbfbba', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e6d3fe8-b3f3-4f80-89a9-6b5529e20867', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e6eeb5d-13e8-4983-b1c8-0cea60cbd070', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6e714d5a-c67c-43b5-8c9a-8b635166da90', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '22', NULL, NULL, NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6e747539-48ba-40ed-8563-1bc72834a3b9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '31P', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6e7e8013-28f4-4f81-9fe4-21b4d51eef73', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 REG', NULL, '0', NULL, '160/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6e8afe18-be2e-4f2a-b861-21ba2513e970', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23REG', NULL, '000/23 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e970259-4832-43d6-a224-3f42a81b4d53', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12 MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e98e5c2-3aad-42f9-be53-ef14df4ed7f0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7744-6623-09d5f49320cd', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6e9b7feb-30a1-4ab6-8d0d-4a15018466b8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22', NULL, NULL, NULL, '165/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6ea30133-e31a-424a-ae35-e1dc69e0be50', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '30 X 28', NULL, '30 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6eada2b1-804b-42a8-a8b9-2f809dfd7159', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '26', NULL, '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6eaea380-e07c-4cad-8f32-e96a49d5651c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6eb0a527-257b-4d4d-897c-f65f1216c612', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '12+', NULL, '12 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6eba3712-4844-41b9-b4bb-19165ee93b81', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12X31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ebca45e-301d-4a9a-96c6-8c12e024a3f2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fd07-5fc3-8d6e440f42f0', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ebf9f68-e0a4-4595-aadb-59bb457ea326', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26P', NULL, '2/26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ec22546-31be-4e10-8c36-99a0008cb5f6', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6ec8fd88-bdca-46ce-94f7-a05e5d34079e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ecacdef-9c7c-4e86-b8a1-96b9af3dbb35', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-8117-8b6f-f6106a33ac4c', 'Gap', '11.5', NULL, '11.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ecc3d0d-39d4-48ce-a919-cbed312f2689', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('6ed94690-d4f5-47f8-bc87-decfbd4aba56', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12L', NULL, '12/31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ef53943-abcf-44ab-8608-901f622d3702', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ef7ee33-def9-4451-99c3-c2ccf2ca51bc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16-18', NULL, '16-18 TAILLE FORTE', NULL, '160/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6efe508f-30f7-4ec8-8943-fb1e3e2166a1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f0f2acb-b81f-4452-bf2b-845c50751206', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f0f7a24-b6d2-4d66-920e-230500c4e5d2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '33L', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6f20b529-1e5c-4309-abef-4fdf62d8004c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXL', NULL, 'TTTG', NULL, '185/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f25bea0-55ae-4f31-87a7-b7673f3d5881', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6 M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f488913-f238-4351-9c5c-e0f609fae5b8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2P', NULL, NULL, NULL, '155/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f4f1dad-2504-4052-9664-f25900300e76', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S SLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f542727-9fd5-47b0-8f15-80bc9f26610f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22 REG', NULL, '22', NULL, '165/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f5441a0-00e3-47a4-be03-63fa3849ab16', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34C', NULL, NULL, NULL, 'B75', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f56f792-1cd6-4956-9d03-a6c681186c39', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '2X/3X', NULL, '2X-3X', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6f596584-ed20-400e-974b-930b9689f00a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '28 X 32', NULL, '28 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6f5afae3-67c1-460d-a8e5-63e79a41032f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XL/T', NULL, 'TG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6f65435b-a512-4d40-a06a-bf1bd7b314ed', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f6c7102-979f-48a6-8f9c-ef011c043f4a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12 P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f6fec57-9a96-4481-80fb-7f41267cd61e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'SPLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f730b3c-c6b0-466b-adcf-620b896438d9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '0 Ankle', NULL, '0 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6f7cb541-cba7-4f1b-9dab-9f5161e39977', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('6f7e4702-2dce-4482-9666-aca14e87fd50', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f936bb5-da7a-4ade-9495-d98137ea2792', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26L', NULL, '2/26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6f988c19-9a31-4f0a-8453-6215e100cc51', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('6fc56f52-362e-4bfa-9ad4-f9ad8bb23c2d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33 S', NULL, '16/33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6fc93533-2034-4386-899c-a45f9a6c1cd0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6fcf9cc1-1914-4779-8036-5b3a37b6b611', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 B', NULL, '34B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6fdd437a-b619-400a-beaa-8b8969932881', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 REG', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ff10993-5cd3-4905-ab63-ff2e66227cb9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ff61d2b-48b0-4835-8b90-435e12f33f4b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('6ff80899-a790-4f31-96d6-f92d68ff8825', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '6-9M-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('6ffcef9c-5295-45ba-8b1f-1af3a4f11623', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '2T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7017aeba-7f95-45a9-9947-f4b63572a247', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'L/XL TALL', NULL, 'L/XL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('701f71f9-da78-4635-86b4-670a536fb287', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25 LONG', NULL, '0/25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('702b343a-1e0b-415e-9e09-8be2c1e2c323', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12 TALL', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7031e7ca-f50d-4ac6-9cf3-2f5178ba0168', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('703f5eb0-5e16-4f5e-a262-d691014c7bcf', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '180/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('70422e4a-dcb0-4990-94ab-78f5de6b0912', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 REG', NULL, '6', NULL, '160/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('70603733-a871-4f46-b7c8-fd29b3eb841b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7066f391-e32d-4093-9a77-2437d2a1e632', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10 REGULAR', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70682207-d854-409f-b5eb-8dc67ebb2a80', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '18 TALL', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('70841a9d-c3bd-4ec6-923d-1ad3de086f42', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16P', NULL, '16 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7085681e-eaac-4672-a736-967ff2fa622c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('708b51d1-58c3-424f-b707-c6154b9bb49d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12+', NULL, '12 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('708d5273-9496-4c47-a223-c1b43d7565e6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS REG', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('708e07d3-3587-4f33-8be8-32e2f61e87bc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16X33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('708ee62d-f5f8-48f4-ab76-83e4164e2ccb', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S', NULL, 'P', NULL, '120/64 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7094e624-f080-40e5-b326-656697965f3e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X 32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70bcca62-1084-48d4-bb55-d8294d9e450c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '12P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('70c4aa26-0f4e-4e4b-bf89-f2874c326f5e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0 XLONG', NULL, '0 GRAND', NULL, '160/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('70c68f34-9330-494c-9647-3d92b88aab6b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXXL+', NULL, '3X', NULL, '165/150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('70c82fed-eecc-4ab9-87af-57ad812e3daf', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12.5', NULL, '12 TAILLE FORTE', NULL, '145/73 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('70d2c0af-c70e-4fad-8d58-ce92d40c5bde', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('70dcd140-0331-474f-980a-44ffd16ae6d6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70e6ba61-ff32-4dd1-96ec-ea9028ad9903', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/ 30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70e7fde4-76e4-41c8-8f52-0e524739e821', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 TALL', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70efe9e8-9484-4983-a53c-b52c22b03bab', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('70f2ce48-229c-4c1b-920e-bc2d9cc06b9a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X 34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7100c095-517b-4a64-a66b-b31058f0f1af', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '16 Petite', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('71018ccf-5da7-4151-9147-ef363eebf3a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000X23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7113855a-3690-4d1d-a02e-efffd55f9334', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXL/T', NULL, 'TTTG GRAND', NULL, '190/140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('711e11fe-d84d-492c-99dc-fe48305075a1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '40 Regular', NULL, '40 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('71220fe0-de56-48bf-9a15-483af185b0d7', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('712cc18d-304a-4b16-aaff-07f31162bde6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 JREG', NULL, '2/26 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('712d613b-1db3-4811-96bf-d6fcc54fd256', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XL', NULL, 'TG', NULL, '150/64 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7134c5d9-0b69-4439-b221-79d80241ad2d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7143d842-5fa5-460c-97c6-398aae9a8143', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 / 30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('715ca989-8592-4669-8689-19cc378d74ca', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7+', NULL, '7 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7163ba4d-195f-410f-b61a-9ea05f6abc62', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '2', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7175aef5-162c-4eac-a666-486c0f5a4820', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31 R', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7175c543-02e9-4bd1-bc7c-2de67d3e5936', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 REG', NULL, '4', NULL, '160/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('717add00-05ef-4670-846b-625ec2463dde', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('717e5960-1dd5-4e27-ab66-aedefa987071', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '46', NULL, NULL, NULL, '180/116A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7180951a-a3a6-47b2-997c-33873294eaa2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('71858a45-de3c-4bd2-a00e-56cc391c624b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7194b436-89c2-42b4-bbb9-88e67d91f7fa', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'L/XL PETITE', NULL, 'G/TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7199be55-d62f-4797-9038-aeac8a27287b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22+ REG', NULL, '22 TAILLE FORTE', NULL, '165/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('719af1a9-8752-45d1-981a-716c27bba2f3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL R', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('719c9f67-c61d-4467-a3ec-6607bf28184b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '38 X 30', NULL, '38 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('719e3853-e71f-4157-941e-a7d2fa53c546', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1XSHORT', NULL, NULL, NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('71a49d09-a057-4bab-b37d-b03b65f66c35', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 /34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71aee04d-6a21-4b96-a494-ee1643ad84e4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '28', NULL, NULL, NULL, '170/148C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('71c0a3a6-1f7f-4ad6-8f35-5543851a2bfe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29 R', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71c59125-2d32-4a61-8afe-ebb3e89c3380', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('71c5b13d-d3ee-4263-ba15-2224f02d02d7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('71cb87ea-c4d1-43de-bedd-11fcb36e57b3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 /30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71cbfdd6-8a34-44bf-8ac7-86ace7d9381d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71d89c2c-f20f-4ba2-99f2-ff4ef47df1d4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('71e12663-5c8a-400d-8daa-7be49defd8aa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71e63fca-2a8e-4478-8c72-072b0de21ca3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71ed0479-0d2b-4c12-bd6f-81a7c80450b6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71f035d3-a844-4dfd-96de-309182d797b2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('71f18c7d-cc8c-47fe-9ae4-4441b3c4bfdb', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublic', '0-3 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('72019fdd-210d-42cd-8c9c-1ab9af25dc25', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12P', NULL, NULL, NULL, '160/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7216dea1-85fc-4274-9154-846a1f57f415', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XS', NULL, 'TP', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('721bd1ad-6e6f-4e75-9ed0-37336fcaf15f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31S', NULL, '12/31 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('722574b0-6d88-45f5-bea5-e928751ff9cf', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S/M ', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7226cbe4-faab-444c-b39b-6c3e0a6f5913', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS+', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72326d43-9add-408e-8037-6c6b89dd1536', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7233fe33-3019-4c3a-98b2-f33aa1c723d7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('723f6351-f62f-46ac-a997-5bf810f0e576', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '36 Regular', NULL, '36 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7246cb6f-110b-4183-8069-df4c49f5df8f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('725da08d-e2dc-4003-b78b-aa67ad272c22', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30', NULL, NULL, NULL, '170/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('725e425b-3ba9-4989-812c-b4a2d7cb6eaa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('727198b0-dd03-4763-a313-836df21581bc', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'L', NULL, 'G', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('727b8aeb-149c-4dd2-adb0-6b23cc4ee724', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20XLONG', NULL, '20 GRAND', NULL, '175/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('72814c21-c5c0-4f0b-8a8a-7bbd6a042a2c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('728d9e15-546f-4800-8134-837080d2061c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('728ff13b-ca8a-461e-bb6f-78da5006267a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('729248cd-061e-4d5a-aa28-74d6732e13ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 S', NULL, '00 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7297c4f6-5427-48ff-8eaf-6d300dcd74b8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8A', NULL, '8 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('729b1321-06ab-4b4a-a5d1-0654d193ae60', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72af3210-3127-4d50-a9e9-f182538af8d7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('72b1ea0b-7c97-4f92-a642-68bcbe8ce072', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('72ba4644-48e8-4f25-aa83-fd7c6f661748', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S', NULL, 'P (6)', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('72bf29a8-66bd-4382-ab9a-5f4b9200b0c5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('72cdf295-cb10-481a-b7bc-d77a925efd47', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72ce978c-aa44-4dd7-9cbe-6412cd55edbc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'MPLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72cf6218-f49d-42cf-8e94-13e7fa2feca7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72d29d1f-e157-4d13-be65-302a38119c7e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '175/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('72d5fc2c-a247-4654-89ca-476796c24b5f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('72fa386c-90d4-4c33-8a11-aead687fdf20', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '6YRS', NULL, '6 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('72fd2540-1374-43f6-81b8-1610d8cd46f1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7300bfcd-f287-47e1-8f9a-a7ebab79bd97', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('730466ec-dd13-4a76-b66f-90ca5587bcf2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '26L', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('730b2208-906c-48c7-838f-38e099bb5fa5', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '7.5', NULL, NULL, NULL, '245/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7310c6a0-e35d-438b-8296-0806d6be1454', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '24 PETITE', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('73124615-b050-4fb0-a19e-a473d2d2963d', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '4T/5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('73312fd3-bffa-4697-b82b-cbaac6aed5e9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7340c71b-c2e4-4fc4-9ade-1f040791d938', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M+', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7346995e-5237-45bd-9675-553b3f4d99d7', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('73486787-75d1-4293-8072-dcc2a4560328', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('734f5d89-a53f-454b-8c33-c92a9c3a76d5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7351d0ce-156e-4182-bd06-fa90ea3e639e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('735936a2-d302-43ec-8e41-b15c935e31c7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('73609048-a964-451d-85cc-837f60c8feb3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7365f306-c69a-4eb2-95f3-1e4252306c3f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 A', NULL, '14 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73689582-7d2d-4eba-b327-d0905475e1e4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '35/20 Long', NULL, '35/20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7373d412-c3d5-4397-a7ef-e3cc0271061a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL+', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7385b276-9334-4d63-b3fc-9cec45b558d9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('7388d4f1-4e04-458f-8717-487b293c6109', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73894d85-9133-4816-8769-d93281ab5ae3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '31 X 36', NULL, '31 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('738d6ae9-86de-496c-84aa-87c25489a86b', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '18', NULL, NULL, NULL, '170/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('739ba4fe-21f1-46c0-93e5-f2fe4012f94e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('739c5ffd-64d8-4adf-8abc-1406614831db', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba8b-511a-d553a9608347', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('73a2db92-358a-447b-9b10-f1fa3bd0abe7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 S', NULL, '2 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73ac0102-fd51-47f8-9182-f8abad082305', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'XXS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('73b3e4d1-82f4-4f50-890d-dfbab848205c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73bd82a4-7296-4092-8447-ca0ce3d3807e', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S+', NULL, 'P (6) TAILLE FORTE', NULL, '120/65 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('73c3c6db-7967-48ef-af76-556d8bedbe1a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 X25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73c562ea-a3b8-4f6d-80fe-8cb04c3fb01c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24SHORT', NULL, '24 COURT', NULL, '160/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('73d0ae0b-298a-4318-a70a-df279a8f000e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73d2744d-f243-4990-8871-3d36ca1ff76d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '15 x 34/35 = M', NULL, '15 x 34/35 = M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('73d47faf-eb9b-422d-9045-145d040050f8', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '0-6M-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('73d725cb-4358-42ce-ad64-4cb3ca1c359e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XLHUSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73dad0a5-7f06-4c58-a417-44bc3db34d47', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 P', NULL, '00/24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73f2dade-dc73-4013-9960-2798fdac8861', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fd07-5fc3-8d6e440f42f0', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('73fff868-1dbd-41f6-a05d-29e8b05a2e66', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7d68-c07a-b92a3815bbb5', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74002fe1-931d-4a08-9a3c-5ff226daf13b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74043793-109b-4f41-9ca3-ab0749facf5e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7404755b-37b4-42c0-8026-1c4932d7c16c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '29 X 34', NULL, '29 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('74078377-ea94-45cb-9346-668399418d50', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-fa07-f4fd-146a1fb15d21', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('740809fa-00cf-45a2-b87c-1e8042c3443e', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M30/W10', NULL, 'H30/F10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('740b6717-1289-443e-bcf3-d5c2bb7e9871', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'L', NULL, 'G (1-2)', NULL, '210/76', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7421d668-4482-4cbe-b2a9-d710adef4375', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7426e273-c7c3-4f20-b4bf-3d4b7767ec41', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4 T', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('742f830e-a014-41a4-be47-836b72e6fc6b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'M/L PETITE', NULL, 'M/G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('74369696-62cc-4261-93c2-01cb2c4ee482', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32/14 Petite', NULL, '32/14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('743aab9d-c6c7-413d-8820-f04d5401b3ac', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-e3fd-54b5-12977ee75b89', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7444b2af-f608-4591-a0c9-39eeb54ec3c1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M PLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74578152-73d4-4be4-917e-d6fd44c807f3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '30+', NULL, '30 TAILLE FORTE', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('745efb54-ad88-4db2-8511-cffb001c0d16', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000P', NULL, '0000/22 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7465a665-6ac9-4799-9363-6c3893296abe', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7467b93e-5b05-4727-b587-d80474750e03', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 /28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('746a6f47-3215-42d8-b056-05bf4ace7611', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29S', NULL, '8/29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('746a6fa8-578e-4dd4-b760-039db93be0bc', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34', NULL, NULL, NULL, '175/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('748107fc-7c35-4770-80a6-ba8176f86e60', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X34', NULL, '42X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('748c513e-e7a5-4b22-b1a7-29c6fc370ea1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74935b1d-bda1-4092-8bba-2cea6a28813f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74ae84ef-9df3-4644-987c-79653d871dd7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16 P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74be088e-e64c-4878-87a8-1ff6bef796b1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33/16 Long', NULL, '33/16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('74cd88c8-c65d-483d-bb83-e367939c61f9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X 32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74e002b0-529e-43b7-b6a7-b82d701d445c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('74ef42ca-c93f-427c-aec5-1c7fe3a3e1db', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10REGULAR', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75074520-e5d6-404d-b27d-00a253289a13', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL PLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7512e39e-e6c2-445a-8a29-1bc77982825c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('751b4182-2810-41b9-8abb-fc9f7ab5b726', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXLREGULAR', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('751e865a-b52e-40ed-a72f-3b5e1d576a50', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30T', NULL, '10/30 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('751ed222-f581-449c-9061-a96714e976e3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '32 R', NULL, '32 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('75332461-237e-487a-825f-b5f5b0d09a15', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '31 X 34', NULL, '31 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('754314af-6932-4264-aa1a-e64a05128dc4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14PLUS', NULL, '14 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75470db9-a902-466b-a3f3-f13bd80dc135', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('75507e69-8e3c-4e8f-85aa-31c8318e4da9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75580ca2-889a-44e3-9c02-b08020e48ed7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2 P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('755b6c57-a17c-4b7f-89e8-5413ef77867d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X 30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('755bf165-2f8c-4a78-a3f0-00f32e02925a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28x28', NULL, '28x28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7563e51a-365e-4a3a-99f2-6b8105366a52', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('757981f7-5479-449b-b4b0-c125638305de', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL SLIM', NULL, 'TTG (14) ÉTROIT', NULL, '150/61 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('757dafa8-b059-4ec6-882e-9c317e300450', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-a48d-93be-70b1603b5160', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, '88-92 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7580bc47-b3e0-4e01-9486-88804ff82287', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'L', NULL, 'G (10-12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7585e714-f354-4d57-8cf6-65c835bc95f9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12 M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('758a23a6-1bad-41ca-865f-f131aaae3720', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL SLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75aaff15-7a02-4dd1-8d63-f2b88ed3ad41', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XS REG', NULL, 'TP (5)', NULL, '110/60 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('75b33dc0-3578-4007-a62d-132abaa0693a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL REGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75bb3779-5c57-436a-97e3-c552ebf1e83b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '29 S', NULL, '29 S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('75ddf184-2d45-4c3c-911e-af1fb49f098c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000 T', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75e27414-e1c1-4fd0-bd3f-829603e40e52', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('75e3e156-81ab-4a90-90ab-41789b308f14', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/88C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('75e5afeb-ca12-45ce-852a-310d191f4fb7', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '48X34', NULL, NULL, NULL, '180/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('75eec8e0-acb8-4738-bb3a-250bb9d4be96', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('75eee1f6-e5e3-4db9-ac2e-560606897501', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76065ba1-cbf3-4c40-b8a9-f333ddefffbc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 LONG', NULL, NULL, NULL, '165/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7624f4d6-e536-48b3-9f80-8a032691c353', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('762b3caf-52b4-4881-a86b-34c7e673611e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 R', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76400d28-6864-4d44-847a-b0b5fad039d7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXS SLIM TALL', NULL, 'TTP ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7640b3b6-4760-40ff-8564-dbc47bc39f26', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'L REGULAR', NULL, 'G Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('765106f3-39d4-456e-a560-42a7b69aaa9c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14 TALL', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7653532a-7349-4a21-bb79-43e5ceca6574', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25 P', NULL, '25 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('76572ccf-0d63-4f3c-8519-88e130779e0f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7663c081-697b-4b17-ad60-26915bc01df7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/ 28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7674d2d6-77fb-458b-ac1a-72359210da46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 /31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7689d132-9cfd-43ba-87f5-69c01d1d0225', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('768f8fd7-2c00-4ad6-9d82-69a4ab6f48eb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXLPLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7695ee1d-f530-4b9d-8720-e8bc74243155', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('769990bb-b79b-473d-b520-dbeab922f60b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34 LONG', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('76a6eae9-f81f-41e3-8e72-230549083eb5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76a9b7b4-50bf-4f11-b293-d5d2004d79e1', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '6-12M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('76b9afca-46e5-4cdd-8260-5d317865e423', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27 P', NULL, '27 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('76c3bc44-b5ba-4df5-bf70-1fec8b52d759', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '36X32', NULL, NULL, NULL, '175/90A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('76d8c3ab-8d6a-4015-a021-c65a0bacd2d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000P', NULL, '000 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76e4a2ad-10dc-44c5-8292-e09cc3747aa1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76e85577-26f6-40c5-ad7c-5f020917eead', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 / 30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('76e96f43-95f3-4345-af9c-19b245c7a318', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('76f03f17-8f13-4e64-b308-c0edd072aea2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '10 Long', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('76f82ace-0977-43fe-9ceb-1bb46651a85c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('76fc1ff1-6654-4b02-9a0c-d1c88698bde0', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42-TALL', NULL, '42 GRAND', NULL, '185/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('770172a1-10b9-444d-b530-ec8016034967', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29J REG', NULL, '8/29 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77094976-4264-4e1f-88d4-419ac63b5b77', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('77192c03-9ee2-4c88-9a48-ab0da883e495', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S/P', NULL, 'P PETITE', NULL, '155/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('77222bcb-cd39-4ff1-8f72-66441e734984', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36AA', NULL, '36AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7759d4ec-24e1-49e3-9336-f8c8ff4c056a', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '0-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('775a9a7f-e263-44f7-a3e4-a900d2244a49', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '10 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('775f7621-10e8-4214-9a06-eee3361dd931', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '180/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('77659684-0a14-4cd0-8ecc-486380a06ad1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/ 32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('777201a5-0df7-4255-88de-48461816ff88', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14 HUSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7773c702-09b6-497d-afb5-852f2613ac96', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'M SLIM TALL', NULL, 'M ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('777e0603-9f34-45f9-88cf-8d48f995d530', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X 34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77859061-86b3-4961-abcb-ae961183498e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '29 X 28', NULL, '29 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('779a2931-99e4-4ff8-b15d-b3946dea57b7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL SLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('779da485-f7fe-4f43-81ea-ca08f86c2a9d', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'OldNavy', 'XS', NULL, 'TP', NULL, '背长 x 胸围 33 x 43 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('77a7ead0-ed07-42ed-ba22-ca2556f3f380', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29L', NULL, '8/29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77b88796-9916-4114-9ea3-58d93491e8d1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18TALL', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77bb665d-eba3-4ecc-a1f6-9818ff635251', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L', NULL, 'G', NULL, '165/106C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('77bb972c-9b11-4524-a0e1-d9158bb93bc0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 SHORT', NULL, '10 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77c22b95-43dc-4adf-af91-b2fb32e07330', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-e413-e823-ad5042a060ad', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('77d004eb-96b6-48ff-a635-098ab95bb5ed', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14LONG', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77e8dcf6-20c2-4ea9-a565-fe8f0909ad18', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X 36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('77eae42b-8011-4c53-a687-0f76fc531ab6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10 TALL', NULL, '10/30 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78039e9a-2f47-4c7f-b458-27d78b2ec149', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 B', NULL, '32B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('781cd8b3-b842-4d93-9f96-9739226138c7', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'S HUSKY', NULL, 'P (6-7) TAILLE FORTE', NULL, '120/68 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('783836e3-3c0d-476d-8e9e-c14c5244629c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29R', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78395834-6278-49cb-96c0-1bc4fd0a87ef', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('783d5233-fdf1-48f2-acca-38e773a4ea75', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XL', NULL, 'TG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7846dbb2-6b0f-4674-887e-786e72f66eef', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12 MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7856e7ce-a969-4771-b251-38e0d3ae5df2', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '5', NULL, NULL, NULL, '240/82', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('78598d04-ac83-4ed4-9016-79834d8e1f2b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '3/4', NULL, '3/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('787b484f-c814-4b2d-a6d4-5e7d9794175c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 /29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7889c51f-6647-4b49-af0a-889fd46c2e66', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '20 Long', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('788b19c3-4f06-4038-a49d-2ee84c6a5468', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('788bbc5d-e0cd-46d6-8295-67c51031772a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('788de48f-87b0-443a-b64d-7e3ab2090ab4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18TALL', NULL, '18 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78aaf4e9-c004-4571-a0f7-69e4b7051ce5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M T', NULL, 'M  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78ab0ed6-a8ab-4098-b092-b85d334beae3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7dcb-0ca5-19fb6787a519', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78c13f90-5f25-4364-9f7b-6861317759f5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78c18b81-2ecd-48ea-ac82-3ea459517602', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34REGULAR', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78d1271e-1a4e-4a27-b398-37d2e28d476d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('78d61f8c-5dbf-497c-84e1-2ad3cb57df5b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('78d852bb-652a-4c7f-af02-b6d9df1cd88b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('78dda226-ab02-4941-9c21-a01fc5abbbf9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22REGULAR', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78e9fec3-4bf7-44ca-a8c3-54cb60f68fa0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('78f5fd78-8036-43d2-a8a5-fd1a629e49f6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('790384db-607f-449c-b36c-005a823a1ad2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00 T', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7905ec99-7f9f-4224-891f-5d3089b98949', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'M Reg', NULL, 'M Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('790cf41c-8856-4024-90ad-7b4479a38be0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('791dfa62-2d86-4443-8633-7aef8f614bab', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('791fcb86-fa5e-410a-9aba-f33c0c9c6e5d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000L', NULL, '000/23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('792d23d5-bafd-43f4-a53f-36493962b78f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18L', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('792d9735-85a8-42ba-a831-5659e506ef3c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('792ee2a7-7810-477b-a9ee-2f0197d8f4ff', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '8.5', NULL, NULL, NULL, '255/82', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7938c28e-f2bd-4af2-ad49-cbc76f531227', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7941dfa5-deed-48b6-bec1-f0e46119d382', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 TALL', NULL, '12/31 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('794a527a-a739-41ee-90a0-87f60b5fbcf3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '29 R', NULL, '29 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('795a952c-f780-4bc5-97f0-0da8eaaf3805', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('795bb73d-b104-4a9f-8ef9-eefc0031e85e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '35 TALL', NULL, '35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('795ce4bd-b9ef-4440-a516-4d2bbee7dc0b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '4 TALL', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('795edc6c-6a3d-4afb-9feb-346d97b96d9d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34B', NULL, '34B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79740dba-4704-41f4-b771-32824ad01ce4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '34 Regular', NULL, '34 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('797b3d94-453f-4c35-b054-e0bcae35d38f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6', NULL, '6', NULL, '120/56 - 6岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79893f9f-a8f5-4d1a-a983-3d1120b65362', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-59c4-1a32-c170aca4803c', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '43-61 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79919f26-0ad4-430c-89fd-37620adb26b7', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8406-e648-f4efcd581d1f', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('799961f9-bddd-41a9-b887-550715cb09e2', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '16', NULL, NULL, NULL, '170/112C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('799f3ada-28e4-4661-9620-71807d7a8471', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79a08f25-4d17-4cda-929e-7e485ebb86f8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S/T', NULL, 'P GRAND', NULL, '165/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79a78a67-0c03-443c-87e1-76e53b425dd5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79b5ac24-e01a-4e50-a318-e603b3e8b0ad', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8+', NULL, '8 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79b70af4-6a25-4e13-a63d-657148ae80fe', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'SXSHORT', NULL, 'P PETITE', NULL, '155/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79c2ac01-64e5-432a-a03f-d28088e81ea4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL T', NULL, 'TTTG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79c33eb6-c79d-427e-ba8a-c33bcbe4e2ca', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44X30', NULL, '44X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79c84790-77cc-4880-9756-afce083b3f9e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 REGULAR', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('79e11871-d9e7-4c63-8854-d6f62359e064', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XL', NULL, 'TG', NULL, '180/115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('79e9696a-811d-46f3-a4da-bd99204f4edb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '29 TALL', NULL, '29 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7a030227-1df2-4ee5-aeb2-4632956cf22f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXLREGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a1ffd93-64fa-4bfa-b102-5e2f38ba230e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6R', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a2e1a73-24e7-45d6-82d5-1c2acae51f6c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12 MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a5141d8-60a2-4d4b-8126-877ad1ad45ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a540a00-ccf5-4cff-9858-14c2da2b251f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '9', NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a6c4907-62c1-4132-8492-bafe64613654', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '4T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7a6d9982-221f-4d97-bead-65cb167c875d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7 SLIM', NULL, '7 ÉTROIT', NULL, '130/50 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7a859b2a-4ab0-4d8d-822c-e4d34acac250', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 LONG', NULL, '18/34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7a86f192-af05-49e9-ad0b-7948c70e1f57', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L SLIM', NULL, 'G (10) ÉTROIT', NULL, '140/60 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7a912178-b060-4da8-87cb-28fa19430dbf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'BananaRepublicFactoryStore', 'M/L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7a9b5f5c-a88f-441a-9976-47c40977f3b2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20X 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7aa45451-1c0f-4163-a82d-96fe555c4c89', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S REG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7aa59007-6131-4ad6-9934-e1866b7b352d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10 REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7aa63646-0eb2-4716-9022-a41dd3029f0c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7aab61f1-bffa-45eb-866e-f43c3f088d38', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8 HUSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7aac20ec-471e-4f1d-9825-6736531fad9c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7aaecd6f-d6c9-48e0-bf21-81c41a87cc8a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '8 Long', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7ab221a0-2466-42a2-b2dc-5cea913a71cc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '27', NULL, '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7ab59155-13bb-428b-b093-b166df07e8ac', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3YEARS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7abca131-ea34-4c64-8876-1d7dfb9006a6', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XL', NULL, 'TG', NULL, '155/69 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7abd4729-f1e1-40ef-a95d-1f3d6c3ad691', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 T', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7acb5578-46bf-4b46-978d-a79f60f6e285', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12TALL', NULL, '12 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7af05b48-ccd1-4ced-a23c-bdd224da7ffa', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7af63457-3e82-4987-aa7c-25edd3d25c49', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '32 TALL', NULL, '32 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7b023ace-2636-4519-852f-57c5e0ece0e3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 SHORT', NULL, '4/27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b057564-5a6d-43ac-a0d4-bceb3dcaaac4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X28', NULL, '36X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b1da0ad-33eb-473a-a40c-f4a88584912f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'S', NULL, 'P (6)', NULL, '120/64 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7b2ce5ed-9ffa-44a7-8385-717076d1ef5d', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '4T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7b2eca2d-4d87-4e1d-ba4a-4a62686fd427', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '29 TALL', NULL, '29 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7b3871f3-8c36-429e-8ae8-e8836c224c5d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L R', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b486888-77e3-46db-bef4-2710c6038b66', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b57bb80-d974-47f6-8378-e946defc9c64', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f96b-e1e7-9a5d3b960c0f', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b57e0f5-bd87-4809-b99c-73d8016a3480', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b69dd87-ecf0-465d-8f3f-c3f8584b5df1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30X30', NULL, NULL, NULL, '170/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7b7e3453-257f-4a55-928a-ff3fba2c4e9a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M R', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b8e799d-3e75-44db-8aa9-4ac5af3d46f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9eaf-f686-592904d735f2', 'Gap', 'S', NULL, 'P (5/6)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b90aa4b-0629-4750-a981-bcf00895f494', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7b914ef4-e199-4f9e-b6e2-f804f235cfb7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14 REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b91d307-1ae6-4dac-9589-5e1a3493da9e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '10/11', NULL, '10/11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b93ca02-d378-41ed-a676-315f1b5f65bb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18 REG', NULL, '18', NULL, '170/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7b94b943-00bd-4d85-995a-a43497a0f9e6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL (12)', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7b96eac5-b9ec-4216-ba4e-5818293cdd38', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7bafb1f3-bdf5-4b38-ae15-4a3cc937bf8a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f51-fb5c-714f94367e54', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7bb525e5-914e-4faa-b4ce-bfbc78e4a142', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25 TALL', NULL, '25 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7bc76437-51c0-4d45-a35e-e7b63ce003fe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7bca8be6-dc2b-4866-9d51-67179ac84470', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '30L', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7bccabfb-934b-43c6-ad19-8b0663888a87', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 SHORT', NULL, '18/34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7bd85d9f-4fd0-47b0-bdb9-5424fef18db4', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '165/85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7bd8aea7-cf4e-4a0d-a368-981883e594a7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7be4ca95-3bce-4611-aef7-00a20ddce11c', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XXL+', NULL, 'TTG (14) TAILLE FORTE', NULL, '150/84 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7bfc96bd-2c8e-4216-a9f8-d8d2c559378f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '35', NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c0013b8-6ad1-4a14-96ca-fe1d4830d50d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '24', NULL, '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7c0b9e2f-049a-4ffd-a4eb-1aea2c1ddf4b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XXL/T', NULL, 'TTG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7c1189ec-b0bb-4980-adbe-6d8e18e72d2b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c13145f-8469-41d2-a3bd-f0c536bd3876', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'XL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7c13fd7e-13cf-48c6-8fbf-8cc098d05837', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18MON', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c154182-111d-4d75-8d04-69858621cf44', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42X30', NULL, NULL, NULL, '170/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7c1c8e9a-9509-4234-a072-e5f41b01d41b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6X 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c27e06b-8b3b-4891-a945-2490ee12641e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'LSLIM', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c349b71-270a-48ca-9648-6b75a18b2b9e', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7c34e16d-7f9a-423f-976c-9b6a6a3577d8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31L', NULL, '12/31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c385745-aecd-4dc7-8013-8e1449ac15ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c3a51d8-2044-4dbc-86e4-7af3d4ef1619', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '2 Short', NULL, '2 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7c404a19-7332-4685-9d51-fbe4ebb16c4f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7c40ec1a-6172-4f32-ad63-90fe0f273b65', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'L', NULL, 'G', NULL, '165/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7c49f026-7e05-47a1-8ae4-412f99aa3632', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14 REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c4ce4b1-4cad-4cb4-8a79-62d096643350', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '2 TALL', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7c4e11dc-87a3-4a60-bbaa-728cde3d479b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XXXS', NULL, 'TTTP(24-25)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c741f9a-b7e2-4749-907f-fdfa4c8fb4a1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXSXSRT', NULL, 'TTP PETITE', NULL, '150/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7c802962-3d09-45c4-b70f-e7702fc5401d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7c960af2-a1c0-42ee-b5e9-017ae6acbf7d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'M PETITE', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7cbaa1e8-1170-4943-8632-263ee38c14e2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-fa07-f4fd-146a1fb15d21', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7cbc1c3b-3cf7-43e4-8ff7-1e91c3608da6', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7ce19600-5fc1-4baa-9fe1-e23e116ede02', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7cf71119-146f-4ab7-b835-d72cbec1c53c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS/P', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d03707c-888f-4e11-b47a-9def511bdc02', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d09890e-2ab2-4827-91d2-49c733a7fc2e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '12/13', NULL, '12/13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d1b8d22-727b-4ef3-91c4-d928493353bc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12 REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d273ba6-454e-4298-89ab-bdb7db435160', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X 34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d2ba6ca-543d-41d6-943c-73d2e7cab8ab', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34 TALL', NULL, '34 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7d2ce0b0-954a-4324-9aeb-2072d7cdd311', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '5.5', NULL, '5 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7d4ddd53-d914-4b80-b854-8e1038a4c1d1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d5806f4-6451-443f-a63c-37ed408f0d64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24REG', NULL, '00/24 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d60d0f7-c89b-417e-bc37-59e37a54da10', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d617ea2-6180-4ab7-8b27-c4fe4a280a74', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18 +', NULL, '18 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d639c52-b3eb-48ac-ab56-94ccdd9b5b73', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00', NULL, '00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d6c9122-3800-4ab8-93a1-52168568fb8d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d776e2a-c6fe-42f5-ad3b-6c0f79141631', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'S/M', NULL, 'P-M', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7d77a610-f361-499a-9ed5-fd9c33c17643', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d8198dc-1738-4120-8d95-fe75367e0115', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d83738e-6bbc-4343-9f77-ce755c9ee1f0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/ 36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d84855e-e63c-43a5-aa1b-47e4b76d2323', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '24P', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7d89bec4-9032-43be-9306-7d09679a391e', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'L SLIM', NULL, 'G (10-12) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7d9a270d-64de-4573-a676-5c9de717c6d3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4SLIM', NULL, '4 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7d9c3dfb-4435-4354-94a8-a1e44355a10f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8853-54e8-2b3692a6cc6f', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7da44e22-0bf3-47a8-941a-2b4e77065b79', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XXXXL', NULL, 'TTTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7da75f30-1bf3-47ff-9a13-60c2bd73af63', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M HUSKY', NULL, 'M COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7daa8a99-d3af-417f-8ebf-465f7a2f8487', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '23/000 Petite', NULL, '23/000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7db810e7-0aaa-42fd-9c6c-32441a2afbfb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S REGULAR', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7dc77217-2ee3-4755-984c-f2e48f8a7304', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/59 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7dcad29c-4896-4bf4-a067-120d3d600410', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8HUSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7ded3ca0-29c3-485e-b47f-36dabb6c6d5f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XLPLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e330ba5-38e4-45ed-bb15-45691dc12372', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-34c3-4e5c-11e6de75cf25', 'OldNavy', '2X', NULL, '2X TAILLE FORTE', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7e3dc007-e3d8-4113-acec-146b50be543d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2X26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e3dd9d4-9f05-4a24-809b-69bec4fc2b1c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34P', NULL, '18/34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e4b74e7-9f5c-4934-966a-d106b17d2ca6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '42', NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e508d20-af36-4964-afb0-a661e3fb6199', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7e548ddf-da82-427c-980c-6925c99aa6a6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34AA', NULL, '34AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e59df97-b723-470f-b2bd-ccd1f299f839', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e64bef5-3f7d-42f2-8cab-b1124ba7a694', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7e67ab97-46f4-476b-882a-e8f12dbb6d1c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '46X34', NULL, NULL, NULL, '180/116A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7e6fa7e5-df2a-48f3-9153-bc9024f88aa0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-c1d4-cbc5-e3c060b978e1', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e6fba25-8229-459e-8608-e78f13296bdb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '23P', NULL, '23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7e79905f-c553-4b1d-9215-ac7fcb340063', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0T', NULL, '0/25 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e85ce03-977f-4662-a7b8-19635ee3add7', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublicFactoryStore', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7e91913f-a18a-4be5-b008-e0029002a6e8', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '46X32', NULL, NULL, NULL, '175/116A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7e92aaae-11c2-4142-8734-07d8bfa88ac4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7e959908-18c6-4bfc-89d1-3c7cce5839ff', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7ea21fae-2d07-4203-89d2-551d9615847c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14 +', NULL, '14 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7ea4b6ec-d136-4485-9502-32c635b82938', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '30', NULL, NULL, NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7ea4e825-253d-46cc-a6f9-70443fea68e0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7ea4fad3-50ed-4a86-8ff0-b5ec33fbefdb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7ea6eebf-2fcd-47a7-b900-94e6cf9c0720', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7ea92bef-b78c-469e-98e8-9f132004f652', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4X', NULL, '4X TAILLE FORTE', NULL, '170/134C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7eab3491-b105-43fb-bf9c-e4f18c02ed36', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10T', NULL, '10/30 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7eb13561-f1ff-4c08-836a-3e94b0afb4ef', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/ 32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7eb3767a-8b44-4692-a928-617563e28f8d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S REG', NULL, 'P (6)', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7ebb68db-c243-43e3-9603-fb4547737c52', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7ec8d8b2-d15c-4a14-b9b3-159661b90823', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6 SLIM', NULL, '6 ÉTROIT', NULL, '120/50 - 6岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7ed83986-7ca9-457f-9fda-a408de115c65', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12 MON', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f07bec1-2f0e-4fb1-8cee-3297f9b28971', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS/P', NULL, 'TP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f093147-2e12-4810-bdcb-821a494e7148', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '185/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7f10e7c7-a434-4646-b886-7edd15bbb65e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f1a0b6f-8caf-4b74-a7be-13506f17a7c3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24LONG', NULL, '00/24 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f1e0708-a896-4828-b5e1-74e1ddd1787d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34A', NULL, '34A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f504609-b457-47f9-930c-fca46131d630', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f5c2dc5-d00f-43a7-935b-43abf74f5f69', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/ 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f7b1404-ac67-4506-bd37-36eacb607146', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7f7c1ed3-2119-43cc-ab42-b6fa40ccc6a0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '24 P', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7f7c3129-fb23-4d27-8ac9-5c7d96affc53', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXL T', NULL, 'TTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f89de4a-cd5d-4245-b2b8-eb4f6368b0f2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 /28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f8d83f2-a2e9-472a-976c-d5bfca1323f3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f8e0581-ad13-49e6-8323-57d485de3720', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7f9d119a-8b9a-4b0a-bc09-f9e9e098edd5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 TALL', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7f9fc7e7-9369-4d14-a64c-30698918f8e0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '155/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7fa67b42-dd95-4c5e-9c34-013fa789732b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '24L', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7fa739a8-5e43-4b9f-b4bc-3553990590e2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '28L', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7fabf6ba-95a6-48d0-adf6-f1a0e165b5aa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7faded9f-61b2-4b8f-ac8e-7b3e38aa4114', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 C', NULL, '32C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7fafcd6f-7156-468e-a460-e16771de6933', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'M/L P', NULL, 'M/G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7fb01095-6f28-4c5a-bf23-c17ae514c285', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7fbc9099-5df0-471f-b50a-dd23d4b58663', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 REGULAR', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7fc59bfe-924b-44b2-988c-77f3f3a339b3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7fc78356-2c08-440d-930d-047150a1aea0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-4811-7a0d-f7453d8c0729', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7fc79e4d-324c-4b82-9642-b2c0b34538c4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XLREGULAR', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7fca5e21-2e23-4c89-b82c-22f477ff718b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('7fdb4abc-b3e5-4922-a399-682b2b9883f6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7feb4954-d114-469b-8772-a5a3e7ace011', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12 MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7feb9d90-8279-4ef8-b2bd-5b1137566bca', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS', NULL, 'TP', NULL, '170/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('7febc61d-9190-42cc-8d62-4bec7a3b767b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('7ffdf1da-a92a-4832-a785-04221e395a3c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '27 LONG', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('7fff4714-241d-459e-b664-644fb57c4e81', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5 SLIM', NULL, '5 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8002b45f-c2c0-42c9-8bce-eb6bc2516faa', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('800baf92-600b-48fe-8270-d31e5f3fadaf', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80224685-63d7-4be0-873b-85f850e08036', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16 / 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80239878-520f-4851-9813-443cf5865939', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9eaf-f686-592904d735f2', 'Gap', 'L', NULL, 'G (9/10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80287796-9125-4564-934d-37e716700b12', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8034deab-9003-4bad-9ff5-78d18f28a358', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24/00', NULL, '24/00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('803e67f4-a072-406d-98d7-f34da901dcda', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '6 SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('804b5794-7da3-4d04-aa63-88b6a84d6bd2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 TALL', NULL, '6 GRAND', NULL, '165/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('80637e18-578d-42a4-bca7-1fbf54356d15', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S REG', NULL, 'P (6-7)', NULL, '120/59 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8075f458-f9b4-4e9e-9877-54686293b507', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL P', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8083e559-3436-4f47-a965-3ca64f383fd3', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '32/14 TALL', NULL, '32/14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('80939601-3f7f-451f-a546-a9841eb3dddf', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('809dffc1-da88-4de6-9f4b-11ab99f5151f', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', 'UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('80a6cb3b-aa13-40db-bb32-a5837122472e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5SLIM', NULL, '5 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80d2fc86-7bf5-4815-abbc-6847c13dc3ae', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4 REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80e28510-90e9-47fc-bbf5-7a2e7820832f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80e6d1fb-cc13-42ea-b1cb-cdc37bf51166', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2 / 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('80ee707d-1da8-40ce-b7f4-139d6ead2da9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('8100f209-ccf5-42dd-98c6-a8f877437190', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'MSLIM', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('810c3c57-4217-4aca-ba54-290ad4b0c1e3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81165224-72e9-49f6-a748-f77040ba6aa8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 / 30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8118e92e-0d03-4082-b118-5647783eb8d1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '38', NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('811b575b-e196-43ce-b894-859cc276e58e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8129d8f5-070f-42b8-8e04-41e8bd7c8692', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-57c5-dd8d-3f495b0c94bf', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('812e1ce8-1e5c-408b-ba26-6e2b23796054', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('813127e6-44c0-4d19-8482-4daaafc294f4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18 /34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('813879f6-9608-4bc2-aa48-42e3882c5730', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81446694-00b9-4603-8bdf-d5e6174b3118', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('816d38cd-307d-46a2-bf77-40ecb6a217f3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X 36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('817876fb-4409-4cc6-97a5-b65d7226230a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL PLUS', NULL, 'TTTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('817dfe8b-7243-48d5-80d7-e45522474164', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '30/10 TALL', NULL, '30/10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('817f7bc8-ed83-4f9f-9738-cf327e971b3b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S REGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('818140a9-85ad-4c85-ba21-19b3b0d6589d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52R TALL', NULL, '52S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('818fd3d4-ec5f-4b96-b8ec-95c710e2b1bb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 R', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81920226-9024-4737-8e3b-7a36afea1ba7', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('81945cad-074b-4fac-bbb7-6fb767312c4d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('819622d6-29c0-40e3-9859-4544c331c1e6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12TALL', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81a9c2d9-5fff-4a26-a150-d482de4a8617', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('81ac1863-46ab-485a-8135-a2f9c2b23fd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81b3a48c-0491-4c06-812d-bf3ad280e62c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14XSHRT', NULL, NULL, NULL, '160/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('81be3b5b-00bf-4566-b06a-5064f57c9c93', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('81c25694-5e29-450f-aab4-7049e616fd17', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '12 TALL', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82010906-7b3b-4a64-9f57-0423bcda97b8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('820221c6-2280-4f8e-9d67-bc50b8e59dbb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('821c2942-54ef-460a-a7ae-18f3030b45c6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('822d4519-ac49-4f38-a2ee-9cdde18d9113', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22SHORT', NULL, '0000/22 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82365bfa-2ab1-4834-b5af-1a8b47e5f270', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5 PLUS', NULL, '5 TAILLE FORTE', NULL, '110/62 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8236837f-9454-4525-9559-f0d629ab5f61', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('8246d340-e1d4-420c-8aeb-a7b059da73cf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '10 Short', NULL, '10 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82709450-8b24-419e-a933-b30d3c11cb45', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82785fa1-0cb3-4b1d-91c9-59514576fb55', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8286af54-b104-4380-941e-b0aa3f59571c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82a3a82b-6c29-4f03-af0e-2f57860d328a', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('82a9be7e-d399-41b6-a11a-b7f641d21fe3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 P', NULL, '16/33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82ad0b8d-a2a8-4713-952f-3c4bbb2a8b08', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublicFactoryStore', 'XS', NULL, 'XS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82ad6065-bfac-47f9-9edc-0b6703129dc6', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82b30fd2-e853-42b9-bdfb-a3b7ac74671f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82b84615-c491-41e4-903c-5d56f41d3f8f', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', 'XL', NULL, 'TG (11-12)', NULL, '285/91', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('82cd70d5-a45e-41bd-a953-1fcb9626b9e6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12 HUSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82df5b20-7461-4bf3-b34b-ab6c79a9088e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '4 TALL', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82e676f5-96fc-43f9-90ca-5ed6cae676e4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('82e6b320-443b-485f-aa29-3b78029d2f92', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38A', NULL, '38A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82ed8ae2-cbaa-4536-999b-b34f9621e504', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10 HUSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('82fac31e-604f-4c25-8a0a-3a9ed788bee0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83074794-e9d5-4f95-b3a3-c0b2ce238b2b', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'M', NULL, NULL, NULL, '160/170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('831601aa-1708-4c4b-b903-57f3b3fc3ab2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28+ REG', NULL, '28 TAILLE FORTE', NULL, '170/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('83198b07-f79d-424f-9655-0f8592ca06e2', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('831d77f1-5996-43c3-a799-4db1de47c7b3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'S XLONG', NULL, 'P GRAND', NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('833407c6-f9d2-4bbb-ba0f-a93cb3617c3d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'L', NULL, 'G', NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('833632b8-36bd-4958-b98c-bb771f4f1f37', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '40 X 32', NULL, '40 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('83443075-8e9b-4464-8646-2c08c189554a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 T', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('834f93a2-f526-4dd1-8c59-b096818f883c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35P', NULL, '20/35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8358b099-7536-4a25-af9f-f43f6d8379f4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('83590966-016e-4121-8f3d-ae27ef4e8364', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('835ffde0-1930-4a74-9b0c-6e1ec1cd8769', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16S', NULL, '16 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8362e52f-5a9b-4842-ae9d-67e30e3a3abf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('836321f5-a5a2-4893-a195-a8b215e33189', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'S/M PETITE', NULL, 'P/M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('837f0561-de5f-4030-a05b-8c827ffceb12', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', 'Up to 7lb', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8385509e-f2e9-4dd4-8770-0a078e5cb67f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4TALL', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83872dcc-d753-4ffa-8579-f242556c574f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9743-d440-2b15e78e046b', 'OldNavy', 'S', NULL, 'P', NULL, '120/70 - 6-7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('83891cb5-2aee-4216-9c62-e6f31a344b71', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X30', NULL, '29X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('838fb331-e71f-4315-b2f1-f8b065041897', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M/P', NULL, 'M P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('839880aa-8d02-4c39-b2de-8c5a7665c93b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-8260-30c7-bcd31c94e7f1', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('839eb6ff-a698-4327-971c-46d90e46fb99', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '8 TALL', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('839ffba0-dc82-453a-866f-a7725d619287', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30R', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83af280f-063d-463c-94c2-f1cf39f5f1eb', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M26/W4', NULL, 'M26/W4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83c00da6-105d-41f9-81f5-5bb2fd7e1246', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-8117-8b6f-f6106a33ac4c', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83c39b1f-fd46-46e8-b4ba-382f412adc31', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-beef-4b96-697ae26c1476', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83ddea80-5eb0-4939-a033-780840d0fbea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30LONG', NULL, '10/30 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83dee80b-1706-4c91-af1b-6aa9dee9c7a4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38 LONG', NULL, '38 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('83e941c6-7f32-414b-a9c7-df73d7beaf16', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XS T', NULL, 'TP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('83ee68be-73dd-432a-aef8-e0c42fd09047', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48 SHORT', NULL, '48 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('83f3c329-431d-40b5-b414-a05292575ff2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10', NULL, NULL, NULL, '165/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('841d8c17-8cb1-4d67-a454-837ef3fbc38d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84294c2a-ac7c-48fa-89ef-7bd45fd37f41', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('842b6b41-7072-4920-b866-059ba1a5139b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('842d6a4b-13a3-4b05-a42b-6eb557b2fa9b', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34X36', NULL, NULL, NULL, '185/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('842d70e5-cade-4522-b703-656b01761ba6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00TALL', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84318459-c97d-4c97-9c63-4dccab9ce7e3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '28 TALL', NULL, '28 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('84436464-fe34-4069-aa91-7b54411ecfe7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'L TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('84439d6c-85ac-4460-82e6-fb7961060776', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6 MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('844bb218-e694-4d63-901f-eeb0ea22c24c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1016-d539-c4328a2f8e84', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('844e3225-fd71-4438-b068-20bf47ccb6f2', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('84530923-998f-4316-9bd3-9abdccd80b1f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84696050-e3eb-4e80-9e15-dfe988501c12', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('848837e8-5ffb-4d70-bce1-b51558ceefc6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '26', NULL, '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8488fe0b-6f22-46cf-944b-eb677ba230d1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS/P', NULL, 'TP PETITE', NULL, '155/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('848ce62a-32a5-459a-ab6d-8ca946e9e356', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'M/L TALL', NULL, 'M/L TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8491ba61-bd40-4bd0-821a-eaaf094d71c6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '18-24M', NULL, '6 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('849503bd-2f4f-46b7-83e6-c7e63696a05e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('849ab6ac-9011-4153-853c-b2a2d06ebfbc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 T', NULL, '0000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('849daf9a-efe7-4725-84c8-6991490ac74d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'L', NULL, 'G', NULL, '165/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('84b1068e-a2b3-478b-8b19-db4fcb1d268f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '18S TALL', NULL, '18C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('84b302de-0db3-430d-a3ee-10214327a1a4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'XS (4-5)', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84b7911d-03f6-43c0-89ef-3ae192308ab6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 X 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84dfa3d4-7b62-4e57-ab71-19b7c934e600', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('84e67543-6a72-47d3-a34e-5fbfbe151201', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'M', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('84f365e9-ed54-4e61-9ea4-b6e9fdfd8c5a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35S', NULL, '20/35 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84f9f5d4-4d44-41db-a5e9-8be8a74ef82a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84fe9907-521a-4afd-88bd-ba9d60d44bd1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('84ff0a5b-46a0-4e99-af2e-0575bcb7c7ba', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8503c3ee-2f70-465c-85f4-71486b52c857', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38X32', NULL, NULL, NULL, '175/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('850d3bf3-6e58-4f7e-b51d-192c1ddbf1eb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXS/P', NULL, 'TTP PETITE', NULL, '150/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('850ef62c-4192-4931-b4ee-d02eaa51ace3', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('850f3829-7767-40fe-9f01-208278de5a2d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 /36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('851ec0b9-6ef8-43fa-8afc-b72b53c5086e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M REG', NULL, 'M (8)', NULL, '130/62 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8522d429-18a5-4105-86d0-c05d2e86be18', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20SHORT', NULL, '20 COURT', NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8523f9a0-22d5-49b0-a9c7-0c6ba8bad951', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/ 30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('852647c2-3b0e-4c26-9f22-41e032a25e07', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '14 Ankle', NULL, '14 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('852baaf2-9ac2-426b-8f95-d78a5068f614', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'L', NULL, 'G (10)', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('852f1626-d3d1-4303-9112-bd2b5e51ed25', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('85331d52-3149-4ce9-9c15-8d5b400ea2d1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 TALL', NULL, '16/33 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('854ca755-604d-49cb-a747-f193ec592adc', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'MHSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8554fbcf-4b97-4e01-ba3c-e1855ae5ed8e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '31 TALL', NULL, '31 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('85573b94-7c84-43a1-87a5-d20ca95701b0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34TALL', NULL, '18/34 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('857890e1-ae2f-4f19-8829-9b7e85ec5340', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'M/T', NULL, 'M G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85794afc-3071-4a7a-b875-e302a1cb64ac', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16 REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8580c9b1-80f5-4554-aa99-e348f2328806', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12 MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('858437f8-24e5-438c-add0-e0c08771eba2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '4 YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('859636d0-388b-4852-a2ed-e7eedca66374', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85a19fdb-671d-4693-a31b-2f4d14cb9c36', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 TALL', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85a55672-978c-447a-ac83-dcecd0453c7f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85b8442b-6c73-4fff-ad27-22bffb81c8ae', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '44 Regular', NULL, '44 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('85bb9b31-ba84-410d-8589-499156722ae5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18T', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85c66699-d88b-461e-b65b-ee2af3e0180a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'SP', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85cc2193-3328-477a-871d-5348b0c7912c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '35 LONG', NULL, '35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('85e1f497-f67e-46b5-aaa7-cfea01f07c49', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28 R', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85e5b781-ebd4-4c12-87e5-9e7d2b7796ee', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '25/0', NULL, '25/0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('85e72dda-1b8e-4ec5-bcd1-526317b91e84', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14 REG', NULL, '14', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('85e9414a-68e2-4ff9-a6ec-62948821638b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS PLUS', NULL, 'TTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('85f5c249-a456-4b36-bb13-07af23f1ac59', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24 M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8608c07d-f5e8-4dc8-8cab-c6ce558713ea', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '31 X 30', NULL, '31 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('860c21cc-7903-41f6-ba1a-f7d6a6a80a9c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XS/S P', NULL, 'TP/P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('86110926-d764-4de7-823e-d740e9e7152f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16 HSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('861935ad-acdd-4ce8-b730-42bdc6e9c044', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8SHORT', NULL, '8 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('861b41d3-e130-4c3f-8680-491e2bf9075a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('864917a7-107b-4fb0-876c-7179f27bc447', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('864dc427-9359-41fd-8260-7f4715794776', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/ 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86586d34-4cd3-49e6-8abb-56cc1569d1d2', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 REG', NULL, '0', NULL, '160/84C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('866b939f-e780-4d98-b4fe-03ec36f1e7ed', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20TALL', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86717fb8-be54-4019-93b0-bfa3face509a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '14 SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8671e9d4-e9cc-4216-863d-c28b3b1bbedb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18PETIT', NULL, NULL, NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8672d18e-5ccf-41c4-b0ad-7b32bf2724cb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '32/14', NULL, '32/14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('867c5b41-cab4-4a6b-8cb1-39fc78766bb6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8 HSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('867dc814-975b-4a97-98d4-a68079c55e93', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 T', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('868308d6-b170-490a-9069-e1e6f4582d30', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10 LONG', NULL, '10/30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('868fd527-1d98-4986-9a69-253673f10c24', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('869fc363-63bf-48ee-bd55-87eef5f9c55d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XS HSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86a4b30f-7269-4707-8dfa-a9f6347fbd26', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26 REG', NULL, '26', NULL, '165/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('86b9eda6-77d8-4199-88cd-8de465c0b75d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'M HUSKY', NULL, 'M (8) TAILLE FORTE', NULL, '130/72 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('86c56034-19e5-49cf-9ae5-80e334439c3c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12 REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86c61986-a1cb-4697-a040-2d09c6dd6ea8', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L', NULL, 'G', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('86c698bd-4dd6-4cb6-95f7-dd8fd202e42e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86ca930f-fb9f-4478-9af0-6ae88cf6ae4f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86cb30ec-fa6b-4530-b6a4-78093a9b36c8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '30/10 Regular', NULL, '30/10 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('86d00228-39bf-4e84-bd5c-86d0abf78813', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS R', NULL, 'TTTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86d1b842-275a-45ac-bb2f-352d6246cd83', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '30/10 Long', NULL, '30/10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('86e9522c-73a2-4439-9d4a-b1c84fb65d82', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '000P', NULL, '000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('86eb23e1-e093-4ed3-b041-4ba88cabbc94', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86f6236d-9e6c-4145-8e94-0b0fc5f638e6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 LONG', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('86fbd651-5745-475d-987b-c6741a0a17e7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M', NULL, NULL, NULL, '165/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('870b6859-63ae-4729-a900-e400dc55a3ae', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '30L', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('87257c20-37c2-405c-bcdb-4a04f22d3e16', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('874502d8-c65d-47ec-ad60-770af3758d76', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87463d25-0262-42be-82ef-823b6cbda151', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14A', NULL, '14 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87465986-3aa5-4886-8fbc-d179bbc4262b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 LONG', NULL, NULL, NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('875d4648-69fd-4c76-a6e4-a3bee6d86721', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS R', NULL, 'TTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('876438c7-f4e6-40c4-81c4-3bdb5954df86', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 / 32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('876b3ff0-e98a-4ee5-aa35-f4dcf07a3192', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 REGULAR', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('877c633d-5f3e-4f24-939b-256cfd87b020', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '12 Ankle', NULL, '12 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('87951e9a-c6e7-4373-8e22-9e6c4dc8be42', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-c181-a8bd-98f9701619cf', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87b52467-2a27-4d46-b16a-5c1509e0f7f8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('87b9638f-e005-4919-bece-a112cc22a708', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 S', NULL, '14 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87bd4eef-a6e3-4288-97e2-c4466eb9c822', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32X38', NULL, NULL, NULL, '190/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('87c56252-a634-4664-a93c-85b210368eca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0745-618e-918791902aed', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87c71d32-f6b4-4b62-a3fc-3f0fa339c575', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-14fc-dba8-880741636a4d', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87c926a6-b1ea-4a02-b3ed-a0ee22517ca0', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('87d08dd1-5870-4ad0-a7af-964bbcec4e77', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9 MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87d4dba4-8732-4448-a427-1bacee1c3357', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '24-26', NULL, '24-26 TAILLE FORTE', NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('87d66d51-04ea-4904-8923-a4886b6351a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87df4a53-0f62-4d4d-919c-b6cbbf0e37f5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXLSLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '14-16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87e60a9c-576f-4e89-88f6-a47539561ea9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('87ebd20f-344b-48b5-b3d1-ddf90c92b98b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35/20 Long', NULL, '35/20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('88005276-3e11-4168-b127-c6c877026822', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '7/8', NULL, '7/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('880b6313-d485-408a-936f-8f4ef13d6502', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '42', NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('880eec2f-e8f8-48bb-ba9e-77754f18b033', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88207793-122e-4928-b207-9ef12d386f25', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26 P', NULL, '2/26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8826f3e6-0a2f-4c80-b4cd-de730d1e87b7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('883158fb-19c5-4aee-a45b-cd2b912309f0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000X22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8832d44a-a60d-4255-9d0a-5b3722f377ad', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8833f6b9-2434-4c0d-a195-0d9828ff2920', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('88349d81-1e9b-403a-8576-9393bdd9c2c4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00S', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('883a76ec-540d-46b9-b72e-084e12595396', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33 TALL', NULL, '33 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('88414347-6c5b-4d33-be32-13e8830f759f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('88430cae-4399-4fb6-a261-90c9ad00d2cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-28d9-e5da-9797f8fc4682', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('884b5b1e-794e-4b34-9f76-8b1659214403', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('884d3b09-96c0-478e-850f-4bf605ae08e2', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', 'PREEMIE – UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('884d92bb-bd5d-48c5-bf84-4d67b2b9bdcc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('884eff20-ebfa-40f9-9cd8-8c24d003fcfb', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('885d768b-438b-4b8d-9bfb-dccae1849e3f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('886b6d15-6199-4c41-aa65-38bd34d5cf28', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('886c90f4-f707-4a0b-b2d0-f503bc1286a1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '16P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('886dac6c-82a4-40eb-8f56-a43a7052ff89', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XL', NULL, 'TG (14-16)', NULL, '155/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8871090d-7318-49db-9991-1009ce334788', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '36P', NULL, '36 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8880f70b-951c-43ca-8a3a-85e702e3e139', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88a10b1d-3c31-49b8-ba3b-e9004d6101aa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2 XLONG', NULL, '2 GRAND', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('88ad6b58-969a-4a3f-a207-55b9235da06f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'L', NULL, 'G', NULL, '180/185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('88bb7031-a2fe-4212-914a-94413765c910', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('88d0e968-a6e8-4fac-addb-2bdcff66ec25', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88df5626-828a-4bf6-aa14-f06190b3caa8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88e289b3-1a47-4b2d-a9aa-ae7b3ea60df2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14P', NULL, '14 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88f007fa-6c10-46d4-92ee-66fe439f03a2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'XXL18-18 1/2', NULL, 'TTG 18-18 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88f667c2-af51-4f47-a76f-f1cc59324c6f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 A', NULL, '0 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('88f9650c-9fdf-45e6-b52a-f43b2f3646d0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8900de22-c6c5-44a7-a57f-2d21134d0bb5', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('89044061-80fd-46fc-89d1-f68fc80f2c2b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '10 LONG', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('890548eb-542e-4cd6-b63d-0b75c297eb7d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 P', NULL, '20/35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('891ccd30-5d74-4fa9-a58e-f701d529e5a8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '41', NULL, '41', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('892da2a6-3b7f-4453-b4e2-c01834684345', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fc2a-f50a-b69401759c32', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89307399-8b1d-4e80-a15a-1683dde7c7f7', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '8 SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8930dbd4-9e68-47af-86b9-5a6e0d518c51', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 / 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('893a8420-3a2a-458b-9d88-c766b3e30f56', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('893e4d71-e23d-469f-8943-a88d5165aaca', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89440eb5-7ea5-4601-a265-5a8f053d7db2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22R', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8947eecf-3b23-45fc-9d28-40a86cc7dafb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XS SLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('894c5908-57c3-4270-9091-57a85a17e1cf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89641960-adfb-4326-bed2-2f660cf9fc38', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '29/8 TALL', NULL, '29/8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8967de4b-70c0-455a-af29-fddc82d83698', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '24', NULL, '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('896fad26-3602-4dd0-9961-e4602da78540', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89719d11-f162-4d71-b1af-7f6f4e0ce9f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('898df8d0-88b3-4029-ace4-dcf7711d9768', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL/P', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8992da41-bcf2-4db1-993a-a92f7d9ba063', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16 REG', NULL, '16', NULL, '170/112C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8b1f60bd-0f75-41d2-9bae-7d68ccfeb8ea', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8994560f-f624-4a18-9605-b2da2935d096', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('89945f27-62f3-443a-a1fc-66b1662e8e19', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89a596e5-931b-4372-ae22-870143d245b3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 / 28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89a82a6a-ce89-4020-b3e8-c8fcb397358b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('89ababcb-42af-4649-bcf5-fcca783711b4', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '34/18 TALL', NULL, '34/18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('89b92d03-339e-43fc-888b-dbd809ecd358', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40X32', NULL, NULL, NULL, '175/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('89b93449-d9d5-45c9-84bb-35b92708d255', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89c2cfb4-87f0-471b-a3f4-c01b08411de0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'S', NULL, 'P', NULL, '120/64 - 6-7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('89d2a2ca-fff1-429c-bf61-10492f6cde39', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6LONG', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('89e42a25-d7e8-4b20-894f-49a602a9bdae', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', 'PREEMIE – UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('89e4ee4c-8d74-4512-a5a2-ac1f96fc5d69', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S', NULL, 'P (6)', NULL, '120/56 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('89fb0e71-f08c-4eb5-a13b-e5d492195eaf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6 REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a0cb0fe-5c71-418f-9c8a-1943fa70c9d1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a222911-6ac5-4c02-9e85-70e85d3b7d14', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '10', NULL, NULL, NULL, '165/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8a241106-da9f-4b88-b159-2dfb56e819bb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X30', NULL, '32X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a345200-b30c-4f23-9185-ab13efde0bf0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 A', NULL, '34A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a37a97e-1279-4441-bfae-aa21622f5eb5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a5513b1-f190-447b-8775-8d05d3946e5f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6 MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a693d3c-5b18-45f4-a13c-5a60e7ff26c1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8a6bcb6a-2f50-49c7-9f6f-d9304d528842', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '44R TALL', NULL, '44S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8a7772b6-0c2b-4cc9-8086-96b43f1b31fb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '27 PETITE', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8a8ca586-3be3-4d25-8452-0f753c2f05ca', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a93bb8c-f946-4ab1-a4d4-321cdadba1cf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38R TALL', NULL, '38S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8a9816f3-c956-4185-a6b6-abee9f0ee946', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '25P', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8a986bde-6305-460f-9908-11b326b68620', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 LONG', NULL, '0000/22 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8a9a8082-a0e9-4be9-8158-336ef44e91cf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8a9bf413-02ef-4ada-89e6-140014af6154', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL REG', NULL, 'TG (12)', NULL, '145/66 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8aa37423-0be8-403b-af25-4878f732d44c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34L', NULL, '18/34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8aa9c041-9c33-4410-b162-a91f8f0f928f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'L+', NULL, 'G (10-12) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8abd5c54-dfac-4bed-99bd-95d9809a3d63', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8aca0057-64ef-4570-8ed8-fd4deb43c99d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 TALL', NULL, '0000/22 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8aca2324-8a19-4da0-9877-2c5e1684b08a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8acf3930-aafb-4f45-b195-4976de18dac2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ad3b817-7d38-4cff-8a61-4617132a7054', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8ad785f3-046b-4416-9ebf-bea7084306fa', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '10', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8ae5be49-70f8-489a-8972-6c3fe08cd055', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8aeada76-d93d-497b-b143-a122cfb9daa0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '0 Petite', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8af35687-038a-4d27-bfd3-0c76b2d41d2a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '5 YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8afb0ea9-2165-444d-ae0f-95f4c2c34ffd', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublicFactoryStore', '6-9 months', NULL, '6-9 months/mois  27-29 in.  69-74 cm  17-20lbs.  7-9 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8b0667f9-4187-4fc4-9ec3-485d64a8caf7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16SHORT', NULL, '16 COURT', NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8b099fcc-c91b-429c-a239-6efbcf158b18', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '2 PETITE', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8b11933d-8998-4370-904b-39f854f02605', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublic', '6-9 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8b15fc71-1674-48b2-9038-13504f7bb48d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', 'M', NULL, NULL, NULL, '270/96', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8b165ea3-74fd-4327-9662-2e6a6c7f19d7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12 M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b31e98d-f2fe-4e91-860a-31e6903a930e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27J REG', NULL, '4/27 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b333a8d-74ed-405e-9ff1-24d45f872db9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0S', NULL, '0/25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b342300-28a5-4952-9bf8-46a49fd570bd', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '2T/3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8b3bd5d3-11a0-4964-b3a2-e9e850a36bc3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b3d432b-804d-414b-8abd-1e13599dacf1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X 30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b3ee16e-dc42-4278-8306-5df7a9b2e07a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X 28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b4f53a9-8a6c-4d41-a7e1-f4306a00d9a0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27 R', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b539453-8148-49b4-93d0-7fa672bf9af8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b5ffde1-4a44-4ca5-b0c7-45f307cb6f3a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXS SLIM', NULL, 'TTTP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b67d16e-a920-4c5b-97ae-0dce13559b26', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'MXSHORT', NULL, NULL, NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8b6d28e2-150b-4428-a136-6370844ad1d0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4A', NULL, '4 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b7a31de-9de2-4b87-a3d2-df259d7c0101', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '48 Long', NULL, '48 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8b7e54e5-26ae-4545-a8f7-c3ad48eb816b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b8bde22-436b-474c-95b4-29e9842965f8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4407-8b9e-a6afa1319c44', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8b8c393e-0502-4157-bcdd-a470a0665fb3', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20 REG', NULL, '20', NULL, '170/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8bc2b18d-a5a9-4aa0-b068-8129cf39e1b3', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '18-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8bd58db3-caa1-4e74-a4a1-c61028d71ba4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M/P', NULL, NULL, NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8bdb52b8-5ba6-45c4-9bd1-f57c2f21dfc5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6P', NULL, NULL, NULL, '155/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8bdfe23f-a4f7-4b57-b93f-1d7ac4f486be', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '32 Short', NULL, '32 Short', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8bf6d844-3db5-4e19-b047-3529270a4c26', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X 30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c062447-258e-4838-a5ac-0f0bd3eeefc4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c08eba2-03dd-4f0b-a0b2-56250291c3d4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8c09756c-b47c-4b8d-a1cf-9a72b59be3a4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32REGULAR', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c12d4ff-520e-4266-96c1-61270e7c0e18', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('8c16e6ff-7bea-4df0-b5bf-c5e2379bd3a1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c3028a1-e079-42d6-a1f8-17d069445838', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'SREGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c320138-ee8a-4471-82c2-677bd8aec580', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XS', NULL, 'TP', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8c41b5c4-8382-4999-930f-6eae84ab0f49', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '000 PETITE', NULL, '000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8c4ddb38-1764-4977-ba05-0af193c3a536', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8HUSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c58d385-17ba-4240-9ff9-b38b4b65f2c6', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'XS', NULL, 'TP (5/6)', NULL, '140/63', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8c5d1708-8b17-4c27-bd0b-721e291cdb79', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c81e7fb-91bc-4eed-b5ad-bfa25a2a56d8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '4', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8c87bd77-fda0-45e0-868d-035ce9999a2a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'XXXL19-19 1/2', NULL, 'TTTG 19-19 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c9833b3-4897-4488-82e6-1c9f0cd6050e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c98f53c-f471-4106-baec-a35fc02fc6cd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8c9d7e90-bc2e-410b-b2a7-1ad05afe85e5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '28/6 Regular', NULL, '28/6 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8cb05738-0ee3-4164-9b01-bd6667eb808f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8cb44abf-54aa-4d89-8cdb-10eb8200cf7f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8cc1b6d6-0313-4eea-b346-7295c83cb431', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '34P', NULL, '34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8cca2e6b-6897-42d8-a2e0-5e53a2d79adf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00X24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8cce41aa-cfc9-42fa-bc38-3e0b301865f8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8cd5424f-d6d8-4d47-a5a4-d5c914237897', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8cd54445-3897-4c0d-b545-97433c2317f6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Gap', '1 (0-3M)', NULL, '1 (0-3M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8cf3dddc-315d-472b-a3f8-06e3b451049a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50S TALL', NULL, '50C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8d024e28-fc85-4b06-9aca-5b86b7b1896f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 A', NULL, '0000 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d1e7b80-6a19-478c-82d0-6449b1664597', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8d2808d9-f042-4ab5-8f33-abf72ee0d4b7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'LHUSKY', NULL, 'G COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d2a710a-9fc3-4e03-bf2b-7d8cd38d0cb3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XSPLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d2c42d7-f20d-40eb-9923-8e1cf49f8f37', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8d2f92a6-e251-444f-a7d1-a679160c513e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d37e450-f50d-4f5f-8015-ad44fa28dbf2', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 LONG', NULL, NULL, NULL, '165/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8d3fa190-3999-4080-9f07-385484426f22', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8 TALL', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d468335-0d89-4c23-99c3-4170d02dd3b1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '42X32', NULL, NULL, NULL, '175/106A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8d4f0406-c40e-4dd0-9437-48e34b7fc340', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('8d540e44-6e33-4cc0-a5fa-d8f0c76dd0ad', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d5f1137-1482-477c-aaeb-66f3bc89ee4d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS+', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d621998-3183-4451-b388-dc7ac71778ca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-34c3-4e5c-11e6de75cf25', 'OldNavy', '4X', NULL, '4X TAILLE FORTE', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8d6a2ca0-32af-4afd-9128-cde59aff41b2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44DDD/F', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8d7f3cc3-d516-416e-98c1-a2ba721ea918', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 L', NULL, '8 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d8c86c9-d20f-41dc-a67f-317f7b858fb0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '165/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8d8f97ab-e6af-4d2b-b9d0-eaffa5732f52', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4S', NULL, '4/27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8d8fb2c7-e824-445f-ae80-bcca9b480a58', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L HUSKY', NULL, 'G (10-12) TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8dad8eae-ba1d-49c8-9438-a0b93c848822', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8dbb120c-2301-4acc-9d21-ae85aca139e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 SHORT', NULL, '2/26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ddac535-a416-4965-958b-688fdfb1cf17', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '27/4 Long', NULL, '27/4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8de2d25a-25b3-4f86-b6c2-00fc318a3bd4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L REG', NULL, 'G (10)', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8df09d0f-1689-4ea2-b2af-2977eb046140', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'L', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8e0d7903-c26f-4bfa-b168-f7ae607e0f56', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '165/105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8e112dfc-ec33-4613-ba93-7e986b58b18c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22REG', NULL, '0000/22 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e11f17b-dae0-45b1-94af-4bdf20f702d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4T', NULL, '4/27 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e16dd96-4375-4f93-aebe-e7171e280952', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', 'preemie – UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8e17833d-9c69-45f0-8bff-7dacad0e338b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8e185c9f-abdf-487c-9165-d35fd5d6861b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e1fbd63-7e7b-44c6-a6a6-3a7ad695c2e6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e218b24-fa14-4e0f-b70e-4d1d72386bde', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e25fc57-a54f-486f-b8c6-13ca6e8fa663', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12 HSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e2c0299-dd00-417f-b96f-a7499743a2c4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e2f0672-2ca7-439f-ada1-16ddbd01d98e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e30c252-6b75-4fcb-ba63-50bbe0e5e407', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 SHORT', NULL, '8 COURT', NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8e3951e2-7d17-44c3-ac86-28cdf76409fd', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('8e3a6bd5-0f8a-4813-9010-1e6a39899b22', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '18 Long', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8e51023c-4555-4e3d-8842-d932b79b5e0d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-abc6-5927-9b41f70fc3ad', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e51c385-ca1d-400c-9187-ed962c7c3703', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30L', NULL, '10/30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e591ca5-a4b7-49e2-8060-c81e37b52c78', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '185/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8e5f1368-ca74-4295-a54f-04d842a77cad', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8e64c890-b49f-4009-aeb3-5fb30d46476e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'SSLIM', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e6dc2b6-cec6-4be9-a409-e050b2f68718', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '20T', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e7c54b5-a91d-430d-8416-b59c043194a9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e7d3046-6ac2-4b9c-a62a-999a7592e28b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S/P', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e825528-fce2-4c2c-b8db-9bb95f1457d5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL /T', NULL, 'TTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8e952029-8870-478c-b933-4e561b52a891', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8e9630fc-d5c4-4d86-a4b4-d835d66fae7b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8e998651-22c6-4e3b-9d1a-9e29d0e4b80d', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8ea564c0-c40d-4173-8452-dc86609fe58e', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XXL', NULL, 'TTG (18)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8ec85913-18bb-40ee-8c21-1d015245b881', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8ecf1dc1-484e-4707-9952-a933e8943cbb', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXLPLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ed2bd5d-41ec-41f2-8ed4-765ca07cec8c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12XSHRT', NULL, NULL, NULL, '160/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8ed4c2cf-cc96-484a-a60d-20f73ad81c83', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '12 SLIM', NULL, '12 ÉTROIT', NULL, '145/58 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8ed953a8-bdf1-4509-a9a5-a42ce4eae01a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8eece477-a658-4919-bd3f-22bc1c67a245', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'MHSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ef1cb94-f091-4201-8135-63059be50edd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ef7b12e-456e-46fc-a593-33692a7c51b2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X 28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f183018-7ce1-4e8d-9ae9-b9176793e48e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS T', NULL, 'TTTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f412e2b-9bfe-4ae5-9e8d-431973b226df', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18 SLIM', NULL, '18 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f44b312-e61f-476e-b90a-1a65a557c991', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-8cd6-cd0c-a8d7866c28bf', 'OldNavy', 'L/XL', NULL, '11/8/2024 12:00:00 AM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8f4af75c-f406-407c-a6fd-f4d4681b3d66', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44/32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f4ceabf-3887-474e-9c61-619bdd48dbbe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2REGULAR', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f4d2c1e-1e53-48b2-945d-63837b2defad', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0P', NULL, NULL, NULL, '155/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8f5a8642-0680-4a11-b839-9fd0904b65f8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f6e2d93-93c9-4824-9693-a027c79692b5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 T', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f6f9ee8-eea3-401c-b23f-a1c14f3c157f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f7545ba-8cff-4181-b938-eab958c8b3ca', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fd07-5fc3-8d6e440f42f0', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f7931bb-c640-47eb-844d-9359cb2f62db', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8f797f83-8dcf-4e30-a292-73d1f5f31fe7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28P', NULL, '6/28 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f8f1f97-74a9-474b-87c0-492e80e785ec', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00PETIT', NULL, NULL, NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8f91b9af-7115-4781-a0d2-ccd444906b66', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f9aa044-4c64-442e-944d-2f7baa60d12e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-abc6-5927-9b41f70fc3ad', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8f9e945f-131e-42c1-b851-76abbb0fd74f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fa5ad87-f502-4719-b044-1537519a15ff', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24 REG', NULL, '24', NULL, '165/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8fa99f9b-9b95-4fe6-8f83-e1ad310efd6d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fb9c012-ca3f-4e51-abd0-2c3d064eb3ef', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 LONG', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fc5d8a0-3081-4250-b230-581f1fa31cca', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('8fc678a1-4a9f-4d84-83db-fe924295bd65', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12 MON', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fc89c6a-21ab-477a-a0c2-551b2256c826', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XSXLONG', NULL, 'TP GRAND', NULL, '165/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8fce30ad-a65d-43d8-8f95-f517a36ab324', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '1/2', NULL, '1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fd9b8a2-404b-4184-8c0c-5f094fd4308d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12HSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fe18f01-101d-40e4-bdfa-dff9923e7337', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'S', NULL, 'P', NULL, '17.5-19 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8fe447bf-d0f0-4af7-b516-4392e62b606e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M REG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fe4eb00-fad2-4b10-9b0f-40fe67f813bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X32', NULL, '42X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8fe6df9c-d376-4cfc-bf29-8c5a6b521ec6', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '10.5', NULL, '10.5 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8fe87d57-7fdd-459b-a69c-5e346d764ce9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X 28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8feaccb3-cbf1-4f02-b4a1-3d412869bf8d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-e115-fdbd-d29a32c010a6', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '185/200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('8febed2e-e0fc-4104-aa4c-fb2c6b8b2ac8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ff7bbb1-045e-44bb-8b80-7f09dca485fb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'ONE SIZE P', NULL, 'TAILLE UNIQUE PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('8ff97957-b6d9-48e1-933b-b74040597de0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00T', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('8ffa0082-f59e-4279-8773-dca2ee8b3d61', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9009882a-e4b5-4ad3-81c5-b9d52623e61e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL REG', NULL, 'TG (14-16)', NULL, '155/69 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('900c6593-a6e9-4710-b4c6-b3a2805025ac', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXS SLIM TALL', NULL, 'TTTP ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('900ca028-3b89-4ae1-9840-a33b19129596', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '34 Short', NULL, '34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('902bd5aa-3337-4f68-8fd9-85d032215ff1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXL+', NULL, '2X', NULL, '165/135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('90348693-e1b3-4768-a732-4bceb35e3766', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('903658ca-4bc6-403e-bd31-cd8c74b9fcc6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32P', NULL, '14/32 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('904a2677-e04d-4e84-8cc5-5718a3405c07', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '6T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('904cc8c6-4f99-4824-94b6-162182123c0a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-43ba-4d32-d4765755b21f', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90631628-2b22-4b5f-814d-824dbc06f0e8', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '185/114A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9095aae0-4fee-4ea7-90be-759f2409b0ab', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9096380b-28c8-4e37-a593-ec679e31adbb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL/P', NULL, 'TTG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90a0c4a4-aace-4006-a342-8814f8bc447e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90a205ba-38b5-4f21-9cf8-9a09e964baac', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X 32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90ab5d22-e1b9-497f-93ba-c00c2e7bb3fe', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('90b77033-e360-4a5d-ba1b-3ebe68c96ac7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('90c0fbe0-1a88-4784-97cc-934fa4fab74f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90c9c36d-5d95-4888-932e-8ec15f9dc878', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('90ccc873-b72b-43d9-a38b-758931fbc2fd', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0df0-ca33-6fa4848dbade', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('90ce0050-6014-4c06-b8c6-e43735cdbebb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90dc51c2-52ba-4676-a187-32758c8b9559', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '23S', NULL, '23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('90e7d012-6ad4-4e79-a291-89afab4807d2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('90e8d1b1-7f56-49ce-9092-c6a7ef31b49b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9114cabe-1a77-4356-ae53-c99a49a20c10', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 / 28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('911a517e-fa0b-44e6-b61b-430c5d50e65d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS +', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9128bbad-5d0d-484c-8127-87ed3fa73d98', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 / 32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('912e1a11-8393-4f82-95d3-db6346abf0bb', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '9/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('912fccbf-3445-48ba-9575-57f1aed6b685', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 LONG', NULL, NULL, NULL, '165/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('913e5489-e0e8-40cb-9573-ab8e8a3ffcc4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-525d-2588-e7f15d7093a2', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91458655-aeb1-4e40-b494-5579da19b73d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91481c4b-8862-4448-b1d1-840643ca2fa9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '4YEARS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91512cc2-baea-41bf-9d9f-d5bfeaf593b0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91534470-2941-48c0-8589-358b2caf91ed', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9155c4c0-eba5-462c-9774-7e5528334584', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9165e3ec-f9b2-4b4c-9c4b-7b0f40730e87', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XL T', NULL, 'TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9168d3e9-a116-478b-8267-e475211895fc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('916c7a3a-4fdd-4f50-b8a7-b1de7e69f74a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X 28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('916f9020-8308-403d-8fbf-ae09e04cfbd2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '18', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91736c81-77d5-4819-a98c-32b878bcfcd2', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'S', NULL, 'P', NULL, '17.5-19 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9177b226-1093-4e5c-bf56-e0924ec3cc0c', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '9', NULL, NULL, NULL, '270/96', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9182aad3-0a4f-4e3a-af53-d4faba586014', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('918e6889-f537-4180-ad4a-b2b6fce334f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/ 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91984a77-ed6a-4566-9b77-53c574826712', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91a40d7c-ceea-430e-b29e-7b1c57fe994b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '1/2', NULL, '1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91a96c4e-6c32-42ce-ac94-bda5be009978', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '4 Short', NULL, '4 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91b3bdd4-6756-424b-8602-39858d16e2cf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91bb7950-8d15-4f58-a884-c883abba2940', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XL/XXL PETITE', NULL, 'TG/TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91c85f1c-0b6e-4836-9904-55b3e312e186', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91ccec5c-df94-44e9-81f6-c39874f49731', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X32', NULL, '36X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91d2d2c0-5c5a-4e8f-b655-b8c084c71541', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('91ea492c-cd91-4617-8351-de442f18a133', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('91fd6e29-edb0-4d49-bb6a-4ae0cf370d11', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('91fe09de-801f-45ad-bab7-2211fab246d0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M/P', NULL, NULL, NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('92041a16-b498-4e2c-a8af-e23c794243f8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '25S', NULL, '25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('92042d17-7be5-4d71-ba15-ad060d7a37d1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9206709b-8158-4dd5-b949-d70a1803903a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '2 Long', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('92077348-0f4d-4158-a30a-064e2c900ef7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '26 x 30', NULL, '26 x 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('920973ce-5053-481b-84fd-e17428a50413', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '26P', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('920bbc7f-483d-4589-9970-e896e6fbaebc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '12 Short', NULL, '12 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('920eb705-7c27-4f02-ac3e-ad8025f299d1', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '19-24 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9217106c-87c0-4fd4-9334-eff1f55cf04e', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('921b62b0-cfb8-438d-b5e9-8aab47f67d86', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 REG', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('921bb698-4ee6-4717-b6d5-6b89e542f84b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/ 34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('921c8fc0-2c28-4491-8932-1ccd5feebf46', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52S TALL', NULL, '52C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('921e963c-e24c-4cac-a478-ce4dc8c6bd33', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '26/2', NULL, '26/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('92204777-e79c-4dfc-a7df-e8abaff7d262', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9222b867-213c-4daa-aa11-bfba2a351014', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L PLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92245c8b-d443-4347-b098-d14a8d7fab70', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9232f281-f1a3-4a02-a79e-66ca57b2c73f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS T', NULL, 'TTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('924efc76-53c0-4e70-8f84-bf86c0471bfa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-fcdb-35df-c4e65e2362a3', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('92553fe9-d556-4cc3-b09b-b1c1e5bac59d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('926a0638-4196-4b4a-ab07-5bb8b53b831f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '18 LONG', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('926c3137-d648-4388-9724-a933077084e9', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '185/132A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9275d6e1-8ecd-49f2-94dc-a0fad934f812', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-28d9-e5da-9797f8fc4682', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('927d2664-3036-4ff5-af2c-ba94498c1a25', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'OldNavy', 'M', NULL, NULL, NULL, '背长 x 胸围 48 x 74 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('927dc3bb-f7bf-42cf-887f-ff3ef1618649', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('927e9800-423e-41c8-83ec-e03472786e20', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXLSLIM', NULL, 'TTTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92819a32-6325-45e9-ba5c-c1e4164f19c5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30 P', NULL, '10/30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9281e58b-1fc5-4ca7-9e36-60cff98fc5d9', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-9c9e-8cb3-8a8541a66beb', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '***', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('928518fb-5998-4f2b-9d68-839952576c43', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XL/T', NULL, 'TG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('928addc2-d9dc-475b-911f-e8795ca752bf', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('929ff69c-ae69-447f-be40-16f6d31db407', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33P', NULL, '16/33 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92a1ea2d-62c3-4e11-9fb2-f3eea0c7cb63', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92a34f50-e938-4f6d-baa7-26cd98ae6035', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL REGULAR', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92b49a8e-566a-4b86-ae4c-7b8699bac3da', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '33/16 Long', NULL, '33/16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('92c000fb-d38e-4e92-b77a-d725d67c27f5', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92c33f88-0aba-46fb-8b37-edf9e07e2250', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92cb107f-c654-4142-95d8-6602e392f661', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14 SLIM', NULL, '14 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92d2b2ca-e628-4f7d-ab8b-95842ff8db9c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', 'UPTO7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('92d45b04-ae2e-4e95-9983-13761c6ab92e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XSHUSKY', NULL, 'TP (5) TAILLE FORTE', NULL, '110/64 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('92e54b91-5713-4fec-9fc0-5de892c0bce3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '00P', NULL, NULL, NULL, '150/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('92fa1831-8b88-4121-b15c-de11f28563b7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('92fd38ca-1828-4930-a4ee-62c15c19cb4e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30 LONG', NULL, NULL, NULL, '175/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('930f1263-c0a6-4643-a332-881aa3f1f290', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32J', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9310e215-0353-4638-82d5-f3a3d52b18c9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44X 30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9318919b-b93e-4fbc-9c7d-48e58318c2f5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93268516-91f7-478d-b173-71ee5bf2742d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e16-36d5-892d7cb07f93', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9328946e-34ac-4b3a-8f14-aff6a26e7c01', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '26 P', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9328993e-edbf-41ec-8286-8ce4d3123164', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M-L PETITE', NULL, 'M-G PETITE', NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('932afc61-34ab-4da8-9127-faf56f8109f8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '30 LONG', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9330e560-b843-4819-a4fe-e35b37cb3986', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '25P', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('933401f9-b888-48fa-9c94-c86f6bfe4817', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L REG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('933ce3cb-4c64-4934-a6e6-563b4bd5c06e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('934493e3-9112-4a69-a645-2057516c1ff3', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9348023c-439b-4f7e-b682-4cc2bcf52c74', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9357548d-19a4-4183-9b1d-5173db95748f', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '6-12M', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9388a83b-2da7-4d9f-9a56-151063072c8e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '28/6 TALL', NULL, '28/6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('938ffdc3-28bc-439f-b7cd-eca52d1c6b5e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '20 Ankle', NULL, '20 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9397fbac-1ea9-4c14-9a57-7ef88ca566a2', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L REG', NULL, 'G (10-12)', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('939827dc-4568-496b-b974-2c5c9397629d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X28', NULL, '33X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93a66cf7-cd6f-442d-94e4-c1597f1cf97c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93a74a63-ebb0-4103-803d-e99f07b6ed06', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93afac33-b534-44ac-b3d9-fc86733c92d0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6331-d8ba-438a49af2b55', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93b61aae-0d20-4646-a256-729d6c204234', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 SHORT', NULL, '2 COURT', NULL, '155/90C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('93bcff60-447b-45f8-8e1d-d31615d997c2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 LONG', NULL, '16/33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93c281b0-ac7d-4f36-a08b-28270b49e105', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('93c44c2f-bd4a-4d44-b568-adf443a5ac3d', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('93c5554c-690c-4eee-ad66-adc3566566e5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35 R', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('93e4eb54-e0ae-4611-944a-2c6af41f16d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33LONG', NULL, '16/33 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9404f710-9236-4e20-86c9-17d3a37c8512', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4407-8b9e-a6afa1319c44', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94062606-2655-44f1-ba3e-e75c4b773951', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('940691d0-e098-4ba9-8469-853de7090f7b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'S REG', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94097f47-994d-4e10-8352-b6546e72f391', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('941b36dc-059e-4c4b-809d-abf90753dd55', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2X 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('942717c8-e494-4cb8-9a86-0bf3b0254e72', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXLREGULAR', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('943c23bf-25ee-426e-ab7d-3f7d7eb5a6b6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9456cdcf-6d2f-41b3-a12c-a8a5a391b4db', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('946a15ec-1f66-4770-9c37-84c79be5ec56', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('946c39e1-eb4e-4b4c-95bd-7d5097923817', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '4T/5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('946f7e2e-66cc-41af-a1a1-2974aac3155b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18 HUSKY', NULL, '18 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94717069-04f1-4dd0-a895-956b39e90131', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '25 TALL', NULL, '25 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9474afcb-5526-4edb-8a2b-a24df6d929f5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '26P', NULL, '26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9479e6fc-050b-4c41-920c-2d259ce231d0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '29/8', NULL, '29/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('947bc8ac-2426-4074-93f6-8e685d800904', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '31/12 Regular', NULL, '31/12 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('948036e1-f7df-4b85-9d51-c65cb3fbb2f4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94814df0-2056-4ea6-a000-83624c6b34cf', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'S', NULL, 'P', NULL, '160/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9486bd22-484c-4c97-8e65-2b48fcb9ea14', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'S/T', NULL, 'P/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('94877414-a7a0-4cf2-96ca-6e49186aea80', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'XXL (14-16)', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94884b93-c16d-4132-9e9b-fe399e97441d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('948854ae-6153-4c61-b89e-560626f20fea', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/ 30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9493bcba-e89d-4e10-9a10-c817e7ace974', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20T', NULL, '20 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9497ba38-a23a-4b1b-9004-fff291af98c5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '30 P', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('94997e73-5604-4acb-bbc9-088d3b68b80e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '38 X 32', NULL, '38 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('949df7c2-2656-40b8-8980-f407ed2c0791', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('94a7e3c8-7361-49da-a241-3562d2470042', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28', NULL, NULL, NULL, '170/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('94ac8d36-1fc4-4e4e-91dc-aeb469054d99', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 LONG', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94bc394b-5a46-40e4-854a-5abcabb8a2ac', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94cbff8f-5daa-470c-a138-f1c23fa351e9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94d12972-e158-4151-88c0-1ac02c1993d2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'XXL ', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('94e41b04-1cd0-4c81-b356-88fabbe47567', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('94e9ac85-1894-4236-a26b-3b4bbe987012', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X30', NULL, '38X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('94ef92aa-5648-4fdf-839a-458d84af261b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10HSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('950b487b-caf8-4905-b15b-331d941b4f1c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M/L PETITE', NULL, 'M/G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9520b5dd-db60-4a1c-8acb-381e7676408d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9525fb1b-d7dd-4d6d-96f9-6142c12c3419', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '11.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('952ecbae-4c2c-452f-83ff-240501fc5a8c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26TALL', NULL, '2/26 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9537c956-72bb-4145-beed-412b6d63e8d4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('95395de2-5558-42be-9779-00c5c0b3afe2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14L', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('953af893-9813-4672-a2c2-061e1c3f5389', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('955c810d-37ef-4f19-a124-8612d610170f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bfa1-05a3-b0d0a7835e54', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('956434cf-1c7c-4bab-8f00-ffc808a91f58', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24 LONG', NULL, NULL, NULL, '170/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('95668e73-fb1b-485b-b003-c2c8b701bf23', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L SLIM', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('956bd26a-31ad-4efa-8ae9-ca2b6c28d3b6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('956c9c95-de7e-4aa0-8e4a-7da8e7748a0c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('956dcbfd-5ca8-4670-b3fd-fed7fe5ec092', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('957398f8-706c-4dc5-bc15-f4120177e270', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 TALL', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9575f104-2b2a-4574-939e-c4bf3de30181', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('95794fab-f830-490d-b927-14010eb479b0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '35 X 34', NULL, '35 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('957a1639-a3fa-4dfa-b7f2-5a92658bd369', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '32L', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('957cda2f-8ee4-4ec1-a073-5383fde2f066', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12HUSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9586643b-c554-4df0-86de-d6fb8f9d1fed', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12MONTHS', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9587e69d-0810-4396-8d94-e8e331ba56b2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X36', NULL, '40X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95921e2e-024b-4830-b3a7-66cc39c89969', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95a334e4-9b4b-448c-9677-a287cf1e7e07', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20TALL', NULL, '20 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95a4a6ca-0fdd-4013-b2b5-ce83fe8108f8', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('95afd3a6-277b-4ef0-b803-bcece7e5a9ee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14TALL', NULL, '14 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95b89e9c-4fa1-4433-9f72-48c6a76164a5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXSREGULAR', NULL, 'TTP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95bdfabb-51f9-496e-b2ed-721310752f37', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '28 SHORT', NULL, '28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('95c058db-5fb7-49b6-9474-5437af8a353f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('95c9c3b7-c717-4fae-8cb0-e9f5f4c0255a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18/34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95cf01ff-1541-4858-a75e-d1fd9264d8b7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('95ebb629-c027-4648-8a05-33d6c906216a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 REG', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('95f64645-321a-4c1e-ba19-f2478eb2a362', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4 TALL', NULL, '4 GRAND', NULL, '165/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('96127274-9a57-4029-b5bb-7f632270fc96', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('9613b078-5be5-4115-a767-1813918ad86a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1 XLONG', NULL, '1 GRAND', NULL, '165/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('96201c61-ac8c-4c8f-bfc0-02ea12dbeaae', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('962c8ff1-3b6e-4f6b-8319-f16b139c9611', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 T', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('962ceb7b-09b8-4287-ba41-b226c6a280c0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '25-28 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('963008be-55a6-433f-b8a9-59c27845a656', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('96335948-606c-4905-89da-6babeefb7045', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '26 x 28', NULL, '26 x 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9637397e-c6c4-4c1a-802f-53b162774789', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'L', NULL, 'L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('963752f4-f013-4ab2-97e7-61c23b0d0d30', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/ 32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('963988ff-684d-4d06-824d-7f5ebad99c8a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '26.5', NULL, '26 TAILLE FORTE', NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('964395e9-bcfc-45c3-81e6-16e76028b7da', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14 SLIM', NULL, '14 ÉTROIT', NULL, '150/61 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9643ef1a-dd23-4a66-b5ec-e8514a93c45e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('964cf37f-9dc0-4019-99bb-d5d1112990c5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('964ed189-5a1b-4df9-8cf6-d29245690242', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40DD', NULL, NULL, NULL, 'E95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('966ae821-dd66-4624-a60a-814c8e607dab', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XLPLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('966deb11-dc1a-4471-82f9-8b4019d60e8d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 / 28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('966ec4c1-a31b-4f84-8000-afc250661931', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-a57d-b650-4f26ecffc811', 'OldNavy', 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('96729d6f-528e-4a74-ace6-3764378b4d73', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '34 X 30', NULL, '34 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9683641f-f494-4f56-bdf0-e0d52c7277f8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96a0af30-a215-4a7a-b1da-c3e83c8b1b76', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X 28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96a6dc73-9540-43f4-877f-48982e487f29', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16R', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96baf13c-2326-45d3-bb6a-d40e698a4614', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'S-M (10-13)', NULL, 'TP-P (10-13)', NULL, '16-19 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('96bf9229-94a5-4f7c-9122-a5a378f878b1', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '12-24M-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('96bfa831-1184-4af9-82a5-5e4286094a72', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9 M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96d047a3-334d-449e-be60-a8734251c8cf', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96dbbb37-a251-4e82-ba9c-28833093f75f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-7628-c0e7-2953753a67e1', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96ea6eef-7011-44ef-80ce-9db78328577f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('96ee1164-b43e-4811-a823-10353756e556', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('96efdaa6-894c-4eca-bb6d-4f6322ab433a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/ 32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('96f2c6e7-1f68-4345-95f1-4e0464f3c5fc', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('96f612f5-2f95-48d1-9d32-fb5fa59a3c0e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X36', NULL, '35X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9701fe78-c32a-4a46-8ca8-bc7eb1aa6daf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS-S PETITE', NULL, 'TP-P PETITE', NULL, '155/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97030855-be1e-4a5c-88cd-b28cd678f62d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97049943-cdf9-4588-94e9-fd92ab8d0d6d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '5 SLIM', NULL, '5 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97088592-051e-4972-83bc-0a68f0bce393', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'M ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9712e55a-738c-492a-8255-6645bf54648a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL/XXL PETITE', NULL, 'TG/TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('971a6a7b-f6b9-4dad-ba37-4f5d2c34b6b7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('97330538-2516-45b9-af82-332fe97f721f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 X 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97556dc0-5c8d-40e9-8405-0e03264e29e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00L', NULL, '00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9758710c-1212-4323-9c51-698b265dec02', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10SHORT', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('975a68cc-bc0e-42ac-ad5f-a19d8dbd0bcd', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('976bf0c9-3e25-4649-9a90-6f33802a988d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c459-a695-1b0f4c446eb7', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9772fd82-98a2-4b6c-b8ee-cbc63c9fd3ee', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35/20 Regular', NULL, '35/20 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('97755f17-f654-4f3b-b299-954bf33e276b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9777fec2-9128-4323-a227-64857daee6be', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'M', NULL, 'M(32-34)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('978728d5-b5cf-44fd-a8ae-a26b95cb4102', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('978982bb-cca7-4267-8d47-7c06fb9331a3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-7628-c0e7-2953753a67e1', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97a27bdf-03a1-4469-b336-51666f0bfaff', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '35 TALL', NULL, '35 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('97a50bfa-c6bd-4d2b-8755-15486a3ddca0', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '48', NULL, NULL, NULL, '185/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97abfb68-0d09-4299-8bc2-e91d37a76f9a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L', NULL, 'G (10-12)', NULL, '140/61 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97b0be05-f4df-412b-9fbf-dcc5ac113186', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6', NULL, '6', NULL, '120/59 - 6 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97b54706-fa8d-486c-8321-4081de940755', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12MONTHS', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97bf1ec4-01e5-4b07-89a2-f246ad93e6e4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'L PLUS', NULL, 'G (10-12) TAILLE FORTE', NULL, '140/76 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('97c7a672-693e-4c20-83e1-9e747787125a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35 T', NULL, '20/35 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97caa0da-104d-4a28-b324-b8553ccda452', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 X24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97cae613-3e34-475a-a03a-aeda025af2aa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28 L', NULL, '6/28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97f48528-36c5-4a8f-a22d-782fa5e76dd8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('97fda0c0-1b4e-44fe-9c70-e553e0a11539', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L P', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9803cf6a-6a8c-492b-980a-8e7e54e8ac37', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18/ 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9812ec6f-6344-41bf-a7bb-3a1677258bb1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10 SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9814ea7b-b5db-4880-ac03-20d834bcc8c2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9815c69b-5714-40c7-ad58-dd54b0c51a7b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18+LONG', NULL, '18 TAILLE FORTE LONG', NULL, '165/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('981e7c98-9781-4ffb-af4d-b5aae528da22', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '20', NULL, '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('98292eba-fb00-4967-b5f1-d693d51f5459', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('98351c4a-2f61-4d7f-a364-5530895201e7', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98391a8f-6956-4578-b476-c4b181c07914', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('983f99de-1dd9-4724-ac48-a02faa32e6fb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4 TALL', NULL, '4/27 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('984285a0-8171-4f7f-a685-8bc5989b9f59', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS PLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('984462b7-3bdd-473c-94cd-11def4283c7a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6 REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9847e1f1-df70-4718-ab8f-1046095d857e', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('984b4883-655d-4654-9df3-fbd1c9b2809b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-e413-e823-ad5042a060ad', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9854a364-98c5-4c70-919d-5f069a95b272', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/ 32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('986fa3e0-a2cb-473d-a49f-920d6cb2057e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'S', NULL, 'P (6-7)', NULL, '120/64 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('987230c5-a83d-49f3-97b9-d46679bca7f9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('98731398-18f4-46bf-83fa-a4811b5c2ece', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32R', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('988943f3-2c7c-446d-8541-0cca28891971', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000/ 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9890701d-cae0-4862-acd1-09628f7de913', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('989257d2-d759-4d14-93f1-622f8eff8479', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9607-1abf-44de15979e47', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('989c86ce-1917-4079-89a2-7c3ff0a00648', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'L 16-16 1/2 34-35"', NULL, 'L /G 16-16 1/2 34-35"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('989df1d2-8872-4001-bddd-ee5fb2728fc2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 /32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('989e82af-ff20-4616-bf88-32c78e90080d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 /30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98a34191-9b59-4c6c-b282-4f9109718401', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '44 X 34', NULL, '44 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('98a4d359-e198-4fa8-8021-5ccdfac7d076', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18 T', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98a8e155-b28c-4599-aa49-f439acc0f299', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '35 X 32', NULL, '35 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('98b5c7c9-8071-452b-b50b-1867ab1559b2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98b67422-0511-4cdb-86b8-1ac0e3c2d887', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'S/P', NULL, 'P/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('98ca89f7-a83e-42a1-9ac9-a32e2f7681ef', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL/P', NULL, 'TG PETITE', NULL, '165/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('98cda791-5a3f-4c6a-9e26-404a15dc345f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '31 X 34', NULL, '31 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('98d1cf82-b028-403f-a623-4e8c76fce03b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28 REG', NULL, '28', NULL, '170/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('98d63f40-89d8-4b6a-9d1b-5701224abfc7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12 /31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98dd5447-e1ef-4fdb-ab8d-e14cdfdddfce', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XL Reg', NULL, 'TG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98e2f747-c75b-4cfa-839b-7d3e3100e79c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12 REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98e47b1f-fe7e-4d84-aed2-41dec62ac93a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 SHORT', NULL, '0 COURT', NULL, '155/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('98e5525e-eeb8-452c-8853-a6525dc1aa65', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 / 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98e6bcda-d56a-4944-827e-13b16de700d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 AA', NULL, '34AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98e8f2fa-49cf-4f08-afbe-7138b910150d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S/M TALL', NULL, 'P/M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('98ea7247-60ab-4a53-9c5a-a796d9a7e9ed', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10 SLIM', NULL, '10 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98f4f1cb-4300-42cf-9a98-84487de1a4bc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('98fc51ff-7661-415d-b49d-131744d72107', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '36 X 32', NULL, '36 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('99004e41-9802-4118-bf8e-854cf916f7c8', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('9908c6b3-3379-4e04-93ef-fb8e8f4f2a85', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 REG', NULL, '6', NULL, '160/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('990b4ab7-a8e9-4df0-a9f0-67605ee84189', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16PETIT', NULL, NULL, NULL, '165/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('991cc8fe-d998-4388-b1d0-882014db6b04', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 LONG', NULL, '14/32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('992039e9-5c3e-46ee-9666-5b9ebddf5a21', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'S T', NULL, 'P GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('99232c88-04ce-4784-aca9-73fb72d8729c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '27S', NULL, '27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('993fa8e2-2fb1-4e28-8708-ec2d1cce8442', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('995c0f87-9b99-4811-abba-95133f7721f6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '155/85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('997780bc-522b-42a1-85f7-f833a377bcd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34 P', NULL, '18/34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('99797cfe-79a9-4f27-acda-b16742c289fe', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('997ce7c5-0737-4e57-82f8-33fbf6a33b90', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '29S TALL', NULL, '29S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('997d7c1a-91f2-4096-9077-edc64455f451', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 /30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9990e1a2-eb8e-4ab2-9754-98f99a1e5253', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS HSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9993957b-d184-4f74-ad89-4116956bfbc0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18HSKY', NULL, '18 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('999d2cbe-1c89-47a7-9bb4-d433b3b756c4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '25 LONG', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('99a3cd2b-22eb-4161-80bd-6c65032a6c3b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL', NULL, 'TTG (14)', NULL, '150/67 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('99b63575-69f1-4842-9fac-8abc69ff80f4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '33 X 36', NULL, '33 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('99d21c6e-1720-4a7d-a945-4c942e842578', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-5e98-8d89-1c1c318078cd', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('99d5cd3d-4f06-443d-afec-1c096ef9777a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000R', NULL, '0000 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('99e746b7-d507-432c-9fa6-97cb165ce9a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XL P', NULL, 'G/TG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('99fee50c-f039-4d1e-8561-fa6b7a15bf6c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-65c2-1cb4-e8b699a38e29', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a085b48-fbb8-4f5b-85b3-939c3e9db18c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22+SHRT', NULL, '22 TAILLE FORTE COURT', NULL, '160/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9a0bf179-5a67-42b6-8987-a7feaaafc782', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9a1dded1-e7a8-4dc7-a27b-29dcf81fd560', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '18', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9a2139fb-a2c8-498c-9c8e-4481d4f67611', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 SHORT', NULL, '0/25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a244413-2075-478b-8c46-83186cc24863', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 REGULAR', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a29bbfa-a79a-4292-943e-29a8e0c08b46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18 / 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a367e52-7b9e-420a-b5d9-142960032195', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a37a610-1368-43e6-a819-bd5e1cc4ced9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a444247-91d5-4454-83a0-9bccbb57c717', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 / 29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a49a617-7296-4fe8-9b85-00dd6e31866e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, '130/56 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9a585ceb-beda-4cb1-83e7-e9161d3bc0a5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '27 TALL', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9a60a2d6-e8a4-4d2e-bad0-95b5b1249757', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '6 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9a7615ae-611b-41b4-b368-017e53e0c3c9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X 32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a8d62a8-1003-4633-bbad-3a53a3aa306f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-6a89-2501-9d7ae73292fb', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a959e6a-bf20-4d00-b25c-bb0012cbc0ae', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9a9d9275-01f3-41b5-8d31-e8d1257e17c9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '26 LONG', NULL, '26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9aa77d76-12fe-4e4b-a204-d51fcda1af02', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X 32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9aa9373c-353a-4685-b2e6-f3e96eaabfa2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 C', NULL, '34C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ab1b45a-54c7-40ed-a6f1-4ddf20c22c46', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34L TALL', NULL, '32L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9ab626ac-36db-4cb1-b638-8415d094eb57', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '12/1/2013 12:00:00 AM', NULL, NULL, NULL, '305/104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9acec42c-72d6-4cd2-a984-5aafa3b2832f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9acfee93-a635-4029-a8f3-3c49409ad622', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0X25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ad78d85-01cc-4535-a531-e42c5830ac42', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '9', NULL, NULL, NULL, '160/66', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9ae491a4-12e4-4ad0-b9a9-e21dd685618e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S +', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b08331c-0d54-4570-9300-dcd1779c979f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X34', NULL, '38X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b0aff93-a262-4167-bd4b-30986bf77be6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '0 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9b11bbe2-beac-4902-8f9c-61047934135b', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20SHORT', NULL, '20 COURT', NULL, '165/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b17941d-374e-4a61-b970-696020d13d60', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4L', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b1f7d58-c731-47ec-b5b9-8a33e74efd78', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '31 X 30', NULL, '31 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9b20ad3d-759f-46d5-84db-2bb5f86b13e3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XXL P', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9b2452d3-79fb-472a-9382-50e315e2e924', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '32 X 30', NULL, '32 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9b25dab2-6050-43ad-9cf4-5ce3e19bdf54', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b275d88-0c12-4f30-a3d3-3ddfb617e594', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('9b29c207-39cb-4db5-8bfd-a76367964662', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38X34', NULL, NULL, NULL, '180/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b2d7f3c-515d-44c2-aca6-387d4b6d4c95', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '29X30', NULL, NULL, NULL, '170/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b2f8f79-32d9-44d6-aacd-dd61148257e9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b335ff5-ca03-4d86-a14b-4bbbe36b79aa', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '12-18M', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9b3686ab-ac40-4c5b-8411-e4a4c559b5d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000T', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b3a9649-5697-411c-976b-963c7b32b37e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10P', NULL, NULL, NULL, '160/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b51f773-e295-4dd7-a27b-14e422cfbe3c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b551470-7cd4-4714-a1a2-2172a0196327', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9b5ff472-bf5f-4107-9a88-24662d093a90', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X32', NULL, '33X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b6a75a8-29f7-4e2f-9d18-96e51ff04ba4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9b761705-b961-46bc-a15d-c25e27e75a51', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b7ea02d-a3c6-4750-9bfd-4c618ab498d3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18SHORT', NULL, '18 COURT', NULL, '165/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b81d257-e1e3-446d-b58e-3f0aa1155515', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8T', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b8c9eef-2bab-43a6-a509-cda2ce008899', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9b976018-d7da-4fb0-ba67-2661176278c4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18 TALL', NULL, '18 GRAND', NULL, '175/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9b9a0d3e-d907-4cc3-b4cc-24e02b4f06d6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XLREGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ba5c2ec-2e5c-4910-b461-b4695fd43f8f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '29 X 30', NULL, '29 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9ba5c72d-0a7c-4d95-bff2-bb5e9c12e03a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '38 X 34', NULL, '38 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9bd54db6-ac33-48ee-8e2b-8413530c5894', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 / 28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9bdbe3c1-878a-4a1f-8c8e-83f2139f0953', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31REG', NULL, '12/31 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9be02495-64d6-403a-b495-890db1de5786', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9be4572c-f158-4c58-813b-3e823f9395ee', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9befe5f3-13ec-4007-9849-6727a269bfc1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9bf39dc4-55bb-446c-9f92-1e9df5c40981', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 REG', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9bf6682e-cc87-4aff-8e34-b397a46147cf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '36', NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9bfb6bc3-a37f-4596-a2d5-1d752f06632a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14SHORT', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c089680-936a-463f-aa36-02bff8ddf8ce', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9c093178-fecd-46bf-99b4-75e813275ba6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-5b44-e938-a3c489e62f62', 'OldNavy', 'L/XL', NULL, 'G-EG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9c178008-e35a-4237-b58f-04e2b445f285', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X 32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c1dbee3-f6fb-45af-97d6-ba50a3b82143', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34R', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c286ae4-6a1e-401f-8da4-1716f143ca66', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9c325e18-6d0a-475c-aa63-75324da05369', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18S', NULL, '18 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c43f06b-f22d-45c8-826f-d87bd315f815', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25P', NULL, '0/25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c45c4c3-72b7-4394-b9c5-2b9bc58ad393', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '0 PETITE', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9c46cfc9-5521-4aa0-ac26-649c84a3e4d3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '30 P', NULL, '30 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9c50be6a-5cc3-460e-ba0a-ddd3cbb7dfe8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27/4 Petite', NULL, '27/4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9c6bb291-21af-4a8a-870a-db1e75a1ba10', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c7723e3-1b32-4972-860c-b64dbe3a7b2c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16 SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9c812d26-f53f-48f1-8bde-602c03f1cd1b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9c8fddc1-3fd8-4fe9-960d-dbaaf776bf20', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42R TALL', NULL, '42S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9c9b03ba-c240-4105-a09c-479424c8cb2c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXL T', NULL, 'TTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ca73377-741a-4451-8853-839d50cadc33', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XLPLUS', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ca9e96a-1d35-43d0-b3e0-62896b7fe9bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9cb2b8cc-bde9-47da-ae88-3cec61ba2f46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34P', NULL, '18/34 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9cb4b144-e293-430e-84e4-f742f9d56a55', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XSXLONG', NULL, 'TP GRAND', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9cb4bfb4-bfb5-41ba-8605-773c236e1028', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9cba4810-f197-4779-a19c-5a6f584964d9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9cc0203f-c9d8-467b-837a-06718e4c4fd2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXS T', NULL, 'TTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9cdaa1c7-a4fe-40a8-a204-898a12746914', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6a19-38f8-1a37cf0c40ff', 'OldNavy', 'One Size', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9cdfe8d2-a01d-41a0-bc68-a8137f1ef74c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Gap', '38', NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9d062316-bf2a-4183-8559-724eac0ac53d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6', NULL, NULL, NULL, '160/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9d0a3368-fe04-4a57-b42e-33525631d61f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6T', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9d12631d-027e-4f39-84f3-9ab5d170e7dd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9d3875fe-1611-446a-88c4-cabd80270213', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '16S', NULL, '16 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9d38cdfa-56ff-4cb4-bed0-9a18cd8fac0d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12SHORT', NULL, '12 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9d3be275-5071-42ee-a4be-24a372b63f72', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9d571220-5cd7-4acc-9663-e900d5309ce7', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9d589870-61af-4830-9f7b-d5ec03ceef47', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XSXLONG', NULL, 'TP GRAND', NULL, '165/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9d6a0baa-c585-4900-8314-064147d165c4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '30 TALL', NULL, '30 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9d84bc19-402e-4cc1-a725-04f29cc9e8ce', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '4/3/2024 12:00:00 AM', NULL, NULL, NULL, '230/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9d874617-6b36-4247-a43c-57a15149a032', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-eb90-5c7f-1eae582e2df1', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9d9b4677-8dee-451a-8c90-7a37d1c4b9ff', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '14P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9da0cc5a-43d4-4b09-ac28-bf551ffba7a7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '30S TALL', NULL, '30S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9da3791d-b287-48c9-be69-fdc4dfe85dc9', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-45c1-f2af-4cad493341e4', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9da7c19c-e430-426f-9fae-7831e3dbee4f', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', 'UPTO7LB', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9dbe503b-c085-479b-b0cf-7174e9979f94', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9dc2493c-c39e-45f5-b98d-0db378cf178c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '18 x 35/36 = XXL', NULL, '18 x 35/36 = TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9dc89d85-844f-4591-8d01-e5afca1b3303', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9dc993fb-0113-4f47-a678-8bc67b536c3e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '2X', NULL, '2X TAILLE FORTE', NULL, '165/135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9ddb372c-b124-4f7d-8ee9-e4782a5113b6', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9dde648b-ca6d-41b5-863d-52e3265f8604', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26 X 32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9df8a3f2-796b-4579-94b2-3d51b30abb50', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e1eb4ce-0925-4f9d-9eda-1536e00923b9', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '8.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('9e1ed97f-a311-49d7-a4cd-c66a72905c1a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9e20d6e1-89b5-4ae7-a3f4-ed1c5387ee91', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28 X 30', NULL, '28 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9e410553-85f5-4df7-8589-e1aa49f63614', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e4347a1-97bf-4f82-9df6-5802277bb98b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '31 X 32', NULL, '31 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9e4482ae-2969-4fc9-93e7-ae7ed801dac4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '31 S', NULL, '31 S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9e44dc24-add3-4147-8e81-ea510daba1d2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0', NULL, NULL, NULL, '155/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9e45b460-a218-4cd8-a980-5824532bf028', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/60 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9e46e4fd-220d-43f5-bd29-d73fb4a192dd', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e943-0e10-fa44023e6216', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e4c29a9-ab87-4269-bdcf-90e3dd4f6a87', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e50c7b3-45a5-4941-9cb3-720900b87cf8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e54b140-c51d-424d-8623-da19abab84e0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'MREG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e68a2cb-fea1-4c96-aaa0-d83090a806c7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L/P', NULL, 'G PETITE', NULL, '160/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9e7687f5-0d7c-4b53-8f42-8b8b3e355b3f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9e76da96-a340-4a76-8a43-5321fa29db46', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 / 30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9e88c1f3-0ffe-44e9-a78d-9393e0e53c6a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9e906339-c7f0-4022-94ad-813243319b6d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXXL', NULL, 'TTTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9ea4ff2c-fc39-457f-9534-4950ce54c468', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9ec86789-d129-47f7-bcdd-7c544074572f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14HSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9edce9fe-b215-4eb2-8438-69cff5e45bc0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9ee74403-24a8-4d55-9b82-b34874ed5711', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9ef0f7c3-c78e-4796-8479-49d5013b35df', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10A', NULL, '10 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9ef80c36-59d6-4898-9547-dcf3166cc8a4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/ 32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f017797-3102-4900-99ca-045842ca8b59', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f10507b-19f2-464f-8971-d44ef74d7c2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 X 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f1c5c60-2a33-4eec-a991-bcdc1d0f2175', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f202cb3-fc4f-42b3-8919-9d9bf16825c6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6A', NULL, '6 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f28815b-fa05-4468-b8d1-e0af926e33a0', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9f3569fb-a52c-4d34-9929-ce4226760e4c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f37f962-410c-4dff-a6cb-0122caf3b51f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f3dbe07-76da-43df-8738-0ded0c13dbeb', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '6', NULL, NULL, NULL, '250/84', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9f52005b-58f7-4b86-a596-153f1dbe23c7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f55d5b4-f0e0-4a12-894b-a96be04fc216', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '12', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9f5d57be-ba2d-473a-b0ed-b7b4a8512a3c', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-0c34-91ed-b52ed97b4187', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '********', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9f5d614f-753c-49d8-9471-8175202c211c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '27/4', NULL, '27/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9f6f9353-ba94-4605-9409-a2ddfe82e6a8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f77a196-21a0-4273-9395-435b889ab7b3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12 M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f7ac47f-989e-4417-ab1b-20fd5e4f4c20', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4TALL', NULL, '4 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f94b308-3d2f-422c-bf4e-b22b0e547f52', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '3-6M', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9f94c149-9090-4501-8cd2-633e683de67a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 SHORT', NULL, '8 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9f99122b-e5f7-488c-a69e-37723d4ba1d9', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '5', NULL, NULL, NULL, '220/75', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9f9ca76d-e4b1-467f-b316-c6476d791600', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '28 PETITE', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9fa25690-f08c-45ee-a50e-08f8cab2fead', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 / 34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9fa3ba38-f69f-4db0-8a4a-ee96e33c207c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 X32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9fb095f2-d133-4f04-b3ef-9a44a19ad93d', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9fb27f7e-323c-4f84-bede-06443eb128d0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '10 Regular', NULL, '10 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9fb86d15-01df-48f3-a6cb-d7e0f5540457', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9fbad72c-617c-4772-8a3b-12e08d62400a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9fbed272-5b87-4186-9c60-7f9f965d9ddf', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7 REG', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('9fcb0446-a8bb-444c-bbb8-73f8bb556ea2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9fcced75-3530-4dae-b553-cfd85ac59b56', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-fcdb-35df-c4e65e2362a3', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9fdb2c55-8a8f-460a-ac45-1cf2668dfb02', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-a57d-b650-4f26ecffc811', 'OldNavy', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('9fdbef86-2347-4355-99a4-e825e1958e0c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-fcdb-35df-c4e65e2362a3', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('9feba813-c7e4-44ea-b0c0-c08a018856c4', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('9ffa0350-0aac-445a-9556-f46acc2ec864', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL SLIM', NULL, 'TG (14-16) ÉTROIT', NULL, '155/63 - 14岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a003e9ac-07d4-4166-b0d5-b6686a0b2a35', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 TALL', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a01e3acd-af97-4c24-8830-937757510a35', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '4 TALL', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a02e8c25-b939-4953-87c1-f2bc0f214607', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14HUSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0334115-7220-4ab1-8c47-d15826bc5253', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a033d804-0f50-4bb0-a2fe-2de0e27b5981', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0354b41-fc4c-402d-a36e-32ae888b5ee4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('a038fd83-5472-4713-97ad-9478d3475f19', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X30', NULL, '40X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0426f47-092c-468c-bbfd-c5a13b8a00da', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '19-22 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a04560bf-fb82-4f0c-9f12-a0d9026fff97', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'LREGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a04ae055-0622-4323-94df-9e7de610a6cf', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6+', NULL, '6 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a04e1a7a-71da-493d-b231-58f128b44feb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a052594d-a962-4387-8790-cd0317400f88', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X36', NULL, '36X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a056bc48-78b2-44bf-af6b-6f26e47011e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 REGULAR', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a065f2a4-9dde-4109-9ec8-e56ddd81f3e4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S P', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a0696cd0-d076-4c2f-9a2a-56a66bf28daf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXL T', NULL, 'TTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a070d5b0-6fd7-4020-93c6-8c09f877df5f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL SLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a07c82b5-ff65-4604-841c-99b95f64ded6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10 +', NULL, '10 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a086d297-61ef-4f26-a8e0-affa2c6591a2', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40X34', NULL, NULL, NULL, '180/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a091db20-d988-4dbb-835a-23bb1107366a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '33 Regular', NULL, '33 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a091f49b-81b2-435e-9c3e-724db3351d91', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X 36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a09e7788-f67f-413f-a36d-16cf58c3f518', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 TALL', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0a43a8a-3fb1-4acb-9b97-ee023b31db21', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M28/W6', NULL, 'H28/F6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0b20f6d-2324-430e-bb6d-bc2ca52492b5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7REGULAR', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0d3aa1e-b68d-4319-94f5-80305f397542', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0d839c5-1b6d-44b8-af22-5ce7e4516131', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1P', NULL, NULL, NULL, '155/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a0f48c39-6ced-415c-b743-c6e360525f4d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a0f6fed0-2e31-4087-8f77-46cfe9fd5952', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14XSHRT', NULL, NULL, NULL, '160/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a101c0ec-ae71-497d-8278-5c59dac21fc4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'SHUSKY', NULL, 'P COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a1041943-fca2-4864-819d-417c70b6f0d4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5REG', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a10abf46-a856-4528-9313-0de44b8671c7', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '180/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a1253b37-d646-4516-be0c-e0ca59bfd8aa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a12c9179-d22d-440a-a074-471fb68afbfc', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXLXLG', NULL, 'TTTG GRAND', NULL, '190/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a12d930e-7eab-4743-be27-6da23d79754c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'S/M  ', NULL, 'P/M ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a14410ed-2226-402d-b619-30aedd51f9d9', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '20+', NULL, '20 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a148e1ed-3a19-44d3-b643-dc8779405b8d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a14a8400-d830-4972-b35b-47286a92620c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-c903-74cb-ec08fed5be7c', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '53 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a14f2c2d-597b-48f9-b09a-aa1bd2f778e6', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XXS TALL', NULL, 'XXS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a162c1ec-11a9-49f2-b9d4-458c78151dee', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL REGULAR', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a163ab56-efb8-45b1-a088-86ba885f39ac', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18+SHRT', NULL, '18 TAILLE FORTE COURT', NULL, '155/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a1703f87-ac09-45b1-a2b6-13d0727c7fe6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '00 Ankle', NULL, '00 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a1744466-6489-4874-855a-37791ed02b99', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '40 Long', NULL, '40 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a17577b0-9897-4667-abc1-bf5571169238', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS P', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a18656a2-af06-4521-b2bc-e53de2fc386d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46 REGULAR', NULL, '46 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a18b5ad4-c08a-40d1-aa02-761438f20149', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '32 TALL', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a1922477-25a4-407a-a9a3-af47e159a13a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a196b59f-d2be-48c9-98cb-dac700a6a771', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '8 LONG', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a19fcef7-da2a-452c-a5f5-5cc9ffe0a8a6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a1a34a0f-7358-442b-aa89-388f687e0c81', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 T', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a1b54f42-759a-49f8-9186-b5f2da1c5738', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32C', NULL, NULL, NULL, 'B70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a1fa4dd6-425e-423e-989f-f38f02ef951c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M PLUS', NULL, 'M (8) TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a22251fb-2582-4544-8f38-8beb1897c423', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'OldNavy', 'M', NULL, NULL, NULL, '250/92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a22c672f-6b5a-488c-857b-2161c88ea8a6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a22dee04-4569-43c2-b785-3c9af8775f7f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M +', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a22e9e69-1da9-481f-b675-e55b9f5438ca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16XSHRT', NULL, NULL, NULL, '165/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a23616f8-4cea-4a30-ab00-8c44f6160b4b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XSXSHRT', NULL, 'TP PETITE', NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a241d12e-7015-4ddb-9105-5f1e752b4c04', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '00', NULL, '00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a246840d-47a1-4a0c-a798-04a0fbe33324', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a265dbde-3555-4fb7-8f53-7a26a28b0192', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26X 32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a26d0599-19ef-4b57-b700-008abbdc56e9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a272133a-fd72-4098-8b8b-86523fb30730', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS/T', NULL, 'TTTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a273e4ef-d35b-48a7-9126-fe57507eceae', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a2776fff-ccd5-4f9d-8b9d-d36b2102c13a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS SLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a2861c56-e6b1-4d47-afb0-eda34d375bd3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29 P', NULL, '8/29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a28702ad-d6ab-4dd0-909c-14a440bfab92', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a2916a89-d42e-4f08-a70f-3d058e224c73', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a292caa1-bd0a-4a7c-aba6-858189d8b90d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-45c1-f2af-4cad493341e4', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a2dd96be-65d4-4b6f-9d98-8b5e3d81838b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a2eb8b89-d23f-4184-9761-009c3cc85bb3', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '185/104A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a2f00dd2-8b92-450f-9ec4-5b2c0d3c893a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a30c42c7-7c4e-4294-a5d7-86ad7d7e2b21', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a30e0803-38cf-4b56-a799-de5bf5ed8c0d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20A', NULL, '20 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a30f47ea-1905-47e2-a75b-587c877703dc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a3214873-9ec2-43e0-8c60-6111e2bb6387', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a326ae57-d637-4007-82f3-daff890e3eed', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 PETITE', NULL, '0000/22 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a3346e33-857c-4b1f-8e84-f6c1a965ff79', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7HUSKY', NULL, '7 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a34d7627-3f8a-4442-ba00-5128ef3c4477', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34J REG', NULL, '18/34 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a34f0c2b-a8b6-4bc2-87d4-9c7e983351aa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000A', NULL, '0000 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a359293b-b5bb-4ab0-9f58-5d8382dc566d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a36251a6-9a25-415c-9419-c4406a65fb0f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-457d-6d07-4b1a19f3d72b', 'OldNavy', 'L/XL', NULL, 'TG-4X', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a36dfb45-1c92-4f45-a7bd-5f19a3032a1d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38X30', NULL, NULL, NULL, '170/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a379d96a-df3a-46bf-99f2-27eb2d112b44', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', 'XXL TALL', NULL, '18.5 x 36/37 = TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a37f6cda-d0be-49cc-ac99-a29cc4209170', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a38ac56b-72e3-46ba-ae00-94ba283b4c00', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46S TALL', NULL, '46C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a38c6194-45ae-4ba5-b0e0-8b1d4ae21494', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '0-3M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a39b7f0d-c252-4d6b-96fe-53ea4a752449', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '10 Ankle', NULL, '10 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a3c03105-d45a-43f0-8dad-096f032b19e1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26SHORT', NULL, '26 COURT', NULL, '160/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a3df2943-e800-4384-880c-8d331fa418c2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 /34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a3f56069-5454-44fe-90c0-07ebef187774', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '23/000 Long', NULL, '23/000 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a3fd5491-9c6b-4995-9c0c-6a8a0779ac2e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a404d1b0-63f5-448e-9fe3-930796f52e62', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27/4 Long', NULL, '27/4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a4218a91-6ceb-4c87-ba49-197c5024f8c4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4 SHORT', NULL, '4/27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a421b2a5-0fa2-41d0-921a-8c88a5fc39c8', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL REG', NULL, 'TTG (18)', NULL, '165/72 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a424831f-5d41-427f-a486-dae74b348bea', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-c181-a8bd-98f9701619cf', 'Gap', 'XXS/XS', NULL, 'TTP/TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a42563c3-2d54-4718-bf5b-994664b9ff3e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('a43b66ac-6155-4f47-a7a7-6791636fc7c3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a448f3ff-3416-4b69-82e6-9c19358c5944', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a449ce06-23f9-479e-a3eb-a31e9560ca56', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a44bf299-7b60-4b53-843d-41c64aea575d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27 P', NULL, '4/27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a44e19a5-38ab-4738-b980-8d04239d338c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '36 X 34', NULL, '36 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a45b1bf7-340d-435c-b7c4-480e2ff7ebf5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '30P', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a460c5d4-72e9-4b55-bd1a-4d483740f5c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/ 36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a46d15fd-32cc-4c0d-a155-012e70b0c06c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20+ REG', NULL, '20 TAILLE FORTE', NULL, '165/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a47cf1dc-c80e-44d6-bc0c-72e112a4b125', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00A', NULL, '00 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a47f7bca-990d-4f86-9c47-704c9503f60c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4818468-56a6-4442-a43e-bceffbd9b5e5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '12/13', NULL, '12/13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a498ccfe-147b-42e7-b2ef-e426c06e63ed', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8 HUSKY', NULL, '8 TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a49cf725-59e8-43ca-ba75-9d05b38196d0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16/ 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4aa8a50-9c8c-4388-981c-1b81dfa2328e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 A', NULL, '4 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4ad9cb0-2256-43c2-8461-8e3315402d2f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16XLONG', NULL, '16 GRAND', NULL, '175/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a4adb2ab-eb7d-4623-9388-f35c17e2d904', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '28 LONG', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a4bcb6cc-7064-40ff-9524-b1d32fccfca9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XLT', NULL, 'G/TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4ce3640-cfdc-4310-bf29-bc359df1909b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4d373c9-cec5-4a1a-9b0c-dec5847ecdb9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('a4d54991-d668-45aa-afed-933b21591576', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4ebf6df-4acd-4450-9796-5eb9d93ba941', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 X 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4eda05e-e0f2-4556-b7a9-72a7afb717e3', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a4efadb4-794e-4ee4-b397-fa0dcfa905b4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 X32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4f2cc03-61a4-4f60-8604-bb9c84a343f8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 P', NULL, '0000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a4f830d3-bad2-4f5b-b77e-cf22bb9f98ed', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a4fe2e52-fffa-470d-bb96-0066abb9d1e9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0XSHORT', NULL, NULL, NULL, '150/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a506b8b5-b2a4-402d-8bd5-b8a92ccf46d8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'LREG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5104ef0-b464-4dcc-92fe-41c74499d6fe', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a54134ef-9e1e-485b-9d67-9de0acc40e68', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 /28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5428f10-a699-41d6-9e38-2d916fdc8817', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a54f5696-681d-49cb-b91c-162abbedf56a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a558e558-aa98-4939-a775-64e7b50b423b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '14+', NULL, '14 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a55c3ce6-114e-4701-a774-ac91b7cf5ade', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 SHORT', NULL, '0000/22 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5698fa8-f0f8-491b-844b-5bb6b888878c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2 T', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a570ccbc-2c4c-4429-adfc-fd1dcc6759da', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a570e027-3c8f-434c-b439-721e3193e56c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31 L', NULL, '12/31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a57d0768-e53a-4f38-b807-65b639aa1b86', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('a58a3cb9-6aa8-48e8-908c-d56ce8dd7977', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a58bd2d8-8fc7-47c6-b3bc-5e18118514c7', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XXL', NULL, 'TTG (14)', NULL, '150/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a58c2aa9-3205-4d8a-a441-443d0d9e8a48', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42 SHORT', NULL, '42 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a593f50e-98ab-4be2-af34-b6281178f602', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '6', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a59c615a-835e-4ff6-8aac-1964bbb19b37', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '4T-5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a5a052d8-adde-444e-9b0f-811d896bf757', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/R', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5b2c0e9-1ca4-4788-976c-3c3b8cdc741f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a5be6701-5c5f-479b-97ef-d5b13fc3b676', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a5bef9b8-a272-43eb-833d-7201ae0f4b0d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XL', NULL, 'TG (12)', NULL, '145/72 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a5bf883c-2259-4f23-9aa2-b81c91de6bdf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a5c1c1d0-610d-4484-b319-0a962c145875', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS+', NULL, 'TP (5) TAILLE FORTE', NULL, '110/65 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a5c525c0-e2ad-436d-af34-f69b3a032f32', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20 X 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5c85a56-6e3b-4a7f-92e4-f8d0ca12144e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5d3b1f9-7635-447d-8e4f-9e8d50c5050f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5dc59d2-2fd2-408f-bfe4-c0f2e3c0f978', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6 X28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5e1b5d3-9a12-4c49-b931-5357bd36e4a5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '17 x 36/37', NULL, '17 x 36/37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a5e83c03-3396-422e-be68-4e3aeb8a1321', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '28-30', NULL, '28-30 TAILLE FORTE', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a5f96452-b088-4ac6-9238-23fe4d37afd2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL +', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a5fb29c0-c16d-4795-8876-631bfb87996c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '2X', NULL, '2X TAILLE FORTE', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a602a49f-1812-49c1-86fd-4052bfc31129', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a60cad4d-5590-4a0e-8e08-a208fea4c159', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a614f970-d6dc-4bb4-a848-0277ee8ca759', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8X 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a616649c-f592-496e-af13-f8c65e15590f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a62b9c9c-7542-4840-9e8a-7714ea53f559', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'MREG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6336ec6-5fbe-4a90-9a08-e4fe592232dc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 / 32', NULL, '34/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a63ab2af-3780-48b3-9a80-53a24bfabe6f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '26S TALL', NULL, '26S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a655610a-123b-4a94-8902-f73999cb49fa', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12 PLUS', NULL, '12 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a657daf4-3851-4859-95d3-52e656250f54', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublicFactoryStore', '3-6 months', NULL, '2 (3-6M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a65c30b3-17bd-45c4-8bbb-48f08f96b385', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20XLONG', NULL, '20 GRAND', NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a65d9023-1506-4b5a-a39c-b7194e48bcce', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14HUSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a65e91f7-1310-4e59-9a4a-2d23d695ec21', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a660b9f8-ef2c-4e51-a913-634b4f4feae2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'LXSHORT', NULL, 'G PETITE', NULL, '160/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a6634a1f-f09d-4d9a-b064-9562f88ba733', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a66a6f9a-a9af-49d1-9b3d-d4d74c03c18a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16R', NULL, '16/33 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a67c946b-81b7-4aeb-a28b-e3f2be65de83', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6840e9f-a027-4b38-8009-95b0a6947b09', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34C', NULL, '34C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6856270-c810-42f7-ae28-b1464743543f', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-a657-ef1b-7244c71678eb', 'BananaRepublic', 'ONE SIZE', NULL, 'Taille Unique  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a69340b4-9b8b-41e2-9596-f496da25889f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e71-f43c-5fa7e185650d', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6a277b8-e885-4fbd-aaff-32db01fe1292', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26+', NULL, '26 TAILLE FORTE', NULL, '165/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a6a8aa24-6732-4308-a404-e007ba8371f0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10PLUS', NULL, '10 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6ab37e8-63bb-4edd-8bf4-4a1c5f71c86b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '40 X 36', NULL, '40 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a6c4b863-69ee-48b4-b774-57b74b963877', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'L T', NULL, 'G GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6c57d30-2c70-4bcd-adbc-ca055c3a4f22', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1016-d539-c4328a2f8e84', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6d706df-21a7-4ca1-9d12-24d1acdc23a0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '10 TALL', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a6d8bb1e-a3a6-43b7-b05b-4ab58538a0a2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '31 PETITE', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a6ec044d-d39a-4a6a-a91d-e7c1ab85ac43', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a6f007f9-15a0-4dd4-a705-cb065f22e2b7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXSP', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a6f13bf4-92c8-4151-b0c0-df06a794a776', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '10.5', NULL, '10.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a7078ff7-ac07-41f8-8c51-bd6e447ba4fd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'M', NULL, 'M fits-shoe-sizes-13-2_M-convient-aux-pointures-13-2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a708441d-241f-434c-8894-26f66cf132b3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M/L P', NULL, 'M/G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a708fb96-ec70-4243-87fe-9892ed42d081', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL/P', NULL, 'TG PETITE', NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a70ea7f8-192d-4c6d-a82a-09caa1d43d61', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a711abe8-1bf6-48e6-9370-521a7b31b82c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a711dcce-613a-4fa4-acd8-d33bfb84fb99', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 S', NULL, '0000 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7210e8a-64b5-4e4d-aeca-7fed80a83b89', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '3YRS', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a72730c9-4aac-4ecc-bc9d-1b0e13bf7c07', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'S', NULL, 'P', NULL, '160/96C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a737104b-0704-40fd-8243-323e9716dd10', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a73dc072-fb84-469e-98ee-a6c3d457644b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXLXSRT', NULL, 'TTG PETITE', NULL, '165/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a73e169b-257c-40c4-8b14-482352276779', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a757fff4-56ec-4bf6-b0fc-193780d99a40', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a759f76d-c239-45fc-9bcd-4b67acc001f0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X30', NULL, '30X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a75e7038-5109-4acd-9374-23483374baa7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34 S', NULL, '18/34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a76202d7-0baf-4584-b76b-098246ff9695', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a77b3fe7-987a-4df2-92ad-5cae7f67598b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '24 P', NULL, '24 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a785df67-b753-4f3f-81ea-d92fdfe65096', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16HUSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a785e959-d414-463b-8363-4eadc0007314', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a786f03d-8549-4569-a467-cee5bb5c5313', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XSPLUS', NULL, 'TP (5) TAILLE FORTE', NULL, '100/62 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a79cc19a-128d-4d25-8ec2-42ab0b841117', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a79ddf10-bf85-4a7d-b845-df482d1a8c5f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00 P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7a4c7a4-b0f0-4ee6-8abc-c7ed073657af', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '34 TALL', NULL, '34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a7a837cf-afbf-4e28-848c-b36962fff855', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7c02c40-7275-454f-a040-a3e0d8cb4891', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XL REG', NULL, 'TG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7eeead6-e37c-4fd5-9a71-d0d3891ab3a8', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7fd2efc-fe50-4882-9c25-df0ab7822ed9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '9', NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a7fe38da-4a29-4334-b9a7-717d152348ec', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '48 Regular', NULL, '48 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a810a7e9-28b2-4843-94c1-3b91655387a6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38DD', NULL, NULL, NULL, 'F85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a823d512-00de-42a1-888f-83c7673bd704', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M REG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a82dec0f-0905-4175-998b-60ec1445aeb6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4 REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a83406b1-9c69-42f3-9f22-246b1d32df3b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-fbb7-e51c-c71e8847e2c7', 'Gap', 'M', NULL, 'M (8-9)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8457209-2f2b-4eaf-9be7-f1f2a24c492b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '27/4 Regular', NULL, '27/4 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a849ea10-f976-4944-8e46-fd2e635205e1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 / 36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a84c932a-0557-40d3-a65e-6ac16ce81663', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a86e08be-ac96-4427-8ce3-686bdef79d8a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8718bc4-a435-4874-9d41-a0356042bbdc', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXXL', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a872da8e-aef5-4028-a185-552ec12116bf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34D', NULL, NULL, NULL, 'C75', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a874fd62-785d-4e76-a751-0904d639028d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a878c503-a352-4b00-9ef0-50aa12ffaecd', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0df0-ca33-6fa4848dbade', 'BananaRepublic', 'X/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a89a2f78-e952-4045-8770-d8f86cb3ede8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8b39cf1-76a7-4c0d-99c0-59825db452c6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a8b80715-9e5c-4647-95e0-3b7f467ee775', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', 'Size on CD 1 - M93 Size Model', NULL, 'CA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a8c0f2d0-b267-461f-8789-6ec00aec1196', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a8c4ee3c-0ef4-4679-97a2-9c22fb8169ab', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a8ceb4d4-4c3a-4c11-af94-254d1620cc32', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XXS PETITE', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a8d36b7d-da53-4e65-b40b-edfdb4487e98', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a8d4daa9-9a4e-4b03-8c1e-7c757fc86e4c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a8dc43e1-5575-4229-9b7d-b4c3114f8be1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18X34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8dd3019-e4ca-4ccc-b25a-f497e695d4e0', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '12/1/2013 12:00:00 AM', NULL, NULL, NULL, '190/72', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a8df19a3-b289-484a-aab9-9f988d9b691a', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '2', NULL, NULL, NULL, '210/76', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a8e88331-67c1-477a-b66d-509f177a0ed1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e71-f43c-5fa7e185650d', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8ede2aa-f27c-4ee0-83a4-482f6fc884e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20X35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a8f15b3c-6d38-48e6-895e-4a8a69b456a8', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '28 X 30', NULL, '28 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a8fe51f6-3397-4cc9-987e-034f483514d3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 R', NULL, '000 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9063f86-e035-42b8-8b9b-088fea15ac5c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X 36', NULL, '29/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a90aa867-c4f8-42a8-b73c-d6e005a0d1ec', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a90dd0c0-3dab-4c12-ad9f-005b68483fcb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXSR', NULL, 'TTP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a90f20ed-1065-4e75-a10e-8091f4817499', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9254640-b46a-4a84-8192-e75113769e45', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32C', NULL, '32C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a92c46d9-e3d4-4955-8a66-6f40fc46834c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a92edb17-43bf-4714-b4ae-9aab6a730c42', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'SXSHORT', NULL, 'P PETITE', NULL, '155/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a92f6325-78c7-4b30-8a10-63ffa6cc62b9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27SHORT', NULL, '4/27 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9385adf-01af-4b4b-9091-721288d44208', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a93ec9de-c167-4835-aa41-086b6d61b739', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a941477a-e8e0-4c43-ab5c-ec4f8104f543', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18', NULL, '18', NULL, '165/75 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a94c42e2-2a33-4bc5-8aee-6d513be64dd6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '10S', NULL, '10 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9513d0f-efd1-41ae-8b29-2f0c7d68ac5e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X 30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9578119-3756-40dc-939b-f43806c28ffd', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '2 TALL', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9587f79-c16e-4b96-8940-63da7df67410', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '28 R', NULL, '28 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a9617f06-5fc5-4648-99fd-0db4e9822868', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XXLHSKY', NULL, 'TTG (18) TAILLE FORTE', NULL, '165/84 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a967c8a1-239d-4ea2-a897-792b3433779e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXSXLNG', NULL, 'TTP GRAND', NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('a96b8c7a-e328-4862-9bcc-acbb2b9aa0bd', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-3ef6-84d6-7cfea460ba11', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a96cc7b7-442b-4067-8411-69432531e6a9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38 D', NULL, '38D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9810865-31cb-4d37-b887-61c3df7a1f94', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a981301c-f092-408d-96f0-2c9f6f4c0b2b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9895f23-5cd7-458e-9cfa-47e8381b20f0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '26 SHORT', NULL, '26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a98f9a7b-0d87-4271-8b03-ada62f149121', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'ONE SIZE PETITE', NULL, 'TAILLE UNIQUE PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a994cacd-5855-4c24-b65c-e3bc06ca8224', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-f66b-0046-267e93b606fd', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9ab5dfa-8798-4bc2-ab79-1998b47a5c3e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9af1744-3ca3-48fc-a74d-2851ca146790', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9afcd6c-d24d-414e-a883-4f11716f5fe2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('a9bbbe83-2ed2-4583-91f6-c5db439813c7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XLSLIM', NULL, 'TG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9cc2757-daed-4699-8b3a-508ba6011da3', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-8f0c-763c-934c914a4f20', 'BananaRepublicFactoryStore', '8 TALL', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('a9d5ab62-cea1-4742-baf7-00b0f6ebf764', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9e4ffb9-cc0c-4269-9a8b-067fb06c4544', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 SHORT', NULL, '0000/22 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9f4cf7f-ce67-4c57-a920-ccf7bd8baf01', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28 S', NULL, '6/28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('a9ffdd23-cea2-4fff-bafd-cfd76a3fca18', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-fc2a-f50a-b69401759c32', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa0dec6b-fbcd-4ca3-ad6b-94920441f04b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L (10)', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa158477-1e3d-4b63-b830-5580bb8e4cd0', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aa1a827f-f367-4799-9fd0-6be3a5033f65', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aa1c0de9-9cca-4fea-97dc-bd833d7a6c3e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S+', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa20ffc4-4bbb-4bea-b6f1-c127171673fd', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'SReg', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa255b16-b9e8-44d4-a0df-b7c40e748132', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '2T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aa4675a4-579a-40f3-b669-86d5661c7e2a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36B', NULL, NULL, NULL, 'B80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aa49593b-96a6-4701-944e-2a1c187ebd64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 X31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa4b8714-24f1-429d-8472-dee09a96eef8', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aa4ee08e-3068-46ed-8226-d49133139ba1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '5YEARS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa56c92e-c0d3-414a-b8a1-6087653ec248', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aa5884e8-46e2-48e0-b052-630d6f1fb4a5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '27 TALL', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aa63c8ae-2d9f-43a4-901a-d9257e049d92', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', '0-3 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aa6efede-30df-4872-8cb1-d67b96e51b89', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXL P', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aa760a39-def1-4bf8-9de0-9c4bf13d1ad6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '27P', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aa78babc-81cc-4240-85a8-7ef4a446f66d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '26/2 Regular', NULL, '26/2 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aa7d5d16-3658-40f1-93cc-78d78cd91edc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aa8dca6f-c222-46c2-8461-f37476f61d00', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aa936087-6e0e-4bc4-95e3-9525841877af', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7 HSKY', NULL, '7 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aaac98ce-f86a-4cfc-a6c5-36e773af8b7e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '14 LONG', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aaae5d51-7bcb-4a62-9902-02b4e799867c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aaaf2939-539b-461c-ab9e-fd4a00fd6640', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aab238b3-1ab9-4047-b0e6-49ad865bc647', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aab5a8bb-862b-4343-b7ee-d4ad3f1e6c07', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1PETIT', NULL, NULL, NULL, '155/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aac3bdd9-4fc2-40ae-a3da-62d7dacfa4bd', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XS+', NULL, 'TP (5) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aace3784-28ed-4afc-9f38-5ba13f87a15a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32D', NULL, '32D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aae32ca8-1790-4287-bac0-c22cfa2d50ac', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '4 YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aaeae7c9-a2d3-48ec-bf5e-0ad9f61d52de', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30P', NULL, '10/30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aaf10248-2c90-4fc9-af83-522b01fbd9cd', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ab00762c-4feb-4c93-81d6-b860ad120290', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '6 Regular', NULL, '6 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab011773-e27a-4e8e-83df-a16063f20ef4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '14 Petite', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab0c7571-5123-4456-938f-3dde6b932eb1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '27/4 Petite', NULL, '27/4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab0d9653-98bc-402b-a25c-e89aa3f58bac', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab15ab7d-bd84-4694-a269-d15e14c89557', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 REGULAR', NULL, '2 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab1b2b89-3e5e-473f-9706-1d6b6cad61ea', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '5REGULAR', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab1c39b1-4029-4244-9b31-d79c0f9b2ba0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M REGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab241e60-7d1f-4680-a1fd-e998ba549984', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'XS', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab30a14c-dcc7-40a0-b0c0-afce1b29729e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ab3a3c7b-71a9-49de-aa07-990fa1939b13', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12 LONG', NULL, NULL, NULL, '170/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ab3f73a9-4328-4489-b995-15b9a5abaf94', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X32', NULL, '28X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab5b59b5-2b26-4313-8f33-4b6836d8663a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab5e6554-42bd-4093-a271-3d9c0d232445', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ab6550fd-b7df-484d-8fdf-8ba6b5be09c2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '38 X 30', NULL, '38 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ab74891e-a526-4125-ae69-a8ba68849551', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '14', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab757294-48fc-49b3-9a64-278a0bafdb5d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab75bd28-9723-4a71-b08b-927e279f188a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20S', NULL, '20 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab7cef6d-a956-405d-98de-e3d37603fdbf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab81926e-0d75-4af9-949f-fd18f17129e3', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '180/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ab8257fe-0b6f-4bd9-9fd3-1b25dbe5d5b3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '175/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ab834783-e4b9-4d15-9b93-6756221af95d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab8ad15e-0938-4d54-8086-364d9ea94042', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ab9329dc-43a1-4e15-89e0-41f1c789c8fc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20REGULAR', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ab96c502-a51a-48d9-a03c-fe368e9126e8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '31 P', NULL, '31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aba6a357-1442-4e12-826e-0fa77bdd7ff2', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M SLIM', NULL, 'M (8) ÉTROIT', NULL, '130/53 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aba7c356-4b76-4caf-bf38-5364f5c3bc03', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L/P', NULL, 'G/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aba92a8c-899f-4599-bdc2-8bfa1814e847', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M/T', NULL, 'M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('abafeec4-169c-403f-afe0-9eb962bb5fe4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14S', NULL, '14 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('abb95e79-ad48-4b9e-9c7a-69a9507a8160', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('abbe0a0b-e93e-4b17-b1ea-ee466325a596', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '33 TALL', NULL, '33 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('abc5090e-40fe-454e-be16-ddb8f1892b06', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32SHORT', NULL, '14/32 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('abd18b39-5f94-4feb-bf6d-df511eea5d5b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-7909-c3fb-d8b2e57c63ce', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('abdc63aa-b0b6-4027-abdf-e76794a2ed54', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '2 TALL', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('abe1118e-018f-4b18-ab04-3ac4138ad9bd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'LXSHORT', NULL, 'G PETITE', NULL, '160/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('abf49081-4b73-490d-88c4-07d724f7e1ef', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '8+', NULL, '8 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('abfff861-1887-4161-a670-b169f5e43b94', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac06a84d-c45b-4592-b6f2-aa24e0886a91', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('ac2162fd-b101-48aa-8314-8a907ad1800b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac2af6f5-e7ca-406a-bcbb-144067281a54', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'XL (12)', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac2e9b1e-374d-4182-8bea-8e5a9763dcf4', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34X32', NULL, NULL, NULL, '175/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ac2ef49c-af0a-458f-b9a7-9b40fdd6d2c7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '30 TALL', NULL, '30 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ac31d5d2-e302-4755-b17a-057a1db1c916', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ac428a32-fe72-46c3-a586-42978dfbf916', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3 YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac53fae2-d04d-4afa-a142-5f1676a329ea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 TALL', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac54abe4-5188-4a32-81fb-2c88747bfeea', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X 30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac5ce630-d455-4d0a-a4cc-a411e7a43ea4', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7 PLUS', NULL, '7 TAILLE FORTE', NULL, '130/65 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ac5e5af3-1e1d-4eb3-8f4c-f4edf95f1c26', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ac613633-e4aa-433a-8f08-f663b4a8ea2e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25 L', NULL, '0/25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac664032-8377-4e51-ae65-0e9aab0f69ed', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L SLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac67d2a4-2b2d-4258-98b0-8273fe4c5373', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0 T', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac67de57-3ceb-47b2-9e69-c26a8d3408c0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0XSHORT', NULL, NULL, NULL, '155/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ac71f9d2-6506-443d-935c-70e38616bbfe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 P', NULL, '12/31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ac8fcb25-f48c-4eeb-90ef-fd4a66ac4e05', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aca3ecc6-2883-4b27-9da5-0b673d876864', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '16S TALL', NULL, '16C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aca70d83-6034-4f24-b9e4-7fb5cf126506', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aca83296-dba6-4daf-9f6c-ece9453ab1a1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXLSLIM', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('acc8d42b-d345-45b7-b2df-ddc971625f26', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('accd3cc0-097b-41a8-a4cf-d23b0077c69f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12 M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('acd2d20f-de3b-4b3e-b560-608272ab6eeb', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('acdf50b3-55fc-4103-a60b-688ab3af1f36', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6HSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ace43e2c-98ca-48d1-a924-e835f1d9f162', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8 REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad0ba3f6-9d71-4406-9554-d16970a82165', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S +', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad10e6eb-327e-4ca9-aa64-053e30c508ce', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad10ede7-9154-454e-b0b0-296c8446d2b4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL (14-16)', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad203df9-0943-4499-9f39-81572a6cbe2d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4 PETITE', NULL, '4/27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad281eeb-5fd9-429a-ada1-81f2a00fd3ea', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('ad2a92a3-60ee-4f15-b19b-5d57ec66e101', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7PLUS', NULL, '7 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad3ce6c4-144c-4122-a26e-e244f7d960f2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14PETIT', NULL, NULL, NULL, '160/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ad663b3a-ddb8-4f6d-acdd-7155c4ee94d5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6 HUSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad732f9b-6452-40b7-a221-da747d98c8e2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '12-18 MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad8234df-659c-4ac4-a681-0f83642066d4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XS REG', NULL, 'TP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad957506-fa9c-41e4-bb7f-9b1abb04125a', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '2T-3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ad97f2f9-a65c-4533-a8ad-01fda8c88059', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25T', NULL, '0/25 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ad9b7dde-104b-4d4d-a676-011aeacec35d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34DD', NULL, NULL, NULL, 'E75', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ad9f5e60-31d0-414b-bb79-abae9c4e32ca', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '34 X 30', NULL, '34 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('adaace99-d335-4abb-a8d4-91ff2f3f74f5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 REG', NULL, '8', NULL, '165/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('adb81958-d4cb-4424-9bbf-09eab2374288', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '18 TALL', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('adc27420-35e2-4c10-aa68-a72f5ed7402a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'S', NULL, 'S fits-shoe-sizes-10-12_P-convient-aux-pointures-10-12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('adcec7e4-a477-4857-bf27-2fcfc8ace7e2', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('add1f158-f710-473d-b791-2f5b249b1aa8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '4S TALL', NULL, '4C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('addf7639-2ee3-492a-927f-70c20545e716', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '27 TALL', NULL, '27 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ade0badf-6cae-4db5-8d3d-67dc0e296064', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'S HUSKY', NULL, 'P (6-7) TAILLE FORTE', NULL, '120/65 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('adeb77bf-0942-4624-952e-945bef3e68e8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-fcdb-35df-c4e65e2362a3', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('aded37c7-69bd-4113-808e-0b394ab38b0f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '0P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('adf84b27-cc09-4788-b4e5-99a560786422', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X 36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ae103d8e-bf56-4540-9749-7dae92c4a62d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '1X', NULL, '1X TAILLE FORTE', NULL, '160/125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ae1481b9-571e-421a-8ec5-a7eeeacda4a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 SHORT', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ae26f51d-c4a3-4b8e-845f-49f5e04ac4de', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXS/P', NULL, 'TTP PETITE', NULL, '150/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ae352508-2e7f-4159-99b6-8dbb49833b9e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ae4a7447-3875-47ac-987b-e8af4bbaccfc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-28d9-e5da-9797f8fc4682', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ae682823-9d2b-48e1-935c-24206d7b3f77', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'M ', NULL, 'M ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ae713ddd-4926-44be-a6ab-23cd36ee3935', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ae744e3b-ff0b-474d-93b6-7719b6ad4d01', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ae83894e-c945-4ef7-af5e-f763da38b30d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000 P', NULL, '000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aea96a16-7b82-46c8-bb48-e3966c30b4fe', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9743-d440-2b15e78e046b', 'OldNavy', 'M', NULL, NULL, NULL, '130/75 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aeabe403-f2e2-44aa-b1c2-a263e18e5540', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000 X 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aecd06c1-c442-40da-9ead-a90133946c62', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '2 YEARS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aed512c1-eea9-437a-bd8f-49eec66700c0', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('aee464ca-8a95-4037-825a-ed1a1f488944', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'MSLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aee6df92-7300-47dd-971e-8100cf2a9281', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 AA', NULL, '32AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('aef32168-7344-40fa-b831-32ab42c7a8b5', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af03111a-55f5-4a9e-8c39-3626f526e835', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('af1c1659-56a4-4c52-9529-08ee5ceb2480', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '3-6M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af27eed9-7d5b-41ea-857e-c2fc009db091', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X 31', NULL, '40/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af2ceee7-82aa-46ba-b162-ce712d7efef3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 REG', NULL, '0/25 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af372363-cb6c-4dd6-ab71-5f3da20d70e7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7744-6623-09d5f49320cd', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af46227b-e617-4395-8b02-b1052d75e5d5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '0 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('af498d40-f40f-42a6-b725-5064f99aa44e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af569552-db96-4c47-aaec-ede65ec913af', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af653a45-2ebb-4a23-a0fc-b4aec843f00f', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '12 ', NULL, '12 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af65ead5-a2d2-4ccb-8c97-60f502a72d8a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 X 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af6957a4-9df3-44bc-8dd8-ba62ef6cb556', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2TALL', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af713d0b-13e7-433d-8439-f8d4c7252bed', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XXL+', NULL, 'TTG (18) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('af72e103-7be6-4a47-8c35-045897ddc0ee', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '35 TALL', NULL, '35 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af7edd96-4970-4196-bd69-cae78abdb1af', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af7fda1c-aa7b-4576-8734-2765d6864b1d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '180/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('af8161eb-ca02-4537-90e7-3eb6346b6c5e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '30 R', NULL, '30 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af8362a0-b2b1-4f2e-a54e-cde080904cde', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af87d0c8-6450-49b2-8b67-f6c057cdbab8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8 REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af8a50fa-5741-4916-8287-956a86321948', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXL SLIM TALL', NULL, 'TTG ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('af8ddcb9-100a-4ba8-8991-8d86fba9dd35', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '2 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('af999963-118a-46b1-af64-8280ca499f41', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29REG', NULL, '8/29 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('afa4ab0c-a7a6-475a-89f5-bc0c7394dfa9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('afb177ae-f4d1-41f1-a474-caff08ca4183', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XXL', NULL, 'TG (18)', NULL, '160/67 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('afc0b595-a320-4a80-a548-769d50b26cb6', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '28S TALL', NULL, '28S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('afc58b08-03ce-46a0-a5d6-550909ad731b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('afd30388-cf1a-4f32-8bd3-8e8409a0d70f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 TALL', NULL, '0 GRAND', NULL, '165/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('afe18967-29e8-4199-85ba-8b93ac1510ae', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-6a89-2501-9d7ae73292fb', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('afe4bb59-e4e4-4914-bbbd-4399cd0551d7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('aff9a4a7-60a0-44e4-9656-cc4f0644f653', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('afffbc7d-21a6-49b1-ae60-3dd7fe0b39a9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b00060ce-570b-4c41-a3ec-11f433349b40', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16 REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b00dfc74-75ae-4bb9-854b-381e41544407', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '32 P', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b016edf2-fa81-4a34-8e39-99094156c301', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '25 LONG', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b01783f7-cbd0-4f28-a578-2e73a32045d8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XLP', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b018e52b-d039-4590-9e9d-a7b0e69ae6ac', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20X35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b027e8a8-8b97-4aea-b54b-6c55bf52a7e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12LONG', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b029ea45-3252-4fdf-a524-9c2389238297', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b02cab61-5a62-4db2-8ba3-d425bca544f3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXLP', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b02d9a9b-e0c3-4537-8121-2140ef216345', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M SLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b031628c-b6bc-4c0b-940e-661be6fccebe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 /28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b03a5f7b-4ff5-45df-bcc0-b74aa9df49e6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XL P', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b03aaa04-4741-46af-ba1b-750b972f2e63', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6 / 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b04083ee-a7d5-48ac-badb-26e71c89ec06', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'S', NULL, 'P (7/8)', NULL, '160/66', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b042f7cd-69d6-4641-91ff-a59e3e455d1f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b04c3b33-7c2f-4cc5-a918-674bc170da33', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '18 TALL', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b058c18f-9b18-4071-8794-899aeaaafea0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0608814-22b1-45a3-8029-1a4d6d4f6a13', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XSREGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0632aff-5b36-4b35-9afe-b2376b0d7257', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'L T', NULL, 'G GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b07f8068-4e73-4592-b722-35d1f087d871', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '33 TALL', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b0803069-bbe3-42a6-afd0-0d13a232278c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b08345f4-6dbe-49a4-b1fa-3408eef7d606', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('b0862454-32dd-4e8b-b385-808c81168364', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS/P', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b092c96f-a7d1-4ca0-acd8-89445c670fea', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0958db4-3d7d-4fe8-b266-69a3163dc498', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '2T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b0983111-fcee-4654-a808-ae6fff4f8be4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '31 Regular', NULL, '31 Regular', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b0ab2342-1fa5-4759-af15-59a2994c8bb3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 TALL', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0b21e22-1a70-49c5-b775-f68e0c3f5624', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '14 Long', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b0bcf9f8-e332-445b-bbf3-62db9d96b13c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M/T', NULL, 'M  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0c4cef7-615a-47c1-927c-5af8bcbc3999', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6 SLIM', NULL, '6 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0c7779e-be16-4759-8584-d62b44d51560', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b0ccc69a-f274-4cf5-be7e-9f9911afc1bb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '8 ', NULL, '8 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b0cd84c6-47ae-4fd4-9a63-780f6cee5992', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 LONG', NULL, NULL, NULL, '165/58A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b0e06bc8-bbf8-46f7-abbe-4edf6d924404', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 A', NULL, '18 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0e3600e-4af1-498c-9174-07669cf9665e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XSSLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0e3fa99-483a-4d79-9be0-94dd22b7928c', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '11', NULL, NULL, NULL, '175/69', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b0e440e3-73b1-44a1-a7d0-c2b88d1ea9a3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26S', NULL, '2/26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0f01f64-df93-4bb4-8cf3-230c1ec2b3d4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18.5', NULL, '18 TAILLE FORTE', NULL, '160/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b0f037cd-8617-4582-a653-8e61bd5efb4d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b0f4b990-a331-4c2d-bbcf-d8048145567f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'S', NULL, 'P', NULL, '120/59 - 6-7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b0fd7a52-3998-48d3-9846-0c77781c624d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12P', NULL, NULL, NULL, '160/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b108c884-b5cb-401d-9a42-2e35c00bba23', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'SSLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1196257-4af5-4190-be54-aa307b943f6f', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b11f2722-d972-4e2e-90ff-cb2022bfb7e4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '18SLIM', NULL, '18 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b12385a4-8c4d-4a8f-acff-d48b1652fbcb', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30X36', NULL, NULL, NULL, '185/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b124966c-f300-447b-a4f6-6708e1216189', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16PLUS', NULL, '16 TAILLE FORTE', NULL, '165/78 - 14 岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1252ca3-fbfe-477a-92a2-cde71568b5c7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b13d677b-23bc-4167-9830-b3135a6b955f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '7.5', NULL, '7 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b14739df-8cd5-4326-aaca-8e189e532324', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '11/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('b155830f-d6ce-4f6f-802b-992b40d7b547', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-7321-1a24-0670356a45c5', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b1646749-3c71-49f1-8938-9f8107c34dc3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXL Reg', NULL, 'TTG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1675051-64b6-4b77-850f-b4217bd74bd5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b16aa79d-40c5-42a8-aa2d-94cdfc86ba17', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '20.5', NULL, '20 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b171aa2a-841d-4fe8-b5fa-d7c992abac74', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublicFactoryStore', 'XL', NULL, 'XL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b17e8029-a386-4113-a17c-52413f0829fc', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b18d1258-e560-4348-9d42-4c82695442ff', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b18de6c2-d133-4658-8d4f-ba8c253f8345', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b192a594-90fb-45a7-bcce-d392599691fd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L+', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1a2658a-ccf2-4dcf-a1fb-ef0abadb9e37', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '16 Ankle', NULL, '16 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b1a46e91-2377-43b7-82b0-ce97973e050d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/59 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1a5ce99-4a4a-41af-8807-baa38d64e1cf', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b1a7bfdf-0906-49c2-8d75-b877cdd24341', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34LONG', NULL, '18/34 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1b1c2a7-0b8e-4fa0-9232-eff32ac2f411', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXS/T', NULL, 'TTP GRAND', NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1b3d141-b851-493c-becc-3539bdec1588', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'BananaRepublic', 'XL 40/42', NULL, 'TG 40/42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b1c26e7e-6c71-4ad6-b13b-2c722ead5e46', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'S SLIM', NULL, 'P (6) ÉTROIT', NULL, '120/56 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1c73d0b-220e-472c-b6d0-e4ebe44f6311', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b1d55d8e-67fb-41e8-a4ca-cfb0d6f49009', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14X 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1d9dc40-8edc-4fa5-b35c-94bf12ce2b91', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22 P', NULL, '0000/22 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1dc79dc-b78c-4246-b7ea-9c1fb4eacc1a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10PLUS', NULL, '10 TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1e25af0-b11b-4834-a4ad-f2d7cac0d631', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '24 LONG', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b1e3409e-3d3e-4b91-a856-ee09c95a9d91', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24 TALL', NULL, '24 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b1f0fb7b-f981-42a6-8b0b-aee00e303d1a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12S', NULL, '12 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1f702da-9382-4b55-8061-e87d7acacd1e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS /T', NULL, 'TTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b1fdac85-95e6-44d0-80ed-c6705ded7a0a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS+', NULL, 'TP (5) TAILLE FORTE', NULL, '110/65 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b1ff4593-f80d-4001-a9fe-d80c2a40823e', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L SLIM', NULL, 'G (10) ÉTROIT', NULL, '140/55 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2046e64-81b5-4f00-a57f-a2efb820e51e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6 SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2158476-9eef-4a57-9aaf-9fecdf51ad2f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10 HUSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b22028e1-dd57-497f-9dff-9a53d70d3042', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '170/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b226f28b-bf57-40f9-afca-d9eeb062c739', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b230c481-c9cd-48e9-a57d-a287bdecb5ff', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34 SHORT', NULL, '34 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b2329e53-bb51-48ac-8272-757e25ed011e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '175/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b240b31f-f53f-4b6a-a0b3-23c11cfca4ff', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-3ef6-84d6-7cfea460ba11', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b250f478-8f9a-4c13-8968-2f7f911cdac8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2A', NULL, '2 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b253fea2-63ce-491b-8c47-7b8905671edb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2544150-3843-44d1-a94c-1bbf695a98d4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7REG', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2585b5c-98cd-441e-bbc1-7ae16512306d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b25bf622-8191-46af-944a-7a5cfffec8dc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2716d5c-7829-4ae7-8778-6e4ac3d95f86', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXLP', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b27c3ced-78d2-4b98-a91d-22f2c7d0ed94', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b28af985-46a6-470e-8770-2685c41b8f92', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48 REGULAR', NULL, '48 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b28cd3f0-a3fc-48bf-9b8a-d34a72514981', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b28f3415-5ebb-4f6e-be2f-368154341aff', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXS T', NULL, 'TTTP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b292cde2-b5ec-4937-9760-5bcfe962d2bb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 PETITE', NULL, '8/29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b295fc90-7464-469d-a79b-ff79dfb4aa19', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', 'L', NULL, 'G (9-10)', NULL, '270/87', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b29c0a46-5fef-41e3-b073-6ec07964b7f1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b2a05963-2681-408c-b88d-8e3360c7bfa5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2a253ab-02f2-41b7-beb3-2007b10e88f9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2a26f64-4277-4e04-b3b8-0c58516ad1c3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16HSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2ac2795-fe81-4043-812d-60defd6cdf4a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/T', NULL, 'P  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2bc29c8-4fc4-49fd-bbb7-7a1f8e73cff2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/ 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2be3d3c-e7ee-44e5-a7fe-416828cb77df', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-5b57-5ec5-5f579cc9e38d', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '152 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2cd6dcf-03ba-4a92-b960-94ed20cdf9ff', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '155/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2cf8ed7-1d5d-4609-bc58-cc0fc8b494f9', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40X30', NULL, NULL, NULL, '170/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2d2b574-7931-4907-aa59-4e17bf64faf5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2d7f7aa-7c01-4882-b285-6f346b140182', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2d86029-6364-4a36-b1e2-494afdf11cca', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L REGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b2d98536-9447-44a8-9e27-b8123775de04', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'M', NULL, NULL, NULL, '130/62 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2ebd273-6baf-4d34-bccd-87f46d298a76', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-96dd-63bd-c7b166ddf2eb', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, 'k', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b2edbe84-0d3c-48a9-9050-8af7346317c7', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXLXLG', NULL, 'TTTG GRAND', NULL, '190/140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3032d93-16dd-4e9f-a13f-503969c67c47', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34X34', NULL, NULL, NULL, '180/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b307828d-a2b6-457e-925c-64486a554b80', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL T', NULL, 'TG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b30a74c0-5cd2-48b8-b0f2-c1d22bfd67e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3113402-f84c-4b20-9e74-23075f364c67', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38', NULL, NULL, NULL, '175/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b313c3fb-2683-47dd-90c9-67c0cfdcc220', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3146d56-5edb-4959-a2b5-b22f8f610d35', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14 REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b31ab644-62d5-497d-b20f-b2fff09ddf6f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b31f8c18-9c76-47ed-8627-7b74614a3ba2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2 X26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3221bdc-bfad-4d14-9b4e-47d00a254c8a', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b322d53f-7752-48a2-9af9-f86f48295b27', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '6.5', NULL, '6.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b32beb2c-44b4-4383-9e24-554c971cfa85', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '10/11', NULL, '10/11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b330c6f9-46c3-4682-af5c-d309cf6b3968', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3365cd6-b5ad-42d0-9ecb-e5ad8248a946', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 SHORT', NULL, '4 COURT', NULL, '155/92C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3411f53-b1cc-479e-b87f-b9cc4b5381ba', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b349228b-119f-4920-b405-1a160091c25c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S+', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b35224ac-e17f-494d-9ac4-5680157fa7f2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'XS   ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b352d62b-0249-4b1d-9b8a-add9c906f668', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M REG', NULL, 'M (8)', NULL, '130/62 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b355f4a4-118e-413b-ad19-9d9d8a0ab649', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b35b13b8-8ce1-45ea-82df-260c78cb150e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XL SLIM TALL', NULL, 'TG ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b36afd64-7c73-4581-9471-3eb8fa849eea', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/ 34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b37411ad-7ce8-4456-9ad9-7b5ca57c67f0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28REG', NULL, '6/28 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL);
INSERT INTO "public"."wp_size_chart" ("id","product_gender_id","product_type_id","brand_type","original_size","us_size","canada_size","sp_size","china_size","ru_size","uk_size","eu_size","jp_size","it_size","fr_size","cn_size","mxsp_size","uy_size","id_size","kr_size","online","s1us_size","s2can_size","s3uk_size","s4eu_size","s5jp_size","s6","s7us_size","s8can_size","s9uk_size","s10eu_size","s11jp_size","s12it_size","s13fr_size","s14it_size","s15fr_size","extra_properties","concurrency_stamp","creation_time","creator_id","last_modification_time","last_modifier_id","is_deleted","deleter_id","deletion_time") VALUES ('b3746528-d3cc-4f97-94a5-a3cfd47b3c08', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '31L', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b39bb1ad-9879-4d7a-ab66-e4317d8b5641', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '2 Ankle', NULL, '2 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b3a4f825-334a-4404-b923-6d5f7f4020aa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3b08032-be66-4fef-bc14-47b779355895', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3bf417d-a7a8-4dc8-aa49-fbfbda399130', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3bfaac7-ff78-4323-9085-90f59e818aa4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '8 Petite', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b3c3140e-3545-4c75-b49d-3b47d503004b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL P', NULL, 'TTTG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3c4ba4a-d48c-4025-86c9-b018bb5d8f6d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26+LONG', NULL, '26 TAILLE FORTE LONG', NULL, '170/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3cd48b7-f721-44eb-be12-d963e0b12fbc', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3cf4b81-b908-43d8-b59d-1890ff07680d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M', NULL, NULL, NULL, '175/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3d56493-9856-4cba-8ef8-6b9e2cadab7f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b535494f-a9d4-406b-8874-9c3e564e32d1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9 MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3df5776-7b98-46a5-b6dc-d83503ac46a3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '8 TALL', NULL, '8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b3e37e2a-359b-4f5b-952c-86857e7caa15', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b3f5503c-8294-4396-8344-396bbe8418be', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-c903-74cb-ec08fed5be7c', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '56 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b3f974a5-c796-4dc7-878b-4367e6feaa43', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14', NULL, '14', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b400f51b-89f6-418a-8c2c-a2a34525ac5c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b40bc02e-ab87-484f-a425-bf3203696f0a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '2 Petite', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b41069d7-9d4d-40d8-966c-5a2eb8651571', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 /25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b41ad229-e887-4f1d-9462-c61e460525d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b41b040e-8ed4-4976-bbc1-ce597a409e55', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '42 Long', NULL, '42 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b41d74ca-0667-4947-982d-12bf7f800a23', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'OldNavy', '12-18M', NULL, NULL, NULL, '115/58', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b41dcc22-bc10-4085-a755-3b0efd8ceb3a', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b42f852f-4386-47d4-9bd7-2c13269d470d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4303dea-a82c-4566-b580-e54715f4be82', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4306c4c-8193-4b6d-af07-daee74e429a0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '8S', NULL, '8 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b43551d7-374a-48de-a0a9-e097061c7af3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 / 28', NULL, '31/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b438cb73-0fe7-44bf-8b0f-6d1f891654cb', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS +', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4416967-df69-4152-a1d3-01c4797ce5b4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'S REGULAR', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4444648-d4d5-4885-933d-bf557decc07b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b45a34ce-0c0a-4d65-999f-2de30e055278', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24MON', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4640e6b-075a-4d35-8ca9-9fe5979eb19f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b4700269-234a-44a3-ae2f-1977317e3d4b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L/T', NULL, 'G GRAND', NULL, '170/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b4808585-3169-4405-aa35-01b11514f4dc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4P', NULL, NULL, NULL, '155/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b482bb3e-fcd8-4826-ac62-3ea400d7ca5f', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b4862312-e23f-43e9-a02b-32800aa78645', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b48a6280-98d8-4e20-9e32-cf611e26bc2c', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-4e87-4d59-f5cb64a7ca0b', 'OldNavy', 'One Size', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b48e1d17-03c7-4f00-bef2-fc0e0da2b446', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b491a234-859c-4491-a5d2-7a8a3f409e65', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XSSLIM', NULL, 'TP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b49326b6-e878-4087-927f-b74d211308cd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24 S', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4a246c8-d469-41a3-9280-77dc72763864', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4a832fc-16e6-4b23-9f2b-ae564560039a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0 X 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4add5d3-9537-4d21-ba80-ce57399985af', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4b4cd3a-4ca4-49f5-a2c1-0418c93a7b17', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4c3eba8-4db8-4ca6-9357-40926aedf225', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X 30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4c7d95b-5ce5-45ab-828c-c053735be723', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4d2f0f8-07eb-4fbb-be78-62130803591e', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('b4e47586-39a0-48b3-811b-c4f8e1c49ea9', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S PLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4e87a61-7868-44f4-972d-c3a538f7d18a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32D', NULL, NULL, NULL, 'C70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b4f01f17-68de-4e0a-942c-0ab906316bea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00R', NULL, '00 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b4f81e88-32fa-4d55-a25c-4543db2c5b3f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5106a12-838e-4049-802d-5ed2aab1e467', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS/T', NULL, 'TP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b513616b-f408-4971-9ad0-314ee3951853', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7SLIM', NULL, '7 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5242985-b255-4c0a-b119-39495ddf4763', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '50L TALL', NULL, '50L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b52470a7-fad9-4147-9931-478abf06292b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b52c886c-0ec0-4fb3-9a67-cfeaf223e072', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52 SHORT', NULL, '52 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b5311b38-d74f-4ecb-889a-f09381c9479b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0 P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5323cb4-29ab-4bd0-9de6-ccbed867493b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b538995b-908c-4931-a728-012246e233ec', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4X', NULL, '4X TAILLE FORTE', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b53a1388-34fd-4fe0-aed4-16227547bbc1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b53bfd4b-0cfa-4056-ac03-edf8b168fec2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b53d3322-7f05-4a65-b622-3868fa7f7203', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5426291-4657-4809-895f-fc9ba56441e9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25L', NULL, '0/25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5431375-5be0-4f66-a748-55b1de98d024', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8', NULL, NULL, NULL, '165/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b54c06f9-4f83-4925-8ad5-02f519907433', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18 X34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5590ddf-3835-4d28-a235-6fe58146cd0f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16+', NULL, '16 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b55b38ef-af9f-401f-9c33-7593a560ae82', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b55b8223-c06c-4a67-ba92-07be67a33564', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b55f6fad-bca7-4f37-8009-cf63ab121064', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '4 Petite', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b572d8d2-39e1-4f1f-8784-9bbae1103b44', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35REGULAR', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b574ca50-d25e-4c09-9a7f-b7a154dcc93c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 LONG', NULL, '10/30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b59762c0-8d56-408b-815e-ad00cb068b5e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '3X', NULL, '3X TAILLE FORTE', NULL, '165/120C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b5a95475-e9a8-4708-ac42-c42dc6a5c8ab', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5aa20b3-50fc-4a41-9c62-561240735a5b', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', 'UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b5c5e4a8-a52a-4674-bf5c-bbcfe2f3c142', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/ 30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5c89610-6c22-4504-812c-745c62602bf5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10LONG', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5cd8e92-5ad9-40b4-b7fb-49529a90daaf', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'M', NULL, NULL, NULL, '190/72', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b5d17e69-71d5-4338-be16-e349227dee26', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b5d722be-8892-4c55-a908-d8c75efcbad7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18 MON', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5dd080a-74c0-43b6-997c-3f4c3b14c00f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5e30439-3f9d-4357-8ef6-b41026fd01a5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5e8ab7f-b604-483c-ba77-96696f57b3d4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '10 ', NULL, '10 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b5f322b8-092e-431a-9afd-8562efedafc6', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '0-2 YRS', NULL, '0-2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b5f83688-3fb6-48cf-ab73-8afc8adc5b85', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30 S', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5fa43f7-1b81-4d3d-950c-a4591d51b300', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26 L', NULL, '2/26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b5fce82e-39ad-40e0-8833-5d5a0e7633a4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '00', NULL, '00  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b60095d7-db83-4f6a-8056-c1cb4440b318', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 SHORT', NULL, '6/28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b60899f6-b012-4e6b-aea5-ee9efa845ab8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '32 P', NULL, '32 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b60cf8d4-f4b2-417d-910d-257a51b8504e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b61efe2f-890d-4874-bb76-fe583d873ca4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/ 30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b62f34e7-69a6-4751-8d0f-c8a2feb91bc3', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '6-9M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b63bd3f6-967f-45c5-919f-a46e94cd64f1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS REGULAR', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6403af6-404c-435e-b9df-e5586efd218f', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b648a6d8-d2c0-4e49-b776-e5d29da57bc2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 /36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b65e0e35-87af-445b-a5f9-92ef749d5d29', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-383b-32bc-d57a1b3f3ef1', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b668e0ab-8513-4499-9304-5fa5ce8f6aca', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44-TALL', NULL, '44 GRAND', NULL, '185/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b66a0527-fb73-4acf-ae2c-68212109e377', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXXL', NULL, 'TTTG', NULL, '185/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b66ed43d-4113-4c07-a1f6-0b6fea140103', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18XLONG', NULL, '18 GRAND', NULL, '175/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b6772d71-8584-4d40-be49-9bc2f191bcfa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6794d44-3dbb-49c8-bc55-8625a01fd4e5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublicFactoryStore', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b686c8b3-604e-45fc-9ef3-baa69fd9ba12', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'SSLIM', NULL, 'P ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6a26537-a006-4225-a07e-f02a08dbe25e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10S', NULL, '10 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6ab6e2e-8e5c-4584-8e33-0c0fbbb1f67d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18XLONG', NULL, '18 GRAND', NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b6b557d1-ea24-401d-84b9-302c8cc9147f', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M28/W6', NULL, 'M28/W6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6b5a621-9306-4cf0-9279-b76c7f912131', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6baba44-7a2c-4874-8421-f44fc4de01ed', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '10S TALL', NULL, '10C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b6bbbdae-3ba7-4266-9e5e-0e3771c26ac4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30 TALL', NULL, '30 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b6bda5cb-523d-4390-8339-00c399fa0c59', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b6bf7800-2f3a-4790-b447-26dcefd75427', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'L', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b6c68b9d-6de5-4342-86ae-de22278ea686', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS P', NULL, 'TTTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6d81e46-3278-4604-8f64-1ada15d10b86', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS/T', NULL, 'TP GRAND', NULL, '165/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b6da2cbd-acc8-40cd-814b-653aa75e0d33', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'MHUSKY', NULL, 'M COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6e33f17-d4ce-4ada-a514-f022e7488e46', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b6e47248-511e-455e-af29-98a5b45fd43f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10 PLUS', NULL, '10 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b6f0115c-ca91-461d-9a24-55ae4260e980', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 T', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7035692-4a84-415e-9227-ecaeb32cff00', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30REGULAR', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b706644c-5cff-49da-8498-603f738a977e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31P', NULL, '12/31 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7149215-fd52-4031-a9e8-70481f34b569', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16PETIT', NULL, NULL, NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b71cbd2a-7599-449a-b838-4bdd47860754', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16XLONG', NULL, '16 GRAND', NULL, '175/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b725fe2d-a70a-4b73-898a-edd0204e758c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XL TALL', NULL, 'TG 17-17 1/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b731af29-e962-43a5-9cad-f9284740b344', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14SHORT', NULL, '14 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7458a0c-7a2d-496c-afa2-166f313cf490', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7 SLIM', NULL, '7 ÉTROIT', NULL, '130/56 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b7490825-3df2-4a4c-84e2-4944aafd2b89', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '11/10/2024 12:00:00 AM', NULL, NULL, NULL, '175/69', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b751d8de-26da-41f6-ba7f-187a5cc4152c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b759c454-83b7-449b-98f6-8f5381bca06d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b76cdc4a-758c-4682-abfb-e94cca415bbf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2P', NULL, '2/26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7820e23-9195-43e4-800d-9fb73bb2d8ee', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16 HUSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b78894f9-65ff-40af-b109-2520d72dd4b7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bfa1-05a3-b0d0a7835e54', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7a417a2-2d46-4559-b2a9-ae04304a62b3', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b7ae3de6-0ba5-4395-8e2a-766cccab28fa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '28S', NULL, '28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b7df52f6-1d7f-49ef-8c53-50927c0ace54', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10', NULL, '10', NULL, '140/66 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b7e22062-f51f-458f-b565-2636760e30ab', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-120e-f174-83eed1baee83', 'BananaRepublicFactoryStore', '6-12 months', NULL, '6-12 months/mois  27-29 in.  69-74 cm  17-22 lbs   7-10 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b80a3612-b816-4fae-a84a-e94d299b4055', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8119b55-1759-4908-b730-e14a1f7e96f0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 /34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8290d27-d7a2-4571-86bb-2c6f3af05a94', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '34X30', NULL, NULL, NULL, '170/86A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b82c50df-926c-47cc-90b1-c57608205fbe', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '25-28 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b841d0a6-013f-4df9-9659-78902b83f7e9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-fbb7-e51c-c71e8847e2c7', 'Gap', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b845e65b-5c5c-4cfe-b723-a76d7780c83f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0X 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b84c74da-20e5-4758-becd-dd94181eecb6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '10/30', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8545692-24ce-4e22-9d57-7e7b31ada8c2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 P', NULL, '18/34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b85ccfd1-b391-496b-88bd-49ca9caa86bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b85f685b-f994-47d9-b716-8d996a9a7208', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'OldNavy', '6-12M', NULL, NULL, NULL, '110/56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b86ca0fa-7500-4cd9-91dd-49cf555d259e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'LHUSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b86d88cd-31d5-4132-82d4-e3fcccd547ec', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9607-1abf-44de15979e47', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b87cb27e-194a-48b3-933b-e06c83a4b22f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e7be-1769-35299b754315', 'Gap', '0-12MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b88ba996-7e98-4d18-80c3-64bf9585c9c1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b88e75c3-781c-44dd-a149-0db68e7fda4b', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8961178-c8b7-44a3-ac2d-d526a95e48e6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0 TALL', NULL, '0 GRAND', NULL, '160/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b898b7af-ec65-4060-8f22-a1445e66367d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '25L', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b8994cc2-c5e8-4ad6-8696-79731dffe411', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '34 REGULAR', NULL, '34 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b8b6983f-3243-4242-a02c-bb3b7bf99092', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'L/XL TALL', NULL, 'G/TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b8be9c45-116e-4fcc-9df7-80d9e3412738', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/28', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8c3ec2b-00ea-4095-a6e5-3ab6fa56dfb3', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b8d467e2-3716-4849-8593-8f30715518ed', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X 30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8d88772-b144-4840-b50e-27159c70edd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 R', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8db2347-4dc9-4392-9e0c-7507965bea27', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'XS (4-5)', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b8efa9cc-d055-4f4c-b1e9-eb3ba5bebaca', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '7', NULL, NULL, NULL, '250/92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b8fd7ac1-2bab-4eac-8245-55e1608bdaea', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/ 34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9092b13-2ff2-467d-b17b-43d50a2761bf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b90aa560-3367-4971-b2c9-d5fd2d8b5cdf', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XL/XXL', NULL, 'TG-TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9188d98-f792-48a1-bfbe-5a60e902c62e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '7/8', NULL, '7/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b91cd306-3aea-4631-981e-092905d53d10', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXL+', NULL, '3X', NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b91ed99f-2b52-43f8-bd5d-e28c60d8f890', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9325f56-6ad1-442c-9a32-906276f6f45b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '0-6MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b934b436-2fbe-49a3-b1e2-5811992c2194', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '35/20 Petite', NULL, '35/20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b93950c0-e534-4eed-9dfa-c5d310137a8e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b93baead-f2cb-4829-ac4f-9fdc19069a98', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28R', NULL, '6/28 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b94fc50f-1def-4c8e-9262-7f6617b6dd7e', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12 LONG', NULL, NULL, NULL, '170/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b953e56a-2665-4f90-9bce-15c24490f6af', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXL/T', NULL, 'TTTG GRAND', NULL, '190/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b96661e1-b7fa-4586-b5c9-92729304653e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9755831-76ff-45d6-8582-bb2ee4cad653', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-1e7b-dc82-553848260965', 'Gap', 'S', NULL, 'S fits-shoe-sizes-10-12_P-convient-aux-pointures-10-12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b982d579-d983-4c5d-873d-ef14160e5079', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('b983b9ae-edf1-49d2-8e22-8242f31018c4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00/24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9934b7a-fa29-4bef-bec0-3e363a7ddf41', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b99ce6af-6181-4d98-a893-0fe1e6f4a1ec', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9ad5005-bd59-4789-9a7c-a7cdc35f90cc', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL HUSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9bf0f6a-3006-401e-b0ee-dbf95fba0bdd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9cac126-f3df-48e8-af7c-54d2e8b017bb', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XL', NULL, 'TG (12)', NULL, '145/66 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9cae8c2-318e-409f-84f5-da33792f3434', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e71-f43c-5fa7e185650d', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9d5a734-1339-4c49-8304-6b8df1e443e5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XS', NULL, 'TP(28-29)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9de8d04-9c23-4a00-94eb-a3e6c23b3f96', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-59c4-1a32-c170aca4803c', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '43-61 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9deaee5-9aba-4079-857b-d54c124fb655', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16+LONG', NULL, '16 TAILLE FORTE LONG', NULL, '165/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9ed8abb-1e21-4e3d-b5e7-95b90caa6d8c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '1', NULL, '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9eece21-eea5-4c32-91ca-018b5c551ca9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL/P', NULL, 'TTG PETITE', NULL, '165/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9f36faf-3d66-40d4-ace1-d5bb3866449b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16.5', NULL, '16 TAILLE FORTE', NULL, '160/114C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('b9f83a7a-e97b-4924-881a-e83a9c7f4687', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-5e98-8d89-1c1c318078cd', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9f9ef6a-10f4-4cbf-bf0f-4a162555fe2e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('b9fb3136-03c5-40da-8322-da3f8a3b16b0', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b9fb3f0e-cdd6-4a92-9f49-be1b6534b34f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '29P', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('b9fd81d4-8248-49dd-8f5d-2ddc5fc2b880', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba023874-2e2a-4e1f-8cc2-13b2b9c50a0c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M T', NULL, 'M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba060559-48c9-4d6d-9c71-cd012bd756e6', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '5', NULL, NULL, NULL, '125/60', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ba0ff7d1-46a3-4691-95b4-7d2e2afd159d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'M HUSKY', NULL, 'M (8) TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ba1df307-9c42-49e7-8300-7e6502fac80a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba2ae92a-a7d2-4f10-90ff-ac908f298921', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2P', NULL, NULL, NULL, '155/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ba3fc190-d7ed-4b2f-a33d-209a61066898', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/R', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba439d9c-d81d-4cc8-9db8-38f744c06df5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2/26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba4461b4-37a7-4149-ac1a-aa067604f025', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27 L', NULL, '4/27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba4f27bd-c6bf-47fe-b321-0371be9117ba', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublic', '0-3 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ba663332-84c3-4225-adfd-74824acb2768', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '28 Short', NULL, '28 Short', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba7575d8-572b-454f-b11a-f20d703da821', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba7e8f6b-092f-43f5-a3ac-dce22de48729', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '9', NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba7fb9e6-297d-4e8d-ad21-822baeb18920', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '27', NULL, '27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba81b924-dfbc-4e32-8f32-50e9efd60b47', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '18XSHRT', NULL, NULL, NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ba8b60c2-9f87-4691-99d1-1eda2e11c5b6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32/14 Long', NULL, '32/14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ba8e8e5e-f7b1-431b-92c4-79adbdc1a53d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '12-18 MON', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba9df39c-1b19-41e2-8b91-bf67b076fd6a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10 A', NULL, '10 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ba9f994e-f69d-438f-9471-f6e5f67e013c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 REGULAR', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('baa71e51-799b-45de-9de6-ff3c084d6be2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('baacebef-b24b-4f21-bf7b-f09cc7de8dd0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26 X32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('baad6867-7b30-45c9-8d04-480ed34d8c13', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '25/0', NULL, '25/0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('babc1494-9395-47f6-941f-4dd75373e982', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-9 MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bac4f95c-c28f-4376-bbed-85a0ee6d5f19', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bac948c2-e5bf-418a-80bb-6b31489d12f1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'BananaRepublicFactoryStore', '12-18 months', NULL, '12-18 months/mois  29-31 in.  74-79 cm  22-27 lbs.  10-12 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('baddbf4a-16f3-4b76-baeb-d8dbcad71ba3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 R', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('badeddd6-87de-4f2b-812a-9045de12ddfd', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32 REGULAR', NULL, '32 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('badfdc30-a647-48b5-8ddd-2a26184aafe7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '00 Short', NULL, '00 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('baf3f4dc-ab09-43b3-9494-146d438d9223', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '3/4', NULL, '3/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bafb9391-ba75-4d92-afd3-eacd1f1c946e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27TALL', NULL, '4/27 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb013a3c-339d-43ef-8344-d23882b9f23a', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-8260-30c7-bcd31c94e7f1', 'BananaRepublic', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bb032ee7-327e-47f8-9a82-a1eed25da06e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XL', NULL, 'TG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bb053c4e-11a5-49bc-81d4-ff53026ff6a3', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 LONG', NULL, NULL, NULL, '165/84C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bb42a917-dc97-449e-afb7-86c6a84a9765', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'OldNavy', '18-24M', NULL, NULL, NULL, '125/60', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bb5220c1-24ce-4859-ab8f-9897d43ca6de', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bb54ed3f-982a-488b-bba5-f187f198b005', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5d1-8b1a-6681f41aed59', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb58be5b-87fd-41d2-9434-ac5ef06567a1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18R', NULL, '18/34 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb6b591d-1597-4c82-8f91-261195288286', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '27 TALL', NULL, '27 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bb6edfa7-db9f-4acf-9079-5866d2e1dfcc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M PLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb7a01c6-2563-4ddb-a47e-a7af935ecb6e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-34fb-f12f-7ff024c5f1e9', 'Gap', '42', NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb8ed7d1-4fee-4904-917e-34d886f5dc62', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bb965c9f-b175-4568-995f-1a0742ac0e1a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '12 TALL', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bb9b8862-71c4-4e77-a844-e42e0ba8c608', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-a38d-0ed7-13731eb5120e', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bb9ee0da-e442-4e37-8a26-5a01f8b44fcf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS/R', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbad69ec-51f1-4911-b4b1-780fb61eb5c9', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '0-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bbb50946-4ee6-42b9-8d63-908403128bcb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-ff5b-9d4e-c827ac82c155', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbbb4dc4-3361-4d8a-911e-ed7a704d1dde', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X 34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbbb6c6c-1d7f-482e-8dd7-05dfbb1c648e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26', NULL, NULL, NULL, '170/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bbbba49a-8f0a-46b3-a2db-86a995abc7e5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26REGULAR', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbc400ac-7731-4b15-8acc-90bdbbe047ca', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6', NULL, '6', NULL, '160/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bbde73a9-3de9-4137-a5fe-574408b30971', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbecd93a-7e19-471d-9bf6-85782327969c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bbee0088-490a-4a07-9b0a-ac7d52764e95', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5119-2c68-4a208711d430', 'BananaRepublic', 'X-Large 40-42', NULL, 'T-Grand 40-42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bbf001d5-ba80-4dee-9a5a-2050cfdf8fb4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f51-fb5c-714f94367e54', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc0840ea-a5ec-423b-a201-66233566265d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '8.5', NULL, '8.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc0f913c-a6bf-4bd3-8ab4-33fa73c8168b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8 REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc111ad2-a0f6-40e8-87ef-4cc158fe3ebe', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'S REG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc12acf8-22dc-4f5c-8aa3-583fe06735a8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '32/14 Long', NULL, '32/14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc163cbd-4e59-472d-b913-53d17338c8a1', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc1c51af-3843-4a29-aa56-4ca4055c0373', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc1dcc79-cb24-4d0b-93e0-06566d52401a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'XS', NULL, 'TP', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bc342ec0-5eca-4a56-b595-7c48ba8c30ec', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '000S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bc5119c8-6f05-4cba-a4a8-7cfcfcc787d2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '40', NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc658807-ed64-4818-9039-ea8e2e2b62cd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12 TALL', NULL, '12 GRAND', NULL, '170/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bc6a9124-308b-47ab-b798-763eb85db3f9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-c84f-6058-c43ce11f704f', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc6ada58-d8f8-42c9-8346-02e0c0b17e1d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8T', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc6ae221-3776-4519-8fb1-67ca2ab66d36', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '31/12 Petite', NULL, '31/12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc7edc7a-f375-432e-a30c-b65760878052', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XS TALL', NULL, 'XS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bc834736-aa6c-4fc5-8925-da224195215b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'SREG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc8559ec-2bf9-4cde-b56e-30ac4be24ab2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000S', NULL, '0000/22 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bc9fd220-49bb-4531-965e-be23a1d5a0de', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32/14', NULL, '32/14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bcae7d0b-2a60-4c0e-977e-12dacbe8875a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '35 X 36', NULL, '35 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bcb4c99c-0587-4b23-8fb0-92eb47e6b6b8', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '6-9M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bcb644c2-533b-4148-923e-0c154bdfc383', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20+', NULL, '20 TAILLE FORTE', NULL, '165/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bcc18f41-cad8-48c7-b2f5-a00293740b83', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('bccfcf73-5536-47d0-8a67-abf7e13f6a00', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '00XLONG', NULL, '00 GRAND', NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bcd8e2d9-ab8d-4517-aa89-0341ba3edc91', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bce6fd4a-7b0f-45e2-85f1-d159910c3f44', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5 HUSKY', NULL, '5 TAILLE FORTE', NULL, '110/62 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bcf03d9b-3b77-480e-8d6c-228ef843c0c9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '30 TALL', NULL, '30 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bcf705e0-d733-4709-a3fc-2f3bda5a1745', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14L', NULL, '14/32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd0bf8ea-6145-4450-8127-87afe1a9fda5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16 +', NULL, '16 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd0c36f8-98fd-4f2b-989a-ba31b9fd4896', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '8.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('bd0c9c0b-5deb-4887-9d8c-31e1ec2e5b19', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd1fe15f-93e4-4888-8364-ce37064e508e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bd26d099-b3c9-44e7-814a-fa5dbbfadb81', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M/P', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd2cfb9f-07f4-4f06-8a45-2f99d6d9e5b3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S HUSKY', NULL, 'P (6) TAILLE FORTE', NULL, '120/62 - 5-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bd326795-6970-48cf-b084-5ff7e27a02a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd32ddd8-61ff-4d5e-9155-6244f64d1248', '3a0c74c8-3055-8590-30a2-d59a6faa10a7', '3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'BananaRepublic', '50" x 60"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bd3c6057-84b4-4a07-b018-89d20cb60386', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 / 36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd58a36d-3cfd-49cc-b510-0f3b3ab31eaf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X 28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd67db2f-9a35-4b8e-ae8b-c4c9a97dca75', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bd6807f5-660d-4e2f-8525-d87c8f338b12', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28 X 32', NULL, '28 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bd7c53c5-9d2f-4411-aeb0-7f84af2ed228', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '2YRS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bd81ee86-194d-4ddb-84f1-10306f11cf54', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXSXLNG', NULL, 'TTP GRAND', NULL, '160/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bd883c0f-76de-4baf-90d0-50d866c21ddf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S REG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bda0166a-4414-44fb-a92d-f5ce3c7bd9bd', '3a0c74c8-3055-ad0c-c2f9-32634e7d880e', '3a100889-485f-fc29-7006-25cb2a5966f6', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bda1efee-ab9a-4989-8391-439daf19ae6b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL+', NULL, 'TTG (14) TAILLE FORTE', NULL, '150/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bda277c5-bdf6-4b05-972f-1eacd7737ffa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 SHORT', NULL, '4 COURT', NULL, '155/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bda466fb-b0b2-41f2-87b9-1e3a1762fe66', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bda9c12c-5769-4f35-8c4b-7ee3edff0e91', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '4T/5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bdc59252-a8f0-4fdb-bc0e-2bb134606790', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8 HSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bdc71c66-945c-499c-b5cd-4210e001e502', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'S 14-14 1/2', NULL, 'P 14-14 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bdd34d5d-a66e-414b-8ec8-d2fc17e5c6b2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XS ', NULL, 'TP ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bdda48db-2f14-4ed2-b126-074d2b416648', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL HSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bddc0464-b230-45ad-bea1-fe7adbb11d9e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 REGULAR', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bde977d3-b4a0-4080-9bad-4ab1fdb2d243', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-3dbd-7cf0-fc3d70abc36c', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bdeb40ec-7157-42ab-b136-75bb12357c23', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 L', NULL, '00 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bdf2f7a5-937c-4c47-ab10-05664e46b67f', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '4T-5T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bdfdd01c-9e8a-454f-95d8-01da9f81c1f1', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bdfe4f55-da7f-42dc-b7b2-034a5ac31eb9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('be02bc33-37ff-4cad-bfba-170b352e6643', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-b4af-8018-c4a2505a756f', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, 'j', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('be052a2f-ac32-4659-9877-26fba578035f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be0b10aa-de1b-4ee1-a249-72c0283cb0c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X 32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be0e462d-7ea7-4878-91bf-2b50ea98b939', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be235b37-216b-4f30-aa0c-125104acbbbe', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '34 X 36', NULL, '34 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('be2661a8-6d46-4ee8-996b-b3dc8b7e81c4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'L/P', NULL, 'G/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('be3018e7-605b-4aaa-ba1c-4553423b3c11', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31 P', NULL, '12/31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be3773fb-eb92-44a3-9176-9bd0cb6e36bb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '2', NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('be458a63-a9d4-4382-9cbd-f484cb3830e6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40C', NULL, '40C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be49396a-00ef-4aa1-b0c3-71d3188f6dad', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8R', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be4ee826-4014-496a-b656-b160651f3058', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12T', NULL, '12 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be542bc0-a05c-49ab-906e-583534406375', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'L', NULL, 'G', NULL, '165/115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('be5c91e4-d854-4087-b690-5cd773f382b3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '31/12', NULL, '31/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('be84f1c1-1d33-4c85-85aa-96f74ef5c680', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52 REGULAR', NULL, '52 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('be90b0f1-9fe4-4921-a8b0-32079f9413cb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be920cf0-edd5-423e-a7fb-8ffbefb395a5', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('be93d2fe-b4a0-4e48-a5a2-230d71434ff4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '5YRS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('be9a6ea9-fe74-4794-9443-9aa061b6fa9b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublicFactoryStore', '0-3 months', NULL, '0-3 months/mois  0-23 in. 0-58 cm  0-12 lbs. 3-5 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bea0d69d-f400-45bf-a5b3-0e4c9732b297', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '0-2 YRS', NULL, '0-2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('beab0875-5967-49d7-a60f-b2ec68419979', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('beaf297d-c1f9-4781-ab18-340fda3bef52', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18 TALL', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('beaf74ae-804a-4a98-ba64-71a94e8c371f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('beb1e2fe-4556-4f91-8aaf-fafdb7136657', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bec71257-6703-446d-819c-df825d7682d0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X 34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bec95505-1e3f-49b3-a461-bed3c1e2d949', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '27', NULL, NULL, NULL, '165/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bed412f2-a61d-483e-8fd3-b6abefc0c004', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bed68820-ed80-4d78-b713-17f6837e5f5e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bed76ca4-23db-4132-b493-86183dfde0dd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 D', NULL, '34D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bed89694-96e2-45c4-b3ed-ec313368b5b3', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6+', NULL, '6 TAILLE FORTE', NULL, '120/65 - 6岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('beda8d33-d55e-4250-b53b-c1dae8cd4dee', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '18P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bedab0f3-e846-48db-b918-906f064d2e24', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '185/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bedd278d-5b65-4185-a890-2a6908f2cbce', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bee109b6-ce1c-48df-8269-60076e3c64cd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf0777a7-566c-487d-8b86-11d8622a6b39', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bf136430-bff0-4c06-ac99-8ab3514fd5be', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14/32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf2172c4-2632-40d1-989b-34ff01790754', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bf2ff4d3-cf61-4fa3-88bd-32cf4b528812', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-6MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf3076bc-3c10-4f20-a6da-be257a86265f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-6331-d8ba-438a49af2b55', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf3d5576-4ee8-4eb3-a505-5473b4b6d886', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bf460534-f10f-44ec-9ed5-e1c8f845dedc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bf4c47e3-54a4-47c7-88aa-07d042662635', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '175/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bf4d98d1-c8a0-4b1c-9318-d1865d2be50d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf4f12ca-05d2-4603-9a85-f19116dff946', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8X29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf58f93d-2360-464c-84a6-c7215d3e89a3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf5a8bac-40ab-4598-8f26-218b9c26361b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-b404-5ce0-c85cc3b25989', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '54-58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bf6cb0d9-30f9-421c-91ed-1b2981dad5e2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf6cda62-4fa3-4051-be50-f426b574f725', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 PETITE', NULL, '6/28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf6e5063-dcc4-4ec0-b046-2b7176c66f22', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'NEWBORN UP TO 7 LBS-Notuse', NULL, 'NOUVEAU-NÉ JUSQU''À 3 KG', NULL, '52/40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bf6f182b-6bda-4603-a1dd-e5a57088fe2a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7', NULL, '7', NULL, '130/56 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bf80469f-2567-447e-9562-b662319651e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf85f7ec-6c79-47b3-bc7b-d25b51dc76b6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XS REGULAR', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf906df7-bee9-4403-9c52-358a5f3d0563', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 REG', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bf975d24-f544-44ba-b982-c4a08b910030', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12 MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfa52fd7-a85b-4280-bf81-c4d535ee2b32', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bfb6d1c5-78e8-4713-ba68-930a09474d7a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfbc89bd-b5e0-4625-8f95-8cce8c981400', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 A', NULL, '20 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfbe1e5c-58d1-4edc-b7ad-404a70221b0c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfc5b833-447c-436e-be73-1a9424777f73', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bfcfb8f3-159d-42d8-a663-d05138cb321e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29J', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfd272fe-0169-41e2-a7d4-573035f0c76c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bfda9520-36ba-41b0-b33e-6c42f61e5e74', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '23P', NULL, '23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('bfe157b2-ddcf-4318-934c-e82cbcb9e0c8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bff1120f-2652-4763-a224-83206a339d2d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28 P', NULL, '6/28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bff21ce1-512d-43d2-8198-646b48c6d54e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '3X/4X', NULL, '3X-4X', NULL, '170/154C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('bff49240-577c-4dcf-b238-dc6c072b9dca', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-6620-9086-22c0270c80bc', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('bff62dbf-02a5-47e7-b153-c4fb20fe3481', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X 32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bff78f01-2feb-4329-88bd-ff9a54954372', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 LONG', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('bffb8d08-be1c-41f3-b722-69efee2eee5a', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10', NULL, '10', NULL, '165/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c01f3cdc-cc1c-4a75-af60-59bacf483245', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/ 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c01fcb67-ccc9-4ffe-a9c5-cbec59739e6f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X28', NULL, '32/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0287a00-bfe5-4162-8427-ceef1fe82bdd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 TALL', NULL, '14/32 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c03509f2-ef70-431f-8748-f74a3ca193aa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 REG', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c03d78be-58cd-42f5-9978-f21405037700', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c03eefa4-8854-42b8-b5fe-5897fff89cff', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', 'UP TO 7 LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0407788-409e-4de2-b8d1-e1744e53967c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 T', NULL, '18 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c045ea12-4d54-40c7-952f-ef0eaa641bd1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '4YRS', NULL, '4 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c06b3e64-fd3f-41d3-a438-b4838ee5a491', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c085b5cc-b811-4110-be07-8eea619db5e3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c085f785-1f00-417e-8406-36c0f58e4de5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c08a05f4-a27f-4d3a-9f93-fb956a71eeba', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c08a7083-1dbe-4d36-89b8-603178cf0a91', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26/ 32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c09c7e18-a1b1-41c1-b993-cbde0c2a3362', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36A', NULL, '36A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c09f0c5c-97e8-4869-960c-2672b61c1462', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c0c5569b-3852-4291-9da0-142e92750de4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c0c84286-1d94-472e-b72d-ddc196f745a6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL PLUS', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0cb8f10-df8d-41e4-8d63-ab9d9742f56e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0dd7160-ddd9-4fa9-bf51-d27183d8cf8b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'XS', NULL, 'TP (8-9)', NULL, '160/66', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c0ec4fa3-1068-46ae-8423-135b48caabea', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1016-d539-c4328a2f8e84', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0ecb480-b78a-4862-99d0-25c93fbd1182', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL +', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0ed5ca7-5125-4641-b28e-4bd1fd8209b6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-3040-560f-b95803c0b112', 'Gap', 'S (6-7)', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0ed9349-60b5-46ec-9483-15f6c07de064', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0f37775-fcf7-4cd1-8f84-9ae6df4a6619', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0f3d2bc-1473-42e3-bf13-262d854aa3a5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16L', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c0f500d9-2d20-4814-bbf9-43ffa24fcc04', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '1/2', NULL, '1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c1007815-c888-448c-816c-f57e5f094765', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6R', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c103f218-14ad-4a3f-94dd-64abb70957a9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS/P', NULL, 'TP PETITE', NULL, '155/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c107d8d0-b2af-4e1b-ad40-0d40ca7f9524', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS/P', NULL, 'TTTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c1090a75-b09b-41c6-92b5-d1ae381b9bf5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '26/2 Regular', NULL, '26/2 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c119eb66-633c-47c7-8cd3-2459af1905b8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20SHORT', NULL, '20 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c12702e2-bd48-4061-a844-3d8e454e6742', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 REG', NULL, '2', NULL, '160/90C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c1288190-6905-4e3a-be00-c04f11b4cceb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40 LONG', NULL, '40 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c14dc6d1-33bf-47d4-b1c2-00c20bc814c9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '18 Petite', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c1510d67-3cc4-4ca5-8c4b-0c023e9d8279', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '00 Petite', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c155fbcb-38bf-489c-9ba0-7929da40315e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L REGULAR', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c15e701f-ba07-4ce6-b3fe-35173d51b87e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c16a62c4-1249-434a-99ae-bef9b534cd42', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XL/T', NULL, 'TG G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c17053d8-b605-4961-a837-a55014f9e837', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6 PLUS', NULL, '6 TAILLE FORTE', NULL, '120/62 - 6 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c172521b-bc35-4021-b5c6-751cc8ef2737', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10 HSKY', NULL, '10 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c17c6105-dcf2-4af2-bcb9-e162ab14d957', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c17eb8b1-60fc-4aef-a37d-8824febfb8cc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXSP', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c18bb7f4-21a5-42e9-a995-52680d1b2237', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXL REGULAR', NULL, 'TTG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c18c1421-b2e2-4d3a-af86-3c7663ee3836', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00SHORT', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c18e1d2b-f356-4cfb-9864-d701e08b4fbe', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c1999481-e3cf-4c22-a0c2-b8ba7716d80a', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30X32', NULL, NULL, NULL, '175/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c1a4e491-635d-4742-a757-b203643d69c6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2T', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c1be5715-b627-4d40-954d-0c17bf9488c9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c1cb5b16-d9a9-4f70-9ce1-c48f143673cd', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '20PLUS', NULL, '20 TAILLE FORTE', NULL, '165/81 - 14 岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c1dbd3df-b304-46dd-9d3b-ae0a6bfcea33', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c20199ec-79f0-4e81-ab0b-d587f8b1f099', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c20a72c4-4e1c-4f01-a571-8e487615667d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXL T', NULL, 'TTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c20f4a9d-e331-4d04-b019-6992f40d5707', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '29 TALL', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c22cd8d4-37c0-4ffe-bf78-76641993225d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '24 SHORT', NULL, '24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c22fe20f-21a6-4e57-893a-f2d085c4b911', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S PLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2301519-0d19-451a-b5a7-a7015be367fb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000X 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2359ae0-1c79-409e-865d-0a7e9c5c2a0f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '46D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c2460b87-359c-4061-a22a-e75c99e04354', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L PLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2565bdb-58be-4dfb-bf9d-d79924ca1265', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'XL17-17 1/2', NULL, 'TG 17-17 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2666fa9-fcb9-41c2-9db1-7f7a38983fa0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'XL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c273999f-5e0f-45f8-a9af-c76bfef70e04', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c2874874-08db-41a4-83db-1c1a74ae8b60', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '33 TALL', NULL, '33 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c2a62620-ec91-4992-9600-08f50daacf73', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXLHUSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2c24a9c-0540-438f-97eb-43458bf2720f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34B', NULL, NULL, NULL, 'A75', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c2ce9828-f9db-44d6-993d-ad21ba836cd4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c2e6746f-d4d1-4eb0-9b3e-92c4fc884259', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12 SLIM', NULL, '12 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c2f19d1c-3f90-4205-99f4-8ec40106c840', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '12P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c2f43b21-e2de-40c1-b7f5-036d1c2c3943', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c302aa6e-c4ea-400f-9438-36553157bc1e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', 'PREEMIE – UP TO 5 LB', NULL, ' JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c30a2a66-55fa-4456-a506-3b291fd26a49', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36DDD', NULL, '36DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3148fe8-7a42-4c91-9c2d-5ded72512dba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 SHORT', NULL, '8/29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c317f4ec-34de-40d8-a8c2-ddce9d92621e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c34f8c98-5c1f-475f-a3db-a84d8cd1fc2b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-e413-e823-ad5042a060ad', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c350479b-22d1-4498-b0cc-c7b004753e80', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c35bf0b2-263c-474b-bbbd-01484086ebe4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c369adf0-1bde-4f0d-b922-75465309458c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '33 X 34', NULL, '33 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c36f61cb-3d70-491f-bbf8-a99ed6878eff', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3786607-38b0-4c9e-a9bf-ad98fe670301', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 PETITE', NULL, '2/26 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c37e262e-11c4-4801-93fe-120796b22364', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '16 TALL', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c37f058f-662f-4b42-84d6-40d3be1af5d5', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c37f7dbe-2e57-48a7-adfa-a9c04169796d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2T', NULL, '2/26 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3862cec-524c-45e3-abd4-be3023a55a54', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8TALL', NULL, '8 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c38b3f43-ee85-46a1-9db3-dd5c222a537d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 X 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3a6737c-835d-440c-b6bd-fe93f5f8ffcf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6L', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3a8b7fb-91d2-470c-a9c8-10dcab5f34f7', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c3aa6b1d-661f-4218-92e6-77b212c7cada', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46R TALL', NULL, '46S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c3ab8f79-4b22-4666-ae9a-d88ac3b2ba6d', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c3af1a3b-b2b1-4a25-91e0-8adb3d5dd16e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8 REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3b01935-e808-495d-914d-ecd048f0632a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3b275a3-8cb9-4848-9b43-f789542b383a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7d68-c07a-b92a3815bbb5', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3b54962-0b1e-4cc5-8a0f-c140b6e1185c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c3b7ac81-383e-461a-8566-df5fead8ab29', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27 TALL', NULL, '27 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c3c1b682-fa6e-4537-b3ed-3915e2af5fe2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5b49-14b8-c57b35a022e2', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3d58c9b-2c4b-4076-8716-88e07a7f2dd6', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS REGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3def222-c04b-4cf6-a1e8-212f09108b42', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XSPLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3ea96e4-6a51-4453-b289-3d09f85b16ef', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS', NULL, 'TP', NULL, '170/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c3ebdbe6-07b3-41c1-9060-4a6cbca3e46e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31/34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c3f3cfa1-c450-4ec2-81b6-f62eae5b9241', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c3feb0ae-8095-4370-9abb-9377e52c8069', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c40649e2-2e22-4560-929a-eca19f395bfc', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '18 SLIM', NULL, '18 ÉTROIT', NULL, '160/ -14岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c40653b3-4f9e-48f8-8bd1-5b1b30526001', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c40dfd20-f45c-42b2-aaba-6d1491f4b423', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30 T', NULL, '10/30 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c40f0ca6-28e4-4cd0-b90b-a72f5884f294', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 AA', NULL, '36AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c431f624-ed19-44e0-870a-fd527f8ca175', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000A', NULL, '000 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c434fea6-568f-484c-ba68-4dbb6adc9a59', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'XXS ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c435ec29-4427-4c96-83a2-9609810ff80a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c438c208-e478-4a3d-a53a-9ff383156a80', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '11/12', NULL, '11/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c43a2b44-9546-44bd-b5ef-f3c5a0bd071d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c44dd8b4-1764-4603-b033-0eddd015fb9f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c4568fb9-e2fd-4ee6-9f28-651dcecb0c02', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4803910-2c90-439c-9d6d-b7413a7223b7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL P', NULL, 'TTG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c482c7d3-e5f8-4b94-a571-056c27ad57e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10 T', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c48423e7-a06d-4fed-b1aa-550b0a7c1d11', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '24/00 Long', NULL, '24/00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c484b654-da49-47a5-a625-8fa7ffce7fda', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XLHUSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4868736-f2ce-4302-a381-24dfc2ddd348', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16/33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c48d6e14-d2c0-415d-abc6-8cfa3ebdf938', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29 LONG', NULL, '8/29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c49b48b3-de27-4d3a-999c-63528dc30376', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c49d9064-dd4f-4a96-9ac5-987e823ff0e3', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16', NULL, '16', NULL, '170/112C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c4a835cf-26db-4b77-968d-e4be9496da61', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00 LONG', NULL, NULL, NULL, '160/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c4a9078a-92dc-4e8c-b3a4-b1f5faf6bf2e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'XS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c4b7008f-57c2-4258-ac83-265500abe348', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c4b7840e-42cc-45e2-8cd0-3fd425f9baa1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e943-0e10-fa44023e6216', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4bfa6dc-a8e0-491c-a059-9fa5995e30bd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16 REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4d642cf-5893-40b0-8c52-bd2e806eb7db', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL R', NULL, 'TTTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4d679f1-279a-45af-9a78-d2d8232801bc', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-b554-462b-291d8f62b33e', 'Gap', 'ON SZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c4e3c9fd-df40-4000-8147-6df46830ae40', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '14 TALL', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c4f53253-6dbe-40cf-8234-92b3873e3573', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '6 TALL', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c4fb99de-3e4a-4fbd-a2ce-9ad9fd254f90', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c50cc47b-8cf9-47b7-b95a-a3a504fc41e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16P', NULL, '16/33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c50e2c48-2683-498b-aeb6-58b571090194', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/ 36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c518b67e-3e35-4538-8ad1-03ef1773f135', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23TALL', NULL, '000/23 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c519a672-c19f-4b21-b16f-40659aabf74e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '29 P', NULL, '29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c51a9962-0c90-42ae-ae1a-f7eff9bfe9c8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c5223aa1-a6db-4aaf-aca1-5a061305558b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '25/0 TALL', NULL, '25/0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c53d5537-4d77-4dda-8758-835cab98b3fd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33REG', NULL, '16/33 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c53e658d-f018-4860-ad79-6e0caa8014bd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c53f6b3a-6bf2-431f-9182-efc5aaa462ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c53fe8c1-c1b6-4022-9e83-55fd64928a52', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '160/80 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c54866e5-ed3b-4353-8914-658cf3f8ff37', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '16 Short', NULL, '16 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c54a2dac-26ae-4e6f-a842-2cf4bd051218', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31X34', NULL, '31X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c550fe1e-1ef0-43d2-9845-18a8c14275b2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-49c2-60e8-0bb146df8a52', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c556269c-1934-4d6f-a0f2-8ef3c230733b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '30/10', NULL, '30/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c559de67-b898-4fd1-a53f-2a6a7b7f9011', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XSREG', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c570af0a-497f-44f2-b9bc-7cbef6198836', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c57b4ac5-7eb8-4103-a511-7248f61ae22e', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c57e100a-b4a3-4243-a76d-e58e55daa46a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c57f4005-778e-41d4-b22b-f3ad88d43f3d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 / 32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c5927c13-eaeb-4642-8069-dd14568ba903', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c596277b-9f12-44c6-98a5-f5a8fb8be5b2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c5a0d8b0-8333-40d5-b0cf-a6306a7fd5aa', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M', NULL, NULL, NULL, '165/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c5e9ea9c-7829-44c1-be58-d04ebdfb2a4e', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-7e23-c9ab-a510a4eda674', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c5ea5d32-77a9-4aab-8d98-57acb510a1c4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL/P', NULL, 'TG PETITE', NULL, '165/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c605fe90-0771-4889-a471-fbf767fd28f4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X 29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c61c89ee-8f44-4ed6-ae32-a12d6828d3d6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c61e83fe-6e71-4498-94bd-2521d07a37bb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000R', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c624f726-c6de-4f8c-a756-81c57531429f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000R', NULL, '000/23 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6322f09-a4e8-4f85-b22d-000d83ba5d4b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c6336742-b9b7-42f0-80e7-4b8382c2fbb0', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '12', NULL, NULL, NULL, '180/70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c6432190-99c5-4267-a115-077a94a96a87', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24/00 Long', NULL, '24/00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c64d566b-c2a6-4872-bb58-e39874e003f7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 / 32', NULL, '35/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c64f1442-3d94-4eb9-8aa0-e44c7fd9d1d7', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '52X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c65192ab-467e-4d00-ac7f-2828ab32cdb6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c65d6584-f729-4d7c-a46f-9cc8da1c65eb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '27P', NULL, '27 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c664486b-9370-478a-abc3-b7934e7a76f4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6 REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c664f4d3-814a-4e3b-a1e5-ac1d41f9224a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c67264cf-02f7-4daf-a48e-c0edc4b62f43', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c67668c4-0735-4670-9862-d24c02a4740f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2L', NULL, '2/26 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c67d1d99-f15a-4317-af76-f0633ea6cac3', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '46 LONG', NULL, '46 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c68d1f41-4b4e-4e13-b11b-aaa6d8127e1a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '6 TALL', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c692c268-fbbc-4c1f-a83c-db00ea04c591', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6952f6f-6217-4555-8df7-771edee186da', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '44', NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c69a0736-703a-4c94-a0ba-cfef1fd52892', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '11/10/2024 12:00:00 AM', NULL, NULL, NULL, '290/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c69cf1f6-c05d-40f8-b235-4f7347896fe3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6 M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6b06873-531d-4023-8369-2f0d5e5d1bb5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-8f15-c24d-1d0efda659dc', 'BananaRepublicFactoryStore', '31/12 Long', NULL, '31/12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c6bdd41e-fbf5-47d0-aa0c-c3caf06f5e0d', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'L+', NULL, 'G (10) TAILLE FORTE', NULL, '140/80 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c6be2c81-4df2-4489-9817-23a05d1b1c9d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-083d-6afc-cf1b986accb8', 'BananaRepublicFactoryStore', 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c6c2cb99-4309-4d4e-80f2-b3bcfb99a191', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L+', NULL, 'G (10-12) TAILLE FORTE', NULL, '140/70 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c6c72b4a-f5f6-4adc-8f51-53b843a11d60', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6c9ef6e-f590-484a-9c25-d1ba228a5ad6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXL SLIM', NULL, 'TTTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6d5fa62-4d84-4952-a990-065c03925143', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0LONG', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6d8986f-9b58-422f-ad70-f90c03c4b07c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublicFactoryStore', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c6e488b9-9079-4c11-839e-91ab0b6e7c6b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14 SLIM', NULL, '14 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6e7b42c-f659-456b-a506-749b36879356', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '30P', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c6ed176d-6c57-4b14-92cc-67f39d2acffb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XSSLIM', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c6f97c29-47d7-4254-a7e7-f55202d8306d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bec5-de88-f6ec558ddb30', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c703f42e-d688-40bb-822d-a58055674fe8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6 XLONG', NULL, '6 GRAND', NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c7114c89-4365-495f-9b98-3d53a2faab42', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXLHSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7161947-4cfa-4b2d-a8aa-c8eb5621b5ba', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c732d3dc-5789-44ac-aec5-4bcdb6522661', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7345bdd-adde-4cea-8400-0b05453612e9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '4-5YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c747361b-0d01-402a-b103-1f6585faed5d', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '160/170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c74e3af2-13b3-4a01-867d-ae2deebd7062', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '28/6 Petite', NULL, '28/6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c75305c9-6cd5-4c08-9f4e-f67e44fd7985', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXLHSKY', NULL, 'TTG (14) TAILLE FORTE', NULL, '155/75 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c756523d-f877-46fe-a4da-f87b39d21d11', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '165/72 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c75b4b11-8ae7-408e-816a-02296db3b540', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c769ef37-cad1-44cc-ac6b-293e327423e2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '26/2 Petite', NULL, '26/2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c7702b5e-f3ce-466f-81ca-31449734214d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'XXL', NULL, 'TTG (5-6)', NULL, '250/84', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c77411c9-2f1d-4c57-9e5b-2973783aea2f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X 32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c77a64b0-822a-455c-8715-899bd20acdb6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14HSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c77c08a6-ded8-49ea-ae01-5701e7ba33d9', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14 LONG', NULL, NULL, NULL, '170/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c77e6cc9-44c0-4160-b4dc-f2221f71d6bf', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c78339de-1a67-4beb-a145-9d8f25f665a4', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '33 X 34', NULL, '33 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c784e03b-23e6-4f6b-a638-b85960e6e4b9', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b6aa-d5ae-d0752f615306', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c787a0ed-e4ed-4bf9-8882-995fdd49974f', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c78f5f14-33e4-4654-9fc3-52161b40c298', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '26', NULL, '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c7917128-eb7d-45bd-b4f4-5f665eba77aa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'XXL', NULL, 'TTG(42-44)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c79895f3-e5ba-422a-9f24-8e8de121ec6a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c7a7f631-240d-4190-8f9b-e7deaabd59ca', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4407-8b9e-a6afa1319c44', 'Gap', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7b8a561-1d9b-4aff-8ce9-c894de25d932', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '26 / 32', NULL, '26/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7bf2785-2c6d-4454-b7a2-b586cc6bf837', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '1', NULL, NULL, NULL, '160/84C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c7c494df-d9ed-4bd9-b09c-48d2d0d08805', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '10.5', NULL, '10 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c7c91c4e-9b16-471e-9f9d-0036a8bf1de7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXL SLIM TALL', NULL, 'TTTG ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7e0796d-3a55-4f70-97e7-36a62a6a316e', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '12-18M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c7e26eb1-4917-451c-b9bf-bd6c1508b64f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('c7e724f3-4049-4e39-bf03-fd8f4de305c0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7f09d45-dce1-414f-b81e-ce9ee957cfc0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7f1a514-2305-425b-95f9-2ac21c574c76', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18P', NULL, '18/34 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7f465d0-a161-481c-9589-ba29d727cda3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 / 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c7ff22c9-bb3f-4e3b-9e24-b05607a74c9b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 /32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c81bbbc6-eb9a-43e6-877d-07ba10755075', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '20+', NULL, '20 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c81d1ab4-098f-4b2c-8988-1e304fd00020', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c82061ed-da42-4163-bcb6-8f1f8f98d60d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c82c1d4e-4cd0-4665-8999-578106988c03', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14 REG', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c82eb145-7fdb-4dfb-8a73-9d9c93d326a3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'XL 18" 38 3/8" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c8367046-f895-411d-b81b-ae47c518f8fb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 X 30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c83b01fe-cb4d-4d3d-9b45-e4ab0cf19758', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18+', NULL, '18 TAILLE FORTE', NULL, '160/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c861e82b-40e4-41cf-944d-323abe1c47cb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000/23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c86a7bf3-60ad-4f45-b731-b13e8a9283d2', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', 'UP TO 7LB', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c86be051-9d51-4757-993b-5add30955306', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c87989f4-20d2-4f9a-9a51-328aeeb5191b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22+', NULL, '22 TAILLE FORTE', NULL, '165/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c88aa869-b067-4a8e-993b-d52643f6b0db', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XLPLUS', NULL, 'TG (12) TAILLE FORTE', NULL, '145/72 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c88e018d-417e-4a26-bf0e-6c02e32cf31c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31/12', NULL, '31/12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c89056e6-4175-4b92-ac01-4817cbca63e4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c892a72c-f631-4e03-8139-43ff9ab7faac', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '23/000', NULL, '23/000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c8963f06-be6b-4a70-83ec-99c27f4fa1ee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL T', NULL, 'TTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c89bbe52-1a47-40ca-a4bd-a1e94f40ea52', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '16 /33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8a26add-7a74-475a-bb77-2a531faee9ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8a81252-87da-4fe0-b8e9-ba7d4f8ee315', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c8b2581d-5614-49a5-ab92-75475b1f35db', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/ 34', NULL, '29/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8c5afb0-9ce5-45c0-83d2-f43927a762b7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8c96e89-b5e6-4cd7-9771-bbf6257aed65', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-c1d4-cbc5-e3c060b978e1', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8d210b3-2136-4c69-9d47-23463e8a0c21', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '42 Short', NULL, '42 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c8dbd0c1-819c-4f33-b650-7a662c084793', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20 REG', NULL, '20', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c8e2b87b-01c4-4c31-9353-87f7dc3594f6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'MREGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c8f3ea7f-cb0a-4f42-b2c4-e6c882298f41', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '24', NULL, '24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c8fe17fe-5907-44dd-9f06-96195363a959', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '28 TALL', NULL, '28 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c90cab58-3d76-437e-89c4-e146044b1cda', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c9149e2c-ba17-4e97-aa5a-8a603a0b9c00', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '14SHORT', NULL, '14 COURT', NULL, '160/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c9187f12-13c3-4126-9f2d-e2093e4d2204', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c91b45e8-4472-4b37-96a0-f59a3e81a4ba', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '14S TALL', NULL, '14C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c920991b-f934-4bf8-a934-c35cf2b9f847', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X 32', NULL, '28/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c922c20d-cf66-470f-abda-df5e4d370b55', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'SP', NULL, 'P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c92da5c5-3e01-47a5-bc8d-c66b5e8a8286', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '48X30', NULL, NULL, NULL, '170/122A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c9374a61-5c33-4012-a829-22a625b03ecf', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '23L', NULL, '23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c93d15dd-3075-46af-8037-fcda23ab7eca', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16 REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c94431b5-d410-4ce6-a100-6f8de727a340', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 TALL', NULL, '8/29 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c9591344-27a9-4a0e-bfe5-7a04b3d29359', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '52L TALL', NULL, '52L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c95c84a8-cff6-4f5a-a508-fc68ced3c084', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL', NULL, 'TTG (14)', NULL, '155/69 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c9607639-74eb-4494-bc7c-7c3d73aad341', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '10 TALL', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c9755295-252e-4e9f-b594-86e2cd41517b', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c98218fa-fffe-4d79-9a50-2bd61b667337', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c98afc13-d8ba-4649-8fac-4a4812122ea9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10XSHRT', NULL, NULL, NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('c9923b77-45d4-41d3-9fed-4f92db707292', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c99dde20-5883-44ec-a546-271ba8a13bbc', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '42', NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c9a739de-3626-4938-8079-44d7115693b5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14 /32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c9a9f778-635e-4dc3-8cf8-173f4cdb6eef', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c9bc6ad9-e4b2-4fa5-95ca-2b118a7ed7b5', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-2772-0f83-1ae9ec1022cd', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('c9cdb796-1c61-46e9-83f5-f2986a760f2c', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('c9e9bd61-dcac-492d-9b9d-e87a7c5e43e6', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '16 TALL', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('c9fdce41-f1c1-457a-9133-03f563700205', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '31', NULL, '31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ca0b950d-9983-4dcc-85eb-3c8e097086ff', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '30 X 34', NULL, '30 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ca0ca71a-e82f-4358-888c-ea0108ad3080', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00XSHRT', NULL, NULL, NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ca14c05e-bb66-4ad1-ab33-d93e7b528aea', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ca1ea737-74b8-41f1-a3aa-dacb2cc51fc9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8/ 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ca492c25-d68a-4d71-8190-59a9b24870f4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS REG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ca579708-7671-4e45-ac61-843312fd90ce', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32 LONG', NULL, '32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ca59ac80-9e84-46a5-acdc-5c1a0b657ee9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '34 X 36', NULL, '34 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ca603367-87a0-4efd-b631-2dc8cb2cacba', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '0-3M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ca65c2bf-45e5-4fee-8523-916a7b26a396', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ca785aff-0074-4cd8-b6be-b3aa62b2ee90', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ca78a2b6-65c7-4bb1-95f5-701bb5f94d1c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '26/2', NULL, '26/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ca8144b4-6a71-4b26-af6f-7e909eed1715', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XLPLUS', NULL, 'TG (14-16) TAILLE FORTE', NULL, '155/75 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ca8bf2cc-0214-425c-8534-289085043d1e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ca9015d1-e01e-4fe0-847f-ce2af27bbc4d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '18 P', NULL, '18 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ca978b63-cd39-4cad-a3a0-89d9406889c8', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'S+', NULL, 'P (6) TAILLE FORTE', NULL, '120/72 - 6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cab2607d-69c1-4d1e-87d3-6bcbfa34e61f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '26/2 TALL', NULL, '26/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cab713f0-b2bf-4622-81dd-f830ae1844e4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XS HSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cabb3ec4-aab3-4a82-933b-23060b4f57d5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44X32', NULL, '44X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cac33a7b-2cac-450f-a497-99132a7e1917', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('caebfdb9-6cbd-4f3e-9499-3dcb8614138b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34DD', NULL, '34DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('caf68821-f90e-4970-8afb-365076434d53', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 / 36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb061336-cac3-4c00-90e2-ef59fb77b82a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS +', NULL, 'TTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb06aab1-1dea-478c-a22c-21eb993a0b98', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XS', NULL, 'TP', NULL, '170/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cb209a30-707b-46b2-816f-140ff72f56ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00X24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb35e41b-4e92-41f0-9215-0c5255102069', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS PLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb378636-ea5e-432e-b369-048f8803dde3', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '2X', NULL, '2X TAILLE FORTE', NULL, '165/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cb4124bd-5e48-4bac-b643-ab6b9530d3b9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb45348e-90cf-479e-85ee-7297f39c29d9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL HUSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb4741b9-891f-4955-b789-c820bdfb22c3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10P', NULL, '10 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb52343f-bc79-4258-acb5-86f77a6c450a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20XSHRT', NULL, NULL, NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cb5312e3-763d-413e-ac32-bb7c2c4d5cd9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cb5ab764-e205-45d8-a3d9-5e6fbcfbd2d4', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb61a8d9-1340-45da-bc40-4fa616bc050d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cb6307c3-e006-4589-a212-c8e4ae820e99', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb6964eb-af38-42be-bb25-3cbb2bc710f9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cb74f6dd-d622-465c-9c68-b37508913325', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'M+', NULL, 'M (8) TAILLE FORTE', NULL, '130/76 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cb875cc8-050c-4fe0-94ec-31d8ef0b13f0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XS/S', NULL, 'TP-P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cb875f27-a88a-45c3-8fbb-b2042c54a788', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23J', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb994e78-a4e4-4069-ac2d-fab97ef5b172', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22 S', NULL, '0000/22 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cb9a579e-237d-4f71-869e-5b9877f4b3c0', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-2282-7614-ed7706e671c5', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '*******', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cbaf25d4-2f2d-473d-8860-226fe365c3de', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '33 X 32', NULL, '33 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cbb308a0-a6c7-4c2d-90ae-d87e326675b0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS+', NULL, 'TTTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cbb6b770-5275-4283-91ba-8e7fa0ef83c1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 X35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cbdb3e44-a3bd-41e9-bc98-414f7aaaf397', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL REG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cbe1f223-b2df-46df-83db-292c540512bd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '28 P', NULL, '28 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cc0417c3-881d-4a79-99b6-098aaae0e762', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18REGULAR', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc080387-5285-4100-bfed-2da7036dc5d1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL REGULAR', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc0ef925-554e-4f5f-a16e-5f62df821249', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26 R', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc134bf5-3aa7-4987-94a4-2c2291383db9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc14ac87-7e13-4230-8e98-40fe6eab1efa', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '27/4 TALL', NULL, '27/4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cc16998e-ee23-4930-b5b3-ed12a76d775c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14+', NULL, '14 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc2f1211-b08f-41d9-b1d1-9307959f4f33', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '28+', NULL, '28 TAILLE FORTE', NULL, '170/148C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cc3e262f-7cb8-422c-bea9-ff360eb9e5f6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32 R', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc4084b5-4d01-4636-9e94-8632bdc6659f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-9 MONTHS', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc673964-c411-4b2d-8b68-85a1174c1a6d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 D', NULL, '32D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc67d3c6-43a3-4d92-8eca-944bc2d826b3', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc6b4485-b793-42c8-b642-48dad680a826', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc6df3f5-dc74-4e46-95e7-28062be08977', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cc739ce6-7de9-4380-8935-a666691277f5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5d1-8b1a-6681f41aed59', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc80f87a-0b5c-4900-9ee4-80afbacbabc5', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cc85a3df-c9b2-4f80-b3a6-1b14c07cc9c4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '31 X 32', NULL, '31 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cc90063d-b2a4-4c22-9380-4db0b70f43e4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X 34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc9346af-9f95-4905-b824-9daf99f12a9c', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cc9bf746-9d6b-4dfd-b7ef-43b4332bca5b', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cc9ccde4-3ace-456e-b4dd-fa7b0bbd30b3', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '4', NULL, NULL, NULL, '230/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cc9d7d0d-46ee-45b3-9644-bb5283c5bb1d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30+ REG', NULL, '30 TAILLE FORTE', NULL, '170/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cc9f7499-3b75-47a0-8a0d-40a43d7e4995', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16P', NULL, NULL, NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cca30108-3081-4e8c-9beb-6dee0d6c2f17', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'LHSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ccaecb00-863c-418e-b533-4853e26de4af', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28+SHRT', NULL, '28 TAILLE FORTE COURT', NULL, '165/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ccb1c487-c638-4c80-ac39-4fe10f728931', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10T', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ccb2b937-5268-4a5c-a5d4-a7c3220f8e73', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1X-2X PLUS', NULL, '1X-2X TAILLE FORTE', NULL, '165/128C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ccc15a6e-a1d0-4b35-9fce-4a42d1e818e5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L', NULL, 'G', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ccc594d5-f435-4878-b40b-b14efa00b08c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-457d-6d07-4b1a19f3d72b', 'OldNavy', 'S/M', NULL, 'TP-G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ccc96f4c-b8cf-4253-9ea6-c974b1c82cc0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cccb0613-1d82-43bd-a51e-b8fef72f2e27', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-59c4-1a32-c170aca4803c', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '25-43 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ccd39bfd-863b-410f-8990-25afd3b709e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 / 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ccd626c5-ca9b-4591-9e22-6b4be2c1dc03', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20T', NULL, '20/35 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ccded077-82d9-4be1-9b62-aae1e42b3758', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24 L', NULL, '00/24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cce04a9a-80c6-4fe6-81ee-d30c04cef3c0', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '185/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cce06877-a7c4-492b-86a5-30f5eb7f32e4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '12/13', NULL, '12/13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ccea47e2-11c6-4516-af07-292d4be66cd1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '46 Long', NULL, '46 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ccf638d3-0564-42e1-9cc9-9a0001fd7c8d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '42 X 36', NULL, '42 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ccfa7715-aa74-4b98-ba85-22271912fa90', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd094608-d186-463e-b02d-88043f85639d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '27X30', NULL, NULL, NULL, '170/68A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cd0de6e8-b0d3-49d8-a003-6c5c5011e839', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 LONG', NULL, '6/28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd12d61b-108c-49ea-bcdb-7f8c92787141', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '2T/3T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cd2b3cf9-1744-4e97-aa26-3646f467d98e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXXL', NULL, 'TTTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd2bf43e-49d3-474b-8d41-f0ee10b2c8c9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '34 DD', NULL, '34DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd39f0a2-93a7-409f-bffc-086562d13cb3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublicFactoryStore', 'S', NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cd3a0a4f-4b67-4787-bdea-cf92e6ed2190', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '6', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cd3b8d25-e64a-4355-93ad-27516ea07c14', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '12P', NULL, '12 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd40c07d-7331-4893-ae61-3911a5517363', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', '2X/3X', NULL, '2X-3X', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cd4145a5-ae78-412f-b4af-7febc30d51ad', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cd421f2b-35a9-4e38-89ed-ae8b8aa1d2f5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '32S TALL', NULL, '32C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cd43392d-867f-4f3b-8d3f-27bfa3252657', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7dcb-0ca5-19fb6787a519', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd4ff55d-1ef3-4971-8735-7312ce22971c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6 PLUS', NULL, '6 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd5a4a40-7d82-4e35-b74c-865b839443f0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cd6cce3c-ba55-440f-8290-91bdb4e3c3f0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-3dbd-7cf0-fc3d70abc36c', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd703128-014a-4d9a-a3dd-68fab4795863', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cd82ea55-25d7-4a09-aa13-1ab93c76db47', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44X36', NULL, NULL, NULL, '185/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cd95adc7-5da8-441b-a281-5b089755262d', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '12.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('cda38c24-6e75-480e-b033-a41b219f176a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cda7a827-c891-4c76-a629-012fb2371f7a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '18X34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cdb9f179-fc44-4446-b793-fdb5ab44d076', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXL PETITE', NULL, 'TTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cdc15958-965d-4a2d-9ed3-2bd6bdb82a4c', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14PLUS', NULL, '14 TAILLE FORTE', NULL, '155/75 -14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cdc99185-c273-42a6-a321-6a9ce3f0a420', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '31', NULL, NULL, NULL, '170/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cdd23641-b974-4588-a95b-04b1b3f0abfa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS T', NULL, 'TTTP G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cdd4ba49-2f52-4500-aa36-e8a9b510f38f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XSREGULAR', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cdd62d2a-95fd-4e60-883c-6a227ae9b59e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25P', NULL, '0/25 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cde3157c-0bb2-4992-a455-d8005a8fece4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '4 Regular', NULL, '4 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cdeb0f7a-87ed-4c9b-afe6-41bb2905795d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '27L', NULL, '27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cdf32ebb-c596-47d6-a1e5-a2b5446317d3', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cdf72fdb-da63-4f39-8e70-fe32a4d63d12', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 / 30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cdf802d6-f840-4380-ae95-8124a3e202ed', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12PETIT', NULL, NULL, NULL, '160/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cdf911cc-a186-4fee-a654-fc6c18e92632', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublicFactoryStore', 'XS/S', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cdfa3dc5-80f8-43ff-8fb5-77aa02d5af64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38 A', NULL, '38A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce07f89b-0aae-4422-af6f-9eb3984bd97c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ce0b223a-7c50-4426-b1ee-98e1d40c40c2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce1d9273-f71e-4482-8353-aaf6ab000f84', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'SREGULAR', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce1ff6d6-a5f7-4965-915a-12673b793e9f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXL REG', NULL, 'TTG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce210062-72bd-4e9b-bc3e-f813632f2763', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS REGULAR', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce2576da-16df-4a14-8468-24aeb057e692', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce319f70-c294-4968-b4f0-2ffb6127fd7a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '24L', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ce3aaf10-cd97-4055-b28e-48428e09ac15', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'M', NULL, 'M (8)', NULL, '130/62 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ce3f4a41-1d7f-4d9c-ae70-40c39813f759', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '1/2', NULL, '1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce5b862f-7c5c-48b7-a31d-2373da5905ce', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16 SLIM', NULL, '16 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce5ee0ef-8050-4e9c-baef-bf9cdf060fb9', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '12S TALL', NULL, '12C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ce69b3b9-d6af-4cfc-85ab-3d51c8761bbb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32 S', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce7933ea-7bc2-471d-9e2a-90f736572ee6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce7b35b9-7186-4d24-9903-0e0336b97b79', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-a9e0-c5bf-9be9c8037172', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '185/200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ce8b04c7-7eb6-4bf1-a3ee-27566aa55d3b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'S HUSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ce8f9ef8-c12b-429b-af5a-d423e4626b7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL +', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cea3a090-f3d2-4c47-b761-76998be5042b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000', NULL, '0000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cea4530e-5560-4d82-9a2a-70a62827b1ce', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ceaba983-135a-4c7c-ad6e-054f17fea33b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '2 YEARS', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ceafb080-6843-456a-8b8d-bc7719ed7492', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-ff5b-9d4e-c827ac82c155', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cebbdf23-0427-478e-a8b3-59093be4226e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '29X32', NULL, NULL, NULL, '175/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cec55f45-4492-4016-a504-9623e428d2d7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '16P', NULL, '16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cece7530-a207-46a8-b42a-de03a1af70a3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7REG', NULL, '7 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ced4278c-f2a3-4b79-a405-95a53d25e4e5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '16.5 x 34/35', NULL, '16.5 x 34/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cedc1bf9-9b1e-4918-9a45-baebda69f35c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '24/00 Petite', NULL, '24/00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cef66c44-c515-4ae2-9e54-557d0cd852df', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cefb28dd-3042-4b14-96fa-34376822874d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/ 34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cefc3c6c-3be2-4f38-bb52-e79557e93752', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M32/W12', NULL, 'H32/F12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf0029d6-4b42-48db-ba85-d7159adc1683', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-6a89-2501-9d7ae73292fb', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf02e512-b494-4cae-b79e-4bbcfada06e2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cf1d1275-9543-48bd-bf10-25d62389bd99', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS REG', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cf21ba52-5cd7-4a10-9df1-8c70af08ed53', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublic', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cf23c59a-8b1f-4683-a2f0-d27708a4ded7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 SHORT', NULL, '0 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf25170f-cda6-4c7c-91cf-e3079e6ebafc', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '9/8/2024 12:00:00 AM', NULL, NULL, NULL, '160/66', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cf31d924-6b72-4160-a31a-c12e7d5537a0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0000 L', NULL, '0000 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf326e78-3057-45f9-bc43-655117f47270', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'S+', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf438da4-d7c8-4d4a-bc53-251f047af0da', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cf4c7c59-917b-4bdc-a3b8-d100bd2ae9cd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf4faf20-e01a-44c0-a518-01f64bf9698d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27P', NULL, '4/27 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf504850-efdc-4942-9e0f-f4ed6197530f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '3/4', NULL, '3/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf536f18-574c-4fc0-9ad8-8d9e19b830e8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '8 Ankle', NULL, '8 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cf549454-8c3f-4ee0-a0b3-6e3024ba2916', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cf5d4b25-cbc1-4433-8b1b-da860ca33abe', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XL/T', NULL, 'TG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf7b2941-4d28-4c4f-a9f4-92ed73b15fe5', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cf85ab86-5116-449e-ade6-6d1b1e3c8bbf', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXLXLNG', NULL, 'TTG GRAND', NULL, '185/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cf8cb4dc-e80e-48a4-957a-492605a21ac4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf94435a-9a64-430a-a5af-7dee14c2d44c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cf9d41c6-3fc8-4d6d-8cea-e43ccceec0d2', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '0-3M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cfa2d413-2260-49b6-b905-402cf8368cab', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cfa5b4d0-802a-4856-9084-d818a26d1038', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000T', NULL, '0000/22 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cfae3be1-fd18-48be-939d-b6f49f875e30', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '5+', NULL, '5 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cfb58bcf-dbd8-4798-80a7-71bfb2d3ca70', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cfb67b2a-3099-4b15-b439-cd875fbc8a6c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26 T', NULL, '2/26 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cfba68ca-2d05-4962-bbd9-f0d9bd188fa6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XLXSHRT', NULL, 'TG PETITE', NULL, '165/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('cfc86619-1c97-4daa-8353-3e2188002c39', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cfd69b22-8465-4027-a437-ad4f974d28d6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32DDD', NULL, '32DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cfd69ee3-7444-4bac-9598-72a0fd91f6bc', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-be46-c9cb-405f42fc6977', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('cfdb74e2-eb0b-4a32-b6b7-bed31d158444', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '48 LONG', NULL, '48 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('cffd3faa-7019-44e5-80b0-e6a92b9088a7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 /34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('cfff8224-5936-4099-83ab-ae8991ca5202', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '25/0 Regular', NULL, '25/0 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d000aa6f-62d6-4155-a155-2c9842fd5db6', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d00218d6-4802-4192-affe-a531be56d273', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/ 36', NULL, '34/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d002805e-e584-4399-9678-8fe3112245d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0745-618e-918791902aed', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d005ccc6-d784-400f-9722-611143a5674d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X 34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d00d504c-19c4-4ac1-ba4f-2e41ba555b6d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/T', NULL, 'G G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d02011ac-1135-4d9c-acd6-265902d12aa1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31T', NULL, '12/31 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d03d1290-7deb-4f07-be1f-1cd7739fd258', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M/R', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d056940f-db87-4709-bf3c-7989aa2235f0', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '4 PETITE', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d05e6a6d-8255-4d53-a0c6-710cec06d3f7', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c72c-8aa4-ef1168b42d92', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d065d3dd-a0fc-47dc-8c0d-a5cde1e11986', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d06aabb5-1671-4fe1-9bab-1ee54fcbdc74', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1', NULL, '1', NULL, '160/86C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d075a1ed-9fba-4db8-ad0c-058f148d4701', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d07e3d38-5102-4dbc-aa76-96cf2b102062', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X 30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d086cdb0-1b48-4787-9ab5-8e53d58b75b4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2SHORT', NULL, '2 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d08902eb-d227-4941-bd4c-49ba0b861254', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18 SHORT', NULL, '18 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d08f7f64-4b49-46e4-b95a-8b74c7b5a742', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 S', NULL, '12 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d09d27b7-a384-466a-b8ac-c628c0663576', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-774a-90aa-e76eb32b6992', 'Gap', 'XS13-13 1/2', NULL, 'TP 13-13 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d0a9fc96-eac6-4255-b0b9-7af84d278719', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d0bcd99a-dca7-4194-8070-57366c531873', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32X28', NULL, '32X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d0da5184-011e-4eab-9c46-aa2e12a60279', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d0e06ac7-3ea8-4088-a554-5f6a46850d99', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '3-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d0f311cb-8387-402c-8d3e-be44dab39fd7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16 PETITE', NULL, '16/33 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d0fa701e-0e53-4ff3-885b-6809b065bf7c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'XXL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d104130b-0c8d-4c1c-9d33-16f5cc8ccfd7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4XSHORT', NULL, NULL, NULL, '155/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d1041981-f7e6-413c-b423-cbdc93948771', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d110d249-22ee-48a3-a869-e858e9ab2732', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26 TALL', NULL, '2/26 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d11a3cf6-4e87-46ee-8a74-ad673d70b20d', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublic', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d11e0744-e5cd-4901-9c52-a2bd330ff98f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33S', NULL, '16/33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d138f76f-3cc9-4825-a94c-06724c965a17', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X34', NULL, '29X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1393ea5-1bad-4262-805c-8fef12436bcf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d14178e1-68f7-4f9f-a52d-2a1ca82dcc34', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 / 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d14ebf48-bea6-4b8d-ab59-21cdb4452bae', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'BananaRepublicFactoryStore', '3-6 months', NULL, '3-6 months/mois  23-27 in.  58-69 cm  12-17 lbs.  5-7 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d15e6c6a-62bd-41fb-94bc-8d6236b1463b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-f595-0bad-a02861647b77', 'OldNavy', 'XL', NULL, 'TG (5-6)', NULL, '225/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d163e7f0-ab07-4a2e-a244-216d60ab2f96', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10REG', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d172734c-7ba8-4fdd-9db9-30405040b800', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '12-18MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1744391-bd57-4e8f-a6f9-ecb1b195e7a6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1879ab1-51fa-4f84-9413-8bd381e3cc4e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'S TALL', NULL, 'P LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d18928b4-3a40-4286-b49e-a08a3874fafd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d19441eb-5b1a-4164-8ece-63e3045847c1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d1a8d24d-bff2-4ba7-9d81-9e820fc8a063', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'L PETITE', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d1c7d043-94f2-4ec7-853c-2937af861c76', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e16-36d5-892d7cb07f93', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1c7f149-8c1c-4155-9cfd-117592b3722c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL+', NULL, '2X', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d1e6e3e2-cf53-4da2-928a-848a6ca858c5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c459-a695-1b0f4c446eb7', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1f0c0ed-224e-420f-95f4-05907eb150e1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00X 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d1f7c801-a64c-446e-a380-ffc9d481a078', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-435a-c901-c591d57a234f', 'BananaRepublicFactoryStore', '4 Ankle', NULL, '4 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d1f99e90-9686-4523-82e1-7fb4c7efc2fa', '3a0c74c8-3055-8590-30a2-d59a6faa10a7', '3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'BananaRepublic', '14" x 36"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d1fc2985-11d4-4beb-b727-3c8c3fe6071f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '30 PETITE', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d20baf47-352a-4eef-94fb-0ca0bb83a297', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 / 34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d21e4fd3-6ad1-4b75-9b9a-8afdb63ae329', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/ 28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2216b9a-7ca8-43e3-abd6-05ba064a122b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X 34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d22b8a24-4d7f-437d-b7ed-5b62f4947e77', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XL +', NULL, 'TG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d22c7eb6-815f-4e8f-9eb8-3f54aaa0f56d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10R', NULL, '10 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2325e8a-c209-4796-a423-90f5802ef9a0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XSREGULAR', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d23f949a-bf0e-4278-bc1c-d039a9a10c70', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 LONG', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d252f236-e7bd-4d4c-98fb-dab6b566558f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2XSHORT', NULL, NULL, NULL, '155/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d25d444a-05d3-4283-b6fb-5e413578c986', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30+LONG', NULL, '30 TAILLE FORTE LONG', NULL, '175/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d26a4329-26f7-45a4-a466-f22d5a2e0177', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d2808750-6dda-4acd-8443-502d4a1a8284', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d2815bb0-b9af-477b-86f1-68001f36f4d0', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d29035cb-4e50-4408-914c-fcf3c90439b6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d29042ce-3bda-46a6-aade-6ee6ff2b4afc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8L', NULL, '8/29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d298efde-1d5d-4ca4-bf42-9a942e6839e5', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0', NULL, '0', NULL, '160/84C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d29d6f79-972d-4dbf-ba57-9de7bcf3593f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d2a9b5eb-c0db-42a2-a652-692df090a8ac', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L REGULAR', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2ad52ab-1e78-494b-9a11-9768112faee3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0 /25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2cfbe2d-c68c-4c6c-9768-31480f745790', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'MPLUS', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2e1f008-2d01-4ab9-9e49-8a417f133271', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XSHSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d2ef4ed5-c777-4ef6-ab58-68ceca7eb7c7', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '4S', NULL, '4 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d30570eb-945e-4aa9-8ff5-92789e21d449', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d306256c-0612-4815-9304-f8cabe199bda', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '20 Petite', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d3191bc1-47d0-49c8-84fa-1a93f2f667fe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d31ab06e-6dfc-41ad-96ed-fd3d0a52fd5e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'M XLONG', NULL, 'M GRAND', NULL, '170/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d320807b-2438-4114-9c50-e4c9b99d1958', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '0 Petite', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d329f6ac-7388-4695-9af6-1ce63612192e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'L', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d32a1f87-6543-47a3-bbb8-6ad5a8f0c840', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 LONG', NULL, NULL, NULL, '165/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d33c5f22-7a22-4a83-8640-d519205b5d24', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1PETIT', NULL, NULL, NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3458015-a755-4124-a4b6-42e0bfb9097e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6829-6223-f9d5706de912', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d35089e0-950b-4cc4-bee9-afcba5854b2b', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '0-3M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d351021f-4de2-4861-871d-473f765209e5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38B', NULL, NULL, NULL, 'C85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d351e6ae-c6b0-4b44-ade1-2ec964434712', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XS 13-13 1/2', NULL, 'TP 13-13 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d3531883-fa9c-4a07-a65c-54f4dd159f5e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '31 TALL', NULL, '31 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d35df8f4-aefc-46e7-bd34-ce8b2e5184e5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-f429-f86f-6638328ea66d', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '54-58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d364fdcd-a5b6-423e-9c89-9eef0a53357c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '36 X 36', NULL, '36 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d369fdfc-0207-45fd-9b05-c65c8573d8ce', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6P', NULL, NULL, NULL, '155/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3734209-4676-438f-9d37-b26dc33714e9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '30 X 36', NULL, '30 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d37824f6-8e1b-40e5-86c6-4d6a8aece4c7', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d37c0741-858e-4173-9f8a-b4682722a3c8', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'XS/S TALL', NULL, 'XS/S TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d37fc61a-53c1-4d30-93c8-d3c0f0b86b16', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L+', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3815378-3368-4325-bc2e-ec57881303e7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2X', NULL, '2X TAILLE FORTE', NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d38414b9-439e-4493-b6ad-e2ab85529169', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '20 TALL', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d38ca988-2927-42ab-a763-7d130b527115', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '33 X 28', NULL, '33 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d3a18552-56be-44c2-89b3-9d2b9eb79b2a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-5981-531c-629f152fffa4', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3a9261b-0bb2-4f25-99cb-6bc17f403e84', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-5b44-e938-a3c489e62f62', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '58 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3ac872c-341f-47ff-a902-52283b806f71', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3b8488d-49ad-414c-9794-cc26045c0dd7', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3ba1008-b55e-4b2c-b076-7bc7b0ef9211', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5REG', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3c02e7d-70d8-4ff1-a87d-d6ee38a956f8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28 LONG', NULL, NULL, NULL, '175/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3c49164-aee2-48a5-a70e-d678003802da', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3c758ba-2237-4638-a96c-4a7104cf63e2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X 28', NULL, '34/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3dc8dfd-db6f-4da8-859b-f55824f59691', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35/20', NULL, '35/20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d3e42622-6bf6-4893-8f84-ce5166880c6e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000 X23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d3eae345-1a1c-4388-80a6-0a800d3d0f14', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'S+', NULL, 'P (6-7) TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3fbbaef-f599-47d3-9d4b-67a7845d57a0', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'XLHUSKY', NULL, 'TG (12) TAILLE FORTE', NULL, '145/76 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d3fcac7c-1a22-42a7-81f5-287441a744d8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXS/T', NULL, 'TTTP G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d405ebc4-4a5b-4f81-a67d-97febebbb6ee', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'M HUSKY', NULL, 'M (8) TAILLE FORTE', NULL, '130/72 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d40b1cde-4b19-41e0-81e1-a657e536f066', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS/P', NULL, 'TTP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d41bbe81-9632-4df2-8c2b-ae2c53822430', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'LREG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d41fcca3-0833-4fcc-8f03-6909e841fd74', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '18', NULL, '18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d4241065-59d5-470a-ae32-31ea2771dafe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4365c4f-6d01-4970-b6ef-fc4374ea5f0e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', 'UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d4372c3f-9f12-44c8-8266-240ebe0d07d7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18', NULL, NULL, NULL, '170/94A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d43a8d97-35f7-4fc6-9a6d-24b68118384a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d43e31f8-fe32-476e-9970-c43468596aeb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '1X', NULL, '1X TAILLE FORTE', NULL, '160/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d460173b-eb1d-44d1-8602-a890f409484d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4672896-da6b-447b-ba88-84041c7c0d05', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '14 Regular', NULL, '14 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d4677efc-4a5c-4625-aa34-83333bfc274c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '38C', NULL, NULL, NULL, 'D85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d4881001-c1a0-4229-8b43-c493038bb24e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '0-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d48b903b-837c-4d83-8580-4d88d6c86a81', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '32 PETITE', NULL, '32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d48d82b9-d8cc-439f-a3b5-14ea6a12346d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0R', NULL, '0/25 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d49ae851-4b26-4257-a9a8-69c629a4b717', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36 B', NULL, '36B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d49b0718-8c40-4cdb-8951-7f69bb46052e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/32', NULL, '29/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4a78c31-c0ea-4440-b18c-2986829f90e2', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '10/11', NULL, '10/11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4b3ec85-b489-42ea-bf9d-525399443df6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4b591f2-3076-407c-936e-57e817974202', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-d246-0c2c-913448a6ec2b', 'BananaRepublic', '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d4c1c642-585b-4283-8176-2bdac7fb44dd', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d4c283fa-54e2-4bcd-8eb3-dc4f7808cc35', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 /32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4d2c3da-0be2-415b-86ea-f72d68c0079b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4e96ed3-29ed-454c-ad1d-dac628d9875a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M REG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4f1e74f-2a84-4af2-8256-821faab42a19', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12 M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4f58471-b663-4281-bf70-813af173711c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-49c2-60e8-0bb146df8a52', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d4fcc800-7f22-4b27-95f0-9f0465c26a5e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 TALL', NULL, '8 GRAND', NULL, '170/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d50217f3-9a03-4364-9d1f-adf8821c589f', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d5072acd-cc89-46e2-889e-6b36482cd9da', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'LHUSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d508f481-52df-4f48-969e-15caf824f416', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', '4X', NULL, '4X TAILLE FORTE', NULL, '170/160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d519d0b7-cdfc-4365-a015-36dd134bf01f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5REGULAR', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d51fb894-8b2f-47d1-81b3-4a1f7316ec46', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32X34', NULL, NULL, NULL, '180/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d527f9b2-cb29-4975-acdd-c46237a3dd01', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '29 P', NULL, '29 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d534ac35-2249-4881-94b5-f6db0d90cd2e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 X 34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5353bf1-8153-4c8e-bf76-915ebb9d7621', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', 'PREEMIE – UP TO 5 LB', NULL, 'prématuré  JUSQU''À 2,3 KG (5 LB)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d5375c2a-3246-4389-ba71-cd75480114e7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6T', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d53c635c-2b36-4fe7-9cd2-987a902175f8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '23/000 Regular', NULL, '23/000 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d548085d-6ea6-4207-9a70-cd9031d9f851', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 P', NULL, '0 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d553daf0-cef2-45b6-9416-76f3ca2913e0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d55adadd-be02-4388-b4e8-dbb1af3aa425', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d55f1acc-a236-4148-a696-2b97352fc7a3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30B', NULL, '30B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d561980e-e6ba-45e7-aa88-59c8fe6ccf52', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '28+', NULL, '28 TAILLE FORTE', NULL, '170/130C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d56e780f-7cb3-4d67-b2f5-ad39b79832ed', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b8e1-9018-d3463e2702cc', 'OldNavy', 'S', NULL, 'P', NULL, '145/150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d577050a-1a41-463d-99e4-eeae46c8ccff', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 A', NULL, '16 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5791e8d-c414-419e-a6f0-0d4b8dae60da', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXS P', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d57fed34-ef7c-441c-a4df-a8e001c2ed3f', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36L TALL', NULL, '36L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d580ae5a-71bf-4198-8a38-f424d2df3b3f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24T', NULL, '00/24 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d587b192-f3f6-410b-adf9-ef848035b618', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '31 P', NULL, '31 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d58bff5e-87f4-41b5-a1cf-d24ebc2de66c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1 TALL', NULL, '1 GRAND', NULL, '165/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d5928830-7968-4de6-a149-4a212cd0184c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35R', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5ba9ee5-03c6-4554-a0ce-287e3a5cca48', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '24 TALL', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d5bbf730-73eb-4bcc-9f4e-771e9cf06121', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X28', NULL, '29X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5c22aae-fb4d-4770-8227-6345a12a2860', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'LREGULAR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5c3faed-cbd7-473e-8db2-00edccd9ae7f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '40D', NULL, '40D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '5D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5c59ca3-899f-4b20-bbfe-b5850479ad44', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, '110/50 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d5d30090-1fc6-4575-8adb-9fbab01bdeaa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5d54fd0-d9cb-4243-8870-10df5aa7cdf4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d5e2de12-44f9-4ccf-a065-9bc3230a70af', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '26', NULL, NULL, NULL, '165/142C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d5e5a646-d1ae-4a90-a745-826f7eae5dbc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1 XLONG', NULL, '1 GRAND', NULL, '165/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d5e70e4a-b980-4372-9d42-a9345cd93841', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5ec73b1-0fbd-496d-8af9-9845246cb29b', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'M 15-15 1/2', NULL, 'M 15-15 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d5efec43-ea4a-4241-81d6-4bde4a665cbc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '7.5', NULL, '7.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d5f7f6bc-d12b-41e5-8397-48b25b104140', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XL P', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d5fa8353-4af6-48e6-aa20-81a35517e097', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d5fe7c8f-7b31-4577-a95b-7ecbd1360185', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L', NULL, 'G (10)', NULL, '140/61 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d60c6ef0-6130-45a3-8254-b0232491d2bd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 T', NULL, '6 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d616d2b6-f071-42e4-8b28-30c9f5ee8022', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'S/M P', NULL, 'P/M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d62b03eb-5542-46f9-b409-d3bf423e4f76', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30 C', NULL, '30C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6326c1e-0412-4464-b0eb-f7ac32feeef3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '30/10', NULL, '30/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d6342d42-4ddd-436d-b87d-1c31c462de95', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6564c74-ae80-4063-93b3-bb9bd9d80a3a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'XXL 18 3/4" 39 1/8" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d668ee44-61eb-4432-b2d6-a1487c540113', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d66e10f9-3fff-4a25-8366-1beb39d06ec9', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d677173e-c946-4432-a150-48301e66a080', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '10PETIT', NULL, NULL, NULL, '160/92A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d6789420-1f50-4cc9-9330-05d24a46ab0c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26P', NULL, '2/26 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d682d78f-534c-40ee-b364-a75ce4127f7f', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '8 Regular', NULL, '8 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d69dfbe9-4846-489d-8f5b-ab600cb5734f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8', NULL, '8', NULL, '135/63 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d6a0d963-1505-4bd4-810f-fbee1a53e21b', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'XL', NULL, 'TG', NULL, '170/115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d6aa311b-a710-43a2-ac5f-cb286296b7af', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'M REGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6ac438b-0c64-4537-844d-584c49534f6f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X 34', NULL, '31/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6b2c89d-f5d1-4b82-a141-b3eb8aecbcaa', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'LPLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6bdca59-3e4e-47b0-88f9-d0a2913abd5b', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XXLPLUS', NULL, 'TTG (18) TAILLE FORTE', NULL, '165/84 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d6bececb-cc3d-4fa7-a5d9-a2a4defc3ee6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d6d1e8c4-7f53-46f7-ae24-9f189a4da873', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d6e89bcd-589e-4959-9980-aa6068c89c7a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4 SLIM', NULL, '4 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6e9202a-a4d4-46f4-83a5-1c9387c5cf4a', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d6ebf489-1561-4174-b672-9fdfc1d23b1b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/ 33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6f704f1-73ef-4099-9792-4ad78ec925c1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d6feebc4-737f-4bb3-8456-caa3b7643211', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30SHORT', NULL, '10/30 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d706154d-f23a-4cb6-8005-2d09f2948d6c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L +', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7091ae6-d055-4050-a180-db88cd7a1044', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '9-12 MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d711e6f8-745f-47d5-8534-1c9fadad3f38', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7133b2e-0ff1-4750-bc1b-c0e7f0eaf81e', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '31X32', NULL, NULL, NULL, '175/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d71860e1-dabb-484f-88b4-ba1260181638', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '14', NULL, NULL, NULL, '165/108C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d71c4dc4-c11c-46d0-b311-1f3566ff4bd8', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d734565e-e912-4134-b47f-cc402d1d4766', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XXS/P', NULL, 'TTP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d73b8af4-801f-4275-bfc2-cb21b5e71bcb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d740c4c2-aabc-446c-9b94-1fe9a9a21aeb', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8 SLIM', NULL, '8 ÉTROIT', NULL, '135/57 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d74f2043-28c6-4e35-8b99-acfd0233f4a8', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublic', '2YRS', NULL, '6 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d75104f5-0a4a-4c2e-96dd-1052fca39b4e', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-14fc-dba8-880741636a4d', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d754986f-cafb-4d14-bc87-6cefa11f2d13', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '12-18M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d760439e-51d1-49f3-8bb7-3762a2c68a9a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d771d814-a6bf-4298-b0ff-9e092ac5e038', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d772c7eb-54be-48b5-a1e9-8c8d591c430f', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-ee64-a6af-b4b2dbd3e0ca', 'OldNavy', '3-6M', NULL, NULL, NULL, '100/55', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d7747030-d717-4c31-812c-2302fe4e991b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '2X 26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7789161-04ec-4a7e-bd30-3b647b3b41d8', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X 36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d77f130d-1032-4b9c-8a89-9679f5d88a38', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '44 TALL', NULL, '44 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d78ea741-8e35-4db9-8586-9b9f0a88fd70', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S P', NULL, 'P P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7999421-7ae9-41bc-88ab-7107e4970a2d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8 / 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d79c356f-b846-41c9-a57f-a26e408b0f4c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7ab7e6e-21c4-4941-81e0-08e550700e64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '000P', NULL, '000 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7b2f9ab-7e94-42d7-866e-2a8a1a362750', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d7b9ac74-3353-46aa-9f93-41adeaa2e044', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 /36', NULL, '33/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7d5d5b9-7c35-4cb8-b6ef-7e5c40bbc24f', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20', NULL, NULL, NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d7dd6ae1-b5a7-4260-af6c-95ab1ac9c945', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32/36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d7ebf415-d322-40fb-ad9f-5e37286b6379', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublicFactoryStore', '0-12M', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d7eccac1-f53e-4bfa-b694-8c403337f0c0', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '7/6/2024 12:00:00 AM', NULL, NULL, NULL, '250/92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d7f09d40-b4bf-4063-81f9-804277fb734c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '7.5 ', NULL, '7.5 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d7f6ec4e-ee9a-4a12-9bc9-57a6261fd15b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-6274-6c78-0cdde0ff41d8', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d8263b29-1d52-49ea-b113-8da7564ff0c3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27/4', NULL, '27/4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d82830b5-edde-4789-801b-b6041c8b65d8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 /29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d83a9765-8524-45a4-986f-a4d8627f6fee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '22TALL', NULL, '0000/22 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d84d5e4d-80f5-46d5-a483-476b7db1cb97', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'S', NULL, 'P', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d8502bc3-67b9-4357-85b2-b4798a0d07fe', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('d85358c0-7571-444a-a933-839e27f64e42', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-4811-7a0d-f7453d8c0729', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8667b5a-9b86-4594-a0f2-5c6faa97412a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 /23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d873c244-e5f5-471c-96c3-b9eb1b59ead3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d87747fc-a44b-4b7e-b142-9c9b90e86d72', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-6ff2-89bd-4cadc4c78159', 'BananaRepublic', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d88c0095-7b5b-46b3-b3c2-f8dc973ae71c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/ 36', NULL, '35/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d897a2c0-1f7c-4246-bec1-e84c54c3222f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXS P', NULL, 'TTP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8a4447f-4bcc-4f20-867f-cb30a729b569', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6 REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8ad1e5a-ea84-435f-a222-b500f9cc4cfc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8ae1853-a7fc-48b2-aef8-007496d7aa87', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'L', NULL, 'G (10)', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d8c6f8a2-4de8-4882-a2a5-94960ea96f77', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '40 X 32', NULL, '40 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d8c7cf0d-d087-4f3a-9499-9eb35baa5dec', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S REGULAR', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8e3e95d-1e43-4c5e-9f17-4b9b93ac7f39', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M REGULAR', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8e67439-2b3d-4138-8620-8b1bfeea370b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', 'PREEMIE – UP TO 5 LB', NULL, ' JUSQU''À 2,3 KG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d8f8e7b5-a093-46de-80a9-ee4a1162b93d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XS REG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d908e748-dd59-41df-8178-c679a2c491f8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'L P', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d924f864-eb8e-4cd4-b55e-27d8f4b1e6fc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '8 SLIM', NULL, '8 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9360d1f-a357-48ef-909b-8b567be2d253', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'S', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9462f9d-ec39-491f-b61f-72c4c4ee90fb', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XLHUSKY', NULL, 'TG (14-16) TAILLE FORTE', NULL, '155/75 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d956ed25-6abf-4829-b1a8-f2aa2c9b7e46', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d95f4d46-5d9b-428f-ade0-cf9978e269de', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9604deb-62a5-468c-a909-cbd7a8ae75f6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20 SHORT', NULL, '20/35 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d961a4f1-3e69-43d9-8045-e8be4d1152cd', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '27 x 30', NULL, '27 x 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d969dd22-9f26-40ee-9e71-a5a54e2a2770', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36C', NULL, '36C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d976c1cc-35ea-48e1-8679-f0d905df780d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'MSLIM', NULL, 'M ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d979461d-fe6b-4982-a8ad-52b8ca00d71a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XSHUSKY', NULL, 'TP COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d97cb06a-7688-42e7-8f64-09bc4a3e1d80', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '6XSHORT', NULL, NULL, NULL, '155/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d984817e-dd9d-4207-8987-7643a68abf5f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X 32', NULL, '32/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d988779f-0170-40a1-bfef-1c07bbf54094', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9a12b08-8dc3-4423-bf17-494111b6df82', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'S/T', NULL, 'P GRAND', NULL, '165/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d9a3f924-76c8-4919-8875-bd023832df28', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d9a86a6a-9d05-47ad-b882-caf3a874be6c', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9aa8ed4-1ab2-4676-8da9-0be682879f60', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '29 X 36', NULL, '29 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d9ad58ff-3d49-4095-86c8-68c335990b37', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9b0231d-4fb2-4df9-9e17-37fed3f9e5e5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '30 TALL', NULL, '30 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d9c2b9ed-7d30-465a-bd27-20f7fe14b61d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '14P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('d9c63f8d-4578-4b1b-9a01-2e15d43b5d44', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14T', NULL, '14 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9c69050-f3f5-4e78-8524-d5a14e0ae161', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'M', NULL, NULL, NULL, '175/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d9ca0851-b2d7-4d89-bc33-968c93bcd684', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0745-618e-918791902aed', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('d9e3f346-bc6f-4783-a217-1065c8e494ab', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('d9ee1341-20aa-4c2f-9377-f78e049e7943', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8 SLIM', NULL, '8 ÉTROIT', NULL, '130/53 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('d9f0ed97-25be-4861-a8ff-0c4eda9c3f31', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da12b39a-2c3b-42d3-b034-0edd6174aa88', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 /30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da13efa1-3dc3-41c2-870d-677666be8e92', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-7c36-acad-12ebafd8c716', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '*****', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('da177d5d-e102-46e5-8d4c-108ddb785a99', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 / 29', NULL, '8/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da1e9e23-344e-44e4-bf94-d69cef195d06', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da20109c-1244-4726-a7af-39c05e804ac4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da22d0b3-5384-4ab3-a31e-3ff824c453bc', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da234f43-a556-4f3f-9a82-b97f49556955', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'LHSKY', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da2a4d31-c2c6-438d-88ed-350db44fd93d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('da2d95e2-8641-4d9c-b0e6-dfb016596226', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 LONG', NULL, '14/32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da314a0c-ae64-4337-9527-2bec20f542a8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da32b7cd-f386-4d1d-a913-d6afc399881a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24', NULL, NULL, NULL, '165/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('da369892-2b92-4383-9f46-2b7d1ce6b000', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00P', NULL, '00 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da384383-65fc-43b8-a928-c68bda32ec29', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'M', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('da497e1a-eefc-4f14-ad5a-5971a8b5b28a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X28', NULL, '29/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da4d9dd2-9776-4cbd-be3e-f31cc8a3f279', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '2T/3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('da59feb7-8335-4cd1-91e2-45ee062f7da6', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-b2ad-212c-21d3979d940b', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('da6a669f-e897-48e2-9ed0-83dc98c9d170', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20/35 P', NULL, '20/35 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da7dd214-5a35-4436-a721-83cf1206a614', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000 X 22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da800b9f-9a2c-486a-8463-7911bf54a5ee', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 /32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da834cd6-166f-4864-b3e8-2af8a360567b', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('da860901-5400-4c60-8b58-9812ca0fd5ca', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('da874eab-1e6e-4c6f-acfa-ce417a97d2b7', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('da8bc1a3-3dab-45b9-8090-07e0b357c090', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 /30', NULL, '28/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da8edf47-7073-49af-b08b-a629f5ce56fb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('da8f3af1-7443-481d-94a9-c4332bde8bf9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 REG', NULL, '8/29 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('da97d20b-effa-4976-9ca7-49d4dd6b0e64', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23 T', NULL, '000/23 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('daa686ff-705a-4b94-9504-2a8165dfc168', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('daab2d5b-71c8-450b-befa-c71a5dacf122', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '0 Short', NULL, '0 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dab96afd-accb-468e-b3cc-aa7b9578fbc2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dabe19db-b370-417d-a352-4f5ccf961b1a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL/T', NULL, 'TTTG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dac8cf72-947f-43d5-b6eb-562693d53712', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '12', NULL, NULL, NULL, '295/102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dad05cd6-51fb-49d9-a194-dd48c3201e60', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12SHORT', NULL, '12 COURT', NULL, '160/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dad29021-b105-48c0-be07-037255372a87', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/60 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dadef7ac-7fa4-4e88-957c-58192ac9e2cb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-abc6-5927-9b41f70fc3ad', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('daed461d-270a-4a57-8f62-9aa405b321f1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X 28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db047b43-b3db-4c68-8830-fb0a450f91ad', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-ba93-17e3-00f06407e583', 'BananaRepublic', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('db0cc80d-fe68-4ef2-8faa-5585e3439856', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XXL SLIM', NULL, 'TTG (14) ÉTROIT', NULL, '155/63 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('db14988f-ecd1-467a-9d07-3ac01de4cf12', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X34', NULL, '30X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db15c663-5bf8-43b6-b834-7490a8473a62', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7dcb-0ca5-19fb6787a519', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db16cf52-271d-400c-ac66-973c5a762c48', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXXLXLG', NULL, 'TTTG GRAND', NULL, '190/140A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('db1d1299-d3ec-426d-bd08-5cd69850ccd8', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublic', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('db1fd6db-59c8-41ed-97b9-5197772a6c18', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '34DD/E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('db242e59-198a-4626-a013-9e2dcd488811', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '14', NULL, '14 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('db382a93-2e04-42f8-8b0a-7fec96071179', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14 HSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db38868a-ee2e-453a-b98c-1ecdde45199b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f96b-e1e7-9a5d3b960c0f', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db3c2e73-a8fd-4ded-8fd1-47462e62df6d', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XL', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db415d9e-62a2-4fc6-9bf4-840b9eddc9cb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '25S TALL', NULL, '25S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('db45ad8b-27c2-489f-8119-e7b5b5116ef5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e16-36d5-892d7cb07f93', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db4b2d51-b42b-4610-bf3d-fab7d5b02a1a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33 TALL', NULL, '16/33 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db4dece5-e802-495d-91dd-78ff206b2efa', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 /32', NULL, '38/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db622448-ccb5-417d-9d06-63c146a9a28a', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M+', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db665fd1-3b5a-4fe3-af61-a11f7dadee54', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db753328-311e-445d-9a0a-bdf0d1c89766', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXL', NULL, 'TTTG', NULL, '185/140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('db7b66fb-34c1-4e88-977a-8cda5487fbf9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-f72c-7c15-160e2a3b1cd2', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db86b558-bd52-40af-b475-a3c5498b68fa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20P', NULL, NULL, NULL, '165/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('db94d6a0-d8f4-4744-b6a1-0a334e937683', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-a5bd-9668-0296bc777474', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('db997a1f-5d78-47dc-97ca-228045f715dc', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33/16', NULL, '33/16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('db9f19cd-3cfe-4970-a506-98348d818500', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', '6', NULL, NULL, NULL, '160/96C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dba30e2b-d687-485c-ab7b-b58a5bec89ea', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16+ REG', NULL, '16 TAILLE FORTE', NULL, '160/94C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dba3162c-d201-4b91-9c92-cfa3a2cc5a63', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29/8', NULL, '29/8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dbc1fbff-08ef-45fa-9f5f-717c3c7a16ac', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-81a7-7318-eb5281c1f797', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dbc7643e-2733-446f-978c-2222404e3454', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dbd03d09-5b16-4f1f-8b99-87e2dec4b8d2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '175/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dbe03826-8917-4e72-971b-f4eef29398c5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-6 MON', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dbe39f34-f30c-49a6-abf6-1616915dace4', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dbed0d9c-347a-4eb5-8279-6a9aae37d44a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-107d-666a-56ad73c13d60', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dbf22fc2-a1c2-430d-b409-223c493112e2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dbf25f51-6d55-415b-a9be-739599af95f3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dbf441bb-4225-4dd9-9247-fe1b10e3acac', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4T', NULL, '4 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc01cbdc-ff92-44f5-94a1-b97a5bf06c92', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24+', NULL, '24 TAILLE FORTE', NULL, '165/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dc0e641c-99bd-4296-ad11-e795ea6a8b7a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6f64-8bbd-4baa7fba449d', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc267b20-383b-4cb5-a690-9192165b3ee1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '50X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dc28ab4a-0383-4338-b42e-708ae1779619', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-6 MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc2deffb-6dde-497e-b38e-33b06316fefb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25 T', NULL, '0/25 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc2f901b-8d9f-45fd-817a-9c68492865ad', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M REGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc55cb92-7c6f-47d0-ae2e-c7554de24312', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 REG', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc654595-6d77-4531-9be9-aaf9a9671497', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '34 TALL', NULL, '18/34 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc6e9e62-b45d-45c4-a322-707c62678751', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30REG', NULL, '10/30 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dc7060cc-2fdf-4b55-9f06-e0d58a9f6cb6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dc76347b-2cde-40c1-aa83-b07b8dd910d7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XXSXSRT', NULL, 'TTP PETITE', NULL, '150/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dcac8e5f-f224-4bf3-8ae9-44e5b0a717fd', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'S TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dcb050cd-e329-4009-bd10-c9f1fbba8433', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dcc161e5-d264-4ff1-a94d-c6fd93e4575c', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '24', NULL, NULL, NULL, '165/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dcd1a28e-3ced-4e57-a6d0-94c1b9f7686f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '24 TALL', NULL, '24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dcdcffd3-dd16-4315-a38c-893f0c9740f2', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublic', '3-6 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dcdda262-b020-4860-8d1a-fbafa86f3431', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X 34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dce5505b-fc42-4c6f-97e5-bf1ff07e0188', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXXL/T', NULL, 'TTTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dce714d3-46ee-43b8-8ed2-8cb582303123', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'M/T', NULL, 'M/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dd02bcca-3055-438d-879a-eb85a43fac86', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 / 36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd0a51a1-5a3b-4959-a68d-0c01b86631c7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXS SLIM', NULL, 'TTP ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd1d2207-f5df-43ba-bcbf-af833ec69929', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'S', NULL, 'P', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dd1d742a-3edf-444f-824d-1e4967fe9e41', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-b8ad-bb6a-01ec7dc9e9b9', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd22ac6f-01d8-44d2-a903-4927ff583a6c', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XXXL T', NULL, 'TTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd25fcd1-74e1-499f-bd21-1d235838ea68', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XLXLONG', NULL, 'TG GRAND', NULL, '185/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dd33019b-15cb-47b9-b089-0709b51ab5bf', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd370920-8d8a-4d47-8903-a409de18c395', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublic', '6-12 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dd48ffed-07be-49d7-9f47-7ff0ce6062fc', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10PETIT', NULL, NULL, NULL, '160/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dd5fd43d-513b-4b92-981b-24f023c4d48e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd656132-0a65-4928-be66-10c25ff13270', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXL HSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd6b4f45-d612-4887-a3b4-d40f73f87b21', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXL+', NULL, '3X', NULL, '165/145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dd6dc988-3488-4996-97f1-4c00b89a80b5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('dd6fd876-940a-4403-9833-6a6819ff65ca', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14', NULL, '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd7600e4-1dd6-4c57-a153-353e117dafe1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '6-12MON', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dd8945d6-5486-4062-9e7d-cc0f05417fcb', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dd89792a-10f7-4edd-8927-73b7c4f9ef81', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X28', NULL, '34X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dda50c7e-0df0-4927-b875-6b0f7b51795c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '5.5', NULL, '5.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dda59775-e9d7-43ec-bf32-9520f2489737', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 REG', NULL, '0000/22 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ddb32eb9-812e-4da1-9218-adcc3662e897', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'MXSHORT', NULL, NULL, NULL, '160/72A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ddeac978-dec9-4280-ba39-e81a6c6acb09', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '27 P', NULL, '27 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ddee3fa4-e196-40a0-a093-cd7330b34f7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-ac3c-d49c-2791bd62166a', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ddfbdf42-6fd4-4230-a15c-981cdd2fbdc1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'LHSKY', NULL, 'G COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de12bc58-8ff1-4fd6-85ac-763c128ad1b2', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXS', NULL, 'TTP', NULL, '165/85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('de1efbf1-70e1-4413-b912-cea1863d8332', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '24 TALL', NULL, '24 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('de2b5b30-789c-4cce-a261-4b0e91b31c47', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('de35d7a3-367b-4249-abdb-23105adf74ff', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/ 34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de4bc61a-c28e-4b44-a2d4-2ec612e0b6ba', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M/T', NULL, 'M/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('de605aab-006c-4534-8178-9c4f3c68a8b9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS', NULL, 'TP', NULL, '160/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('de6717c3-5d8f-4ad6-8aa6-7155df2e5c67', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/ 29', NULL, '29/29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de6a2213-d9b4-4e3c-8fce-3379ab3f567a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '34 LONG', NULL, '34 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('de739b88-8195-4d84-88b4-17b1951a8416', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '8HSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de79de83-a5d2-4eb5-8c59-d8ed04fd2ea7', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '11', NULL, NULL, NULL, '280/89', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('de7fbd2a-c59d-4607-a7eb-7b0948d46368', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Gap', '2 (3-6M)', NULL, '2 (3-6M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de83711b-f298-4f34-8ce1-1e4e36c1f355', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL+', NULL, 'TG (14-16) TAILLE FORTE', NULL, '150/73 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('de8d89e4-b116-4cd6-93a9-196e8a103187', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('de92ce36-1735-4f95-aae1-007469a201ce', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'SPLUS', NULL, 'P PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('de94e6da-c151-432e-9eb5-b729dae9cf97', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dea11611-29ff-4707-9999-76712e54d125', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'L SLIM', NULL, 'G (10-12) ÉTROIT', NULL, '140/55 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dea895c8-eedd-49fa-b3f8-9ad094af022c', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '3', NULL, NULL, NULL, '220/78', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('deb125ed-b9e5-477c-894c-4513febbdaa2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6 SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dec11583-718f-4222-9373-e9780943107a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4PETIT', NULL, NULL, NULL, '155/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dec3d065-4b6b-4eda-a2e0-1dd52f7f0d11', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '23/000 Regular', NULL, '23/000 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dec866a1-5615-4f36-b94c-c60422429fc9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-812c-790f-7d8eb578f719', 'BananaRepublic', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('decb1a02-f2b8-48c3-9c78-94fc2b3d78e8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000TALL', NULL, '000 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('decb9b04-121b-4f11-989b-fdf1f67e13fd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'M/L', NULL, 'M-G', NULL, '165/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('decc51d2-2b76-4456-aaef-895ff435d39c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', 'UP TO 7 LBS', NULL, 'JUSQU''À 3 KG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ded336fa-0d91-41d2-ab68-bff6960c4f97', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-5ecd-3898-133431d438d6', 'BananaRepublicFactoryStore', 'L/XL TALL', NULL, 'L/XL TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dede9f8e-2b82-463e-b5c9-36dbe64d4ca9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '14 P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dedf9743-bb80-4bb4-b052-5b8622385ad7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-fa07-f4fd-146a1fb15d21', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dee494e2-f9eb-4be5-b9b0-ad37223bbaf1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29 P', NULL, '29 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dee77c53-743b-4798-bb4e-8edee960252c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '16T', NULL, '16 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('deebf035-79c1-4ae3-ad7f-60bd708180eb', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '6YRS', NULL, '6 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('def44916-a430-4654-be65-42810ff4f5ec', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16 LONG', NULL, NULL, NULL, '175/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('def5bc32-b1ff-428c-977a-c75cbc418e90', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-9133-d948-6a0b28bceec3', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('def81211-6a6d-46fe-b0a5-115394cb6cb6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '25', NULL, '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('def86ddd-6b73-4444-8073-98e185a695ab', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXLREGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df074593-c33d-4204-a4f7-558417ca4a5f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XSREG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df0af36c-56b5-4436-b0e2-646cea8b6813', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XL', NULL, 'TG (12)', NULL, '145/72 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('df0c697b-a836-420c-b3c5-d16d0312bd96', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL', NULL, 'TG', NULL, '180/120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('df1e0273-1213-4357-b8b2-049fd1cfdbcc', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '40', NULL, NULL, NULL, '180/102A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('df234e90-fbf3-46de-8c55-befd5300346b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'SRegular', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df48f050-77e0-4fd2-9d3b-4888b0575a92', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XS/P', NULL, 'TP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('df4f6fc5-6024-44cd-9232-a5ad70679db6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXL /T', NULL, 'TTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df7e4b36-4dc6-433b-b115-f5c00afcc5f0', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublic', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('df8a14bf-8564-4594-bc35-127947777294', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '0-3MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df8b21c0-8b3c-41c2-8894-0ab43d91b6a7', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '38 X 34', NULL, '38 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('df93770f-b821-4bb6-b70a-f2f4d73385dc', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '33S TALL', NULL, '33S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('df940814-4274-432a-becc-e8877cbee676', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-95bc-3dfc-0a1b593accae', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df9593b3-07de-448e-8c4d-b3563f364a14', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/M T', NULL, 'P/M G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('df98b06f-22c0-44da-8032-fb3c57b5a040', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000SHRT', NULL, '000 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfa26e70-20ea-49ae-983c-8cef4aa4ed82', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '6+', NULL, '6 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dfc5ddbd-fecc-464f-a913-d751808f9099', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfc72c5b-4288-4145-94cb-0580c52466df', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8P', NULL, '8/29 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfc7b73b-50ec-4b91-9f7c-2ffb555c6284', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '00', NULL, '00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dfc87f06-f786-4420-9340-5f91c1d9e3d0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'L Reg', NULL, 'G Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfc9f18b-a2ce-4abc-b753-7ab7d42be724', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2TALL', NULL, '2 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfcdac9e-c684-4bca-8d79-4fca3db5ccef', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfd0900a-29d3-44e1-9c6f-08dd9688d35f', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '3-6M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dfd3c3e2-2424-429a-88fa-103ece0d9b60', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('dfd463ae-78b5-41d7-8ac7-c5c42009d03e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 SHORT', NULL, '2/26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfda1f71-6274-436c-b0d8-a2dba14ee2d7', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c337-6592-3b68eb86d962', 'BananaRepublicFactoryStore', '6 Short', NULL, '6 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('dfe62660-4835-4eb3-b5e6-7cf12cfc605a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XS P', NULL, 'TP P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dfed8f98-ec59-4ea9-969b-98930decd3b4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XLP', NULL, 'TG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('dffafce0-e9b9-42fe-b9e6-292d295e0b39', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '40 X 36', NULL, '40 X 36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e00b1b2e-c14c-4024-81f1-b9a293b2cbcc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35J REG', NULL, '20/35 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e02d072a-4340-4ae6-9fa0-8152a7192667', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 SHORT', NULL, '14 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e03aec34-2812-46aa-b521-ba7958c7b373', '3a106a3e-aa0f-f689-1ea9-73f47ce24812', '3a106a3e-aa62-1592-bbdc-475d7e7d56a9', 'OldNavy', 'L', NULL, 'G (4A-5A)', NULL, '110/53 - 110/56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e0400f88-79d6-4b2a-9f72-8829ba693895', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'BananaRepublic', 'L 36/38', NULL, 'G 36/38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e0509148-6083-4b3d-ae1f-3150a5a85315', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e057096c-0482-4edb-8c67-f445fc9bec30', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0609d27-2656-470a-a4f4-64630db19e33', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 / 30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e065c238-4b06-4579-aee5-62b6562eab92', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '30C', NULL, '30C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e06c5c6c-b8f9-426e-9ec4-41d579e6d13a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '48DDD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e0771806-d86f-49d2-abe6-f487c94203a1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XXS PETITE', NULL, 'TTP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e08178fc-318a-42ac-80b0-1504cb388c06', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8P', NULL, NULL, NULL, '160/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e08b3820-08d3-4076-ab29-f6e008906668', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '0PETIT', NULL, NULL, NULL, '150/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e08e94cf-0809-4b45-9c7f-511d155087d0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e09a4e12-c89f-45be-a0d2-2bcae8b557ce', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '6/5/2024 12:00:00 AM', NULL, NULL, NULL, '250/84', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e0a525d8-84da-48cc-a9ce-e5cc55df9629', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXXL', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0b0d8ae-fe7b-4ad1-b43d-e932e3429a44', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e0b9d38f-b987-457c-9a13-b637efb26bd2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0R', NULL, '0 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0ba3704-180c-48e9-89b7-8752428cb1b9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '00XLONG', NULL, '00 GRAND', NULL, '160/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e0c7cb93-bc75-4552-a95a-f6e12d78dc6c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XXLHSKY', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0d54b48-84c8-4742-82f1-c9f86c8d71c7', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e0d78b7b-ae9b-4a3a-8a8d-d840db2866d1', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('e0e341e9-0416-4ced-98be-09e3346f8b90', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '30', NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0ecf5a0-e304-4673-a462-46d22f2d1b3e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00P', NULL, '00 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0ef1248-68c4-4e01-8f89-f9e567014da4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2 X26', NULL, '2/26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e0fc3821-5fc2-4099-ae91-7416423840c1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e120af58-9aa1-45c0-a703-7a0e97267f8e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e1277ce8-10c9-47bc-b372-f86f3daf0643', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '29 P', NULL, '29 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e128cee6-5516-4ac6-bfa6-2198917a6a57', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10+', NULL, '10 TAILLE FORTE', NULL, '140/70 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e13052c3-4d18-4bcc-9c5c-427ad09cbd95', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-0492-0683-d49d5fcd29b8', 'BananaRepublic', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e130bea0-f5c5-477a-adc6-8cad9ed166ce', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XSXSHRT', NULL, 'TP PETITE', NULL, '155/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e1379059-eab4-4e0d-9f2d-5e470b85b602', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '25/0 Regular', NULL, '25/0 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e144f99b-9960-470e-bb10-dcb14f5f8a7e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '2P', NULL, '2 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e15dc162-14e0-41a2-8dcb-1d1a87e0b5d4', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '16 TALL', NULL, '16 GRAND', NULL, '175/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e162e9db-649a-474b-a28a-f5b522d153bf', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '25 TALL', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e1771edb-5d47-4f7b-a88d-53d9845b60e1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29/8 Long', NULL, '29/8 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e1856e49-ad28-4f73-99d6-6b2a97fb0082', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'L-XL (13-15)', NULL, 'M-G (13-15)', NULL, '19-24 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e18d49aa-cc7a-4180-a9b5-72100cddca0b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-12MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e198faf2-a3ab-4553-b520-ec5f960b84e7', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e1b39203-716f-4d48-a01d-8afe002ea7b8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20L', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e1be6e7d-7da5-4d99-ad40-cf2e4f7ae3f0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10P', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e1c22e3c-6c2a-456f-8ea4-a821ea188099', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '3', NULL, '3', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e1d2a55b-8f2d-4d81-a963-ebd6a2cfecc0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'SREG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e1da822d-d537-47b5-88fa-9d53f6307a93', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000/22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e1dadecb-4d44-4cf3-b6f9-32a41b04e25d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e20b6eb2-ef5c-4490-b459-1633e9a79816', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L', NULL, 'G', NULL, '175/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e21bc0e2-7cbc-4590-bef7-9c897820aa8f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5 PLUS', NULL, '5 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e223ba16-ae5a-49ee-be04-3830377883ae', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-d0da-f753-4e7a49dfd2fc', 'BananaRepublicFactoryStore', 'XL', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e2323382-f0c4-44b4-882e-4568d13969ed', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '6', NULL, NULL, NULL, '230/77', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e23c5b24-b984-4c2f-950f-a9546c6b9dc0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '4/27', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e23dace6-7cb5-462d-9383-1bf8947ec07e', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', 'M', NULL, NULL, NULL, '175/69', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e23db415-cde5-4931-8b94-0c98f92aa540', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '13', NULL, NULL, NULL, '190/72', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e24106ff-4980-4db6-8c69-706d022105b5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XXXL T', NULL, 'TTTG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e246601f-dc1b-49d9-93b2-2c5ee74dca07', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '14.5', NULL, '14 TAILLE FORTE', NULL, '150/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e24fbc93-a2a1-4034-bd14-fa1ec5b24559', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X32', NULL, '34X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e266155d-5157-4969-a783-1962aeb97d68', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '36B', NULL, '36B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e26a60ac-66a7-4b31-afa5-7eb0ba3bf3cd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e278ddbf-854b-4a1b-8df3-e73f2d68cac3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24P', NULL, '00/24 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2886af1-2783-4621-b16b-2395e24e564c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '25 SHORT', NULL, '25 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e28b2d32-adaa-415f-984d-5a88cea29c64', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'SHUSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e28e466f-a51d-4133-9158-ca3b82c0eb98', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3 MONTHS', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e29248ab-435c-48ee-9e54-3e2b66176a39', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e298e5d5-ecd2-4319-8992-de3bb29ee8d7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '30 SHORT', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e29f21db-dcfc-4ef4-8dd8-3b0ec9f93b87', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e2a5903c-8f0c-4a6a-96fa-abc84a6691c2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2b015ce-6496-49f8-88ca-5bc14b9d04a1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('e2b3f766-1766-44f9-b7f9-4bc93995eb3c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XLREG', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2b4afb1-d7e8-4f62-ac00-6452fd816369', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42 / 34', NULL, '42/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2b923da-93d5-46f1-bad0-b648cce825c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X36', NULL, '33X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2bee85a-03a5-4b72-9baf-4ec89cc48d8f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', '6-12 months', NULL, '6-12 months/mois  27-29 in.  69-74 cm  17-22 lbs.  7-10 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e2d4eb3b-0dc0-4009-af78-4f37ac1d6c46', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12 SHORT', NULL, '12 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2e5dbd3-c664-4f26-afcd-796bd4ec5b40', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '30/10 Long', NULL, '30/10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e2fb6e00-8caa-4961-8872-863863ca4682', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12/ 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e2fc0426-e77f-4aab-bd2b-c6f6ce2a45ac', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '14REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3019d0a-65c2-4218-bbd0-e1cb7124784f', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e3049a3e-001b-48d6-ac38-44c4d8e457e2', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XXL TALL', NULL, 'TTG 18-18 1/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e324e6f8-2627-4799-8cba-7d37b7dd958c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '2-3 YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3252620-ca77-41bd-9723-a6ca82d4a2c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 /32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e32f1f98-5e4b-417f-8c99-c392636dc717', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8 P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e33022aa-5b74-48cc-82d0-eb90eaee7649', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X 32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e340225f-766c-474d-a166-902f53a71982', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000S', NULL, '000 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e349e897-41f6-4ccc-8cab-35499a155799', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublic', '10 TALL', NULL, '10 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e3586ac8-cfe7-429d-94b9-9f4ef7dae3d1', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5119-2c68-4a208711d430', 'BananaRepublic', 'XXL 44-46', NULL, 'TT-Grand 44-46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e35ecf12-d473-4683-9b09-ecf68d263f56', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e361692b-382b-4451-ad58-a7ba4b33198e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXLHUSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e36188e1-b85f-43b8-86e7-414f0443a2c1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 X 30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e369073f-da95-449b-b75a-7ea3ee1f4a4c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '2 LONG', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e36d1102-0001-4f6e-a154-81c4c4384c9b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 /30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e376e1ea-b1fb-4598-8c10-d072af785f1b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('e37b016a-f71b-41cb-a43a-e6b2b7c30848', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '2-3YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e37b3fd4-bc6f-4884-a2ed-e389672d9807', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XS TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e385f6f6-4f47-409f-869a-18355677b40e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '14 X 32', NULL, '14/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3880aaa-5393-4a4a-94fd-b100afcc3f81', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '36 X 30', NULL, '36 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e38db73d-50ce-4548-9ae8-20a2f6c668fd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e38fff00-b2a8-4c20-9738-38277dc15e71', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32AA', NULL, '32AA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e395c7bc-6035-4c1e-92bf-e0a7180c5874', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '2-3YEARS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e39f834e-ac72-4c20-b9da-e136bb38d07a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12XLONG', NULL, '12 GRAND', NULL, '170/78A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e3aedec5-a8ec-443c-99bb-f30a9434a29c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'L REG', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3b5a144-d9cf-4000-8934-2c6a80ec93ce', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3b8d53c-6511-4827-9558-5c7e54c3ec82', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16 PLUS', NULL, '16 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3c4e733-9f2c-47c8-b767-a57159365e0c', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '40 X 30', NULL, '40 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e3cbb898-272f-4ef2-868a-86f1439f08eb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e3d2c784-c1f4-4b3c-9152-4b43263d6803', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'M/L', NULL, 'M-G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e3d52c21-688d-46aa-a10d-b75554b02785', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33X34', NULL, '33X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e3d9a231-07d1-4610-b2b3-573fc446077e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8XSHORT', NULL, NULL, NULL, '160/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e3ee920a-057a-41d9-aefd-182e9b21fd5a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e3ef7634-ee04-444a-86c7-e85623dda05d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '9/8/2024 12:00:00 AM', NULL, NULL, NULL, '270/96', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e3f61d1f-c215-4781-b110-afe015b3ffdf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '30 P', NULL, '30 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e3f78c4b-e27d-4a27-a412-6d3f16c170b9', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6PLUS', NULL, '6 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e402f240-bdb0-44e0-926c-d845de71ddce', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '4', NULL, '4 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e4155f5a-ecc7-4ce6-9f82-d68d807943f4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e41c5ef1-aa3b-4a85-92b9-db287d7ebc91', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 / 30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e44ace1e-4841-4eb6-977b-e5f544d97e03', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14 REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e44dfc44-62f2-4cee-9d8b-7a499a6705bf', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0', NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4520061-b411-4f7a-bd52-bfc3c770d7e9', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '38L TALL', NULL, '38L LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e46b8e7e-c7b6-4db1-8ae8-d737ee864faa', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e47e8221-9bf3-4404-aa2b-10b91fea7d28', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e48cfdb5-b60d-4959-a21a-98b33293861a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10TALL', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4929963-f8e6-40ad-a98e-1a46c69aff4a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 S', NULL, '20 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e492dea5-336c-458f-b6bb-53b1708cbc60', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00L', NULL, '00/24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e497351f-d32b-4dc3-af60-2cd7bfd6c4e5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28SHORT', NULL, '6/28 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4b4b001-82d8-46ca-98c8-569616291af1', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X29', NULL, '29X29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4b89411-e0c7-4cd7-a39f-8fdf30328d68', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4bdb695-502b-4763-8ae2-0693dad2616f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9 MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4bf77a5-45cd-48c3-818c-e7bd271b0d25', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '4-5YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4cf50e5-d0d6-405b-8f21-e75c890abb5e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6 MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e4f9ccae-2d14-4ccb-bc62-53f5b7286faf', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'L', NULL, 'G', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e4fb81e2-3fa3-4be8-a632-ff46fa85fb34', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6REGULAR', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e51c02eb-f8be-4741-838f-8dc3a379b40c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 PETITE', NULL, '000/23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e521c5d6-0a84-44f2-9ddc-e7b42c0fde4d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '20P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e5226586-846c-43d9-bc34-68c98f2919b1', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS P', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e529f167-f379-44c3-b199-766a744e1bdf', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '24+ REG', NULL, '24 TAILLE FORTE', NULL, '165/116C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e52cb2dc-c69d-43c0-9518-6a94f1030f1b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'M T', NULL, 'M GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5377d8a-74b7-4f3e-9b82-fa0735569805', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e53b0c1e-5b6a-4491-ab6c-ba6fb4e240b0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12P', NULL, '12/31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e53b4696-15f2-49fe-bf0b-0a30e5f1c91e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/M P', NULL, 'P/M P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e543cb80-97df-49ad-9e9d-689f5300446b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '24 P', NULL, '24 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e549dc30-2eaa-407c-baf2-58f350dbf4fc', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e557bc4b-2e9b-45f5-85cf-a2d03b45846f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20/ 35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e55abd72-c8e2-470d-9cac-173caf31639a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 A', NULL, '8 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e56b74ab-8387-47d5-9b39-e411bd324ccb', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12HUSKY', NULL, '12 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5774457-2b71-4e77-a984-c1dd41dac80d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-892d-cdce-f20b0f379e09', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e57d2161-0be4-484f-b34c-62eb66b84709', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18 SLIM', NULL, '18 MINCE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e57dfc8a-1365-4bcc-ac1f-cd6a9acec2fb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 SHORT', NULL, '20 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e57e8019-f4ea-400c-9ec6-5ec552b72a14', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '31L', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e57f08d8-86b5-42e2-8c2a-b6a1ccf86438', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-ccce-3509-cda52df613f7', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '185/200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e583f035-5acb-4ebc-9d45-4e2d531a0c71', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XS/P', NULL, 'TP PETITE', NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e5a140b2-f51a-4c02-b296-b8ac75c50349', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 REG', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5a42b9d-6394-442a-94b3-830862fbb11d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL+', NULL, 'TTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5a643c9-4754-4a6a-af76-373003b49107', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5a96789-dafe-43f4-ae3e-52af72e81dd5', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-181a-962f-d59f2bca32ba', 'OldNavy', 'M', NULL, NULL, NULL, '165/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e5e4b59a-bd10-4175-aaff-bc335e2d6a0d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-c1d4-cbc5-e3c060b978e1', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5f320b6-0e53-4038-a3ad-fe44bb7a4b69', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'S', NULL, 'P', NULL, '160/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e5f61b89-a441-4e3c-b22a-6384fb602f44', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5f7d7f3-e2f7-488a-8dfc-6eccfb76b44a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L/XL R', NULL, 'G/TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e5f7f97f-537b-4588-86f0-84f2a053b993', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e5faaf5d-aadc-47ad-95d7-b92bc3fbbe72', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '6SLIM', NULL, '6 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6071a32-c9a0-40c0-8a8f-9e8af7ce3b73', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '27/4 Regular', NULL, '27/4 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e6100c8b-f938-48b6-bffd-31e19325503e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '9-12MON', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e61e835c-a824-41f8-940f-9ceff79381e0', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e629b349-ba2a-40f8-9332-22da23454e25', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5 REGULAR', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e62a93db-b029-4c45-95ac-0df5e57fe92b', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'S PLUS', NULL, 'P (6) TAILLE FORTE', NULL, '120/64 -6-7 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e636298b-7a12-4edd-a14f-82df945b6697', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6TALL', NULL, '6 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6398aef-b95c-4008-a9a1-1f0803c60c8e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e66d6bb1-aa1b-429f-ba52-1cec80457ae5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XSREGULAR', NULL, 'TP Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e673f5a7-ab0d-4abe-8452-94b96e8f0f29', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-e8b2-5dd9-3b632877d4b0', 'BananaRepublic', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('e67615b6-ce0b-4a14-b2a2-549f8010bb5f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X 34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e68e3ccc-45f6-4597-8549-47e04d8260ad', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6 TALL', NULL, '6/28 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6956b2d-19da-49e4-8cbb-2eea2a005266', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'S/M ', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e6970553-f334-4af6-9280-842bede1e164', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '4 XLONG', NULL, '4 GRAND', NULL, '165/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e69d764c-9d7d-4144-9011-0923aeefcc48', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e69dbc49-58d4-4d53-84ac-7bad422e0bd1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00 /24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6a8aaac-cee9-4b2a-8bba-83858b5edae0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 REG', NULL, '20 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6af122f-9523-4c42-9c10-329b9335df6d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20 LONG', NULL, NULL, NULL, '175/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e6b743d8-f8c4-4f29-accc-d2db94b571d9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6bc31f2-861a-449b-978a-f0f05d92b2d6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X34', NULL, '36/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6c7594e-7284-42d9-b75b-f59c1d1689e3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'MHUSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6d546e4-9ba2-42c3-85cd-a0c896fbbd15', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e6d9669d-3bec-4af9-b336-b7cd2298896e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3ef8-39f6-24846a19acc3', 'Gap', '4-5 YEARS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6e5c90c-8681-45c7-b8ed-fb3e771a8fd7', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e6f079df-a4ad-4d24-a370-8dd69651dd4a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL REGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6f2d7ba-a8f1-4dd1-b184-3194ab8d11b6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e6f7c365-d6e5-4fd2-938c-1b251d6b489e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XL-XXL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e70286ab-05f9-4796-ac39-0fa261f5ca2a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 X32', NULL, '36/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e702d38f-ecbe-444b-85f9-b45e1866c660', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e709da2f-518a-4172-aa54-62fbd3127e1c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'MHUSKY', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e70b1b16-9f17-40c3-acdc-f6947492e407', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '180/114A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e70fc73a-be62-430d-82b5-29b8cd9aa927', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 X34', NULL, '40/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7137b78-b64c-4cef-8e75-e4f1fc70f972', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'SREG', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7158733-f870-4cf8-845f-586164f10d9c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e724820f-6bad-4e45-ad99-36d665faa777', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'MREG', NULL, 'M Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7429f4d-0fb6-4137-8e9a-c00a408eb9a4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12 SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e742e0a7-7cb3-4fb3-8d59-1e663c4a9be6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000SHORT', NULL, '000/23 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e753247c-19fb-4f54-843c-e9954fb95fff', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '6 TALL', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e7532e83-aff8-45f0-ad1c-691e81fce1a6', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-c903-74cb-ec08fed5be7c', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '53 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e75930f5-90a8-4cde-b9f0-22c6efaf8509', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '25P', NULL, '25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e759ae33-4c02-481c-b330-f4fcdf30a0ce', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e764e73a-d226-4064-af58-67e1bdadf14e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '6 SLIM', NULL, '6 ÉTROIT', NULL, '120/53 - 6 岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e76f88b8-c330-4c22-8028-48416ab9033d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XS (4-5)', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7812821-1dd3-44c9-92b0-94c7a36d04bb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 X 30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e79d06b8-5e22-4bc0-98f4-675fbcb8a0e6', '3a0b68d3-2212-b852-827d-34a4e881d20a', '3a0b68d3-2385-a1a4-298d-af4fc558fbe4', 'Gap', 'M34/W14', NULL, 'H34/F14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'NULL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7a916e3-0519-41b1-84ca-365495bde8d4', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XS', NULL, 'TP', NULL, '110/60 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e7a9b126-7322-4141-bca1-9c706534d450', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30X34', NULL, NULL, NULL, '180/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e7dd0d37-676a-477e-89ef-164ea380187e', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X34', NULL, '30/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7eedd3f-b2a7-437f-8721-53213fde96a0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '12-18 M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7f795df-87b2-4bb7-a331-903840d0d185', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-5e96-a141-900f95a616df', 'OldNavy', '6T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e7fc007b-324c-4c62-baf0-373707d5ac35', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '8HSKY', NULL, '8 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e7fc8595-d71e-46af-8486-cfbca0e8328b', '3a0b6926-08fe-86e0-4dbb-48d694bc3ca8', '3a0b6926-0ca4-61af-173e-25fcb35f13f6', 'OldNavy', 'XL', NULL, 'TG', NULL, '背长 x 胸围 64 x 104 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e7fcd68a-5aeb-44f4-b94f-f5560c5c6988', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '41 TALL', NULL, '41 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e7ff0ace-307d-43e5-994d-73a078252548', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28J', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e80454e9-5e3e-4d21-a9f1-0a1cd8f04c41', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e804ed56-97ae-4cd2-99d8-58e189b7201f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '20 PETITE', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8061d50-c5b9-435f-a8df-cfe6c1de1590', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8 SHORT', NULL, '8/29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e816ff19-9136-4f94-996d-9eccc9ab76ab', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'OldNavy', 'XL', NULL, 'TG (11-12)', NULL, '275/98', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e81e73fd-6dd3-436f-9e6c-6b9d5cf362af', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '34 X 34', NULL, '34 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8265296-29b3-4d0e-bb71-91e823252518', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '0-6MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e82d3732-55c3-47f1-9d33-d3ec1f0b868f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X28', NULL, '30X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e836659d-643a-4fe3-a7a2-dc8de31568bc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35/34', NULL, '35/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8414367-ad90-4bf7-ab2c-a3ed98fb562c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31LONG', NULL, '12/31 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e844e950-bf7d-4f60-b396-645c0160fc1a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '12 SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e845fec1-a7ce-4906-9149-fd94cd1eaabb', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '42 X 30', NULL, '42 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e8521bf6-3a9f-4b41-9553-00ae241cd8c9', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '20P', NULL, '20 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e856a99e-0ab0-4839-a30a-360e17cfa337', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '36', NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e865ae75-cb56-4030-9e47-39b9d4b3d24f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 S', NULL, '16 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8826b5f-ffc5-4bb2-8e0d-d467f9a2a11f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25 R', NULL, '0/25 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e883d67f-6857-4aa0-9f38-2516e5bf610b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '1P', NULL, NULL, NULL, '155/62A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e8878200-1c1d-4826-a3aa-f56b35c159a0', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1XSHORT', NULL, NULL, NULL, '155/76A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e88b5056-bcf8-4ab6-baf4-9fd43b038ff2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e88e3c4d-a313-4050-b304-0e1d781f25a7', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '12R', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8a52484-138c-41e4-bb2f-1d17bf9a1c1a', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '25 TALL', NULL, '25 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8ab7ea9-eec6-4523-a687-f91b7fc961d8', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8b06148-2c78-4c98-9860-765a9eb4f98a', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-95f4-5e2d-6496a4b3517d', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8b75c13-1dcc-4a9e-9e3b-cae6a24d6b51', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-65ec-cfe3-3a0689e94ccc', 'BananaRepublic', '3-6 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8c99e23-36e6-4763-b39e-1f71349c1091', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8da9497-b905-4ac1-a17b-1cced0814f8f', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-1229-2ce7-628852840be6', 'BananaRepublic', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('e8eff806-389b-48a2-a4f4-0c9330a63d94', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29 X30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8f80a6d-1fc0-489d-a28e-7df12191c836', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24 MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8fa8f9b-46aa-445d-9ffa-8231bdca565f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24SHORT', NULL, '00/24 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e8fe33cf-4ac1-4544-bbbd-556f6f2563a2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 X30', NULL, '32/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e901b5ae-a020-4f3b-9e85-37427f02f9b2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30X32', NULL, '30X32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9070c32-9017-4b75-be55-5e23175d410b', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e912a086-e255-4c1e-ab8e-f9cf8324e42c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e914ea3d-5ad5-4b39-a21b-733f5b1873df', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '00', NULL, '00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9184447-123b-4994-9832-9f36ca5c75f5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'SREGULAR', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e92378de-e1ee-4624-80a6-ce502ff95ca1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 PETITE', NULL, '12/31 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9259417-2c5c-499f-936a-15e603efb418', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bd98-bcb5-9f7d345d46d5', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9261d53-d239-4499-aa9f-48a4514f4eb5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26', NULL, NULL, NULL, '165/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e9353fe7-38f8-4d6d-843c-919e53f1e178', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-5e98-8d89-1c1c318078cd', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e938055a-3f96-4d78-a0d2-cd0d8901ff06', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '32 REGULAR', NULL, '14/32 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e945e5eb-981e-4116-b12e-d72da22f888b', '3a0b68d3-2212-f21a-e4f3-da1e2e18f0f9', '3a0b68d3-2385-edc2-d5f2-e9b9d62dc915', 'Gap', 'M34/W14', NULL, 'M34/W14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e94626b8-9fff-4c12-bdcb-13870c21e04f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '32 /36', NULL, '32/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e946f1a2-9ca9-4d9f-806f-4034f938c3cb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 X 32', NULL, '44/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e948fa4e-a1ee-4d48-b350-b4cf56665edd', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0 / 25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e954e0b7-6576-4ce8-8829-0def67fd573a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XLHSKY', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e95ad8fd-75b0-4299-aa61-bab623110e78', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14 SHORT', NULL, '14/32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9793102-ba48-4d77-b4a2-e2cc99b75b7e', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '18-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e99748ee-746e-4528-aa40-24eeb2f01f66', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-34bb-7876-d77e298f6e65', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e999bfdc-a372-4ffc-8a42-d3fd471e6446', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 /28', NULL, '30/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e99c40f9-414f-4059-92c1-6d351ff03f4d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL REG', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9a18035-e87b-43c6-b36a-f463326c825c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9a4b7c8-2336-4a9c-88c5-659302218f63', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXS+', NULL, 'TTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9a94510-a44e-456d-8fda-3560a7468cdf', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e9af7982-15f9-4188-bb52-54164eb747c9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-6MONTHS', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9b0a704-862e-4cad-9fdc-45f61cdb8773', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34/30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9b57d2d-539f-4c1c-95c9-72606b6d2416', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '28 X 34', NULL, '28 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e9c1925e-5b7c-439e-b19e-fb8df3c98987', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 L', NULL, '20 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9d0c29b-89ae-47a4-8cc1-1ee5a5fbdaa8', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '10+', NULL, '10 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('e9e42ae7-9594-4ca6-8ac2-ae80bd9d9735', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'L', NULL, 'G', NULL, '175/105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e9e8d06b-c9d4-4a3b-9a43-c3d9b24ab1e2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6PETIT', NULL, NULL, NULL, '155/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e9f470d9-327d-48e3-8e29-cb8d8cbcfd1f', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('e9f58cf4-dbf4-4dd4-bcc8-bc39c8f3bcf2', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '6T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e9f9115d-bd52-40ae-b2d5-60c9dc3d4e0a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('e9fe8654-2af1-4212-b588-d8b4e4517267', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '44C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ea1dfcd2-5287-4e01-b570-334f9edd7e98', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20P', NULL, NULL, NULL, '165/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ea29ff40-8a1c-4697-a066-2a284d38ae78', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '14REGULAR', NULL, '14 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ea2b62f6-46b0-47d1-96d2-5aeaa7fc037a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9743-d440-2b15e78e046b', 'OldNavy', 'L', NULL, 'G', NULL, '140/80 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ea51dc61-a95f-4c99-8f96-0afff5e4d648', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18/ 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ea59ef57-7085-43b3-aa7f-255918db399e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XS REG', NULL, 'TP (5)', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ea687e0c-a1fe-425b-8fc1-79f22726df5d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12PETIT', NULL, NULL, NULL, '160/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ea6f6047-136b-4f3c-8126-fa11597f2ed9', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ea8705d5-4130-497a-8ab5-c6f54df51459', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ea9afe1f-ac5b-43f7-9b44-408098d60219', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '6-12 M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ea9db162-4b0a-4ef2-b2c1-976866051444', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL HSKY', NULL, 'TG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eaa17bc8-587a-463d-91ef-bdb175d78d7b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0TALL', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eaaab7da-4556-435d-8ef2-23be3b4fe67f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXLP', NULL, 'TTTG PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eabb751d-8558-4d26-abe9-69af61c89514', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '20 LONG', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eac0a507-87e3-453d-bbe8-503bdbbe1151', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('eac4a122-fc1c-42af-8427-1926964abd48', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10S', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eac75716-f947-4366-a99e-8d6b45ece6c6', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XXL', NULL, 'TTG (14-16)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eacd0115-4be4-4701-9de3-c0f957b898d4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '40', NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eae4fc77-c2d6-4b70-831f-7d811b82bbf5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24REGULAR', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eae725d1-2018-40c3-a1b2-6cea2991937c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eaea0ad9-a33d-43ea-a5a5-0a343d5b3bcf', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35 /30', NULL, '35/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb1260cc-8903-4cbf-a0c1-7f3802769a03', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '18-24M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eb322deb-0638-4338-afe3-4e18dabc88a1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6371-deee-be9c48fc0e81', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb3a9477-e794-464a-8c4f-a0a90c4a61d0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XL REG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb3e06b7-eff1-4bd3-b8f4-c1e8bad4677b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M', NULL, NULL, NULL, '165/95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eb3fa218-95c5-4a60-8712-cf868843ef37', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42 LONG', NULL, '42 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('eb43d869-0a56-4086-b865-bffc32a3275c', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('eb4d5dd2-00a1-423e-9d0e-103c1d9fceb5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '000 T', NULL, '000 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb69a306-37b5-4cfa-80c0-27893afb07d0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 TALL', NULL, '12/31 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb6bfd73-9a0b-41cc-87d2-2865d72a15fe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12MON', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb728266-3202-4848-89d9-4c658c6dd7bb', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'M/T', NULL, 'M/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('eb7475fa-27ab-4f55-9fef-d75060875006', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XLPLUS', NULL, 'TG (14-16) TAILLE FORTE', NULL, '155/80 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eb77abbc-d49b-4a60-b69f-70a3aa185563', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '00X 24', NULL, '00/24', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb7a2617-03f7-49e9-b074-c98c9d60ec99', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7', NULL, '7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb7d3ce5-a0f2-4c25-b7db-3348af0e0f5a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 / 28', NULL, '38/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb83cd0c-dd65-4b3f-ac6e-abf712edbf6c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'M P', NULL, 'M P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eb89fee2-9acc-4705-8249-0047240553cb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M/P', NULL, 'M/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('eb8b85b0-68be-4efb-a1bc-3f8594649ea3', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e0c4-3d01-392cff3b7df9', 'BananaRepublicFactoryStore', 'XS TALL', NULL, 'TP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('eb916a99-d900-4c71-9e82-10b9d8b8f108', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1016-d539-c4328a2f8e84', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebb21eba-2745-4e8d-8389-915958b167bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Gap', '4 (12-18M)', NULL, '4 (12-18M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebb76389-3555-4490-813d-32197cf85a29', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34X 34', NULL, '34/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebb9c937-ad49-4f20-a9b2-b9201576b27a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XS', NULL, 'TP', NULL, '110/56 - 4-5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ebc1ae11-e920-46f5-9605-f3007f204cb6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '42', NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebc5d2da-6ffa-4711-9707-7886f765a71e', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9288-1490-7d3f59b8d0fb', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ebc6ae96-d1d5-4051-abb9-b9025f2ab81d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '7 PLUS', NULL, '7 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebcb379e-a956-4126-8fe8-624ec21b7b8d', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '38X36', NULL, NULL, NULL, '185/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ebcefe6a-1fb1-4a60-8392-d56af4fd6b6b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XS P', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ebda454d-ac3b-45c1-bd12-75b974b6422c', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '9/10', NULL, '9/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ebdbad93-1624-4368-8a84-8f7c1806f3ed', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ebdd84bc-717a-4956-bf3b-abc9ebb9dd65', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '10+', NULL, '10 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ebfebde9-5ffb-421a-8117-f066f75efee7', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-85de-782e-4460e0b7a850', 'OldNavy', 'XS SLIM', NULL, 'TP (5) ÉTROIT', NULL, '110/52 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ec033cbb-e233-4d86-bb1c-81914b4e32c4', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublicFactoryStore', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ec04a411-7ca7-4ceb-9712-65eec357553a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '0T', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec1e72fb-dc4d-43da-9491-662b7d7d00de', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-a1d5-cf51-a9b4ea3c2a91', 'BananaRepublicFactoryStore', '9.5 ', NULL, '9.5 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ec306532-bb27-4aec-8456-8b2d4a1d2bb1', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XL 17-17 1/2', NULL, 'TG 17-17 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ec3b7fff-0ff8-43ad-aedf-5be9c6b5c641', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec40c6f6-b07e-4f97-aa0a-9f3fc2847fdd', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-c181-a8bd-98f9701619cf', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec450d57-e25c-469c-844d-15ebbe52a5f3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXL/T', NULL, 'TTG  G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec5ae8c9-433a-4e3d-a4fa-e26905eab0ba', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '27 LONG', NULL, '4/27 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec67f4cb-a829-4d67-948c-4525ab50cb78', '3a0b6926-08fe-07ab-f486-f54a2dd49b82', '3a0b6926-0ca4-2be0-758a-06e232d7f0f6', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '****', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ec68241e-133f-46df-9985-aa678ee3902e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-6c3b-9e47-5b492b7fb0db', 'BananaRepublicFactoryStore', '35/20 TALL', NULL, '35/20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ec765218-17cb-4520-b4df-edb55d126e74', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'SHSKY', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ec868dd3-ffa8-4597-b818-f018b5ca29ea', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'XXL 18-18 1/2', NULL, 'TTG 18-18 1/2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ec88def7-aff4-4bf6-b8e1-2bb0d5472d21', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '44X34', NULL, NULL, NULL, '180/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ec9c1db6-95bd-4e4c-ac97-77a2a97e73bb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'XL TALL', NULL, 'TG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ec9ff28a-06d4-4b04-84ab-0de669638514', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4 S', NULL, '4 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eca28c9d-56e8-41bf-8f78-f4950e745b2f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XXL SLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ecaf490f-0960-4c71-8001-22c4e25ee72e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2 LONG', NULL, NULL, NULL, '165/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ecb94642-2418-4cf3-a14b-7bff040b87ad', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '29', NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ecbfae7d-3925-400f-b129-0fdaefcc9634', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ecd0c19d-f92e-4cda-9c40-18d7ce243e57', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublicFactoryStore', '0-3 months', NULL, '0-3 months/mois  0-23 in. 0-58 cm  0-12 lbs. 3-5 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ecd265b4-3b85-4ac6-8fb0-27dc19f0856a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'L PLUS', NULL, 'G (10) TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ecdc5878-9029-4369-bc56-a8316fc96dc6', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '7SLIM', NULL, '7 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ece53959-3c61-4976-a5ee-91d8e28425cf', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', '1', NULL, NULL, NULL, '200/74', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ecf76369-e4bf-448f-9aee-71e293f228d5', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20.5', NULL, '20 TAILLE FORTE', NULL, '165/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ed00fd07-ba36-4b06-b11c-69d2d1fdc509', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL/T', NULL, 'TG GRAND', NULL, '175/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ed107124-06a9-4fe0-9f02-6dd2cf0c82fe', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-2772-0f83-1ae9ec1022cd', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed14a333-2f67-4063-bafa-36ae523227d1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-d68b-3231-c25588a50a7c', 'BananaRepublicFactoryStore', '6-9M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed1e334f-fb77-4506-8efd-e1571da79d6e', '3a0b6926-08fe-487c-b42c-3e08fe71ba71', '3a0b6926-0ca4-4898-5c90-cde054079121', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, 'n/a', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ed20b8ae-4622-4d5c-9c09-ba0771ada54f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16 SLIM', NULL, '16 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed27e895-83ef-45ab-ae32-01fd765e20fc', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XL T', NULL, 'TG GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed36d811-482c-4698-9c69-fd871ee2d50b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33/28', NULL, '33/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed41db38-449e-48c4-bea6-0aad023375fa', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed440f07-99cd-45a8-8f1b-09d797784bbe', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ed542436-2cd6-4447-9ec8-7179834e0255', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-78e0-56d4-fb41656408d0', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed5c0248-d78d-4303-80cb-51ab5e7d2804', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-ee1f-b48b-6e651abe46ec', 'BananaRepublicFactoryStore', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed66a2eb-de0d-41f6-a4fb-41ddaaeacdb1', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'L ', NULL, 'G ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed6ab203-d751-4438-bde5-9634ba105f34', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-72dc-48c2-2c6c278580a1', 'BananaRepublicFactoryStore', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed741482-3fc4-41e3-9df2-99eb4be4e6af', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 / 32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed7b73d1-9505-4c59-8ce1-96a3d1aa21c6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '33', NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ed7da7c7-6e9d-4aab-8f4d-2744a7adef4a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ed801f22-68a2-4df0-9ceb-4d5f11870799', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-28d9-e5da-9797f8fc4682', 'Gap', 'ON SZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('edb0ced8-5b61-47f3-b4ad-dbad8fdc669d', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '00 Long', NULL, '00 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('edc0ae45-660f-4f3b-816b-a83908ede59f', '3a0c74c8-3055-d9e1-c906-afbfe9051db5', '3a0c74c8-3226-ae8f-6362-9bc6a2639bb5', 'BananaRepublic', '6.5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('edc67666-4f18-423e-9cbc-466bb27eaa83', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bf97-a6bc-52d444c90887', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('edc96446-15c5-4ce4-b5eb-179e65145ec5', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '25 P', NULL, '25 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('edcad150-44e7-44de-ab90-1b9e837ec4b9', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5b49-14b8-c57b35a022e2', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('edf6b918-6c94-41b1-aa42-25392030bcc3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XL REG', NULL, 'TG (14-16)', NULL, '155/76 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('edfeade2-fbbb-4131-bcc2-228bfc557535', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '12-18M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ee03b8a6-97a8-4e98-b94a-32c3655ae3fb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 /28', NULL, '36/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee1426dc-62d5-4b8a-9897-6b4ed8e23e59', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'M', NULL, 'M (8)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee23222e-8186-496b-8cfe-7bd4d2d5f035', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 SHORT', NULL, '2 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee244ee1-41e8-4917-8fd9-38585086e136', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'OldNavy', 'L', NULL, 'G (9-10)', NULL, '265/96', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ee25e8ed-8d6e-4346-88c1-473c6d143932', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-db72-ed40-794fde312607', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee345ae7-2aed-4c34-8a2e-ac83c8e4ff5d', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'XXS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ee398662-03d1-4818-99c2-92c5924ae29d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXLR', NULL, 'TTTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee3a5f85-273c-4b47-959f-4ed7684765f0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XSP', NULL, 'TP PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee4264a0-7990-418f-be87-7483c17e7b6d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee4e4e00-e321-4124-b3ac-a1a3ad2f5ec0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '24 TALL', NULL, '24 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ee584534-fe4d-44c0-a3d1-05545b9da479', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5 REG', NULL, '5 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee5ef7bd-dc1e-4290-9b25-45770f5415a4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/30', NULL, '36/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee60cc72-9ed8-4754-9879-680704696f49', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '9.5', NULL, NULL, NULL, '265/85', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ee70a083-1ef6-4869-bdfd-dc72cc7ad095', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-7e1c-3613-fdf6db3bee11', 'Gap', 'S (6-7)', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ee79f3d4-86bb-42c3-a531-22e1f348b456', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-8e64-27ec-f8416d8a762f', 'OldNavy', 'XS', NULL, 'TP (3-4)', NULL, '225/88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ee7f427b-7e18-4935-8823-0451ea2b0579', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-9ac0-f8b2-0b3914709ddf', 'BananaRepublicFactoryStore', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ee908d5e-7867-44b4-b54e-fffac541c7b3', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eea483f2-f108-416f-97b3-2dbddea8ca54', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-d02c-b2b6-d2120b13de33', 'BananaRepublicFactoryStore', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('eeae7221-20b9-4414-a00c-adb932684837', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-31cc-d3e2-aac078914a1c', 'OldNavy', 'L HUSKY', NULL, 'G (10) TAILLE FORTE', NULL, '140/76 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eeb16539-d322-44ff-aed8-87b9db798df6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '42C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eeb4f9b6-8c3d-4594-a516-b09110922778', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '31 TALL', NULL, '31 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('eeb585ce-d025-48a7-b249-8ba6fac35165', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eeb70a35-490d-4a6f-b687-c0fc178a83bf', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12 REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eec4b014-9b8f-4e98-bbde-8309ed4b2b5b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eee430fe-1505-46b9-8bb3-dd613501f72d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '30 X 34', NULL, '30 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('eefeb2ea-c0f7-4ef1-ac96-963be6592a11', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublicFactoryStore', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('eefff4fb-5486-485c-b743-5dc76a2a0021', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '2T-3T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ef03c5fa-c94e-47a1-87f1-fc4baa7f1c96', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '0 Regular', NULL, '0 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ef04e3a5-a219-465b-82eb-094c2ac52db1', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5119-2c68-4a208711d430', 'BananaRepublic', 'Small 28-30', NULL, 'Petit 28-30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ef0a15a5-862a-4920-9f32-4968fc0b4ab6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6T', NULL, '6/28 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef0f034f-15e6-40c3-acb9-d6b097eb8909', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', ' ', NULL, '0/25 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef10a5ce-7e7b-4018-a2b3-ae558139082a', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XSHUSKY', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef161da5-26dc-45a3-8bda-fc9b984bc662', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8 XLONG', NULL, '8 GRAND', NULL, '170/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ef16899e-a824-43b2-9c49-d3ae5e856344', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '26 TALL', NULL, '26 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ef251216-81d4-4259-9a9f-ac06b617d0f4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6/28', NULL, '6/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef2b0991-587b-4c78-9893-d8cb4551254e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'XL REG', NULL, 'TG (12)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef4010e4-3f6b-4dd6-a791-5425c397be85', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-65c2-1cb4-e8b699a38e29', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef442fe7-8c96-422b-8427-a1d1e43f573b', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '10', NULL, NULL, NULL, '280/98', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ef448c06-508e-434f-8f08-d9c979303112', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'M +', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef460f95-e05a-49e9-93e0-2632d6b7aa18', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-239e-8f2d-ca7f0c846556', 'BananaRepublicFactoryStore', 'XXL TALL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ef494495-39fb-4081-860c-a2814e1197b5', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X32', NULL, '31/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef4effdf-011a-4379-a137-459946ad78ca', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10/30S', NULL, '10/30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef4f1813-2f58-42e4-8af3-6e38d5ab7735', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'LR', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef51d6ac-ae5e-405f-8285-f0432ce93d12', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L P', NULL, 'G P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef5fae93-1299-4416-b17a-eb5b7dae45bb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X 32', NULL, '33/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef6eecfa-3287-4eba-9621-9a697d54ed64', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 X 30', NULL, '33/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef734ec8-27d9-42f2-b1d9-b4202a254861', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-57c5-dd8d-3f495b0c94bf', 'Gap', 'ONESIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef747607-cb46-420a-9df7-53eaf9ffda80', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-2772-0f83-1ae9ec1022cd', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ef748878-2717-42f7-9d42-693ec3def573', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ef8aa7fa-105f-4705-bdea-071fe5d7502a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4PETIT', NULL, NULL, NULL, '155/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ef903694-eaf8-434f-9c4a-20e1c4f72e79', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '31 X30', NULL, '31/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('efaf6b69-39eb-4fbb-b13a-2a770e00d6bd', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('efc7268b-1921-4f4d-a99a-ada22fb06073', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '10 TALL', NULL, '10 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('efcf49b7-d72a-43f8-b851-4914040d10b6', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '2T', NULL, '2 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('efd3c1c1-a0ed-4aa6-aa37-5ccdc9baecaa', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '36', NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('efe42b3e-db28-4eb9-8bd5-44997c4c46f2', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XS/T', NULL, 'TP GRAND', NULL, '165/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eff33a2c-5f6b-48c9-95ee-e727811e8f31', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-c903-74cb-ec08fed5be7c', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, '56 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('eff92ba3-6972-43e4-8dae-c211f6fcd6f2', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '18-24 MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('eff93e94-0e33-493f-b71f-8239385a0a79', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'XLREG', NULL, 'TG Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('effafcee-facc-4bf5-bd12-1ea7259ab565', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f007f0f3-62a8-49f5-97d7-2ab31e731f1d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '18 REG', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f015b29b-de94-46ea-855c-add40da2b6bf', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40R TALL', NULL, '40S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f0259e7c-8dd3-4f15-8e2f-a0371fac4a18', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '26+SHRT', NULL, '26 TAILLE FORTE COURT', NULL, '160/124C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f0316f97-365a-40e0-a231-95a31ebe950d', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-de5a-9612-43ec872471ad', 'BananaRepublic', '6-12M', NULL, '6-12MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f0424ef1-c8fc-4108-a507-2210ebb9c89b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10R', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f045b715-b9ba-4564-9370-27908310e55d', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f048921c-bab6-4064-88b8-1883a53ef900', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f05f23de-7f15-4840-8a4b-7ac77cb4778e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 LONG', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0620549-bbf8-4ae8-99e4-bd23e0dc9ef1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '12REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f06f7890-692a-4d45-8793-54046bef2288', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'S/M PETITE', NULL, 'P/M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f072246b-28a7-49c9-90da-18b5747d41b8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-93a6-bd30-0a8a2e3774d6', 'Gap', 'S SLIM', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f07f4edf-050d-4850-beae-eb309203bb89', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXXL+', NULL, '3X', NULL, '165/120C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f08620d4-deaa-4fc2-a7cf-1b7deacec73e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4R', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0913933-85d0-41bb-bdfb-01d320d8a2ba', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '35 X 30', NULL, '35 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f091c6b3-3334-4d4d-a2fd-83a6ad190824', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10XSHRT', NULL, NULL, NULL, '160/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f092a98c-f7c3-4692-b07b-b4ce2befb6c4', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'MREG', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0939e41-b9c5-4cad-9bb9-0417e5954703', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '12', NULL, '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f09e1db1-1e7d-47c0-945b-3740a20fbbdb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6fa3-b15b-97ae4c9f11b7', 'BananaRepublic', '8S TALL', NULL, '8C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f09f0164-a02d-48d5-a20d-218bc169461f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '4 REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0a85a9d-9b68-40a0-b7d8-cefab0a48b29', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublic', 'XXS TALL', NULL, 'TTP LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f0a878be-6e6f-4694-8771-ab94d2e93c78', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-e80b-83b7-c89d3d332af4', 'BananaRepublicFactoryStore', '10 Petite', NULL, '10 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f0b4103b-1ec2-4235-beee-b33209351a5c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0b759ed-bc48-4f2b-91a6-a10283a1bf8b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0be4111-bd66-496a-93d2-d55dd0f7718a', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-ae4a-b884-905829162a3c', 'Gap', '9/10', NULL, '9/10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0c6e1cd-75d7-4f33-9572-f86fabf1535a', '3a0c74c8-3055-8590-30a2-d59a6faa10a7', '3a0c74c8-3226-0dea-f135-65769ae7f1f4', 'BananaRepublic', '14" x 24"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f0cd4e2b-0fdd-4336-90a3-58493c824c30', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29X36', NULL, '29X36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0cdea4e-44fa-4d16-8e89-4c9a6441d6b0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3e15-4cfc-a32f220ed4f2', 'BananaRepublicFactoryStore', 'S 15 3/4" 35 5/8" ', NULL, '  ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f0d374f9-0509-4a00-b043-3b543d1d2064', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '000 / 23', NULL, '000/23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0d3ada7-8e4c-4c20-84a4-1a3cac1a29a5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10 SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0d5e036-efe2-4aee-a0d0-c3ee7f8a40fc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'M+', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0e4d781-3431-4268-b39a-e43318a84ab5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'XSREG', NULL, 'TP RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0eb338e-edce-4767-a0b6-6fe28f76fc19', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 TALL', NULL, '000/23 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0ef6f43-b345-43b7-84e2-ca43009a6d56', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f0f78456-ec2f-40f9-b9d3-1b98262fe18c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XXL HUSKY', NULL, 'TTG COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f0fdccf8-967e-4e87-a1af-027b779c747c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f102f819-02ed-409d-a9d3-8e732ed24fde', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3d60-e564-8bcfae4a6f98', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1073184-0abe-4589-bcff-0082b47304dd', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-30b0-326c-b9d978d477e6', 'BananaRepublicFactoryStore', 'XS/S PETITE', NULL, 'TP/P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f1085445-8562-4826-82bd-41446be0bb11', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '24 P', NULL, '24 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f10f30b6-7195-4ebc-a03b-ff5209543c01', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '38', NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f119520e-342c-4d8a-aa94-b08ebacce4f4', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '28 S', NULL, '28 S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f12d53c3-98bb-4746-bdea-c2d75bd663f2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXS', NULL, 'TTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f13c22d0-bb10-4642-87b7-13f6053344a7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '26', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f1504550-04ca-4b06-8613-147a328192c7', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f15b2d3e-09fa-4578-8f0a-f4b06bef5cbc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L/T', NULL, 'G GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f15db238-c57d-4a05-8a83-a2a300ee321a', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL/T', NULL, 'TTG GRAND', NULL, '175/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f164a643-81f0-404c-a065-3f66e25f2065', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24MON', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1803938-0a61-49df-8270-cdd1287ebe47', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-294e-b136-9c9270278a10', 'BananaRepublic', '14.5 x 32/33 = S', NULL, '14.5 x 32/33 = P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f181236d-5a36-4441-999b-7d8d619df4f8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'SREG', NULL, 'P (6-7)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1853e85-99a7-41fb-afba-54f4cb2b49ae', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25LONG', NULL, '0/25 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f18963d9-0a5f-4b0c-82b1-f8558bc719a7', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '40 X 30', NULL, '40 X 30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f18b0c6b-7ae9-4d31-867c-ec22dda039d1', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-a6b3-12d8-9aaa7ebbe499', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '180/125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f18e82d9-24ec-4f9d-b5b9-87023b4d6177', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6209-fa67-ce299a8617ba', 'BananaRepublic', 'M/L TALL', NULL, 'M/G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f1905961-665b-43b1-8c23-6178d99a9319', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1b505ce-c4e5-480d-96f2-4c8074833209', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '13', NULL, '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1bed107-99e7-4ba5-b3c6-2e65b1331f52', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a0c74c8-3226-a857-7dde-6c178b17ea37', 'BananaRepublicFactoryStore', 'L', NULL, 'L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f1c431ce-c22b-4307-aec2-0ba5fede7419', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-acab-cf36-334ffe531b27', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f1cddba1-be29-42f3-a8a8-11753bdb6b48', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33 T', NULL, '16/33 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1ddefa9-f155-4e91-8c2d-5452de75114e', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '31 P', NULL, '31 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f1e7769c-b300-4abc-a01e-c874088ef096', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f1e78c33-6af9-4e41-bb19-df94e9da8aad', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '32X30', NULL, NULL, NULL, '170/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f1f3e9ac-adf5-45bf-9d32-9d45b2a478b4', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-6ba5-b59d-e89c5f9ccf35', 'BananaRepublicFactoryStore', '0-3 months', NULL, '0-3 months/mois  0-23 in 0-58 cm  0-12 lbs. 3-5 kg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f2024e9e-446f-47f7-a1bb-d10f6a5d250d', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-5f2d-51dd-3e395b9f99d0', 'BananaRepublicFactoryStore', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f2038d6b-cda0-4c74-bc64-aa758af8b2e6', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'BananaRepublic', 'XXL 44/46', NULL, 'TTG 44/46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f20d7eb0-9097-420a-afe7-f8298b6a2bb3', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XLHUSKY', NULL, 'TG (12) TAILLE FORTE', NULL, '145/72 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f21d527e-ed0a-48aa-912f-352bae60a124', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10TALL', NULL, '10 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f21e07e8-c0f9-4c6e-bc81-c9694ec15837', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '14.5', NULL, '14 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f21e6c6f-f99b-4620-8042-44578be57fc1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e3fd-2bf9-cb79d0e41b94', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f226e7ca-dc8b-4722-a3e0-ae59bdd9f24c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L SLIM', NULL, 'G ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f230349c-2f74-4b0a-9148-1a7a05e72c65', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32P', NULL, '14/32 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f236e1f4-0eec-489f-86b7-3c2dba06e5fb', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-6c93-243a-2d4dab67cd4d', 'OldNavy', 'L/XL', NULL, 'G-TG', NULL, 'length of belt x width of belt MM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f23c27c9-ad84-4920-98f0-8c82d0fb88ab', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f2448f41-3662-493c-8cef-408b32a0b9fd', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '4T/5T-Notuse', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f24ae1e8-1ed3-4344-a6d1-c7a1d594e28c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f24e6893-dca0-4ba4-a945-1294e7a11cb4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 X30', NULL, '30/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f25b91be-0813-483e-8dc0-f94b19cfd2b5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 T', NULL, '0 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f25f65db-db10-48d4-9cae-3a5feef2026a', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-fb6f-bac8-57f4e0d4ce13', 'BananaRepublicFactoryStore', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f26006a4-6faa-48be-8378-7468a293e954', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '50X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f266f174-d3f5-417a-b5d7-7e32e3a77cb0', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '32 DD', NULL, '32DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1E', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f267f12e-a917-4e32-93c2-31b3188b87f6', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3f6d-09cd-2106f3ac8347', 'Gap', '12-24 MONTHS', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f26aa8c6-431b-4027-a02c-c28df0504547', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '23/000 Long', NULL, '23/000 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f276ba4c-378c-42e8-81a5-607c065d54f8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '6REG', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f27f308f-4548-443b-bd66-b798f8380142', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '35 TALL', NULL, '35 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f29f8840-8771-4e03-b22f-c6b28380f962', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '40 REGULAR', NULL, '40 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f2a03b92-0a19-4a35-bcd4-4424f7ab7dfa', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f6e4-a677-be3223b85d18', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f2afeaeb-563c-4971-a564-a5f0ae0f756f', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10 LONG', NULL, NULL, NULL, '170/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f2b2a2f1-7132-45f5-9bd7-1bc3547bd0c5', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a106a3e-aa62-b404-5ce0-c85cc3b25989', 'OldNavy', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, '53-59 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f2bc0b10-4e63-48ec-b759-36ff0ab10503', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '6 SHORT', NULL, '6 COURT', NULL, '155/70A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f2c170b6-aa99-40e8-ba50-56a42306ffd5', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '6-9MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f2c95c90-2c7b-49f9-a0a3-44e1d302e714', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '14 HUSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f2e9526b-2278-4209-b0db-439eca811081', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '28LONG', NULL, '6/28 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f2f1a274-785d-4767-8885-582c7dbc0435', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '4-5 YRS', NULL, '4-5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f30b5e3c-2291-4e23-b2ab-41501d8ff499', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24S', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f30d744b-6eeb-4c21-abe2-930c5e5e75e2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f323dc7b-b63e-4526-b587-2f89781d04c8', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-a690-b134-df6418cf7c2b', 'Gap', '8', NULL, '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3252c25-e62d-443d-ad5a-4d289e0ec431', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '29/ 30', NULL, '29/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f33dcf07-3540-4407-9f12-747ed08ebb95', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', 'XXS/P', NULL, 'TTP/P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f349d1c4-573e-4bd7-a837-b284034c0290', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f34e444f-5262-445c-82b2-d8bd0300fd94', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '33 / 34', NULL, '33/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f35012cd-a9be-4afc-9712-93ebca3d4dcb', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-115d-073b-d5507bc89a5b', 'OldNavy', 'M', NULL, NULL, NULL, '165/100C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f354c002-ef1b-4cc2-8fc3-fd5156544319', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XS PLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f356b8e7-66e5-44b2-bde5-a2eba4ff74b3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6S', NULL, '6/28 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f37a6fe6-57f8-43cc-97ad-0b8905238db8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/28T', NULL, '6/28 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f38ed62b-bcc5-471d-80ca-f32c038814e8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-c54c-828c-01a7ba3f226b', 'Gap', 'ONSZ', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f39008d4-d6b6-4140-8e38-fa8c469d74fc', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XSHUSKY', NULL, 'TP (5) TAILLE FORTE', NULL, '100/62 - 3-4岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f3929676-ce0d-405e-8863-7043c96a6799', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3c559bd-0927-466e-9ffc-c08ef4fd8d27', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '10SHORT', NULL, '10 C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3cfdf1f-cca7-4e89-9716-77435be8c207', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '33X32', NULL, NULL, NULL, '175/84A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f3d1027d-13b3-4abc-a3b3-590aec63720f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36/36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3d1d319-111e-400a-8d3e-431d64ee7882', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-f595-0bad-a02861647b77', 'OldNavy', 'L', NULL, 'G (3-4)', NULL, '215/78', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f3d1ebde-79dc-4341-b121-bbd168e76ca6', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-1ced-36e6-c8ce19bd75d0', 'BananaRepublicFactoryStore', '26 TALL', NULL, '26 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f3dd7768-0259-4022-a7e0-9cdc584880b7', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '1X', NULL, '1X TAILLE FORTE', NULL, '160/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f3e72780-4d44-4072-b289-aeccbcf4cafb', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9MON', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3f48f9c-d698-4ee6-98c5-24f9581f7673', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0 S', NULL, '0 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3f71f2a-71a2-4cb6-8aa5-69886af1dafa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'XXS/XS', NULL, 'TTP/TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f3fb1d29-4022-4092-aeed-05b40becfa80', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '30S', NULL, '30 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f4180704-765b-4bce-9b51-fff03b743f79', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18MONTHS', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f41a70eb-39b0-46ce-ae58-6755233381e2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '25', NULL, '0/25', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f423ef3a-9dc4-4a29-9445-07a57bbbff07', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '29S', NULL, '29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f4366636-b4ff-443e-9764-4100c7dcc477', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '4REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f43f85ed-baeb-4da6-a49c-bb5e54274df7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6a88-4f26-d7c2e8c4a94f', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4422a4c-b1f2-4a15-b306-c352c5e8d3bf', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-f453-97aa-6b3e564746a8', 'BananaRepublicFactoryStore', 'M TALL', NULL, 'M TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f442415a-5345-4921-9451-34f18580010f', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '4REG', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4547b29-6061-4888-9553-593dd88652b8', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'LREG', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f474271d-bb06-4539-bec2-e2a18085f653', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4/27 S', NULL, '4/27 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f47a9382-2c33-4c50-9370-fca0e4c57606', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '9/8/2024 12:00:00 AM', NULL, '9/8/2024 12:00:00 AM', NULL, '260/83', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f48204c8-ce69-4cc1-b40f-b4593a17752e', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '170/80A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f48776df-f71c-40f2-85a5-5f17005869f5', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f4920187-93c7-4971-bede-53f8c30d8113', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f4a4968f-85d2-46c3-8f47-094c68b3c440', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00T', NULL, '00/24 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4a85058-01b9-4936-9c5e-023b232c4307', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 R', NULL, '00 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4a8cc4f-7684-43a4-ab86-4a6780ea6b02', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24TALL', NULL, '00/24 G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4b1423c-96dc-4ea0-b0d1-f7ae0419afba', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38/36', NULL, '38/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4b3aa2f-c432-4a71-9492-886095cb1042', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '32 SHORT', NULL, '32 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f4bdcc26-ebef-467e-a105-2715e9ea9473', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-3dbd-7cf0-fc3d70abc36c', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4bdf5c6-43c3-41f3-bebf-204b7528aa11', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40/ 30', NULL, '40/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4beddba-6f7b-4922-b161-9296c9da5318', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-e622-8c83-a74f34cd201f', 'Gap', 'S REGULAR', NULL, 'P RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4c21c23-ed29-40bb-86d6-2d977e979f9a', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '10HUSKY', NULL, '10 TAILLE FORTE', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f4c44bf3-002f-4c03-8235-d7a81a42eb1e', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'XL 17-17 1/2 35-36"', NULL, 'XL/TG 17-17 1/2 35-36"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f4cad7b5-9d6d-4ba4-a655-e6e90a73a198', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-5981-531c-629f152fffa4', 'BananaRepublicFactoryStore', '12-24M', NULL, '12-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f4d07929-cb1e-45f5-a607-a48312b3106a', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f4d1f9be-06ae-4bb1-8d10-74aed9f239a4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X 28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4e57a2c-36b5-4c65-bc98-d3fb9ab095d4', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9394-6e1e-c67cd721e736', 'OldNavy', 'L', NULL, 'G', NULL, '22-24 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f4e5b920-4b76-426f-838e-a3132b8314cb', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'M +', NULL, 'M PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4f02b3b-7917-4d4e-a408-7f40a6e49206', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-653d-c2c0-2c8b2c81e5ec', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f4f0ee36-a5ea-4c0b-b279-6efc09758cd9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-57c5-dd8d-3f495b0c94bf', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4f8a43f-92e0-411c-a5f1-318db3ec3010', '3a0b68d3-2212-1980-c64e-bd99eecc1c92', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L', NULL, 'G (10)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4fd8825-5795-47a0-914f-2d6b1943e3e5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2LONG', NULL, '2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f4fe0a55-c51b-47e9-b211-9ce14a981685', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '42S TALL', NULL, '42C LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f50a3e0a-49a4-4822-b521-c21bf450035f', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f523dda9-de09-4372-ad1e-20248ac3a31d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-05a7-f748-523f45b5d3cf', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f52541e5-cbc7-4335-b172-0b863ba1342d', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 /34', NULL, '38/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f53d3342-4498-4a7e-b934-dd0f130dbdcf', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-e0f5-638c-a7ce0ee6e415', 'OldNavy', '3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f540b5f5-33b1-4cef-b335-56a64cfd3f5d', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublic', '3-6 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f540d190-3fe1-434b-a32c-b62fe37796a3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXSPLUS', NULL, 'TTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5489b62-cc99-4ccd-8577-7cce87b1a90f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'XL/XXL', NULL, 'TG/TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f54fa62e-a32a-4eb6-971c-eb39f5abcbb2', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '12-18M', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f551662a-0224-484d-971e-466ce49b99ff', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '28', NULL, '28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f558bb3d-186e-4b18-a818-b40fa4ff8f61', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', 'XS', NULL, 'TP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f5727ba9-9a6e-46cd-8477-3fad5bd5cfb6', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', 'XLXSHRT', NULL, 'TG PETITE', NULL, '165/112A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f57d8706-d346-45de-b966-d77833a0d206', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', 'S Regular', NULL, 'P Reg', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5923415-08bb-4866-b098-ef6309023279', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6a69-8a3c-e6a0450600ea', 'Gap', 'XXXS', NULL, 'TTTP', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f59236d9-efa7-4b6a-914c-72c5930c236b', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-1bd2-c5c8-107005c7fed7', 'BananaRepublicFactoryStore', '46', NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f5956065-0fd6-44a8-a74c-362aea9c2d18', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XS T', NULL, 'TP GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f59f7a39-e514-4fb6-a383-8f5dfa5613d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '2 L', NULL, '2 L', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5a39087-a084-4010-b537-8a8e295100aa', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '16', NULL, NULL, NULL, '170/108A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f5b0fbda-9def-403a-aa4f-b3c2519b1ecb', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '6 P', NULL, '6 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5b2a69a-c258-40b8-9a77-78cf983c7e77', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a106a3e-aa62-f114-8571-ec68ec3bdf3c', 'OldNavy', 'S/M', NULL, 'P-M', NULL, '56 CM', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f5b343ac-ebc0-491c-a41e-d61194151f9c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '5', NULL, '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5bab8e3-5434-43b7-b287-1f09eddef81b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '6-9 M', NULL, '6-9 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5bdebf1-d31b-4ee0-99f4-a3f61b365e03', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '12SLIM', NULL, '12 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5c07f5d-a6d4-41d6-bd61-63e889b35813', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-b0d7-6a69-0477ba9ace51', 'BananaRepublic', '28 P', NULL, '28 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f5c84a21-e48c-4ee7-9f9d-1e9b681481ec', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7.5', NULL, '7 TAILLE FORTE', NULL, '130/65 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f5cd8d80-711f-4079-963f-4e50e23da794', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '2-3 YRS', NULL, '2-3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5cef46f-f2e8-42ea-be1b-3cd4872aadc5', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '31 R', NULL, '31 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f5e318d5-1736-4a49-ae3a-70c15667a047', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5ebd8df-e220-434c-815a-b70bca2914be', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-c616-3965-4eefa8115c62', 'BananaRepublicFactoryStore', '26 P', NULL, '26 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f5f63d4c-368f-4633-a5a8-259c83a60dea', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f5fa6189-91a8-44b8-b334-78fbe84f0de5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-2c79-402a-89bcf126a7fb', 'Gap', 'XS REG', NULL, 'TP (4-5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f602e8ec-9559-4d77-98da-47d1b41bc3f3', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e73c-1bbe-1211cba4847a', 'BananaRepublicFactoryStore', '31 Short', NULL, '31 Short', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f61891b9-36de-40a2-8c58-c1e7210de5d7', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '2T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f6237d39-e751-4be3-add1-ee6a56ebd770', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36 /36', NULL, '36/36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f63a2d64-a840-4576-b526-796fbe8d4400', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '32 X 28', NULL, '32 X 28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f63c23a5-1e11-4b99-8b94-b3fcdd97894b', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-6a89-2501-9d7ae73292fb', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f63cf74d-c2e5-4458-b3d9-0cb5a9279802', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '6 LONG', NULL, '6 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f64119db-66df-4771-8954-058f294f49fc', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublic', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f64e9759-8341-41eb-984b-0936b2a524e8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '28 P', NULL, '28 P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f6647c72-08ba-479f-94fb-dea44a0dbf57', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2S', NULL, '2/26 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f66b3bac-52e3-4ee4-aa1e-89e14f206293', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0856-7830-3e34768ec693', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f66c57ac-d142-4733-8dac-fbb1332e6b6d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '30SHORT', NULL, '30 COURT', NULL, '165/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f6782f5d-bf16-4817-bd2a-809ae6c64160', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-faed-5a98-49473fd9de44', 'BananaRepublic', '12-18 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f678f1c4-b63a-47f5-92ea-d383cf39da5c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-bcc8-a8c6-db3442c27e76', 'Gap', '6-12 MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f67c9462-0289-4a11-90de-bf7083a7566b', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-b099-d4c3-c664a4da2766', 'BananaRepublic', '6-12M', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f69ea2a6-a7e5-4e4e-bf7c-9ec3b2b93ac3', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '00 T', NULL, '00 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6a14afd-b88a-4383-8da6-28574b5dc42e', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6a90e0f-77d6-475a-bffe-0628b16f4eee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '23 P', NULL, '000/23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6bf2bc8-945f-4bc6-9a21-87b7fd6b0ca5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4 REGULAR', NULL, '4 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6cb29dd-5584-4f9c-a5e7-a6a47fcdcb7f', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3708-1eca-242b4d964916', 'Gap', '6-12MONTHS', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6cb70da-0592-4d27-ae58-24ca8b8ae690', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublicFactoryStore', 'M 15-15 1/2 33-34"', NULL, 'M/M 15-15 1/2 33-34"', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f6cc944e-8f87-4764-b652-697aac89f5bf', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18', NULL, '18', NULL, '170/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f6ce7cf7-4153-4fce-b46d-698b1073f74c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-43ba-4d32-d4765755b21f', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6d00c4c-8a90-4697-ab02-1fe36c28043e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('f6da9363-09be-406f-a866-b748c7ba34b8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20R', NULL, '20/35 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6ddec59-cd7d-4009-ac3a-211f88ec8ae1', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '000 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f6e466ff-8a12-4e72-aafb-181dda50245f', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'SSLIMTALL', NULL, 'P ÉTROIT GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f6efffc7-c469-477a-801d-5675047feafd', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-bc1f-3916-49fd6e6b6be3', 'BananaRepublicFactoryStore', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f6f11c8e-cfef-4c6e-8b18-3a837a68431b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12X 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f7062a2f-b70d-4d75-a17f-e96fe16f2676', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f70ea6f1-6bcb-468b-b184-70027630444d', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-0700-897d-c39ccfb96386', 'OldNavy', 'XL', NULL, 'TG (3-4)', NULL, '230/80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f7129ae9-b25d-47a1-8c80-8271392ee792', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-073c-15cf-a05caab09529', 'BananaRepublicFactoryStore', '16', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f713d4c9-7e05-4ada-b2bc-06073e7d6b61', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-fd64-57e4-7bef61f3c9f9', 'BananaRepublic', 'L TALL', NULL, 'G 16-16 1/2 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f722d3b0-af0d-4d92-9fdd-c87858819ccb', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f725bc04-6152-4741-b6f9-796a9e3639cd', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-7af7-a571-8563ee8178f9', 'OldNavy', '6', NULL, NULL, NULL, '240/90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f72ae268-0265-46ad-8804-d5f303642fe1', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '14 HSKY', NULL, '14 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f72c312a-020f-4a15-8317-66d4cf7b908f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24 R', NULL, '00/24 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f72ca2ec-b2e5-411c-b182-8bde8b44f243', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '2T/3T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f744e5d5-d703-4b4f-860b-245928724e30', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '5/6', NULL, '5/6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f75defe5-fe90-49a4-a9bd-8775f6cdca5e', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XL', NULL, 'TG', NULL, '155/76 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f76cdd65-8347-44f9-84b3-0674cf037fb0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '24/00', NULL, '24/00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f76ed538-04a6-4cb9-a02f-a79fc9753643', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '18 REG', NULL, '18', NULL, '170/118C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f7950bb4-8166-44d7-aa87-121269c31231', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f998-637f-ce5c291a25d8', 'OldNavy', 'XXL REG', NULL, 'TTG (18)', NULL, '165/80 - 14岁+ +', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f7992499-5fa3-4c64-a23a-2a8110cb28eb', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40X34', NULL, '40X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f79b4694-936f-4542-a21e-93848f70b83a', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '0-3 M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f7a8b035-3c3f-4680-a828-8ac8660b8ef9', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-b084-b7de-42dbcd76f10c', 'OldNavy', 'XSHUSKY', NULL, 'TP (5) TAILLE FORTE', NULL, '100/62 - 3-4岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f7af3f1a-5739-43fc-ad62-9c2ca1cf474b', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-c587-c46d-719b8ea0cd95', 'BananaRepublic', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f7b0b4c6-d516-4a41-b8e1-2be7d5d58b91', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-84dc-dc56-7785cebf7a4d', 'Gap', '6-12MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f7c171b0-ad57-4c6b-a6d8-d2a4ad57d61c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16L', NULL, '16/33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f7c9ff36-404a-41a9-a39c-43f0dd5bcb50', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L XLONG', NULL, 'G GRAND', NULL, '180/110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f7e95c43-08cb-4064-8f8e-91985d1fdb61', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XL ', NULL, 'TG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f7f882d2-48bc-4e7b-a303-56d0a92fbf4b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '8PETIT', NULL, NULL, NULL, '160/88A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f81815be-a721-4891-bf5f-ebf964f645b4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '36X34', NULL, '36X34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f81d5b39-126b-412e-9096-3332b556feca', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-e6c0-b44d-dd249d23c3d2', 'Gap', 'XXL SLIM', NULL, 'TTG ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f81eff74-7f51-4518-b264-78e7497e8275', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8 REG', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f820efb1-c3e8-44fa-95bd-00c76437e2da', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXLPLUS', NULL, 'TTTG PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f821c7a3-f4ab-4065-96b2-2525eb01f28b', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-f066-2dd1-e82ad6bdd362', 'BananaRepublic', '4P', NULL, '4 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f82ec6bf-73f6-427e-a0b2-cc464a0234d7', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '44 X 32', NULL, '44 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f83c83e7-7700-468d-b07b-db0c81e44edc', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-d145-94a8-c29267eb9430', 'Gap', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f83cb606-06e6-4fbc-b1ca-c4600ff1519b', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d286-1223-13acf0a2fc6a', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f846ca31-6b2d-4190-b77b-c7580a9a5824', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '10REGULAR', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f84aa693-f6f5-4054-b0a8-5731a2a5a13d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'L +', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f86a52af-b50e-4bf8-b286-b2f44e247327', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '33J REG', NULL, '16/33 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f87441f7-ee53-4626-a8f3-dfefd0be6d32', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a100889-485f-29c6-ce4e-984a2cb974fa', 'BananaRepublic', 'XL/T', NULL, 'TG/T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f882fc64-6bc4-4cc3-b9f3-571266a7d7a9', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-a512-98bc-8070412bba03', 'BananaRepublicFactoryStore', '32/14', NULL, '32/14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f88ea056-dbc6-4dde-89d6-7edb16a5019d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '8 LONG', NULL, NULL, NULL, '170/98C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f8902c0b-daa5-4b21-bd31-61c2f2b6363e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'S/MR', NULL, 'P/M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8998269-d1d5-4310-b678-778f59cd9e26', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-3acf-8c37-cbe28f17dc76', 'Gap', '38', NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f89ebb55-22ee-4bd1-aee9-a8930f2f1020', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12 M', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8a15bf7-e6bf-4cc6-b4db-fad2fa2ff5fa', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '4', NULL, NULL, NULL, '115/58', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f8b1747e-9243-4abb-a16b-e7a460252672', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXXXL+', NULL, '4X', NULL, '170/155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f8b65b0d-66b9-4723-833a-3dd65c6d15e9', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-8b39-054a-d3e12d9bb069', 'Gap', '3 (6-12M)', NULL, '3 (6-12M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8b78041-17b8-422e-b547-9ed4ba230044', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28 X28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8bd033d-dad3-4363-a6a3-e252b055ce19', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'S', NULL, 'P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8c3de12-e4f8-4e00-8701-5660fc6cc288', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16', NULL, '16', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8cdcea1-52ee-42a8-9338-d2b01e57b3c4', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '16REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8d1d3d4-61cc-4ffa-9826-fd94d82e6821', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22 P', NULL, '0000/22 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8e4f1b4-d1ec-4967-bd92-418d73881d07', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38X28', NULL, '38X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8e62b98-544b-48bc-9621-b5bb9964e83f', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'XXXL/P', NULL, 'TTTG P', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f8fe0b25-60e9-4b6d-ba94-b9ead74aff69', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f907bc05-4a3c-4e4a-acb7-7830fdf3e131', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38B', NULL, '38B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f90dbdaf-929c-4aa5-bb5e-5b0fbf317f1e', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-9623-3863-60e0355d6341', 'BananaRepublicFactoryStore', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f90f4cd8-b37e-4533-8831-d4152898cb85', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f9157a98-77bd-4684-8593-cc0d085d4caa', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12/31R', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f921e1fc-23c8-47a6-ac98-381368d06c51', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f92561f1-0a63-4bcc-9b37-e9251d195876', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f9273a38-fd4a-47da-af0e-4f89915682d9', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XSPLUS', NULL, 'TP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f92d4391-66b3-4180-821b-1bbb43e1f270', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30/ 32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f931a80b-a35d-46db-b704-c9b1527cead0', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f9480bd1-def4-4421-8ef6-4c04cfd91148', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-db85-3f9d-ad89a1e54891', 'BananaRepublic', 'M 32/34', NULL, 'M 32/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f9509bbb-2972-4b96-97c6-274165bb8b3e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-137b-fb18-a410b3d8b42a', 'Gap', 'L T', NULL, 'G G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f95c9d3b-d342-4b15-84cc-09fdd4b30019', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-5149-66c7-b6a4bc91654c', 'BananaRepublicFactoryStore', '2 Regular', NULL, '2 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f96602cb-3e03-4e9b-a455-f275c242339b', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-7628-c0e7-2953753a67e1', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f96cc304-7830-43ff-89a4-32c9548ad45c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublic', '20 TALL', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f97d7b66-e349-4964-870f-f71241ba8b60', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '20/35', NULL, '20/35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f98de4f8-13b5-4439-b995-1e805c0fbb98', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20', NULL, '20', NULL, '170/122C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f992a4fb-eccd-43b8-ad2e-74c6bcca8ec5', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-ff5b-9d4e-c827ac82c155', 'Gap', 'L', NULL, 'G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f995c2a0-4625-4ff9-b573-f6e4e397ddcc', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33', NULL, '16/33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f995fe76-c564-4171-886c-26e306566903', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '33 LONG', NULL, '33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f99697f7-88d3-4277-bd05-70a9548394f1', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-cf24-8093-38ecac76f375', 'BananaRepublicFactoryStore', '12-18M', NULL, '2 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('f99a3e37-8919-4114-9114-a66cb45b7419', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-7e09-0459-326b6b1dd706', 'BananaRepublic', '14P', NULL, '14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f9a58c65-0318-47bd-bad8-44d609fddc47', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-9187-3993-eec83afd5079', 'BananaRepublic', '18 TALL', NULL, '18 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('f9aaae98-c520-45d4-b0b3-adbc62941017', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000/23 P', NULL, '000/23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f9d04551-11e1-4426-8492-3f379ebd80bd', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '24.5', NULL, '24 TAILLE FORTE', NULL, '165/136C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('f9e70aaa-21a3-4577-904f-4e92bc723c44', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '11', NULL, '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('f9eeada8-4e24-4099-9a9b-c5477e059582', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-3896-7659-36de4c2659a7', 'BananaRepublic', '3YRS', NULL, '3 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fa012b36-dbb4-4d56-910c-6bfa564d1d4f', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-9dea-c90b-7e86d1563623', 'Gap', '1', NULL, '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa073c77-0b21-480a-97bf-d6c1114053c4', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '28L', NULL, '28 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fa11dcfc-e23d-4c3f-81fe-a1ec5e629b24', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '38 X 30', NULL, '38/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa135d46-17f7-444c-a520-908ca114c0d1', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 TALL', NULL, '4 GRAND', NULL, '165/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fa33bf23-d24d-4ff9-85ea-bdd464732538', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '4 XLONG', NULL, '4 GRAND', NULL, '165/66A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fa3bcb5c-b96d-4d10-b20e-b37aeee0df3c', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa412d5a-b9b4-47ce-ab9f-7bee7aa50ae2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '35 X 32', NULL, '35 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fa49194c-efbc-44c8-94e8-9e686bb48b0d', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'XLREG', NULL, 'TG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa495481-a0be-44e9-a60a-0919efce0bf9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', 'XXS/P', NULL, 'TTP PETITE', NULL, '150/56A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fa4bdc15-3fea-481e-8516-805b460fb73c', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10SLIM', NULL, '10 ÉTROIT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa580340-2e53-4f40-a3da-c08431993473', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-6b0b-b6ef-f1d4c229dd73', 'Gap', '3-6 MONTHS', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa59085c-40a4-4fe5-966d-dbad59dc1eed', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28X30', NULL, '28X30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa5ba777-7f15-4759-a356-97ce3a39832d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-3bdb-a34c-6ad8f019fc9b', 'BananaRepublic', '46 TALL', NULL, '46 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fa5ba916-f7aa-4c0e-b8e3-bcbff56feaee', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'M/T', NULL, 'M GRAND', NULL, '180/100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fa5c1073-a345-430e-a4a2-f088be2a0f88', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '18R', NULL, '18 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '54', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fa623188-ee4d-4ba9-b5c0-935e748ac531', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a100889-485f-d450-f5c4-b21605a5f7ab', 'BananaRepublic', '6-9 months', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fa63a8ac-b2f0-4a3c-b436-b549f914d45d', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '12 REG', NULL, '12', NULL, '165/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fa697134-f34f-4a43-8895-30e83aa9ebeb', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '32S TALL', NULL, '32S LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fab0133b-8ea5-479b-851f-4c0890f739ad', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '0L', NULL, '0 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fab2d5e3-daaf-4872-94c8-425277d16ec0', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '18.5', NULL, '18 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fabe8350-01a9-414d-8fc9-8e4f7f83b436', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-e664-0d4a-802b70dccec0', 'BananaRepublicFactoryStore', '34 X 32', NULL, '34 X 32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fac3d446-9f95-4ba7-8dde-33a11295dbf1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000/22T', NULL, '0000/22 GRAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fac547fb-9927-486a-8d73-508a62d34673', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-d54c-eb9a-88a10560dec4', 'Gap', 'XXS', NULL, 'TTP (2-3)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('facabe9a-7f03-4c7a-a45f-34bdac430b27', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '2/26R', NULL, '2/26 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('face87ff-4bc5-4a24-8ab0-79c14a58fa9e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-0476-1efc-c7e324dc8878', 'Gap', 'M/L', NULL, 'M/G', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fad02e58-1c06-4937-9c7a-3f01b0f15028', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-665a-dc0a-0d918034f3aa', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fae26abc-5735-4915-93e8-0ab49fa24199', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-526e-90f7-7cc14c10d669', 'Gap', '5 YEARS', NULL, '5 ANS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fae7cac9-9905-423f-a7e6-6e739c30491b', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'M P', NULL, 'M PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('faf0cccf-b16e-472c-af7d-f5c831780e24', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00/24L', NULL, '00/24 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fafc8727-c1eb-420f-a13c-498f0bd9d3f1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'L PLUS', NULL, 'G PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb052de5-be46-411e-84c3-b5882d3817fe', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a100889-485f-bf2d-8d60-97bbac1690ea', 'BananaRepublicFactoryStore', '0-3 months', NULL, '1 (0-3M)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fb20b25f-c937-483d-94b0-10e5c6442b02', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '0-3 MON', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb2d0882-7ca9-4753-ba2d-a5e378c4be67', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '31 LONG', NULL, '31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fb474010-3da0-4ea6-95ef-06ebe3e64679', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-8bac-8990-02a7108a446f', 'BananaRepublic', 'ONE SIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fb575271-481c-4191-8cc4-3e2dad8bfb00', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'L P', NULL, 'G PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fb5a8d57-761e-4dcc-b4cb-3917693a366d', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-0a85-a337-a156f5d60f44', 'BananaRepublic', '12 LONG', NULL, '12 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fb5ac6c8-67b2-4a8a-8668-542590b123f2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33L', NULL, '16/33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb5fae79-4da8-4c9e-ac00-3f9506798868', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12', NULL, '12/31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb65f334-be41-4721-9530-44120f5c1df2', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42/30', NULL, '42/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb6b2160-10fd-4640-b78f-2eef1dacdc06', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31 LONG', NULL, '12/31 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb71bd3e-1cd8-46c2-8f32-b477aaa50d05', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '0000 /22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb79942b-c65e-40ed-a2e7-dea79f8bb946', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '4HSKY', NULL, '4 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fb92ab33-d0ca-45dd-92ce-c18fac756cf0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '44 X30', NULL, '44/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fbaf50e0-2881-464a-8f7f-1ed6c041baca', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '40D', NULL, NULL, NULL, 'D95', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fbb6b1be-19eb-4527-8d70-0397e9bb2512', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '31REGULAR', NULL, '12/31 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fbb9cc1b-b0ad-4ca6-bbc6-a2200bb2fd75', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'L', NULL, 'G', NULL, '140/72 - 10-12岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fbbaf276-dbf4-4970-8097-668de8d6533c', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b694d-4649-3f22-109f-5127025b58be', 'BananaRepublicFactoryStore', 'M/L ', NULL, ' M/G ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:15:23.401417', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fbc30cda-86e4-4757-9205-40edec162515', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '5', NULL, '5', NULL, '110/56 - 5岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fbc95bdd-9948-4176-99c0-5520907fc8e4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '12-18 MON', NULL, '12-18 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fbd344b3-4354-4c56-97eb-e74100979cf9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14 TALL', NULL, '14 GRAND', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fbdc775a-f69e-4af4-b136-7f71d1573cfa', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '16HSKY', NULL, '16 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fbed6aaa-fc99-4330-8bb3-f8ea464fa945', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-78a9-7cd2-8a37d35b1cfa', 'Gap', '32', NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fc0fcb04-343f-405a-b4c6-1ebb336b5aa5', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-38e9-c516-81a50eb39d13', 'BananaRepublic', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fc1fcfcb-e245-42e7-858a-a049ac678ac8', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-5e81-5d97-9c364694e3bb', 'BananaRepublic', 'L TALL', NULL, 'G LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fc2a7380-94e0-498d-8e93-bba18e899294', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', 'XXL', NULL, 'TTG', NULL, '165/80 - 14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fc30d9bc-7a15-43a9-a8d1-ae39691780d8', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '22+LONG', NULL, '22 TAILLE FORTE LONG', NULL, '170/110C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fc33cc19-4011-4695-8eaf-20af00153eb1', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '9-12 MONTHS', NULL, '9-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fc3b7906-930d-4e27-bbee-445431ffe485', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-b145-0caa-e4343a0c238f', 'Gap', 'S/M', NULL, 'P/M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fc4eaa81-4d66-476d-98ce-2b475cabe46b', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '8.5', NULL, '8 TAILLE FORTE', NULL, '130/68 - 8-9岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fc56d8c0-9249-4074-a4ed-e53acfb99ebe', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-3b60-b833-94cf629eb613', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fc5ef15d-6ac2-48f4-a1b1-66b64557af28', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '29 TALL', NULL, '29 TALL', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fc6cf330-e8e5-4153-b284-d10db5e16d97', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '12 REG', NULL, '12 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fc90ec3c-d8b0-45df-9b8a-43f688aa467a', '3a0c74c8-3055-373e-14b2-d2a1eea21a91', '3a0c74c8-3226-a470-563a-6e1450651ed3', 'BananaRepublic', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fc967bc1-204e-40e6-b554-f8151565494f', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-6b4d-face-acdb8b1fde70', 'OldNavy', '8.5', NULL, '8 TAILLE FORTE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fc9f9d0e-34ac-4d9a-bb9e-58d1326c56b2', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '18 / 34', NULL, '18/34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fca57ba1-0101-4dac-817b-1786d8552866', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '20+SHRT', NULL, '20 TAILLE FORTE COURT', NULL, '160/104C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fca6d874-dea7-4b35-a662-da1aec9bdf57', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16 REG', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fcacd0fb-ea25-4dc5-bd69-4313502f8bd7', '3a0b68d3-2212-7d16-13f5-a57d6adc7199', '3a0b68d3-2385-77fb-d480-787e4a5756f1', 'Gap', '10', NULL, '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fcb02c6f-bbbf-4517-93b5-359db5ac1ea8', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '29/8 Regular', NULL, '29/8 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fcb33041-94e1-4e50-8b48-c963ebbc1d13', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'XS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fcbba493-c8aa-4357-956f-57cc9a62eb6b', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('fcbca027-8b2f-4a77-b717-9ef4c84df722', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a1079d2-b3a5-e9f0-cc7f-20816f22f069', 'BananaRepublicFactoryStore', '20 TALL', NULL, '20 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fccc9ebb-7c9d-4c3d-917f-29038f49b89a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', 'XL', NULL, 'TG (14-16)', NULL, '150/64 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fccda3b3-c87a-48ad-abac-47c35befc862', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-80c6-83bd-2a580112b620', 'BananaRepublicFactoryStore', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fccf0e71-aa72-41f2-ba20-22c3418ff97d', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '32DD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fcd9f78c-0ebd-4fb2-b2ed-695321b4a148', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '12 X 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fcda463a-9078-4425-a5ca-f5201a145ce3', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-6683-f003-ec05899cd254', 'BananaRepublic', '33 SHORT', NULL, '33 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fcdbbe17-3c46-4e2a-86c4-2e90da7fe555', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-d6be-4bab-1f0592376efa', 'Gap', '3-6MON', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fcde54db-87da-4431-93eb-421ee5e7e324', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-055d-65db-4f96521cfbb4', 'Gap', 'XL', NULL, 'TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fce9c5b3-9595-4e6e-990b-20e4895ba9a2', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0c74c8-3226-aa69-9b30-fa711dd8c161', 'BananaRepublicFactoryStore', '0-3M', NULL, '0-3 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fcec29aa-0821-4e1b-b8bd-d83606dab886', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a0b6926-0ca4-50c9-c2fa-3011248a6a45', 'OldNavy', '5T', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fcf6552f-f83b-45e8-8491-59b1d88245a2', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'L REG', NULL, 'G RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd1703fd-5823-4c5b-89df-0797f57486b5', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '12 X 31', NULL, '10/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd18ef07-2656-4ec2-9d97-dfdafd8b0c5b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '16A', NULL, '16 CHEVILLE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd226030-f845-4e4e-8fed-cddf7eabfb9c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '6 X 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd26c65f-d21f-4ceb-998d-7ff35c5a40fa', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-c096-c719-d4a93239e342', 'BananaRepublicFactoryStore', '4', NULL, '4', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fd2943b1-6a0b-41f6-ab91-449f9e5abcde', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-6e67-f64e-5d99caacaec9', 'Gap', '8P', NULL, '8 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd296584-53b2-427d-941e-4d638bdc3335', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '12', NULL, NULL, NULL, '165/96A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fd29f787-a1fc-43d9-b176-cd1c2c92c27d', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '8/29 S', NULL, '8/29 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd37c320-5172-4ddb-bcca-65ad7b03d59e', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '29L', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fd43f678-9286-4023-a25b-2909930b9723', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '20', NULL, NULL, NULL, '170/120A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fd45a71c-46b5-4225-91c4-6dd5ba550f38', '3a0b6926-08fe-7da1-34e1-cd0d98d494e0', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '0 SHORT', NULL, '0 COURT', NULL, '155/84C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fd538f69-ca3f-4e8f-959d-7bc5c7f6cb2a', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '24 SHORT', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fd680dc9-96ae-459e-9579-1179fa280c80', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-8906-a6f5-1bd475b4a83e', 'BananaRepublic', '29L', NULL, '29 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fd6c9cfe-5617-43c6-a97c-9766e0ab516d', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-ff2c-b74b-2fa30e6b7a3a', 'BananaRepublic', '32 X 34', NULL, '32 X 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fd75d861-f0d5-4858-a28c-6d6fd1244c2f', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '7 HUSKY', NULL, '7 TAILLE FORTE', NULL, '130/65 - 7岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fd9f3222-d70d-4eaf-91e5-b9e48f6accf0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '28/ 28', NULL, '28/28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fda75626-5652-4fa0-9236-c519ee42e80a', '3a0b6926-08fe-a5e2-ac93-07e17ec8f8ff', '3a106a3e-aa62-9743-d440-2b15e78e046b', 'OldNavy', 'XL', NULL, 'TG', NULL, '150/85 - 12-14岁', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fda81fd3-24d7-4f0b-bc6b-58b1edc9e77b', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '6 R', NULL, '6 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '42', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fdc64adb-6c09-4991-a729-8ece8cf14f4b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '2', NULL, NULL, NULL, '160/64A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fdc710f3-9389-4d08-9ad2-5bd4af7cf5a4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '3-6 M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fdd22c07-9a46-43cb-9f37-05934351386e', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-0e9d-e7cb-83bcdbfa9dfd', 'Gap', 'ONSZ', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fdd3723f-49dd-4960-8537-f48056ffb4b9', '3a1079d2-b37f-1c3c-154a-5fc05ea8e835', '3a0c74c8-3226-18ea-79d0-2d26d3bf500d', 'BananaRepublicFactoryStore', '000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fdd68ab3-d10f-4fa9-b764-f3da59899bd8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '35 LONG', NULL, '20/35 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fde00157-f795-498d-8da0-a0463c756a39', '3a0b6926-08fe-5912-13e9-a145cae7c89f', '3a106a3e-aa62-e115-fdbd-d29a32c010a6', 'OldNavy', 'S/M', NULL, 'P-M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fde97359-c82b-4222-accd-a9ca8650a138', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-0b00-c3e9-e8033ce5dd26', 'BananaRepublicFactoryStore', 'XS', NULL, 'XS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fde973bd-c934-4982-879c-8535271fded4', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6490-ac39-3775bb24a46c', 'BananaRepublicFactoryStore', '33/16 Petite', NULL, '33/16 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fdfc01af-df28-4624-b986-8a3d66d1e22b', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-66ad-28c5-a2370330a232', 'OldNavy', '14XLONG', NULL, '14 GRAND', NULL, '170/100A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fdfc9559-e776-4ce1-aa06-990a6a8bc8bf', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-acd8-50fe-61f5097466ba', 'Gap', 'MREGULAR', NULL, 'M RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fdfc99ff-d0c8-4dde-80e4-bab9ffad05a7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-6157-3de9-a2c8adeff6ff', 'Gap', 'XXL', NULL, 'TTG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe03d563-40bd-416a-b7de-3f9bc00e5457', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublic', '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('fe0423e4-841a-407b-b1f0-c0375d817236', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '4 REG', NULL, '4/27 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe064a6c-b1d6-499d-be50-6ebc652adfb3', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '16REGULAR', NULL, '16 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe06bc00-fc49-4b83-b05c-2415795b8b0e', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10P', NULL, '10/30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe151293-81fa-40cc-9aca-d1a8d5a6b5db', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe1eafd8-a19a-48a5-bec6-d4d00d2008cf', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-e069-cc20-180a73889e60', 'Gap', '6-12 MON', NULL, '6-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe1f8d06-86a6-4e9f-bffa-7369ef332d8c', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-8bdf-e636-a6c83eaf941f', 'Gap', '5PLUS', NULL, '5 PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe24bf24-2f9c-41a7-96d9-1c5df0b25244', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '24 PETITE', NULL, '24 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('fe2af8fe-6219-455d-b191-1c5b88cdeef2', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-2e8a-b37b-dc615242ad7b', 'BananaRepublicFactoryStore', '32/14 Petite', NULL, '32/14 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fe37c965-3b56-4f13-beaa-9998736cd81e', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '12-18 M', NULL, '12-18 MOIS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe3c020c-c3d1-4a3a-9b7e-6694cee65de6', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-9f92-1cf5-0977ec383741', 'Gap', 'M', NULL, 'M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe4ccf98-3449-4f3d-9d87-b0b8d4a5e1f1', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-dbb9-f4fa-4b7826227fe1', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe4d72e8-b7e0-4c8a-a4b2-1fa62c9691c0', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-4e71-f43c-5fa7e185650d', 'Gap', 'ONE SIZE', NULL, 'TAILLE-UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'TAGLIA UNICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe4fc777-e3b7-454b-84d2-1791f7ec394a', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-3108-6b32-ec29a728e97b', 'BananaRepublicFactoryStore', '16 Long', NULL, '16 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fe55ba89-8b5a-4282-a6c4-e2241c28e3f9', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-5b76-bd18-512b6c183f12', 'OldNavy', '36D', NULL, NULL, NULL, 'D80', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fe6cfb58-8fe0-43ee-b297-fe72945e8b40', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-97df-de7b-257cf76a473b', 'Gap', 'L/XL', NULL, 'G/TG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fe923bcc-cad7-4293-bf57-6697619b8f95', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '16/33 L', NULL, '16/33 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '52', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fee1c6f3-1fd3-4519-ac6d-b7543e0f9136', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6adb-ad24-3139e1e01460', 'BananaRepublicFactoryStore', 'XS/S PETITE', NULL, 'TP/P PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('fee1d0d4-e4b2-42dc-8c2c-5780bdff96c4', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '34 /30', NULL, '34/30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fee361a5-8903-4310-8057-67868df7bba4', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a51-e5ed-12bee94c8e58', 'Gap', '18-24MONTHS', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fee3b1dd-898b-4be7-a810-0773f5a2eefc', '3a0b68d3-2212-0592-3b1e-c422f9013905', '3a0b68d3-2385-fe72-7341-9187777fa457', 'Gap', 'XXL REGULAR', NULL, 'TTG RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fee7e0e2-5446-468c-966b-eff543aa177c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0000 /22', NULL, '0000/22', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('feebab86-2c1f-4d69-a373-1b277fdd9f3c', '3a1079d2-b37f-9c68-4af9-a7e043d79d92', '3a1079d2-b3a5-6e03-0605-79d4d41c2baf', 'BananaRepublicFactoryStore', '33/16 Regular', NULL, '33/16 REGULAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ff1752a7-8389-4c56-bf34-ebd85da0fc2e', '3a0c74c8-3055-fc79-e74c-203533439c04', '3a0c74c8-3226-dadf-dbcc-e265df8c33c5', 'BananaRepublic', '36 REGULAR', NULL, '36 SHORT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ff1dfae9-d1fb-48d1-8694-cef3979fbf0c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32 L', NULL, '14/32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff2976db-1ea2-4db8-9e46-ef7696717a5d', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-1229-2ce7-628852840be6', 'Gap', '3-6M', NULL, '3-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff2b5eb9-e014-4730-b4d0-bf62faca39f0', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a1079d2-b3a5-2486-bbb5-f548b6741855', 'BananaRepublicFactoryStore', 'XXL', NULL, 'TTG LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ff2cd7c5-311a-40e6-b390-382f64608bcf', '3a0b6926-08fe-2173-ff5b-217480fd2a7b', '3a0b6926-0ca4-f44c-5fe4-e7e0b7381d15', 'OldNavy', '16', NULL, '16', NULL, '160/72 -14岁+', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ff3c0a0a-4ed4-4673-8a12-1098488f4370', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000P', NULL, '000/23 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff4515c5-9138-4d95-b9cf-94319d8a0b14', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-e2bf-a79e-8f91d57f727c', 'Gap', '38C', NULL, '38C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff53453e-fd3a-4398-ad2c-7cbf157bd6ff', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-f279-bc4f-1313b07ef2b8', 'Gap', '0-12MONTHS', NULL, '0-12 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff5ae095-5bf5-4391-99a5-28386e82b821', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '30 / 32', NULL, '30/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff5d70aa-5dbf-4e87-8607-95db5ccd3431', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '10 REG', NULL, '10/30 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff604cda-3aef-40fd-a79c-c012ee3658b2', '3a0b694d-44ed-f91f-3cb0-f893cf06b723', '3a0b6945-a19a-d511-56cc-c36ea7493fa6', 'BananaRepublicFactoryStore', '34', NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ff6d8013-d843-469d-8d5f-f5ec44ff2915', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-1312-b4fb-fe23e731e2c8', 'Gap', 'XXXS +', NULL, 'TTTP PLUS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff75d24e-5415-4c11-ba9a-754c2bfe7b32', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '26REG', NULL, '2/26 R', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '38', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff7a267f-253e-444e-bdc8-a4c50c0a3ff0', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '40 / 32', NULL, '40/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff7e34a5-8b17-463b-9509-5c3e07bd9673', '3a1079d2-b37f-4dd0-e786-fc769333b513', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'BananaRepublicFactoryStore', '0-6M', NULL, '0-6 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-02-02 10:28:59.577923', NULL, '2024-02-02 10:28:59.577923', NULL, 'f', NULL, NULL),('ff88c66d-e9c2-4a33-85eb-8606a5c83f7b', '3a0b68d3-2212-7698-3c3f-c90317f131c1', '3a0b68d3-2385-0a91-e00a-c0d30d256b14', 'Gap', '18-24 M', NULL, '18-24 MOIS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff8c6312-c944-46dd-9981-d743e26fc235', '3a0b6926-08fe-33de-544d-9a8f959de695', '3a0b68d3-2385-cdfe-1540-42bef0477a9b', 'OldNavy', '7', NULL, NULL, NULL, '240/79', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ff8f917c-a738-4c08-aff5-5e541c8a542c', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a0c74c8-3226-3126-d192-f842917e1e27', 'BananaRepublic', '30 PETITE', NULL, '30 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ff9bc2e9-4a6b-40f8-ace4-50baef146bed', '3a0c74c8-3055-475b-4b2d-61966f05c000', '3a100889-485f-9f75-e96c-9e5ce76c95ce', 'BananaRepublic', '23 LONG', NULL, '23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-12 10:36:19.788907', NULL, '2024-02-02 10:28:11.429147', NULL, 'f', NULL, NULL),('ff9d6abf-1f1f-402b-a10e-625cb9bdd06d', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-5359-dbe1-cef8bd5dd42e', 'Gap', '6', NULL, '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ff9e93cc-57f9-4adf-8cd1-b1bb424e2a3a', '3a0c74c8-3055-2d7c-e355-ed873d5ced2d', '3a0c74c8-3226-58ea-9f91-d6e36c733fbd', 'BananaRepublic', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-07-17 14:58:41.737727', NULL, '2024-03-12 20:14:46.346045', NULL, 'f', NULL, NULL),('ffa15cb3-d686-4e6a-9131-437723aa43f0', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-7d68-c07a-b92a3815bbb5', 'Gap', 'ONESIZE', NULL, 'TAILLE UNIQUE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffa23318-60e4-49c0-8090-e8a0211332a1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f564-4619-85abdcf21226', 'Gap', '8REGULAR', NULL, '8 RÉGULIER', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '44', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffaf2951-b2fc-4122-a432-8b4f210271ee', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '000 LONG', NULL, '000/23 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffaf83c8-4986-41bd-be52-35558bf8e8e8', '3a0b6926-08fe-5220-6222-f5457a734acc', '3a106a3e-aa62-83ff-99e2-bb736e3b44a1', 'OldNavy', '6-12M', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2024-01-30 09:52:59.804098', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('ffdaf30f-914a-4743-a25e-deaf6b3d10a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '0/25 P', NULL, '0/25 PETITE', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '36', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffdb26d3-34c2-4030-82b5-56b61d4d6c82', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '35X28', NULL, '35X28', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffdd7962-2dc6-4aaa-beb1-3fdee5d88af7', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-4c77-ae66-229aa0e8cb74', 'Gap', '42X 32', NULL, '42/32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffdfd79d-6012-45cd-a735-1c1df9083107', '3a0b68d3-220f-d013-1006-25030e1c4971', '3a0b68d3-2385-74ce-1093-a7088791c880', 'Gap', 'S', NULL, 'P(30-31)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffe00460-0539-4aeb-a9bc-edc056fd80a8', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '14/32L', NULL, '14/32 LONG', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffe30a31-724a-4a4a-8c43-75588fb6550c', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '6/ 28', NULL, '4/27', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('ffed1b17-1e0b-4635-90c0-02b5fc7892a1', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '20S', NULL, '20/35 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fff1dc3c-90e5-40b7-af24-897d302681db', '3a0b68d3-2212-c0ef-7380-365754ac9ff9', '3a0b68d3-2385-45a6-04cc-e17a9e3db44e', 'Gap', '6 HSKY', NULL, '6 COSTAUD', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('fff1fc02-deca-4cd4-ad40-e0b457aed728', '3a0b6926-08fe-2168-ea21-a05b6666288a', '3a0b6926-0ca4-7876-031f-6d66c5b3406d', 'OldNavy', '10XLONG', NULL, '10 GRAND', NULL, '170/74A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-26 18:18:20.416817', NULL, '2024-01-30 09:52:59.804098', NULL, 'f', NULL, NULL),('fff97138-bb52-47ba-a59c-7e4f4ffc7694', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-f595-5385-5d8564a0738d', 'Gap', '00 SHORT', NULL, '00/24 COURT', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL),('964900ca-3ec5-42d9-b13b-4e1bfdaa0dd4', '3a0b68d3-2212-e0b7-747f-899c0a793431', '3a0b68d3-2385-9332-7b53-b2d7f140a413', 'Gap', '8', '8/29', '8/29', NULL, NULL, '12', '40', '29', 'NULL', 'NULL', '8/29', '', '12', '40', '', '', NULL, '', '', '', '', '', '', '', '', '', '', '2023-05-29 10:09:39.719493+08', NULL, 'Gap', NULL, NULL, '', '', '2023-05-29 10:09:39.719493', NULL, NULL, NULL, 'f', NULL, NULL)
;
COMMIT;
ALTER TABLE "AbpAuditLogActions" ADD CONSTRAINT "PK_AbpAuditLogActions" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpAuditLogActions_AuditLogId" ON "AbpAuditLogActions" USING btree (
  "AuditLogId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpAuditLogActions_TenantId_ServiceName_MethodName_Executio~" ON "AbpAuditLogActions" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "ServiceName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "MethodName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ExecutionTime" "pg_catalog"."timestamp_ops" ASC NULLS LAST
);
ALTER TABLE "AbpAuditLogs" ADD CONSTRAINT "PK_AbpAuditLogs" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpAuditLogs_TenantId_ExecutionTime" ON "AbpAuditLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "ExecutionTime" "pg_catalog"."timestamp_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpAuditLogs_TenantId_UserId_ExecutionTime" ON "AbpAuditLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "UserId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "ExecutionTime" "pg_catalog"."timestamp_ops" ASC NULLS LAST
);
ALTER TABLE "AbpBackgroundJobs" ADD CONSTRAINT "PK_AbpBackgroundJobs" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpBackgroundJobs_IsAbandoned_NextTryTime" ON "AbpBackgroundJobs" USING btree (
  "IsAbandoned" "pg_catalog"."bool_ops" ASC NULLS LAST,
  "NextTryTime" "pg_catalog"."timestamp_ops" ASC NULLS LAST
);
ALTER TABLE "AbpClaimTypes" ADD CONSTRAINT "PK_AbpClaimTypes" PRIMARY KEY ("Id");
ALTER TABLE "AbpEntityChanges" ADD CONSTRAINT "PK_AbpEntityChanges" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpEntityChanges_AuditLogId" ON "AbpEntityChanges" USING btree (
  "AuditLogId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpEntityChanges_TenantId_EntityTypeFullName_EntityId" ON "AbpEntityChanges" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "EntityTypeFullName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "EntityId" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpEntityPropertyChanges" ADD CONSTRAINT "PK_AbpEntityPropertyChanges" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpEntityPropertyChanges_EntityChangeId" ON "AbpEntityPropertyChanges" USING btree (
  "EntityChangeId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpFeatureGroups" ADD CONSTRAINT "PK_AbpFeatureGroups" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpFeatureGroups_Name" ON "AbpFeatureGroups" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpFeatureValues" ADD CONSTRAINT "PK_AbpFeatureValues" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpFeatureValues_Name_ProviderName_ProviderKey" ON "AbpFeatureValues" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderKey" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpFeatures" ADD CONSTRAINT "PK_AbpFeatures" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpFeatures_GroupName" ON "AbpFeatures" USING btree (
  "GroupName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE UNIQUE INDEX "IX_AbpFeatures_Name" ON "AbpFeatures" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpLinkUsers" ADD CONSTRAINT "PK_AbpLinkUsers" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpLinkUsers_SourceUserId_SourceTenantId_TargetUserId_Targe~" ON "AbpLinkUsers" USING btree (
  "SourceUserId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "SourceTenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "TargetUserId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "TargetTenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpOrganizationUnitRoles" ADD CONSTRAINT "PK_AbpOrganizationUnitRoles" PRIMARY KEY ("OrganizationUnitId", "RoleId");
CREATE INDEX "IX_AbpOrganizationUnitRoles_RoleId_OrganizationUnitId" ON "AbpOrganizationUnitRoles" USING btree (
  "RoleId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "OrganizationUnitId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpOrganizationUnits" ADD CONSTRAINT "PK_AbpOrganizationUnits" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpOrganizationUnits_Code" ON "AbpOrganizationUnits" USING btree (
  "Code" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpOrganizationUnits_ParentId" ON "AbpOrganizationUnits" USING btree (
  "ParentId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpPermissionGrants" ADD CONSTRAINT "PK_AbpPermissionGrants" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpPermissionGrants_TenantId_Name_ProviderName_ProviderKey" ON "AbpPermissionGrants" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderKey" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpPermissionGroups" ADD CONSTRAINT "PK_AbpPermissionGroups" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpPermissionGroups_Name" ON "AbpPermissionGroups" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpPermissions" ADD CONSTRAINT "PK_AbpPermissions" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpPermissions_GroupName" ON "AbpPermissions" USING btree (
  "GroupName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE UNIQUE INDEX "IX_AbpPermissions_Name" ON "AbpPermissions" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpRoleClaims" ADD CONSTRAINT "PK_AbpRoleClaims" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpRoleClaims_RoleId" ON "AbpRoleClaims" USING btree (
  "RoleId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpRoles" ADD CONSTRAINT "PK_AbpRoles" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpRoles_NormalizedName" ON "AbpRoles" USING btree (
  "NormalizedName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpSecurityLogs" ADD CONSTRAINT "PK_AbpSecurityLogs" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpSecurityLogs_TenantId_Action" ON "AbpSecurityLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "Action" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpSecurityLogs_TenantId_ApplicationName" ON "AbpSecurityLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "ApplicationName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpSecurityLogs_TenantId_Identity" ON "AbpSecurityLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "Identity" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpSecurityLogs_TenantId_UserId" ON "AbpSecurityLogs" USING btree (
  "TenantId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "UserId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpSettingDefinitions" ADD CONSTRAINT "PK_AbpSettingDefinitions" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpSettingDefinitions_Name" ON "AbpSettingDefinitions" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpSettings" ADD CONSTRAINT "PK_AbpSettings" PRIMARY KEY ("Id");
CREATE UNIQUE INDEX "IX_AbpSettings_Name_ProviderName_ProviderKey" ON "AbpSettings" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderKey" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpTenantConnectionStrings" ADD CONSTRAINT "PK_AbpTenantConnectionStrings" PRIMARY KEY ("TenantId", "Name");
ALTER TABLE "AbpTenants" ADD CONSTRAINT "PK_AbpTenants" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpTenants_Name" ON "AbpTenants" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpTenants_NormalizedName" ON "AbpTenants" USING btree (
  "NormalizedName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpUserClaims" ADD CONSTRAINT "PK_AbpUserClaims" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpUserClaims_UserId" ON "AbpUserClaims" USING btree (
  "UserId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpUserDelegations" ADD CONSTRAINT "PK_AbpUserDelegations" PRIMARY KEY ("Id");
ALTER TABLE "AbpUserLogins" ADD CONSTRAINT "PK_AbpUserLogins" PRIMARY KEY ("UserId", "LoginProvider");
CREATE INDEX "IX_AbpUserLogins_LoginProvider_ProviderKey" ON "AbpUserLogins" USING btree (
  "LoginProvider" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "ProviderKey" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "AbpUserOrganizationUnits" ADD CONSTRAINT "PK_AbpUserOrganizationUnits" PRIMARY KEY ("OrganizationUnitId", "UserId");
CREATE INDEX "IX_AbpUserOrganizationUnits_UserId_OrganizationUnitId" ON "AbpUserOrganizationUnits" USING btree (
  "UserId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "OrganizationUnitId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpUserRoles" ADD CONSTRAINT "PK_AbpUserRoles" PRIMARY KEY ("UserId", "RoleId");
CREATE INDEX "IX_AbpUserRoles_RoleId_UserId" ON "AbpUserRoles" USING btree (
  "RoleId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "UserId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpUserTokens" ADD CONSTRAINT "PK_AbpUserTokens" PRIMARY KEY ("UserId", "LoginProvider", "Name");
ALTER TABLE "AbpUsers" ADD CONSTRAINT "PK_AbpUsers" PRIMARY KEY ("Id");
CREATE INDEX "IX_AbpUsers_Email" ON "AbpUsers" USING btree (
  "Email" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpUsers_NormalizedEmail" ON "AbpUsers" USING btree (
  "NormalizedEmail" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpUsers_NormalizedUserName" ON "AbpUsers" USING btree (
  "NormalizedUserName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_AbpUsers_UserName" ON "AbpUsers" USING btree (
  "UserName" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "OpenIddictApplications" ADD CONSTRAINT "PK_OpenIddictApplications" PRIMARY KEY ("Id");
CREATE INDEX "IX_OpenIddictApplications_ClientId" ON "OpenIddictApplications" USING btree (
  "ClientId" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "OpenIddictAuthorizations" ADD CONSTRAINT "PK_OpenIddictAuthorizations" PRIMARY KEY ("Id");
CREATE INDEX "IX_OpenIddictAuthorizations_ApplicationId_Status_Subject_Type" ON "OpenIddictAuthorizations" USING btree (
  "ApplicationId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "Status" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "Subject" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "Type" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "OpenIddictScopes" ADD CONSTRAINT "PK_OpenIddictScopes" PRIMARY KEY ("Id");
CREATE INDEX "IX_OpenIddictScopes_Name" ON "OpenIddictScopes" USING btree (
  "Name" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "OpenIddictTokens" ADD CONSTRAINT "PK_OpenIddictTokens" PRIMARY KEY ("Id");
CREATE INDEX "IX_OpenIddictTokens_ApplicationId_Status_Subject_Type" ON "OpenIddictTokens" USING btree (
  "ApplicationId" "pg_catalog"."uuid_ops" ASC NULLS LAST,
  "Status" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "Subject" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST,
  "Type" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
CREATE INDEX "IX_OpenIddictTokens_AuthorizationId" ON "OpenIddictTokens" USING btree (
  "AuthorizationId" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
CREATE INDEX "IX_OpenIddictTokens_ReferenceId" ON "OpenIddictTokens" USING btree (
  "ReferenceId" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);
ALTER TABLE "__EFMigrationsHistory" ADD CONSTRAINT "PK___EFMigrationsHistory" PRIMARY KEY ("MigrationId");
ALTER TABLE "wp_product_gender" ADD CONSTRAINT "pk_wp_product_gender" PRIMARY KEY ("id");
ALTER TABLE "wp_product_type" ADD CONSTRAINT "pk_wp_product_type" PRIMARY KEY ("id");
ALTER TABLE "wp_size_chart" ADD CONSTRAINT "pk_wp_size_chart" PRIMARY KEY ("id");
CREATE INDEX "ix_wp_size_chart_product_gender_id" ON "wp_size_chart" USING btree (
  "product_gender_id" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
CREATE INDEX "ix_wp_size_chart_product_type_id" ON "wp_size_chart" USING btree (
  "product_type_id" "pg_catalog"."uuid_ops" ASC NULLS LAST
);
ALTER TABLE "AbpAuditLogActions" ADD CONSTRAINT "FK_AbpAuditLogActions_AbpAuditLogs_AuditLogId" FOREIGN KEY ("AuditLogId") REFERENCES "public"."AbpAuditLogs" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpEntityChanges" ADD CONSTRAINT "FK_AbpEntityChanges_AbpAuditLogs_AuditLogId" FOREIGN KEY ("AuditLogId") REFERENCES "public"."AbpAuditLogs" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpEntityPropertyChanges" ADD CONSTRAINT "FK_AbpEntityPropertyChanges_AbpEntityChanges_EntityChangeId" FOREIGN KEY ("EntityChangeId") REFERENCES "public"."AbpEntityChanges" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpOrganizationUnitRoles" ADD CONSTRAINT "FK_AbpOrganizationUnitRoles_AbpOrganizationUnits_OrganizationU~" FOREIGN KEY ("OrganizationUnitId") REFERENCES "public"."AbpOrganizationUnits" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpOrganizationUnitRoles" ADD CONSTRAINT "FK_AbpOrganizationUnitRoles_AbpRoles_RoleId" FOREIGN KEY ("RoleId") REFERENCES "public"."AbpRoles" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpOrganizationUnits" ADD CONSTRAINT "FK_AbpOrganizationUnits_AbpOrganizationUnits_ParentId" FOREIGN KEY ("ParentId") REFERENCES "public"."AbpOrganizationUnits" ("Id") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "AbpRoleClaims" ADD CONSTRAINT "FK_AbpRoleClaims_AbpRoles_RoleId" FOREIGN KEY ("RoleId") REFERENCES "public"."AbpRoles" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpTenantConnectionStrings" ADD CONSTRAINT "FK_AbpTenantConnectionStrings_AbpTenants_TenantId" FOREIGN KEY ("TenantId") REFERENCES "public"."AbpTenants" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserClaims" ADD CONSTRAINT "FK_AbpUserClaims_AbpUsers_UserId" FOREIGN KEY ("UserId") REFERENCES "public"."AbpUsers" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserLogins" ADD CONSTRAINT "FK_AbpUserLogins_AbpUsers_UserId" FOREIGN KEY ("UserId") REFERENCES "public"."AbpUsers" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserOrganizationUnits" ADD CONSTRAINT "FK_AbpUserOrganizationUnits_AbpOrganizationUnits_OrganizationU~" FOREIGN KEY ("OrganizationUnitId") REFERENCES "public"."AbpOrganizationUnits" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserOrganizationUnits" ADD CONSTRAINT "FK_AbpUserOrganizationUnits_AbpUsers_UserId" FOREIGN KEY ("UserId") REFERENCES "public"."AbpUsers" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserRoles" ADD CONSTRAINT "FK_AbpUserRoles_AbpRoles_RoleId" FOREIGN KEY ("RoleId") REFERENCES "public"."AbpRoles" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserRoles" ADD CONSTRAINT "FK_AbpUserRoles_AbpUsers_UserId" FOREIGN KEY ("UserId") REFERENCES "public"."AbpUsers" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "AbpUserTokens" ADD CONSTRAINT "FK_AbpUserTokens_AbpUsers_UserId" FOREIGN KEY ("UserId") REFERENCES "public"."AbpUsers" ("Id") ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "OpenIddictAuthorizations" ADD CONSTRAINT "FK_OpenIddictAuthorizations_OpenIddictApplications_Application~" FOREIGN KEY ("ApplicationId") REFERENCES "public"."OpenIddictApplications" ("Id") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "OpenIddictTokens" ADD CONSTRAINT "FK_OpenIddictTokens_OpenIddictApplications_ApplicationId" FOREIGN KEY ("ApplicationId") REFERENCES "public"."OpenIddictApplications" ("Id") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "OpenIddictTokens" ADD CONSTRAINT "FK_OpenIddictTokens_OpenIddictAuthorizations_AuthorizationId" FOREIGN KEY ("AuthorizationId") REFERENCES "public"."OpenIddictAuthorizations" ("Id") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "wp_size_chart" ADD CONSTRAINT "fk_wp_size_chart_wp_product_gender_product_gender_id" FOREIGN KEY ("product_gender_id") REFERENCES "public"."wp_product_gender" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "wp_size_chart" ADD CONSTRAINT "fk_wp_size_chart_wp_product_type_product_type_id" FOREIGN KEY ("product_type_id") REFERENCES "public"."wp_product_type" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION;
